<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:ns1="http://purl.org/dc/elements/1.1/"
    xmlns:ns2="http://jazz.net/xmlns/alm/qm/v0.1/" xmlns:ns3="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:ns4="http://schema.ibm.com/vega/2008/"
    xmlns:ns5="http://jazz.net/xmlns/alm/qm/v0.1/testscript/v0.1/"
    xmlns:ns6="http://jazz.net/xmlns/alm/qm/v0.1/executionworkitem/v0.1"
    xmlns:ns7="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
    xmlns:ns8="http://jazz.net/xmlns/alm/qm/v0.1/tsl/v0.1/"
    xmlns:core="http://www.ibm.com/ccl/soa/deploy/core/1.0.0/"
    xmlns:net="http://www.ibm.com/ccl/soa/deploy/net/1.0.0/"
    xmlns:os="http://www.ibm.com/ccl/soa/deploy/os/1.0.0/"
    xmlns:server="http://www.ibm.com/ccl/soa/deploy/server/1.0.0/"
    xmlns:xmi="http://www.omg.org/XMI"
    exclude-result-prefixes="ns8 ns7 ns6 ns5 ns4 ns3 ns2 ns1 core net os server xmi xsl">
    
    <xsl:variable name="lang">
        <xsl:value-of select="locale"/>
    </xsl:variable>
    <xsl:variable name="font" select="font"/>
    
    <xsl:template match="transformArgs">
        <xsl:choose>
            <xsl:when test="(componentType='STAND_ALONE') or (componentType='STAND_ALONE_SUMMARY')">
                <fo:page-sequence xmlns:fo="http://www.w3.org/1999/XSL/Format"
                    initial-page-number="1" force-page-count="no-force"
                    master-reference="PageMaster">
                    <fo:static-content flow-name="xsl-region-before">
                        <fo:block font-size="8pt" text-align="right">
                            <fo:page-number/> / <fo:page-number-citation ref-id="{reqNumber}"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:static-content flow-name="xsl-region-after">
                    	<fo:block-container height="0.1in" padding-after="0.07in">
							<fo:block text-align="center">
								<fo:leader leader-pattern='rule' rule-thickness='1pt' leader-length='100%'/>
							</fo:block>
						</fo:block-container>
                        <fo:block text-align="center">
                            <fo:retrieve-marker retrieve-class-name="artifactUri"/>
                        </fo:block>
                    </fo:static-content>
                    <fo:flow flow-name="xsl-region-body">
                        <fo:marker marker-class-name="artifactUri">
                            <fo:block font-size="6pt">
                                <fo:basic-link external-destination="{originUrl}" color="blue"
                                    text-decoration="underline">
                                    <xsl:value-of select="originUrl"/>
                                </fo:basic-link>
                            </fo:block>
                        </fo:marker>
                        <xsl:apply-templates select="descendant::ns2:labresource"/>
                        <fo:block id="{reqNumber}"/>
                    </fo:flow>
                </fo:page-sequence>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="descendant::ns2:labresource"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ns2:labresource">
        <xsl:choose>
            <xsl:when
                test="(../../componentType='SUMMARY') or (../../componentType='STAND_ALONE_SUMMARY') or (../../componentType='COMPOSITE_SUMMARY')">
                <xsl:choose>
                    <xsl:when
                        test="../../componentType='STAND_ALONE_SUMMARY' or (../../componentType='COMPOSITE_SUMMARY')">
                        <xsl:if test="../../componentType='STAND_ALONE_SUMMARY'">
                            <fo:block font-size="14pt" space-before="6mm" space-after="2mm"
                                    ><xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelSummary"
                                />: <xsl:value-of
                                    select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelLabRes"
                                /></fo:block>
                        </xsl:if>
                        <fo:table border="0.5pt solid black" text-align="left" font-size="8pt">
                            <fo:table-header>
                                <fo:table-row>
                                    <fo:table-cell>
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelName"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell>
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/group"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell>
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/OperatingSystem"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell>
                                        <fo:block-container overflow="hidden">
                                            <fo:block font-weight="bold">
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/ipAddress"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-header>
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block>
                                                <xsl:apply-templates select="ns2:title"/>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block>
                                                <xsl:value-of
                                                  select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/group"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block>
                                                <xsl:value-of
                                                  select="descendant::os:unit.operatingSystemUnit/@name"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                    <fo:table-cell padding="3pt" border="0.5pt solid black">
                                        <fo:block-container overflow="hidden">
                                            <fo:block>
                                                <xsl:value-of
                                                  select="descendant::net:capability.ipInterface/@net:ipV4Address"
                                                />
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </xsl:when>
                    <xsl:otherwise>
                        <fo:table-row font-size="8pt">
                            <fo:table-cell padding="3pt" border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block>
                                        <xsl:apply-templates select="ns2:title"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell padding="3pt" border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block>
                                        <xsl:value-of
                                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/group"
                                        />
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell padding="3pt" border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block>
                                        <xsl:value-of
                                            select="descendant::os:unit.operatingSystemUnit/@name"/>
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                            <fo:table-cell padding="3pt" border="0.5pt solid black">
                                <fo:block-container overflow="hidden">
                                    <fo:block>
                                        <xsl:value-of
                                            select="descendant::net:capability.ipInterface/@net:ipV4Address"
                                        />
                                    </fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                        </fo:table-row>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
                <fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format">
                    <xsl:if test="(../../componentType='COMPOSITE' )">
                        <xsl:attribute name="break-after">page</xsl:attribute>
                    </xsl:if>
                    <fo:block font-size="14pt" space-before="2mm" space-after="2mm"><xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelLabRes"
                        />: <xsl:value-of select="ns2:title"/></fo:block>
                    <fo:block space-after="4mm"><xsl:value-of
                            select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labeldescription"
                        />: <xsl:value-of select="description"/></fo:block>
                    <xsl:apply-templates select="ns2:tdm"/>
                </fo:block>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="ns2:tdm">
        <xsl:if test="core:topology">
            <xsl:apply-templates select="core:topology"/>
        </xsl:if>
    </xsl:template>
    <xsl:template match="core:topology">
        <xsl:if test="server:unit.serverUnit">
            <xsl:apply-templates select="server:unit.serverUnit"/>
        </xsl:if>
        <xsl:if test="os:unit.operatingSystemUnit">
            <xsl:apply-templates select="os:unit.operatingSystemUnit"/>
        </xsl:if>
        <xsl:if test="net:unit.ipInterfaceUnit">
            <xsl:apply-templates select="net:unit.ipInterfaceUnit"/>
        </xsl:if>
    </xsl:template>
    <xsl:template match="server:unit.serverUnit">
        <xsl:if test="server:capability.server">
            <xsl:apply-templates select="server:capability.server"/>
        </xsl:if>
        <xsl:if test="core:link.hosting">
            <xsl:apply-templates select="core:link.hosting"/>
        </xsl:if>
    </xsl:template>
    <xsl:template match="os:unit.operatingSystemUnit">
        <xsl:if test="os:capability.operatingSystem">
            <xsl:apply-templates select="os:capability.operatingSystem"/>
        </xsl:if>
        <xsl:if test="core:link.hosting">
            <xsl:apply-templates select="core:link.hosting"/>
        </xsl:if>
    </xsl:template>
    <xsl:template match="net:unit.ipInterfaceUnit">
        <xsl:if test="net:capability.ipInterface">
            <xsl:apply-templates select="net:capability.ipInterface"/>
        </xsl:if>
    </xsl:template>
    <xsl:template match="server:capability.server">
        <fo:table font-size="8pt">
            <fo:table-body>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/cpuArchitecture"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/cpuCount"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/cpuArchitectureWidth"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpu.architecture"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpu.count"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpuArchitectureWidth"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/cpuCoresInstalled"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/cpuDiesInstalled"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/cpuManufacturer"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpuCoresInstalled"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpuDiesInstalled"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpuManufacturer"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/cpuSpeed"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/Type"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/Manufacturer"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpuSpeed"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@cpuType"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@manufacturer"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/memory"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/model"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/PrimaryMACAddress"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/SerialNumber"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/labelId"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@memory.size"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@model"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@primaryMACAddress"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@serialNumber"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@systemId"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
            </fo:table-body>
        </fo:table>
    </xsl:template>
    <xsl:template match="core:link.hosting"> </xsl:template>
    <xsl:template match="os:capability.operatingSystem">
        <fo:block>
            <xsl:value-of select="os.type"/>
        </fo:block>
        <fo:table font-size="8pt">
            <fo:table-body>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/hostname"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/FullyQualifiedDomainName"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/KernelArchitecture"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@hostname"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@fqdn"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@kernelArchitecture"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/KernelVersion"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/KernelWidth"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/Locale"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@kernelVersion"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@kernelWidth"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@locale"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/Manufacturer"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/Distribution"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@manufacturer"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@os.distribution"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
            </fo:table-body>
        </fo:table>
    </xsl:template>
    <xsl:template match="net:capability.ipInterface">
        <fo:table font-size="8pt">
            <fo:table-body>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/IpV4Address"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/IpV6Address"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/L2InterfaceName"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@net:ipV4Address"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@net:ipV6Address"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@net:l2InterfaceName"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/Netmask"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of
                                select="document('fopmessages.xml')/fopmessages//*[name()=$lang]/SubnetAddress"
                            />
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
                <fo:table-row>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@net:netmask"/>
                        </fo:block-container>
                    </fo:table-cell>
                    <fo:table-cell>
                        <fo:block-container overflow="hidden">
                            <xsl:value-of select="@net:subnetAddress"/>
                        </fo:block-container>
                    </fo:table-cell>
                </fo:table-row>
            </fo:table-body>
        </fo:table>
    </xsl:template>
</xsl:stylesheet>
