<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"
	xmlns:ns2="http://jazz.net/xmlns/alm/qm/v0.1/" xmlns:ns10="http://jazz.net/xmlns/alm/qm/v0.1/executionworkitem/v0.1"
	xmlns:ns11="http://jazz.net/xmlns/alm/qm/v0.1/tsl/v0.1/" xmlns:ns12="http://schema.ibm.com/vega/2008/"
	xmlns:ns3="http://purl.org/dc/elements/1.1/" xmlns:ns4="http://jazz.net/xmlns/alm/v0.1/"
	xmlns:ns5="http://jazz.net/xmlns/alm/qm/qmadapter/task/v0.1" xmlns:ns6="http://jazz.net/xmlns/alm/qm/qmadapter/v0.1"
	xmlns:ns7="http://jazz.net/xmlns/alm/qm/v0.1/executionresult/v0.1"
	xmlns:ns8="http://jazz.net/xmlns/alm/qm/v0.1/catalog/v0.1" xmlns:ns9="http://jazz.net/xmlns/alm/qm/v0.1/testscript/v0.1/"
	xmlns:ns14="http://jazz.net/xmlns/alm/qm/v0.1/#extension"
	exclude-result-prefixes="ns14 ns9 ns10 ns11 ns8 ns7 ns6 ns5 ns4 ns3 ns2 xsl">
	<xsl:include href="xhtml-to-xslfo-ns.xsl"/>
	<xsl:include href="wrapping-rules.xsl"/>
	<xsl:include href="attribute-sets.xsl"/>
	
	<xsl:variable name="lang" select="locale"/>
	<xsl:variable name="strings" select="document('fopmessages.xml')/fopmessages//*[name()=$lang]"/>
	<xsl:variable name="font" select="font"/>
	
	<xsl:template match="transformArgs">
		<xsl:choose>
			<xsl:when
				test="(componentType='STAND_ALONE') or (componentType='STAND_ALONE_SUMMARY')">
				<fo:page-sequence xmlns:fo="http://www.w3.org/1999/XSL/Format"
					initial-page-number="1" force-page-count="no-force"
					master-reference="PageMaster">
					<fo:static-content flow-name="xsl-region-before">
						<fo:block font-size="8pt" text-align="right">
							<fo:page-number />
							/
							<fo:page-number-citation ref-id="{reqNumber}" />
						</fo:block>
					</fo:static-content>
					<fo:static-content flow-name="xsl-region-after">
						<fo:block-container height="0.1in"
							padding-after="0.07in">
							<fo:block text-align="center">
								<fo:leader leader-pattern='rule' rule-thickness='1pt'
									leader-length='100%' />
							</fo:block>
						</fo:block-container>
						<fo:block text-align="center">
							<fo:retrieve-marker retrieve-class-name="artifactUri" />
						</fo:block>
					</fo:static-content>
					<fo:flow flow-name="xsl-region-body">
						<fo:marker marker-class-name="artifactUri">
							<fo:block font-size="6pt">
								<fo:basic-link external-destination="{originUrl}"
									color="blue" text-decoration="underline">
									<xsl:value-of select="originUrl" />
								</fo:basic-link>
							</fo:block>
						</fo:marker>
						<xsl:apply-templates select="descendant::ns2:testplan" />
						<fo:block id="{reqNumber}" />
					</fo:flow>
				</fo:page-sequence>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="descendant::ns2:testplan" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="ns2:testplan">
		<xsl:choose>
			<xsl:when
				test="(../../componentType='SUMMARY') or (../../componentType='STAND_ALONE_SUMMARY')">
				<xsl:choose>
					<xsl:when
						test="../../componentType='STAND_ALONE_SUMMARY' or (../../componentType='COMPOSITE_SUMMARY')">
						<xsl:if test="../../componentType='STAND_ALONE_SUMMARY'">
							<fo:block font-size="14pt" space-before="6mm"
								space-after="2mm">
								<xsl:value-of
									select="$strings/labelSummary" />
								:
								<xsl:value-of
									select="$strings/labelTestPlan" />
							</fo:block>
						</xsl:if>
						<fo:table border="0.5pt solid black" font-size="8pt">
							<fo:table-header>
								<fo:table-row background-color="rgb(249,245,219)">
									<fo:table-cell width="7mm" padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block font-weight="bold">
												<xsl:value-of
													select="$strings/labelId" />
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block font-weight="bold">
												<xsl:value-of
													select="$strings/labelName" />
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell width="30mm" padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block font-weight="bold">
												<xsl:value-of
													select="$strings/labelState" />
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell width="22mm" padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block font-weight="bold">
												<xsl:value-of
													select="$strings/Product" />
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell width="22mm" padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block font-weight="bold">
												<xsl:value-of
													select="$strings/Release" />
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell width="30mm" padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block font-weight="bold">
												<xsl:value-of
													select="$strings/labelModifiedDate" />
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
								</fo:table-row>
							</fo:table-header>
							<fo:table-body>
								<fo:table-row> 
									<fo:table-cell padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block>
												<xsl:variable name="alias" select="ns3:alias" />
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="substring-after($alias,'testplan:')" />
												</xsl:call-template>
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block>
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="ns3:title"/>
												</xsl:call-template>
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block>
												<xsl:choose>
													<xsl:when test="ns4:state='com.ibm.rqm.planning.common.underreview'">
														<xsl:call-template name="wrap-on-all-characters">
															<xsl:with-param name="text-content" select="$strings/com.ibm.rqm.planning.common.underreview" />
														</xsl:call-template>				
													</xsl:when>
													<xsl:when test="ns4:state='com.ibm.rqm.planning.common.new'">
														<xsl:call-template name="wrap-on-all-characters">
															<xsl:with-param name="text-content" select="$strings/com.ibm.rqm.planning.common.new" />
														</xsl:call-template>				
													</xsl:when>
													<xsl:when test="ns4:state='com.ibm.rqm.planning.common.approved'">
														<xsl:call-template name="wrap-on-all-characters">
															<xsl:with-param name="text-content" select="$strings/com.ibm.rqm.planning.common.approved" />
														</xsl:call-template>				
													</xsl:when>
												</xsl:choose>
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block>
												<xsl:choose>
													<xsl:when test="ns2:category[@term=$strings/Product]">
														<xsl:call-template name="wrap-on-all-characters">
															<xsl:with-param name="text-content" select="ns2:category[@term=$strings/Product]/@value" />
														</xsl:call-template>
													</xsl:when>
													<xsl:otherwise>
														<xsl:call-template name="wrap-on-all-characters">
															<xsl:with-param name="text-content" select="$strings/labelUnassigned" />
														</xsl:call-template>
													</xsl:otherwise>
												</xsl:choose>
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block>
												<xsl:choose>
													<xsl:when test="ns2:category[@term=$strings/Release]">
														<xsl:call-template name="wrap-on-all-characters">
															<xsl:with-param name="text-content" select="ns2:category[@term=$strings/Release]/@value" />
														</xsl:call-template>
													</xsl:when>
													<xsl:otherwise>
														<xsl:call-template name="wrap-on-all-characters">
															<xsl:with-param name="text-content" select="$strings/labelUnassigned" />
														</xsl:call-template>
													</xsl:otherwise>
												</xsl:choose>
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
									<fo:table-cell padding="3pt" border="0.5pt solid black">
										<fo:block-container overflow="hidden">
											<fo:block>
												<xsl:value-of select="ns4:updated" />
											</fo:block>
										</fo:block-container>
									</fo:table-cell>
								</fo:table-row>
							</fo:table-body>
						</fo:table>
					</xsl:when>
					<xsl:otherwise>
						<fo:table-row font-size="8pt">
							<fo:table-cell padding="3pt" border="0.5pt solid black">
								<fo:block-container overflow="hidden">
									<fo:block>
										<xsl:variable name="alias" select="ns3:alias" />
										<xsl:call-template name="wrap-on-all-characters">
											<xsl:with-param name="text-content" select="substring-after($alias,'testplan:')" />
										</xsl:call-template>
									</fo:block>
								</fo:block-container>
							</fo:table-cell>
							<fo:table-cell padding="3pt" border="0.5pt solid black">
								<fo:block-container overflow="hidden">
									<fo:block>
										<xsl:call-template name="wrap-on-all-characters">
											<xsl:with-param name="text-content" select="ns3:title"/>
										</xsl:call-template>
									</fo:block>
								</fo:block-container>
							</fo:table-cell>
							<fo:table-cell padding="3pt" border="0.5pt solid black">
								<fo:block-container overflow="hidden">
									<fo:block>
										<xsl:choose>
											<xsl:when test="ns4:state='com.ibm.rqm.planning.common.underreview'">
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="$strings/com.ibm.rqm.planning.common.underreview" />
												</xsl:call-template>	
											</xsl:when>
											<xsl:when test="ns4:state='com.ibm.rqm.planning.common.new'">
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="$strings/com.ibm.rqm.planning.common.new" />
												</xsl:call-template>	
											</xsl:when>
											<xsl:when test="ns4:state='com.ibm.rqm.planning.approved'">
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="$strings/com.ibm.rqm.planning.common.approved"/>
												</xsl:call-template>
											</xsl:when>
										</xsl:choose>
									</fo:block>
								</fo:block-container>
							</fo:table-cell>
							<fo:table-cell padding="3pt" border="0.5pt solid black">
								<fo:block-container overflow="hidden">
									<fo:block>
										<xsl:choose>
											<xsl:when test="ns2:category[@term=$strings/Product]">
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="ns2:category[@term=$strings/Product]/@value" />
												</xsl:call-template>	
											</xsl:when>
											<xsl:otherwise>
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="$strings/labelUnassigned" />
												</xsl:call-template>	
											</xsl:otherwise>
										</xsl:choose>
									</fo:block>
								</fo:block-container>
							</fo:table-cell>
							<fo:table-cell padding="3pt" border="0.5pt solid black">
								<fo:block-container overflow="hidden">
									<fo:block>
										<xsl:choose>
											<xsl:when test="ns2:category[@term=$strings/Release]">
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="ns2:category[@term=$strings/Release]/@value" />
												</xsl:call-template>	
											</xsl:when>
											<xsl:otherwise>
												<xsl:call-template name="wrap-on-all-characters">
													<xsl:with-param name="text-content" select="$strings/labelUnassigned" />
												</xsl:call-template>	
											</xsl:otherwise>
										</xsl:choose>
									</fo:block>
								</fo:block-container>
							</fo:table-cell>
							<fo:table-cell padding="3pt" border="0.5pt solid black">
								<fo:block-container overflow="hidden">
									<fo:block>
										<xsl:value-of select="ns4:updated" />
									</fo:block>
								</fo:block-container>
							</fo:table-cell>
						</fo:table-row>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<fo:block xmlns:fo="http://www.w3.org/1999/XSL/Format"> <!-- font-size="8pt" ? -->
					<xsl:if test="(../../componentType='COMPOSITE')">
						<!--						<xsl:attribute name="break-after">page</xsl:attribute>-->
					</xsl:if>
					<fo:block font-size="14pt" space-after="6mm" text-align="left"
						font-weight="bold" text-decoration="underline" color="rgb(0,0,0)">
						<xsl:value-of
							select="$strings/labelTestPlan" />:
						<xsl:apply-templates select="ns3:title"/>
					</fo:block>
					<fo:block space-after="2mm" text-align="left"
						font-weight="bold">
						<xsl:value-of
							select="$strings/labeloriginatorLabel" />
						:
						<xsl:value-of select="ns3:creator" />
					</fo:block>
					<fo:block space-after="4mm" text-align="left"
						font-weight="bold">
						<xsl:value-of
							select="$strings/labelState" />
						:
						<xsl:choose>
							<xsl:when test="ns4:state='com.ibm.rqm.planning.common.new'">
								<xsl:value-of
									select="$strings/com.ibm.rqm.planning.common.new" />
							</xsl:when>
							<xsl:when test="ns4:state='com.ibm.rqm.planning.common.underreview'">
								<xsl:value-of
									select="$strings/com.ibm.rqm.planning.common.underreview" />
							</xsl:when>
							<xsl:when test="ns4:state='com.ibm.rqm.planning.common.approved'">
								<xsl:value-of
									select="$strings/com.ibm.rqm.planning.common.approved" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of
									select="$strings/labelUnassigned" />
							</xsl:otherwise>
						</xsl:choose>
					</fo:block>

					<xsl:for-each select="ns2:section">
						<xsl:choose>
							<!-- SUMMARY -->
							<xsl:when test="@name='RQM-KEY-TP-SUMMARY-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-after="4mm" space-before="4mm" font-weight="bold" 
									text-decoration="underline" text-align="left">
									<xsl:value-of select="$strings/labelSummary"/>
								</fo:block>
								
								<!-- Section Content -->
								<xsl:for-each select="../../../categoryType">
									<fo:block>  <!-- font-size="8pt" ? -->
										<xsl:value-of select="current()" />
										:
										<xsl:choose>
											<xsl:when test="../artifactXML/ns2:testplan/ns2:category[@term=current()]">
												<xsl:value-of select="../artifactXML/ns2:testplan/ns2:category[@term=current()]/@value" />
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="$strings/labelUnassigned" />
											</xsl:otherwise>
										</xsl:choose>
									</fo:block>
								</xsl:for-each>
								<fo:block space-before="4mm" space-after="1mm">
									<xsl:value-of select="$strings/labeldescription"/>:
								</fo:block>
								<fo:block space-after="4mm" white-space-collapse="false" linefeed-treatment="preserve">
									<xsl:apply-templates select="../ns3:description"/>
								</fo:block>
							</xsl:when>
							
							<!-- BUSINESS OBJECTIVES -->
							<xsl:when test="@name='RQM-KEY-TP-BUSS-OBJ-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									      text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/RQM-KEY-TP-BUSS-OBJ-TITLE" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:com.ibm.rqm.planning.editor.section.planBusinessObjectives">
										<fo:block>
											<xsl:apply-templates select="../ns2:com.ibm.rqm.planning.editor.section.planBusinessObjectives" />		<!-- applies template for rich text section -->
										</fo:block>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- TEST OBJECTIVES -->
							<xsl:when test="@name='RQM-KEY-TP-TEST-OBJ-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/RQM-KEY-TP-TEST-OBJ-TITLE"/>
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:com.ibm.rqm.planning.editor.section.planTestObjectives">
										<fo:block>
											<xsl:apply-templates select="../ns2:com.ibm.rqm.planning.editor.section.planTestObjectives" />				<!-- applies template for rich text section -->
										</fo:block>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- FORMAL REVIEW -->
							<xsl:when test="@name='RQM-KEY-PROC-REVIEW-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/labelFormalReview"/>
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:approvals">
										<fo:table font-size="8pt">
											<fo:table-header>
												<fo:table-row background-color="rgb(249,245,219)">
													<fo:table-cell width="30mm" padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/labelTitleApprovalTable" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
													<fo:table-cell width="45mm" padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/labelName" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
													<fo:table-cell padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/reqLabel_status" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
													<fo:table-cell padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/reqLabel_comments" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
													<fo:table-cell padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/labelModifiedDate" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
												</fo:table-row>
											</fo:table-header>
											<fo:table-body>
												<xsl:apply-templates select="../ns2:approvals/ns2:approvalDescriptor" />
											</fo:table-body>
										</fo:table>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- REQUIREMENTS -->
							<xsl:when test="@name='RQM-KEY-TP-REQ-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline" text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/labelRequirements" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:requirement">
										<xsl:choose>
											<!-- COMPOSITE RECURSIVE PRINT -->
											<xsl:when test="(../ns2:requirement/fo:wrapper/fo:block) and (../ns2:requirement/fo:wrapper/fo:table-row)">
												<fo:table xsl:use-attribute-sets="artifact-table">
													<fo:table-header xsl:use-attribute-sets="artifact-table-header">
														<!-- id -->
														<fo:table-cell xsl:use-attribute-sets="border id-header">
															<fo:block><xsl:value-of select="$strings/labelId"/></fo:block>
														</fo:table-cell>
														<!-- status -->
														<fo:table-cell xsl:use-attribute-sets="border" width="50">
															<fo:block><xsl:apply-templates select="$strings/reqLabel_status"/></fo:block>
														</fo:table-cell>
														<!-- name -->
														<fo:table-cell xsl:use-attribute-sets="border" width="75">
															<fo:block><xsl:apply-templates select="$strings/labelName"/></fo:block>
														</fo:table-cell>
														<!-- description -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:apply-templates select="$strings/labeldescription"/></fo:block>
														</fo:table-cell>
														<!-- owner -->
														<fo:table-cell xsl:use-attribute-sets="border user-header">
															<fo:block><xsl:apply-templates select="$strings/labelOwner"/></fo:block>
														</fo:table-cell>
													</fo:table-header>
													<fo:table-body>
														<xsl:copy-of select="../ns2:requirement/fo:wrapper/fo:table-row" />
													</fo:table-body>
												</fo:table>
												<xsl:for-each select="../ns2:requirement/fo:wrapper/fo:block">
													<xsl:choose>
														<xsl:when test="//pageBreaks = 'false'">
															<fo:block>
																<fo:leader/>
																<xsl:copy-of select="." />
															</fo:block>
														</xsl:when>
														<xsl:otherwise>
															<fo:block break-before="page">
																<xsl:if test="position()=last()">
																	<xsl:attribute name="break-after">page</xsl:attribute>
																</xsl:if>
																<xsl:copy-of select="." />
															</fo:block>
														</xsl:otherwise>
													</xsl:choose>
												</xsl:for-each>
											</xsl:when>
											<!-- COMPOSITE SUMMARY VIEW -->
											<xsl:when test="../ns2:requirement/fo:table">
												<fo:table xsl:use-attribute-sets="artifact-table">
													<xsl:copy-of select="../ns2:requirement/fo:table/fo:table-header" />
													<fo:table-body>
														<xsl:copy-of select="../ns2:requirement/fo:table/fo:table-body/fo:table-row" />
														<xsl:copy-of select="../ns2:requirement/fo:table-row" />
													</fo:table-body>
												</fo:table>
											</xsl:when>
											<!-- COMPOSITE STAND ALONE -->
											<xsl:when test="../ns2:requirement/fo:block">
												<xsl:copy-of select="../ns2:requirement/fo:block" />
											</xsl:when>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- TEST SCHEDULE -->
							<xsl:when test="@name='RQM-KEY-PROC-TIMEBOX-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/RQM-KEY-PROC-TIMEBOX-TITLE"/>
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:testSchedule/ns2:testPhase">
										<fo:table xsl:use-attribute-sets="artifact-table">
											<fo:table-header xsl:use-attribute-sets="artifact-table-header">
												<!-- name -->	
												<fo:table-cell xsl:use-attribute-sets="border" width="55">
													<fo:block>
														<xsl:apply-templates select="$strings/labelName"/>
													</fo:block>
												</fo:table-cell>
												<!-- description -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block>
														<xsl:apply-templates select="$strings/labeldescription"/>
													</fo:block>
												</fo:table-cell>
												<!-- planned start date -->
												<!-- width needs to be overridden for russian translation of "planned" -->
												<fo:table-cell xsl:use-attribute-sets="border date-header" width="45">
													<fo:block>
														<xsl:value-of select="$strings/labelStartDateTimeBox"/>
													</fo:block>
												</fo:table-cell>
												<!-- planned end date -->
												<!-- width needs to be overridden for russian translation of "planned" -->
												<fo:table-cell xsl:use-attribute-sets="border date-header" width="45">
													<fo:block>
														<xsl:value-of select="$strings/labelEndDateTimeBox"/>
													</fo:block>
												</fo:table-cell>
												<!-- actual start date -->
												<fo:table-cell xsl:use-attribute-sets="border date-header">
													<fo:block>
														<xsl:value-of select="$strings/labelActStartDateTimeBox"/>
													</fo:block>
												</fo:table-cell>
												<!-- actual end date -->
												<fo:table-cell xsl:use-attribute-sets="border date-header">
													<fo:block>
														<xsl:value-of select="$strings/labelActEndDateTimeBox"/>
													</fo:block>
												</fo:table-cell>
												<!-- points -->
												<fo:table-cell xsl:use-attribute-sets="border" width="20">
													<fo:block font-weight="bold">
														<xsl:value-of select="$strings/labelPointsTimeBox"/>
													</fo:block>
												</fo:table-cell>
											</fo:table-header>
											<fo:table-body>
												<xsl:apply-templates select="../ns2:testSchedule/ns2:testPhase" />
											</fo:table-body>
										</fo:table>
									</xsl:when>
									<xsl:when test="../ns2:keydates/ns2:keydate">
										<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
											text-align="left" keep-with-next="always">
											<xsl:value-of select="$strings/labelKeyDateTableTimeBox" />
										</fo:block>
										<fo:table font-size="8pt"> <!-- keep-together="always"-->
											<fo:table-header>
												<fo:table-row background-color="rgb(249,245,219)">
													<fo:table-cell width="40mm" padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/labelName" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
													<fo:table-cell width="60mm" padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/labeldescription" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
													<fo:table-cell padding="3pt" border="0.5pt solid black">
														<fo:block-container overflow="hidden">
															<fo:block font-weight="bold">
																<xsl:value-of select="$strings/labelDate" />
															</fo:block>
														</fo:block-container>
													</fo:table-cell>
												</fo:table-row>
											</fo:table-header>
											<fo:table-body>
												<xsl:apply-templates select="../ns2:keydates/ns2:keydate"/>
											</fo:table-body>
										</fo:table>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- TEST ESTIMATION -->
							<xsl:when test="@name='RQM-KEY-PROC-SIZING-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/RQM-KEY-PROC-SIZING-TITLE" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:estimation">
										<xsl:apply-templates select="../ns2:estimation" />					<!-- applies template for rich text section -->
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- TEST CONFIGURATION -->
							<xsl:when test="@name='RQM-KEY-TP-ENV-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/labelTestEnvironment" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:configuration">
										<xsl:choose>
											<!-- COMPOSITE RECURSIVE PRINT -->
											<xsl:when test="(../ns2:configuration/fo:wrapper/fo:block) and (../ns2:configuration/fo:wrapper/fo:table-row)">
												<fo:table xsl:use-attribute-sets="artifact-table">
													<fo:table-header xsl:use-attribute-sets="artifact-table-header">
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/labelName"/></fo:block>
														</fo:table-cell>
														<fo:table-cell xsl:use-attribute-sets="border">
															<!-- This needs to be externalized in fopmessages.xml -->
															<fo:block>Server</fo:block>
														</fo:table-cell>
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/Browsers"/></fo:block>
														</fo:table-cell>
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/cpu"/></fo:block>
														</fo:table-cell>
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/DataBase"/></fo:block>
														</fo:table-cell>
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/ManagementAgent"/></fo:block>
														</fo:table-cell>
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/operatingsystem"/></fo:block>
														</fo:table-cell>
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/TestAdapter"/></fo:block>
														</fo:table-cell>
													</fo:table-header>
													<fo:table-body>
														<xsl:copy-of select="../ns2:configuration/fo:wrapper/fo:table-row" />
													</fo:table-body>
												</fo:table>
												<xsl:for-each select="../ns2:configuration/fo:wrapper/fo:block">
													<xsl:choose>
														<xsl:when test="//pageBreaks = 'false'">
															<fo:block>
																<fo:leader/>
																<xsl:copy-of select="." />
															</fo:block>
														</xsl:when>
														<xsl:otherwise>
															<fo:block break-before="page">
																<xsl:copy-of select="." />
															</fo:block>
														</xsl:otherwise>
													</xsl:choose>
												</xsl:for-each>
											</xsl:when>
											<!-- COMPOSITE SUMMARY VIEW -->
											<xsl:when test="../ns2:configuration/fo:table">
												<fo:table border="0.5pt solid black" font-size="8pt">
													<xsl:copy-of select="../ns2:configuration/fo:table/fo:table-header" />
													<fo:table-body>
														<xsl:copy-of
															select="../ns2:configuration/fo:table/fo:table-body/fo:table-row" />
														<xsl:copy-of select="../ns2:configuration/fo:table-row" />
													</fo:table-body>
												</fo:table>
											</xsl:when>
											<!-- COMPOSITE STAND ALONE -->
											<xsl:when test="../ns2:configuration/fo:block">
												<xsl:copy-of select="../ns2:configuration/fo:block" />
											</xsl:when>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- TEAM AREA -->
							<xsl:when test="@name='RQM-KEY-TP-TEST-TEAM-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/RQM-KEY-TP-TEST-TEAM-TITLE" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:teamarea">
										<xsl:choose>
											<!-- COMPOSITE RECURSIVE PRINT -->
											<xsl:when test="(../ns2:teamarea/fo:wrapper/fo:block) and (../ns2:teamarea/fo:wrapper/fo:table-row)">
												<fo:table border="0.5pt solid black" font-size="8pt">
													<fo:table-header>
														<fo:table-row background-color="rgb(249,245,219)">
															<fo:table-cell padding="3pt" border="0.5pt solid black">
																<fo:block-container overflow="hidden">
																	<fo:block font-weight="bold">
																		<xsl:value-of select="$strings/labelName" />
																	</fo:block>
																</fo:block-container>
															</fo:table-cell>
															<fo:table-cell padding="3pt" border="0.5pt solid black">
																<fo:block-container overflow="hidden">
																	<fo:block font-weight="bold">
																		<xsl:value-of select="$strings/labelSummary" />
																	</fo:block>
																</fo:block-container>
															</fo:table-cell>
														</fo:table-row>
													</fo:table-header>
													<fo:table-body>
														<xsl:copy-of select="../ns2:teamarea/fo:wrapper/fo:table-row" />
													</fo:table-body>
												</fo:table>
											</xsl:when>
											<!-- COMPOSITE SUMMARY VIEW -->
											<xsl:when test="../ns2:teamarea/fo:table">
												<fo:table border="0.5pt solid black" font-size="8pt">
													<xsl:copy-of select="../ns2:teamarea/fo:table/fo:table-header" />
													<fo:table-body>
														<xsl:copy-of
															select="../ns2:teamarea/fo:table/fo:table-body/fo:table-row" />
														<xsl:copy-of select="../ns2:teamarea/fo:table-row" />
													</fo:table-body>
												</fo:table>
											</xsl:when>
											<!-- COMPOSITE STAND ALONE -->
											<xsl:when test="../ns2:teamarea/fo:block">
												<xsl:copy-of select="../ns2:teamarea/fo:block" />
											</xsl:when>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- QUALITY OBJECTIVES -->
							<xsl:when test="@name='RQM-KEY-PROC-QUALITY-GOAL-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/labelQualityObjectives" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:objectives/ns2:objectiveStatus/ns2:group='com.ibm.rqm.process.web.qualityGoalSection'">
										<fo:table xsl:use-attribute-sets="artifact-table" space-after="4mm">
											<fo:table-header xsl:use-attribute-sets="artifact-table-header">
												<!-- Objective -->
												<fo:table-cell xsl:use-attribute-sets="border" width="50mm">
													<fo:block>
														<xsl:value-of select="$strings/labelObjective" />
													</fo:block>
												</fo:table-cell>
												<!-- Expected -->
												<fo:table-cell xsl:use-attribute-sets="border" width="20mm">
													<fo:block>
														<xsl:value-of select="$strings/labelExpected" />
													</fo:block>
												</fo:table-cell>
												<!-- Actual Value -->
												<fo:table-cell xsl:use-attribute-sets="border" width="20mm">
													<fo:block>
														<xsl:value-of select="$strings/labelActual" />
													</fo:block>
												</fo:table-cell>
												<!-- Status -->
												<fo:table-cell xsl:use-attribute-sets="border" width="25mm">
													<fo:block>
														<xsl:value-of select="$strings/reqLabel_status" />
													</fo:block>
												</fo:table-cell>
												<!-- Comment -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block>
														<xsl:value-of select="$strings/labelComment" />
													</fo:block>
												</fo:table-cell>
											</fo:table-header>
											<fo:table-body>
												<xsl:for-each select="../ns2:objectives/ns2:objectiveStatus[ns2:group='com.ibm.rqm.process.web.qualityGoalSection']">
													<fo:table-row>
														<!-- objective -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//*[local-name()='title']" />
															</fo:block>
														</fo:table-cell>
														<!-- expected value -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//ns2:operator" />
																<xsl:text />
																<xsl:value-of select=".//ns2:targetValue" />
															</fo:block>
														</fo:table-cell>
														<!-- actual value -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select="ns2:actualValue" />
															</fo:block>
														</fo:table-cell>
														<!-- status -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:choose>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.success'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.success" />
																	</xsl:when>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.unsuccessful'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.unsuccessful" />
																	</xsl:when>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.unresolved'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.unresolved" />
																	</xsl:when>
																	<xsl:otherwise>
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.not_started" />
																	</xsl:otherwise>
																</xsl:choose>
															</fo:block>
														</fo:table-cell>
														<!-- comment -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//*[local-name()='comment']" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
												</xsl:for-each>
											</fo:table-body>
										</fo:table>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- ENTRY CRITERIA -->
							<xsl:when test="@name='RQM-KEY-PROC-ENTRY-CRITERIA-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/RQM-KEY-PROC-ENTRY-CRITERIA-TITLE" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:objectives/ns2:objectiveStatus/ns2:group='com.ibm.rqm.process.web.entryCriteria'">
										<fo:table xsl:use-attribute-sets="artifact-table" space-after="4mm">
											<fo:table-header xsl:use-attribute-sets="artifact-table-header">
												<!-- Objective -->
												<fo:table-cell xsl:use-attribute-sets="border" width="50mm">
													<fo:block>
														<xsl:value-of select="$strings/labelObjective" />
													</fo:block>
												</fo:table-cell>
												<!-- Expected -->
												<fo:table-cell xsl:use-attribute-sets="border" width="20mm">
													<fo:block>
														<xsl:value-of select="$strings/labelExpected" />
													</fo:block>
												</fo:table-cell>
												<!-- Actual Value -->
												<fo:table-cell xsl:use-attribute-sets="border" width="20mm">
													<fo:block>
														<xsl:value-of select="$strings/labelActual" />
													</fo:block>
												</fo:table-cell>
												<!-- Status -->
												<fo:table-cell xsl:use-attribute-sets="border" width="25mm">
													<fo:block>
														<xsl:value-of select="$strings/reqLabel_status" />
													</fo:block>
												</fo:table-cell>
												<!-- Comment -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block>
														<xsl:value-of select="$strings/labelComment" />
													</fo:block>
												</fo:table-cell>
											</fo:table-header>
											<fo:table-body>
												<xsl:for-each select="../ns2:objectives/ns2:objectiveStatus[ns2:group='com.ibm.rqm.process.web.entryCriteria']">
													<fo:table-row>
														<!-- objective -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//*[local-name()='title']" />
															</fo:block>
														</fo:table-cell>
														<!-- expected -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//ns2:operator" />
																<xsl:text />
																<xsl:value-of select=".//ns2:targetValue" />
															</fo:block>
														</fo:table-cell>
														<!-- actual value -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select="ns2:actualValue" />
															</fo:block>
														</fo:table-cell>
														<!-- status -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:choose>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.success'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.success" />
																	</xsl:when>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.unsuccessful'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.unsuccessful" />
																	</xsl:when>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.unresolved'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.unresolved" />
																	</xsl:when>
																	<xsl:otherwise>
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.not_started" />
																	</xsl:otherwise>
																</xsl:choose>
															</fo:block>
														</fo:table-cell>
														<!-- comment -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//*[local-name()='comment']" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
												</xsl:for-each>
											</fo:table-body>
										</fo:table>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- EXIT CRITERIA -->
							<xsl:when test="@name='RQM-KEY-PROC-EXIT-CRITERIA-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/RQM-KEY-PROC-EXIT-CRITERIA-TITLE" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:objectives/ns2:objectiveStatus/ns2:group='com.ibm.rqm.process.web.exitCriteria'">									
										<fo:table xsl:use-attribute-sets="artifact-table" space-after="4mm">
											<fo:table-header xsl:use-attribute-sets="artifact-table-header">
												<!-- Objective -->
												<fo:table-cell xsl:use-attribute-sets="border" width="50mm">
													<fo:block>
														<xsl:value-of select="$strings/labelObjective" />
													</fo:block>
												</fo:table-cell>
												<!-- Expected -->
												<fo:table-cell xsl:use-attribute-sets="border" width="20mm">
													<fo:block>
														<xsl:value-of select="$strings/labelExpected" />
													</fo:block>
												</fo:table-cell>
												<!-- Actual Value -->
												<fo:table-cell xsl:use-attribute-sets="border" width="20mm">
													<fo:block>
														<xsl:value-of select="$strings/labelActual" />
													</fo:block>
												</fo:table-cell>
												<!-- Status -->
												<fo:table-cell xsl:use-attribute-sets="border" width="25mm">
													<fo:block>
														<xsl:value-of select="$strings/reqLabel_status" />
													</fo:block>
												</fo:table-cell>
												<!-- Comment -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block>
														<xsl:value-of select="$strings/labelComment" />
													</fo:block>
												</fo:table-cell>
											</fo:table-header>
											<fo:table-body>
												<xsl:for-each select="../ns2:objectives/ns2:objectiveStatus[ns2:group='com.ibm.rqm.process.web.exitCriteria']">
													<fo:table-row>
														<!-- objective -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//*[local-name()='title']" />
															</fo:block>
														</fo:table-cell>
														<!-- expected -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//ns2:operator" />
																<xsl:text />
																<xsl:value-of select=".//ns2:targetValue" />
															</fo:block>
														</fo:table-cell>
														<!-- actual value -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select="ns2:actualValue" />
															</fo:block>
														</fo:table-cell>
														<!-- status -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:choose>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.success'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.success" />
																	</xsl:when>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.unsuccessful'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.unsuccessful" />
																	</xsl:when>
																	<xsl:when test="ns2:state='com.ibm.rqm.planning.objectives.unresolved'">
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.unresolved" />
																	</xsl:when>
																	<xsl:otherwise>
																		<xsl:value-of select="$strings/com.ibm.rqm.planning.objectives.not_started" />
																	</xsl:otherwise>
																</xsl:choose>
															</fo:block>
														</fo:table-cell>
														<!-- comment -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block>
																<xsl:value-of select=".//*[local-name()='comment']" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
												</xsl:for-each>
											</fo:table-body>
										</fo:table>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- TEST CASES -->
							<xsl:when test="@name='RQM-KEY-TP-TEST-CASES-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/labelTestCases" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:testcase">
										<xsl:choose>
											<!-- COMPOSITE RECURSIVE PRINT -->
											<xsl:when test="(../ns2:testcase/fo:wrapper/fo:block) and (../ns2:testcase/fo:wrapper/fo:table-row)">
												<fo:table xsl:use-attribute-sets="artifact-table">
													<fo:table-header xsl:use-attribute-sets="artifact-table-header">
														<!-- id -->
														<fo:table-cell xsl:use-attribute-sets="border id-header">
															<fo:block><xsl:value-of select="$strings/labelId"/></fo:block>
														</fo:table-cell>
														<!-- name -->
														<fo:table-cell xsl:use-attribute-sets="border">
															<fo:block><xsl:value-of select="$strings/labelName"/></fo:block>
														</fo:table-cell>
														<!-- state -->
														<fo:table-cell xsl:use-attribute-sets="border" width="60">
															<fo:block><xsl:value-of select="$strings/labelState"/></fo:block>
														</fo:table-cell>
														<!-- weight -->
														<fo:table-cell xsl:use-attribute-sets="border" width="25">
															<fo:block><xsl:value-of select="$strings/labelWeight"/></fo:block>
														</fo:table-cell>
														<!-- last modified -->
														<fo:table-cell xsl:use-attribute-sets="border timestamp-header">
															<fo:block><xsl:value-of select="$strings/labelModifiedDate"/></fo:block>
														</fo:table-cell>
													</fo:table-header>
													<fo:table-body>
														<xsl:copy-of select="../ns2:testcase/fo:wrapper/fo:table-row" />
													</fo:table-body>
												</fo:table>
												<xsl:for-each select="../ns2:testcase/fo:wrapper/fo:block">
													<xsl:choose>
														<xsl:when test="//pageBreaks = 'false'">
															<fo:block>
																<fo:leader/>
																<xsl:copy-of select="." />
															</fo:block>
														</xsl:when>
														<xsl:otherwise>
															<fo:block break-before="page">
																<xsl:copy-of select="." />
															</fo:block>
														</xsl:otherwise>
													</xsl:choose>
												</xsl:for-each>
											</xsl:when>
											<!-- COMPOSITE SUMMARY VIEW -->
											<xsl:when test="../ns2:testcase/fo:table">
												<fo:table xsl:use-attribute-sets="artifact-table">
													<xsl:copy-of select="../ns2:testcase/fo:table/fo:table-header" />
													<fo:table-body>
														<xsl:copy-of select="../ns2:testcase/fo:table/fo:table-body/fo:table-row" />
														<xsl:copy-of select="../ns2:testcase/fo:table-row" />
													</fo:table-body>
												</fo:table>
											</xsl:when>
											<!-- COMPOSITE STAND ALONE -->
											<xsl:when test="../ns2:testcase/fo:block">
												<xsl:copy-of select="../ns2:testcase/fo:block" />
											</xsl:when>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- RESOURCES -->
							<xsl:when test="@name='RQM-KEY-TP-RESOURCES-TITLE'">
							</xsl:when>
							
							<!-- ATTACHMENTS -->
							<xsl:when test="@name='RQM-KEY-ATTACHMENTS-TITLE'">
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/labelAttachments" />
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:attachment">									
										<fo:table xsl:use-attribute-sets="artifact-table">
											<fo:table-header xsl:use-attribute-sets="artifact-table-header">
												<!-- id -->
												<fo:table-cell xsl:use-attribute-sets="border id-header">
													<fo:block><xsl:value-of select="$strings/labelId"/></fo:block>
												</fo:table-cell>
												<!-- file name -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block><xsl:value-of select="$strings/labelFileName"/></fo:block>	
												</fo:table-cell>
												<!-- label size -->
												<fo:table-cell xsl:use-attribute-sets="border" width="50">
													<fo:block><xsl:value-of select="$strings/labelSize"/></fo:block>
												</fo:table-cell>
											</fo:table-header>
											<fo:table-body>
												<xsl:apply-templates select="../ns2:attachment" />
											</fo:table-body>
										</fo:table>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- REQUIREMENT COLLECTIONS LINKS -->
							<xsl:when test="@name='RQM-KEY-RM-COL-SECTION-TITLE'">
								<!--
									Currently print does not support this section.
								-->
							</xsl:when>
							
							<!-- RISK ASSESSMENT -->
							<xsl:when test="@name='RQM-KEY-TP-RISK-TITLE'">
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline"
									text-align="left" keep-with-next="always">
									<xsl:value-of select="$strings/labelRiskAssessment" />
								</fo:block>
								<xsl:choose>
									<xsl:when test="../ns2:risk">
										<fo:block space-after="4mm" font-size="8pt">
											<xsl:apply-templates select="../ns2:com.ibm.rqm.risk.editor.section.planAssessment" />
										</fo:block>
										<fo:block space-after="4mm" font-size="8pt">
											<xsl:value-of select="$strings/labelRiskAssessment" />: 
											<xsl:value-of select="../ns2:risk/ns2:riskLevel"/>
										</fo:block>
										<xsl:if test="../ns2:risk/ns2:factors/ns2:factor">
											<fo:table space-after="4mm" font-size="8pt">
												<fo:table-header>
													<fo:table-row background-color="rgb(249,245,219)">
														<fo:table-cell padding="3pt" border="0.5pt solid black">
															<fo:block-container overflow="hidden">
																<fo:block font-weight="bold">
																	<xsl:value-of select="$strings/labelRisk" />
																</fo:block>
															</fo:block-container>
														</fo:table-cell>
														<fo:table-cell padding="3pt" border="0.5pt solid black">
															<fo:block-container overflow="hidden">
																<fo:block font-weight="bold">
																	<xsl:value-of select="$strings/labelImportance" />
																</fo:block>
															</fo:block-container>
														</fo:table-cell>
													</fo:table-row>
												</fo:table-header>
												<fo:table-body>
													<xsl:for-each select="../ns2:risk/ns2:factors/ns2:factor">
														<fo:table-row>
															<fo:table-cell padding="3pt" border="0.5pt solid black">
																<fo:block-container overflow="hidden">
																	<fo:block>
																		<xsl:apply-templates select="ns2:name" />
																	</fo:block>
																</fo:block-container>
															</fo:table-cell>
															<fo:table-cell padding="3pt" border="0.5pt solid black">
																<fo:block-container overflow="hidden">
																	<fo:block><xsl:value-of select="ns2:weight" /></fo:block>
																</fo:block-container>
															</fo:table-cell>
														</fo:table-row>
													</xsl:for-each>
												</fo:table-body>
											</fo:table>
										</xsl:if>
										<xsl:if test="../ns2:risk/ns2:commnunityAssessment">
											<fo:table font-size="8pt">
												<fo:table-column column-width="25mm" />
												<fo:table-column column-width="25mm" />
												<fo:table-body>
													<fo:table-row>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="$strings/veryHigh" />:
															</fo:block>
														</fo:table-cell>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="../ns2:risk/ns2:commnunityAssessment/ns2:veryHighAmount" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
													<fo:table-row>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="$strings/high" />:
															</fo:block>
														</fo:table-cell>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="../ns2:risk/ns2:commnunityAssessment/ns2:highAmount" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
													<fo:table-row>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="$strings/neutral" />:
															</fo:block>
														</fo:table-cell>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="../ns2:risk/ns2:commnunityAssessment/ns2:neutralAmount" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
													<fo:table-row>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="$strings/low" />:
															</fo:block>
														</fo:table-cell>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="../ns2:risk/ns2:commnunityAssessment/ns2:lowAmount" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
													<fo:table-row>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="$strings/veryLow" />:
															</fo:block>
														</fo:table-cell>
														<fo:table-cell>
															<fo:block>
																<xsl:value-of select="../ns2:risk/ns2:commnunityAssessment/ns2:veryLowAmount" />
															</fo:block>
														</fo:table-cell>
													</fo:table-row>
												</fo:table-body>
											</fo:table>
										</xsl:if>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							
							<!-- APPLICATION SECURITY -->
							<xsl:when test="@name='RQM-KEY-APPSCAN-TP-APPLICATION-SECURITY-TITLE'">
							</xsl:when>
							
							<!-- CHILD TEST PLANS -->
							<xsl:when test="@name='RQM-KEY-TP-CHILDREN-TITLE'">
								<xsl:variable name="childList" select="../ns2:childplan"/>
								
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline" text-align="left"
									keep-with-next="always">
									<xsl:value-of select="$strings/childTestPlans"/>
								</fo:block>
								
								<xsl:if test="$childList">
									<fo:table xsl:use-attribute-sets="artifact-table">
										<fo:table-header xsl:use-attribute-sets="artifact-table-header">
											<fo:table-row>
												<!-- ID (no header) -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block/>
												</fo:table-cell>
												<!-- Risk -->
												<!--We can't do this right now because we cannot get access to the enhancers from our 
													UriResolver.
													<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block><xsl:value-of select="$strings/labelRisk"/></fo:block>
													</fo:table-cell>-->
												<!-- State -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block><xsl:value-of select="$strings/labelState"/></fo:block>
												</fo:table-cell>
												<!-- Name -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block><xsl:value-of select="$strings/labelName"/></fo:block>
												</fo:table-cell>
												<!-- Last Modified Date -->
												<fo:table-cell xsl:use-attribute-sets="border">
													<fo:block><xsl:value-of select="$strings/DateLastModified"/></fo:block>
												</fo:table-cell>
											</fo:table-row>
										</fo:table-header>
										<fo:table-body>
											<xsl:for-each select="$childList">
												<xsl:variable name="child" select="document(concat('rest://', @href))/ns2:testplan"/>
												
												<fo:table-row>
													<!-- ID (no header) -->
													<fo:table-cell xsl:use-attribute-sets="border" width="26">
														<fo:block><xsl:value-of select="substring-after($child/ns3:identifier, 'testplan:')"/></fo:block>
													</fo:table-cell>
													<!-- Risk -->
													<!--<fo:table-cell xsl:use-attribute-sets="border" width="25">
														<fo:block><xsl:value-of select="$child/ns2:risk/ns2:riskLevel"/></fo:block>
														</fo:table-cell>-->
													<!-- State -->
													<fo:table-cell xsl:use-attribute-sets="border" width="50">
														<xsl:variable name="state" select="$child/ns4:state"/>
														
														<fo:block>
															<xsl:choose>
																<xsl:when test="$state='com.ibm.rqm.planning.common.new'">
																	<xsl:value-of select="$strings/com.ibm.rqm.planning.common.new"/>
																</xsl:when>
																<xsl:when test="$state='com.ibm.rqm.planning.common.underreview'">
																	<xsl:value-of select="$strings/com.ibm.rqm.planning.common.underreview"/>
																</xsl:when>
																<xsl:when test="$state='com.ibm.rqm.planning.common.approved'">
																	<xsl:value-of select="$strings/com.ibm.rqm.planning.common.approved"/>
																</xsl:when>
																<xsl:otherwise>
																	<xsl:value-of select="$state"/>
																</xsl:otherwise>
															</xsl:choose>
														</fo:block>
													</fo:table-cell>
													<!-- Name -->
													<fo:table-cell xsl:use-attribute-sets="border">
														<fo:block><xsl:value-of select="$child/ns3:title"/></fo:block>
													</fo:table-cell>
													<!-- Last Modified Date -->
													<fo:table-cell xsl:use-attribute-sets="border" width="75">
														<fo:block><xsl:value-of select="$child/ns4:updated"/></fo:block>
													</fo:table-cell>
												</fo:table-row>
											</xsl:for-each>
										</fo:table-body>
									</fo:table>
								</xsl:if>
							</xsl:when>
							
							<!-- CUSTOM SECTIONS -->
							<xsl:otherwise>
								<!-- Section Header -->
								<fo:block font-size="10pt" space-before="4mm" space-after="4mm" font-weight="bold" text-decoration="underline" text-align="left"
									keep-with-next="always">
									<xsl:value-of select="@name"/>
								</fo:block>
								
								<!-- Section Content -->
								<xsl:choose>
									<xsl:when test="../ns2:*[@extensionDisplayName=current()/@name]">
										<fo:block font-size="8pt" space-after="4mm">
											<xsl:apply-templates select="../ns2:*[@extensionDisplayName=current()/@name]"/>
										</fo:block>
									</xsl:when>
									<xsl:otherwise>
										<xsl:call-template name="empty-section">
											<xsl:with-param name="section-name" select="@name"/>
										</xsl:call-template>
									</xsl:otherwise>
								</xsl:choose>
								
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</fo:block>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="ns2:attachment">
		<xsl:if test="name">
			<fo:table-row>
				<!-- id -->
				<fo:table-cell xsl:use-attribute-sets="border id-cell">
					<fo:block><xsl:value-of select="id"/></fo:block>
				</fo:table-cell>
				<!-- file name -->
				<fo:table-cell xsl:use-attribute-sets="border">
					<fo:block>
						<fo:basic-link external-destination="{download-link}" xsl:use-attribute-sets="simple-link">
							<xsl:apply-templates select="name"/>
						</fo:basic-link>
					</fo:block>
				</fo:table-cell>
				<!-- size -->
				<fo:table-cell xsl:use-attribute-sets="border" text-align="right">
					<fo:block><xsl:value-of select="size"/></fo:block>
				</fo:table-cell>
			</fo:table-row>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="ns2:keydates/ns2:keydate">
		<fo:table-row font-size="8pt">
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:value-of select="ns2:name" />
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:value-of select="ns2:description" />
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:value-of select="ns2:date" />
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
		</fo:table-row>
	</xsl:template>
	
	<xsl:template match="ns2:testSchedule/ns2:testPhase">
		<fo:table-row>
			<!-- name -->
			<fo:table-cell xsl:use-attribute-sets="border">
				<fo:block>
					<xsl:apply-templates select="name"/>
				</fo:block>
			</fo:table-cell>
			<!-- description -->
			<fo:table-cell xsl:use-attribute-sets="border">
				<fo:block>
					<xsl:apply-templates select="description"/>
				</fo:block>
			</fo:table-cell>
			<!-- planned start date -->
			<fo:table-cell xsl:use-attribute-sets="border date-cell">
				<fo:block>
					<xsl:value-of select="plannedStartDate"/>
				</fo:block>
			</fo:table-cell>
			<!-- planned end date -->
			<fo:table-cell xsl:use-attribute-sets="border date-cell">
				<fo:block>
					<xsl:value-of select="plannedEndDate"/>
				</fo:block>
			</fo:table-cell>
			<!-- actual start date -->
			<fo:table-cell xsl:use-attribute-sets="border date-cell">
				<fo:block>
					<xsl:value-of select="actualStartDate"/>
				</fo:block>
			</fo:table-cell>
			<!-- actual end date -->
			<fo:table-cell xsl:use-attribute-sets="border date-cell">
				<fo:block>
					<xsl:value-of select="actualEndDate"/>
				</fo:block>
			</fo:table-cell>
			<!-- points -->
			<fo:table-cell xsl:use-attribute-sets="border" text-align="end">
				<fo:block>
					<xsl:value-of select="points"/>
				</fo:block>
			</fo:table-cell>
		</fo:table-row>
	</xsl:template>
	
	<xsl:template match="ns2:estimation">
		<fo:table space-after="10pt" font-size="8pt"> <!--keep-together="always"-->
			<fo:table-column column-width="32mm" />
			<fo:table-column column-width="5mm" />
			<fo:table-column column-width="100%" />
			<fo:table-body>
				<fo:table-row>
					<fo:table-cell>
						<fo:block-container overflow="hidden">
							<fo:block font-weight="bold">
								<xsl:value-of
									select="$strings/labelPlanningEffort" />
							</fo:block>
						</fo:block-container>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block-container overflow="hidden">
							<fo:block font-weight="bold">:</fo:block>
						</fo:block-container>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block-container overflow="hidden">
							<fo:block>
								<xsl:call-template name="ConvertHours">
									<xsl:with-param name="TotalHours" select="ns2:planningEffort" />
								</xsl:call-template>
							</fo:block>
						</fo:block-container>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell>
						<fo:block-container overflow="hidden">
							<fo:block font-weight="bold">
								<xsl:value-of
									select="$strings/labelExecutionEffort" />
							</fo:block>
						</fo:block-container>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block-container overflow="hidden">
							<fo:block font-weight="bold">:</fo:block>
						</fo:block-container>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block-container overflow="hidden">
							<fo:block>
								<xsl:call-template name="ConvertHours">
									<xsl:with-param name="TotalHours" select="ns2:executionEffort" />
								</xsl:call-template>
							</fo:block>
						</fo:block-container>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
		</fo:table>
	</xsl:template>
	
	<xsl:template match="ns2:approvals/ns2:approvalDescriptor">
		<fo:table-row font-size="8pt">
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:choose>
							<xsl:when
								test="ns2:approvalType='com.ibm.team.workitem.approvalType.approval'">
								<xsl:value-of
									select="$strings/labelApprovalApprovalTable" />
							</xsl:when>
							<xsl:when
								test="ns2:approvalType='com.ibm.team.workitem.approvalType.review'">
								<xsl:value-of
									select="$strings/labelReviewerApprovalTable" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of
									select="$strings/labelUnassigned" />
							</xsl:otherwise>
						</xsl:choose>
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:value-of select="ns2:approval/ns2:approvalOwner" />
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:choose>
							<xsl:when
								test="ns2:approval/ns2:approvalStatus='com.ibm.team.workitem.approvalState.approved'">
								<xsl:value-of
									select="$strings/labelApprovedApprovalTable" />
							</xsl:when>
							<xsl:when
								test="ns2:approval/ns2:approvalStatus='com.ibm.team.workitem.approvalState.pending'">
								<xsl:value-of
									select="$strings/labelPendingApprovalTable" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of
									select="$strings/labelUnassigned" />
							</xsl:otherwise>
						</xsl:choose>
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:apply-templates select="comment/content" />
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
			<fo:table-cell padding="3pt" border="0.5pt solid black">
				<fo:block-container overflow="hidden">
					<fo:block>
						<xsl:value-of select="comment/date" />
					</fo:block>
				</fo:block-container>
			</fo:table-cell>
		</fo:table-row>
	</xsl:template>

	<xsl:template name="ConvertHours">
		<xsl:param name="TotalHours" />
		<xsl:variable name="Years" select="($TotalHours) div 8760" />
		<xsl:variable name="Months" select="($TotalHours) div 720" />
		<xsl:variable name="Days" select="($TotalHours) div 24" />
		<xsl:variable name="Hours" select="($TotalHours)" />
		<xsl:choose>
			<xsl:when test="($Years &gt;= 1) and (floor($Years)=$Years)">
				<xsl:value-of select="floor($Years)" />
				Years
			</xsl:when>
			<xsl:when test="($Months &gt;= 1) and (floor($Months)=$Months)">
				<xsl:value-of select="floor($Months)" />
				Months
			</xsl:when>
			<xsl:when test="($Days &gt;= 1) and (floor($Days)=$Days)">
				<xsl:value-of select="floor($Days)" />
				Days
			</xsl:when>
			<xsl:when test="($Hours &gt;= 1) and (floor($Hours)=$Hours)">
				<xsl:value-of select="floor($Hours)" />
				Hours
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="empty-section">
		<xsl:param name="section-name"/>
		
		<fo:block><fo:leader/></fo:block>
	</xsl:template>
	
	<xsl:template match="ns2:name">
		<xsl:choose>
			<xsl:when test=".='Insufficient test resources'">
				<xsl:value-of select="$strings/insufficientTestResources" />
			</xsl:when>
			<xsl:when test=".='Insufficient test configurations'">
				<xsl:value-of select="$strings/insufficientTestConfigurations" />
			</xsl:when>
			<xsl:when test=".='Insufficient static review in design'">
				<xsl:value-of select="$strings/insufficientStaticReviewInDesign" />
			</xsl:when>
			<xsl:when test=".='Lack of skills'">
				<xsl:value-of select="$strings/lackOfSkills" />
			</xsl:when>
			<xsl:when test=".='New technology'">
				<xsl:value-of select="$strings/newTechnology" />
			</xsl:when>
			<xsl:when test=".='Aggressive schedule'">
				<xsl:value-of select="$strings/aggressiveSchedule" />
			</xsl:when>
			<xsl:when test=".='Inexperienced team'">
				<xsl:value-of select="$strings/inexperiencedTeam" />
			</xsl:when>
			<xsl:when test=".='Large development team'">
				<xsl:value-of select="$strings/largeDevelopmentTeam" />
			</xsl:when>
			<xsl:when test=".='Geographically distributed team'">
				<xsl:value-of select="$strings/geographicallyDistributedTeam" />
			</xsl:when>
			<xsl:when test=".='Historically problematic area'">
				<xsl:value-of select="$strings/historicallyProblematicArea" />
			</xsl:when>
			<xsl:when test=".='Lack of formal development process'">
				<xsl:value-of select="$strings/lackOfFormalDevelopmentProcess" />
			</xsl:when>
			<xsl:when test=".='Complex System integration involved'">
				<xsl:value-of select="$strings/complexSystemIntegrationInvolved" />
			</xsl:when>
			<xsl:when test=".='Insufficient developer test'">
				<xsl:value-of select="$strings/insufficientDeveloperTest" />
			</xsl:when>
			<xsl:when test=".='Loss of revenue'">
				<xsl:value-of select="$strings/lossOfRevenue" />
			</xsl:when>
			<xsl:when test=".='Damage to third parties'">
				<xsl:value-of select="$strings/damageToThirdParties" />
			</xsl:when>
			<xsl:when test=".='Economic Loss'">
				<xsl:value-of select="$strings/economicLoss" />
			</xsl:when>
			<xsl:when test=".='Physical damage'">
				<xsl:value-of select="$strings/physicalDamage" />
			</xsl:when>
			<xsl:when test=".='Costs of corrections and repair'">
				<xsl:value-of select="$strings/costsOfCorrectionsAndRepair" />
			</xsl:when>
			<xsl:when test=".='Damage to reputation'">
				<xsl:value-of select="$strings/damageToReputation" />
			</xsl:when>
			<xsl:when test=".='Loss of customer trust'">
				<xsl:value-of select="$strings/lossOfCustomerTrust" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="." />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
