<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <!-- Page Title -->
    <xsl:attribute-set name="page-title">
        <xsl:attribute name="font-size"><xsl:value-of select="'14pt'"/></xsl:attribute>
        <xsl:attribute name="font-weight">bold</xsl:attribute>
        <xsl:attribute name="keep-with-next">always</xsl:attribute>
        <xsl:attribute name="page-break-inside">avoid</xsl:attribute>
        <xsl:attribute name="text-align">left</xsl:attribute>
    </xsl:attribute-set>
    
    <!-- Page Subtitle -->
    <xsl:attribute-set name="page-subtitle">
        <xsl:attribute name="font-size"><xsl:value-of select="'12pt'"/></xsl:attribute>
        <xsl:attribute name="color">rgb(190,190,190)</xsl:attribute>
        <xsl:attribute name="font-weight">bold</xsl:attribute>
    </xsl:attribute-set>
    
    <!-- Section Heading -->
    <xsl:attribute-set name="section-heading">
        <xsl:attribute name="font-size"><xsl:value-of select="'10pt'"/></xsl:attribute>
        <xsl:attribute name="font-weight">bold</xsl:attribute>
        <xsl:attribute name="font-style">normal</xsl:attribute>
        <xsl:attribute name="space-before">12pt</xsl:attribute>
        <xsl:attribute name="space-after">8pt</xsl:attribute>
        <xsl:attribute name="keep-with-next">always</xsl:attribute>
        <xsl:attribute name="page-break-inside">avoid</xsl:attribute>
        <xsl:attribute name="text-align">left</xsl:attribute>
    </xsl:attribute-set>
    
    <xsl:attribute-set name="subsection-heading" use-attribute-sets="section-heading">
        <xsl:attribute name="font-size"><xsl:value-of select="'10pt'"/></xsl:attribute>
    </xsl:attribute-set>
    
    <!-- Simple Text -->
    <xsl:attribute-set name="simple-text">
        <xsl:attribute name="font-size">7pt</xsl:attribute>
    </xsl:attribute-set>
    
    <!-- Simple Link -->
    <xsl:attribute-set name="simple-link">
        <xsl:attribute name="color">blue</xsl:attribute>
        <xsl:attribute name="text-decoration">underline</xsl:attribute>
    </xsl:attribute-set>
    
    <!-- Artifact Table -->
    <xsl:attribute-set name="artifact-table" use-attribute-sets="simple-text">
        
    </xsl:attribute-set>
    
    <!-- Artifact Table Header -->
    <xsl:attribute-set name="artifact-table-header" use-attribute-sets="artifact-table">
        <xsl:attribute name="text-align">center</xsl:attribute>
        <xsl:attribute name="font-weight">bold</xsl:attribute>
        <xsl:attribute name="font-size">7pt</xsl:attribute>
        
        <xsl:attribute name="background-color">rgb(249,245,219)</xsl:attribute>
    </xsl:attribute-set>
    
    <!-- Table Default Border -->
    <xsl:attribute-set name="border">
        <xsl:attribute name="border">solid 1pt black</xsl:attribute>
        <xsl:attribute name="padding">1mm</xsl:attribute>
    </xsl:attribute-set>
    
    <!-- specific kinds of cells -->
    <xsl:attribute-set name="id-header">
        <xsl:attribute name="width">40</xsl:attribute>
    </xsl:attribute-set>
    
    <xsl:attribute-set name="id-cell">
        <xsl:attribute name="text-align">center</xsl:attribute>    
    </xsl:attribute-set>
    
    <xsl:attribute-set name="user-header">
        <xsl:attribute name="width">50</xsl:attribute>
    </xsl:attribute-set>
    
    <xsl:attribute-set name="timestamp-header">
        <xsl:attribute name="width">100</xsl:attribute>
    </xsl:attribute-set>
    
    <xsl:attribute-set name="timestamp-cell">
        <xsl:attribute name="text-align">center</xsl:attribute>
    </xsl:attribute-set>
    
    <xsl:attribute-set name="date-header">
        <xsl:attribute name="width">35</xsl:attribute>
    </xsl:attribute-set>
    
    <xsl:attribute-set name="date-cell">
        <xsl:attribute name="text-align">center</xsl:attribute>
    </xsl:attribute-set>
    
</xsl:stylesheet>