/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {
    
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.requireLocalization("com.ibm.rqm.planning.web.ui.internal", "messages");

// already defined message bundle id for RTLM
var MessageBundleRTLM = MessageBundle.LM_CATALOG;
var MessageBundleRTLMBase = "RTLM";

// define a message bundle id for RQM
var MessageBundleRQM = "RQM";

var CommonPreferenceClient = com.ibm.asq.common.web.client.internal.CommonPreferenceClient;

dojo.declare("com.ibm.rqm.planning.web.client.internal._MessageLoader", null,
{
    constructor: function(){
        // initializes the rqm message bundle
        MessageUtil.registerRequireBundle(MessageBundleRQM, "com.ibm.rqm.planning.web.ui.internal", "messages");
        console.debug("Registered QM bundle: \"" + MessageUtil.getMessage(MessageBundleRQM, "bundle_description") + "\"" );
    }
});

// create an instance to ensure the message bundle is loaded
com.ibm.rqm.planning.web.client.internal.MessageLoader = new com.ibm.rqm.planning.web.client.internal._MessageLoader();

com.ibm.rqm.planning.web.client.internal.Constants = {

	NEW_PAGE_TITLE: MessageUtil.getMessage(MessageBundleRQM, "labelNewPageTitle"),
	
	DB_STRING_SIZE_LARGE: Math.pow(2,15),
	DB_STRING_SIZE_MEDIUM: 1000,
	DB_STRING_SIZE_SMALL: 250,

	HEADER_STATUS_ERROR: 1,
	HEADER_STATUS_SUCCESS: 2,
	HEADER_STATUS_INFO: 3,
	HEADER_STATUS_WARNING: 4,
	
	CLASSNAME_PLAN: "TestPlanDTO",
	CLASSNAME_GROUP: "TestCaseGroupDTO",
	CLASSNAME_CASE: "TestCaseDTO",
	CLASSNAME_CASESUMMARY: "TestCaseSummaryDTO",
	CLASSNAME_SCRIPT: "ManualExecutionScriptDTO",
	CLASSNAME_EWI: "ExecutionWorkItemDTO",
	CLASSNAME_PLAN_SIZING: "TestPlanWithSizingDTO",
	CLASSNAME_GROUP_SIZING: "TestCaseGroupWithSizingDTO",
	CLASSNAME_CASE_SIZING: "TestCaseWithSizingDTO",
	CLASSNAME_SCRIPT_SIZING: "TestScriptWithSizingDTO",
	CLASSNAME_WORKITEM: "WorkItemDTO",
	
	MODEL_PACKAGE: "com.ibm.rqm.planning",
	MODEL_TYPE_PLAN: "com.ibm.rqm.planning.TestPlan",
	MODEL_TYPE_VERSIONED_PLAN: "com.ibm.rqm.planning.VersionedTestPlan",
	MODEL_TYPE_GROUP: "com.ibm.rqm.planning.TestCaseGroup",
	MODEL_TYPE_CASE: "com.ibm.rqm.planning.TestCase",
	MODEL_TYPE_VERSIONED_CASE: "com.ibm.rqm.planning.VersionedTestCase",
	MODEL_TYPE_VERSIONED_SCRIPT: "com.ibm.rqm.planning.VersionedExecutionScript",
	MODEL_TYPE_SCRIPT: "com.ibm.rqm.planning.ManualExecutionScript",
	MODEL_TYPE_REMOTE_SCRIPT: "com.ibm.rqm.planning.RemoteExecutionScript",
	MODEL_TYPE_OBJECTIVE: "com.ibm.rqm.planning.Objective",
	MODEL_TYPE_CATEGORY_TYPE: "com.ibm.rqm.planning.CategoryType",
	MODEL_TYPE_CATEGORY: "com.ibm.rqm.planning.Category",
	MODEL_TYPE_WORKITEM: "com.ibm.team.workitem.WorkItem",
	MODEL_TYPE_DATAPOOL: "com.ibm.rqm.datapool.Datapool",
	MODEL_TYPE_KEYWORD: "com.ibm.rqm.keyword.Keyword",
	MODEL_TYPE_SUITE: "com.ibm.rqm.execution.TestExecutionSuite",	
	MODEL_TYPE_EWI: "com.ibm.rqm.execution.ExecutionWorkItem",
	MODEL_TYPE_RESULT: "com.ibm.rqm.execution.ExecutionResult",
	MODEL_TYPE_RESULT_STATE: "com.ibm.rqm.execution.ExecutionResultState",
	MODEL_TYPE_REQUIREMENT: "com.ibm.rqm.requirement.Requirement",
	MODEL_TYPE_CONFIGURATION: "com.ibm.rational.lm.Configuration",
	MODEL_TYPE_BUILD_DEFINITION: "com.ibm.rqm.buildintegration.BuildDefinition",
	MODEL_TYPE_BUILD_RECORD: "com.ibm.rqm.buildintegration.BuildRecord",
	MODEL_TYPE_LAB_REQUEST: "com.ibm.rational.test.lm.Request",
	MODEL_TYPE_TEST_ENVIRONMENT: "com.ibm.rational.test.lm.AssetConfiguration",
	MODEL_TYPE_TEST_CELL: "com.ibm.rational.test.lm.ResourceCollection",
	MODEL_TYPE_RESOURCE_GROUP: "com.ibm.rational.test.lm.AssetGroup",
	MODEL_TYPE_EXECUTION_SEQUENCE: "com.ibm.rational.test.lm.sequencer.ExecutionSequence",
	MODEL_TYPE_LAB_RESOURCE: "com.ibm.rational.test.lm.LabResource",
	//MODEL_TYPE_DATAPOOL: "com.ibm.rqm.datapool.DataPool",
	MODEL_TYPE_UNKNOWN: MessageUtil.getMessage(MessageBundleRQM, "labelUnknown"),

	TYPE_WORK_ITEM: MessageUtil.getMessage(MessageBundleRQM, "labelWorkItem"),
	TYPE_PLAN: MessageUtil.getMessage(MessageBundleRQM, "labelTestPlan"),
	TYPE_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelTestCaseGrp"),
	TYPE_CASE: MessageUtil.getMessage(MessageBundleRQM, "labelTestCase"),
	TYPE_SCRIPT: MessageUtil.getMessage(MessageBundleRQM, "labelTestScript"),
	TYPE_EWI: MessageUtil.getMessage(MessageBundleRQM, "labelEWI"),
	TYPE_RESULT: MessageUtil.getMessage(MessageBundleRQM, "labelExeResult"),
	TYPE_SUITE: MessageUtil.getMessage(MessageBundleRQM, "labelTestSuite"),	
    TYPE_EXE_LOG: "Execution Log",
	TYPE_REQUEST: "Adapter Request",
	EWI: "executionworkitem",
	TYPE_EWILIST: MessageUtil.getMessage(MessageBundleRQM, "labelEWI"),
	TYPE_PLAN_SIZING: MessageUtil.getMessage(MessageBundleRQM, "labelTestPlanSizing"),
	TYPE_GROUP_SIZING: MessageUtil.getMessage(MessageBundleRQM, "labelTestGrpSizing"),
	TYPE_CASE_SIZING: MessageUtil.getMessage(MessageBundleRQM, "labelTestCaseSizing"),
	TYPE_SCRIPT_SIZING: MessageUtil.getMessage(MessageBundleRQM, "labelTestScriptSizing"),
	TYPE_REQUIREMENT: MessageUtil.getMessage(MessageBundleRQM, "labelRequirement"),
	TYPE_WORKITEM: MessageUtil.getMessage(MessageBundleRQM, "labelWorkItem"),
	TYPE_DATAPOOL: MessageUtil.getMessage(MessageBundleRQM, "labelDatapool"),
	TYPE_KEYWORD: MessageUtil.getMessage(MessageBundleRQM, "labelKeyword"),
	TYPE_CONFIGURATION:MessageUtil.getMessage(MessageBundleRQM,"labelConfiguration"),
	TYPE_BUILD_DEFINITION: MessageUtil.getMessage(MessageBundleRQM,"labelBuildDef"),
	TYPE_BUILD_RECORD: MessageUtil.getMessage(MessageBundleRQM,"labelBuildRecord"),
    TYPE_LAB_REQUEST: MessageUtil.getMessage(MessageBundleRQM,"labelRequest"),
    TYPE_TEST_ENVIRONMENT: MessageUtil.getMessage(MessageBundleRQM,"labelTestEnvironment"),
    TYPE_TEST_CELL: MessageUtil.getMessage(MessageBundleRQM,"labelTestCell"),        
    TYPE_RESOURCE_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelResGrp"),        
    TYPE_EXECUTION_SEQUENCE: MessageUtil.getMessage(MessageBundleRQM, "labelExecutionSequence"),
    TYPE_LAB_RESOURCE: MessageUtil.getMessage(MessageBundleRQM, "labelLabRes"), 
	TYPE_TC_CATEGORY: "TestCaseCategoryType",
    TYPE_TP_CATEGORY: "TestPlanCategoryType",
	TYPE_TES_CATEGORY: "TestSuiteCategoryType",
	
	CALM_LINK_TYPE_PLAN_ITEM: "com.ibm.rqm.planning.linktype.testedByTestCase",
	CALM_LINK_TYPE_REQUIREMENT: "com.ibm.rqm.planning.linktype.testcase.validatesRequirement",
	CALM_LINK_TYPE_REQUIREMENT_SET: "com.ibm.rqm.planning.linktype.testplan.validatesRequirementSet",
    
	IS_PROJECT_AREA_ADMIN: "com.ibm.rqm.permissions.isProjectAreaAdmin",
	
	PERMISSIONS_INIT_DATA_KEY: "com.ibm.rqm.planning.service.permissionsWebUIInitializer",
	USER_PROJECT_AREAS_OBJECT_ID: "com.ibm.rqm.web.userProjectAreas",		
	REGISTRY_INIT_DATA_KEY: "com.ibm.rqm.planning.service.registryWebUIInitializer",
	
	AUTH_USER_OBJECT_ID: "com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR",
	ROLE_JAZZ_ADMIN: "JazzAdmins",
	ROLE_JAZZ_PROJECT_ADMIN: "JazzProjectAdmins",
	ROLE_JAZZ_DWADMIN: "JazzDWAdmins",
	
	EDITOR_REGISTRY_OBJECT_ID: "com.ibm.rqm.planning.web.editorregistry",
	EDITOR_PREFIX: "com.ibm.rqm.planning.editor",
	EDITOR_TEMPLATE_PREFIX: "com.ibm.rqm.planning.templates",
	EDITOR_ID_PLAN: "com.ibm.rqm.planning.editor.testplan",
	EDITOR_ID_CASE: "com.ibm.rqm.planning.editor.testcase",
	EDITOR_ID_SCRIPT: "com.ibm.rqm.planning.editor.testScript",
	EDITOR_ID_SUITE: "com.ibm.rqm.planning.editor.testsuite",
	
	ACTION_BAR_REGISTRY_OBJECT_ID: "com.ibm.rqm.planning.web.actionbarrregistry",
	
	DYNAMICSECTION_RICHTEXT: "richtext",
	DYNAMICSECTION_GRID: "grid",
	DYNAMICSECTION_RICHTEXT_ID: "dynamicSection_",
	DYNAMICSECTION_GRID_ID: "dynamicGridSection_",
		
	STATUS_SUCCESS: MessageUtil.getMessage(MessageBundleRQM, "labelSuccess"),
	STATUS_FAILURE: MessageUtil.getMessage(MessageBundleRQM, "labelFailure"),
	STATUS_SAVING: MessageUtil.getMessage(MessageBundleRQM, "labelSaving"),
	STATUS_NEW: MessageUtil.getMessage(MessageBundleRQM, "labelNew"),
	STATUS_DIRTY: MessageUtil.getMessage(MessageBundleRQM, "labelDirty"),
	STATUS_NOT_NECESSARY: MessageUtil.getMessage(MessageBundleRQM, "labelSaveNotNecessary"),
	
	TEST_GROUP_WORKITEM_SUMMARY: MessageUtil.getMessage(MessageBundleRQM, "msgCompleteTestCaseGrp"),
	TEST_CASE_WORKITEM_SUMMARY: MessageUtil.getMessage(MessageBundleRQM, "msgCompleteTestCase"),
	TEST_CASE_DEFAULT_WEIGHT: 100,
	MAX_INT_VALUE_IN_HEX: 0x7fffffff, //Max what server can understand.
	
	TABLE_PROFILE_ALL: "ALL",
	TABLE_PROFILE_MINIMAL: "MINIMAL",
	
	//To show initial loading.. and when the lists are empty	
	LOADING: MessageUtil.getMessage(MessageBundleRQM, "labelLoading"),
	NO: MessageUtil.getMessage(MessageBundleRQM, "labelPrefixNo"),
	FOUND: MessageUtil.getMessage(MessageBundleRQM, "labelSuffixFound"),
	
	CSHELP_URL: "/help/rtopic/com.ibm.rational.test.qm.cshelp/topics/",
	CSHELP_INFO_CENTER_LABEL: MessageUtil.getMessage(MessageBundleRQM, "labelInfoCtr"),
	CSHELP_INFO_CENTER_HREF: "/help/index.jsp",	
	
	INCLUDE_PLAN: "($Test-Plan)",
	INCLUDE_ITERATION: "($Test-Milestone)",
	
	ROLE_OWNER: 0,
	ROLE_REVIEWER: 1,
	ROLE_GUEST: 2,

    MAX_INFO_PANEL_DEFECTS: 25, // number of defects show in the right hand side info panel

	PACKAGE_URI: "com.ibm.rqm.planning",
    APPROVAL_TYPE: "Review/Approval",
	
    TYPE_PENDING: "com.ibm.team.workitem.approvalState.pending",
    TYPE_APPROVED: "com.ibm.team.workitem.approvalState.approved",
    TYPE_REJECTED: "com.ibm.team.workitem.approvalState.rejected",
    TYPE_REOPEN: "com.ibm.team.workitem.approvalState.reopen",
	
	TYPE_APPROVER: "com.ibm.team.workitem.approvalType.approval",
	TYPE_REVIEWER: "com.ibm.team.workitem.approvalType.review",
	
	PROCESS_SUMMARY: MessageUtil.getMessage(MessageBundleRQM, "labelProcessSummay"),
	PROCESS_APPROVE: MessageUtil.getMessage(MessageBundleRQM, "labelProcessApprove"),
	
	PLAN_TYPE: "VersionedTestPlan",
	CASE_TYPE: "VersionedTestCase",
	
	PROCESS_TEST_GROUP: "Test Group Approval",
    PROCESS_TEST_CASE: "Test Case Approval",
    PROCESS_SCRIPT: "Test Script Approval",
	
	VALIDATION_ERROR:  MessageUtil.getMessage(MessageBundleRQM, "labelValidationError"),
	OPERATION_WARNING:  MessageUtil.getMessage(MessageBundleRQM, "labelOperationWarning"),
	
	APPROVAL_TITLE_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelTitleApprovalTable"),
	APPROVAL_NAME_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelNameApprovalTable"),
	APPROVAL_STATUS_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelStatusApprovalTable"),
	APPROVAL_COMMENTS_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelCommentsApprovalTable"),
	APPROVAL_MODIFIED_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelModifiedApprovalTable"),

	APPROVAL_APPROVAL_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelApprovalApprovalTable"),

	APPROVAL_REVIEWER_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelReviewerApprovalTable"),
	
	APPROVAL_PENDING_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelPendingApprovalTable"),	
	APPROVAL_APPROVED_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelApprovedApprovalTable"),
	APPROVAL_REJECTED_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelRejectedApprovalTable"),
	APPROVAL_REOPEN_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelReopenApprovalTable"),
	APPROVAL_REVIEWED_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelReviewedApprovalTable"),
	APPROVAL_ALL_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelAllApprovalTable"),
	APPROVAL_ADD_USERS_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "labelAddUsersApprovalTable"),
	APPROVAL_GUEST: MessageUtil.getMessage(MessageBundleRQM, "labelGuestApproval"),
	
	
	APPROVAL_ADD_AR_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "msgAddARApprovalTable"),
	APPROVAL_REMOVE_AR_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "msgRemoveARApprovalTable"),
	
	APPROVAL_NO_SUMMARY_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "msgNoSummaryApproval"),
	APPROVAL_MORE_SUMMARY_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "msgMoreSummaryApproval"),
	APPROVAL_REVIEW_SUMMARY_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "msgReviewSummaryApproval"),
	APPROVAL_NO_SUMMARY_Yet_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "msgNoSummaryYetApproval"),
	
	APPROVAL_NO_HISTORY_Yet_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "msgNoHistoryYetApproval"),
	
	APPROVAL_ADD_APPROVER_IN_DRAFT_WARNING_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "msgAddApproverInDraftWarningApproval"),
	
	APPROVAL_NONE_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "labelNoneApproval"),
	APPROVAL_OF_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "labelOfApproval"),
	
	APPROVAL_REVIEW_HISTORY_APPROVAL: MessageUtil.getMessage(MessageBundleRQM, "labelReviewHistoryApproval"),
	APPROVAL_REMOVE_MORE_WARNING_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "msgRemoveMoreWarningApprovalTable"),
	APPROVAL_ADDING_DUPLICATED_WARNING_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "msgAddingDuplicatedWarningApprovalTable"),
	APPROVAL_REJECT_REASON_DUPLICATED_WARNING_APPROVAL_TABLE: MessageUtil.getMessage(MessageBundleRQM, "msgRejectionReasonWarningApprovalTable"),
	
	PROCESS_DESCRIPTION_QUALITYGOAL: MessageUtil.getMessage(MessageBundleRQM, "labelDescriptionQualityGoal"),
	PROCESS_CURRENT_STATUS_QUALITYGOAL: MessageUtil.getMessage(MessageBundleRQM, "labelCurrentStatusQualityGoal"),
	PROCESS_MET_STATUS_QUALITYGOAL: MessageUtil.getMessage(MessageBundleRQM, "labelMetStatusQualityGoal"),
	PROCESS_COMMENT_QUALITYGOAL: MessageUtil.getMessage(MessageBundleRQM, "labelCommentQualityGoal"),
	
	PROCESS_SUMMARY_INFO_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelSummaryInfoTimeBox"),
	PROCESS_PROMOTE_MSG_SIZING_POPUP: MessageUtil.getMessage(MessageBundleRQM, "labelPromoteMsgSizing"),
	PROCESS_INVALID_MSG_SIZING_POPUP: MessageUtil.getMessage(MessageBundleRQM, "labelInvalidMsgSizing"),
	
	PROCESS_GROUP_NAME_TEST_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelGroupNameTestGroup"),
	PROCESS_PLANNING_EFFORT_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelPlanningEffortTestGroup"),
	PROCESS_EXECUTE_EFFORT_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelExecuteEffortTestGroup"),
	PROCESS_NOT_SET_YET_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelNotSetYetTestGroup"),
	PROCESS_APPROXIMATELY_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelApproximatelyTestGroup"),
	PROCESS_APPROXIMATELY_ZERO_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelApproximatelyZeroTestGroup"),
	PROCESS_YEAR_TEST_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelYearTestGroup"),
	PROCESS_MOUTH_TEST_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelMouthTestGroup"),
	PROCESS_DAY_TEST_GROUP: MessageUtil.getMessage(MessageBundleRQM, "labelDayTestGroup"),
	
	PROCESS_DURATION_MSG_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "msgDurationMsgTimeBox"),
	PROCESS_NAME_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelNameTimeBox"),
	PROCESS_DESCRIPTION_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelDescriptionTimeBox"),
	PROCESS_START_DATE_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelStartDateTimeBox"),
	PROCESS_END_DATE_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelEndDateTimeBox"),
	PROCESS_DURATION_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelDurationTimeBox"),
	PROCESS_ACT_START_DATE_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelActStartDateTimeBox"),
	PROCESS_ACT_END_DATE_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelActEndDateTimeBox"),
	PROCESS_ACT_DURATION_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelActDurationTimeBox"),
	PROCESS_POINTS_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelPointsTimeBox"),
	PROCESS_DEFECTS: MessageUtil.getMessage(MessageBundleRQM, "labelExpectedDefects"),
	PROCESS_VALID_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelValidTimeBox"),
	PROCESS_OWNER_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelOwnerTimeBox"),

	PROCESS_NAME_KEY_DATE: MessageUtil.getMessage(MessageBundleRQM, "labelNameKeyDate"),
	PROCESS_DESCRIPTION_KEY_DATE: MessageUtil.getMessage(MessageBundleRQM, "labelDescriptionKeyDate"),
	PROCESS_DATE_KEY_DATE: MessageUtil.getMessage(MessageBundleRQM, "labelDateKeyDate"),
	
	PROCESS_ADD_TEST_ITERATIONS_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelAddTestIterationsTimeBox"),
	PROCESS_REMOVE_TEST_ITERATIONS_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelRemoveTestIterationsTimeBox"),
	
	PROCESS_ADD_KEY_DATES_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelAddKeyDatesTimeBox"),
	PROCESS_TEST_ITERATION_TABLE_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelTestIterationTableTimeBox"),
	PROCESS_KEY_DATE_TABLE_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelKeyDateTableTimeBox"),
	PROCESS_REMOVE_KEY_DATES_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "labelRemoveKeyDatesTimeBox"),
	PROCESS_REMOVE_MSG_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "msgRemoveMsgTimeBox"),
	PROCESS_VALIDATE_REQUIRE_MSG_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "msgValidateRequireMsgTimeBox"),
	PROCESS_VALIDATE_DURATION_MSG_TIME_BOX: MessageUtil.getMessage(MessageBundleRQM, "msgValidateDurationMsgTimeBox"),
	
	PROCESS_OPEN_ITEM_REVIEWLET: MessageUtil.getMessage(MessageBundleRQM, "labelOpenItemReviewlet"),
	PROCESS_ALREADY_APPROVED_REVIEWLET: MessageUtil.getMessage(MessageBundleRQM, "labelAlreadyApprovedReviewlet"),
	PROCESS_ALREADY_REJECTED_REVIEWLET: MessageUtil.getMessage(MessageBundleRQM, "labelAlreadyRejectedReviewlet"),
	PROCESS_PENDING_APPROVALS_REVIEWLET: MessageUtil.getMessage(MessageBundleRQM, "labelPendingApprovalsReviewlet"),
	
	DATAPOOL_ADDING_ATTACHMENT: MessageUtil.getMessage(MessageBundleRQM, "msgDatapoolAddAtta"),
	
	ARTIFACT_STATE_TRANSITION_CONSTRAINTS_CATEGORY: "ARTIFACT_STATE_TRANSITION_CONSTRAINTS",
	STATETRANSITION_PREFERENCE_NOEDITAPPROVED: 1,
	STATETRANSITION_PREFERENCE_ALLWIAPPROVED: 2,
	STATETRANSITION_PREFERENCE_ALLAPPROVED: 3,
	STATETRANSITION_PREFERENCE_ALLCHILDCASESAPPROVED: 4,
	STATETRANSITION_PREFERENCE_ALLCHILDSCRIPTSAPPROVED: 5,
	STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED: 6,
	STATETRANSITION_PREFERENCE_DEFAULT: [{
					"id": 1,
					"state": true,
					"description": MessageUtil.getMessage(MessageBundleRQM, "labelConstraintDescription1")
			}, {
					"id": 2,
					"state": true,
					"description": MessageUtil.getMessage(MessageBundleRQM, "labelConstraintDescription2")
			},{
					"id": 3,
					"state": true,
					"description": MessageUtil.getMessage(MessageBundleRQM, "labelConstraintDescription3")
			},{
					"id": 4,
					"state": false,
					"description": MessageUtil.getMessage(MessageBundleRQM, "labelConstraintDescription4")
			},{
					"id": 5,
					"state": false,
					"description": MessageUtil.getMessage(MessageBundleRQM, "labelConstraintDescription5")
			},{
					"id": 6,
					"state": false,
					"description": MessageUtil.getMessage(MessageBundleRQM, "labelConstraintDescription6")
			}],

	SHARED_RESOURCES_LOCATION_CATEGORY: "SHARED_RESOURCES_LOCATION_CATEGORY",
	EXECUTION_SYSTEM_CONSTRAINTS: "EXECUTION_SYSTEM_CONSTRAINTS",
	MANUALSCRIPT_CONVERTOR_DICTIONARY_CATEGORY: "MANUALSCRIPT_CONVERTOR_DICTIONARY_CATEGORY",
	GLOBAL_SOFT_CPU_LIMIT: "GLOBAL_SOFT_CPU_LIMIT",
	TESTCASE_SYSTEM_PREFERENCE: "TESTCASE_SYSTEM_PREFERENCE",
	
    EDITORSECTION_STATE_VALIDATION_FETCHING: "fetching", //flag to indicate a section needs to fetch data for validating state change on artifact
	STATETRANSITION_STATE_DRAFT: "com.ibm.rqm.planning.common.new",  //Draft
	STATETRANSITION_STATE_UNDERREVIEW: "com.ibm.rqm.planning.common.underreview",  //Under Review
	STATETRANSITION_STATE_APPROVED: "com.ibm.rqm.planning.common.approved",  //Approved
	STATETRANSITION_STATE_RETIRED: "com.ibm.rqm.planning.common.retired", //Retired
	
	STATETRANSITION_ACTION_READYFORREVIEW: "com.ibm.rqm.planning.common.readyforreview", //Ready for Review
	STATETRANSITION_ACTION_APPROVE: "com.ibm.rqm.planning.common.approve",  //Approve
	STATETRANSITION_ACTION_REOPEN: "com.ibm.rqm.planning.common.reopen",  //Reopen
	STATETRANSITION_ACTION_RETIRE: "com.ibm.rqm.planning.common.retire",  //Retire
	STATETRANSITION_ACTION_REJECT: "com.ibm.rqm.planning.common.reject",  //Reject
	
	USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY,
	USER_UI_CUSTOMISE_ACTIONBAR_EXPANSION_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_EXPANSION_CATEGORY,
	USER_UI_CUSTOMISE_ACTIONBAR_TOC_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_TOC_CATEGORY,
	USER_UI_CUSTOMISE_ACTIONBAR_RELATEDINFO_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_RELATEDINFO_CATEGORY,
	USER_UI_CUSTOMISE_ACTIONBAR_MAXTABLESIZE_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_MAXTABLESIZE_CATEGORY,
    USER_UI_CUSTOMISE_ACTIONBAR_DATEFORMAT_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_DATEFORMAT_CATEGORY,
	USER_UI_CUSTOMISE_ACTIONBAR_ADAPTERSELECTION_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_ADAPTERSELECTION_CATEGORY,
	USER_UI_CUSTOMISE_ACTIONBAR_WORDWRAPCHOICE_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_ACTIONBAR_WORDWRAPCHOICE_CATEGORY,
    USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY,
	USER_UI_CUSTOMISE_QUERYLISTS_ONLY_MY_ASSETS_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_QUERYLISTS_ONLY_MY_ASSETS_CATEGORY,
    USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY,
    USER_UI_CUSTOMISE_QUERYLISTS_DEFAULT_VIEW_MODE: CommonPreferenceClient.USER_UI_CUSTOMISE_QUERYLISTS_DEFAULT_VIEW_MODE,
	USER_UI_CUSTOMISE_EXECUTION_PREF_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_EXECUTION_PREF_CATEGORY,
	USER_UI_CUSTOMISE_EDITOR_TEXT_DIRECTION_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_EDITOR_TEXT_DIRECTION_CATEGORY,
    USER_UI_CUSTOMISE_PROGRESS_PANEL_CATEGORY: CommonPreferenceClient.USER_UI_CUSTOMISE_PROGRESS_PANEL_CATEGORY,
	
	RELATED_LINKS_PREFERENCE_KEY: "RQM_RELATED_LINKS",
	RELATED_LINKS_PREFERENCE_DEFAULTS: [
	   { 
		   id: 1, 
		   name: MessageUtil.getMessage(MessageBundleRQM,"labelIBMRational"), 
		   url: "http://www-306.ibm.com/software/rational/"
	   },
	   {
	   	   id: 2, 
		   name: MessageUtil.getMessage(MessageBundleRQM,"labelIBMRationalQualityMgmt"), 
		   url: "http://www-306.ibm.com/software/rational/offerings/testing.html"
	   }	   
	],
	
	REPORT_SERVER_PREFERENCE_KEY: "RQM_REPORT_SERVER",
	REPORT_SERVER_PREFERENCE_DEFAULTS: [
	   { 
		   address: "", 
		   port: "", 
		   user: "",
		   pass: "",
		   namespace: ""
	   }	   
	],
	
    ARTIFACT_OPTIONS_PREFERENCE_KEY_PREFIX: "com.ibm.rqm.artifact.preferences",	
	
    ARTIFACT_OPTIONS_PREFERENCE_LOCKING_KEY: "lockingEnabled",
    ARTIFACT_OPTIONS_PREFERENCE_LOCKING_DEFAULT: true,

    ARTIFACT_OPTIONS_PREFERENCE_SIGN_REVIEWS_KEY: "signReviewsEnabled",
    ARTIFACT_OPTIONS_PREFERENCE_SIGN_REVIEWSS_DEFAULT: false,
	
	ARTIFACT_OPTIONS_PREFERENCE_SEARCH_LIMIT_KEY: "searchResultLimit",
    ARTIFACT_OPTIONS_PREFERENCE_SEARCH_LIMIT_DEFAULT: 1000,
	
	ARTIFACT_SEARCH_STATUS_OK: 0,
    ARTIFACT_SEARCH_STATUS_OK_EXPIRED: 1,
	ARTIFACT_SEARCH_STATUS_MAX_EXCEEDED: 400,
	ARTIFACT_SEARCH_STATUS_ERROR: 500,
	
	ARTIFACT_SEARCH_POLICY_ENFORCE: "enforce",  //$NON-NLS$
	ARTIFACT_SEARCH_POLICY_TRUNCATE: "truncate",  //$NON-NLS$
	ARTIFACT_SEARCH_POLICY_IGNORE: "ignore",  //$NON-NLS$
	
	LIST_CELL_ADD : "add",
	LIST_CELL_REMOVE : "remove",
	LIST_CELL_CLOSE :"close",

	ATTRIBUTE_HEADER_NAME: MessageUtil.getMessage(MessageBundleRQM,"labelAttributeName"),
	ATTRIBUTE_HEADER_TYPE: MessageUtil.getMessage(MessageBundleRQM,"labelDataType"),
	ATTRIBTE_VALUE : MessageUtil.getMessage(MessageBundleRQM,"labelValue"),
	
	ATTRIBUTE_VIEWER_STRING_TYPE: "StringType",
	ATTRIBUTE_VIEWER_NUMERIC_TYPE : "NumericType",
	ATTRIBUTE_VIEWER_PART_TYPE : "ConfigurationPartType",
	ATTRIBUTE_VIEWER_DATE_TYPE : "TimeStampType",
	
	ATTRIBUTE_VIEWER_UI_STRING_TYPE : MessageUtil.getMessage(MessageBundleRQM,"labelString"),
	ATTRIBUTE_VIEWER_UI_NUMERIC_TYPE : MessageUtil.getMessage(MessageBundleRQM,"labelNumber"),
	ATTRIBUTE_VIEWER_UI_PART_TYPE : MessageUtil.getMessage(MessageBundleRQM,"labelConfigurationPart"),
	ATTRIBUTE_VIEWER_UI_PART_TYPE_ARRAY : MessageUtil.getMessage(MessageBundleRQM,"labelMultiplConfigurationParts"),
	ATTRIBUTE_VIEWER_UI_DATE_TYPE : MessageUtil.getMessage(MessageBundleRQM,"labelDate"),
		
    /**
     * Validate the message bundle in case anything goes wrong during load time,
     * register the bundle here explicitly.
     */
    validateMessageBundle: function() {
        if (!MessageUtil.getBundle(MessageBundleRQM)) {
            dojo.requireLocalization("com.ibm.rqm.planning.web.ui.internal", "messages");
            MessageUtil.registerBundle(MessageBundleRQM, "com.ibm.rqm.planning.web.ui.internal", "messages");
            console.debug("Explicitly registered QM bundle: \"" + MessageUtil.getMessage(MessageBundleRQM, "bundle_description") + "\"");
        }
    },
    
    /**
     * Return the message from the message bundle with the specified keyword.
     * Optional token arguments are for replacing place holders in the message
     * definition.  The place holders have the syntax "%number" with the number
     * starting from 1.  For example, if the message "myStr" is defined as
     * "This is %1 of %2 message".  getMessage("myStr", "one", "my many") will return
     * "This is one of my many message".
     */
    getMessage: function(keyword, tokens) {
    	var length=arguments.length;
    	if (length==1){
    		return MessageUtil.getMessage(MessageBundleRQM,keyword);
    	}
        var args = [MessageBundleRQM];
        for( var i = 0; i < arguments.length; i++){ 
            args.push(arguments[i]);
        }
        return MessageUtil.getMessage.apply(MessageUtil, args);
    },
    
    /**
     * Returns the message stored in the common message bundle.
     * @param {Object} keyword
     * @param {Object} tokens
     */
    getCommonMessage: function(keyword, tokens) {
    	var length=arguments.length;
    	if (length==1){
    		return MessageUtil.getMessage(MessageBundle.COMMON,keyword);
    	}
        var args = [MessageBundle.COMMON];
        for( var i = 0; i < length; i++){ 
            args.push(arguments[i]);
        }
        return MessageUtil.getMessage.apply(MessageUtil, args);
    },
    
    /**
     * Returns the message stored in the LM message bundle.
     * @param {Object} keyword
     * @param {Object} tokens
     */
    getLmMessage: function(keyword, tokens) {
    	var length=arguments.length;
    	if (length==1){
    		return MessageUtil.getMessage(MessageBundleRTLM,keyword);
    	}
        var args = [MessageBundleRTLM];
        for( var i = 0; i < length; i++){ 
            args.push(arguments[i]);
        }
        return MessageUtil.getMessage.apply(MessageUtil, args);
    },

    /**
     * Returns the message stored in the Base LM message bundle.
     * 
     * Note that currently the only messages that come from here are some Test Cell messages
     * It is too late for translation changes right now but in a subsequent release we should
     * move the Test Cell messages to the common message bundle and remove this method.
     * 
     * @param {Object} keyword
     * @param {Object} tokens
     */
    getBaseLmMessage: function(keyword, tokens) {
    	var length=arguments.length;
    	if (length==1){
    		return MessageUtil.getMessage(MessageBundleRTLMBase,keyword);
    	}
        var args = [MessageBundleRTLMBase];
        for( var i = 0; i < length; i++){ 
            args.push(arguments[i]);
        }
        return MessageUtil.getMessage.apply(MessageUtil, args);
    },
    
    getExtensionDisplayMessage: function(name) {
        if (name && dojo.isString(name)) {
            return (name.search("RQM-KEY-") == 0) ? this.getMessage(name) : name;
        } else {
            return name;
        }
    }
};
})();