/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.client.internal.ContributorClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

var CONTRIBUTOR_SERVICE_URI = "com.ibm.rqm.common.service.rest.IContributorRestService"; //$NON-NLS-1$ 

com.ibm.asq.common.web.client.internal.ContributorClient = {
    
	_invokeService: function(responseHandler, method, args) {
		if (args && !args.processAreaUUID) {
			args.processAreaUUID = getCurrentPA().itemId;
		}
		var serviceRequest = new ServiceRequest(CONTRIBUTOR_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
    getContributors: function(responseHandler, args)
    {
		args = args || {};
		return this._invokeService(responseHandler, "getContributors", args);
	},
	
	getMembers: function(responseHandler, maxResults)
    {
		var args = {
			maxResults: (maxResults || -1)	
		};
		return this._invokeService(responseHandler, "getMembers", args);
	}, 
	
	searchContributors: function(responseHandler, args) {
		return this._invokeService(responseHandler, "getSearchContributors", args);	
	}
};

})();
