/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.ObjectiveClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.planning.web.client.internal.ObjectiveClient = {

	OBJECTIVE_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IObjectiveRestService",

	_invokeObjectiveService: function(responseHandler, method, args) {
		if (args && !args.processAreaUUID) {
			args.processAreaUUID = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.OBJECTIVE_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
    getObjectives: function(serviceResponseHandler, showArchived) {
		var args = {
			includeArchived: showArchived === true ? true : false
		}
        this._invokeObjectiveService(serviceResponseHandler, "getObjectives", args);
    },
	
    getObjectiveStatuses: function(serviceResponseHandler, args) {
        this._invokeObjectiveService(serviceResponseHandler, "getObjectiveStatusDTO", args);
    },	
	   
    postObjective: function(serviceResponseHandler, objectiveObj) {
		//objectiveObj:  
        /*public boolean isNewItem;
        public String processAreaUUID;
        public String itemId;
        public String stateId;
        public String id;
        public String name;
        public String description;
        public String operator;
        public Integer targetValue;
        public boolean archive;*/		
        this._invokeObjectiveService(serviceResponseHandler, "postObjective", objectiveObj);
    },
	
	evaluateObjectives: function(serviceResponseHandler, versionableItemId, statuses){
		var args = {
			testPlanUUID: versionableItemId
		}
		if (statuses && statuses.length > 0) {
			args.statusJSON = dojo.toJson(statuses);
		}
		this._invokeObjectiveService(serviceResponseHandler, "postEvaluateObjectives", args);
	}
};

})();
