 /*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.buildintegration.web.client.internal.RemoteTeamConcertClient");

dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.repository.web.transport.RestRequest");
dojo.require("com.ibm.team.repository.web.transport.ExternalTeamServerClient");

(function() {

var Status						= com.ibm.team.repository.web.foundation.Status;
var RestRequest					= com.ibm.team.repository.web.transport.RestRequest;
var ExternalTeamServerClient	= com.ibm.team.repository.web.transport.ExternalTeamServerClient;
var ROA_SERVICE_URI				= "com.ibm.team.workitem.service.internal.roa.IRestService";
var METHOD_GET					= "GET";
var RESOURCE_PROJECTAREAS		= "projectareas";

com.ibm.rqm.buildintegration.web.client.internal.RemoteTeamConcertClient= {
	
	getProjectAreas: function(serverDescription, responseCallback, options) {
		var label = options.requestLabel?options.requestLabel:"Get Project Areas";
		var request= RestRequest.create(ROA_SERVICE_URI, RESOURCE_PROJECTAREAS, METHOD_GET);
		ExternalTeamServerClient.invokeService(request, serverDescription, responseCallback, label, false);
	},

	getProjectArea: function(projectAreaId, serverDescription, responseCallback, options) {
		var label = options.requestLabel?options.requestLabel:"Get Project Area";
		var request= RestRequest.create(ROA_SERVICE_URI, RESOURCE_PROJECTAREAS + "/" + projectAreaId, METHOD_GET);
		ExternalTeamServerClient.invokeService(request, serverDescription, responseCallback,  label, false);
	},
	
	__sentinel: null // terminates this class definition
};

})();