/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function(){
dojo.provide("com.ibm.asq.common.web.client.internal._catalog._DocumentBase");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Part");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Attribute");
dojo.require("com.ibm.asq.common.web.client.internal._catalog._Util");
dojo.declare("com.ibm.asq.common.web.client.internal._catalog._DocumentBase", null, 
{
    // can construct the configuration from either a string or the javascript
    // configuration object supported by the catalog
    constructor: function(obj, typeName){
        this.typeName = typeName;
        this._util = new com.ibm.asq.common.web.client.internal._catalog._Util();
        if(this instanceof com.ibm.asq.common.web.client.internal._catalog.Asset) {
            this.isAsset = true;
        } else {
            this.isAsset = false;
        }
    },
    initBase: function(obj){
        this.obj = obj; // obj is the javascript object (JSON) used by the catalog system
        this.isResolved = false;
        if (obj){
            var inner = obj.AssetTemplate;
            if (!inner){
                inner = obj.Assets;
	            if (!inner) {
                    // Check if this is a nested template
                    inner = obj.value;
                    if (!inner) {
                        throw new Error("cannot find root config part!");
                    }
				}
            }
            this.rootObj = inner["AssetType"];
            if (!this.rootObj["Attributes"]){
                this.rootObj["Attributes"] = {"Attribute": []};
            }
        } 
    }

}
)})();
