/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function(){
dojo.provide("com.ibm.asq.common.web.client.internal._catalog._Util");
dojo.declare("com.ibm.asq.common.web.client.internal._catalog._Util", null, 
{
    constructor: function(){
    },
    // This helper function corrects for the array problem
    // caused by Jettison.  It take the three ways an 
    // array gets represented in the obj and normalizes it
    // into a standard array.
    _getArrayObject: function(objContainer, objname, arrayName) {
		var objC = objContainer[objname];
        if (objC == "") {
        	objC={};
            objContainer[objname] = objC;
            objC[arrayName] = [];
        } else if (!(objC[arrayName] instanceof Array)) {
            var temp = objC[arrayName];
            if (temp == null) {
                objC[arrayName] = [];
            }
            else {
                objC[arrayName] = [temp];
            }
        }
        return objC[arrayName];
     },
        
    _removeFromArray: function(arr, index) {
        var newArr = new Array();
        var length=arr.length;
        for(var i=0;i<length;i++) {
            if(i != index){
                newArr.push(arr[i]);
            }
        }
        return newArr;
	},
	
	_insertToArray: function(aiArr, index, newItem) {
		var copyAi = new Array();
		var modifyLast = true;  
		for(var i=0; i<aiArr.length; i++){
			if(i==index){
				copyAi.push(newItem);
				modifyLast = false;
			}
			copyAi.push(aiArr[i]);
		}
		if(modifyLast){
			copyAi.push(newItem);
		}
		return copyAi;
	},
	
   	_splitTag: function(path){
		var splitArray = path.split(".");
		var tagArray = [];
		var segment = splitArray[0];
		var length=splitArray.length;
		for(var i=1; i<length; i++){
			if(segment.substring(segment.length - 1) == "/"){
				segment = segment.substring(0, segment.length - 1) + "." + splitArray[i];
			} else {
				tagArray.push(segment);
				segment = splitArray[i];
			}
		}
		tagArray.push(segment);
		return tagArray;
	}
   
}
)})();
