/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.process.web.client.internal.approval.ProcessClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() { //module container

var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNotEmpty 		= net.jazz.ajax.toolbox.lang.checkNotEmpty;
var findIf					= net.jazz.ajax.toolbox.lang.findIf;
var removeIf				= net.jazz.ajax.toolbox.lang.removeIf;

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
//var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.process.web.client.internal.approval.ProcessClient = {

	PROCESS_SERVICE_URI: "com.ibm.rqm.process.common.service.rest.IApprovalRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.artifactItemTypeName) {
				actualArgs.artifactItemTypeName= appArgs.artifactItemTypeName;
			}
			if(appArgs.artifactPackageUri) {
				actualArgs.artifactPackageUri= appArgs.artifactPackageUri;
			}
			if(appArgs.artifactItemId) {
				actualArgs.artifactItemId= appArgs.artifactItemId;
			}
		}
		actualArgs.processArea = getCurrentProjectArea().itemId;
		var serviceRequest= new ServiceRequest(this.PROCESS_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	_invokePostService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.originator) {
				actualArgs.originator= appArgs.originator;
			}
			if(appArgs.owner) {
				actualArgs.owner= appArgs.owner;
			}
			if(appArgs.approvalType) {
				actualArgs.approvalType= appArgs.approvalType;
			}
			if(appArgs.artifactItemTypeName) {
				actualArgs.artifactItemTypeName= appArgs.artifactItemTypeName;
			}
			if(appArgs.artifactPackageUri) {
				actualArgs.artifactPackageUri= appArgs.artifactPackageUri;
			}
			if(appArgs.artifactItemId) {
				actualArgs.artifactItemId= appArgs.artifactItemId;
			}
		}
		actualArgs.processArea = getCurrentProjectArea().itemId;
		var serviceRequest= new ServiceRequest(this.PROCESS_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeUpdateService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.comment) {
				actualArgs.comment= appArgs.comment;
			}
			if(appArgs.owner) {
				actualArgs.owner= appArgs.owner;
			}
			if(appArgs.status) {
				actualArgs.status= appArgs.status;
			}
			if(appArgs.artifactItemTypeName) {
				actualArgs.artifactItemTypeName= appArgs.artifactItemTypeName;
			}
			if(appArgs.artifactPackageUri) {
				actualArgs.artifactPackageUri= appArgs.artifactPackageUri;
			}
			if(appArgs.artifactItemId) {
				actualArgs.artifactItemId= appArgs.artifactItemId;
			}
		}
		actualArgs.processArea = getCurrentProjectArea().itemId;
		var serviceRequest= new ServiceRequest(this.PROCESS_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeDeleteService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.owner) {
				actualArgs.owner= appArgs.owner;
			}
			if(appArgs.artifactItemTypeName) {
				actualArgs.artifactItemTypeName= appArgs.artifactItemTypeName;
			}
			if(appArgs.artifactPackageUri) {
				actualArgs.artifactPackageUri= appArgs.artifactPackageUri;
			}
			if(appArgs.artifactItemId) {
				actualArgs.artifactItemId= appArgs.artifactItemId;
			}
		}
		actualArgs.processArea = getCurrentProjectArea().itemId;
		var serviceRequest= new ServiceRequest(this.PROCESS_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeViewletService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.itemId) {
				actualArgs.owner= appArgs.itemId;
			}
		}
		actualArgs.processArea = getCurrentProjectArea().itemId;
		var serviceRequest= new ServiceRequest(this.PROCESS_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeBatchService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.operationJson) {
				actualArgs.operationJson= appArgs.operationJson;
			}
			if(appArgs.projectAreaItemId)
				actualArgs.processArea = appArgs.projectAreaItemId;			
		}
		if(!actualArgs.processArea)
			actualArgs.processArea = getCurrentProjectArea().itemId;
		var serviceRequest= new ServiceRequest(this.PROCESS_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	getApprovalDTO: function(serviceResponseHandler, para) {
	  	this._invokeService(serviceResponseHandler, "getApprovalDTO",para);
	},
	
	getApprovalRecord: function(serviceResponseHandler, para) {
		this._invokePostService(serviceResponseHandler, "postApprovalRecord", para);
	},
	
	getUpdateApprovalRecord: function(serviceResponseHandler, para) {
		this._invokeUpdateService(serviceResponseHandler, "postUpdateApprovalRecord", para);
	},
	
	getDeleteApprovalRecord: function(serviceResponseHandler, para) {
		this._invokeDeleteService(serviceResponseHandler, "postDeleteApprovalRecord", para);
	},
	
	getApprovalHistoryDTO: function(serviceResponseHandler, para) {
		this._invokeService(serviceResponseHandler, "getApprovalHistoryDTO", para);
	},
	
	getApprovalDashboardDTO: function(serviceResponseHandler, para) {
		this._invokeViewletService(serviceResponseHandler, "getApprovalDashboardDTO", para);
	},
	postBatchUpdate: function(serviceResponseHandler, para) {
		this._invokeBatchService(serviceResponseHandler, "postBatchUpdate", para);
	},
	postExecuteQuery: function(serviceResponseHandler, para) {
		this._invokeBatchService(serviceResponseHandler, "postExecuteQuery", para);
	}
};

})();
