/**************************************BuildClient**************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.foundation.Status");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Status					= com.ibm.team.repository.web.foundation.Status;

com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient= {

	BUILD_SERVICE_URI: "com.ibm.rqm.buildintegration.common.service.rest.IBuildIntegrationRestService",
	BUILD_PROVIDER_SERVICE_URI:"com.ibm.rqm.buildintegration.common.service.rest.IBuildProviderTypeRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.newBuildRecord)
				actualArgs.newBuildRecord = appArgs.newBuildRecord;
			if(appArgs.id)	
				actualArgs.id = appArgs.id;
			if(appArgs.itemId)	
				actualArgs.itemId = appArgs.itemId;
			if(appArgs.itemIds)	
				actualArgs.itemIds = appArgs.itemIds;
			if(appArgs.externalId)	
				actualArgs.externalId = appArgs.externalId;
			if(appArgs.name)	
				actualArgs.name = appArgs.name;
			if(appArgs.status)
				actualArgs.status = appArgs.status;
			if(appArgs.state)
				actualArgs.state = appArgs.state;
			if(appArgs.parentBuildDefinitionId)
				actualArgs.parentBuildDefinitionId = appArgs.parentBuildDefinitionId;
			if(appArgs.lastUpdatedTime)
				actualArgs.lastUpdatedTime = appArgs.lastUpdatedTime;
			if(appArgs.buildRecords)
				actualArgs.buildRecords = appArgs.buildRecords;
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;
			if(appArgs.stateId)
				actualArgs.stateId =  appArgs.stateId;
			if(appArgs.description)	
				actualArgs.description = appArgs.description;
			if(appArgs.endTime)
				actualArgs.endTime = appArgs.endTime;
			if(appArgs.providerTypeId)
				actualArgs.providerTypeId = appArgs.providerTypeId;
			if(appArgs.buildDefinitionId)
				actualArgs.buildDefinitionId = appArgs.buildDefinitionId;
			if(appArgs.removeBuildRecords)
				actualArgs.removeBuildRecords = appArgs.removeBuildRecords;
            if(appArgs.statusIds)
                actualArgs.statusIds = appArgs.statusIds;
            if(appArgs.includeArchived)
                actualArgs.includeArchived = appArgs.includeArchived;
            if(appArgs.policy)
                actualArgs.policy = appArgs.policy;
            if(appArgs.description)
                actualArgs.description = appArgs.description;
            // paging parameters
            if(appArgs.queryToken) {
                actualArgs.queryToken = appArgs.queryToken; 
            }       
            if(appArgs.page) {
                actualArgs.page = appArgs.page; 
            }       
            if(appArgs.pageSize) {
                actualArgs.pageSize = appArgs.pageSize; 
            }       
            if(appArgs.sortColumns) {
                actualArgs.sortColumns = appArgs.sortColumns; 
            }           
            if(appArgs.textSearch) {
                actualArgs.textSearch = appArgs.textSearch; 
            }           
		}else{
			appArgs = {};
		}
		if(!appArgs.projectArea){
			actualArgs.projectArea = getCurrentPA().itemId;	
		}
		var serviceRequest= new ServiceRequest(this.BUILD_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	getBuildRecordsDTO:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getBuildRecordsDTO", params);
	},
	getBuildDefinitionsDTO:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getBuildDefinitionsDTO", params);
	},
	postBuildRecordDTO:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postBuildRecordDTO", params);
	},
	postArchiveBuildRecord:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postArchiveBuildRecord", params);
	},
	postBuildDefinitionDTO:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postBuildDefinitionDTO", params);
	},
	getProviderTypes:function(serviceCallback, params){
		var serviceRequest= new ServiceRequest(this.BUILD_PROVIDER_SERVICE_URI, "getProviderTypes", params);
		var serviceResponseHandler= new ServiceResponseHandler({
			success: function(result) {
				serviceCallback(Status.OK_STATUS, result);
			},
			failure: function(error) {
				serviceCallback(new Status(Status.ERROR, error.message, error), null);
			}
		}, "success", "failure");
		TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
	getBuildProviderTypeDTO:function(serviceCallback, params){
		var serviceRequest= new ServiceRequest(this.BUILD_PROVIDER_SERVICE_URI, "getBuildProviderTypeDTO", params);
		var serviceResponseHandler= new ServiceResponseHandler({
			success: function(result) {
				serviceCallback(Status.OK_STATUS, result);
			},
			failure: function(error) {
				serviceCallback(new Status(Status.ERROR, error.message, error), null);
			}
		}, "success", "failure");
		TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},
    getSearchBuildDefinitions:function(serviceResponseHandler, params){
        /*
         valid parameters:
            public String projectArea;
            public String name;
            public String description;
            public String[] statusIds;
            public boolean includeArchived = false;
            public String policy;
            String queryToken;
            int page;
            int pageSize;
            String[] sortColumns;
            String textSearch;
        */
        this._invokeService(serviceResponseHandler, "getPagedSearchResult", params);
    }
};

})();
