/****BuildSateClient************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.buildintegration.web.client.internal.build.BuildStatesClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.buildintegration.web.client.internal.build.BuildStatesClient= {

	BUILD_STATES_SERVICE_URI: "com.ibm.rqm.buildintegration.common.service.rest.IBuildProviderTypeRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			if(appArgs.id)	
				actualArgs.id = appArgs.id;
			if(appArgs.providerTypeId)	
				actualArgs.providerTypeId = appArgs.providerTypeId;
		}else{
			appArgs = {};
		}
		if(!appArgs.projectArea){
			actualArgs.projectArea = getCurrentPA().itemId;	
		}
		var serviceRequest= new ServiceRequest(this.BUILD_STATES_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
//	getBuildRecordsDTO:function(serviceResponseHandler, params){
//		this._invokeService(serviceResponseHandler, "getBuildRecordsDTO", params);
//	},
//	getBuildDefinitionsDTO:function(serviceResponseHandler, params){
//		this._invokeService(serviceResponseHandler, "getBuildDefinitionsDTO", params);
//	},
//	postBuildRecordDTO:function(serviceResponseHandler, params){
//		this._invokeService(serviceResponseHandler, "postBuildRecordDTO", params);
//	},
	getBuildStates:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getBuildProviderTypeDTO", params);
	}
};

})();
