/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { //module container
var ImageCache = com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates = {

    PASSED: "com.ibm.rqm.execution.common.state.passed", 
    FAILED: "com.ibm.rqm.execution.common.state.failed",
    BLOCKED: "com.ibm.rqm.execution.common.state.blocked", 
	COMPLETE: "com.ibm.rqm.execution.common.state.complete",
	INCONCLUSIVE: "com.ibm.rqm.execution.common.state.inconclusive",
	ERROR: "com.ibm.rqm.execution.common.state.error",
	
    ICONS: {
        "com.ibm.rqm.execution.common.state.passed": ImageCache.PASS_ICON,
        "com.ibm.rqm.execution.common.state.failed": ImageCache.FAIL_ICON,
        "com.ibm.rqm.execution.common.state.blocked": ImageCache.STEP_VERDICT_ICONS.ENABLED["com.ibm.rqm.execution.common.state.blocked"],
        "com.ibm.rqm.execution.common.state.complete": ImageCache.STEP_COMPLETED,
		"com.ibm.rqm.execution.common.state.inconclusive": ImageCache.STEP_VERDICT_ICONS.ENABLED["com.ibm.rqm.execution.common.state.inconclusive"],
		"com.ibm.rqm.execution.common.state.error": ImageCache.STEP_VERDICT_ICONS.ENABLED["com.ibm.rqm.execution.common.state.error"]
    },
	
	LABELS: {
        "com.ibm.rqm.execution.common.state.passed": Constants.getMessage("labelPassed"),
        "com.ibm.rqm.execution.common.state.failed": Constants.getMessage("labelFailed"),
        "com.ibm.rqm.execution.common.state.blocked": Constants.getMessage("labelBlocked"),
        "com.ibm.rqm.execution.common.state.complete": Constants.getMessage("labelComplete"),
		"com.ibm.rqm.execution.common.state.inconclusive": Constants.getMessage("labelInconclusive"),
		"com.ibm.rqm.execution.common.state.error": Constants.getMessage("labelError")
    }	
	
};

})();
