/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.risk.web.client.internal.mapper.RiskProfileMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");
dojo.require("com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil");

dojo.declare("com.ibm.rqm.risk.web.client.internal.mapper.RiskProfileMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	// maps a DTO without name to a full DTO
	// optimus prime time.  transform a DTO without name to look like a real DTO. 
	map: function(profile) {
		profile.description = com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil.getMessage(profile.description);
		profile.profileName = com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil.getMessage(profile.profileName);
		for(var i = 0; i < (profile.riskMeasurements ? profile.riskMeasurements.length:0); i++) {
			var key = profile.riskMeasurements[i].assessFactor.key;
			if(key) {
				var transName = com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil.getFactorByKey(key);
				if (transName != profile.riskMeasurements[i].assessFactor.name) {
					profile.riskMeasurements[i].assessFactor.name = transName;
					profile.riskMeasurements[i].assessFactor.description = transName;
				}
			}
		}
		
		return profile;
	}
	
});