/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.risk.web.client.internal.mapper.RiskTypeMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");
dojo.require("com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil");

dojo.declare("com.ibm.rqm.risk.web.client.internal.mapper.RiskTypeMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	// maps a DTO without name to a full DTO
	// optimus prime time.  transform a DTO without name to look like a real DTO. 
	map: function(riskType) {
		
		// snapshot info
		if (riskType.name != null ) {
			var transName = com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil.getRiskTypeByKey(riskType.name);
			if(transName != riskType.name)
				riskType.name = transName;
		}
		
		for(var i = 0; i < (riskType.riskFactors ? riskType.riskFactors.length:0); i++) {
			if(riskType.riskFactors[i].key) {
				var transName = com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil.getFactorByKey(riskType.riskFactors[i].key);
				if (transName != riskType.riskFactors[i].name) {
					riskType.riskFactors[i].name = transName;
					riskType.riskFactors[i].description = transName;
					riskType.riskFactors[i].riskType = riskType.name;
				}
			}
		}
		
		return riskType;
	}
	
});