/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");

dojo.declare("com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
    SEARCH_RESULT_DTO_CLASSNAME: "com.ibm.rqm.planning.rest.dto:SearchResultDTO",
	PAGED_SEARCH_RESULT_DTO_CLASSNAME:"common_dto.rest:PagedSearchResultDTO",				
    /*
     * Handle mapping results contained within a SearchResultDTO object 
     * in addition to handling the normal modelled object and arrays
     */
    doCallback: function(result) {
        
        //handle normal array result
        if (result && dojo.isArray(result)) {
            result = this.mapArray(result);

        } else if (result && dojo.isObject(result) && 
			(result._eQualifiedClassName == this.SEARCH_RESULT_DTO_CLASSNAME || 
			 result._eQualifiedClassName == this.PAGED_SEARCH_RESULT_DTO_CLASSNAME)) {
            //handle case of search result object
			result.results = result.results || [];
            if (dojo.isArray(result.results)) {
                result.results = this.mapArray(result.results);
            }        
        }
        //do callback
        var obj= this._contextObject;
        obj[this._callbackName].call(obj, result);          
    }, 

	map: function(summaryDTO) {
		return summaryDTO;
	}
	
});