/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.risk.web.client.internal.mapper.SystemRiskMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");
dojo.require("com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil");

dojo.declare("com.ibm.rqm.risk.web.client.internal.mapper.SystemRiskMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	doCallback: function(result) {
		var mappedObjects = null;
		if (!dojo.isArray(result)) {
			//map object
			mappedObjects = this.map(result);
		}
		else {
			//map objects
			mappedObjects = this.mapArray(result);
		}
		//this.inherited(mappedObjects);   doesn't work?!
		var obj = this._contextObject;
		obj[this._callbackName].call(obj, mappedObjects);
	},		 	
			 	
	// maps a DTO without name to a full DTO
	// optimus prime time.  transform a DTO without name to look like a real DTO. 
	map: function(systemRisk) {
		
		for(var i = 0; i < (systemRisk.assessElements ? systemRisk.assessElements.length:0); i++) {
			var key = systemRisk.assessElements[i].assessFactor.key;
			if(key) {
				var transName = com.ibm.rqm.risk.web.ui.internal.util.RiskMessageUtil.getFactorByKey(key);
				if (transName != systemRisk.assessElements[i].assessFactor.name) {
					systemRisk.assessElements[i].assessFactor.name = transName;
					systemRisk.assessElements[i].assessFactor.description = transName;
				}
			}
		}
		
		return systemRisk;
	}
	
});