/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper");

dojo.declare("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper",	
              com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper, {
			 	
	// transforms a summary DTO to a full DTO
	map: function(summaryDTO) {
		// current result group
		if (summaryDTO.currentResultGroupId!=null) {
			summaryDTO.currentResultGroup = {};
			summaryDTO.currentResultGroup.id = summaryDTO.currentResultGroupId;
			summaryDTO.currentResultGroup.state = {};
			summaryDTO.currentResultGroup.state.name = summaryDTO.currentResultGroupStateName;
			delete summaryDTO.currentResultGroupId;
			delete summaryDTO.currentResultGroupStateName;
		}
		
		// owner
		if(summaryDTO.ownerName){
			summaryDTO.owner = {};
			summaryDTO.owner.name = summaryDTO.ownerName;
			delete summaryDTO.ownerName;
		}
		
		//elements as workitem
		var elements=summaryDTO.elements;
		if (elements!=null) {
			var length=elements.length;
			for(var i=0;i<length;i++){
				var element=elements[i];
				var workitem = {
					id: element.ewiId,
					name: element.ewiName,
					itemId: element.ewiitemId,
					archived: element.ewiIsArchived };
				element.workitem=workitem;
				var tc = element.testCase;
				if (!tc){
					tc={ id: element.ewiTestCaseId,
						 name: element.ewiTestCaseName,
						 modified: element.ewiTestCaseModified,
						 state: element.ewiTestCaseState,
						 versionableItemId: element.ewiTestCaseVersionableItemId,
						 scripts: [{ id: element.ewiTestCaseScriptId,
						 			name: element.ewiTestCaseScriptName,
									versionableItemId: element.ewiTestCaseScriptVersionableItemId,
									archived: element.ewiTestCaseScriptArchived,
						 			scriptType: {
						 				id: element.ewiTestCaseScriptTypeId
						 			 }}]};
				}
				workitem.testCase=tc;
				
				workitem.weight = element.ewiWeight;
				if(element.ewiPlanId){
					workitem.testPlan = {
						id: element.ewiPlanId,
						name: element.ewiPlanName,
						versionableItemId: element.ewiPlanVersionableItemId };
				}	
				if(element.ewiPhaseItemId){
					workitem.testPhase = {
						name: element.ewiPhaseName,
						itemId: element.ewiPhaseItemId };
				}
				if(element.scriptId){
					element.script = {
						id: element.scriptId,
						name: element.scriptName,
						versionableItemId: element.scriptItemId, //Backend is sending versionableItemId
						stateId: element.scriptStateId,
						scriptType:  {id: element.scriptTypeId }};
				}
				if(element.ewiDefaultScriptId){
					workitem.defaultScript = {
						id: element.ewiDefaultScriptId,
						name: element.ewiDefaultScriptName,
						versionableItemId: element.ewiDefaultScriptItemId,
						stateId: element.ewiDefaultScriptStateId,
						scriptType: { id: element.ewiDefaultScriptTypeId }};
				}else{
					workitem.defaultScript = null;
				}
				workitem.stateId = element.ewiStateId;
				workitem.configuration = element.ewiConfigurationItemId;
				
				delete element.ewiId;
				delete element.ewiName;
				delete element.ewiitemId;
				delete element.ewiIsArchived;
				delete element.testCase;
				delete element.ewiDefaultScriptId;
				delete element.ewiDefaultScriptName;
				delete element.ewiDefaultScriptItemId;
				delete element.ewiDefaultScriptStateId;
				delete element.ewiDefaultScriptTypeId;
				delete element.ewiConfigurationItemId;
				delete element.ewiStateId;
				delete element.ewiPlanId;
				delete element.ewiPlanName;
				delete element.ewiPlanVersionableItemId;
				delete element.ewiPhaseItemId;
				delete element.ewiPhaseName;
				delete element.ewiWeight;
				
				delete element.scriptId;
				delete element.scriptName;
				delete element.scriptItemId;
				delete element.scriptStateId;
				delete element.scriptTypeId;
				delete element.ewiTestCaseId;
				delete element.ewiTestCaseName;
				delete element.ewiTestCaseModified;
				delete element.ewiTestCaseState;
				delete element.ewiTestCaseScriptId;
				delete element.ewiTestCaseScriptName;
				delete element.ewiTestCaseScriptTypeId;

			}
		}
		return summaryDTO;
	}
	
});