/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { // module container 	
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient = {

    REQ_CONNECT_SERVICE_URI: "com.ibm.rqm.requirement.common.service.rest.IRequirementConnectionRestService",
    REQ_PROJECT_SERVICE_URI: "com.ibm.rqm.requirement.common.service.rest.IRequirementProjectRestService",
	
    _invokeService: function(responseHandler, method, appArgs){
        var actutualArgs = {};
		if (appArgs != null) {
			if (appArgs.id) {
				actutualArgs.id = appArgs.id;
			}
			if (appArgs.name) {
				actutualArgs.name = appArgs.name;
			}
			if (appArgs.connectionType) {
				actutualArgs.connectionType = appArgs.connectionType;
			}
			if (appArgs.hostname) {
				actutualArgs.hostname = appArgs.hostname;
			}
			if (appArgs.port) {
				actutualArgs.port = appArgs.port;
			}
			if (appArgs.username) {
				actutualArgs.username = appArgs.username;
			}
			if (appArgs.password) {
				actutualArgs.password = appArgs.password;
			}
			if (appArgs.project) {
				actutualArgs.project = appArgs.project;
			}			
		}
		if(appArgs && appArgs.processArea){
			actutualArgs.processArea = appArgs.processArea;
		}
		else{
			actutualArgs.processArea = getCurrentProjectArea().itemId;
		}
        var serviceRequest = new ServiceRequest(this.REQ_CONNECT_SERVICE_URI, method, actutualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
	
	_invokeProjectService: function(responseHandler, method, appArgs){
        var actutualArgs = {};
		if (appArgs != null) {
			if (appArgs.connectionItemId) {
				actutualArgs.connectionItemId = appArgs.connectionItemId;
			}
			if (appArgs.projectItemId) {
				actutualArgs.projectItemId = appArgs.projectItemId;
			}
			if (appArgs.username) {
				actutualArgs.username = appArgs.username;
			}
			if (appArgs.password) {
				actutualArgs.password = appArgs.password;
			}
			if (appArgs.typeItemId) {
				actutualArgs.typeItemId = appArgs.typeItemId;
			}
		}
		if(appArgs && appArgs.processArea){
			actutualArgs.processArea = appArgs.processArea;
		}
		else{
			actutualArgs.processArea = getCurrentProjectArea().itemId;
		}		
        var serviceRequest = new ServiceRequest(this.REQ_PROJECT_SERVICE_URI, method, actutualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
    
    getRequirementConnectionDTOs: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getRequirementConnectionDTOs", params);
    },

    getUpdatedRequirementConnectionDTO: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getUpdatedRequirementConnection", params);
    },
	
	getDeleteRequirmentConnection: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getDeleteRequirmentConnection", params);
    },
    
	getRequirementTypeDTOs: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getRequirementTypeDTOs", params);
    },
	
    postRequirementConnection: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "postRequirementConnection", params);
    },
	
	getRequirementProject: function(serviceResponseHandler, params){
        this._invokeProjectService(serviceResponseHandler, "getRequirementProjectDTO", params);
    },
	
	getUpdatedRequirementItems: function(serviceResponseHandler, params){
        this._invokeProjectService(serviceResponseHandler, "getUpdatedRequirementItems", params);
    },
	
	// Summary: get the summary information of a requirement project. Returns only the requirement types
	// defined in the project. Use getRequirementItemsByType to fetch requirements of a specific type.
	//
	getSummaryRequirementProject: function(serviceResponseHandler, params){
        this._invokeProjectService(serviceResponseHandler, "getSummaryRequirementProjectDTO", params);
    },
	
	getRequirementItemsByType: function(serviceResponseHandler, params){
        this._invokeProjectService(serviceResponseHandler, "getRequirementItemsByType", params);
    }
};

})();