/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.risk.web.client.internal.risk.RiskClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { // module container 	

var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.risk.web.client.internal.risk.RiskClient = {

    RISK_ASSESSMENT_SERVICE_URI: "com.ibm.rqm.risk.common.service.rest.IRiskAssessmentRestService",
	RISK_PROFILE_SERVICE_URI: "com.ibm.rqm.risk.common.service.rest.IRiskProfileRestService",
    RISK_FACTOR_SERVICE_URI: "com.ibm.rqm.risk.common.service.rest.IRiskTypeRestService",
	
    _invokeAssessmentService: function(responseHandler, method, appArgs){
		
        var actutualArgs = {};
        if (appArgs.id) {
            actutualArgs.id = appArgs.id;
        }
        if (appArgs.artifactType) {
            actutualArgs.artifactType = appArgs.artifactType;
        }
        if (appArgs.artifactItemId) {
			actutualArgs.artifactItemId = appArgs.artifactItemId;
		}
		if (appArgs.artifactItemIds) {
			actutualArgs.artifactItemIds = appArgs.artifactItemIds;
		}
		 if (appArgs.riskProfileId) {
			actutualArgs.riskProfileId = appArgs.riskProfileId;
		}
		if (appArgs.riskFactorIds) {
			actutualArgs.riskFactorIds = appArgs.riskFactorIds;
		}
		 if (appArgs.ranking) {
			actutualArgs.ranking = appArgs.ranking;
		}
		if (appArgs.comment) {
			actutualArgs.comment = appArgs.comment;
		}
		if (appArgs.likelihoods) {
			actutualArgs.likelihoods = appArgs.likelihoods;
		}
		if (appArgs.costs) {
			actutualArgs.costs = appArgs.costs;
		}
		if (appArgs.dynamicRiskValues) {
			actutualArgs.dynamicRiskValues = appArgs.dynamicRiskValues;
		}
		if (appArgs.mitigationActions) {
			actutualArgs.mitigationActions = appArgs.mitigationActions;
		}
		if (appArgs.operation) {
			actutualArgs.operation = appArgs.operation;
		}
		if (appArgs.weights) {
			actutualArgs.weights = appArgs.weights;
		}
		if (appArgs.currentImpacts) {
			actutualArgs.currentImpacts = appArgs.currentImpacts;
		}
		if(appArgs.skipCreate) {
			actutualArgs.skipCreate = appArgs.skipCreate;
		}
		if(appArgs.testCaseItemIds) {
			actutualArgs.testCaseItemIds = appArgs.testCaseItemIds;
		}
		actutualArgs.processArea = getCurrentProjectArea().itemId;
        var serviceRequest = new ServiceRequest(this.RISK_ASSESSMENT_SERVICE_URI, method, actutualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
    
	_invokeProfileService: function(responseHandler, method, appArgs){
        var actutualArgs = {};
        if (appArgs.id) {
            actutualArgs.id = appArgs.id;
        }
		if (appArgs.name) {
            actutualArgs.name = appArgs.name;
        }
		if (appArgs.description) {
			actutualArgs.description = appArgs.description;
		}
		if (appArgs.operationType) {
            actutualArgs.operationType = appArgs.operationType;
        }
		if (appArgs.targetArtifactType) {
            actutualArgs.targetArtifactType = appArgs.targetArtifactType;
        }
		if (appArgs.riskFactorIds) {
            actutualArgs.riskFactorIds = appArgs.riskFactorIds;
        }
        if (appArgs.artifactType) {
            actutualArgs.artifactType = appArgs.artifactType;
        }
        if (appArgs.artifactItemId) {
			actutualArgs.artifactItemId = appArgs.artifactItemId;
		}
		if (appArgs.riskFactorIds) {
			actutualArgs.riskFactorIds = appArgs.riskFactorIds;
		}
		if (appArgs.likelihoods) {
			actutualArgs.likelihoods = appArgs.likelihoods;
		}
		if (appArgs.costs) {
			actutualArgs.costs = appArgs.costs;
		}
		if (appArgs.weights) {
			actutualArgs.weights = appArgs.weights;
		}
		if (appArgs.dynamicRiskValues) {
			actutualArgs.dynamicRiskValues = appArgs.dynamicRiskValues;
		}
		if (appArgs.isNew) {
			actutualArgs.isNew = appArgs.isNew;
		}
		if (appArgs.archived) {
			actutualArgs.archived = appArgs.archived;
		}
		if (appArgs.defaultProfile) {
			actutualArgs.defaultProfile = appArgs.defaultProfile;
		}
		actutualArgs.processArea = getCurrentProjectArea().itemId;
        var serviceRequest = new ServiceRequest(this.RISK_PROFILE_SERVICE_URI, method, actutualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
	
	_invokeRiskTypeService: function(responseHandler, method, appArgs){
        var actutualArgs = {};
        if (appArgs.id) {
            actutualArgs.id = appArgs.id;
        }
        if (appArgs.name) {
            actutualArgs.name = appArgs.name;
        }
        if (appArgs.riskFactorsJsonString) {
			actutualArgs.riskFactorsJsonString = appArgs.riskFactorsJsonString;
		}
		if (appArgs.artifactType) {
			actutualArgs.artifactType = appArgs.artifactType;
		}
		if (appArgs.factorItemIds) {
			actutualArgs.factorItemIds = appArgs.factorItemIds;
		}
		if (appArgs.names) {
			actutualArgs.names = appArgs.names;
		}
		if (appArgs.descriptions) {
			actutualArgs.descriptions = appArgs.descriptions;
		}
		if (appArgs.riskTypeItemIds) {
			actutualArgs.riskTypeItemIds = appArgs.riskTypeItemIds;
		}
		actutualArgs.processArea = getCurrentProjectArea().itemId;
        var serviceRequest = new ServiceRequest(this.RISK_FACTOR_SERVICE_URI, method, actutualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
	
    getSystemRiskAssessmentDTO: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "getSystemRiskAssessmentDTO", params);
    },
    
    getCommunityRiskAssessmentDTO: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "getCommunityRiskAssessmentDTO", params);
    },
	
	postSystemRiskAssessment: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "postSystemRiskAssessmentDTO", params);
    },
	
	postMyRanking: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "postMyRankingDTO", params);
    },
	
	postTestPlanFullRisk: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "postTestPlanFullRisk", params);
    },
	
	postTestCaseFullRisk: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "postTestCaseFullRisk", params);
    },
	
	postSwitchRiskProfile: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "postSwitchRiskProfile", params);
    },
	
	postChangeRiskAssessmentsByWeight: function(serviceResponseHandler, params){
        this._invokeAssessmentService(serviceResponseHandler, "postChangeRiskAssessmentsByWeight", params);
    },
	
	getRiskProfileDTOs: function(serviceResponseHandler, params) {
		this._invokeProfileService(serviceResponseHandler, "getRiskProfileDTOs", params);
	},
	
	postRiskProfileDTOs: function(serviceResponseHandler, params) {
		this._invokeProfileService(serviceResponseHandler, "postRiskProfile", params);
	},
	
	getAllRiskTypeDTOs: function(serviceResponseHandler, params) {
		this._invokeRiskTypeService(serviceResponseHandler, "getAllRiskTypeDTOs", params);
	},
	
	postDeleteRiskFactors: function(serviceResponseHandler, params) {
		this._invokeRiskTypeService(serviceResponseHandler, "postDeleteRiskFactors", params);
	},
	
	postRiskFactors: function(serviceResponseHandler, params) {
		this._invokeRiskTypeService(serviceResponseHandler, "postRiskFactors", params);
	}
	
};

})();