/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");

(function() {

dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.requireLocalization("com.ibm.rational.test.lm.sequencer.web.ui.internal", "messages");

// define a message bundle id for RTLMSequencer
var MessageBundleRTLMSequencer = "RTLMSequencer";
var MessageBundleRQM = "RQM";
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal._MessageLoader", null,
{
    constructor: function(){
        // initializes the rqm message bundle
       MessageUtil.registerRequireBundle(MessageBundleRTLMSequencer, "com.ibm.rational.test.lm.sequencer.web.ui.internal", "messages");
    }
});

com.ibm.rational.test.lm.sequencer.web.ui.internal.MessageLoader = new com.ibm.rational.test.lm.sequencer.web.ui.internal._MessageLoader();
com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants = {
	   
	AUTOMATION_ID: "automation",
	TEST_RECORD_ID: "testrecord",
	SEQUENCE_TYPE_BVT: "bvt",
	SEQUENCE_TYPE_SCHEDULE: "schedule",
	MODEL_TYPE_SUITE: "com.ibm.rqm.execution.TestExecutionSuite",	
	MODEL_TYPE_EWI: "com.ibm.rqm.execution.ExecutionWorkItem",
	ADD_STEP: 1,
	REMOVE_STEP: 2,
	MODIFY_STEP: 3,	  
	TYPE_TEST: "TEST",
	TYPE_AUTOMATION: "AUTOMATION",
	TYPE_SEQUENCE: "Execution Schedule",
	TYPE_SEQUENCE_RESULT: "Execution Schedule Result",
	
	HEADER_STATUS_ERROR: 1,
	HEADER_STATUS_SUCCESS: 2,
	HEADER_STATUS_INFO: 3,
	HEADER_STATUS_WARNING: 4,
	STATUS_SUCCESS: MessageUtil.getMessage(MessageBundleRQM, "labelSuccess"),
	STATUS_FAILURE: MessageUtil.getMessage(MessageBundleRQM, "labelFailure"),
	STATUS_SAVING: MessageUtil.getMessage(MessageBundleRQM, "labelSaving"),
	STATUS_NEW: MessageUtil.getMessage(MessageBundleRQM, "labelNew"),
	STATUS_DIRTY: MessageUtil.getMessage(MessageBundleRQM, "labelDirty"),
	STATUS_NOT_NECESSARY: MessageUtil.getMessage(MessageBundleRQM, "labelSaveNotNecessary"),
	VALIDATION_ERROR:  MessageUtil.getMessage(MessageBundleRQM, "labelValidationError"),
	OPERATION_WARNING:  MessageUtil.getMessage(MessageBundleRQM, "labelOperationWarning"),
	STATUS_SUCCESS: MessageUtil.getMessage(MessageBundleRQM, "labelSuccess"),
	STATUS_FAILURE: MessageUtil.getMessage(MessageBundleRQM, "labelFailure"),
	STATUS_SAVING: MessageUtil.getMessage(MessageBundleRQM, "labelSaving"),
	STATUS_NEW: MessageUtil.getMessage(MessageBundleRQM, "labelNew"),
	STATUS_DIRTY: MessageUtil.getMessage(MessageBundleRQM, "labelDirty"),
	STATUS_NOT_NECESSARY: MessageUtil.getMessage(MessageBundleRQM, "labelSaveNotNecessary"),
	OPERATION_WARNING:  MessageUtil.getMessage(MessageBundleRQM, "labelOperationWarning"),
	TEST_ENVIRONMENT: MessageUtil.getMessage(MessageBundleRQM, "labelTestEnvironment"),
	
	
		 
    getMessage: function(keyword, tokens) {
        var args = [];
		if (arguments.length > 1)
		{
			var len = arguments.length;
        	for( var i = 1; i < len; i++){ 
            	args.push(arguments[i]);
			}
        }
		if (args.length == 0)
			return MessageUtil.getMessage(MessageBundleRTLMSequencer, keyword);
		else if (args.length == 1)
			return MessageUtil.getMessage(MessageBundleRTLMSequencer, keyword, args[0]);
		else if (args.length == 2)
			return MessageUtil.getMessage(MessageBundleRTLMSequencer, keyword, args[0], args[1]);
		else if (args.length == 3)
        	return MessageUtil.getMessage(MessageBundleRTLMSequencer, keyword, args[0], args[1], args[2]);
    },
	getRQMMessage: function(keyword, tokens) {
        var args = [MessageBundleRQM];
		var len = arguments.length;
        for( var i = 0; i < len; i++){ 
            args.push(arguments[i]);
        }
        return MessageUtil.getMessage.apply(MessageUtil, args);
    },
	
	getCommonMessage: function(keyword, tokens) {
        var args = [MessageBundle.COMMON];
		var len = arguments.length;
        for( var i = 0; i < len; i++){ 
            args.push(arguments[i]);
        }
        return MessageUtil.getMessage.apply(MessageUtil, args);
    }
};
})();
