/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.module.TestPlanCreationPickerWidget");//$NON-NLS-1$
// declare dependencies on other Dojo modules
dojo.require("com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.NewTestPlanPanel");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

(function(){

    var TEST_CASE_FACTORY_PREFIX = net.jazz.ajax._contextRoot + "/oslc_qm/contexts/";
    var OSCL_ATTRIB_SUMMARY = "dc:name";//$NON-NLS-1$
    var OSCL_ATTRIB_DESCRIPION = "dc:description";//$NON-NLS-1$
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var newTestPlanPanel = com.ibm.rqm.planning.web.ui.internal.view.common.NewTestPlanPanel;
    var TestPlanClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.TestPlanCreationWidget", [dijit._Widget, dijit._Templated], {
        templateString: '<div style="margin-left:0;margin-top:0.5em;overflow-x:auto;overflow-y:auto;position:relative;width:100%;"><div dojoAttachPoint="_artifactTable" class=""></div><div style="float:right;margin-top:0.5em;margin-right:0.5em;position:relative;"><button class="Button" dojoattachevent="onclick:_onOk">' + Constants.getMessage("labelOk") + '</button><button class="Button" dojoattachevent="onclick:_onCancel">' + Constants.getMessage("labelCancel") + '</button></div></div>',
        
        postCreate: function(){
            this.newTestPlanPanel = new newTestPlanPanel({
                defaultSummary: this.defaultSummary,
                defaultDesc: this.defaultDesc
            });
            this._artifactTable.appendChild(this.newTestPlanPanel.domNode);
        },
        
        validate: function(attr){
            if (!attr.names || dojo.trim(attr.names[0]).length == 0) {
                alert(Constants.getMessage("msgNameRequired"));
                return false;
            }
            return true;
        },
        
        _onOk: function(){
            var editorObj = this.newTestPlanPanel.getAttributes();
            if (this.validate(editorObj)) {
                var aTestPlanObj = {};
                aTestPlanObj.newTestPlan = true;
                aTestPlanObj.name = editorObj.names[0];
                aTestPlanObj.description = editorObj.descriptions[0];
				aTestPlanObj.state = Constants.STATETRANSITION_STATE_DRAFT;
                if (editorObj.ownerIds[0] && editorObj.ownerIds[0] != "-1") {
                    aTestPlanObj.ownerId = editorObj.ownerIds[0];
                }
                dojo.mixin(aTestPlanObj, editorObj);
                var self = this;
                var handler = {
                    success: function(testPlan){
                        self.pickerWidget.send([testPlan], com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget.RETURN_MSG_CREATE);
                    },
                    error: function(e){
                        self._error(e);
                    }
                }
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                TestPlanClient.postTestPlan(responseHandler, aTestPlanObj);
            }
        },
        
        _onCancel: function(){
            this.pickerWidget.send(null, com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget.RETURN_MSG_CREATE);
        },
        
        _error: function(e){
            console.debug(this.declaredClass + ": Error: " + e.message);
        }
    });
    // declare and implement the widget "class"
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.module.TestPlanCreationPickerWidget", com.ibm.rqm.planning.web.ui.internal.module.AbstractPickerWidget, {
    
        getItemType: function() {
			return Constants.getMessage("labelTestPlan");
		}, 
		
		getItemUri: function(versionableItemId){
            if (this.currentProjectArea) {
                var projectAreaId = this.currentProjectArea.itemId;
                return location.protocol + '//' + location.host + TEST_CASE_FACTORY_PREFIX + projectAreaId + '/resources/com.ibm.rqm.planning.VersionedTestPlan/' + versionableItemId;
            }
            else {
                this._noProjectArea();
            }
        },
        
        getContentArea: function(){
            var content = new com.ibm.rqm.planning.web.ui.internal.module.TestPlanCreationWidget({
                pickerWidget: this,
                defaultSummary: this.getDialogArgs()[OSCL_ATTRIB_SUMMARY],
                defaultDesc: this.getDialogArgs()[OSCL_ATTRIB_DESCRIPION]
            });
            return content;
        }
    });
    
})();
