/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.print.PrintPageView");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.core.loader");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper")

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.print.PrintPageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");

(function()
{	
	var PlatformUI			= net.jazz.ajax.ui.PlatformUI;	
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
	var ArtifactModel       = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;
	var TestScriptClient    = com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
	var root                = "com.ibm.rqm.planning.printview.";
	var RegistryClient		= com.ibm.rqm.planning.web.client.internal.RegistryClient;
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.print.PrintPageView", [dijit._Widget, dijit._Templated],
	{      
		controller: null,      
		templateString: '<div class="com-ibm-rqm-printable-artifact-view">' +
		                '    <div class="rqm-print" dojoAttachPoint="_contentNode"></div>' +
		                '</div>',
		
		_actions: ["testPlan", "testCase", "testScript", "execution", "testSuite"],			
			
		/*
		 * Required by Jazz web framework to make hyperlinking and back/forward
		 * work.
		 */
		getController: function() {
			return this.controller;
		},
		
		// initialization      
		postCreate: function() {
			this.controller = new com.ibm.rqm.planning.web.ui.internal.page.print.PrintPageController(this);
            
			// register actions			
            var actionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			for (var i = 0; i < this._actions.length; i++) {
				var actionName = this._actions[i];
		        actionRegistry.registerAction(root + actionName, this.controller, actionName);
			}					
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody", function f(){});
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates", function f(){});
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", function f(){});
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper", function f(){});
            //dojox.data.dom.removeChildren(this._contentNode);
			var handler= new ServiceResponseHandler(this, "setElementResultStateTypes", "_error");
			RegistryClient.getAllExecutionElementResultStateTypes(handler);									
		},
		
        viewTestPlan: function(uriArgs) {		
            var artifactModel = new ArtifactModel(Constants.TYPE_PLAN);
            var editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor({
                parentController: this,
                model: artifactModel,
                kwArgs: uriArgs,
				printable: true
            });
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(editor.domNode);
        },
        
        viewTestCase: function(uriArgs) {		
            var artifactModel = new ArtifactModel(Constants.TYPE_CASE);
            var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor({
                parentController: this,
                model: artifactModel,
                kwArgs: uriArgs,
                printable: true
            });
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(editor.domNode);			
        },
		
		viewTestSuite: function(uriArgs) {		
            var artifactModel = new ArtifactModel(Constants.TYPE_SUITE);
            var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor({
                parentController: this,
                kwArgs: uriArgs,
                printable: true
            });
			editor.setArtifactModel(artifactModel);
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(editor.domNode);			
        },
		
        viewTestScript: function(uriArgs) {       
            // create the editor to show loading in progress in a new tab and reinitialize the editor
            // after the data is fetched from the server
            var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
            var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
            editor.setArtifactModel(artifactModel);
            var self = this;
            var handler = {
                success: function(result) {
	                if (!result || result.length != 1) {
	                    alert(Constants.getMessage("errRetrieveTestScript"));
	                    return;
	                }
					if (dojo.isArray(result)) {
	                    result = result[0]; 
	                }
	                // initialize will implicitly update the tab button label
	                editor.initialize({
						parentController: self, 
						testScript: result, 
						printable: true
					});							
                },
                error: function(e) {
                    self._error(e);
                }
            }
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
            TestScriptClient.getTestScript(responseHandler, uriArgs.id);			
			
            dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(editor.domNode);          
        },
		
		viewExecution: function(kwArgs){	
			var ewi = kwArgs.ewi;
			var runScript = kwArgs.runScript;
			var _resultId = null;
			var requestId = null;
			var ergId = null;
			var printView = false;
			if(kwArgs._resultId)
				_resultId =kwArgs._resultId; 
			if(kwArgs.requestId)
				requestId =kwArgs.requestId;
			if(kwArgs.ergId)
				ergId =kwArgs.ergId;
			if(kwArgs.printView)
				printView = true;			
				
			var _manualExecPage =new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody({ 
											parentController: this, 
											ewi: ewi, 
											runScript: runScript, 
											_resultId: _resultId, 
											requestId: requestId, 
											ergId: ergId, 
											printView: printView });
			dojox.data.dom.removeChildren(this._contentNode);
            this._contentNode.appendChild(_manualExecPage.domNode);
		},
		
		setElementResultStateTypes: function(types){
			if(types && types.length > 0){
				for(var i=0;i<types.length;i++){
					types[i].name = com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates.LABELS[types[i].id];
				}
				this._executionElementResultStates = types;
			}
		},
			
		getElementResultStates: function(){
			return this._executionElementResultStates;
		},
		
		_error: function(e) {
			console.error(this.declaredClass + ": Error occurred: [" + e.message);
		}
	});
})();
