/*HomePageView***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.reports.web.ui.internal.view.NewReport");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.reports.web.ui.internal.view.NewReportEditor");

(function()
{   
    var NewReportEditor = com.ibm.rqm.reports.web.ui.internal.view.NewReportEditor;
	
	dojo.declare("com.ibm.rqm.reports.web.ui.internal.view.NewReport",  [dijit._Widget, dijit._Templated], 
	{
		           
		templateString:   '<div class="com-ibm-rqm-reports">' +
		                  '    <div dojoAttachPoint="_newReportNode" class="com-ibm-team-reports"></div>' +
						  '</div>',	
			
		/*
		 * Required by Jazz web framework to make hyperlinking and back/forward
		 * work.
		 */
		constructor: function() {
            this._view = null;		
			this._editor = null;
		},
		
		// initialization      
		postCreate: function() {	
            console.debug(this.declaredClass + ": postCreate --> entry.");
			this._editor = new com.ibm.rqm.reports.web.ui.internal.view.NewReportEditor({controller: this});
			this._newReportNode.appendChild(this._editor.domNode);
		},
		
        setView: function(view) {
            this._view = view;          
            this._updateView();
        },      
        
        _updateView: function() {
            if (this._view && this._view.controlButton) {
                //apply the tab class
                dojo.addClass(this._view.controlButton.containerNode, "report-icon-tab");
                //TODO update the tab label
            }           
        },
		
		//*******************************************************************************
		//             Overridde from Jazz's ReportsController to allow reuse of 
		//                    Jazz's ReportsViewer widget
		//*******************************************************************************	
		refreshNavigator: function() {
			//do nothing; not using navigator
		},
		//*******************************************************************************
		
		
		_error: function(e) {
			console.error(this.declaredClass + ": Error: " + e.message);
		}	

	});
})();
