/*HomePageView***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.reports.web.ui.internal.view.NewReportEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.reports.web.ui.internal.NewReportEditor");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.reports.web.ui.internal.util.ReportUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function()
{   	
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var ReportUtil = com.ibm.rqm.reports.web.ui.internal.util.ReportUtil;
	
	dojo.declare("com.ibm.rqm.reports.web.ui.internal.view.NewReportEditor",  
	[dijit._Widget, dijit._Templated, com.ibm.team.reports.web.ui.internal.NewReportEditor], 
	{
		//override the template for i18n and styles
        templatePath: dojo.moduleUrl("com.ibm.rqm.reports.web", "ui/internal/view/templates/NewReportEditor.html"),
			
		//i18n labels
		labelReport: Constants.getMessage("labelReport"),
		labelName: Constants.getMessage("labelName"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelTheme: Constants.getMessage("labelTheme"),
		labelTemplate: Constants.getMessage("labelTemplate"),
		labelSave: Constants.getMessage("labelSave"),
			
		// initialization      
		postCreate: function() {	
            this.inherited('postCreate', arguments);
			this._setupCSHelp();
		},
		
		_saveComplete: function(args) {
            document.location.href = ReportUtil.getReportURI({
                name: this._getName(),
                queryUUID: args
            });			
		},
		
		_setupCSHelp:function()
		{
            dojox.data.dom.removeChildren(this.helpButtonNode);
            this.helpButtonNode.style.display = "inline";
            var args = {
                'contextID': "rqm_copy_report.html",
                'csHelpEngine': null,
                'csHelpProviderId':  null
            };
            this.cshelp = new com.ibm.asq.common.web.ui.internal.util.CSHelp(args);
			this.cshelp.setButtonLabel(Constants.getMessage("labelHelp"));
            this.helpButtonNode.appendChild(this.cshelp.domNode);
		}

	});
})();
