/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.AdministrationActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.AdministrationActionBarEntry");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");

(function() 
{
	var JAZZ_ADMIN_PAGE_ID_SERVER = "com.ibm.team.repository.server";
	var JAZZ_ADMIN_PAGE_ID_PROJECTS = "com.ibm.team.process.ProjectAreaManagement";
	var JAZZ_ADMIN_PAGE_ID_USERS = "com.ibm.team.repository.users";
	
	var SERVER_ADMIN_PAGE_ID = "com.ibm.team.process.ProjectAreaManagement";
	var PageRegistry = net.jazz.ajax.ui.internal.PageRegistry;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.AdministrationActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(args)
			{
				com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.AdministrationActionBarEntry.superclass.initialize.call(this, args);
				
				var pages = PageRegistry.getPages();
				this._jazzPageUri = "";
				for(var i=0; i<pages.length; i++)
				{
					if (pages[i].id == JAZZ_ADMIN_PAGE_ID_SERVER) 
					{
						this._jazzServerPageUri = pages[i].getUri();
					}
					if (pages[i].id == JAZZ_ADMIN_PAGE_ID_PROJECTS)
					{
						this._jazzProjectPageUri = pages[i].getUri();
					}
                    if (pages[i].id == JAZZ_ADMIN_PAGE_ID_USERS)
                    {
                        this._jazzUsersPageUri = pages[i].getUri();
                    }					
				}
				
				this._addMenuEntry("System Properties", dojo.hitch(this, "_onClickSystemProperties"), false, {'subAction': "viewSystemProperties"});
				this._addMenuSeparator();
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelJazzServerAdmin"), dojo.hitch(this, "_onClickJazzServerAdmin"), false, null);
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelJazzProjectAdmin"), dojo.hitch(this, "_onClickJazzProjectAdmin"), false, null);
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelJazzUserAdmin"), dojo.hitch(this, "_onClickJazzUserAdmin"), false, null);
			},

			_onClickJazzServerAdmin: function()
			{
				window.location.hash = this._jazzServerPageUri;
			},
			
			_onClickJazzProjectAdmin: function()
			{
				window.location.hash = this._jazzProjectPageUri;
			},

            _onClickJazzUserAdmin: function()
            {
                window.location.hash = this._jazzUsersPageUri;
            },
						
			_onClickSystemProperties: function()
			{
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.administration.AdministrationEditor", 
                    dojo.hitch(this, function(tab, onComplete) {
                        var view = new com.ibm.rqm.planning.web.ui.internal.view.administration.AdministrationEditor();
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                
				this._addPage( {
                    name: Constants.getMessage("labelSystemProperties"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
//			_onClickFeedViews: function()
//			{
//				var feedViews = new com.ibm.rqm.planning.web.ui.internal.view.administration.FeedViews();
//				this._addPage( {name: Constants.getMessage("labelFeedViews"), content: feedViews, closable: true});
//			},
            
            _onClickCatalogEditor: function()
            {
                var catalogEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.CatalogEditor({parent: this});
                this._addPage( {name: Constants.getMessage("labelCustomizeCatalog"), content: catalogEditor, closable: true});                
            }
		}
	);
}
)();
