/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var PageRegistry = net.jazz.ajax.ui.internal.PageRegistry;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry", [com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry], {
        constructor: function(){
        },
        
        postCreate: function(args){
        },
        
        initialize: function(args){
            //com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry.superclass.initialize.call(this, args);
            this.inherited('initialize', arguments);
            this._loadClassAsync("com.ibm.rqm.defects.web.client.ChangeRequestManager", dojo.hitch(this, "_initActionEntries"));
        },
        
        _initActionEntries: function() {
            var page = PageRegistry.findPageWithId("com.ibm.team.workitem");
            this._jazzPageUri = (page) ? page.getUri() : "";
            var self = this;
            com.ibm.rqm.defects.web.client.ChangeRequestManager.getInstance().getServiceProviders(dojo.hitch(this, function(serviceProviders){
                if (serviceProviders && serviceProviders.length > 0) {
                    dojo.forEach(serviceProviders, function(projectLink){
                        self._addNonDispatchableMenuEntry(Constants.getMessage("labelCreateExternalDefect", projectLink.name), dojo.hitch(self, "_onClickCreateExternalDefect", projectLink), false, null);
                        self._addNonDispatchableMenuEntry(Constants.getMessage("labelGoToExternalDefects", projectLink.name), dojo.hitch(self, "_onClickExternalDefects", projectLink), false, null);
                        self._addMenuSeparator();
                    });
                    self._addNonDispatchableMenuEntry(Constants.getMessage("labelGoToDefects"), dojo.hitch(self, "_onClickLocalDefects"), false, null);
                }
                else {
                    self._addNonDispatchableMenuEntry(Constants.getMessage("labelCreateDefect"), dojo.hitch(self, "_onClickCreateLocalDefect"), false, null);
                    self._addNonDispatchableMenuEntry(Constants.getMessage("labelGoToDefects"), dojo.hitch(self, "_onClickLocalDefects"), false, null);
                }
                
            }));            
        },
        
        _onClickCreateLocalDefect: function(){
            var uniqueId = Date.parse(new Date().toString());
            window.location.hash = "action=com.ibm.team.workitem.newWorkItem&type=defect&ts=" + uniqueId;
        },
        
        _onClickLocalDefects: function(){
            window.location.hash = this._jazzPageUri;
        },
        
        _onClickCreateExternalDefect: function(projectLink){
            var self = this;
            var workFunc = function(){
                com.ibm.rqm.defects.web.client.ChangeRequestManager.getInstance().initServiceProvider(projectLink, function(currentServiceProvider){
                    if (currentServiceProvider) {
                        var creationDialogUri = currentServiceProvider.providerUris.defaultCreationDialogURI;
                        var params = {
                            dialogTitle: Constants.getMessage("labelCreateDefect"),
                            secondaryTitle: Constants.getMessage("labelAddNewDefect"),
                            pickerURL: creationDialogUri,
                            height: currentServiceProvider.providerUris.creationDialog.height,
                            width: currentServiceProvider.providerUris.creationDialog.width,
                            parentElement: self.domNode,
                            onOk: function(selectedItems){
                            //do nothing
                            },
                            onClose: function(){
                            }
                        };
                        new com.ibm.rqm.defects.web.helper.RemoteItemPicker(params);
                    }
                });
            }
            this._loadClassAsync("com.ibm.rqm.defects.web.helper.RemoteItemPicker", workFunc);
        },
        
        _onClickExternalDefects: function(projectLink){
            com.ibm.rqm.defects.web.client.ChangeRequestManager.getInstance().initServiceProvider(projectLink, function(serviceProvider){
                if (serviceProvider) {
                    if (serviceProvider.services.homeUrl && serviceProvider.services.homeUrl.indexOf("http") > -1) {
                        window.open(serviceProvider.services.homeUrl);
                    }
                    else { //relative url
                        window.location.hash = serviceProvider.services.homeUrl;
                    }
                }
            });
        }
    });
})();
