/*HomePageView***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.reports.web.ui.internal.view.admin.ReportsAdmin");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.reports.web.ui.internal.AdminViewer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function()
{   
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var AdminViewer = com.ibm.team.reports.web.ui.internal.AdminViewer;
		
	dojo.declare("com.ibm.rqm.reports.web.ui.internal.view.admin.ReportsAdmin", [dijit._Widget, dijit._Templated], 
	{
		templateString:   '<div class="com-ibm-rqm-reports admin">' +
		                  '   <span dojoAttachPoint="_pageTitle" class="title"></span>' +
		                  '   <div dojoAttachPoint="_adminNode" class="com-ibm-team-reports"></div>' +
						  '</div>',
		
		constructor: function() {
			this._adminViewer = null;
		},
		
		postCreate: function() {
			this._pageTitle.innerHTML = Constants.getMessage("labelAdminDWTitle");
			this.showAdminViewer();
		},
		
		showAdminViewer: function() {
			dojox.data.dom.removeChildren(this._adminNode);
            if (!this._adminViewer) {
				this._adminViewer = new com.ibm.team.reports.web.ui.internal.AdminViewer({controller: this});
			}
			this._adminNode.appendChild(this._adminViewer.domNode);			      	
		}
		
	});
	
})();
