/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea, {
        
		csHelpId: "rqm_admin_prop.html",
		
		setDirty: function(dirty){
			this.dirty = dirty;
			var parent = this.parent;
			if(dirty && parent && parent.setDirty && dojo.isFunction(parent.setDirty)){
				parent.setDirty();
			}
		},
		
		isDirty: function(){
			return this.dirty;
		},
		
		
		
		
		
		
        isEditable: function() {
			var parent = this.parent;
            if(parent && parent.isEditable && dojo.isFunction(parent.isEditable)){
                return parent.isEditable();
            }
            return true;
        },
        setErrorMessage: function(message, hoverHelp){
			hoverHelp = hoverHelp ? hoverHelp : message;
			var parent = this.parent;
			if(parent && parent.viewHeaderNode){
				parent.viewHeaderNode.setStatus(message, ViewHeaderLayout.ERROR, hoverHelp);
			}
		},
        
		setSaveErrorMessage: function(message, hoverHelp){
			hoverHelp = hoverHelp ? hoverHelp : message;
			var parent = this.parent;
			if(parent && parent.viewHeaderNode){
			    parent.addError(this.name,message);  
			}
		},

        setSuccessMessage: function(message, hoverHelp){
            hoverHelp = hoverHelp ? hoverHelp : message;
			var parent = this.parent;
            if(parent && parent.viewHeaderNode){
                parent.viewHeaderNode.setStatus(message, ViewHeaderLayout.SUCCESS, hoverHelp);
            }
        },

        clearMessage: function(){
        	var parent = this.parent;
            if(parent && parent.viewHeaderNode){
                parent.viewHeaderNode.clearStatus();
            }
        },
		
		onValidate: function(){
			var result ={
				pass: true,
				message: ""
			}
			return result;
		},
		
		//If the page need a confirmation before saving this function should return true
		//on the implemmented in the specific Content Area and onConfirmation should be overwritten
		confirmationRequired: function(){
          return false;
        },
		
        onConfirmation: function(){
            var parent = this.parent;
            if(parent && parent.confirmationFinished){
                parent.confirmationFinished(true);
            }
        },
		
		onSave: function(){
			return;
		},
		 
        _error: function(error){
            var hoverMessage = error && error.message ? error.message : Constants.getMessage("msgSysPropErrorNoDetails"); 
            var message = Constants.getMessage("msgLoadingSectionSystemProperties", this.name, hoverMessage); 
            this.setErrorMessage(message, null); 
        },
		
        _saveError: function(error){            
            var hoverMessage = error && error.message ? error.message : Constants.getMessage("msgSysPropErrorNoDetails"); 							
            this.parent.addError(this.name,hoverMessage);
        }

    });
    
})();
