/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ActionBarContentArea");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");

(function(){
	var _textContent=dojo.isIE?"innerText":"textContent"; 
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ActionBarContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
				        '<table>' +
				        '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td></tr>' +
				        '<tr><td><div dojoAttachPoint="_content">' +
				        '<table style="border-spacing: 5px;">' +
						'    <tr><td>' +
				        '        <label><input type="radio" value="actionBarVertical" dojoAttachPoint="actionBarVertical" name="actionbar" dojoType="dijit.form.RadioButton"/>${labelVertical} </label>' +
				        '    </td></tr>' +
						'    <tr><td>' +
						'        <div style="margin-left:16px"><span style="float:left" class="pref-verticalvw-icon-24"></span><span><label>${labelActionBarVerticalDescription}</label></span></div>' + 
						'    </td></tr>' +
						'    <tr><td>' +
				        '        <label><input type="radio" value="actionBarHorizontal" dojoAttachPoint="actionBarHorizontal" name="actionbar" dojoType="dijit.form.RadioButton"/> ${labelHorizontal}</label>' +
				        '    </td></tr>' +
						'    <tr><td>' +
						'        <div style="margin-left:16px"><span style="float:left" class="pref-horizontalvw-icon-24"></span><span><label>${labelActionBarHorizontalDescription}</label></span></div>' + 
						'    </td></tr>' +
						'    <tr><td style="padding-top: 10px;">' +
				        '        <label class="note-text">${labelNote}</label><label class="note-text">${msgPreferenceBeActive}</label>' +
				        '    </td></tr>' +
				        '</table>' +
				        '</div></td></tr>' +
				        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelHorizontal: Constants.getMessage("labelHorizontal"),
		labelVertical: Constants.getMessage("labelVertical"),
		labelActionBarVerticalDescription: Constants.getMessage("labelActionBarVerticalDescription"),
		labelActionBarHorizontalDescription: Constants.getMessage("labelActionBarHorizontalDescription"),
		labelNote: Constants.getMessage("labelNote"),
		msgPreferenceBeActive: Constants.getMessage("msgPreferenceBeActive"),
		
		postCreate: function(){
			this.csHelpId = "rqm_pref_action_bar.html";
            this.csHelpLabel = Constants.getMessage("labelActionBarHelp");
            
			this.inherited("postCreate", arguments);
			dojo.connect(this.actionBarVertical, "onChange", this, "onChange");
			dojo.connect(this.actionBarHorizontal, "onChange", this, "onChange");
		},
        
		// @override for AbstractContentArea
        setName: function(){
            this._name[_textContent]=Constants.getMessage("labelActionBar");
        },
		
		// @overrie for AbstractPreferenceContentArea
        getValues: function(){
			var actionBarVertical = this.actionBarVertical;
            return [{
                key: this.key,
                value: actionBarVertical.checked == true ? actionBarVertical.getValue() : this.actionBarHorizontal.getValue()
            }];
        },
		
		// @overrie for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return false;
		}
    });
    
})();
