/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Load: com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberTableViewer");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberTableViewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	
    dojo.declare("CPUNumberTableViewer.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        parentView: null,
    
    	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    	{
        	if (callback != null && dojo.isFunction(callback)) {
		        callback();
		   	}  
    	}
    });
    
    dojo.declare("CPUNumberTableViewer.CellModifier", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, {
        tableViewer: null,
		
		constructor: function(parentView)	{
	        	this.parentView = parentView;
	    },
        
        cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
            switch (columnIndex) {
                case 0:
                    rowObject.globalCpuSoftLimit = newValue;
//					this.parentView.saveActionNode.setDisabled(false);
					this.parentView.parent.setDirty(true);
                    break;
            }
        },
		
		cellActionInvoked: function(rowObject, columnIndex)
	    {
//			if(columnIndex == 2) {
//				this.parentView._handleStopSynchronization(rowObject);
//			}
	    }
    });
    
    dojo.declare("CPUNumberTableViewer.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        getNumColumns: function(content){
            return 2;
        },
        
        getColumnHeading: function(content, index){
            var headings = [Constants.getMessage("labelCPULimit"), Constants.getMessage("labelCPUCount")];
            return headings[index];
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
            return true;
        },
		
        getColumnWidth: function(content, atColumnIndex){
            var width = 2;
            switch (atColumnIndex) {
                case 0:
                    width = 50;
                    break;
                case 1:
                    width = 50;
                    break;
            }
            return width;
        },
		
        getIsCellEditable: function(rowData, atColumnIndex){
			if(atColumnIndex < 2){
				return true;
			}else{
				return false;
			}
        },
        
        // Summary:
        //    The only assumptions the table have on the data that it displays
        //    is that it's an array contents. These are the data content/object that
        //    will be displayed in the table rows.
        //
        getContentObjects: function(content){
            // our content is already an array of objects
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.itemId;
        },
        
        // Summary:
        //    Returns the type of the cell to be displayed. By default, the TableViewer
        //    will support a set of cell types. The type of the cell will map to a specific
        //    cell renderer (to be discussed).
        getCellDisplayType: function(rowData, atColumnIndex){
			switch (atColumnIndex) {
                case 0:
                    return TableConstants.RENDER_TYPE_EDITABLE_TEXT;
                case 1:
                    return TableConstants.RENDER_TYPE_TEXT;
            }
        },
        
        // Summary:
        //    Returns the display data of the cell. For cell renderer type of TEXT, this will
        //    be the string. Others cell render type would be Date, or integer value, etc. If the 
        //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
        //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
        //    cell types such as image where it could have multiple values for different states, the 
        //    client also needs to implement the next method.
        //    
        //    Client must implement this method to provide the cell data.
        //    
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.globalCpuSoftLimit;
                    break;
                case 1:
                    val = rowData.numGlobalCpus;
                    break;
            }
            return val;
        },
		
		getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
	    {  
	        var val = null;
	        return val;
	    }  
    });
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberTableViewer", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1"></div>',
        
        constructor: function(args){
			this.globalCpuSoftLimit = args.globalCpuSoftLimit ? args.globalCpuSoftLimit : null;
			this.numGlobalCpus = args.numGlobalCpus ? args.numGlobalCpus : null;
			this.saveActionHandler = args.saveActionHandler ? args.saveActionHandler : null
        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
        },
        
        initialize: function(args){
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
            this.domNode.appendChild(tableViewer.domNode);
            this.tableViewer = tableViewer;
			
            var contentProvider = new CPUNumberTableViewer.TableProvider();
            
            tableViewer.setContentPageSize(20);
//			this.saveActionNode = tableViewer.addAction("save", Constants.getMessage("labelSaveGlobalCPULimitation"), null, "save-icon-image", dojo.hitch(this, "_handleSaveClick"));
//            this.saveActionNode.setDisabled(true);
			tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), null, "refresh-icon-image", dojo.hitch(this, "refreshActionHandler"));
			
			var content = [{globalCpuSoftLimit: this.globalCpuSoftLimit, numGlobalCpus: this.numGlobalCpus}];
			tableViewer.setContent(content);
            tableViewer.setContentProvider(contentProvider);
			tableViewer.setTableListener(new CPUNumberTableViewer.TableListener(this));
			tableViewer.setCellModifier(new CPUNumberTableViewer.CellModifier(this));
            tableViewer.show();
            tableViewer.setEditable(this.parent.isEditable());
        },
		
		refresh: function(globalCpuSoftLimit, numGlobalCpus) {
		  this.globalCpuSoftLimit = globalCpuSoftLimit;
		  this.numGlobalCpus = numGlobalCpus;
	      this.tableViewer.setContent([{globalCpuSoftLimit: this.globalCpuSoftLimit, numGlobalCpus: this.numGlobalCpus}]);
//	      this.saveActionNode.setDisabled(true);
		  this.tableViewer.show();
	    },
		
		refreshContent: function() {
			this.tableViewer.refresh();
		},
		
		getGlobalCpuSoftLimit: function(){
			return this.tableViewer.getContent()[0].globalCpuSoftLimit;
		},
        
		_handleSaveClick: function(){
			if(this.saveActionHandler && dojo.isFunction(this.saveActionHandler)){
				this.saveActionHandler();
			}
		},
		
        _error: function(errorObj){
            alert(errorObj.message);
        }
    });
    
})();
