//ExecutionPref
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading..com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionSystemPreferenceContentArea");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionSystemPreferenceContentArea");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

(function(){
    var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
	var KEY 							= Constants.EXECUTION_SYSTEM_CONSTRAINTS;
	var PreferenceClient				= com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var getCurrentProjectArea			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
    var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionSystemPreferenceContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
        
        csHelpId: "rqm_admin_exec_pref.html",
		
		postCreate: function(){
            this.inherited("postCreate", arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelExecutionHelp"));
        },
		
		setName: function(){
            this.name = Constants.getMessage("labelExecutionPrefs");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
    
		setText: function(){
			this.text = "";
	        dojox.data.dom.removeChildren(this._text);
	        var text = document.createTextNode(this.text);
	        this._text.appendChild(text);
    	},
		
	    setContent: function(){
			var option = new com.ibm.asq.common.web.client.internal.option();
			var responsehandler = new ServiceResponseHandler(this, "createContentArea", "_error")
			option.getProjectPreferences(responsehandler, getCurrentProjectArea().itemId, KEY);
	    },
		
		createContentArea: function(prefEntry){
			var doc = document;
			console.debug("Entering createContentArea with PrefEntry " + prefEntry);
			this.prefEntry = prefEntry;
			var values = prefEntry && prefEntry.value ? dojo.fromJson(prefEntry.value) : {};
			dojox.data.dom.removeChildren(this._content);
			var table = doc.createElement('table');
			this._content.appendChild(table);
			var tbody = doc.createElement('tbody');
			table.appendChild(tbody);
			var trApply = doc.createElement('tr');
			tbody.appendChild(trApply);
			var checkApplyTD = doc.createElement('td');
			trApply.appendChild(checkApplyTD);
			checkApplyTD.width = "5%";
			var labelApplyTD = doc.createElement('td');
			trApply.appendChild(labelApplyTD);
			labelApplyTD.width = "95%";
			
			//Apply all disability
			var disableApplyAllCheckbox = doc.createElement('input');
			disableApplyAllCheckbox.type = 'checkbox';
			this.connect(disableApplyAllCheckbox, "onclick", this.onChange);
			var label = doc.createElement('label');
			label.innerHTML = "&nbsp;&nbsp;" + Constants.getMessage("labelDisableApplyAllForManualTest");
			checkApplyTD.appendChild(disableApplyAllCheckbox);
			labelApplyTD.appendChild(label);
			this.disableApplyAllCheckbox = disableApplyAllCheckbox;
			if(values.disableApplyAll){
				disableApplyAllCheckbox.checked = true;
			}
			//Use workitem for unblocking TER
			var trUseWI = doc.createElement('tr');
			tbody.appendChild(trUseWI);
			var checkUseWITD = doc.createElement('td');
			trUseWI.appendChild(checkUseWITD);
			checkUseWITD.width = "5%";
			var labelUseWITD = doc.createElement('td');
			trUseWI.appendChild(labelUseWITD);
			labelUseWITD.width = "95%";
			
			var useWICheckbox = doc.createElement('input');
			useWICheckbox.type = 'checkbox';
			var wiLabel = doc.createElement('label');
			wiLabel.innerHTML = "&nbsp;&nbsp;" + Constants.getMessage("labelUseWIForUnblocking");
			checkUseWITD.appendChild(useWICheckbox);
			labelUseWITD.appendChild(wiLabel);
			this.useWICheckbox = useWICheckbox;
			useWICheckbox.disabled = true;//Not modifyable for now.
			useWICheckbox.checked = true;
			
			//Use plan workitem for unblocking TER
			var trUsePlanWI = doc.createElement('tr');
			tbody.appendChild(trUsePlanWI);
			var checkUsePlanWITD = doc.createElement('td');
			trUsePlanWI.appendChild(checkUsePlanWITD);
			checkUsePlanWITD.width = "5%";
			var labelUsePlanWITD = doc.createElement('td');
			trUsePlanWI.appendChild(labelUsePlanWITD);
			labelUsePlanWITD.width = "95%";
			
			var usePlanWICheckbox = doc.createElement('input');
			usePlanWICheckbox.type = 'checkbox';
			var planWiLabel = doc.createElement('label');
			planWiLabel.innerHTML = "&nbsp;&nbsp;" + Constants.getMessage("labelUsePlanWIForUnblocking");
			checkUsePlanWITD.appendChild(usePlanWICheckbox);
			labelUsePlanWITD.appendChild(planWiLabel);
			this.usePlanWICheckbox = usePlanWICheckbox;
			this.connect(usePlanWICheckbox, "onclick", this.onChange);
			if(values.blockOnPlanitems){
				usePlanWICheckbox.checked = true;
			}else
				usePlanWICheckbox.checked = false;
			
			//Use build for unblocking TER
			var trUseBuild = doc.createElement('tr');
			tbody.appendChild(trUseBuild);
			var checkUseBuildTD = doc.createElement('td');
			trUseBuild.appendChild(checkUseBuildTD);
			checkUseBuildTD.width = "5%";
			var labelUseBuildTD = doc.createElement('td');
			trUseBuild.appendChild(labelUseBuildTD);
			labelUseBuildTD.width = "95%";
			
			var useBuildCheckbox = doc.createElement('input');
			useBuildCheckbox.type = 'checkbox';
			this.connect(useBuildCheckbox, "onclick", this.onChange);
			var buildLabel = doc.createElement('label');
			buildLabel.innerHTML = "&nbsp;&nbsp;" + Constants.getMessage("labelUseBuildForUnblocking");
			checkUseBuildTD.appendChild(useBuildCheckbox);
			labelUseBuildTD.appendChild(buildLabel);
			this.useBuildCheckbox = useBuildCheckbox;
			if(values.buildStatus){
				useBuildCheckbox.checked = true;
			}
			this.setDirty(false);
		},
		
	    getValues: function(){
			var object = {
				disableApplyAll: this.disableApplyAllCheckbox.checked,
				wiStatus: this.useWICheckbox.checked,
				blockOnPlanitems: this.usePlanWICheckbox.checked,
				buildStatus: this.useBuildCheckbox.checked
			}
	    	return object;
	    },
		
		onChange: function(changeValue){
			this.setDirty(true);
		},
		
		onSave: function(){
			var option = new com.ibm.asq.common.web.client.internal.option();
			this.parent.addSaveParticipantNum();
			var self = this;
			var handler = {
				success: function(results){
                    self.setDirty(false);
					self.parent.saveFinished();
					self.prefEntry = results;
				},
				error: function(e){
                    self._saveError(e); 
					self.parent.saveFinished();
				}
			}
			
			var responsehandler = new ServiceResponseHandler(handler, "success", "error");
			var res = this.getValues();
			if(this.prefEntry){
				option.updateProjectPreferences(responsehandler, getCurrentProjectArea().itemId, this.prefEntry.itemId, dojo.toJson(res));
			}else{
				option.createProjectPreferences(responsehandler, getCurrentProjectArea().itemId, KEY, dojo.toJson(res));
			}
		}
		
    });
})();
