//debug listcellrenderer

/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget");


(function() {

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
	
    // Summary:
    //    Renders the image cell content. The following cellData can be expected. 
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/ cellModifier, rowObject, columnIndex){
		var obj = {
			rowObject: rowObject,
			columnIndex: columnIndex,
			cellModifier: cellModifier
		};	
		var args = {
                validateCallback: dojo.hitch(obj, this._onValidate),
                changedCallback: dojo.hitch(obj, this._onChanged),
				cellData: cellData,
				rowObject:rowObject
        };
		var lcw = new com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget(args);
        this.registerWidget(lcw);
		return lcw.domNode;
	},
	
	_onValidate: function(oldList, newList, action, rowObject)
	{
		return this.cellModifier.cellValueValidate(oldList, newList, this.rowObject, this.columnIndex, action);		
	},
	
	_onChanged: function(oldList, newList, action, rowObject)
	{
		this.cellModifier.cellValueChanged(oldList, newList, this.rowObject, this.columnIndex, action);
	}


});

})();
