//debug ListCellWidget
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
     
       
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget");



dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");


(function() {

var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var Button = com.ibm.asq.common.web.ui.internal.widgets.Button;


com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidgetAction = {
	ADD : "add",
	REMOVE : "remove",
	CLOSE : "close"
};

var ListCellWidgetAction = com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidgetAction;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget", [dijit._Widget, dijit._Templated], {
	_select: null,
	_cellData: null,
	_validateCallback: null,
	_changedCallback: null,
	_rowobject: null,
	_error: "",
    _value: Constants.getMessage("labelValue"),
    _colon: Constants.getMessage("labelColen"),
		templateString: '<div style="width:25em" dojoAttachPoint="_toplevelNode" >' + 
					'          <div style="float: left; width: 70%">' +
                    '			   <div dojoAttachPoint="_listboxNode"></div>' +
					'              <div style="float: left;">${_value}${_colon}</div>'+										
				    '              <div style="float: right;" dojoAttachPoint="_inputNode"></div>'+
					'          </div>' +
					'          <div style="float: right;">' +
					'	            <div dojoAttachPoint="_closeNode" class="button"></div>' +					
					'	            <div dojoAttachPoint="_addNode" class="button"></div>' +
					'			    <div dojoAttachPoint="_removeNode" class="button"></div>' + 
					'          </div>'  +
					'          <div style="clear: left;" dojoAttachPoint="_validationNode" class="com-ibm-asq-listcellwidget-text-error" ></div>' +
                    '</div>',
					
    constructor: function(args) {
  		this._validateCallback = args.validateCallback;
		this._changedCallback = args.changedCallback;
		this._cellData = args.cellData; 
	},

    postCreate: function(){
        this.inherited('postCreate', arguments);
		
		var argAdd = {
            label: Constants.getMessage("labelAdd"),
			iconClass: "add-icon-image",						
            showLabel: true,
            parent: this,
            onClick: dojo.hitch(this, "_onAdd")
        };		
		var argClose = {
            label: Constants.getMessage("labelCollapse"),
            showLabel: true,
			iconClass: "collapse-icon-image",
            parent: this,
            onClick: dojo.hitch(this, "_onClose")
        };
		var argRemove = {
            label: Constants.getMessage("labelRemove"),
            showLabel: true,
			iconClass: "delete-icon-image",
            parent: this,
            onClick: dojo.hitch(this, "_onRemove")
        };
        var removeButton = new Button(argRemove);
        var addButton =    new Button(argAdd);
        var closeButton =  new Button(argClose);		
				 
				
		var select = document.createElement("select");
		select.className = "com-ibm-asq-listcellwidget-text-normal";
		select.multiple = "yes";
		select.size = 5;
		var cellData = this._cellData;
		var length = cellData.length;
		for (var i = 0; i < length; i++) {
			select.options[i] = new Option(cellData[i], i);
		}
		
		this._listboxNode.appendChild(select);
		this._select = 	select;	
		
		var input = document.createElement("input");
		input.className = ".com-ibm-asq-listcellwidget-text-normal";
		this.connect(input, "onkeyup", "_onkeyup");		
		
		this._input = input;
		
		this._inputNode.appendChild(input);
		this._closeNode.appendChild(closeButton.domNode);					
		this._addNode.appendChild(addButton.domNode);			
		this._removeNode.appendChild(removeButton.domNode);

    },
	
	_onkeyup: function(ch)
	{
		if(ch.keyCode == dojo.keys.ENTER)
		 	this._onAdd();
 	},
	
	_onValidate: function(oldList, newList, action){
		this._validationNode.innerHTML = "";						
		return this._validateCallback(oldList, newList, action, this.rowObject);
	},
	
	_onChanged: function(oldList, newList, action){
		return this._changedCallback(oldList, newList, action, this.rowObject);
	},
		
	_onRemove: function(){
		var rc;

		if(this._select){
			var selectionList = this._getSelectionList();
			rc = this._onValidate(null, selectionList, ListCellWidgetAction.REMOVE);
			if(rc.valid){
				this._onChanged(null, selectionList, ListCellWidgetAction.REMOVE);
				var options = this._select.options;
				var length = options.length;
				for (var i = length - 1; i >= 0; i--) {
					if(options[i].selected){
						for(var j = i; j < length - 1; j++)
							options[j].text = options[j + 1].text;
						options[options.length - 1] = null;
					}
			 	}
			 }
			 else
		 		this._validationNode.innerHTML = rc.reason;
		}
	},
	
	_onClose: function(){
			this._onValidate(null, null, ListCellWidgetAction.CLOSE)		
			this._onChanged(null, null, ListCellWidgetAction.CLOSE);
	},
	
	_onAdd: function(){
		var text = this._input.value;
		this._validationNode.innerHTML = "";				
		var rc = this._onValidate(null, text, ListCellWidgetAction.ADD);
		if(rc.valid){
			this._onChanged(null, text, ListCellWidgetAction.ADD);
			this._select.options[this._select.options.length] = new Option(text, text);
			this._input.value = "";
		}
		else	
			this._validationNode.innerHTML = rc.reason;
	},
	
	_getSelectionList: function()
	{
		var list = new Array();
		var options = this._select.options;
		var length = options.length;
		for (var i = 0; i < length; i++){
			var option = options[i];
			if(option.selected){
				list.push(option.text);
			}
	 	}
		return list;
	}
});
})();