//MSD
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ManualScriptDictionary");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("dijit.form.Button");

(function() { // module container 

var ImageCache 						= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ManualScriptDictionary", [dijit._Widget, dijit._Templated], {
	
	/*
	 * CSS nodes need to Match Category CSS values for same look and feel
	 */
	 templateString: 	'<div class="com-ibm-rqm-categories-editor">' +
				        '    <label class="note-text">${labelNote}</label><label class="note-text">${labelArtifactEditorTOCNote}</label>' +
	 					'    <table dojoAttachPoint="_itemTableNode" class="category-type-editor-table">' +
		                '        <tr class="category-type-row" dojoAttachEvent="onclick:_handleItemHeaderClick">' + 
		                '            <th dojoAttachPoint="_nameNode" class="content-column"></th>' +
						'            <th dojoAttachPoint="_actionsNode" class="actions-column"></th>' +
		                '        </tr>' +  
						'        <tbody dojoAttachPoint="_itemNode">' +
						'        </tbody>' +
						'    </table>' +
						'</div>'	,
	
	labelNote: Constants.getMessage("labelNote"),
	labelArtifactEditorTOCNote: Constants.getMessage("labelArtifactEditorTOCNote"),
	
	postCreate: function(){
		if(!this.parentEditor){
			throw new Error("Parent Editor is required");
		}
		this.rows = [];
		this.rowCount = 0;
	},
	
	initialize: function(){
		this._nameNode.innerHTML = this.title;
		var args = {
                label: Constants.getMessage("labelAddNewWord"),
                onClick: dojo.hitch(this, this._addNewRowClicked),
                iconClass: "add-icon-image",
                showLabel: false
            };
		var button = new dijit.form.Button(args);
		this._actionsNode.appendChild(button.domNode);
		if(this.items){
			for(var i=0;i<this.items.length;i++){
				this._addNewRowClicked(null, this.items[i]);
			}
		}
	},
	
	getValues: function(){
		var values = [];
		for(var i=0;i<this.rowCount;i++){
			var value = this.rows[i].getValue();
			if(value.length > 0)
				values.push(value);
		}
		return values;
	},
	
	_addNewRowClicked: function(e, item){
		var args = {
			content: "",
			valueChangeCallback: this.editCallback,
			deleteCallback: dojo.hitch(this, this.deleteCallback),
			parentTable: this,
			rowNumber: this.rowCount };
		if(item){
			args.content = item;
		}else{
			this.editCallback(null);
		}
		var row = new com.ibm.rqm.planning.web.ui.internal.view.administration._ManualScriptDictionaryRow(args);
		this.rows.push(row);
		this.rowCount++;
		this._itemNode.appendChild(row.domNode);
	},
	
	deleteCallback: function(rowIndex){
		if( isNaN(rowIndex) ){
			return;
		}
		this.rows.splice(rowIndex, 1);
		for(var i = rowIndex; i < this.rows.length ;i++){
				this.rows[i].rowNumber--;
		}
		this.rowCount--;
		this._itemNode.deleteRow(rowIndex);
		this.editCallback(null);
	},
	
	_handleItemHeaderClick: function(event){
		if(event){
            dojo.stopEvent(event);
        }
	},
	
	_error: function(error){
        console.error("Error in ManualScriptDictionary");
	}
});
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration._ManualScriptDictionaryRow", [dijit._Widget, dijit._Templated], 
{
	templateString: 
						'    <tr class="category-type-row">' + 
		                '        <td dojoAttachPoint="_itemNode" class="content-column" dojoAttachEvent="onclick:_handleItemClick">'+
						'             <input dojoAttachPoint="_item"></input>'+
						'        </td>' +
						'        <td dojoAttachPoint="_deleteActionNode" class="actions-column"></td>' +
		                '    </tr>' ,
		postCreate: function(){
			if(this.content)
				this._item.value = this.content;
			this.connect(this._item, "onkeyup", this._itemValueChanged);	
			var args = {
                label: Constants.getMessage("labelDelete"),
                onClick: dojo.hitch(this, this._deleteClicked),
                iconClass: "delete-icon-image",
                showLabel: false
            };
		var button = new dijit.form.Button(args);
		this._deleteActionNode.appendChild(button.domNode);
		},
		
		_itemValueChanged: function(){
			if(this.valueChangeCallback){
				this.valueChangeCallback(this._item.value);
			}
		},
		
		_handleItemClick: function(event){
		    if(event){
                dojo.stopEvent(event);
            }
		},
		
		_deleteClicked: function(){
			if(this.deleteCallback){
				this.deleteCallback(this.rowNumber);
			}
		},
		
		getValue: function(){
			return this._item.value;
		}
		
});
})();