/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.PreferencesEditor");

dojo.require("com.ibm.asq.common.web.client.internal.option");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ActionBarContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ArtifactEditorContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.RelatedInformationContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.DateFormatContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AdapterSelectionContentArea");
//dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.WordWrapChoiceContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionUserPreferenceContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.QueryListsContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.EditorTextDirectionContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ProgressPanelContentArea");

dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var Constants 		= com.ibm.rqm.planning.web.client.internal.Constants;
	var AlertDialog 	= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.PreferencesEditor", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor, {
        /*
         * If at least one preference need logout/login to take effect, isHotSwitchable is flaged as false.
         * 
         * Need Logout/Login: Action Bar, Related Information
         * Nedd Not Logout/Login: TOC
         */
		isHotSwitchable: true,
		
		constructor: function(){
            this.headerTitle = Constants.getMessage("labelPreferences");
            this.defaultProperty = Constants.getMessage("labelActionBar");
        },
		
		postCreate: function(){
			this.inherited("postCreate", arguments);
			this._loadUserPreference();
		},
		
        setNameContentPairs: function(){
			var widgetArgs = {onChange: dojo.hitch(this, "onChange")};
			
			this._nameContentPairs = [{
                "name": Constants.getMessage("labelActionBar"),
                "content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.ActionBarContentArea,
				"widgetArgs": widgetArgs
            },{
				"name":Constants.getMessage("labelArtifactEditorTOC"),
				"content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.ArtifactEditorContentArea,
				"widgetArgs": widgetArgs
			},{
                "name":Constants.getMessage("labelArtifactViewBuilderSettings"),
                "content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.QueryListsContentArea,
				"widgetArgs": widgetArgs
            },{
				"name":Constants.getMessage("labelRelatedInformation"),
				"content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.RelatedInformationContentArea,
				"widgetArgs": widgetArgs
            },{
                "name":Constants.getMessage("labelProgressPanelSettings"),
                "content": null,
                "jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.ProgressPanelContentArea,
                "widgetArgs": widgetArgs
            },{
				"name":Constants.getMessage("labelDateFormat"),
				"content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.DateFormatContentArea,
				"widgetArgs": widgetArgs
			},{
				"name":Constants.getMessage("labelExecutionPreferences"),
				"content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionUserPreferenceContentArea,
				"widgetArgs": widgetArgs
			},{
				"name":Constants.getMessage("labelAdapterPreference"),
				"content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.AdapterSelectionContentArea,
				"widgetArgs": widgetArgs
			},{
				"name":Constants.getMessage("labelEditorTextDirection"),
				"content": null,
				"jsClass": com.ibm.rqm.planning.web.ui.internal.view.administration.EditorTextDirectionContentArea,
				"widgetArgs": widgetArgs
			}]
        },
        
        setButtonArea: function(){
			var doc = document;
			var inputLabel = doc.createElement("label");
			this.defaultButton = doc.createElement("input");
			var button = this.defaultButton;
			button.type = "button";
            button.value = Constants.getMessage("labelRestoreDefault");
			this.connect(button, "onclick", "_onRestoreDefault");
			inputLabel.appendChild(button);
            this._buttonArea.appendChild(inputLabel);
			
			var inputLabel = doc.createElement("label");
			this.okButton = doc.createElement("input");
			var button = this.okButton;
			button.type = "button";
			button.disabled = true;
            button.value = Constants.getMessage("labelOk");
			this.connect(button, "onclick", "_onOK");
			inputLabel.appendChild(button);
            this._buttonArea.appendChild(inputLabel);
			
			var inputLabel = doc.createElement("label");
			this.cancelButton = doc.createElement("input");
			var button = this.cancelButton;
			button.type = "button";
            button.value = Constants.getMessage("labelCancel");
			this.connect(button, "onclick", "_onCancel");
			inputLabel.appendChild(button);
            this._buttonArea.appendChild(inputLabel);

        },
		
		onCloseParentDialog: function(){
			//Empty function, connect it with the close() function of Parent SelectionDialog. Fire close() function when the Cancel button is clicked.
		},
		
		onChange: function(){
			var defaultButtonDiabled = true;
			var okButtonDiabled = true;
			var nameContentPairs = this._nameContentPairs;
			var length = nameContentPairs.length;
            var hasInvalidInput = false;
			for(var i = 0; i < length; i++){
				var nameContentPairContent = nameContentPairs[i].content;
				if(nameContentPairContent && dojo.isFunction(nameContentPairContent.matchingDefalutValues)){
					 defaultButtonDiabled = defaultButtonDiabled && nameContentPairContent.matchingDefalutValues();
				}
				if(nameContentPairContent && dojo.isFunction(nameContentPairContent.matchingOldValues)){
					 okButtonDiabled = okButtonDiabled && nameContentPairContent.matchingOldValues();
				}
                if(!hasInvalidInput && nameContentPairContent && dojo.isFunction(nameContentPairContent.hasInvalidInput)){
                     hasInvalidInput = nameContentPairContent.hasInvalidInput();
                }
			}
			this.defaultButton.disabled = defaultButtonDiabled;
			this.okButton.disabled = okButtonDiabled || hasInvalidInput;
		},
		
		_onOK: function(){
			this.defaultButton.disabled = true;
			this.okButton.disabled = true;
			this.cancelButton.disabled = true;
			this._saveUserPreference();
        },
		
		_onCancel: function(){
			this.onCloseParentDialog();
		},
		
		_onRestoreDefault: function(){
			var nameContentPairs = this._nameContentPairs;
			var length = nameContentPairs.length;
			for(var i = 0; i < length; i++){
				var nameContentPair = nameContentPairs[i];
				if(nameContentPair.content){
					nameContentPair.content.restoreDefault();
				} else {
					nameContentPair.content = new nameContentPair.jsClass(nameContentPair.widgetArgs);
					nameContentPair.content.restoreDefault();
				}
			}
			this.onChange();
		},
		
		_setUserPreference: function(userPreference){
			var nameContentPairs = this._nameContentPairs;
			var length = nameContentPairs.length;
			for(var i = 0; i < length; i++){
				var nameContentPair = nameContentPairs[i];
				if(nameContentPair.content) {
					nameContentPair.content.setUserPreference(userPreference);
				} else {
					nameContentPair.widgetArgs.userPreference = userPreference;
				}
			}
			this.onChange();
		},
		
		_saveUserPreference: function(){
			var keyValues = [];
			var nameContentPairs = this._nameContentPairs;
			var length = nameContentPairs.length;
			for(var i = 0; i < length; i++){
				var nameContentPairContent = nameContentPairs[i].content;
				if(nameContentPairContent) {
					var keyValue = nameContentPairContent.getValues();
					if(!nameContentPairContent.matchingOldValues() && !nameContentPairContent.isHotSwitchable()){
						this.isHotSwitchable = false;
					}
					var keyValueLength = keyValue.length;
					for(var j = 0; j < keyValueLength; j++){
						keyValues.push(keyValue[j]);
					}
				}
			}
			var responseHandler = new ServiceResponseHandler(this, "_savedSuccess", "_error");
            PreferenceClient.saveCurrentUserPreferences(keyValues, responseHandler);
		},
		
		_loadUserPreference: function(){
            PreferenceClient.getCurrentUserPreferences(this, this._setUserPreference);
		},
		
		_savedSuccess: function(){
			  this.onCloseParentDialog();
		},
		
		_error: function(e){
			console.debug(e);
		}
    });
})();
