/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.QualityObjectivesContentArea");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.QualityObjectivesGrid");


(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var QualityObjectivesGrid = com.ibm.rqm.planning.web.ui.internal.view.construction.QualityObjectivesGrid;
	var AbstractPropertyContentArea = com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.QualityObjectivesContentArea", AbstractPropertyContentArea, {
        
		postCreate: function() {
			this.csHelpId = "rqm_quality_objectives_sys_prop.html";
			this.inherited('postCreate', arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelManageObjectives") + " " + Constants.getMessage("labelHelp"));
		},
		
		setName: function(){
            this.name = Constants.getMessage("labelManageObjectives");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelManageObjectivesText");
			dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function(){
			this._showEditor();
        },

        _showEditor: function() {
            dojox.data.dom.removeChildren(this._content);
            this._editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.QualityObjectivesGrid({
				isDialog: false,
                editable: true,
				okCallback: dojo.hitch(this, "_onSaveFinished")
            });				
			
			dojo.connect(this._editor, "_onGridChange", this, "_setDirty");
            this._content.appendChild(this._editor.domNode); 			
		},
		
		_setDirty: function() {
			this.setDirty(this._editor.isDirty());
		},
		
		onSave: function() {
			if (this._editor && this._editor.isDirty()) {
				this.parent.addSaveParticipantNum();
				this._editor._onOK();
			}
		},
		
		_onSaveFinished: function(status) {
		    //append error message if necessary
			if (!status.ok) {
				this.setSaveErrorMessage(Constants.getMessage("msgCategorySaveError"), status.errorMessage);  
			}
			else{
			    this.setDirty(false);
			}
			this.parent.saveFinished();
		},
        
        getValues: function(){
        	return [];
        }
    });
})();
