//ExecutionPref
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading..com.ibm.rqm.planning.web.ui.internal.view.administration.TestCasePreferenceContentArea");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.TestCasePreferenceContentArea");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

(function(){
    var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
	var KEY 							= Constants.TESTCASE_SYSTEM_PREFERENCE;
	var PreferenceClient				= com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var getCurrentProjectArea			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
    var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.TestCasePreferenceContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
        
        csHelpId: "rqm_admin_tc_pref.html",
		
		postCreate: function(){
            this.inherited("postCreate", arguments);
			this.csHelp.setButtonLabel(Constants.getMessage("labelTCPreferencesHelp"));
        },
		
		setName: function(){
            this.name = Constants.getMessage("labelTCPreferences");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
    
		setText: function(){
			this.text = "";
	        dojox.data.dom.removeChildren(this._text);
	        var text = document.createTextNode(this.text);
	        this._text.appendChild(text);
    	},
		
	    setContent: function(){
			var option = new com.ibm.asq.common.web.client.internal.option();
			var responsehandler = new ServiceResponseHandler(this, "createContentArea", "_error")
			option.getProjectPreferences(responsehandler, getCurrentProjectArea().itemId, KEY);
	    },
		
		createContentArea: function(prefEntry){
			var doc = document;
			this.prefEntry = prefEntry;
			var values = prefEntry && prefEntry.value ? dojo.fromJson(prefEntry.value) : {};
			dojox.data.dom.removeChildren(this._content);
			var table = doc.createElement('table');
			this._content.appendChild(table);
			var tbody = doc.createElement('tbody');
			table.appendChild(tbody);
			var trApply = doc.createElement('tr');
			tbody.appendChild(trApply);
			var checkApplyTD = doc.createElement('td');
			trApply.appendChild(checkApplyTD);
			checkApplyTD.width = "5%";
			var labelApplyTD = doc.createElement('td');
			trApply.appendChild(labelApplyTD);
			labelApplyTD.width = "95%";
			
			//Apply all disability
			var useTriggerActivity = doc.createElement('input');
			useTriggerActivity.type = 'checkbox';
			this.connect(useTriggerActivity, "onclick", this.onChange);
			var label = doc.createElement('label');
			label.innerHTML = "&nbsp;&nbsp;" + Constants.getMessage("labelUseTriggerActivity");
			checkApplyTD.appendChild(useTriggerActivity);
			labelApplyTD.appendChild(label);
			this.useTriggerActivity = useTriggerActivity;
			if (values.useTriggerActivity) {
				useTriggerActivity.checked = true;
			}
			this.setDirty(false);
		},
		
	    getValues: function(){
			var object = {
				useTriggerActivity: this.useTriggerActivity.checked
			}
	    	return object;
	    },
		
		onChange: function(changeValue){
			this.setDirty(true);
		},
		
		onSave: function(){
			var option = new com.ibm.asq.common.web.client.internal.option();
			this.parent.addSaveParticipantNum();
			var self = this;
			var handler = {
				success: function(results){
                    self.setDirty(false);
					self.parent.saveFinished();
					self.prefEntry = results;
				},
				error: function(e){
                    self._saveError(e); 
					self.parent.saveFinished();
				}
			}
			
			var responsehandler = new ServiceResponseHandler(handler, "success", "error");
			var res = this.getValues();
			if(this.prefEntry){
				option.updateProjectPreferences(responsehandler, getCurrentProjectArea().itemId, this.prefEntry.itemId, dojo.toJson(res));
			}else{
				option.createProjectPreferences(responsehandler, getCurrentProjectArea().itemId, KEY, dojo.toJson(res));
			}
		}
		
    });
})();
