/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.WordWrapChoiceContentArea");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");
dojo.require("dijit.form.CheckBox");

(function(){
	var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.WordWrapChoiceContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
					        '<table>' +
					        	'<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td>'+
								'</tr>' +
						        '<tr><td><div dojoAttachPoint="_content">' +
							        '<table>' +
							        	'<tr><td>' +
							        		'<label><input type="radio" value="labelEnableWordWrap" dojoAttachPoint="enableWordWrap" name="wordwrap" dojoType="dijit.form.CheckBox"/> ${labelEnableWordWrap}</label>' +
							        	'</td></tr>' +
										'<tr><td>' +
								        '   <label class="note-text">${labelNote}</label><label class="note-text">${labelEnableWordWrapMessage}</label>' +
								        '</td></tr>' +
							        '</table>' +
						        '</div></td></tr>' +
					        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_ACTIONBAR_WORDWRAPCHOICE_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelEnableWordWrap: Constants.getMessage("labelEnableWordWrap"),
		labelEnableWordWrapMessage: Constants.getMessage("labelEnableWordWrapMessage"),
		labelNote: Constants.getMessage("labelNote"),
		
		postCreate: function(){
			this.csHelpId = "rqm_word_wrap.html";
            this.csHelpLabel = Constants.getMessage("labelWordWrapHelp");
            
			this.inherited("postCreate", arguments);
			dojo.connect(this.enableWordWrap, "onChange", this, "onChange");
		},
		
		// @override for AbstractContentArea
        setName: function(){
            dojox.data.dom.removeChildren(this._name);
            this._name.appendChild(document.createTextNode(Constants.getMessage("labelEnableWordWrapPref")));
        },

		// @overrie for AbstractPreferenceContentArea
        getValues: function(){
            return [{
                key: this.key,
                value: this.enableWordWrap.checked
            }];
        },
		
		// @overrie for AbstractPreferenceContentArea
		displayUserPreference: function(userPreferences){
			var length = userPreferences.length;
			for(var i = 0; i < length; i++){
                this.enableWordWrap.setChecked(userPreferences[i].value);
			}
		},
		
		// @overrie for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return true;
		}
    });
    
})();
