/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar");
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Slider");

// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.AbstractFormField");
dojo.provide("com.ibm.asq.common.web.ui.internal.util.DomConstructor");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");

(function(){ // module container
    /* Jazz objects */
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    /* QM objects */
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var RiskUtil = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
	var MaxValue = 5;
	
    dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="assessmentNode" class="com-ibm-rqm-risk-assessment">' +
                    '  <img dojoAttachPoint="star1"></img>' +
                    '  <img dojoAttachPoint="star2"></img>' +
					'  <img dojoAttachPoint="star3"></img>' +
					'  <img dojoAttachPoint="star4"></img>' +
					'  <img dojoAttachPoint="star5"></img>' +
                    '</div>',
        
//		widgetsInTemplate: true,
		editable: true,
		value: 0, //0 1 2 3 4 5
		isRiskWidget: true,  //true: orange color;  false: blue color 
		
        // object initializer
        constructor: function(args){
			this.value = args.value;
			this.editable = args.editable;
			this.onChangeHandler = args.onChangeHandler;
        },
        
		postCreate: function() {
			this.images = [];
			this.images.push(this.star1);
			this.images.push(this.star2);
			this.images.push(this.star3);
			this.images.push(this.star4);
			this.images.push(this.star5);
			if(this.editable) {
				for(var i = 0; i < this.images.length; i++) {
					dojo.addClass(this.images[i], "riskStarEditable");
					this.images[i].onclick = dojo.hitch(this, "_onStarClick", i);
//					this.images[i].onmouseenter = dojo.hitch(this, "_onMouseEnter", i);
//					this.images[i].onmouseleave = dojo.hitch(this, "_onMouseLeave", i);
				}
			}
	        this._initialize();			
		},	
		
        _initialize: function(){
			if(this.value > MaxValue)
				this.value = MaxValue;
			for(var i = 0; i < this.value; i++) {
					this.images[i].src = this.isRiskWidget ? ImageCache.RISK_SELECTED : ImageCache.RISK_IMPORT_SELECTED;
					if(this.editable)
						this.images[i].title = RiskUtil.getRiskLabel(i + 1);
			}
			for(var i = this.value; i < this.images.length; i++) {
				if(this.editable)
					this.images[i].title = RiskUtil.getRiskLabel(i + 1);
				if(this.isRiskWidget)
					this.images[i].src = this.editable ? ImageCache.RISK_UNSELECT : ImageCache.RISK_READONLY;
				else 
					this.images[i].src = ImageCache.RISK_IMPORT_UNSELECTED;
			}
        },
        
		setValue: function(value) {
			this.value = value;
			this._initialize();
		},
		
		getValue: function() {
			return this.value;
		},
		
		_onStarClick: function(i) {
			this.value = i+1;
			if(this.onChangeHandler && dojo.isFunction(this.onChangeHandler)) {
				this.onChangeHandler(this.value);
			}
			this._initialize();
		},
		
//		_onMouseEnter: function(i) {
//			for(var i = 0; i < i+1; i++) {
//					this.images[i].src = ImageCache.RISK_SELECTED;
//			}
//			for(var i = i+1; i < this.images.length; i++) {
//				this.images[i].src = ImageCache.RISK_UNSELECT;
//			}
//		},
//		
//		_onMouseLeave: function(i) {
//			for(var i = 0; i < this.value; i++) {
//					this.images[i].src = ImageCache.RISK_SELECTED;
//			}
//			for(var i = this.value; i < this.images.length; i++) {
//				this.images[i].src = ImageCache.RISK_UNSELECT;
//			}
//		},

        
        _error: function(e){
            alert("An error occurred: [" + e.message + "] @ RiskAssessmentStar#_error");
        }
    });
    

dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.assessment.FormRiskField", 
    com.ibm.asq.common.web.ui.internal.widgets.layout.AbstractFormField,
{
    currentValue: null,
    disabled: false,
    
    textFieldInvalidFormatMsg: "",
    riskWidgetTemplate: '<table dojoAttachPoint="domNode" width="100%">' +
                        '  <tr>' +
                        '    <td valign="middle" colspan="3">' +
                        '      <input type="checkbox" dojoAttachPoint="riskToggle"></input>' +
                        '      <label dojoAttachPoint="riskToggleLabelNode"><span dojoAttachPoint="riskToggleLabel"></span></label>' +
                        '    </td>' +
                        '  </tr>' +
                        '  <tr style="white-space:nowrap">' +
                        '    <td>' +
                        '      <img dojoAttachPoint="resetRisk" style="cursor:pointer;padding-right:5px;"></img>' +
                        '    </td>' +
                        '    <td dojoAttachPoint="riskNode" style="white-space:nowrap"></td>' +
                        '    <td align="right" width="100%"><span dojoAttachPoint="riskSetting"></span></td>' +
                        '  </tr>' +
                        '</table>',
                        
    constructor: function() {
        this.currentValue = 0;
    },
    
    postCreate: function() {
        this.inherited("postCreate", arguments);
        
        this.riskField = new com.ibm.asq.common.web.ui.internal.util.DomConstructor(this.riskWidgetTemplate);
        this.riskField.riskToggleLabelNode.setAttribute("for", this.domNode.id + "_riskToggle");
        this.riskField.riskToggleLabel.innerHTML = Constants.getMessage("resetAnyRisk");

        this.riskToggle = this.riskField.riskToggle;
        this.riskToggle.setAttribute("id", this.domNode.id + "_riskToggle");
        this.connect(this.riskToggle, "onchange", "_onToggleRisk");

        this.resetRisk = this.riskField.resetRisk;
        this.resetRisk.src = ImageCache.RISK_READONLY;
        this.resetRisk.title = Constants.getMessage("msgNoRiskShort");
        this.connect(this.resetRisk, "onclick", "_onRiskReset");
        
        this.riskAssessment = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar({
            value: 0,
            editable: true,
            onChangeHandler: dojo.hitch(this, "_onRiskChanged")
        });
        this.riskField.riskNode.appendChild(this.riskAssessment.domNode);

        var parent = (this.alterHolderNode || this.fieldHolderNode);
        parent.appendChild(this.riskField.domNode);
        
        if (this.defaultValue) {
            this.setValue(this.defaultValue);
        }
        this.formField = this.riskField.domNode;
    },
    
    uninitialize: function() {
        this.riskAssessment.destroy();
    },

    _valueChangedHandler: function() {
        var oldValue = this.currentValue;
        this.currentValue = this.getValueNum(); 
        
        this.onValueChanged(this, oldValue, this.currentValue);
        this.riskField.riskSetting.innerHTML = this.getValueInString();
    },
    
    _onRiskChanged: function() {
        // a value is set, uncheck "Any"
        this.riskToggle.checked = false;
        this._valueChangedHandler();
    },
    
    _onRiskReset: function() {
        // reset to not yet rated, value = 0
        this.riskAssessment.setValue(0);
        this._onRiskChanged();
    },
    
    _onToggleRisk: function() {
        if (this.riskToggle.checked) {
            this.clearValue();
        }
    },
    
    setValue: function(value) {
        // external interface uses string as value to avoid any chance that the value 0 is
        // used in a boolean evaluation as false
        value = Number(value);
        if (!isNaN(value) && (value >= 0)) {
            this.riskAssessment.setValue(value);
            this._onRiskChanged();
        } else {
            this.clearValue();
        }
    },

    getValue: function() {
        // external interface uses string as value to avoid any chance that the value 0 is
        // used in a boolean evaluation as false
        return this.getValueNum().toString();
    },
    
    getValueNum: function() {
        var val = this.riskToggle.checked ? -1 : this.riskAssessment.getValue();
        return val;
    },
    
    getValueInString: function() {
        if (this.riskToggle.checked) {
            return Constants.getMessage("labelAnyCap");
        } else {
            var val = this.getValueNum();
            return RiskUtil.getRiskLabel(val);
        }
    },
    
    clearValue: function() {
        this.riskToggle.checked = true;
        this.riskAssessment.setValue(0);
        this._valueChangedHandler();
    },

    _getBaseClassName: function() {
        return "text-field";
    }
});

})();
