/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.SelectItemTableDialog");
dojo.require("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {

var BuildUiUtil 			= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var BuildTableView			= com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView;
var SelectItemTableDialog   = com.ibm.rqm.buildintegration.web.ui.internal.view.build.SelectItemTableDialog;

/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

var BuildClient				= com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient;
var PermissionsClient 		= com.ibm.asq.common.web.client.internal.PermissionsClient;
var Constants				= com.ibm.rqm.planning.web.client.internal.Constants;
var ProgressUtility = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoAttachPoint="viewHeaderNode"></div>' +
					'  <div dojoAttachPoint="buildTableNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '</div>',
	consoleNode:false,
	parent:null,
	buildDefId:null,
    constructor: function(args) {
		args = args ? args : {};
		this.parent = args.parent;
		this.consoleNode = args.consoleNode;
		this.buildDefId = args.buildDefId;
		this.builds = [];		
	 },

    postCreate: function(){
		if(!this.consoleNode){
	        var headerArg = {
				title: BuildUiUtil.getMessage("labelAllBuilds"),
	            contextHelpId: "rqm_all_builds.html",
                isCompact: true
	        };
			this.viewHeader = new com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout(headerArg);
			this.viewHeader.setCSHelpButtonLabel(BuildUiUtil.getMessage("labelBuildsHelp"));
			this.viewHeaderNode.appendChild( this.viewHeader.domNode );
		}
		if (this.clientLoaded) 
			this.initialize();
		else {
			jazz.core.loader.load_async("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient", dojo.hitch(this, "initialize"));
		}
	},
	
	initialize:function(){
		this.clientLoaded = true;
        this.sequenceClient = com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;

		this.removedBuildRecs = [];
		var args = {};
		if(this.consoleNode){
			if(this.buildDefId == null)
				this.buildDefId = -1;	
			args.buildDefinitionId = this.buildDefId;
		}

        if (!this.buildTable) {
            var actions = [];
            if (this.consoleNode) {
                actions.push({
                    name: "addBuildRec",
                    label: BuildUiUtil.getMessage("labelAddBuildRec"),
                    context: this,
                    icon: "add-icon-image",
                    callback: dojo.hitch(this, "addBuildRec")
                });
                actions.push({
                    name: "removeBuildRec",
                    label: BuildUiUtil.getMessage("labelRemoveBuildRec"),
                    context: this,
                    icon: "delete-icon-image",
                    callback: dojo.hitch(this, "removeBuildRec")
                });
            } else {
				var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_BUILD_RECORD);
				if(permission.archive){
					actions.push({
	                    name: "removeBuildRec",
	                    label: BuildUiUtil.getMessage("labelDeleteBuildRec"),
	                    context: this,
	                    icon: "delete-icon-image",
	                    callback: dojo.hitch(this, "preDeleteAction")
	                });
				}
			}
            var buildTableArgs = {
                parentController: this,
                builds: this.builds,
                actions: actions,
                tableRowsCheckable: (this.rowCheckable ? this.rowCheckable : this.consoleNode),
                consoleNode: this.consoleNode,
                // hook in the method to obtain all results' item ids.
                _getAllResultsItemIds: dojo.hitch(this.sequenceClient, "getAllSearchBuildRecordResultItemIds"),
                // initialize options for the view builder
                _searchFunction: dojo.hitch(this.sequenceClient, "getSearchBuildRecordsWithStatistics"),
                _searchCallback:dojo.hitch(this, "_showTable"),
                buildDefId: this.buildDefId?this.buildDefId:null
            };
            if (this.singleSelectable) 
                buildTableArgs.singleSelectable = this.singleSelectable;
            if (this.editable) 
                buildTableArgs.editable = this.editable;
            this.buildTable = new BuildTableView(buildTableArgs);
			if(this.viewHeader){
				this.viewHeader.containerNode.appendChild(this.buildTable.domNode);
			}else{
				this.buildTableNode.appendChild(this.buildTable.domNode);
			}
        } else if (this.buildDefId!=-1){
            this.buildTable.initRunQuery();
        }
	},
    
	_showTable:function(builds){
		this.builds = builds?builds:[];
		this.buildTable.refreshTable(this.builds);
	},
    
	addBuildRec:function(){
		var params = {
            title: BuildUiUtil.getMessage("labelAddBuildRec"),
            exclusionList: this.builds,                    
            onOk: dojo.hitch(this, "_handleAddedItems")
        };
        var itemListWidget = new SelectItemTableDialog(params);
        itemListWidget.show();
	},
	_handleAddedItems:function(buildRecs){
		buildRecs = buildRecs? buildRecs:[];
		for(var i=0;i<buildRecs.length;i++){
			this.builds.push(buildRecs[i]);
		}
		this.buildTable.refreshTable(this.builds);
		this._onChange();
	},
	removeBuildRec:function(){
		var buildRecs = this.buildTable.getSelectedRows();
		for(var i=0;i<buildRecs.length;i++){
			for(var j=0;j<this.builds.length;j++){
				if(this.builds[j].id == buildRecs[i].id){
					this.builds.splice(j,1);
					if(buildRecs[i].buildRecord)
						this.removedBuildRecs.push(buildRecs[i].buildRecord.id);
					else
						this.removedBuildRecs.push(buildRecs[i].id);
					break;
				}
			}
		}
		this.buildTable.refreshTable(this.builds);
		this._onChange();
	},
	
    preDeleteAction: function(){
        // call invoke action to 'normalize' the selection, it gets all of
        // the select items's itemId, even if the page have not been loaded.
        this.buildTable.invokeAction("itemId", this, "onDeleteActionClick");
    },
    
	onDeleteActionClick: function(selectedIds){
        // check if any selected test cases are current displayed in another tabs
		var openedBuilds = [];
        var selectedBuilds = [];
        var userSelectedBuilds = this.getSelectedBuildRecord();
        
        if (dojo.isArray(userSelectedBuilds) && this.artifactsDisplayContainer) {
			var length = userSelectedBuilds.length;
            if (length > 0) {
                for (var i = 0; i < length; i++) {
					var build = userSelectedBuilds[i].buildRecord;
                    var buildURI = BuildUiUtil.getBuildRecordURI(build.id);
                    if (this.artifactsDisplayContainer.hasPage(buildURI)) {
                        openedBuilds.push(build);
                    } else {
                        selectedBuilds.push(build);
                    }
                }
            }
        } else {
            // can't check for opened tab, just show the deleting confirmation
            selectedBuilds = null;
        }
		var len = (selectedBuilds) ? selectedBuilds.length : selectedIds.length;
        this.selectedBuilds = selectedBuilds;
        var prompt = BuildUiUtil.getMessage("msgDelBuildRecordConfirm",len);
        if (openedBuilds.length > 0) {
            if (len > 0) {
                // some selected artifacts are not opened in tabs
                prompt = BuildUiUtil.getMessage("msgDelSomeOpenBuildRecordConfirm");
            } else {
                // all selected artifacts are opened in tabs
                prompt = BuildUiUtil.getMessage("msgDelAllOpenBuildRecordConfirm");
            }
        }

        var args = {
            'message': prompt,
            'options': openedBuilds,
            'okCallback': dojo.hitch(this, "deleteBuildRec"),
            'okCallbackData': selectedIds,
            'cancelCallback': null,
            'cancelCallbackData': null
        };
        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.OptionsDialog(args);
        this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
        this.confirmDialog.open();
	},
	
	deleteBuildRec: function(selectedIds){
        var dlg = this.confirmDialog;
        var deleteIds = [];
        this.confirmDialog = null;
        
        // we have possible shown options to not delete certain items, check it.
        if (this.selectedBuilds) {
            this.selectedBuilds = this.selectedBuilds.concat(dlg.getSelection());
            var count = this.selectedBuilds.length;
            deleteIds = [];
            for(var i = 0; i < count; i++) {
                deleteIds.push(this.selectedBuilds[i].itemId);
            }
        }
        else {
            // no special handling of opened items, just use all deleted ids.
            deleteIds = selectedIds;
        }
        var totalDeleteCnt = this.selectedBuildCount = deleteIds.length;
        if (totalDeleteCnt > 0) {
            this.buildTable.deleteActionNode.setDisabled(true);
            this.errorBuildCount = 0;
            this.deletedBuildCount = 0;
            var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
            BuildClient.postArchiveBuildRecord(responseHandler,
                {	archive: true,
					itemIds: deleteIds });
            this.monitorId = ProgressUtility.beginTaskMonitor(BuildUiUtil.getMessage("labelDeleteBuildRec"), 0, null);
        }
	},
	
	_deleteSuccess: function(response) {
        this.deletedBuildCount = response;
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        this._setDeleteStatus(err);
    },
    
    _setDeleteStatus: function(err) {
    	var error = (err && err.message)?err.message:err; 
        ProgressUtility.endTaskMonitor(this.monitorId,error);
        this.viewHeader.setStatus(
            BuildUiUtil.getMessage("msgDeletedBuildRecords", this.deletedBuildCount, this.selectedBuildCount),
            this.deletedBuildCount == this.selectedBuildCount ? ViewHeaderLayout.SUCCESS : ViewHeaderLayout.INFO
        );
        if (this.deletedBuildCount > 0) {
            this.buildTable._invalidateQuery();
        }
    },
	
	getSelectedBuildRecord: function(){
		return this.buildTable.getSelectedRows();
	},
	
	getBuildRecs:function(){
		
		return this.builds;
	},
	getRemovedBuildRecs:function(){
		return this.removedBuildRecs;
	},
	clearRemovedBuildRecs:function(){
		this.removedBuildRecs = [];
	},
	_error: function(e){
		console.error("An error occurred: [" + e.message + "] @ BuildList#Error");
	},
	_onChange:function(){
		if(this.parent && this.parent._onChange){
			this.parent._onChange();
		}
	}
});

})();
