/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntryDropDownButton");

dojo.require("dijit.form.Button");

(function() 
{
    // Subclass of DropDownButton for the menu bar buttons to keep the active CSS
    // as long as the drop down is opened and not only depending on hover.
    //
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntryDropDownButton", dijit.form.DropDownButton, {
        
        templateString:"<div tabIndex=\"0\" class=\"dijit dijitLeft dijitInline\"\r\n\tdojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse,onclick:_onDropDownClick,onkeydown:_onDropDownKeydown,onblur:_onDropDownBlur,onkeypress:_onKey\"\r\n\t><div class='dijitRight'>\r\n\t<button class=\"dijitStretch dijitButtonNode dijitButtonContents\" type=\"${type}\"\r\n\t\tdojoAttachPoint=\"focusNode,titleNode\" waiRole=\"button\" waiState=\"haspopup-true,labelledby-${id}_label\"\r\n\t\t><div class=\"dijitInline ${iconClass}\" dojoAttachPoint=\"iconNode\"></div\r\n\t\t><span class=\"dijitButtonText\" \tdojoAttachPoint=\"containerNode,popupStateNode\"\r\n\t\tid=\"${id}_label\">${label}</span\r\n\t\t><span class='dijitA11yDownArrow'><img dojoAttachPoint=\"_downArrowImg\"/></span>\r\n\t</button>\r\n</div></div>\r\n",

        downArrow: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/images/menudropdown.gif"),
        downArrowHov: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/images/menudropdown_hov.gif"),

        postCreate: function() {
            this.inherited(arguments);
            this._downArrowImg.src = this.downArrow;
        },
        
        _openDropDown: function() {
            this.inherited(arguments);
            this._setStateClass();
        },

        _closeDropDown: function(focus) {
            this.inherited(arguments);
            this._active = false;
            this._setStateClass();
        },
    
        _setStateClass: function() {
            this._active = this._active || this._opened;
            this._downArrowImg.src = (this._hovering || this._active) ? this.downArrowHov : this.downArrow;
            this.inherited(arguments);
        }
    });
}
)();