//EV
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * This widget provides the basic structure of any execution widget.
 *
 * Author: vasrivas
 */
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

(function() {

var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants       				= com.ibm.rqm.planning.web.client.internal.Constants;
var ExecutionClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
var ExecutionWorkItemClient			= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ToolAdapterRegistrationClient	= com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var MachineAdapterTV           		= com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;

dojo.declare(
	"com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer",
	[dijit._Widget, dijit._Templated],
	{
		templateString: "<div dojoAttachPoint=\"_container\">"+
						"<div dojoAttachPoint=\"_dialog\"></div>"+
						"</div>",
		
		EXECUTE: 0,
		progressPercent: 0,
		autoSelect: true,
		isNew: false,
		_stopEnabled: false,
		_isStopable: false,
		_isPrintable: false,
		
		constructor: function() {
			/*
			 * parentController: Required 
			   parentEditor: Required - should be ExecutionPageBody
			   ewiItemId: Required 
			   script: Required
			   ewiConfigId: optional
			   _resultId: Optional 
			   ergId: Optional 
			   requestId: Optional 
			 */
		},
		
		postCreate: function() {
		},	
		
		//Optional over-ride for custom initialization
		initialize: function(){
			this.myViewUri = window.location.hash;
			var ewi = this.parentEditor._ewi;
			if(ewi && ewi.currentResult && ewi.currentResult.script && ewi.currentResult.script.id == this.script.id){
				if(ewi.currentResult.properties){
					var len = ewi.currentResult.properties.length;
					for(var j=0;j<len;j++){
						if(ewi.currentResult.properties[j].propertyName == "adapterId"){
							this.lastSelectedAdapterExternalId = ewi.currentResult.properties[j].propertyValue;
							break;
						}
					}
				}
			}
			if(!this.requestId)
				this.openAdapterSelectionDialog(this.script.scriptType.id)
			else
				this.setRequestId({id: this.requestId});
		},
		
		//Required over-ride
		getHelpContextID: function(){
			return null;
		},
		
		//Helper
		getCurrentUserId: function(){
			return getAuthenticatedContributor().userId;
		},
		
		//Optional over-ride 
		openAdapterSelectionDialog: function(/*String - scriptTypeId*/scriptTypeId){
			var responseHandler = new ServiceResponseHandler(this, "_setCurrentServerTime", "_error");
			ExecutionClient.getServerTime(responseHandler);
		},
		
		//Required over-ride: Pass on the attributes/properties needed as part of execution request
		getExecutionRequestProperties: function(){
			var props = [];
			if (this.script.properties){
				props = props.concat(this.script.properties);
			}
			return props;
		},
		
		getLocation: function(sections, type){
			var sectionId = "com.ibm.rqm.planning.editor.section.planResources";
			var location = "";
			var items = [];
			if (sections){
				var len = sections.length;
				for(var i=0;i<len;i++){
					if(sections[i].id == sectionId){
						items = sections[i].content ? dojo.fromJson(sections[i].content) : []
						break;
					}
				}
				for(var j=0;j<items.length;j++){
					if(items[j].type == type)
						location =items[j].resolvedPath; 
					}
				}
			return location;
		},
		
		updateParentDetailSection: function(adapter){
			this.parentEditor.updateDetailSection(adapter);
		},
		
		//Optional over-ride
		createExecutionRequest: function(){
			//Show adapterDetails in the parent.
			this.updateParentDetailSection(this.selectedAdapter);
			var script = this.script;
			var _ewi = this.parentEditor._ewi;
			//createExecutionRequest properties and post request
			var properties = this.getExecutionRequestProperties();//Must return an Array of properties
			properties.push({propertyName: "scriptId", propertyValue: script.id+"", propertyType: "String"});
			properties.push({propertyName: "scriptItemId", propertyValue: script.versionableItemId ? script.versionableItemId : script.itemId, propertyType: "String"});
			properties.push({propertyName: "scriptTypeName", propertyValue: script.scriptType.name, propertyType: "String"});
			if(this.ewiConfiguration){
				properties.push({propertyName: "configuration", propertyValue: this.ewiConfiguration, propertyType: "String"});
				properties.push({propertyName: "configId", propertyValue: this.ewiConfigId, propertyType: "String"});
			}	
			properties.push({propertyName: "testCaseName", propertyValue: _ewi.testCase.name, propertyType: "String"});
			if(_ewi.testPlan){
				var shareLocation = this.getLocation(_ewi.testPlan.sections, script.scriptType.name);
				properties.push({propertyName: "testPlan", propertyValue: _ewi.testPlan.name, propertyType: "String"});
				properties.push({propertyName: "sharePrefix", propertyValue: shareLocation, propertyType: ""});
			}
			properties.push({propertyName: "testPhase", propertyValue: (_ewi.phase ? _ewi.phase.name: ""), propertyType: "String"});
			properties.push({propertyName: "ewiId", propertyValue: _ewi.id, propertyType: "link"});
			properties.push({propertyName: "scriptType", propertyValue: script.scriptType.id, propertyType: "String"});
			properties.push({propertyName: "scriptItemId", propertyValue: script.versionableItemId ? script.versionableItemId : script.itemId, propertyType: "link"});
			if(this.selectedAdapter)
				properties.push({propertyName: "machine", propertyValue: this.selectedAdapter.hostName, propertyType: "String"});
			/*properties.push({propertyName: "owner", propertyValue: this.getCurrentUserId(), propertyType: "String"});*/
			properties.push({propertyName: "ewiItemId", propertyValue: this.ewiItemId, propertyType: "String"});
//			properties.push({propertyName: "scriptName", propertyValue: script.name, propertyType: "String"});
			
			//If reservations were created for this execution they will be in the this.reservations variable.
			//If there are any then extract them into a comma delimited string and add them to the properties array.
			//These reservations will be released once the execution finishes.
			if (this.reservations && this.reservations.ids && this.reservations.ids.length > 0){
				var idArray = this.reservations.ids;
				var resIDs = "";
				var len = idArray.length;
				for (var i = 0; i < len; i++){
					if (i > 0)
						resIDs += ",";  //comma separate
					resIDs += idArray[i];
				}
				//add the string to the array of properties
				properties.push({propertyName: "reservationUUIDs", propertyValue: resIDs, propertyType: "String"});
			}
			
			this.isNew = true;
			var requestObj = {
				requestType: this.EXECUTE,
				properties: properties,
				isNew: this.isNew
			}
			if(this.selectedAdapter && this.selectedAdapter.id){
				requestObj.selectedAdapterId = this.selectedAdapter.id;
			}
			var responseHandler = new ServiceResponseHandler(this, "setRequestId", "createRequestError");
			ExecutionClient.postCreateRequest(responseHandler, requestObj);
		},
		
		//Optional over-ride if need to ping faster/slower - Time is in Milliseconds
		getPingTimeOut: function(){
			return 1500;
		},
		
		//Optional over-ride if want to check progress in widget
		setRequestId: function(request){
			if(this.isNew)
				this.parentEditor.setHeaderStatus(Constants.getMessage("msgExecReqCreated"), 3);
			this.isNew = false;	
			this.requestId = request.id;
			this._remoteProgress();
		},
		
		createRequestError: function(error){
			this.parentEditor.setHeaderStatus(Constants.getMessage("msgErrorStartingRun"), 1, error);
		},
		
		//Optional over-ride if there is a need to show custom messages, call this after over-riding
		setCurrentRequest: function(/*Object*/ request){
			var parentEditor = this.parentEditor;
			if(parentEditor && parentEditor.cancelButton && parentEditor.cancelButton.isDisabled()){
				parentEditor.cancelButton.setDisabled(false);
			}
			if(parentEditor && parentEditor.stopButton && parentEditor.stopButton.setDisabled){
				if(this.isStopExecutionEnabled())
					parentEditor.stopButton.setDisabled(false);
			}
			
			if(request.state && request.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled" && parentEditor){
				parentEditor.setHeaderStatus(Constants.getMessage("msgExeCancel"), 3);
				if(this.__timer){
					clearInterval(this.__timer);
					delete this.__timer;
				}
				parentEditor.cancelButton.setDisabled(true);
				if(parentEditor && parentEditor.stopButton && parentEditor.stopButton.setDisabled){
					parentEditor.stopButton.setDisabled(true);
				}
					
				parentEditor.showResultButton.setStyle("display", "none");
				parentEditor._header.addRightViewAction(Constants.getMessage("labelClose"), dojo.hitch(this, "onClose"), null, null);
				return;
			}
			
			if(this.selectedAdapter == null){
				var eSelf = this;
				var callbackObj = {
					success: function(adapters){
						if(adapters && adapters.length > 0){
							eSelf.selectedAdapter = adapters[0];
							eSelf.updateParentDetailSection(eSelf.selectedAdapter);
						}	
					},
					failure: function(errorObj){
						console.error("Error fetching adapter info in ExecViewer, message - "+errorObj.message);
					}
				}
				var params = {
					id: this.latestRequestObject.selectedAdapterId
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				ToolAdapterRegistrationClient.getAdaptersWithMachines(responseHandler, params);
			}
			
			var percent =request.progress+"%";
			if(percent && parseInt(percent) > 0){
				parentEditor.clearHeaderStatus()
				dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_REQUEST, [request]]);
			}
			if(percent=="100%"){
				var properties = request.propertiesMap;
				var executionResultId = "";
				var len = properties.length;
				for(var i=0;i<len;i++){
					if(properties[i].propertyName === "resultItemId"){
						executionResultId = properties[i].propertyValue;
						break;
					}
				}	
				this._finalizeForLog(executionResultId);
				return;
			}
		},
		
		onClose: function(){
			setTimeout(dojo.hitch(this.parentEditor, "publishClosure"), 1500);
		},
		
		//Optional over-ride
		updateProgressBar: function(percent /*eg. 5 */){
			//Calling updateProgress function in EPB
			if(this.parentEditor){
				this.parentEditor.updateProgress(percent);
			}	
		},
		
		//Optional over-ride
		onStartOfExecution: function(reservations){
			//If reservations were made for this execution remember them for later processing
			//A bit of a hack.  The return value from reserving Cells is different from that of reserving a single machine
			if (reservations && reservations.idsAreReservations) //reservations from reserving a cell
				this.reservations = {
					ids: reservations.resultIds
				};
			else 
				this.reservations = reservations;  //reservations from reserving a single machine
				
			//this.selectedAdapter gives the selected Adapter details
			var self = this;
			var callbackObj = {
				success: function(config){
					self.ewiConfiguration = config.name;
					self.ewiConfigId = config.id;
					self.createExecutionRequest();
				},
				failure: function(){
					console.error("EWI configuration was not fetched & set");
					self.createExecutionRequest();
				}
			}
			
			if (this.parentEditor._ewi.configuration) {
			 	var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			 	this.config = new com.ibm.rational.test.lm.web.client.internal.config();
			 	this.config.retrieveConfigurationWithDetails(responseHandler, this.parentEditor._ewi.configuration);
			}else
				self.createExecutionRequest();
		},

		//Optional over-ride
		onCancel: function(/*Boolean*/showAlertMessage, /*String*/message){
			if(showAlertMessage){	
				var msg = ""
				if(message)
					msg=message;
				this.parentEditor.setHeaderStatus(Constants.getMessage("msgExeCancel")+msg, 3);
			}
			//Clear off the timer if cancel is hit.
			if(this.__timer){
				clearInterval(this.__timer);
				delete this.__timer;
			}			
			var instructions = [];
			instructions.push({requestId: this.requestId, instructionType: "CANCEL"});
			var adapterId = this.selectedAdapter ? this.selectedAdapter.id : this.latestRequestObject.selectedAdapterId;

			var params = {
				id: adapterId,
				instructions: instructions,
				isNew: false
			}
			
			var responseHandler = new ServiceResponseHandler(this, "_refreshCancelState", "_error");
			ToolAdapterRegistrationClient.postRegister(responseHandler, params);

			history.back();
			return true;	
		},
		
		_refreshCancelState: function() {
			console.debug("after cancel");
		},
		
		//Optional over-ride
		onEndOfExecution: function(){	/*Shows the result of the EWI*/
			if(!this._resultItemId)	{
				console.error("Missing required parameter this._resultItemId in ExecutionViewer");
				return;
			}	
			var resultId = this._resultItemId;
			var args = {
				ewiId: this.parentEditor._ewi.id,
				resultItemId: resultId
			};
			if(this.ergId)
				parent.location = Utility.runSuite({groupId: this.ergId});//Return to the suite execution page not result
			else	
				parent.location = Utility.getResultURI(args);
		},
		
		//Helper
		setAdapter: function(/*Adapter object*/adapter){
			this.selectedAdapter = adapter;
		},
		/*
		 * Stop functions
		 */
		//returns true if the given script type allow stopping the execution in the middle
		isStopAllowed: function(){
			return this._isStopable;
		},
		
		setStopAllowed: function(stopable){
			this._isStopable = stopable;
		},
		
		//returns true if the state of the execution is stopable.
		isStopExecutionEnabled: function(){
			return this._stopEnabled;
		},
		
		setStopExecutionEnabled: function(enabled){
			this._stopEnabled = enabled;
		},
		/*
		 * Print functions
		 */
		//returns if the script support print ability
		isPrintable: function(){
			return this._isPrintable;
		},
		
		setPrintable: function(printable){
			this._isPrintable = printable;
		},
		
		//Over-ride if no confirmation dialog is needed.
		onStop: function(){
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmStop"),
				yesCallback: dojo.hitch(this,this.onStopConfirm),
				noCallback: null
			}
			var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
            dialog.setSecondaryTitle(args.title);
            dialog.open();
		},
		
		//Over-ride to call custom completion and call inherited for request update.
		onStopConfirm: function(){
			this.setCancelDisabled(true);
			this.setStopDisabled(true);
			this.parentEditor.showResultButton.setDisabled(true);
			var requestArgs = {isNew: false, id: this.requestId};
			var innerCallback = {
				callSuccess: function(obj){
					console.debug("EV: successfully completed request on stop");
				},
				callFailure: function(error){
					console.debug("EV: stop request update failed"+error.message);
				}
			}
			var responseHandler=new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");
			requestArgs.state = "com.ibm.rqm.executionframework.common.requeststate.complete";	
			ExecutionClient.postCreateRequest(responseHandler, requestArgs);
		},
		
		setCancelDisabled: function(disable){
			if(this.parentEditor.cancelButton){
				this.parentEditor.cancelButton.setDisabled(disable);
			}
		},
		
		setStopDisabled: function(disable){
			var parentEditor = this.parentEditor;
			if(parentEditor && parentEditor.stopButton && parentEditor.stopButton.setDisabled){
				parentEditor.stopButton.setDisabled(disable);
			}
		},
		//////////////////////////////////////////////////////////////////////////////////
		////////////////////Internal Functions //////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////
		
		_setCurrentServerTime: function(currentServerTime){
			this._currentServerTime = currentServerTime;
				var adapterArgs = {
					serverTime:this._currentServerTime,
					scriptType: this.script.scriptType.id,
					/*configID: this.ewiConfigId,*/
					loadingCompleteCallback: dojo.hitch(this, this._createDialog),
					onCheckedStateChange: dojo.hitch(this, this._onCheckedStateChange),
					lastSelectedAdapterExternalId: this.lastSelectedAdapterExternalId
					}
				this.adapterTable = new MachineAdapterTV(adapterArgs);
		},
		
		_createDialog: function(engineList){
			var userPref = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getAutomaticAdapterSelectionPreference();
			if(userPref && userPref.showAdapter && this.autoSelect){
				var availableAdapters = [];
				var len = engineList.length;
				for(var i=0;i<len;i++){
					var adapterInfo = engineList[i].adapterInfo;
					if(adapterInfo && (adapterInfo.health == "GREEN")){
						if(adapterInfo.requestsInQueue == 0)
							availableAdapters.push(engineList[i]);
					}
				}
				if(availableAdapters.length == 1){
					this.selectedAdapter = availableAdapters[0].adapterInfo;
					this._reserveMachine(availableAdapters[0]);
					return;
				}
			}
			
			if (!this._adapterDialog) {
				//create dialog
		        var dialogArgs = {
		            okCallback: dojo.hitch(this, "_okButtonClicked"),
		            cancelCallback: dojo.hitch(this, "_cancelButtonClicked"),
					style: "z-index: 9999;"
		        };
		        
		        var _adapterDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
		        _adapterDialog.setWidth("80%");
		        _adapterDialog.setHeight("80%");
				_adapterDialog.getOkButton().innerHTML = Constants.getMessage("labelRun");
				_adapterDialog.contentContainer.appendChild(this.adapterTable.domNode);
		        _adapterDialog.setSecondaryTitle(Constants.getMessage("labelChooseMachineForRun"));
		        _adapterDialog.getOkButton().disabled = false;
				this._adapterDialog = _adapterDialog;
			} else {
				//Clean off the selected adapter before being re-used.
				this.selectedAdapter = null;
			}			
		    this._adapterDialog.open(false);   				
		},
		_onCheckedStateChange: function(isChecked){
			if(this._adapterDialog){
				//It is possible that the dialog was not created and auto selection happened.
				if(isChecked){
					this._adapterDialog.getOkButton().disabled = false;
				}else{
					this._adapterDialog.getOkButton().disabled = true;
				}
			}	
		},
		_onHide: function(){
			if(this._adapterDialog){
				this._adapterDialog.getCancelButton().disabled = true;
				this._adapterDialog.getOkButton().disabled = true;
			}
			if(this.selectedAdapter == null)
				this._displayAlertDialog(Constants.getMessage("msgExeCancel"));
		},
		
		_okButtonClicked: function(){
			var selection = this.adapterTable.getSelectedInfo();
			if(!selection.adapterInfo){
				this._displayAlertDialog(Constants.getMessage("msgSelectAdapter"))
				return;
			}
			if(this._adapterDialog){
				this._adapterDialog.getCancelButton().disabled = true;
				this._adapterDialog.getOkButton().disabled = true;
			}
			this.selectedAdapter = selection.adapterInfo;
			this._reserveMachine(selection);
		},
		
		_reserveMachine: function(selectedInfo){
			try{
				var responseHandler = new ServiceResponseHandler(this, "onStartOfExecution", "_machineReservationFailed");
				if (selectedInfo.cellID)
					this.adapterTable.reserveCell(selectedInfo.cellID, responseHandler);
				else
					this.adapterTable.reserveMachine(selectedInfo.machineID, responseHandler);
			}catch(execp){
				console.error("exception in ExecutionViewer _reserveMachine: "+execp.message)
			}
		},

		_machineReservationFailed: function(errorObj){
			//this._displayAlertDialog(Constants.getMessage("msgMachineReservationFailed",errorObj.message));
			console.debug(Constants.getMessage("msgMachineReservationFailed",errorObj.message));
			this.onStartOfExecution(null);
		},
		
		_cancelButtonClicked: function(){
			setTimeout(dojo.hitch(this.parentEditor, "publishClosure"), 500);
		},
		////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////Remote Progress Monitor Functions///////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////
		
		_getProgressReport: function(result){
			if(this.haveLatest){
				var deferred = new dojo.Deferred();
				//use the result here to calculate the progress and return then
				if(result == "")
					result = "0:";
				this.progressPercent = result;
				deferred.callback(this.progressPercent);
				
				this.haveLatest=false;
				return deferred;
			}
			else{
				var execViewerSelf = this;
				var callbackObj = {
					success: function(items){
						var resp = "";
						resp = items;
						execViewerSelf.haveLatest=true;
						var def = execViewerSelf._getProgressReport(resp);
						execViewerSelf.responseFromService = def;
					},
					error: function(e){
						execViewerSelf._error(e);
					}				
				}
			
				var param = {
					requestId: execViewerSelf.requestId
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "error");
				ExecutionWorkItemClient.getRequestDTO(responseHandler, param);
			}
		},

		_remoteProgress: function(){
			var execViewerSelf = this;
			var timeOut = this.getPingTimeOut();
			var _timer = setInterval(function(){
				console.debug("EV:Running execution request timer...");
				/* if our page is not in view, don't waste the cycle to update the progress.
	        	 *  Suspend the refresh until we're in view again.
    	    	 */
				if (execViewerSelf.myViewUri == window.location.hash) {
					console.debug("EV:Execution request progress");	
					var report = execViewerSelf._getProgressReport();
					if(!report)
						report = execViewerSelf.responseFromService;
					if(report){
						report.addCallback(function(requests){
							var requestObject = requests ? requests[0] : null;
							if(requestObject && execViewerSelf.requestId == requestObject.id){
								execViewerSelf.latestRequestObject = requestObject;
								var percent = requestObject.progress;
								execViewerSelf.updateProgressBar(percent);
								execViewerSelf.setCurrentRequest(requestObject);
								if(percent == "100"){
									clearInterval(_timer);
									_timer = null;
								}
							}			
						});
					}
				}
			}, timeOut); 
			
			this.__timer = _timer;
		},

		_isArray: function(arr){
			return (arr.constructor.toString().indexOf("Array") != -1);
		},

		_finalizeForLog: function(resultId){
			this._resultItemId = resultId;
			var parentEditor = this.parentEditor;
			if(!parentEditor._resultId || parentEditor._resultId != resultId){
				parentEditor._resultId = resultId;
				dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, 
					Utility.startExecution(parentEditor.ewi, parentEditor.runScript, 
						parentEditor._resultId, parentEditor.requestId, parentEditor.ergId)
					]);
			}			
			parentEditor.enableNavigationToResultPage();
		},
		
		cleanUp: function(){
			if(this.__timer){
				clearInterval(this.__timer);
				delete this.__timer;
			}
			return false;
		},
		
		_error: function(errorObj) {
			if(this.__timer){
				console.error("Error in ExecutionViewer  [ " + errorObj.message + " ]")
				clearInterval(this.__timer);
				delete this.__timer;
			}
		},
		_displayAlertDialog: function(message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.open();
        },
		uninitialize: function(){
			if(this.__timer){
				clearInterval(this.__timer);
				delete this.__timer;
			}
		}
	}
);

})();
