/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function()
{	
	var ImageCache = dojo.provide("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

	ImageCache._BASE = dojo.moduleUrl("com.ibm.asq.common.web","ui/internal/view/templates/common/images/").toString();
	ImageCache._BASE_ICON = dojo.moduleUrl("com.ibm.asq.common.web","ui/internal/images/icons/").toString();

    ImageCache._getIconUri = function(imgName)
    {
        return ImageCache._BASE_ICON + imgName;
    };
	
	ImageCache._getImageUri = function(imgName)
	{
		return ImageCache._BASE + imgName;
	};
	
	ImageCache.getTypeIconURL = function(/* SimpleExtensionType */ type)
	{
		var icon = type.icon;	
		var iconImage = icon != null ? icon.substring(icon.lastIndexOf("/") + 1) : "";
		return ImageCache._BASE + iconImage;
	};
	
	ImageCache.IN_PROGRESS                  = ImageCache._getImageUri("inprogress-obj.gif");
	ImageCache.COMPLETE          			= ImageCache._getImageUri("complete_obj.gif");
	ImageCache.CLEAR_FILTER_ENABLED     = ImageCache._getImageUri("clear_enabld_co.gif");
	ImageCache.CLEAR_FILTER_DISABLED    = ImageCache._getImageUri("clear_disabld_co.gif");
    ImageCache.SORT                     = ImageCache._getImageUri("sort.gif");
	ImageCache.SORT_ASC                 = ImageCache._getImageUri("arrow-asc.gif");
	ImageCache.SORT_DSC                 = ImageCache._getImageUri("arrow-dsc.gif");
	ImageCache.REMOVE_ENABLED           = ImageCache._getImageUri("remove-enabled.gif");
	ImageCache.REMOVE_DISABLED          = ImageCache._getImageUri("remove-disabled.gif");
	ImageCache.EDIT          			= ImageCache._getIconUri("elcl16/edit.gif");
	ImageCache.SAVE          			= ImageCache._getImageUri("save.gif");
	ImageCache.WORK_ITEM				= ImageCache._getImageUri("defect.gif");
	ImageCache.TEST_PLAN                = ImageCache._getIconUri("obj16/qm_testplan16.gif");
	ImageCache.MASTER_TEST_PLAN         = ImageCache._getIconUri("obj16/qm_mastertestplan16.gif");
	ImageCache.CHILD_TEST_PLAN          = ImageCache._getIconUri("obj16/qm_childtestplan16.gif");
	ImageCache.TEST_GROUP               = ImageCache._getImageUri("testcasegroup_obj.gif");
	ImageCache.TEST_CASE                = ImageCache._getIconUri("obj16/qm_testcase16.gif");
	ImageCache.TEST_SUITE                = ImageCache._getIconUri("obj16/qm_testsuite16.gif");
	ImageCache.TEST_SCRIPT              = ImageCache._getIconUri("obj16/qm_testscript16.gif");
	ImageCache.EXECUTION_SEQ            = ImageCache._getIconUri("obj16/qm_execseq16.gif");
	ImageCache.EXECUTION_SEQ_RESULT     = ImageCache._getIconUri("obj16/qm_execseq16.gif");/*TODO:VS icon change*/
	ImageCache.TEMPLATE_CASE_ICON       = ImageCache._getIconUri("obj16/casetemplate_obj.gif");
	ImageCache.TEMPLATE_PLAN_ICON       = ImageCache._getIconUri("obj16/plantemplate_obj.gif");
	ImageCache.EWI                      = ImageCache._getIconUri("obj16/qm_execworkitem16.gif");
	ImageCache.REQUIREMENT              = ImageCache._getIconUri("obj16/qm_requirement16.gif");
	ImageCache.EWI_LOG                  = ImageCache._getImageUri("ewi-log.gif");
	ImageCache.EXECUTION_ARROW          = ImageCache._getImageUri("execution_arrow.gif");
	ImageCache.HELP                     = ImageCache._getImageUri("help.gif");
	ImageCache.TWISTIE_OPEN             = ImageCache._getImageUri("section-twistie-open.gif");
	ImageCache.TWISTIE_CLOSED           = ImageCache._getImageUri("section-twistie-closed.gif");
    ImageCache.SOLID_ARROW_OPEN         = ImageCache._getImageUri("arrow-open.gif");
    ImageCache.SOLID_ARROW_CLOSED       = ImageCache._getImageUri("arrow-closed.gif");
    ImageCache.OUTLINE_ARROW_DOWN       = ImageCache._getImageUri("outline-down.gif");
    ImageCache.OUTLINE_ARROW_UP         = ImageCache._getImageUri("outline-up.gif");
	ImageCache.FLAG_STATUS_INCOMPLETE   = ImageCache._getImageUri("incomplete_stat_obj.gif");
	ImageCache.FLAG_STATUS_REQ_NOT_COMP = ImageCache._getImageUri("reqnotcomplt_stat_obj.gif");
	ImageCache.FLAG_STATUS_DRAFT_COMP   = ImageCache._getImageUri("compltdDraft_stat_obj.gif");
	ImageCache.FLAG_STATUS_COMPLETED    = ImageCache._getImageUri("completed_stat_obj.gif");
	ImageCache.POP_OUT_EXECUTION_WINDOW = ImageCache._getImageUri("pop_out.gif");
	ImageCache.FILE_DEFECT 				= ImageCache._getImageUri("defect.gif");
	ImageCache.PASS_ICON				= ImageCache._getImageUri("pass.gif");
	ImageCache.FAIL_ICON				= ImageCache._getImageUri("fail.gif");
	ImageCache.INCON_ICON				= ImageCache._getImageUri("incon.gif");
	ImageCache.BLOCKED_ICON				= ImageCache._getImageUri("blocked.gif");
	ImageCache.ERROR_ICON				= ImageCache._getImageUri("error.gif");
	ImageCache.EXPAND_PLUS              = ImageCache._getImageUri("expand-plus.gif");
	ImageCache.EXPAND_MINUS             = ImageCache._getImageUri("expand-minus.gif");
    ImageCache.ATTACHMENT               = ImageCache._getImageUri("attachment.gif");
	ImageCache.ATTACH_IMAGE             = ImageCache._getImageUri("attachImage.gif");
    ImageCache.COPY_ICON                = ImageCache._getImageUri("copy.gif");
    ImageCache.PROGRESS                 = ImageCache._getImageUri("progress.gif");	
	ImageCache.VIEW_PROGRESS            = ImageCache._getImageUri("view_progress.gif");	
    ImageCache.PRIORITYLOW_ICON         = ImageCache._getImageUri("priority_low_obj.gif");
    ImageCache.PRIORITYMED_ICON         = ImageCache._getImageUri("priority_med_obj.gif");
    ImageCache.PRIORITYHIGH_ICON        = ImageCache._getImageUri("priority_high_obj.gif");	
	ImageCache.CONFIGURATION_ICON		= ImageCache._getImageUri("configurationIcon.gif");//TODO: Change to the image provided by UX once received.
	ImageCache.COLLAPSE_HOV_ICON        = ImageCache._getIconUri("elcl16/collapse_hov.gif");
	ImageCache.COLLAPSE_ICON            = ImageCache._getIconUri("elcl16/collapse.gif");
	ImageCache.EXPAND_HOV_ICON          = ImageCache._getIconUri("elcl16/expand_hov.gif");
	ImageCache.EXPAND_ICON              = ImageCache._getIconUri("elcl16/expand.gif");
	ImageCache.DELETE					= ImageCache._getIconUri("elcl16/delete.gif");
	ImageCache.DDELETE					= ImageCache._getIconUri("dlcl16/remove-disabled.gif");
	ImageCache.REFRESH_RED				= ImageCache._getIconUri("elcl16/rfs_red.gif");
	ImageCache.REFRESH_GREEN			= ImageCache._getIconUri("elcl16/rfs_green.gif");
	ImageCache.REFRESH_YELLOW			= ImageCache._getIconUri("elcl16/rfs_yellow.gif");
    ImageCache.EDIT_FIELD_ICON          = ImageCache._getIconUri("elcl16/edit_field.gif");
	ImageCache.BULK_CHANGE              = ImageCache._getIconUri("elcl16/bulkchange.gif");
	ImageCache.ADD_ICON_ENABLED         = ImageCache._getIconUri("elcl16/add.gif");
	ImageCache.ADD_ICON_DISABLED        = ImageCache._getIconUri("dlcl16/add.gif");
    ImageCache.RESTORE_ICON_ENABLED     = ImageCache._getIconUri("elcl16/restore.gif");
    ImageCache.RESTORE_ICON_DISABLED    = ImageCache._getIconUri("dlcl16/restore.gif");
	ImageCache.WARNING_ICON             = ImageCache._getIconUri("elcl16/warning.gif");
	ImageCache.CONNECTION_ICON          = ImageCache._getIconUri("elcl16/connection.gif");
	ImageCache.PAUSE_ICON				= ImageCache._getIconUri("elcl16/pause.gif");
	ImageCache.RESUME_ICON				= ImageCache._getIconUri("elcl16/resume.gif");
    ImageCache.FIRST_PAGE_ICON          = ImageCache._getIconUri("elcl16/firstpage.gif");
    ImageCache.LAST_PAGE_ICON           = ImageCache._getIconUri("elcl16/lastpage.gif");
    ImageCache.NEXT_PAGE_ICON           = ImageCache._getIconUri("elcl16/shownext.gif");
    ImageCache.PREV_PAGE_ICON           = ImageCache._getIconUri("elcl16/showprevious.gif");
	ImageCache.REQ_NORMAL				= ImageCache._getIconUri("obj16/req_normal.gif");
	ImageCache.REQ_UPDATED				= ImageCache._getIconUri("obj16/req_updated.gif");
	ImageCache.REQ_REMOVED				= ImageCache._getIconUri("obj16/req_removed.gif");
	ImageCache.TESE_SUSPECT 			= ImageCache._getIconUri("obj16/case_suspect.gif");
	ImageCache.TESE_NONE_SUSPECT		= ImageCache._getIconUri("obj16/case_nonsuspect.gif");	
	ImageCache.MOVE_UP_ICON_ENABLED     = ImageCache._getIconUri("etool16/arrow-up.gif");
	ImageCache.MOVE_DOWN_ICON_ENABLED   = ImageCache._getIconUri("etool16/arrow-down.gif");
    ImageCache.DEFAULT_TEMPLATE_ICON    = ImageCache._getIconUri("etool16/defaulttemplate.gif");
	ImageCache.REQUEST                  = ImageCache._getIconUri("obj16/rtlm_request16.gif");
	ImageCache.RESERVATION              = ImageCache._getIconUri("obj16/rtlm_reserve16.gif");
	ImageCache.MACHINE                  = ImageCache._getIconUri("obj16/rtlm_machine16.gif");
	ImageCache.VIRTUALIMAGE             = ImageCache._getIconUri("obj16/rtlm_virtualimg16.gif");
	ImageCache.MACHINEGROUP             = ImageCache._getIconUri("obj16/rtlm_machinegrp16.gif");
	ImageCache.SEVERITY_BLOCKER         = ImageCache._getIconUri("obj16/sev_blocker.gif");
	ImageCache.SEVERITY_CRITICAL        = ImageCache._getIconUri("obj16/sev_critical.gif");
	ImageCache.SEVERITY_MAJOR           = ImageCache._getIconUri("obj16/sev_major.gif");
	ImageCache.SEVERITY_NORMAL          = ImageCache._getIconUri("obj16/sev_normal.gif");
	ImageCache.SEVERITY_MINOR           = ImageCache._getIconUri("obj16/sev_minor.gif");
	ImageCache.SEVERITY_UNCLASSIFIED    = ImageCache._getIconUri("obj16/sev_unclassified.gif");
	ImageCache.ARCHIVE_ICON_DISABLED	= ImageCache._getIconUri("elcl16/archive.gif");
	ImageCache.ARCHIVE_ICON_ENABLED		= ImageCache._getIconUri("elcl16/archive_hov.gif");
	ImageCache.REQT_ASSIGNED            = ImageCache._getIconUri("obj16/reqt_assigned.gif");
	ImageCache.REQT_COMPLETE            = ImageCache._getIconUri("obj16/reqt_complete.gif");
	ImageCache.REQT_DRAFT               = ImageCache._getIconUri("obj16/reqt_draft.gif");
	ImageCache.REQT_RETURNED            = ImageCache._getIconUri("obj16/reqt_returned.gif");
	ImageCache.REQT_SUBMITTED           = ImageCache._getIconUri("obj16/reqt_submitted.gif");
	ImageCache.REQT_CLOSED              = ImageCache._getIconUri("obj16/reqt_closed_obj.gif");
	ImageCache.RISK_LEVEL               = ImageCache._getIconUri("elcl16/risklevel.gif");
	ImageCache.COMMU_LEVEL              = ImageCache._getIconUri("elcl16/communityBackground.gif");
	ImageCache.NO_COMMU_LEVEL           = ImageCache._getIconUri("elcl16/noCommunityBackground.gif");
	ImageCache.ENGINE_AVAILABLE			= ImageCache._getImageUri("health_good.gif");
	ImageCache.ENGINE_NOTAVAILABLE		= ImageCache._getImageUri("health_bad.gif");
	ImageCache.ENGINE_NOTRESPONDED		= ImageCache._getImageUri("health_conditional.gif");
	ImageCache.NOIMAGE					= ImageCache._getImageUri("spacer.gif");
	ImageCache.BLOCKING_DEFECT			= ImageCache._getImageUri("blocking_defect.gif");
	ImageCache.ADD_NEW_CASE             = ImageCache._getIconUri("elcl16/AddNewTestCase.gif");
	ImageCache.TEST_CELL	             = ImageCache._getIconUri("obj16/rtlm_testcell16.gif");
	ImageCache.RISK_SELECTED            = ImageCache._getIconUri("elcl16/risk-selected_obj.gif");
	ImageCache.RISK_READONLY            = ImageCache._getIconUri("elcl16/risk-read-only_obj.gif");
	ImageCache.RISK_UNSELECT            = ImageCache._getIconUri("elcl16/risk-unselect_obj.gif");
	ImageCache.RISK_IMPORT_SELECTED     = ImageCache._getIconUri("elcl16/importance_selected_obj.gif");
	ImageCache.RISK_IMPORT_UNSELECTED   = ImageCache._getIconUri("elcl16/importance_unselected_obj.gif");
	ImageCache.RISK_COMMUNITY	        = ImageCache._getIconUri("elcl16/communityrisk_obj.gif");
	ImageCache.RISK_MYRANKING           = ImageCache._getIconUri("elcl16/myrisk_obj.gif");
	ImageCache.RISK_CALCULATED          = ImageCache._getIconUri("elcl16/calculatedrisk_obj.gif");
	ImageCache.RISK_BORDER              = ImageCache._getIconUri("elcl16/risk_endcap-1x9.gif");
	ImageCache.RISK_LEVELS              = new Array(ImageCache._getIconUri("elcl16/risklevel0.gif"),
													ImageCache._getIconUri("elcl16/risklevel1.gif"),
													ImageCache._getIconUri("elcl16/risklevel2.gif"),
													ImageCache._getIconUri("elcl16/risklevel3.gif"),
													ImageCache._getIconUri("elcl16/risklevel4.gif"),
													ImageCache._getIconUri("elcl16/risklevel5.gif"));
	ImageCache.RISK_LEVELS_READONLY     = new Array(ImageCache._getIconUri("elcl16/risklevel0_readonly.gif"),
													ImageCache._getIconUri("elcl16/risklevel1_readonly.gif"),
													ImageCache._getIconUri("elcl16/risklevel2_readonly.gif"),
													ImageCache._getIconUri("elcl16/risklevel3_readonly.gif"),
													ImageCache._getIconUri("elcl16/risklevel4_readonly.gif"),
													ImageCache._getIconUri("elcl16/risklevel5_readonly.gif"));	
	ImageCache.DATAPOOL 				= ImageCache._getIconUri("obj16/qm_datapool16.gif");
	ImageCache.BUILD_RECORD				= ImageCache._getIconUri("obj16/qm_buildrecord16.gif");
	ImageCache.BUILD_DEF				= ImageCache._getIconUri("obj16/qm_builddef16.gif");
	ImageCache.KEYWORD					= ImageCache._getIconUri("obj16/keyword.gif");
	ImageCache.TEST_ENVIRONMENT         = ImageCache._getIconUri("obj16/rtlm_config16.gif");									
	
}
)();
