/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function()
{	
	var ImageCache = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");

	ImageCache._BASE= dojo.moduleUrl("com.ibm.rqm.planning.web","ui/internal/view/templates/common/images/").toString();

	ImageCache._getImageUri = function(imgName)
	{
		return ImageCache._BASE + imgName;
	};
	
	ImageCache.getTypeIconURL = function(/* SimpleExtensionType */ type)
	{
		var icon = type.icon;	
		var iconImage = icon != null ? icon.substring(icon.lastIndexOf("/") + 1) : "";
		return ImageCache._BASE + iconImage;
	};
	
	ImageCache.CLEAR_FILTER_ENABLED     = ImageCache._getImageUri("clear_enabld_co.gif");
	ImageCache.CLEAR_FILTER_DISABLED    = ImageCache._getImageUri("clear_disabld_co.gif");
	ImageCache.SORT_ASC                 = ImageCache._getImageUri("arrow-asc.gif");
	ImageCache.SORT_DSC                 = ImageCache._getImageUri("arrow-dsc.gif");
	ImageCache.REMOVE_ENABLED           = ImageCache._getImageUri("remove-enabled.gif");
	ImageCache.REMOVE_DISABLED          = ImageCache._getImageUri("remove-disabled.gif");
	ImageCache.EDIT          			= ImageCache._getImageUri("EditIcon.jpg");
	ImageCache.SAVE          			= ImageCache._getImageUri("save.gif");
	ImageCache.WORK_ITEM				= ImageCache._getImageUri("defect.gif");  //TODO change to the correct image, which is currently used by TEST_PLAN
	ImageCache.TEST_PLAN                = ImageCache._getImageUri("testplan_obj.gif");
	ImageCache.TEST_GROUP               = ImageCache._getImageUri("testcasegroup_obj.gif");
	ImageCache.TEST_CASE                = ImageCache._getImageUri("testcase_obj.gif");
	ImageCache.TEST_SUITE                = ImageCache._getImageUri("testsuite_obj.gif");
	ImageCache.TEST_SCRIPT              = ImageCache._getImageUri("testscript_obj.gif");
	ImageCache.EWI                      = ImageCache._getImageUri("executionwork_obj.gif");
	ImageCache.EWI_LOG                  = ImageCache._getImageUri("ewi-log.gif");
	ImageCache.EXECUTION_ARROW          = ImageCache._getImageUri("execution_arrow.gif");
	ImageCache.HELP                     = ImageCache._getImageUri("help.gif");
	ImageCache.TWISTIE_OPEN             = ImageCache._getImageUri("section-twistie-open.gif");
	ImageCache.TWISTIE_CLOSED           = ImageCache._getImageUri("section-twistie-closed.gif");
	ImageCache.FLAG_STATUS_INCOMPLETE   = ImageCache._getImageUri("incomplete_stat_obj.gif");
	ImageCache.FLAG_STATUS_REQ_NOT_COMP = ImageCache._getImageUri("reqnotcomplt_stat_obj.gif");
	ImageCache.FLAG_STATUS_DRAFT_COMP   = ImageCache._getImageUri("compltdDraft_stat_obj.gif");
	ImageCache.FLAG_STATUS_COMPLETED    = ImageCache._getImageUri("completed_stat_obj.gif");
	ImageCache.POP_OUT_EXECUTION_WINDOW = ImageCache._getImageUri("pop_out.gif");
	ImageCache.FILE_DEFECT 				= ImageCache._getImageUri("defect.gif");
	ImageCache.COMMENT				 	= ImageCache._getImageUri("comment.gif");
	ImageCache.COMPARE				 	= ImageCache._getImageUri("pastecompare.gif");
	ImageCache.PASS_ICON				= ImageCache._getImageUri("Pass.gif");
	ImageCache.FAIL_ICON				= ImageCache._getImageUri("Fail.gif");
	ImageCache.INCON_ICON				= ImageCache._getImageUri("Incon.gif");
	ImageCache.EXPAND_PLUS              = ImageCache._getImageUri("expand-plus.gif");
	ImageCache.EXPAND_MINUS             = ImageCache._getImageUri("expand-minus.gif");
	ImageCache.ATTACHMENT				= ImageCache._getImageUri("attachment.gif");
	ImageCache.COPY_ICON				= ImageCache._getImageUri("copy.gif");
	ImageCache.PROGRESS					= ImageCache._getImageUri("progress.gif");
	ImageCache.GRID_PLACEHOLDER			= ImageCache._getImageUri("PlaceholderIconsForGrid.gif");
	ImageCache.GRID_ADDROW				= ImageCache._getImageUri("AddRowIcon.gif");
	ImageCache.GRID_DELETEROW			= ImageCache._getImageUri("deleteRowIcon.gif");
	ImageCache.DROPDOWN_ARROW			= ImageCache._getImageUri("dropdownarrow.gif");
	
//	ImageCache.ENGINE_AVAILABLE						= ImageCache._getImageUri("engine_available.gif");
//	ImageCache.ENGINE_NOTAVAILABLE					= ImageCache._getImageUri("engine_notavail.gif");
//	ImageCache.ENGINE_NOTRESPONDED					= ImageCache._getImageUri("engine_notresponded.gif");
}
)();
