/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea");

dojo.require("dijit.TitlePane");

(function() 
{
var _textContent=dojo.isIE?"innerText":"textContent"; 

dojo.declare("com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea",
dijit.TitlePane,
{
    templateString: '<div id="${id}" dojoAttachPoint="domNode" class="com-ibm-asq-common-web-ui-simple-collapsible-area">' +
                    '  <div dojoAttachEvent="onclick:toggle,onkeypress:_onTitleKey" tabindex="0" waiRole="button" class="header" dojoAttachPoint="focusNode">' +
                    '    <div class="header-left">' +
                    '      <div class="header-right">' +
                    '        <div class="header-mid">' +
                    '          <div class="title-container">' +
                    '            <span dojoAttachPoint="titleNode" class="title" style="white-space:nowrap"></span>' +
                    '          </div>' +
                    '        </div>' +
                    '      </div>' +
                    '    </div>' +
                    '  </div>' +
                    '  <div class="content-outer-container" dojoAttachPoint="hideNode">' +
                    '    <div class="content-inner-container" dojoAttachPoint="wipeNode">' +
                    '      <div class="content-area" dojoAttachPoint="containerNode,contentNode" waiRole="region" tabindex="-1"></div>' +
                    '      <div class="content-bottom-container">' +
                    '        <div class="content-bottom-left">' +
                    '          <div class="content-bottom-right">' +
                    '            <div class="content-bottom-mid">' +
                    '            </div>' +
                    '          </div>' +
                    '        </div>' +
                    '      </div>' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',

    collapsible: true, // yes, we allow setting it not collapsible
    
    postCreate: function() {
        this.arrowNodeInner = document.createElement("div");
        this.inherited('postCreate', arguments);
    },
    
    _onTitleClick: function() {
        this.toggle();
    },

    toggle: function(event){
        /* override the method to allow non-collapsible pane */
        if (this.collapsible) {
            this.inherited('toggle', arguments);
        }
        if(event){
            dojo.stopEvent(event);
        }
    }

});

dojo.declare("com.ibm.asq.common.web.ui.internal.view.common.ActionLinkCollapsibleArea",
com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea,
{
    _actionListNode: null,

	
	_varWidth: "", 
	
	_times: 0,
	
    postCreate: function() {
        this.inherited('postCreate', arguments);
        this._actionListNode = document.createElement("ul");
        dojo.addClass(this._actionListNode, "com-ibm-asq-common-web-ui-view-action-link-button");
        this.containerNode.appendChild(this._actionListNode);
		
		this.connect(this.domNode, "onscroll", "_onscroll");
    },
    uninitialize: function() {
    	if (this._buttonList){
	    	var n=this._buttonList.length;
    		var _b=this._buttonList;
	    	while(n--) {
    			_b[n].destroy();
    		}
	    	delete this._buttonList;
    	}
    },
	_onscroll: function(){
		var _varWidth;
		if (this._times == 0 ){
			_varWidth = this.domNode.scrollWidth + "px";
			this._times=1;
		}
	
		var i=0;
		var childNodes = this.domNode.childNodes;
		var length = childNodes.length;
		for ( i=0; i<length; i++)
		{
			var ele = childNodes[i];
		    if(ele.tagName == "DIV"){
				ele.style.width = _varWidth;
			}
		} 
	},
	
    addActionLink: function(handler, label, callbackData, /* optional */ iconClass, /* optional */ anchorAsLink, /* optional */ ignoreHandler) {
		if (anchorAsLink){
			// Use <a> to construct the action link.
			var anchor = document.createElement("a");
			anchor[_textContent]=label;
			anchor.target = "_blank";
			
			dojo.addClass(anchor, "com-ibm-asq-common-web-ui-action-link-button");
			if(ignoreHandler == false){
				this.connect(anchor, 'onclick', function(){
					handler(callbackData);
				});
			}
			
			var item = document.createElement("li");
	        item.appendChild(anchor);
			
			this._actionListNode.appendChild(item);
			return anchor;
		} else {
			// Use dojo button to construct the action link.
			var arg = {
	            label: label,
	            onClick: function() {
	                this.clientCallback(this.callbackData);
	            },
	            'class': "com-ibm-asq-common-web-ui-action-link-button"
	        };
	        
	        if (iconClass) {
	            arg['iconClass'] = iconClass;
	        }
	        var button = new dijit.form.Button(arg);
	        if (!this._buttonList){
	        	this._buttonList=[];
	        }
	        this._buttonList.push(button);
	        // store the client callback and data into the button
	        button.clientCallback = handler;
	        button.callbackData = callbackData;
	        
	        var item = document.createElement("li");
	        item.appendChild(button.domNode);
	
	        this._actionListNode.appendChild(button.domNode);
	        return button;
		}
    },
	
	getActionsNode: function() {
		return this._actionListNode;
	}
});
})();
