//STS
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common.StepTypeSelector");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common.StepTypeSelector");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordSelectionTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function() {
	var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
	var CSHelp 							= com.ibm.asq.common.web.ui.internal.util.CSHelp;	
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var TestRecordSelectionTableView	= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordSelectionTableView;
	var ASQUtility						= com.ibm.asq.common.web.ui.internal.util.Utility;
	var Utility 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility;
    
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common.StepTypeSelector", [dijit._Widget, dijit._Templated],
{
		       templateString: "<div class=\"com-ibm-rqm-construction-newitem-popup\">" +
                        	"<div dojoAttachPoint=\"_topMessageNode\" width=\"100%\"></div>" +
                			"<div>${msgChoseStepToAdd}</div>"+
							"<table width=\"100%\">" +
                				"<tr>" +
                					"<td width=\"150px\"><span>"+ 
                					"<input type=\"radio\" dojoAttachPoint=\"_testSuite\"></input>&nbsp;&nbsp;${labelAddSuite}<br/>"+
									"<input type=\"radio\" dojoAttachPoint=\"_testER\"></input>&nbsp;&nbsp;${labelAddTER}<br/>"+
									"<input type=\"radio\" dojoAttachPoint=\"_automation\"></input>&nbsp;&nbsp;${labelAutomation}</span>"+
									"</td>" +
                				"</tr>" + 
                        	"</table>" +
							"<div dojoAttachPoint=\"_detailNode\"></div>"+
                        "</div>",
 
 		width: "80%",
 		labelAutomation: Constants.getMessage("labelAutomation"),
 		labelAddTER: Constants.getMessage("labelAddTER"),
		labelAddSuite: Constants.getMessage("labelAddSuite"),
		msgChoseStepToAdd: Constants.getMessage("msgChoseStepToAdd"),
		
		postCreate: function(){
			dojox.data.dom.removeChildren(this._detailNode);
			this.connect(this._automation, "onclick", this._automationClicked);
			this.connect(this._testSuite, "onclick", this._testSuiteClicked);
			this.connect(this._testER, "onclick", this._testERClicked);
			var dialogArgs = {
				okCallback: dojo.hitch(this, "_onOk"),
				isClosable: true,
				primaryTitle: Constants.getMessage("labelChoseStepType")				
			}
			var selectorDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			selectorDialog.setWidth(this.width);
 			var cshelp = new CSHelp({contextID: "execution_addstep.html"});
            cshelp.setButtonLabel(Constants.getMessage("execution_addstepCSHelp"));		
		    selectorDialog.setSecondaryTitleNode(cshelp.domNode);				
			selectorDialog.contentContainer.appendChild(this.domNode);
			
			selectorDialog.getOkButton().disabled = false;
			this.okButton = selectorDialog.getOkButton();
			selectorDialog._onClose = function(){
				this.destroy();//dont destroy recursive;
			};
			selectorDialog.open(false);
			
			var modsNeeded = [];
			modsNeeded.push("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView");
			modsNeeded.push("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");
			modsNeeded.push("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
			Utility.loadModules(modsNeeded);
			this._testSuiteClicked();//For initial loading and rendering		
		},
		
		_automationClicked: function(){
			this._automation.checked = true;
			this._testSuite.checked = false;
			this._testER.checked = false;
			if(!dojo.getObject("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView"))
				jazz.core.internal.loader.load_async("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView", dojo.hitch(this, "_fetchAutomation"));
			else
				this._fetchAutomation();	
		},
		
		_testSuiteClicked: function(){
			this._automation.checked = false;
			this._testSuite.checked = true;
			this._testER.checked = false;
			if(!dojo.getObject("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient"))
				jazz.core.internal.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", dojo.hitch(this, "_fetchSuites"));
			else
				this._fetchSuites();
		},
		
		_testERClicked: function(){
			this._automation.checked = false;
			this._testSuite.checked = false;
			this._testER.checked = true;
			if(!dojo.getObject("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient"))
				jazz.core.internal.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", dojo.hitch(this, "_fetchEWIs"));
			else
				this._fetchEWIs();	
		},
		
		_fetchAutomation: function(){
		    this.cleanUpNode(this._detailNode);
			this.automationView = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView({insideEditor: true, okButton: this.okButton});
			this.automationView.viewHeaderNode.viewHeaderBackNode.style.display = 'none';
			this.automationView.viewHeaderNode.containerNode.style.padding = "0px";			
			this._detailNode.appendChild( this.automationView.domNode );
		},
		
		_fetchEWIs: function(){
			this.recordType = Constants.MODEL_TYPE_EWI;
            this._createRecordSelectionTable();
		},
	
		_fetchSuites: function(){
			this.recordType = Constants.MODEL_TYPE_SUITE;
            this._createRecordSelectionTable();
		},
		
		_createRecordSelectionTable: function(){			
            this.cleanUpNode(this._detailNode);
            
            var serviceClient = this.recordType == Constants.MODEL_TYPE_SUITE ? 
                dojo.hitch(com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient, "searchTestSuites") :
                dojo.hitch(com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient, "searchExecutionWorkItem");
                
			var args = {
				recordType: this.recordType,
                queryServiceCall: serviceClient, 
				okButton: this.okButton
			}
			this.recordTable = new TestRecordSelectionTableView(args);
			this.recordTable.initialize();
			this._detailNode.appendChild(this.recordTable.domNode);
		},
		
		_onOk: function(){
			var type = this._automation.checked ?  Constants.TYPE_AUTOMATION : Constants.TYPE_TEST;
			var attributes = this._automation.checked ?  this.getAutomationAttributes() : this.getTestAttributes();
			this.okCallback({type: type, attributes: attributes});
		},
		
		getAutomationAttributes: function(){
			var currentSelection = this.automationView.getCurrentSelectionFromTables();
			var attributes = {
				type: Constants.TYPE_AUTOMATION,
				automation: currentSelection
			}
			return attributes;
		},
		
		getTestAttributes: function(){
			var records = this.recordTable.getSelectedItems();
			var attributes = {
				type: this.recordTable.getRecordType(),
				record: records
			}
			return attributes;
		},
	
		cleanUpNode: function(node){
			if(node){
				ASQUtility.destroyWidgetsFromNode(node);
				dojox.data.dom.removeChildren(node);	
			}
		},
		
		_error: function(errorObj){
			console.error("Error in StepTypeSelector " + errorObj.message);
		}
	}
);
}
)();
		
