/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009,2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
// Summary: This is a widget to choose options.
//

dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel");

dojo.require( "dijit._Widget" );
dojo.require( "dijit._Templated" );


(function() {
dojo.declare(
    "com.ibm.rqm.planning.web.ui.internal.view.common.properties.FilterListPanel",
    [dijit._Widget, dijit._Templated],
{
	
	templateString: '<div id="${id}" dojoAttachPoint="domNode" tabindex="-1">' +
					' <table border="0" style="width:100%">' +
					'  <tr>' +
					'    <td style="width:100%">'+
					'       <label><input type="text" dojoAttachPoint="filterBox" size="29" style="width: 100%" dojoAttachEvent="onkeyup:_onFilterChange"></label>'+
					'    </td>' +
					'  </tr>' +
					'  <tr>' +
					'    <td style="width:100%">'+
					'      <label><select dojoAttachPoint="selectionList" name="selectionList" style="width: 100%" multiple=false size="10" dojoAttachEvent="onchange: _onChange">' +
					'      </select></label>' +
					'    </td>' +
					'  </tr>'+
					'</table>'+
	                '</div>',
		
		postCreate :function()
		{
			this.inherited("postCreate", arguments);
			this.changeListener = null;
			this.selectionList.multiple = false;
			this.filterBox.style.border =  "1px solid #69AAAA";
			this.selectionList.style.border =  "1px solid #69AAAA";
			
		},
		
		
		addOption: function(id, name, description)
		{
			if( !this.options )
			{
				this.options = new Array();
			}
			this.options.push(new FilterListPanel.Option( id, name, description ));
			this._showOption(id, name)
		
		},
		
		addChangeLisner: function(listener) {
			if (listener)
				this.changeListener = listener;
		},
		
		getFirstSelectedValue: function() {
			for (var i = 0; i < this.selectionList.options.length; i++)	{
				if (this.selectionList.options[i].selected == true)	{
					return this.selectionList.options[i].value;
				}
			}
			return null;
		},
		
		getSelectedItems: function()
		{
			var retVal = new Array();
			
			for (var i = 0; i < this.selectionList.options.length; i++)
			{
				if (this.selectionList.options[i].selected == true)
				{
					var id = this.selectionList.options[i].value;
					var name = this.selectionList.options[i].text;
					retVal.push(new FilterListPanel.Option(id, name));
				}
			}
			return retVal;
		},
		
		getOptions: function()
		{
		  return this.selectionList.options;
		},
		
		setMultiSelect :function(value)
		{
			this.selectionList.multiple=value;
		},
		
		selectItem : function(item)
		{
			this.selectionList.selectedIndex = item;
		},
		
		_showOption :function(id, displayName)
		{
			var option = new Option( displayName, id );
			
			if(option)
				option.title = displayName;
			
			this.selectionList.options[ this.selectionList.options.length ] = option;
		},
		
		
		_onFilterChange :function()
		{
			var str = this.filterBox.value;
			this._clearList();
			this._doFilter(str);
			if(this.changeListener)
				this.changeListener();
		},
		
		_clearList:function()
		{
			for (var i =0; i < this.selectionList.options.length; )
				this.selectionList.remove(0);
		},
		
		_doFilter: function(filter)
		{
			for (var i=0; i < this.options.length; i++)
			{
				var ItemLabel = this.options[i].name;
				if (ItemLabel.indexOf(filter) >= 0)
					this._showOption(this.options[i].id, ItemLabel);
			}
		},
		
		_onChange: function()
		{
			for (var i = 0; i < this.selectionList.options.length; i++)
			{
				if (this.selectionList.options[i].selected == true)
				{
					this.filterBox.value = this.selectionList.options[i].text;
				}
			}
			if(this.changeListener)
				this.changeListener();
		}
}
);
		
dojo.declare( "FilterListPanel.Option", null,
{
	id: null,
	name: "",
	description: "",	
	constructor: function(id, name, description )
	{
		this.name = name;
		this.id = id;
		this.description=description;
	} 	
}	
);
})();
