/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIConfigurationPanel");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIConfigurationPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationPanel");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIOverviewSection");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection");
dojo.require("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var TestConfigurationUtil 			= com.ibm.rqm.configuration.web.util.TestConfigurationUtil;
    var GenerateEWIOverviewSection 		= com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIOverviewSection;
    var GenerateEWIEnvironmentSection 	= com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection;
	var PropertiesSection 				= com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection;
	var CSHelp 							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
	var Constants  						= com.ibm.rqm.planning.web.client.internal.Constants;
	var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIConfigurationPanel", [dijit._Widget, dijit._Templated, com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationPanel], {
        
        constructor: function(args, frag){
            this.testCases = args.testCases;
			this.parentTestPlan = args.parentTestPlan;
        },
		
		//Overriden from ConfigurationPanel
		uninitialize: function(){
//			console.debug("===============GenerateEWIConfigurationPanel Uninitialize");
			this._environmentWidget.destroyRecursive();
			this._overviewWidget.destroyRecursive();
			this._tcgWidget.destroyRecursive();
		},
        
		//Overriden from ConfigurationPanel
        _initTitle: function(){
            this._title.appendChild(document.createTextNode(Constants.getMessage("labelGenerateEWI")));
			if(this.testCases.length == 1){
				this._titleName.appendChild(document.createTextNode(this.testCases[0].name));
			}else{
				this._titleName.appendChild(document.createTextNode(Constants.getMessage("labelTestCases")));
			}
        },
        
		//Overriden from ConfigurationPanel
        _initOverview: function(){
            dojox.data.dom.removeChildren(this._ewiOverview);
            this._overviewWidget = new GenerateEWIOverviewSection({
                controller: this.controller,
                testCases: this.testCases ? this.testCases : null,
				parentTestPlan: this.parentTestPlan ? this.parentTestPlan : null
            });
            this._ewiOverview.appendChild(this._overviewWidget.domNode);
        },
		
		//Overriden from ConfigurationPanel
		_initTCG: function(){
            dojox.data.dom.removeChildren(this._tCG);
            this._tcgWidget = new PropertiesSection({
                controller: this.controller,
				showWorkItemDistribution: (this.testCases.length == 1) ? false : true
            });
            this._tCG.appendChild(this._tcgWidget.domNode);
        },
        
        //Overriden from ConfigurationPanel
        _initEnvironment: function(){
            var self = this;
            var disableCoverageOptions = function(){
                self._tcgWidget.disableSelectOptions("coverage", [1]);
            };
            var enableCoverageOptions = function(number){
                self._tcgWidget.enableSelectOptions("coverage", number);
            };
            dojox.data.dom.removeChildren(this._environment);
            this._environmentWidget = new GenerateEWIEnvironmentSection({
                controller: this.controller,
                disableCoverageOptions: disableCoverageOptions,
                enableCoverageOptions: enableCoverageOptions,
				enableNextButton: dojo.hitch(this, "enableNextButton"),
				testCases: this.testCases ? this.testCases : null,
				parentTestPlan: this.parentTestPlan ? this.parentTestPlan : null
            });
            this._environment.appendChild(this._environmentWidget.domNode);
			this._environmentWidget.initialize();
        },
        
        //Overriden from ConfigurationPanel
        onNext: function(){
//            if (this._environmentWidget.getResourceInfo().length == 0) {
//                alert("Please select one or more environment attributes!");
//                return;
//            }
//                else 
                    if (this._environmentWidget.advancePropertiesPopupWindow && this._environmentWidget.checkEnviromentAndProperties()) {
                        var alertDialog = new AlertDialog({
			                'message': Constants.getMessage("msgConfilictConfiguration")
			            });
			            alertDialog.setSecondaryTitle("");
			            alertDialog.open();
                        return;
                    }
                    else {
						var testPlan = this._overviewWidget.getTestPlan();
                        var params = {
                            owner: this._overviewWidget.getOwner(),
                            interactionLevel: this._tcgWidget.getCoverage(),
                            coverageTarget: "100",
                            executionEnvTypes: this._environmentWidget.getExecutionEnvTypes(),
                            resourceInfomation: this._environmentWidget.getResourceInfomation(),
                            weightsJsonString: this._environmentWidget.getWeightings(),
                            isRandomSelectCase: this._tcgWidget.getWorkItemDistribution(),
                            excludes: this._environmentWidget.getExclusions(),
                            includes: this._environmentWidget.getInclusions(),
							testCases: this.testCases,
							testPhase: (testPlan != TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN) ? this._overviewWidget.getTestPhase() : null,
							parentTestPlanUUID: (testPlan) ? testPlan.versionableItemId : -1,
							parentTestPlan: testPlan,
							existingConfigurations: this._environmentWidget.getExistingConfigurations()
                        };
                        
                        this.controller.doNext(params);
                    }
        },
        
        _error: function(errorObj){
            alert("Error: (message: '" + errorObj.message + "') from GenerateEWIConfiguration#_error");
        }
    });
    
})();
