/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotDialog");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    
    /**
     *
     */
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/SnapshotDialog.html"),
		
		labelSnapshotNameRequired: Constants.getMessage("labelSnapshotNameRequired"),
		labelsnapshotname: Constants.getMessage("labelSnapshotName"),
		labeldescription: Constants.getMessage("labeldescription"),
        labelOk: Constants.getMessage("labelOk"),
		labelCancel: Constants.getMessage("labelCancel"),

        width: "600px",
        title: Constants.getMessage("labelCreateNewSnapshot"),
		
        constructor: function(args) {
            this.onOk = null;
            this.onCancel = null;
        },
		
		postCreate: function() {     
            if (!dojo.isFunction(this.onOk)) {
                throw new Error("Missing function for 'onOk' parameter");
            }		
            if (!dojo.isFunction(this.onCancel)) {
                throw new Error("Missing function for 'onOk' parameter");
            }				
			// this doesn't work
			// this._name.focus();
			this._showAsDialog();
			setTimeout(dojo.hitch(this, "_setInitialFocus"), 250);
		},
		
		_setInitialFocus: function() {
			this._name.focus();
		},
		
        _showAsDialog: function(){
            var dialogArgs = {
				primaryTitle: this.title,
                okCallback: dojo.hitch(this, "_onOk"),
                cancelCallback: dojo.hitch(this, "_onCancel")
            };
            
            this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this.floatingPane.setWidth(this.width);
            this.floatingPane.contentContainer.appendChild(this.domNode);
            this.floatingPane.getOkButton().disabled = false;    
            this.floatingPane.open();      
        },		
		
        _onCancel: function(e){
            this.onCancel();
             if(e){
                dojo.stopEvent(e);
            }
        },
		
        _onOk: function(e){
			if (this._name.value==null || dojo.trim(this._name.value).length==0) {
				this._nameRequired.style.display="inline";
			} else {
	            //this._object[this.onOk].call(this._object, this._name.value, this._description.value);
				this.onOk(this._name.value, this._description.value);
			}
			if(e){
                dojo.stopEvent(e);
            }
        },
		
		_onKeyup: function(e){
/*
enter key on any one of the text fields should not close the dialog 
			if (e.keyCode == dojo.keys.ENTER){
				//this._onOk();
				this.floatingPane.getOkButton().onclick();
			}
*/
            if(e){
                dojo.stopEvent(e);
            }
		}
        
    });
})();
