/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("jazz.core.loader");

// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SectionWorkItem");
dojo.require("com.ibm.rqm.planning.web.client.internal.WorkItemUtils");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.QMWorkItemPane");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.DatapoolInTestScriptClient");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotEnabledEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function() { // module container

/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
/* QM objects */
var Constants    			= com.ibm.rqm.planning.web.client.internal.Constants;
var Utility					= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var TestScriptClient 		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var TestCaseClient 			= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
var TestCaseMapper 			= com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
var RegistryClient     		= com.ibm.rqm.planning.web.client.internal.RegistryClient;
var EditorUtil     			= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var AbstractArtifactEditor 	= com.ibm.rqm.planning.web.ui.internal.view.construction.AbstractArtifactEditor;
var SectionWorkItem			= com.ibm.rqm.planning.web.ui.internal.view.common.SectionWorkItem;
var WorkItemUtils 			= com.ibm.rqm.planning.web.client.internal.WorkItemUtils;
var DEFAULT_SCRIPT_TYPE 	= "Manual"; // Constants.getMessage("labelManual");
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var DatapoolClient			= com.ibm.rqm.planning.web.client.internal.construction.DatapoolInTestScriptClient;
var SelectUtility 			= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var YesNoDialog      		= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var SnapshotEnabledEditor	= com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotEnabledEditor;
var ViewHeaderLayout 		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var SnapshotDialog			= com.ibm.rqm.planning.web.ui.internal.view.construction.SnapshotDialog;
var PrintViewBaseURI        = "action=com.ibm.rqm.planning.printview.testScript&id=";
var CommonUtility           = com.ibm.asq.common.web.ui.internal.util.Utility;

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor",
	[dijit._Widget, dijit._Templated, AbstractArtifactEditor, SnapshotEnabledEditor],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/TestScriptEditor.html"),
	  
	  	labelLoading: Constants.getMessage("labelLoading"),
	
		// object initializer
		constructor: function(args) {
			this._isInitialized = false;
			this._stepsEditor = null;
			this._scriptTypes = [];
			this._isNew = false;
			this._isMinimal = false;
			this._script = null;	
			this._listener = null;	
         	this._nameListenerNode = null;
			this._sectionWI = null;
			this._editorId = Constants.EDITOR_ID_SCRIPT;
			this._editorRegistry = dojo.getObject(Constants.EDITOR_REGISTRY_OBJECT_ID);
			this._doesPrint = true;
			this._printType = "testscript";
			this._printsHistory = true;
			this._supportsDuplicate = true;			
		},
		
		events: ["onKeyPress", "onKeyDown", "onKeyPressed"],		
		// populate the template with data, connect events, and show initial
		// sub-tab
		postCreate: function() {	
            this.inherited('postCreate', arguments);
            this.setArtifactType(Constants.TYPE_SCRIPT);
			this.setSnapshotClient(TestScriptClient);			
			this._keyHandlers = {};
			this.onLoad();
			this.setupDefaultShortcuts();
			this.setCopy(this.copy === true);
			this._isNew = this.copy === true;
			
            //internalize params
            if (this.model) {
                this.setArtifactModel(this.model);
                this.model = null;
            }
			
			this._parentInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel();
			this._parentInfo.getInfoGroup(Constants.getMessage("labelParentTestCaseInfo"), true);			

		},		
		
		initialize: function(args) {
			this.args = args;
						
			var doc = document;
			this._datapoolContainer = null;
			if (this.getArtifact() && this.parentController) {
				//handle discard or re-initialize scenarios
                args = args || {};
				args.testScript = args.artifact || this.getArtifact();
                args.parentController = this.parentController;
            }
            // our content will be completely rebuilt. This includes the
            // ViewLayoutHeader, etc. Destroy all widgets in the content
            // node before removing it from view.
            if(this._isInitialized) {
                CommonUtility.destroyWidgetsFromNode(this._contentNode);
                
                // clear all old references to UI objects before recreate
                this._snapshotPane = null;
                this._saveButton = null;
                this._cancelButton = null;
                this._printButton = null;
                this._pdfButton = null;
            }
            dojox.data.dom.removeChildren(this._contentNode);
				
			if ( args != null) {
				if (args.parentController == null) {
					throw new Error("TestScriptEditor#initialize: Missing required parameter 'parentController'");
				}
				this.parentController = args.parentController;
				this._script = args.testScript;
                if (this.isCopy()) {
                    // clear out the snapshot info
                    this._script.snapshotInfo = null;					
                }                                                   
				this.setArtifact(args.testScript);
				this._isInitialized = true;
			} else if (!this._isInitialized) {
				throw new Error("TestScriptEditor#initialize: Missing required parameter 'args'");
				return;
			}

			// create header			
            this._snapshotsNode = doc.createElement("div");
			this._mainContentNode = doc.createElement("div");
			var isManualScript = (this._script!=null && this._script.scriptType!=null && this._script.scriptType.name == "Manual");
			this._doesPrint = isManualScript;
            this.setNew(!this.getArtifact() || this.isCopy());
            this.setPrintViewURI(PrintViewBaseURI + (this.getArtifact() ? this.getArtifact().id : ""));
			
            this.createHeader("testscript-icon-48", this._mainContentNode, this._snapshotsNode);
            var header = this.getHeader();
            dojox.data.dom.removeChildren(header.getInfoAttributesNode());
			// view header
            this._contentNode.appendChild(header.domNode);
			if (this._script != null) {
				this.setOriginator(this._script.originator.name);
				//State Management  Hard Coded 
				this.setState(this._script.state);
			}else{
				this.setOriginator(EditorUtil.getCurrentContributor().name);
				//State Management  Hard Coded 
	            this.setState(Constants.STATETRANSITION_STATE_DRAFT); 
			}
			// add line break in the info attributes area of the header for type and data in a new line
            header.addInfoLineBreak();
            this._initScriptTypes();
            // create the script type widget
            this._createScriptTypesWidget(!this._script);
			if (this._script == null || (this._script.scriptType != null && this._script.scriptType.name != "Manual")) {
				dojo.style(header.contentSelectorNode,"display","none");
				dojo.style(header.typeNode,"display","inline");
			}			
            // snapshot node
            this._snapshotsNode.appendChild(this.getSnapshotPane().domNode);
            
            // Set the view state AFTER the view header is created. Setting
            // certain view state would trigger updating the view header's buttons.
            // This ensures the view header buttons state would be set properly.
            
            //print view mode
            if (args.printable) {
                this.setPrintView(true);
                this.setReadOnly(true);
                this.printable = null;
            }
            if (this.isArchived()) {
                this.setReadOnly(true);
            }
            // if this is a "new" test script, don't set dirty from the start
            this.setDirty(this.isCopy());
            this.setIsSnapshot(this.getArtifact() && !this.isCopy() && this._script && this._script.snapshotInfo);

			// main content node
			var stepsTitleDiv = doc.createElement("div");
			stepsTitleDiv.className = "steps-title";
			this._typeSpecificSectionTitle = doc.createElement("span");
			this._typeSpecificSectionCshelp = doc.createElement("span");
			this._stepsContainer = doc.createElement("div");
			this._typeSpecificSection = doc.createElement("div");
			
			this._mainContentNode.appendChild(stepsTitleDiv);
			stepsTitleDiv.appendChild(this._typeSpecificSectionTitle);
			stepsTitleDiv.appendChild(this._typeSpecificSectionCshelp);
			this._mainContentNode.appendChild(this._stepsContainer);
			this._stepsContainer.appendChild(this._typeSpecificSection);
			this._typeSpecificSectionTitle.appendChild(doc.createTextNode(this.labelLoading));
			
			
			// context sensitive help moved from section to header
            header.setCSHelpId("rqm_test_script_overview.html");
			header.setCSHelpButtonLabel(Constants.getMessage("labelTestScriptEditorCSHelp"));
			header.setSummaryLabel(Constants.getMessage("labeldescription"));
            header.setSummaryEditable(true);
			header.onSummaryEdited = dojo.hitch(this, this._setEditorDirty);
            this.setLoading(true);
			if ( this._script != null ) {
				var scriptWI = null;
				if(this._script.workItems && this._script.workItems.length>0 ){
					//need to fix the workitem object received. copy values from attributes to the workitem
					//moved mapping up into TestScriptClient like other artifact clients
					//this._script = WorkItemUtils.fixupArtifactWorkItems(this._script);
					scriptWI = this._script.workItems[0];
				}
				var defaultOwnerId = null;
				if(scriptWI == null)
					defaultOwnerId = this._script.ownerItemId; 
					// add the Section Work Item
                var labelSpan = doc.createElement("span");
                labelSpan.innerHTML = Constants.getMessage("labelWorkItemLabel");
				if(this._sectionWI)
					this._sectionWI.destroyRecursive();
				this._sectionWI = new SectionWorkItem({
						parentSection: this,
						workItem: scriptWI,
						artifact: null,
            	    	sectionId: "com.ibm.rqm.planning.editor.section.testScript.manual",
						editable: !this.isReadOnly(),
		                defaultOwnerId:defaultOwnerId
				});
                
                // only grab the icon and link dom nodes of the SectionWorkItem widget to
                // avoid the float CSS of the layers of parent DIV's.
                var wiSpan = doc.createElement("span");
                wiSpan.appendChild(this._sectionWI._stateIcon);
                wiSpan.appendChild(this._sectionWI._workItemLink);
                dojo.addClass(this._sectionWI._workItemLink, "com-ibm-rqm-test-section-workitem");
                // append to the second attribute in the info area
                var attributeContainer = header.setExtInfoAttribute(labelSpan, wiSpan); 
                attributeContainer.id = this.id+"_sectionWI";

				// Need this to be set but dont display it since Section Work Item shows the Owner
	            this.setOwner(this._sectionWI.getOwnerId());
				this.setOwnerVisible(false);
				if ( this._script.description != null ) {
                    header.setSummary(this._script.description);
				} else {
                    header.setSummary("");
				}
			} else {
				// add the Section Work Item 
                var labelSpan = doc.createElement("span");
                labelSpan.innerHTML = Constants.getMessage("labelWorkItemLabel");
				if(this._sectionWI)
					this._sectionWI.destroyRecursive();
				this._sectionWI = new SectionWorkItem({
						parentSection: this,
						workItem: null,
						artifact: null,
            	    	sectionId:"com.ibm.rqm.planning.editor.section.testScript.manual",
						editable: true,
		                defaultOwnerId: EditorUtil.getCurrentContributor().itemId
				});
                
                var wiSpan = doc.createElement("span");
                wiSpan.appendChild(this._sectionWI._stateIcon);
                wiSpan.appendChild(this._sectionWI._workItemLink);
                dojo.addClass(this._sectionWI._workItemLink, "com-ibm-rqm-test-section-workitem");
                var attributeContainer = header.setExtInfoAttribute(labelSpan, wiSpan);
                attributeContainer.id = this.id+"_sectionWI";
                
				// Need this to be set but dont display it since Section Work Item shows the Owner 
				this.setOwner();
				this.setOwnerVisible(false);
                header.setSummary("");
			}
         	
            if (this.isNew() && !this.isCopy()) {
                this._defaultName = header.getTitle();
                this.setLastSaved(Constants.STATUS_NEW);
            }
			this._updateLockAction();
			if(this.isReadOnly()){
				header.setSummaryEditable(false);
			}
			this._getRelatedInfo();
            this.setLoading(false);

            if (this.isNew() || this.isCopy()) {
                header.setEditableTitleFocus();
            }            
		},

		// @override AbstractArtifactEditor		
        _snapshotsSelected: function() {
            this.inherited('_snapshotsSelected', arguments);
			this.getHeader().getSummaryNode().style.display="none";
			this.getHeader().getExtInfoAttributesNode().style.display="none";
		},
		
		// @override AbstractArtifactEditor		
        _contentSelected: function() {
            this.inherited('_contentSelected', arguments);
			this.getHeader().getSummaryNode().style.display="";
			this.getHeader().getExtInfoAttributesNode().style.display="inline";
		},
		
		// @override AbstractArtifactEditor : We don't need to append snapshot info, service do it
        getHeaderTitle: function() {
            var title = "";
            var artifact = this.getArtifact(); 
			if (this.isNew() && !this.isCopy()) {
//          	title = new String(Constants.NEW_PAGE_TITLE);
//          	title = title.replace(/_type/, this.getArtifactType());
			} else if (artifact.archived) {
				title = artifact.name + " (" + Constants.getMessage("labelDeleted") + ")";
				
            } else if (artifact) {
				title = artifact.name;
            }
			
            return title;
        },
        
		
		// @override AbstractArtifactEditor : We don't need to append snapshot info, service do it
		getHeaderSubTitle: function() {
	        var subTitle = "";
            return subTitle;
        },
		
        getStaticRelatedInfo: function() {
			return this._parentInfo || null;
        },
            
        getStaticRelatedInfoId: function() {
			if (this.getArtifact() && this.getArtifact().id) {
				return this.declaredClass + this.getArtifact().versionableItemId;
			} else {
				return this.declaredClass + new Date().toString();
			}
        },
		
		_getRelatedInfo: function() {            
            var script = this.getArtifact();
            if (script != null) {
                var responseHandler = new TestCaseMapper(this, "_addRelatedInfo", "_error");
				TestCaseClient.getTestScriptTestCases(responseHandler, script.versionableItemId);
            }            
        },
		
		_addRelatedInfo: function(cases) {
			cases = cases || [];
			var group = this._parentInfo.getInfoGroup(Constants.getMessage("labelParentTestCaseInfo"));
			dojox.data.dom.removeChildren(group._actionListNode);
			var len = cases.length;
			for(var i = 0; i < len; i++) {
				var href = null;
				var isSnapshot = cases[i].snapshotInfo != null;
				if (isSnapshot) {
					href = Utility.getTestCaseURI(cases[i].itemId, cases[i].snapshotInfo.revision);
				} else {
					href = Utility.getTestCaseURI(cases[i].id);
				}
                          
                var heading = cases[i].name + (isSnapshot ? " (" + cases[i].snapshotInfo.name + ")" : "");
                if( heading.length > 32 ) {
                    heading = heading.substring( 0, 28 ) + "...";
                }
                                    
                this._parentInfo.addLink(Constants.getMessage("labelParentTestCaseInfo"), heading, href);
            }    
		}, 		
		
      ////////////////////////////////////////////////////////////////////////////////////////////////////
      //                                   PLUGGABLE SECTION SUPPORT                                   //
      ////////////////////////////////////////////////////////////////////////////////////////////////////      
      _initTypeSpecificSection: function() {
         if (!this._sectionConfig) {
            this._sectionConfig = this._editorRegistry.getEditor(this);  
         }      
         CommonUtility.destroyWidgetsFromNode(this._typeSpecificSection);
         dojox.data.dom.removeChildren(this._typeSpecificSection);
		 	
         this._typeSpecificSectionWidget = this._getTypeSpecificSectionWidget();
         this._typeSpecificSection.appendChild(this._typeSpecificSectionWidget.domNode);  
         this._typeSpecificSectionWidget.initialize(); 
         this._typeSpecificSectionTitle.innerHTML = Constants.getExtensionDisplayMessage(this._typeSpecificSectionConfig.name);
         
         this._addTypeSpecificCSHelp(this._typeSpecificSectionWidget);
      },
      
      _addTypeSpecificCSHelp: function(section) {
         CommonUtility.destroyWidgetsFromNode(this._typeSpecificSectionCshelp);
         dojox.data.dom.removeChildren(this._typeSpecificSectionCshelp);
		 var contextId = this._typeSpecificSectionConfig.id + ".html";
		 // allow section to override usage of sectionid
         if (section && section.getHelpContextID && section.getHelpContextID() != null) {
		 	contextId = section.getHelpContextID();
         }          
         var cshelp = new CSHelp({
             contextID: contextId
         });
		 cshelp.setButtonLabel(Constants.getMessage("labelTestScriptStepsCSHelp"));
         this._typeSpecificSectionCshelp.appendChild(cshelp.domNode);
      },
      
      _getTypeSpecificSectionWidget: function() {
         var scriptTypeName = this._script ? this._script.scriptType.name : this._scriptTypeSelect.value;
         var scriptType = this._getScriptTypeByName(scriptTypeName);                  
         this._typeSpecificSectionConfig = this._getTypeSectionConfig(scriptType);
		 var sectionConstructor = null;
		 var existingObject = dojo.getObject(this._typeSpecificSectionConfig.jsClass);
		 if(!existingObject){
		 	console.info("Dynamic Widget loading...ScriptType: [" + scriptType.id + "]; Widget Id: [" + this._typeSpecificSectionConfig.jsClass + "]");
			jazz.core.loader.load_sync(this._typeSpecificSectionConfig.jsClass);
			sectionConstructor = dojo.getObject(this._typeSpecificSectionConfig.jsClass);
		 }else{
				sectionConstructor = existingObject;
		 }
         var widgetArgs = { parentController: this.parentController, parentEditor: this, script: this._script, scriptType: scriptType };
         var contributedWidget = new sectionConstructor(widgetArgs);     
         return contributedWidget;
      },
      
      _getTypeSectionConfig: function(scriptType) {
         var found = null;
         var isDefault = false;
         var sections = this._sectionConfig.sections;
		 var len = sections.length;
         for (var i = 0; i < len; i++) {
			var properties = sections[i] && dojo.isArray(sections[i].properties) ? sections[i].properties : []; 
			var len2 = properties.length;
            for (var j = 0; j < len2; j++) {
               var property = properties[j];
               if (property.id == "com.ibm.rqm.planning.common.executionScriptType" && property.value == scriptType.id) {
                  return sections[i];
               } else if (property.id == "default" && property.value == "true") {
                  found = sections[i];
                  isDefault = true;
               }
            }
         }
         if (found != null && isDefault) {
            console.info("No widget found for ScriptType: [" + scriptType.id + "]; Using default Section: [" + found.id + "]");
         }
         return found;          
      },
      
      _getScriptTypeById: function(id) {
	  	var _scriptTypes = this._scriptTypes;
		var len = _scriptTypes.length;
		for (var i = 0; i < len; i++) {
			if (_scriptTypes[i].id == id) {
				return _scriptTypes[i];
			}
		}
		return null;
      },
            
      _getScriptTypeByName: function(name) {
		var _scriptTypes = this._scriptTypes;
		var len = _scriptTypes.length;
		for (var i = 0; i < len; i++) {
			if (_scriptTypes[i].name == name) {
				return _scriptTypes[i];
			}
		}
		return null;
      },      
      ////////////////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////////////////////////////////////////////////////////////////////////
	  	  
	  	_createDatapoolWidget: function(){
			var doc = document;
			var _datapoolLabel = doc.createElement("label");
            _datapoolLabel.innerHTML = Constants.getMessage("labelTestDataLabel");
			_datapoolLabel.setAttribute("for", "datapool-select");
			
            this._datapoolSelect = doc.createElement("select");
			this._datapoolSelect.name = "datapool-select";
			this._datapoolSelect.id = "datapool-select";
			this._datapoolSelect.disabled = this.isReadOnly();
			
            this._datapoolSelect.className = "input-entry";
            var _datapoolSpan = doc.createElement("span");
            _datapoolSpan.appendChild(this._datapoolSelect);
            this._datapoolContainer = this.getHeader().addInfoAttribute(_datapoolLabel, _datapoolSpan);
			this.connect(this._datapoolSelect, "onchange", "_onDatapoolChange");
            this._initDatapools();
		},
		
		_initDatapools: function(){
			SelectUtility.add( this._datapoolSelect, new Option(Constants.getMessage("labelLoading"), "") );
			var handler= new ServiceResponseHandler(this, "_doInitDatapools", "_error");
			var params = {
				linkedTestScriptUUID: ""
			}
			DatapoolClient.getDatapoolDTOs(handler, params);
		},
		
		_doInitDatapools: function(datapools){
			this._datapools = datapools;
			this._showDatapools(this._datapools, this.datapool != null ? this._datapool : "Datapool");
		},
		
		_showDatapools: function(datapools){
			dojox.data.dom.removeChildren(this._datapoolSelect);
			var opt = new Option(Constants.getMessage("labelUnassigned"), -1);
			SelectUtility.add( this._datapoolSelect, opt );
			this.currentDatapoolIndex = 0;
			if ( datapools != null && datapools.length > 0 ) {
				var len = datapools.length;				
				for (var i = 0; i < len; i++) {
               		var opt = new Option(datapools[i].name, datapools[i].itemId);
					SelectUtility.add( this._datapoolSelect, opt );
				}
			}
			if(this._script){
				var self = this;
				var handler = {
					success: function(datapools){
						if(datapools && dojo.isArray(datapools) && datapools.length > 0){
							var options = self._datapoolSelect.options;
							var len = options.length;
							var dItemId = datapools[datapools.length - 1].itemId;
							for(var i = 0; i < len; i++){
								if(options[i].value == dItemId){
									options[i].selected = true;
								}
							}
						}
						
						self.currentDatapoolIndex = self._datapoolSelect.selectedIndex;
					},
					error: function(){
						
					}
				}
				var responseHandler= new ServiceResponseHandler(handler, "success", "error");
				var params = {
					linkedTestScriptUUID: this._script.itemId,
					linkedTestScriptStateUUID: this._script.stateId
				}
				DatapoolClient.getDatapoolDTOs(responseHandler, params);
			}
		},
		
		_onDatapoolChange: function(e) {
//			if(e != null) {
//				e.stopPropagation();
//			}
//			this._setDatapoolSelectState();
//			this._datapoolSpan.innerHTML = this._datapoolSelect.value;
//			this._setEditorDirty(true);

			
			if(this.currentDatapoolIndex != 0) {
				var self = this;
				var dialogArgs = {
					primaryTitle: Constants.getMessage("labelConfirmation"),
					isClosable: true,
					okCallback: function(){
						self._setEditorDirty(true);
						self.currentDatapoolIndex = self._datapoolSelect.selectedIndex;					
						if (self._typeSpecificSectionWidget._onDatapoolChange && dojo.isFunction(self._typeSpecificSectionWidget._onDatapoolChange)) {
							self._typeSpecificSectionWidget._onDatapoolChange();
						}
					},
					cancelCallback: function(){
						self._datapoolSelect.selectedIndex = self.currentDatapoolIndex;
					}
				};			
				var dlg = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
		 		dlg.contentContainer.appendChild(document.createTextNode(Constants.getMessage("msgChangeDataPool")));
				dlg.open();
			}else{
				this._setEditorDirty(true);
				this.currentDatapoolIndex = this._datapoolSelect.selectedIndex;					
				if (this._typeSpecificSectionWidget._onDatapoolChange && dojo.isFunction(this._typeSpecificSectionWidget._onDatapoolChange)) {
					this._typeSpecificSectionWidget._onDatapoolChange();
				}
			}
		},
		
		_setDatapoolSelectState: function() {
			var mutable = this._isDatapoolMutable();
			//hide or show the select
			if(mutable){
				if(dojo.hasClass(this._datapoolSelect, "hidden"))
					dojo.removeClass(this._datapoolSelect, "hidden");
				if(!dojo.hasClass(this._datapoolSpan, "hidden"))
					dojo.addClass(this._datapoolSpan, "hidden");	
			}else{
				if(!dojo.hasClass(this._datapoolSelect, "hidden"))
					dojo.addClass(this._datapoolSelect, "hidden");
				if(dojo.hasClass(this._datapoolSpan, "hidden"))
					dojo.removeClass(this._datapoolSpan, "hidden");	
			}
		},
		
		_isDatapoolMutable: function() {
			if (this._isNew) {
				return true;
			} else {
				//if elements or external info has been added, its not mutable
				var script = this._script;
				var datapoolSaved = script.scriptType ? false: true; 
				return datapoolSaved;
			}
		},
		
		_createDatapoolLinkage: function(){
			var args = {
				execItemUUID: this._script.itemId,
				execItemStateUUID: this._script.stateId,
				scriptVersionableItemId: this._script.versionableItemId
			}

			if(this._datapoolSelect && this._datapoolSelect.value != -1) {
				var dataPool = this.getSelectedDataPool();
				if (dataPool && dataPool.itemId) {
					args.dataItemUUID = dataPool.itemId;
					args.dataItemStateUUID = dataPool.stateId;
				}
			}
			var handler = {
				success: function(){
				},
				error: function(){
				}
			}
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			DatapoolClient.postDatapoolLink(responseHandler, args);
		},
		
	  	getSelectedDataPool: function() {
			var _datapools = this._datapools;
			if (_datapools != null && _datapools.length > 0) {
				var selected = this._datapoolSelect.value;
				var len = _datapools.length;
				for (var i = 0; i < len; i++) {
					if(_datapools[i].itemId == selected) {
						return _datapools[i];
					}
				}
			}
			return null;
		},
		
        _createScriptTypesWidget: function(/* boolean */ connectOnchange) {
			var doc = document;
            var _typeLabel = doc.createElement("label");
            _typeLabel.innerHTML = Constants.getMessage("labeltype");
			_typeLabel.setAttribute("for", "script-type-select");
            this._scriptTypeSelect = doc.createElement("select");
            this._scriptTypeSelect.className = "input-entry";
			this._scriptTypeSelect.name = "script-type-select";
			this._scriptTypeSelect.id = "script-type-select";
			
            this._scriptTypeSpan =  doc.createElement("span");
            this._scriptTypeSpan.className = "hidden input-label";
            var _typeContainer = doc.createElement("span");
            _typeContainer.appendChild(this._scriptTypeSelect);
            _typeContainer.appendChild(this._scriptTypeSpan);
            this.getHeader().addInfoAttribute(_typeLabel, _typeContainer);
            if (connectOnchange) {
                this.connect(this._scriptTypeSelect, "onchange", this._onScriptTypeChange);
            }
        },

		_initScriptTypes: function() {
			var handler= new ServiceResponseHandler(this, "_doInitScriptTypes", "_error");
			RegistryClient.getAllExecutionScriptTypes(handler);			
		},
		
		_doInitScriptTypes: function(types) {
         this._scriptTypes = types;			
         this._showScriptTypes(this._scriptTypes, this._script != null ? this._script.scriptType.name : DEFAULT_SCRIPT_TYPE );  
//         this._initTypeSpecificSection(this._scriptTypes);
         this._onScriptTypeChange(null);//ShowHideManualEditor       
		},
		
		_showScriptTypes: function(types, typeName) {
			if ( types != null && types.length > 0 ) {
				var len = types.length;
				dojox.data.dom.removeChildren(this._scriptTypeSelect);
				for (var i = 0; i < len; i++) {
					if (types[i].name == "Unknown" || types[i].name == "NoScript") { continue; }
					types[i].displayName = (types[i].name == DEFAULT_SCRIPT_TYPE) ? Constants.getMessage("labelManual") : Constants.getExtensionDisplayMessage(types[i].name);
				}
				
				for( var ix = 0; ix < len; ix++ ){
					for( var iy = ix + 1; iy < len; iy++ ){
						if( types[iy].displayName < types[ix].displayName ){
							var swap = types[ix];
							types[ix] = types[iy];
							types[iy] = swap;
						}
					}
				}
				
				for( var i = 0; i < len; i++ ){
					if (types[i].name == "Unknown" || types[i].name == "NoScript") { continue; }
               		var opt = new Option(types[i].displayName, types[i].name);
					if ( types[i].name == typeName ) {
						opt.selected = true;
					}
					SelectUtility.add( this._scriptTypeSelect, opt );
				}
			}			
		},
		
		_onScriptTypeChange: function(e) {
			if(e != null) {
				e.stopPropagation();
			}
                  
//         if (this._isScriptTypeMutable()) {
            this._initTypeSpecificSection();   
//         }
			this._setScriptTypeSelectState();
			if(this._scriptTypeSelect.value  == DEFAULT_SCRIPT_TYPE){
				this._scriptTypeSpan.innerHTML = Constants.getMessage("labelManual");
				if(!this._datapoolContainer)
					// create the datapool widget
					this._createDatapoolWidget();
				else{
					dojo.style(this._datapoolContainer,"display","inline");
				}
			}else{
				this._scriptTypeSpan.innerHTML = Constants.getExtensionDisplayMessage(this._scriptTypeSelect.value);
				if(this._datapoolContainer)
					dojo.style(this._datapoolContainer,"display","none");
			}
		},
		
		_setScriptTypeSelectState: function() {
         //this._scriptTypeSelect.disabled = !this._isScriptTypeMutable();
			var mutable = this._isScriptTypeMutable();
			//hide or show the select
			if(mutable){
				if(dojo.hasClass(this._scriptTypeSelect, "hidden"))
					dojo.removeClass(this._scriptTypeSelect, "hidden");
				if(!dojo.hasClass(this._scriptTypeSpan, "hidden"))
					dojo.addClass(this._scriptTypeSpan, "hidden");	
			}else{
				if(!dojo.hasClass(this._scriptTypeSelect, "hidden"))
					dojo.addClass(this._scriptTypeSelect, "hidden");
				if(dojo.hasClass(this._scriptTypeSpan, "hidden"))
					dojo.removeClass(this._scriptTypeSpan, "hidden");	
			}
		},
		
		_isScriptTypeMutable: function() {
			if (this._isNew && !this.isCopy()) {
				return true;
			} else {
				//if elements or external info has been added, its not mutable
				var script = this._script;
				var typeSaved = script.scriptType ? false: true; 
				return typeSaved;
			}
		},
		
		onCancel: function(){
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self.setDirty(false);
					self.initialize(self.args);
					return true;          
				},
				noCallback: function() {
					if(self.isDirty()){
						self.setDirty(true);
					}
					return false;
				}
			}
			var dialog = new YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();
		},
								
		onSave: function(){
			//clean Header Status: 
			var _header = this.getHeader();
			_header.clearStatus();
			_header.setProgressStart(Constants.getMessage("labelSavingArtifact", this.getArtifactType()));
			//validate fields
            if (!this.validate()) {
				_header.setProgressEnd();
                return false;
            }
			var scriptTypeName = this._script ? this._script.scriptType.name : this._scriptTypeSelect.value;
			var ownerId = null;
			//set save in progress
            if (this.isSaving()) {
                return; //protects against multiple save button clicks
            } else {
                this.setSaving(true);
            }
			var workItemList = [];
            var sectionWorkItemInfo = this._sectionWI.getWorkItemInfo();
			if (sectionWorkItemInfo) {
				 workItemList.push(sectionWorkItemInfo);
			}
			var workItemsJsonString = dojo.toJson(workItemList);
			ownerId = this._sectionWI.getOwnerId();
			//save the new Script
			var responseHandler = new ServiceResponseHandler(this, "saveFinished", "_saveError");	
			var scriptObj = {
				name: _header.getTitle(),
				type: this._scriptTypeSelect.value,
				description: _header.getSummary(),
				//content: contentHTML,
				newScript: this.isNew(),				
				ownerId: ownerId,
				state: this.getStateValue()	
			};
			if(workItemsJsonString)
				scriptObj.workItemsJsonString = workItemsJsonString;		
			if ( !this.isNew() ) {
				scriptObj.stateId = this._script.stateId;
				scriptObj.id =  this._script.id;
				scriptObj.versionableItemId = this._script.versionableItemId;
			}
			
			if (this._createSnapshot) {
				scriptObj.createSnapshot = true;
				scriptObj.snapshotName = this._snapshotName;
				scriptObj.snapshotDescription = this._snapshotDescription;
				scriptObj.snapshotContent = this._mainContentNode.innerHTML;
			}
		
    		if(!dojo.isFunction(this._typeSpecificSectionWidget.onSave)){
				//Manual Script only
				if(this._typeSpecificSectionWidget.validate()){
					if(this._typeSpecificSectionWidget.isEmpty()){
						var self = this;
						var args = {
							title: Constants.getMessage("labelConfirmation"),
							message: Constants.getMessage("msgNoStepStillSave"),
							yesCallback: function(){
								self._saveManualScript(responseHandler, scriptObj);
							},
							noCallback: function() {
								self._stopSaving();
								if(self.isDirty()){
									self.setDirty(true);
								}
							}
						};
						var dialog = new YesNoDialog(args);
				        dialog.setTitle(args.title);
				        dialog.open();
					}else
						this._saveManualScript(responseHandler, scriptObj);
				}else{
					this._stopSaving();
				}		
    		} else {
    			//let the widgets handle the save. Remote Scripts
    			this._typeSpecificSectionWidget.onSave(responseHandler, scriptObj, this._lastSaved);
    		}
		},

		_saveManualScript: function(responseHandler, scriptObj){
			var typeSpecificAttributes = this._typeSpecificSectionWidget.getAttributes();
	         if (typeSpecificAttributes != false) {
	            dojo.mixin(scriptObj, typeSpecificAttributes);
				TestScriptClient.saveTestScript(responseHandler, scriptObj);
	         }else{
				this._stopSaving();
			 }
		},
		
		_stopSaving: function(){
			this.setSaving(false);
			this.getHeader().setProgressEnd();
        	return false;
		},

		_saveError: function(status){
			if (status!=null && status.message!=null) {
				var re = /^\[(\d+)\]\s*:\s*/;
				status.message = status.message.replace(re, "");
			}
			this._stopSaving();
            this.setLastSaved(Constants.STATUS_FAILURE, status);
		},
		
        //@Override this method must be implemented to support locking
        lock: function(serviceResponseHandler) {
            var args = {
                lock: !this.getArtifact().locked,
                versionableItemId: this.getArtifact().versionableItemId
            }
            TestScriptClient.postLockTestScript(serviceResponseHandler, args);
        },
		
		
		// @override for SaveParticipant
		validate: function(){
			//validate fields
            var name = this.getHeader().getTitle();
            var detailError = Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelTestScript"));
			if (dojo.trim(name).length == 0) {
				if (this.isNew()) {
					this.setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
					return false;
				} else {
					this.getHeader().setTitle(this.getArtifact().name);
				}				
			} else if (this._defaultName && name == this._defaultName) {
                    this.setHeaderStatus(detailError, Constants.HEADER_STATUS_ERROR, detailError);
                return false;
            }
			return true;
 		},
		
		// @override for SaveParticipant
 		getAttributes: function(){
			var scriptObj = {
				name: this.getHeader().getTitle(),
				type: this._scriptTypeSelect.value,
				description: this.getHeader().getSummary(),
				newScript: this.isNew(),
				elements: this._stepsEditor ? this._stepsEditor.getElements() : null,
				ownerId: this.getOwnerValue(),
            	state: this.getStateValue()				
			};		
			if ( !this.isNew() ) {
				scriptObj.id =  this._script.id;
			}
 			return scriptObj;
 		},
		
		// @override for SaveParticipant
 		getItemType: function(){
			return Constants.MODEL_TYPE_SCRIPT;
 		},
		
		// @override for SaveParticipant
 		getItemId: function(){
 			return this.isNew() ? null : (this._script.versionableItemId  ? this._script.versionableItemId : this._script.itemId);
 		},

        // @override for SaveParticipant
        getStateId: function(){
            return this.isNew() ? null : this._script.stateId;
        },
				
        updateTableOfContents: function(selectFirst) {
            // no TOC for the test script editor, override superclass to do nothing
        },
        
		// @override for SaveParticipant
 		saveFinished: function(testScript){
			//State Management 
			//Clear the state changed flag on each save.
			this.setStateChanged(false);
            this.setPrintViewURI(PrintViewBaseURI + testScript.id);
            if (this._createSnapshot) {
                // refresh the snapshot list
                this.getSnapshotPane().refreshSnapshots();
                
                // unset the snapshot properties on the editor so next save doesn't create a snapshot
                this._createSnapshot = false;
                this._snapshotName = null;
                this._snapshotDescription = null;
				//Strip off snapshot info, service should not return this
				testScript.snapshotInfo = null;
            }
			this._script = testScript;
			this.inherited('saveFinished', arguments);          
               
            this._typeSpecificSectionWidget.saveFinished(testScript);
            this._setScriptTypeSelectState();

			var scriptWI = null;
			if(testScript.workItems && testScript.workItems.length>0 )
				scriptWI = testScript.workItems[0];
			
			var defaultOwnerId = null;
			if(scriptWI == null)
				defaultOwnerId = testScript.owner.itemId;
			var infoNode = this.getHeader().getExtInfoAttributesNode();
			var prevAttributeContainer = dojo.byId(this.id+"_sectionWI");
            if (prevAttributeContainer) {
                infoNode.removeChild(prevAttributeContainer);
            }
            if(this._sectionWI)
				this._sectionWI.destroyRecursive();
			this._sectionWI = new SectionWorkItem({
					parentSection: this,
					workItem: scriptWI,
					artifact: null,
        	    	sectionId:"com.ibm.rqm.planning.editor.section.testScript.manual",
					editable: true,
	                defaultOwnerId: defaultOwnerId
			});
            var labelSpan = document.createElement("span");
            labelSpan.innerHTML = Constants.getMessage("labelWorkItemLabel");
            var wiSpan = document.createElement("span");
            wiSpan.appendChild(this._sectionWI._stateIcon);
            wiSpan.appendChild(this._sectionWI._workItemLink);
            dojo.addClass(this._sectionWI._workItemLink, "com-ibm-rqm-test-section-workitem");
            var attributeContainer = this.getHeader().setExtInfoAttribute(labelSpan, wiSpan); 
            attributeContainer.id = this.id+"_sectionWI";
			
			this._getRelatedInfo();
			
			if (this._datapoolContainer) {
				this._createDatapoolLinkage();
			}
			
			if (this._script != null && this._script.scriptType != null && this._script.scriptType.name == "Manual") {
				dojo.style(this._header.contentSelectorNode,"display","inline");
				dojo.style(this._header.typeNode,"display","none");
				if (this._doesPrint != true) {
					this._doesPrint = true;
					
					var printMenu = new dijit.Menu({ style: "display: none;"});
					var normalOption = new dijit.MenuItem({
						label: Constants.getMessage("labelShowNormalView"),
						onClick: dojo.hitch(this, "printPdfNormal")
					});
					printMenu.addChild(normalOption);
					var historyOption = new dijit.MenuItem({
						label: Constants.getMessage("printLabelHistory"),
						onClick: dojo.hitch(this, "printPdfHistory")
					});
					printMenu.addChild(historyOption);
					this._menus.push(printMenu);
					this._pdfButton = this._header.addLeftViewAction(Constants.getMessage("labelPDFView"), dojo.hitch(this, "onPDFView"), null, "pdf-icon-image", printMenu);
				}
			}
 		},

		/*
		 * Keyboard accessibility for CTRL+s for saving test script
		 */
		setupDefaultShortcuts: function(){
			var ctrl = this.KEY_CTRL;
			var exec = function(cmd, arg){
				return arguments.length == 1 ? function(){ this.execCommand(cmd); } :
					function(){ this.execCommand(cmd, arg); }
			}
			this.addKeyHandler("s", ctrl, exec("save"));
		},

		addKeyHandler: function(/*String*/key, /*Int*/modifiers, /*Function*/handler){
			// summary: add a handler for a keyboard shortcut
			if(!dojo.isArray(this._keyHandlers[key])){ this._keyHandlers[key] = []; }
			this._keyHandlers[key].push({
				modifiers: modifiers || 0,
				handler: handler
			});
		},
			
		KEY_CTRL: 1,
		KEY_SHIFT: 2,
	
		onKeyPress: function(e){
			// summary: Fired on keypress
			// handle the various key events
			var modifiers = e.ctrlKey ? this.KEY_CTRL : 0 | e.shiftKey?this.KEY_SHIFT : 0;
	
			var key = e.keyChar||e.keyCode;
			if(this._keyHandlers[key]){
				var handlers = this._keyHandlers[key]; var i = 0; var h;
				while((h = handlers[i++])){
					if(modifiers == h.modifiers){
						if(!h.handler.apply(this,arguments)){
							e.preventDefault();
						}
						break;
					}
				}
			}
	
			// function call after the character has been inserted
			setTimeout(dojo.hitch(this, function(){
				this.onKeyPressed(e);
			}), 1);
		},
			
		execCommand: function(/*String*/command, argument){
		 // more can be added later
			if(command === "save"){
				this.onSave();
			}
		},
			
		onLoad: function(e){
			var events=this.events.concat(this.captureEvents),i=0,et;
			while((et=events[i++]))	{
				this.connect(this.domNode, et.toLowerCase(), et);
			}
			this.onDisplayChanged(e);
		},
		
		onKeyDown: function(e){
			this.onKeyPress(e);
		},
		
		onKeyPressed: function(e){
			this.onDisplayChanged(); 
		},
			
		updateInterval: 200,
		_updateTimer: null,
		
		onDisplayChanged: function(e){
			if(!this._updateTimer){
				if(this._updateTimer){
					clearTimeout(this._updateTimer);
				}
				this._updateTimer=setTimeout(dojo.hitch(this,this.onNormalizedDisplayChanged),this.updateInterval);
			}
		},
		
		onNormalizedDisplayChanged: function(){
			this._updateTimer=null;
		},
		
		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
			var len = artifactArray.length;
            if ((changeType == GlobalEvents.ArtifactsDeleted) && (artifactType == Constants.TYPE_SCRIPT)) {
                for (var i = 0; i < len; i++) {
                    if (this.getArtifact() && (this.getArtifact().id == artifactArray[i].id)) {
                        this.getHeader().setStatus(Constants.getMessage("msgEditorTestScriptDeleted"), ViewHeaderLayout.ERROR);
						this.setArchived(true);
                        return;
                    }
                }
            }else if (artifactType == Constants.TYPE_KEYWORD) {
                if(this._typeSpecificSectionWidget && this._typeSpecificSectionWidget.onArtifactChanged)
					this._typeSpecificSectionWidget.onArtifactChanged(changeType, artifactType, artifactArray);
            }else if (artifactType == Constants.TYPE_DATAPOOL && changeType == GlobalEvents.ArtifactsUpdated) {
                var datapools = this._datapools;
                var datapoolsLength = datapools.length;
                var currentDP = this.getSelectedDataPool(); 
                for(var i=0;i<len;i++){
	                for(var j=0;j<datapoolsLength;j++){
	                	if(datapools[j].id == artifactArray[i].id){
	                		datapools[j] = artifactArray[i];//Try to change the datapools here to put the latest ones. 
	                		if(currentDP && datapools[j].id == currentDP.id){//If current DP is the selected one, inform user to update.
	                			this.getHeader().setStatus(Constants.getMessage("msgEditorDatapoolChanged"), ViewHeaderLayout.INFO);
	                		}	
	                	}
	                }
				}
            }
        },
		
		_setEditorDirty: function(value){
			if(value == "")
				value = true;
			if(value != true && value != false){
				value = true;//Use the same function for events
			}
			if(!this.isDirty())
				this.setDirty(value);
		},
		
		setDirty: function(dirty){
			if(dirty == undefined){
				dirty = true;
			}
			this.inherited("setDirty", arguments, [dirty]);
		},
		
		_error: function(e){
			console.error(this.declaredCass + ": An error occurred: [" + e.message + "]");
		},
		uninitialize:function(){
			if (this._sectionWI) {
				this._sectionWI.destroyRecursive();
				this._sectionWI = null;
			}
			if (this._parentInfo) {
				this._parentInfo.destroyRecursive();
				this._parentInfo = null;
			}
			this.inherited("uninitialize",arguments);
			
		},
		onActivated:function(){
			if(this._typeSpecificSectionWidget && this._typeSpecificSectionWidget.onActivated)
				this._typeSpecificSectionWidget.onActivated();
		}
	}
);

}
)();