/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ScriptingClipboardTableView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ScriptingClipboardTableView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dojo.dnd.Source");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("jazz.ui.HoverPopup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.Clipboard");

(function() {

var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TestScriptClient		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var AlertDialog 			= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var CommonImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Clipboard				= com.ibm.rqm.planning.web.ui.internal.view.common.Clipboard;
var _textContent			= dojo.isIE ? "innerText" : "textContent";

dojo.declare("ScriptingClipboardTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{        
	constructor: function(parentView) {
        this.parentView = parentView;
    },
	
	
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		var selectionCount = tableViewer.getCheckedRows().length;
		if(selectionCount)
			this.parentView.deleteButton.attr('disabled', true);
		else
			this.parentView.deleteButton.attr('disabled', true);
    },
    	
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
		if (callback != null && dojo.isFunction(callback)) {
			callback();
        } 
    }
});


dojo.declare("ScriptingClipboardTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 2;
    },
    
    getColumnHeading: function(content, index){
        var headings = [
			"",
			Constants.getMessage("labelSteps")
        ];
        return headings[index];
    },

    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
        return false;
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex){
         if(atColumnIndex)
			return 80;
		else
			return 20;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_scripting_clipboard_" + rowData.index;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        if(atColumnIndex == 0){
			type = TableConstants.RENDER_TYPE_IMAGE;
        }
        return type;
    },

    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.elementType.displayName;
                break;
            case 1: 
                val = rowData.displayContents;
                break;
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 1) {
        }		  		  		  
        return val;
    }    
});
dojo.declare("ScriptingClipboardTableView.TableRowRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer,
{
	editor:null,	
	constructor :function(params){
		this.editor = params.editor;
		this.clipboardStepType = params.stepType;
		this.deleteButton = params.deleteButton;
	},
	renderRow: function(viewer, rowObject, trNode){
		var doc = document;
		
		var anchor = doc.createElement('a');
        var img = doc.createElement('img');
        img.src = rowObject.elementType.iconUrl;
		img.alt = rowObject.elementType.displayName;
		anchor.href = "javascript:{}";
		anchor.appendChild(img);
        var td = doc.createElement("td");
		td.appendChild(anchor);
        trNode.appendChild(td);
		var td2 = doc.createElement("td");
		viewer.tooltips.push(new jazz.ui.HoverPopup({html:rowObject.fullContent , around:[td2]}));
        td2[_textContent] = rowObject.displayContents;
        trNode.appendChild(td2);
		var rowId = "_tr"+rowObject.index;
		trNode.id = rowId;
		trNode.type = this.clipboardStepType;
//		this._attachContextMenu(trNode,viewer);
		// the trNode is not yet connected to the tbody at this time, as the tableViewer uses
		// a fragment to collect all the rows and append them all at once.  The dnd support
		// looks up the parent chain and breaks because of the fragment, so we defer
		// setting up the DND.
		setTimeout(dojo.hitch(this,function(){
			var _dojo = dojo;
			if(!_dojo.hasClass(trNode.parentNode,"dojoDndSource")){
				if(this.dndSource)
					this.dndSource.destroy();
				this.dndSource= new _dojo.dnd.Source(trNode.parentNode,{
					accept:[],
					copyOnly:true,
					singular:false,
					selfAccept:false,
					selfCopy:false,
					creator:this._dndCreator,
					onMouseUp:_dojo.hitch(this,function(e){
						if(this.dndSource.mouseDown){
							this.dndSource.mouseDown = false;
							dojo.dnd.Source.superclass.onMouseUp.call(this, e);
						}
						var nodes = this.dndSource.getSelectedNodes();
						if(nodes.length >0)
							this.deleteButton.attr("disabled",false);
						else
							this.deleteButton.attr("disabled",true);
					})
				});
				this.dndSource.getSelectedNodes = _dojo.hitch(this,"getSelectedNodes");
				
				//changes to dnd classes to improve performance especially on IE
				this.dndSource._changeState = _dojo.hitch(this.dndSource,function(type, newState){
					var prefix = "dojoDnd" + type;
					var state  = type.toLowerCase() + "State";
					var oldClass = prefix + this[state];
					var newClass = prefix + newState;
					if(oldClass == newClass)
						return;
					var oldClassName = this.node["className"];
					var newClassName = dojo.trim((" " + oldClassName + " ").replace(" " + oldClass + " ", " "+newClass+" "));
					if(oldClassName != newClassName)
						this.node["className"] = newClassName;
					this[state] = newState;
				});
			}
			this.dndSource.setItem(rowId, {data: rowObject, type: [this.clipboardStepType]});
			_dojo.addClass(trNode, "dojoDndItem");
		}),0);
		
    },
    getSelectedNodes: function(){
		// summary: returns a list (an array) of selected nodes
			var _dojo = dojo;
			var t = new _dojo.NodeList();
			var e = _dojo.dnd._empty;
			var doc = document;
			for(var i in this.dndSource.selection){
				if(i in e){ continue; }
				t.push(_dojo.byId(i,doc));
			}
			t = t.sort(function(a1,a2){
				if(a1.sectionRowIndex < a2.sectionRowIndex)
					return -1;
				else
					return 1;
			});
			return t;	// Array
		},
	
    _dndCreator:function(row,hint){
        if(hint == "avatar"){
			var span = document.createElement("span");
			span[_textContent] = row.displayContents;
            return {node: span, data: row, type: [this.clipboardStepType]};
		}			
	}
	
});		
dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.ScriptingClipboardTableView",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/manualscripteditor/ScriptingClipboardTableView.html"),
		
		labelScriptingClipboard: Constants.getMessage("labelClipboard"),
		editor:null,
		clipboardType:"ManualSteps",
		clipboardStepType:"ClipboardStep",
		constructor: function() {
		},
		
		postCreate: function() {
			this.rows = [];
			this.vOpen = true;
			this.headerCollapsImg.src = CommonImageCache.COLLAPSE_ICON;
			this.connect(this.headerCollapsImg,"onclick","toggleView");
			this.connect(this.headerCollapsImg,"onkeypress","toggleView");
			this.connect(this.titleRow,"onclick","toggleView");
			this.connect(this.titleRow,"onkeypress","toggleView");
			this.connect(this.titleRow,"onmouseover","_onMouseOverImg");
			this.connect(this.titleRow,"onmouseout","_onMouseOutImg");
			//cshelp
			if (this._cshelp) {
		        var cshelp = new CSHelp({
		        	contextID: "rqm_clipboard_view.html"
		        });
				cshelp.setButtonLabel(Constants.getMessage("labelClipboardCSHelp"));
		        this._cshelp.appendChild(cshelp.domNode);
			}
			this.dndTopic = dojo.subscribe("/dnd/drop",this, "_dndDrop");
			this.stepsDndSource = new dojo.dnd.Target(this.clipboard, {
					accept: [ this.editor.id],
					copyOnly:true,
					selfAccept:false,
					selfCopy:false,
					creator:this._dndCreator
				});
			this.rows = Clipboard.getItems(this.clipboardType);
			this._displayTable(this.rows);
			this.clipboardUpdateTopic = dojo.subscribe("ClipboardUpdate",this, "_update"); 
		},
		_update:function(type){
			if(type == this.clipboardType)
				this.pendingUpdate = true;
		},
		_dndDrop:function(source,nodes,iscopy,target){
			if(target.parent == this.clipboard)
				setTimeout(dojo.hitch(this, "addSteps",nodes),10);
		},
		
		_dndCreator:function(row,hint){
			var newRow = document.createElement("tr");	
            return {node: newRow, data: null, type: []};
		},
		addSteps:function(nodes){
			if(!nodes || !nodes.length)
				return;
			this.editor._preserveEditedContent();
			var steps = [];
			var len = nodes.length;
			for(var i=0;i<len;i++){
				var editorStep = this.editor._getStepForRow(nodes[i]);
				if(!editorStep.content|| dojo.trim(editorStep.content).length === 0 || unescape(editorStep.content) == '<br />'){
					var alertDialog = new AlertDialog({
						primaryTitle:Constants.getMessage("labelError"),
            			message: Constants.getMessage("msgStepContentRequired", editorStep.num)
        			});
        			alertDialog.open();
					return;
				}
				var step = {};
				step.content = editorStep.content;
				var descriptionCell = nodes[i].cells[2];
				if(descriptionCell.innerText)
					step.displayContents = descriptionCell.innerText || ""; //IE
				else 	
					step.displayContents = descriptionCell.textContent || "";//FF
				
                var isImageStep = false;
                if (!step.displayContents || step.displayContents == "") {
                    // Inserted image has no text content, parse the step.content which should have
                    // the href of the IAttachmentRestService and image alt tag for the file name.
                    // Use the image file name here.
                    var html = unescape(step.content);
                    if (html.search("com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService")) {
                        // make sure there is an attached image
                        var tagBegin = html.indexOf("<img alt=");
                        if (tagBegin > 0) {
                            tagBegin += 10;  // offset to start after the quote in <img alt="
                            var tagEnd = html.indexOf("\"", tagBegin); // get the end quote
                            if (tagEnd > tagBegin) {
                                step.displayContents = html.substring(tagBegin, tagEnd);
                                isImageStep = true;
                            }
                        }
                    }
                }
				step.fullContent = step.displayContents;
				if (step.displayContents.length > 25) {
                    var extension = "";
                    var length = 22; // length of the trimmed string
                    if (isImageStep) {
                        // For image step we want to show the file extension to indicate it is an inserted
                        // image file.  Default to regular trimming if fail to determine the extension.
                        var extensionStart = step.displayContents.lastIndexOf(".");
                        if (extensionStart > 0) {
                            var imgExt = step.displayContents.substring(extensionStart + 1); // skip the leading "."
                            if (length - imgExt.length > 0) {
                                length -= imgExt.length;
                                extension = imgExt;
                            }
                        }
                    }
                    step.displayContents = step.displayContents.substring(0, length) + "..." + extension;
                }
				step.properties = editorStep.properties;
				step.expectedResult = editorStep.expectedResult;
				step.elementType = editorStep.elementType;
				step.summary = editorStep.summary;
				step.type = "ClipboardStep";
				steps.push(step);
			}
			this.rows = Clipboard.addItems(steps,this.clipboardType);
			this._displayTable(this.rows);
		},
		_displayTable: function(){
			if (!this.tableViewer) {
				var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({tooltips:[],noItemMessage:Constants.getMessage("labelClipboardNoItems")});
				tableViewer.setShowingPagingControl(false);
				tableViewer.setShowingPagingRangeControl(false);
				tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelClipboard")));
				this._tableViewerNode.appendChild(tableViewer.domNode);
				this.deleteButton = tableViewer.addAction("delete", Constants.getMessage("labelDelete"), this, "delete-icon-image", dojo.hitch(this, "deleteStep"));
				this.deleteButton.attr('disabled', true);
				this.clearButton = tableViewer.addAction("clear", Constants.getMessage("labelClearAll"), this, "clear-item-icon-image", dojo.hitch(this, "clearSteps"));
				if(this.rows.length == 0)
					this.clearButton.attr('disabled', true);
				tableViewer.setTableRowsCheckable(false,false);
				this.stepsRowRenderer = new ScriptingClipboardTableView.TableRowRenderer({
					editor: this.editor,
					stepType:this.clipboardStepType,
					deleteButton:this.deleteButton
				});
				tableViewer.setCustomRowRenderer(this.stepsRowRenderer);
				tableViewer.setContent(this.rows);
				tableViewer.setContentProvider(new ScriptingClipboardTableView.TableProvider());
				tableViewer.setTableListener(new ScriptingClipboardTableView.TableListener(this));
				tableViewer.show();
				this.tableViewer = tableViewer;
			}else{
				this._refreshTable();
			}
			if(!this.menu && this.rows.length > 0)
				this.menu = this._attachContextMenu(this.tableViewer);
		},
		_attachContextMenu: function(viewer){
			var callback = this;
			var node = viewer.domNode;
			if(node){
				var pMenu = new dijit.Menu({targetNodeIds:[node]});
	            pMenu.addChild(new dijit.MenuItem({
					label: Constants.getMessage("labelInsertBefore"),
					callback: callback,
					viewer:viewer, 
					onClick:this._insertSteps
				}));
	            pMenu.addChild(new dijit.MenuItem({
					label:Constants.getMessage("labelReplaceStatement"),
					callback: callback,
					viewer:viewer, 
					onClick:this._replaceCurrentWithSteps
				}));
	            pMenu.startup();
				return pMenu;
			}
		},
		
		_replaceCurrentWithSteps: function(){
			var editor = this.callback.editor;
			if(editor){	
				var stepsDndSource = editor.stepsDndSource;
				if (stepsDndSource) {
					var node = stepsDndSource.anchor;
					if (node) {
						var source = this.callback.stepsRowRenderer.dndSource;
						var items = [];
						var nodes = source.getSelectedNodes();
						var len = nodes.length;
						for (var i = 0; i < len; i++) {
							items.push(source.getItem(nodes[i].id).data);
						}
						editor.addClipboardSteps(node, items, true);
					}
					else 
						this.callback._displayAlertDialog(Constants.getMessage("msgNoStepToReplace"));
				}
			}
		},
		_insertSteps: function(){
			var editor = this.callback.editor;
			if(editor){
				var stepsDndSource = editor.stepsDndSource;
				if (stepsDndSource) {
					var node = stepsDndSource.anchor;
					if (node) {
						var source = this.callback.stepsRowRenderer.dndSource;
						var items = [];
						var nodes = source.getSelectedNodes();
						var len = nodes.length;
						for (var i = 0; i < len; i++) {
							items.push(source.getItem(nodes[i].id).data);
						}
						editor.addClipboardSteps(node, items, false);
					}
					else 
						this.callback._displayAlertDialog(Constants.getMessage("msgNoStep"));
				}
			}
		},
		_displayAlertDialog: function(message){
	        var alertDialog = new AlertDialog({
	            'message': message
	        });
	        alertDialog.open();
	    },
		
		deleteStep:function(){
			var source = this.stepsRowRenderer.dndSource;
			var nodes = source.getSelectedNodes();
			var items = [];
			var len = nodes.length;
			for(var i=0;i<len;i++){
				items.push(source.getItem(nodes[i].id).data);
				source.delItem(nodes[i].id);
			}
			Clipboard.removeItems(items,this.clipboardType);
			this._refreshTable();
			
		},
		clearSteps:function(){
			Clipboard.clear(this.clipboardType);
			this.stepsRowRenderer.dndSource.clearItems();
			this.rows = [];
			this.tableViewer.setContent(this.rows);
			this.tableViewer.refresh();
			this.deleteButton.attr('disabled', true);
			this.clearButton.attr('disabled', true);
		},
		
		_refreshTable:function(){
			var rows = Clipboard.getItems(this.clipboardType);
			this.rows = rows;
			this.tableViewer.setContent(rows);
			this.tableViewer.refresh();
			this.deleteButton.attr('disabled', true);
			if(rows.length >0)
				this.clearButton.attr('disabled', false);
			else
				this.clearButton.attr('disabled', true);
		},
		_error: function(errorObj) {
			console.debug("Error: (message: '" + errorObj.message + "') in ScriptingClipboardTableView#_error");
			
		},
		uninitialize: function(){
			dojo.unsubscribe(this.dndTopic);
			this.dndTopic = null;
			dojo.unsubscribe(this.clipboardUpdateTopic)
			this.clipboardUpdateTopic = null;
			if(this.stepsDndSource){
				this.stepsDndSource.destroy();
			}
			if(this.stepsRowRenderer.dndSource){
				this.stepsRowRenderer.dndSource.destroy();
			}
			if (this.tableViewer) {
				var tooltips = this.tableViewer.tooltips;
				var len = tooltips.length;
				for(var i =0;i<len;i++){
					var tooltip = tooltips[i];
					if (tooltip.destroyRecursive) {
						tooltip.destroyRecursive();
					}
				}
				this.tableViewer.tooltips = [];
			}
			if(this.menu){
				var menu = this.menu;
				if (menu.destroyRecursive) {
					menu.destroyRecursive();
				}
				this.menu = null;
			}
			
		},
		_onMouseOverImg: function(e){
	        this.titleRow.className = "title-row image-hover";
	        if (this.vOpen) {
	            this.headerCollapsImg.src = CommonImageCache.COLLAPSE_HOV_ICON;
	            this.headerCollapsImg.title = Constants.getCommonMessage("actionLabel_Collapse");
	        }
	        else {
	            this.headerCollapsImg.src = CommonImageCache.EXPAND_HOV_ICON;
	            this.headerCollapsImg.title = Constants.getCommonMessage("actionLabel_Expand");
	        }
	    },
	            
	    _onMouseOutImg: function(e) {
	        this.titleRow.className = "title-row";
	        if(this.vOpen)
	            this.headerCollapsImg.src = CommonImageCache.COLLAPSE_ICON;
	        else
	            this.headerCollapsImg.src = CommonImageCache.EXPAND_ICON;
	    },
		toggleView:function(e){
			dojo.stopEvent(e);
			if(this.vOpen){
				this._tableViewerNode.style.display = "none";
				this.vOpen = false;
			}else{
				this._tableViewerNode.style.display = "block";
				this.vOpen = true;
			}
		},
		onActivated:function(){
			if(this.pendingUpdate){
				this._refreshTable();
				this.pendingUpdate = false;
			}
		}
	}
);

})();
