/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.GenericAttachmentViewer");
(function() { // module container

var RESULT_ATTACHMENT_VIEW		= "result AttachmentView";
var ATTACHMENT_VIEW				= "attachmentView";
var GenericAttachmentViewer		= com.ibm.asq.common.web.ui.internal.widgets.GenericAttachmentViewer;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView", [dijit._Widget, dijit._Templated],
{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/properties/AttachmentView.html"),
		
		postCreate: function(){
			this._attachmentArray = [];
		},
		
		initialize: function(args){
			var params = {elements: args.attachments,showPath: false}
			if(args.hideForm){
				this.hideForm = args.hideForm;
				params.isNonEditableMode = true;
			}

			if(this.parentSection)//AttachmentsPlugin is the parent section
				params.parentSection = this.parentSection;
			this.gav = new GenericAttachmentViewer();//Pass dirty info to Attachments plugin
			this.gav.initialize(params);
			this._attachmentViewer.appendChild(this.gav.domNode);
		},
		
		setData: function(elements,removedElements,isNotScriptView){
			this._attachmentArray= [];
			dojox.data.dom.removeChildren(this._attachmentViewer);
			if(elements){
				var len = elements.length;
				if (isNotScriptView) {
					for (var i = 0; i < len; i++) {
						var attachment = elements[i];
                        
                        // make sure that we have one attribute or the other.
                        var fname = attachment.name || attachment.fileName;
                        var attachId = attachment.itemId || attachment.uuid;
                        
						var attachObj = {
							fileName: fname,
							id: attachment.id,
							size: attachment.size,
							uuid: attachId,
							isNew:attachment.isNew
						};
						this._attachmentArray.push(attachObj);
					}
				}else {
					for (var i = 0; i < len; i++) {
						var name = elements[i].propertyName;
						var value = elements[i].propertyValue;
						var arg = value.split(":");
						var attachObj = {
							fileName: arg[0],
							id: arg[1],
							size: arg[2],
							uuid: arg[3]
						};
						this._attachmentArray.push(attachObj);
					}
				}
			}
			if(removedElements){
				var len2 = removedElements.length;
				for(var j=0;j<len2;j++)
					this._attachmentArray.push(removedElements[j]);
			}
			this.initialize({hideForm: this.hideForm, attachments: this._attachmentArray})
		},

		getData: function(viewTitle,isNotScriptView){
			if(isNotScriptView){
				if(this.gav){
					return this.gav.getAllAttachments();	
				}else{
					return [];
				}
			}
			var returnData = new Array();
			var viewName = null;
			if(viewTitle && viewTitle.toLowerCase() == RESULT_ATTACHMENT_VIEW.toLowerCase())
				viewName = RESULT_ATTACHMENT_VIEW;
			else
				viewName = ATTACHMENT_VIEW;
			if(this.gav)
				this._attachmentArray = this.gav.getAllAttachments();
			var len = this._attachmentArray.length;
			for(var i=0;i<len; i++){
				if(this._attachmentArray[i].isRemoved == true)
					continue;
				returnData.push(viewName);
				var name = this._attachmentArray[i].fileName;
				var id = this._attachmentArray[i].id;
				var size = this._attachmentArray[i].size;
				var uuid = this._attachmentArray[i].uuid;
				returnData.push("fileName:id:size:uuid"+uuid);//TODO: Remove ID once changed from services
				returnData.push(name + ":" + id + ":" + size + ":" + uuid);
			}
			return returnData;		
		},
		getRemovedAttachments : function(){
			return this.gav.getRemovedAttachments();
		}
});
}
)();				
