/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container

var COMPARE_VIEW			="compareView"
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/properties/CompareView.html"),
		hideActual:false,
		editable:true,
		
		constructor: function(params){
			if(params.hideActual)
				this.hideActual = params.hideActual;
			if(params.editable)
				this.editable = params.editable;
			if(params.callback)
				this.callback = params.callback;
			if(params.callbackData)
				this.callbackData = params.callbackData;
			this.isForDataEntry = false;
		},
		postCreate: function(){
			this._initializeView();
		},
		setExpectedValue: function(comment){
			this._expectedtextArea.value = comment;
			this._expectedValue = comment;
		},
		setActualValue: function(comment){
			this._actualtextArea.value = comment;
			this._actualValue = comment;
		},
		setFocus:function(){
			//if(this.editable){
				this._expectedtextArea.focus();
				if(!this.isForDataEntry && !this.hideActual)
					this._actualtextArea.focus();
			//}
		},
		setDataEntryOnly:function(value){
			this.isForDataEntry = value;
		},
		getDataEntryOnly:function(){
			return this.isForDataEntry;
		},
		setData: function(elements,isNotScriptView){
			if(!elements || (!isNotScriptView && elements.length ==0)){
				this.setExpectedValue("");
				this.setActualValue("");
				return;
			}
			var name = "compare";
			var value = null;
			var expected = null;
			var actual = null;
			if (!isNotScriptView) {
				var len = elements.length;
				if ( len > 0) {
					for (var i = 0; i < len; i++) {
						name = elements[i].propertyName;
						if (name == "compare" || name == "dataentry") {
							value = true;
							var splitValues = elements[i].propertyValue.split(":");
							expected = splitValues[0];
							actual = splitValues[1] ? splitValues[1] : null;
							break;
						}
					}
				}
			}else{
				var splitVals = elements.split(":");
				if (splitVals.length == 1) {//compare with just expected
					value = true;
					expected = splitVals[0];
				}else if (splitVals.length == 2) { //dataentry with expected
					if (splitVals[0] == "dataentry") {
						name = "dataentry";
						value = true;
						expected = splitVals[1];
					}else {//compare with both expected and actual
						value = true;
						expected = splitVals[0];
						actual = splitVals[1];
					}
				}
			}
			if (value) {
				if (name == "compare" || name == "dataentry") {
					this.setExpectedValue(this._fixColon(expected, true));
					if (actual) {
						this.setActualValue(this._fixColon(actual, true));
						this._compare();
					}
					else 
						this.setActualValue("");
					if (!this.editable) 
						this._compare();
					if (name == "dataentry") {
						this.isForDataEntry = true;
						this._hideActualArea();
					}
					else {
						this.isForDataEntry = false;
						this._hideActualArea();
					}
				}
			}
		},
		getData: function(isNotScriptView){
			this.validatingText = false;
			this._validate();
			var expectedText = this._expectedValue;
			if (expectedText.length > 250) {
				expectedText = expectedText.substr(0, 249);
			}
			var value = this._fixColon(expectedText, false);
			if (!this.isForDataEntry && this._actualValue && this._actualValue.length > 0) {
				var actualText = this._actualValue;
				if (actualText.length > 250) {
					actualText = actualText.substr(0, 249);
				}
				value = value + ":" + this._fixColon(actualText, false);
			}
			if (isNotScriptView) {
				return this.isForDataEntry?"dataentry"+":"+value:value;
			}
			else {
				var returnData = new Array();
				returnData.push(COMPARE_VIEW);
				if (!this.isForDataEntry) 
					returnData.push("compare");
				else 
					returnData.push("dataentry");
				returnData.push(value);
				return returnData;
			}
		},
		_fixColon:function(value,reverse){
			if (reverse){
				var str = value.replace(/&colon;/g, ":");
			}else {
				var str = value.replace(/\:/g, "&colon;");
			}
			return str;
		},
		_hideActualArea:function(){
			if(this.isForDataEntry && !this.hideActual){
				this._expectedtextArea.readOnly = true;	
				dojo.addClass(this._actual,"hidden");
				if(this.actualAreaHandle) {
					this.disconnect(this.actualAreaHandle);
					this.actualAreaHandle = null;
				}
				if(this.expectedAreaHandle) {
					this.disconnect(this.expectedAreaHandle);
					this.expectedAreaHandle = null;
				}
				this._expectedtextAreaLabel.innerHTML = "<b>"+Constants.getMessage("labelDuringCompare")+"</b>";
			}else if (!this.hideActual) {
				this._expectedtextArea.readOnly = true;
				this._expectedtextAreaLabel.innerHTML = "<b>"+Constants.getMessage("labelDuringCompare")+"</b>";
				dojo.removeClass(this._actual, "hidden");
				this._actualtextAreaLabel.innerHTML = "<b>" + Constants.getMessage("labelToCompare") + "</b>";
				this.actualAreaHandle = this.connect(this._actualtextArea, "onkeypress", this._compare);
			}
			if(!this.editable){
				this._expectedtextArea.readOnly = true;
				this._actualtextArea.readOnly = true;
				if(this.actualAreaHandle) {
					this.disconnect(this.actualAreaHandle);
					this.actualAreaHandle = null;
				}
				if(this.expectedAreaHandle){
					this.disconnect(this.expectedAreaHandle);
					this.expectedAreaHandle = null;
				}
			}
		},
		
		_initializeView: function(){
			this._expectedtextAreaLabel.innerHTML = "<b>"+Constants.getMessage("labelForCompare")+"</b>";
			this.setExpectedValue("");
			this.expectedAreaHandle = this.connect(this._expectedtextArea, "onkeypress", this._validate);
			this.setActualValue("");
			this._resultLabel.innerHTML = Constants.getMessage("labelComparisonResult");
			this._hideActualArea(this.hideActual,this.editable);
		},
		_validate:function(e){
			if(e && (e.keyChar || e.keyCode) && !this.validatingText){
				setTimeout(dojo.hitch(this, this._validate), 1);
			}else{
				this.validatingText = true;
				if(this._expectedValue.length>250){
					this._msgArea.innerHTML = "<b>"+Constants.getMessage("labelError")+": "+Constants.getMessage("labelTextTooLong")+"<b>";
					dojo.removeClass(this._msgArea,"hidden");
					this.msgAreaShowing = true;
				}
				else if(this.msgAreaShowing == true){
					this._msgArea.innerHTML = "";
					dojo.addClass(this._msgArea,"hidden");
					this.msgAreaShowing = false;					
				}
				this._expectedValue = this._expectedtextArea.value;
				this.validatingText = false;
			}
	
		},
		_compare:function(e){
			if(e && (e.keyChar || e.keyCode)){
				if (!this.compareTimeout) {
					this.compareTimeout = setTimeout(dojo.hitch(this, this._compare), 500);
				}else{
					clearTimeout(this.compareTimeout);
					this.compareTimeout = setTimeout(dojo.hitch(this, this._compare), 500);
				}
			}else{
				this._actualValue = this._actualtextArea.value;
				if (this._actualValue.length > 250) {
					this._msgArea.innerHTML ="<b>"+Constants.getMessage("labelError")+": "+Constants.getMessage("labelTextTooLong")+"<b>";
					dojo.removeClass(this._msgArea, "hidden");
					this.msgAreaShowing = true;
				}else {
					if(this.msgAreaShowing == true){
						this._msgArea.innerHTML = "";
						dojo.addClass(this._msgArea,"hidden");
						this.msgAreaShowing = false;
					}
					if ((this._actualtextArea.value) == this._expectedValue) 
						this._resultLabel.innerHTML = Constants.getMessage("labelComparisonResult")+"<b>"+Constants.getMessage("labelSuccess")+"</b>";
					else 
						this._resultLabel.innerHTML = Constants.getMessage("labelComparisonResult")+"<b>"+Constants.getMessage("labelFailure")+"</b>";
				}
				delete this.compareTimeout;
			}
		},
		_onBlur:function(e){
			if(this.callback)
				this.callback(this.callbackData);
		},
		_error: function(errObj){
			alert("Error: (message: '" + errObj.message + "') from CompareView#_error");
		}
}
);

})();	
