/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009,2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");

/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");
(function() {
var SelectUtility 					= com.ibm.asq.common.web.ui.internal.util.SelectUtility;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var ExecutionElementResultStates	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog", [dijit._Widget, dijit._Templated],
{
		templateString: "<div class=\"com-ibm-rqm-construction-newitem-popup\">" +
                        	"<div dojoAttachPoint=\"_topMessageNode\" width=\"100%\"></div>" +
	                			"<table width=\"100%\">" +
	                				"<tr dojoAttachPoint=\"_verdictNode\">" +
	                					"<td width=\"150px\"><span><b>${labelVerdict}</b></span></td>"+ 
	                					"<td><select dojoAttachPoint=\"_verdicts\" class=\"newitem-popup-select\"></select></td>" +
										"<td></td>" +
	                				"</tr>" + 
									"<tr dojoAttachPoint=\"_onlyCurrentNode\">"+
										"<td colspan=3 style=\"padding-top:10px\">"+
											"<input type=\"checkbox\" dojoAttachPoint=\"onlyCurrentIteration\" dojoType=\"dijit.form.CheckBox\" style=\"margin-right:4px\"/>"+
											"<label>${labelOnlyCurrentIteration}</label>"+
										"</td>"+
									"</tr>"+
	                			"</table>" +
                        "</div>",
		
		labelVerdict: Constants.getMessage("labelStepResult"),
		labelOnlyCurrentIteration: Constants.getMessage("labelOnlyCurrentIteration"),
		widgetsInTemplate: true,
		postCreate: function(){		
			if(!this.okCallback || !this.verdictTypes || !this.parentEditor){
				throw Error("parentEditor, okCallback and verdictTypes are required fields")
			}
			if (this.showOnlyCurrent) {
				dojo.style(this._onlyCurrentNode,'display','');
				if (this.onlyCurrent) {
					this.onlyCurrentIteration.setChecked(true);
				}
				else 
					this.onlyCurrentIteration.setChecked(false);
			}else{
				dojo.style(this._onlyCurrentNode,'display','none');
			}
			this._topMessageNode.innerHTML = Constants.getMessage("msgApplyAllConfirmMessage");
		},

		initialize: function(){
			dojox.data.dom.removeChildren(this._verdicts);
			var types = this.verdictTypes;
			var selectItem = ExecutionElementResultStates.PASSED;
			if(this.selectedVerdictId){
				selectItem = this.selectedVerdictId; 
			}
			if(types != null){
				var typesLength = types.length;
				for (var i = 0; i < typesLength; i++){
					if(types[i].id == ExecutionElementResultStates.COMPLETE)
						continue;
					var opt = new Option(types[i].name, types[i].id);
					if(types[i].id === selectItem)
						opt.selected = true;
					SelectUtility.add( this._verdicts, opt );
				}
			}
			
			var dialogArgs = {
				primaryTitle: Constants.getMessage("labelApplyAllConfirm"),
                okCallback: dojo.hitch(this, "_onOK"),
				cancelCallback: dojo.hitch(this, "_onCancel"),
				movable: true
            };
			
            this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this.floatingPane.setWidth("30%");
			this.floatingPane.getOkButton().disabled = false;    
			this.floatingPane.contentContainer.appendChild(this.domNode);
			this.floatingPane.open();
		},
		
		_onOK: function(){
			this.floatingPane.getOkButton().disabled = true;
			var args = {
				verdict: this._verdicts.value,
				onlyCurrent:this.onlyCurrentIteration.checked
			}
			this.okCallback(args);
		},
		
		_onCancel: function(){
			
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from ApplyAllConfirmationDialog#_error");
		}
	}
);
}
)();
		
