/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.MachineDetails");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.MachineDetails");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {
var Constants                      = com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.MachineDetails", [dijit._Widget, dijit._Templated],
{
		templateString: "<div>"+
							"<table width=\"40%\"><tbody width=\"99%\">"+
								"<tr width=\"30%\">"+
									"<td width=\"50%\"><label>${labelMachineName}</label></td>"+
									"<td width=\"50%\"><label dojoAttachpoint=\"_machineName\"></label></td>"+
								"</tr>"+
								"<tr width=\"30%\">"+
									"<td width=\"50%\"><label>${labelIPaddress}</label></td>"+
									"<td width=\"50%\"><label dojoAttachpoint=\"_ipAddress\"></label></td>"+
								"</tr>"+
								"<tr width=\"30%\">"+
									"<td width=\"50%\"><label>${labelAdapterName}</label></td>"+
									"<td width=\"50%\"><label dojoAttachpoint=\"_adapterName\"></label></td>"+
								"</tr>"+
							"</tbody></table>"+
						"</div>",
		
		
		labelMachineName: Constants.getMessage("labelMachineName")+Constants.getMessage("labelColen"),
		labelIPaddress: Constants.getMessage("labelIPAddress")+Constants.getMessage("labelColen"),
		labelAdapterName: Constants.getMessage("labelAdapterName")+Constants.getMessage("labelColen"),
		
		postCreate: function() {
			if(this.adapter){
				this.initialize({adapter: this.adapter});
			}
		},
		
		initialize: function(args){
			if(!args || !args.adapter){
				console.error("selected adapter information was not found in the machine details widget");
				return;
			}else{
				this.adapter = args.adapter;
			}
			this._adapterName.innerHTML = this.adapter.name ? this.adapter.name : "";
			this._machineName.innerHTML = this.adapter.machine ? this.adapter.machine.name : "";
			this._ipAddress.innerHTML = this.adapter.machine ? this.adapter.machine.ipAddress : "";
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from MachineDetails#_error");
		}
	}
);
}
)();
		
