/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecutionLog");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
//Clients
dojo.require("dojo.parser");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");

(function() { // module container

var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ResultClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var RichTextControl 				= com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.NoScriptExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/NoScriptExecutionLog.html"),
		
		labelExecutionInformation: Constants.getMessage("labelExecutionInformation"),
		
		result: null,
		_testcase: null,
		_startTime: null,
		_endTime: null,
		_logName: null,

		widgetsInTemplate: true,

		postCreate: function() {		
			//Set Ids for this
			this.PASS_ID = this.id+"passValue";
			this.FAIL_ID = this.id+"failValue";
			this.UNATTEMPTED_ID = this.id+"unattemptedValue";
		},
		
		initialize: function(){
			this.isDirty = false;
			if(this.result){
				this.setResult(this.result);
				var args = {
						resultItemId: this._resultId,
						resolveDefects:true
						}
				var responseHandler=new ServiceResponseHandler(this, "_showAttachments", "_error");
			    ResultClient.getExecutionResultDTO(responseHandler, args);	
			}
			else
				this._showAttachments();
		},

		_setDescription:function(ewi){
		},

		_showAttachments: function(){
			var content = this.result && this.result.content ? this.result.content :"";
			if(this.result && !this.parentEditor._isPermitted()){//If not permitted to edit, dont show editor
				this._commentsEditor.innerHTML = content;
			}
			else{//if no result / permitted to edit show the editor
				//Add richtext editor here
				this._editor = new RichTextControl({
						inEditMode: false,
						save: dojo.hitch(this, function(){
							var editor = this.parentEditor;
							if(dojo.isFunction(editor.onSave)){
								editor.onSave();
							}
						})
						});
				this._commentsEditor.appendChild(this._editor.domNode);
				this._editor.setContentHTML(content);
				dojo.connect(this._editor, "onChange", this, "setDirty");
				this._editor.show();
				if(!this.result)
					this._editor.toggleEditMode();//Show editable if it is new
			}
		},

		_getTextBox: function(id, value, readonly){
			var txtbox = document.createElement('input');
			txtbox.type = 'input';
			txtbox.id = id;
			txtbox.value = value ? value : "";
			if(readonly){
				txtbox.disabled = true;
				txtbox.readonly = true;
			}
			return txtbox;
		},

		getAttributes: function(){
			if(!this.parentEditor._isPermitted())
				return null;
			var returnValues = {};
			if(this.isDirty) {
				returnValues.content = this._editor.getContentXHTML();
				returnValues.contentType = "application/xhtml+xml";
			}
			returnValues.attachments = [];
			return returnValues;
		},

		setResult: function(result){
			this.result = result;
			
			if(this.result && this.result.itemId != null){
				this._itemId = this.result.itemId;
			}	
			this._elementResults = null;
		},
		
		setDirty: function(){
			this.isDirty = true;
			if(!this.parentEditor.isDirty())
				this.parentEditor._setDirty(true);
		},
				
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ Scriptless ExecutionLog#_error");
		}
	});
})();
