/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
console.debug("Loading: com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecutionLog");
dojo.provide("com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");
dojo.require("dijit.TitlePane");	
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection");

(function() { // module container

var   ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var   Constants                        	= com.ibm.rqm.planning.web.client.internal.Constants;
var   Utility                          	= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var   AbstractArtifactEditorSection    	= com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var	  EditorUtil					   	= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var   REScriptEditorSection			   	= com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection;
var   resultDetailsTable				= null;						
var	  bTogglebgColor					= false;
var   nResultRowCount					= 0;
var   resultTable						= null;
var   resultTableBody					= null;
dojo.declare("com.ibm.rqm.adapter.robot.web.ui.internal.view.execution.RobotExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.robot.web", "ui/internal/view/templates/execution/RobotExecutionLog.html"),
		postCreate: function() {		
		},
	
		initialize: function()
		{
			var result = this.result;
				if (result.properties)
				{
					var resultPropertiesLength = result.properties.length;
					if(resultPropertiesLength > 0)
					{
						resultDetailsTable = null;
						resultDetailsTable = new Array();
						for (var i = 0; i < resultPropertiesLength; i++)
						{
							if(result.properties[i].propertyName != "message")
							{
								resultDetailsTable.push(result.properties[i].propertyName + "." + result.properties[i].propertyValue);
								nResultRowCount ++;
							}
						}
						resultDetailsTable.sort();
						this._detailsContainer.appendChild(document.createElement("br"));
						this.addResultarea();
					}
				}
		},
		addColumnData:function(rowElement,colType,dataString)
		{
			var colData = document.createElement("td");
			var lblData = document.createElement("label");
			if(colType == "Result")
			{
				var resultImg = document.createElement("img");
				resultImg.alt= "Result";
				resultImg.className = "type-image";
				if(dataString == "Pass")
				{
					resultImg.src = ImageCache.PASS_ICON;
					colData.appendChild(resultImg);
				}
				else if(dataString == "Fail")
				{
					resultImg.src = ImageCache.FAIL_ICON;
					colData.appendChild(resultImg);
				}
				else if(dataString == "Warning")
				{
					resultImg.src = ImageCache.INCON_ICON;
					colData.appendChild(resultImg);
				}
			}
			lblData.innerHTML = dataString;
			colData.appendChild(lblData);
			rowElement.appendChild(colData);
		},
		addRow:function(level,eventType,Result,lineNumber,scriptName,Remarks)
		{
			var row = document.createElement("tr");
			var indent = "&nbsp;&nbsp;&nbsp;";
			var fullIndent = "";
			for(var i=1;i<=level;i++)
			{
				fullIndent = fullIndent + indent;
			}
			eventType = fullIndent + eventType;
			this.addColumnData(row,"EventType",eventType);
			this.addColumnData(row,"Result",Result);
			this.addColumnData(row,"LineNumber",lineNumber);
			this.addColumnData(row,"ScrName",scriptName);
			this.addColumnData(row,"ScrName",Remarks);
			if(bTogglebgColor == true)
			{
				row.bgColor = "#F1F1F1";
				bTogglebgColor = false;
			}
			else
			{
				row.bgColor	= "white"
				bTogglebgColor = true;
			}
			this.resultTableBody.appendChild(row);
		},
		
		addColumnHeader:function(rowElement,colWidth, headerName)
		{
			var cellHeader = document.createElement("th");
			var lblHeader = document.createElement("label");
			lblHeader.innerHTML = headerName;
			cellHeader.appendChild(lblHeader);
			cellHeader.width = colWidth;
			rowElement.appendChild(cellHeader);
		},
		addTable: function(targetElement,numInitialRows,numCols)
		{
			//Create Table and set the headers
			var headerRow = document.createElement("tr");
			this.addColumnHeader(headerRow,"20%","Event Type");
			this.addColumnHeader(headerRow,"7%","Result");
			this.addColumnHeader(headerRow,"5%","Line#");
			this.addColumnHeader(headerRow,"10%","Script Name");
			this.addColumnHeader(headerRow,"58%","Remarks");
	
			headerRow.align = "center";
			headerRow.bgColor = "#F2F8FC";
			this.resultTableBody.appendChild(headerRow);
			this.fileareacontainer.appendChild(this.resultTable);
			this.fileareacontainer = document.createElement("div");
			//Uses level variable for indenting. Need to do something better
			var level = 1;
			//Extract the data from the customPropertyName. Robot adapter generate
			//the cust property name with inthe following pattern and send it to server.
			//LogSignature.Serial#.EventType.VpType.ResultType.LineNumber.ScriptName.AdditionalInfo
			var resultDetailsTableLength = resultDetailsTable.length
			for (var i = 0; i < resultDetailsTableLength; i++)
				{
					var propName = resultDetailsTable[i];
					propName =  propName.substring(propName.indexOf(".") + 1 , propName.length );
					propName =  propName.substring(propName.indexOf(".") + 1 , propName.length );
					var eventType = propName.substring(0 , propName.indexOf(".") );
					propName =  propName.substring(propName.indexOf(".") + 1 , propName.length );
					var vpType = propName.substring(0 , propName.indexOf(".") );
					propName =  propName.substring(propName.indexOf(".") + 1 , propName.length );
					var resultType = propName.substring(0 , propName.indexOf(".") );
					propName =  propName.substring(propName.indexOf(".") + 1 , propName.length );
					var lineNumber = propName.substring(0 , propName.indexOf(".") );
					propName =  propName.substring(propName.indexOf(".") + 1 , propName.length );
					var scriptName = propName.substring(0 , propName.indexOf(".") );
					propName =  propName.substring(propName.indexOf(".") + 1 , propName.length );
					var propValue = propName
					var eventTypeString = null;
					//Generate EventType String from the code letter
					switch(eventType)
					{
						case 'A': 	eventTypeString = "ScriptStart"; 
									level++;
									propValue = "Started Script Playback : " + scriptName; 
									break;
						case 'B': 	eventTypeString = "ScriptEnd"; 
									level--;
									propValue = "End Script Playback : " + scriptName;
									break;
						case 'C': 	eventTypeString = "CallScript"; 
									propValue = "Call another script : " + propValue;
									break;
						case 'D': 	eventTypeString = "ApplicationStart"; break;
						case 'E': 	eventTypeString = "VerificationPoint"; break;
						case 'F': 	eventTypeString = "LogMessage"; break;
						default:
									eventTypeString = "Unknown";
					}
					//Generate ResultType string from the code letter
					var res = null;
					if(resultType == "P")
					   res = "Pass";
					else if(resultType == "F")
					   res = "Fail"
					else if(resultType == "W")
						res = "Warning"   
					if(eventTypeString != "Unknown")
					  this.addRow( level,eventTypeString,res,lineNumber,scriptName,propValue);
				}
		},
		addResultarea: function()
	   {
	   		console.debug("addResultarea=>Init");
	   		if (this.viewfiletitlepane)
				return;
			this.resultTable =	document.createElement("table");
			this.resultTableBody = document.createElement("tbody");
			this.resultTable.appendChild(this.resultTableBody);
			this.viewfiletitlepane = new dijit.TitlePane({title: "Robot Playback Log", open: true, style:"overflow:auto;overflow-x:hidden;overflow-y:hidden;"});
			this.connect(this.viewfiletitlepane, "toggle", this.onViewFileToggle);
			this._detailsContainer.appendChild(this.viewfiletitlepane.domNode);
			this.fileareacontainer = document.createElement("div");
			this.viewfiletitlepane.setContent(this.fileareacontainer);
			this.addTable(this._detailsContainer,2,3);
		}
		
	}
);

}
)();
