/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.risk.web.ui.internal.view.extension.AssessmentSection");
dojo.provide("com.ibm.rqm.risk.web.ui.internal.view.extension.AssessmentSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");

// Require local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.table.RisksInSectionTableView");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskDiscussionWidget");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.CommunityRisk");
dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskDiscussionWidget");
dojo.require("com.ibm.rqm.risk.web.client.internal.risk.RiskClient");
dojo.require("com.ibm.rqm.risk.web.client.internal.mapper.SystemRiskMapper");

(function(){ // module container
    /* Jazz objects */
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    /* QM objects */
	var RichTextControl = com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var RiskAssessmentStar = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskAssessmentStar;
	var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var RiskUtil = com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
	var RiskClient = com.ibm.rqm.risk.web.client.internal.risk.RiskClient;
	var SystemRiskMapper = com.ibm.rqm.risk.web.client.internal.mapper.SystemRiskMapper;
	var DEFAULT_COMMENT_MSG = Constants.getMessage("msgCommentHere");
	var SHOW_COMMENTS_NUM = 2;
	
    dojo.declare("com.ibm.rqm.risk.web.ui.internal.view.extension.AssessmentSection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.risk.web", "ui/internal/view/templates/extension/AssessmentSection.html"),
        
		labelCommunity: Constants.getMessage("labelCommunityRiskTitle"),
		labelMine: Constants.getMessage("labelMyRiskTitle"),
		labelCalcu: Constants.getMessage("labelCalcuRiskTitle"),
		labelAverage: Constants.getMessage("labelShortAvg"),
		labelMore: Constants.getMessage("lavelMore"),
		labelAddComment: Constants.getMessage("msgCommentHere"),
		
        // object initializer
        constructor: function(args){
			this._isInitialized = false;
        },
        
		postCreate: function() {
			this.inherited('postCreate', arguments);
            this.addWorkItemSupport();		
		},	
		
		//@Overriden from AbstractArtifactEditorSection - invoked on first expand
        initialize: function(isEditable){
			
			this._isInitialized = true;
            var parentEditor = this.getParentEditor();
			switch (parentEditor.getArtifactType()) {
                case Constants.TYPE_CASE:
                    this.artifactType = Constants.MODEL_TYPE_CASE;
                    break;
                case Constants.TYPE_PLAN:
                    this.artifactType = Constants.MODEL_TYPE_PLAN;
                    break;
                default:
                    break;
            }
			this._initRichSection();
			if (!parentEditor.isNew()) {
				this.artifactItemId = parentEditor.getVersionableItemId();
				this.artifact = parentEditor.getArtifact();
				var args = {
					artifactType: this.artifactType,
					artifactItemId: this.artifactItemId,
					stateId: parentEditor.getStateId(),
					skipCreate: true
				}
				
				var responseHandler = new ServiceResponseHandler(this, "_initCommunityRisk", "_error");
				RiskClient.getCommunityRiskAssessmentDTO(responseHandler, args);
				var responseHandler = new SystemRiskMapper(this, "_initCalcuRisk", "_error");
				RiskClient.getSystemRiskAssessmentDTO(responseHandler, args);
			}
			else {
				this._initCommunityRisk({
					veryHighAmount: "0", highAmount: "0", neutralAmount: "0", lowAmount: "0", veryLowAmount: "0",
					myRanking: "0",	averageLevel: "0"
				});
				
				args = {
					artifactType: this.artifactType,
					skipCreate: true
				}
				var responseHandler = new SystemRiskMapper(this, "_initCalcuRisk", "_error");
				RiskClient.getSystemRiskAssessmentDTO(responseHandler, args);
			}
		},
        
		_initCommunityRisk: function(risk) {
			this.risk = risk;
			var communityRisk = {
				veryHighAmount: risk ? Number(risk.veryHighAmount) : 0,
				highAmount: risk ? Number(risk.highAmount) : 0,
				neutralAmount: risk ? Number(risk.neutralAmount) : 0,
				lowAmount: risk ? Number(risk.lowAmount) : 0,
				veryLowAmount: risk ? Number(risk.veryLowAmount) : 0,
				myRanking: risk ? Number(risk.myRanking) : 0,
				averageLevel: risk ? Number(risk.riskLevel) : 0
			}
			this._commImg.src = ImageCache.RISK_COMMUNITY;
			
			//community risk level
			this._commuRiskStar = this._createStarWidget(communityRisk.averageLevel, false);
			this.unloadContent(this._averageImage);
			this._averageImage.appendChild(this._commuRiskStar.domNode);
			dojox.data.dom.removeChildren(this.averageLabel);
			this.averageLabel.appendChild(document.createTextNode(RiskUtil.getRiskLabel(communityRisk.averageLevel)));
			RiskUtil.resetLevelLabelTextColor(this.averageLabel, RiskUtil.getRiskLabel(communityRisk.averageLevel));
			
			//community polls
			var community = new com.ibm.rqm.risk.web.ui.internal.view.assessment.CommunityRisk({
				risks: communityRisk
			});
			this.unloadContent(this._cummunity);
			this._cummunity.appendChild(community.domNode);
			
			//community comments
			this._addComments();
			
			this._initMyRisk(communityRisk);
		},
		
		_initMyRisk: function(individualRiskAssessment) {
			this.oldMyRanking = individualRiskAssessment.myRanking;
			this._myImg.src = ImageCache.RISK_MYRANKING;
			
			//community risk level
			this._myRiskStar = this._createStarWidget(individualRiskAssessment.myRanking, this.isEditable(), dojo.hitch(this, "_resetMyRiskLevelText"));
			this.unloadContent(this._myRiskImage);
			this._myRiskImage.appendChild(this._myRiskStar.domNode);
			dojox.data.dom.removeChildren(this.myRiskLabel);
			this.myRiskLabel.appendChild(document.createTextNode(RiskUtil.getRiskLabel(individualRiskAssessment.myRanking)));
			RiskUtil.resetLevelLabelTextColor(this.myRiskLabel, RiskUtil.getRiskLabel(individualRiskAssessment.myRanking));
			
			if (this.isEditable()) {
				//my comment
				var outerDiv = document.createElement("div");
				outerDiv.id = "comment-outer-div";
				var input = document.createElement("textarea");
				input.title = this.labelAddComment;
				input.name = "comment-input";
				dojo.addClass(input, "no-risk-label");
				dojo.addClass(input, "border-area");
				input.rows = "1";
				input.cols = "85";
				
				this.currentComment = this._getMyCurrentValue(this.risk.comments || []);
				input.value = this.currentComment;
				this._commentText = input;
				this.connect(input, "onfocus", function(){
					dojo.removeClass(input, "no-risk-label");
					var value = this._commentText.value;
					this._commentText.value = value && value == this.currentComment ? "" : value;
				});
				this.connect(input, "onblur", function(){
					dojo.addClass(input, "no-risk-label");
					var value = this._commentText.value;
					this._commentText.value = value && dojo.trim(value) != "" ? value : this.currentComment;
				});
				this.connect(input, "onkeypress", function() {
					this.setDirty();
				});
				outerDiv.appendChild(input);
				dojox.data.dom.removeChildren(this._myComment);
				this._myComment.appendChild(outerDiv);
			}
		},
		
		_getMyCurrentValue: function(comments) {
			var currentComment = DEFAULT_COMMENT_MSG;
			var currentUserItemId = EditorUtil.getCurrentContributor().itemId;
			for(var i = comments.length - 1; i >= 0; i--) {
				if(comments[i].creator.itemId == currentUserItemId) {
					currentComment = comments[i].content;
					return currentComment;
				}
			} 
			return currentComment;
		},
		
		_resetMyRiskLevelText: function(newLevel) {
			dojox.data.dom.removeChildren(this.myRiskLabel);
			this.myRiskLabel.appendChild(document.createTextNode(RiskUtil.getRiskLabel(newLevel)));
			RiskUtil.resetLevelLabelTextColor(this.myRiskLabel, RiskUtil.getRiskLabel(newLevel));
			this.setDirty();
		},
		
		_initCalcuRisk: function(systemRiskAssessment) {
			systemRiskAssessment.riskLevel = systemRiskAssessment && systemRiskAssessment.riskLevel ? Number(systemRiskAssessment.riskLevel) : 0;
			this.systemRiskAssessment = systemRiskAssessment;
			this._calcuImg.src = ImageCache.RISK_CALCULATED;
			
			//calcu risk level
			this._calcuStar = this._createStarWidget(systemRiskAssessment.riskLevel, false);
			this.unloadContent(this._calcuRiskImage);
			this._calcuRiskImage.appendChild(this._calcuStar.domNode);
			dojox.data.dom.removeChildren(this.calcuRiskLabel);
			var label = RiskUtil.getRiskLabel(systemRiskAssessment.riskLevel);
			this.calcuRiskLabel.appendChild(document.createTextNode(label));
			RiskUtil.resetLevelLabelTextColor(this.calcuRiskLabel, RiskUtil.getRiskLabel(label));
			
			this._setCalcuTable(systemRiskAssessment);
		},
		
		_initRichSection: function() {
			//create the rich text control
			dojox.data.dom.removeChildren(this._richContent);
			if (!this._richText) {
				this._richText = new RichTextControl({
                    editable: this.isEditable(),
					inEditMode: false,  //default to preview mode
					minHeight: "2em",
					contentHTML: this.getSection().content ? this.getSection().content : "",
					save: dojo.hitch(this, function(){
						var editor = this.getParentEditor();
						if(dojo.isFunction(editor.onSave)){
							editor.onSave();
						}
					})
				});
				dojo.connect(this._richText, "onChange", this, "setDirty");
			} else {
				this._richText.setContentHTML(this.getSection().content);
			}			
			this._richContent.appendChild(this._richText.domNode);     
		},
		
        _createStarWidget: function(value, editable, onChangeHandler) {
			var star = new RiskAssessmentStar({
				value: value,
				editable: editable,
				onChangeHandler: editable ? onChangeHandler : null
			});
			dojo.addClass(star.domNode, "inlineRiskLevel");
			return star;
		},
		
		_setCalcuTable: function(systemRiskAssessment) {
			var parentEditor = this.getParentEditor();
            this.riskTable = new com.ibm.rqm.risk.web.ui.internal.view.table.RisksInSectionTableView({
				artifactType: this.artifactType,
				artifact: parentEditor.getArtifact(),
				editable: this.isEditable(),
                printable: this.isPrintView(),
                typeName: this.artifactType,
                contents: [],
				isInSection: true,
				parentSection: this
            });
            this.unloadContent(this._calcuTable);
            this._calcuTable.appendChild(this.riskTable.domNode);
			
			if (systemRiskAssessment){ 
				//if user has assessed, then refresh the table
				var assessElements = systemRiskAssessment.assessElements || [];
				this.riskTable.refresh(parentEditor.getArtifactType(), assessElements);
			}
		},
		
		_addComments: function() {
			var comments = this.risk.comments || [];
			if (comments && comments.length > 0) {
				var showedComments = comments;
				if (comments.length > SHOW_COMMENTS_NUM) 
					showedComments = comments.slice(0, 2);
				var commentDiv = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskDiscussionWidget({
					comments: showedComments,
					commentsNum: comments.length,
					editable: false,
					isCollapsible: false,
					isHideAllComments: false
				});
				this.unloadContent(this._comments);
				this._comments.appendChild(commentDiv.domNode);
				
				if (comments.length > SHOW_COMMENTS_NUM) {
					//display more
					this._commentsMore.style.display = "";
				}
				this._commentsTD.style.display = "";
			}
			else {
				this._commentsTD.style.display = "none";
			}
		},
		
		_onCommentsClick: function() {
			var comments = this.risk.comments || [];
			var commentsWidget = new com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskDiscussionWidget({
                comments: comments,
				commentsNum: comments.length,
                editable: false,
                isCollapsible: false,
                isHideAllComments: false
            });
            
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelAllCommentsTitle"),
                width: "40%"
            };
            
            var dialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(dialogArgs);
            dialog.contentContainer.appendChild(commentsWidget.domNode);
            dialog.open();
		},
		
		//@Overridden from AbstractArtifactEditorSection
        getExpandHandler: /* Function */ function() {
            return dojo.hitch(this, "_showRichText");
        },
		
        _showRichText: function() {
            if (this._richText) {
                this._richText.show();
            }
        },
		
		//returns the persistent section DTO
		//@Overridden from AbstractArtifactEditorSection
        getSectionInfo: function() {      
            this.inherited("getSectionInfo", arguments);
            if (this._richText || this.getSection().content) {
                var strValue = this._richText ? this._richText.getContentHTML() : this.getSection().content;
                this.getSection().attributes = [];
                this.getSection().attributes.push({
                    type: "richtext",
                    name: "content",
                    value: strValue ? dojo.trim(strValue) : ""
                });
            }
			return this.getSection();
        },
		
		//@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
            this.addWorkItemSupport();
			if (this._isInitialized) {
				this.artifactItemId = this.getParentEditor().getVersionableItemId();
				var args = {
					artifactType: this.artifactType,
					artifactItemId: this.artifactItemId
				}
				if(this._myRiskStar.getValue() != this.oldMyRanking)
					args.ranking = this._myRiskStar.getValue();
				
				var value = this._commentText.value;
				if(value && dojo.trim(value) != "" &&  dojo.trim(value) != this.currentComment)
					args.comment = dojo.trim(value);
					
				var results = this.riskTable.getCurrentValues();
				if(results)
					dojo.mixin(args, results);
				var self = this;
				var handler = {
					success: function(artifactDTO){
						self.getParentEditor().setArtifact(artifactDTO);
						self.initialize();
					},
					error: function(e){
						self._error(e);
					}
				}
				var responseHandler = new ServiceResponseHandler(handler, "success", "error");
				if(this.artifactType == Constants.MODEL_TYPE_PLAN) {
					RiskClient.postTestPlanFullRisk(responseHandler, args)
				}else if(this.artifactType == Constants.MODEL_TYPE_CASE) {
					RiskClient.postTestCaseFullRisk(responseHandler, args)
				}
			}
        },
		reset:function(){
			if(this._richText){
				this._richText._doPreview();
			}
		},
        _error: function(e){
            console.debug("An error occurred: [" + e.message + "] @ AssessmentSection#_error");
        }
    });
    
})();
