/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.buildintegration.web.ui.internal.view.extension.BuildsActionBarEntry");
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.extension.BuildsActionBarEntry");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

(function() 
{
	var PageRegistry 		= net.jazz.ajax.ui.internal.PageRegistry;
    var BuildUiUtil 		= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
	var PermissionsClient   = com.ibm.asq.common.web.client.internal.PermissionsClient;
	
	dojo.declare(
		"com.ibm.rqm.buildintegration.web.ui.internal.view.extension.BuildsActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function(){
			},
	
			postCreate: function(args){
				this._loadClassAsync("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient", null);
			},
			
			initialize: function(args){
				var buildDefPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_BUILD_DEFINITION);
				var buildRecPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_BUILD_RECORD);
				com.ibm.rqm.buildintegration.web.ui.internal.view.extension.BuildsActionBarEntry.superclass.initialize.call(this, args);
				
				if (!buildRecPerm || buildRecPerm.create) {
					this._addMenuEntry(BuildUiUtil.getMessage("labelCreateBuildRecord"), dojo.hitch(this, "_onClickCreateBuild"), false, {
						'subAction': "newBuild",
						'tq': ""
					});
				}
				this._addMenuEntry(BuildUiUtil.getMessage("labelViewBuildRecords"), dojo.hitch(this, "_onClickAllBuilds"),false, {'subAction': "viewBuilds"});
				this._addMenuSeparator();
				// Build Definitions
				if (!buildDefPerm || buildDefPerm.create) {
					this._addMenuEntry(BuildUiUtil.getMessage("labelCreateBuildDef"), dojo.hitch(this, "_onClickCreateBuildDef"), false, {
						'subAction': "newBuildDef",
						'tq': ""
					});
				}
				this._addMenuEntry(BuildUiUtil.getMessage("labelViewBuildDef"), dojo.hitch(this, "_onClickAllBuildDefs"),false, {'subAction': "viewBuildDefs"});
				if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("editBuild", dojo.hitch(this, "editBuild"));
					this.actionDispatcher.registerDispatchAction("editBuildDef", dojo.hitch(this, "editBuildDef"));
				}
			},
			_onClickAllBuilds: function(){
				var func = function(tab, onComplete) {
					var buildList = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList({parent: this, editable: true, rowCheckable: true});
					buildList.artifactsDisplayContainer = this._contentArea;
                    onComplete(tab, buildList);
                };
                var loadFunc = function(tab, onComplete){
                    var classname = "com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildList";
                    this._loadClassAsync(classname, dojo.hitch(this, func, tab, onComplete));
                }                
                var browserTitle = BuildUiUtil.getMessage("labelBuildRecord") + BuildUiUtil.getMessage("labelColen") +" " + BuildUiUtil.getMessage("labelAllView");
                this._addPage({
                    name: BuildUiUtil.getMessage("labelViewBuildRecs"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
			},
			
			_onClickAllBuildDefs: function(){
				var func = function(tab, onComplete) {
					var buildList = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildDefList();
                    onComplete(tab, buildList);
                };
                var loadFunc = function(tab, onComplete){
                    var classname = "com.ibm.rqm.buildintegration.web.ui.internal.view.build.BuildDefList";
                    this._loadClassAsync(classname, dojo.hitch(this, func, tab, onComplete));
                }                
                var browserTitle = BuildUiUtil.getMessage("labelBuildDef") + BuildUiUtil.getMessage("labelColen") +" " + BuildUiUtil.getMessage("labelAllView");
                this._addPage({
                    name: BuildUiUtil.getMessage("labelViewBuildDefs"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
			},
            _openBuildRecEditor: function(name, args) {
                var _openBuildEditor = function(tab, onComplete){
                    var editor = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildRecord(args);
                    tab.controlButton.containerNode.className = "build-rec-icon-16-inTab";
                    editor.page = tab;                    
                    onComplete(tab, editor);
                    editor._updateBrowserTitle();
                }; 
                var loadFunc = function(tab, onComplete){
                    var classname = "com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildRecord";
                    this._loadClassAsync(classname, dojo.hitch(this, _openBuildEditor, tab, onComplete));
                };                
                this._addPage({
                    name: name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });                
            },
			_onClickCreateBuild:function(){
                this._openBuildRecEditor(BuildUiUtil.getMessage("labelNewBuildRec"), {});
			},
            _openBuildDefEditor: function(name, args) {                 
                var _openBuildEditor = function(tab, onComplete){
                    var editor = new com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildDef(args);
                    tab.controlButton.containerNode.className = "build-def-icon-16-inTab";  
                    editor.page = tab;                      
                    onComplete(tab, editor);
                    editor._updateBrowserTitle();
                }; 
                var loadFunc = function(tab, onComplete){
                    var classname = "com.ibm.rqm.buildintegration.web.ui.internal.view.build.EditBuildDef";
                    this._loadClassAsync(classname, dojo.hitch(this, _openBuildEditor, tab, onComplete));
                }               
                this._addPage({
                    name: name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                }); 
            },
			_onClickCreateBuildDef:function(){
                this._openBuildDefEditor(BuildUiUtil.getMessage("labelNewBuildDef"), {});
			},
			editBuild:function(args){
                this._openBuildRecEditor("", {buildId:args.id});
			},
			editBuildDef:function(args){
                this._openBuildDefEditor("", {buildDefId:args.id});
			}		
		}
	);
}
)();
