/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.ExecutionActionBarEntry");

dojo.require("com.ibm.team.repository.web.client.session.Session");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");

(function() 
{
	var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
    var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var Utility                         = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var PermissionsClient          		= com.ibm.asq.common.web.client.internal.PermissionsClient;
	var RegistryClient					= com.ibm.rqm.planning.web.client.internal.RegistryClient;
	var ExecutionElementResultStates	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;
	
	dojo.declare(
		"com.ibm.rqm.execution.web.ui.internal.view.extension.ExecutionActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function(){
				this._executionElementResultStates = []; 			 
			},
	
			postCreate: function(args){
				setTimeout(dojo.hitch(this,function(){
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.administration.ExecutionStatesEditor",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionResultTableView",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ScriptComboCellRenderer",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.TextComboCellRenderer",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.common.TestCaseConfigSelector",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTestCasesTableView",null);
					this._loadClassAsync("com.ibm.rqm.adapter.rpt.web.ui.internal.RptUiUtil",null);
				}),100);
				setTimeout(dojo.hitch(this,function(){
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.AdapterSelector",dojo.hitch(this,
							"_loadClassAsync","com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileBrowser",dojo.hitch(this,
								"_loadClassAsync","com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileSelector",dojo.hitch(this,
									"_loadClassAsync","com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection",null)))));
				}),10);
				setTimeout(dojo.hitch(this,function(){
					this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestCellTableView",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordSelectionTableView",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common.StepTypeSelector",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceStepsTableView",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultStepsTableView",dojo.hitch(this,
						"_loadClassAsync","com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultTableView",null
					))))))))))))));	
					this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.client.internal.mapper.ExecutionSequenceMapper",null);				
				}),10)
			},
			
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry.superclass.initialize.call(this, args);
				this.inherited('initialize', arguments);
				
                var tcPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
                var ewiPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
                var tsuitePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);	
				var resultPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_RESULT); 
				var seqPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_SEQUENCE); 			

                //'All Test Execution Records' entry
				this._addMenuEntry(Constants.getMessage("labelAllEWI"), dojo.hitch(this, "_onClickAllExecutionWorkItems"), false, {'subAction':"viewExecutedItems"});
				this._addMenuSeparator();
				
				//'View Test Suites' entry
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelAllTestSuite"), dojo.hitch(this, "_onClickAllTestSuites"), false, null);
				this._addMenuSeparator();

                //'View Execution Results' entry
				this._addMenuEntry(Constants.getMessage("labelViewTestcaseResults"), dojo.hitch(this, "_onClickViewExecutionResults"), false, {'subAction': "viewResults"});
				this._addMenuEntry(Constants.getMessage("labelAllSuiteResult"), dojo.hitch(this, "_onClickViewSuiteResults"), false, {'subAction': "viewSuiteResults"});
				this._addMenuSeparator();
                
                //'All Test Cases' entry
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelAllTestCase"), dojo.hitch(this, "_onClickAllTestCases"), false, null);
				
				//Sequence				
				this._addMenuSeparator();

				if(!seqPerm || seqPerm.create)
					this._addMenuEntry(Constants.getMessage("labelNewSequence"), dojo.hitch(this, "_onClickNewSequence"), false, {'subAction': "newSequence", 'tq': ""});
				this._addMenuEntry(Constants.getMessage("labelViewSequences"), dojo.hitch(this, "_onClickAllSequence"), false, {'subAction': "viewSequences"});

				this._addMenuSeparator();
				
				//'Execution Console' entry
				this._addMenuEntry(Constants.getMessage("labelExecCon"), dojo.hitch(this, "_onClickShowExecutionConsole"), false, {'subAction':"viewExecutionConsole"});
				//'Adapter Status' entry
				this._addMenuEntry(Constants.getMessage("labelAdapterConsole"), dojo.hitch(this, "_onClickShowAdapterStatus"), false, {'subAction': "viewAdapterStatus"});

				//register actions with the dispatcher
				if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("startExecution", dojo.hitch(this, "startExecution"));
                    this.actionDispatcher.registerDispatchAction("viewResult", dojo.hitch(this, "showResult"));
					this.actionDispatcher.registerDispatchAction("viewEWIResults", dojo.hitch(this, "showEWIResults"));
					this.actionDispatcher.registerDispatchAction("runSuite", dojo.hitch(this, "runSuite"));
					this.actionDispatcher.registerDispatchAction("showSuiteResult", dojo.hitch(this, "showSuiteResult"));
					this.actionDispatcher.registerDispatchAction("viewSequence", dojo.hitch(this, "viewSequence"));
					this.actionDispatcher.registerDispatchAction("viewSequenceResults", dojo.hitch(this, "viewSequenceResults"));
					this.actionDispatcher.registerDispatchAction("viewSequenceResult", dojo.hitch(this, "viewSequenceResult"));
                }
				setTimeout(dojo.hitch(this,function(){
					var handler= new ServiceResponseHandler(this, "setElementResultStateTypes", "_error");
					RegistryClient.getAllExecutionElementResultStateTypes(handler);
				}),1000);
			},
			
			setElementResultStateTypes: function(types){
				if(types && types.length > 0){
					var typesLength = types.length;
					for(var i=0;i<typesLength;i++){
						types[i].name = ExecutionElementResultStates.LABELS[types[i].id];
					}
					this._executionElementResultStates = types;
				}
			},
			
			getElementResultStates: function(){
				return this._executionElementResultStates;
			},
			
			_onClickNewSequence: function(){
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor", dojo.hitch(this, "_openSequenceEditor", tab, onComplete));
                }                
                var title = Constants.getMessage("labelNewSequence");
                var view = this._addPage( {
                    name: title,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: title
                });
			},
			
			_openSequenceEditor: function(tab, onComplete, args){
                args = args || {};
                args.parentController = this
				var editor = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor(args);
				editor.initialize();
                onComplete(tab, editor);
			},
			
			_onClickAllSequence: function(){
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceTableView", dojo.hitch(this, "_viewAllSequence", tab, onComplete));
               }
				var queryName =  Constants.getMessage("labelViewSequences");
                this._addPage( {
                    name: queryName,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: queryName
                });
			},
			
			_viewAllSequence: function(tab, onComplete){
				var queryName =  Constants.getMessage("labelViewSequences");
				try{
					var seqTable = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceTableView({
						queryName: queryName
					});
					seqTable.initialize();
                    onComplete(tab, seqTable);
				}catch(e){
					console.error("failed to create sequence table in EABE");
				}
			},
						
			viewSequence: function(kwArgs){
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor", dojo.hitch(this, "_openSequenceEditor", tab, onComplete, kwArgs));
                }                
                var view = this._addPage( {
                    name: Constants.getMessage("labelLoading"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			viewSequenceResults: function(args){
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceResultsPage", 
                    dojo.hitch(this, function(tab, onComplete) {
                        var view = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceResultsPage(args);
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                
                var title = Constants.getMessage("labelSequenceResultHistory");
				args.name = title;
				this._addPage({
                    name: args.name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: title
                });
			},
				
			viewSequenceResult: function(kwArgs){
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceLog", 
                    dojo.hitch(this, function(tab, onComplete) {
                        var view = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceLog(kwArgs);
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                                
                var title = Constants.getMessage("labelSequenceResult");
				kwArgs.name = title;
				this._addPage({
                    name: title,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: title
                });
			},
						
			_onClickAllTestSuites: function(){
                window.location.hash = Utility.getTestSuitesURI();
			},
			
			_onClickShowExecutionConsole: function(){
                var title = Constants.getMessage("labelExecCon");
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole", 
                    dojo.hitch(this, function(tab, onComplete) {
                        var args = {
                            parentController: this,
                            name: title
                        };
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole(args);
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                                
                this._addPage({
                    name: title,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: title
                });
            },
			
			runSuite: function(kwArgs){
                var name = "Test Suite Execution";
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution", dojo.hitch(this, function(tab, onComplete){
                        var args = {};
                        args.parentController = this;
                        args.name = name;
                        if (kwArgs.groupId) 
                            args.groupId = kwArgs.groupId;
                        if (kwArgs.itemId) 
                            args.itemId = kwArgs.itemId;
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution(args);
                        view.page = tab;
                        onComplete(tab, view);
                        view._updateBrowserTitle();
                    }, tab, onComplete));
                }                                
				var page = this._addPage({
                    name: name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			showSuiteResult: function(kwArgs){
                var name = Constants.getMessage("labelSuiteResult");
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog", dojo.hitch(this, function(tab, onComplete){
                        var args = {};
                        args.parentController = this;
                        args.name = name;
                        if (kwArgs.id) 
                            args.suiteId = kwArgs.id;
                        if (kwArgs.itemId) 
                            args.itemId = kwArgs.itemId;
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog(args);
                        view.page = tab;
                        onComplete(tab, view);
                        view._updateBrowserTitle();
                    }, tab, onComplete));
                }                                
				var page = this._addPage({
                    name: name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			_onClickMyExecutionWorkItems: function()
			{
				var args = {};
				args.name = Constants.getMessage("labelMyEWI");
				args.owner = getAuthenticatedContributor().userId;
				args.browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView");
				this._showEwiList(args);
			},
			
			_onClickAllExecutionWorkItems: function()
			{
				var args = {};
				args.name = Constants.getMessage("labelAllEWI");
				args.browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                args.showQueryFilters = true;
                args.contentIsVirtual = true;
                var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
				args.enableRowEditable = (!permission || permission[PermissionsClient.ACTION_EDIT]);
				this._showEwiList(args);
			},
			
			_showEwiList: function(args)
			{
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList", 
                    dojo.hitch(this, function(tab, onComplete) {
                        args.parentController = this;
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList(args);
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                                
				this._addPage({
                    name: args.name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: args.browserTitle
                });
			},
			
			_onClickViewExecutionResults: function()
			{
                var args = {
                    name: Constants.getMessage("labelViewTestcaseResults"),
                    browserTitle: Constants.getMessage("labelExeResult") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelAllView")
                };
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView", dojo.hitch(this, function(tab, onComplete){
                        //create and display the results table viewer (empty)
                        var widgetArgs = {
                            results: [],
                            showQueryFilters: true,
                            queryName: args.name
                        };
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView(widgetArgs);
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                               
                this._addPage({
                    name: args.name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: args.browserTitle
                });    								
			},
			_onClickViewSuiteResults:function(){
				var name =  Constants.getMessage("labelAllSuiteResult");
				var browserTitle =  Constants.getMessage("labelSuiteResult") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.SuiteLogTableView", dojo.hitch(this, function(tab, onComplete){
                        //create and display the results table viewer (empty)
                        var args = {
                            results: [],
                            showQueryFilters: true,
                            queryName: name
                        };
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.table.SuiteLogTableView(args);
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                               
                
                this._addPage({
                    name: name,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
			},
			startExecution: function(kwArgs)
			{
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody", dojo.hitch(this, function(tab, onComplete){
                        var ewi = kwArgs.ewi;
                        var runScript = kwArgs.runScript;
                        var _resultId = null;
                        var requestId = null;
                        var ergId = null;
                        if (kwArgs._resultId) 
                            _resultId = kwArgs._resultId;
                        if (kwArgs.requestId) 
                            requestId = kwArgs.requestId;
                        if (kwArgs.ergId) 
                            ergId = kwArgs.ergId;
                        
                        var args = {
                            parentController: this,
                            ewi: ewi,
                            runScript: runScript,
                            _resultId: _resultId,
                            requestId: requestId,
                            ergId: ergId
                        };
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody(args);
                        view.page = tab;                        
                        onComplete(tab, view);
                        view._updateBrowserTitle();
                    }, tab, onComplete));
               }
				var page = this._addPage({
                    name: Constants.getMessage("labelExecution"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true
                });
			},
			
			showResult: function(kwArgs)
			{
                var func = function(tab, onComplete){
                    var args = {
                        parentController: this,
                        ewiId: kwArgs.ewiId
                    };
                    if (kwArgs.resultItemId) {
                        args.resultItemId = kwArgs.resultItemId;
                    }
                    if (kwArgs.id) {
                        args.id = kwArgs.id;
                    }
                    if (kwArgs.editable) 
                        args.editable = kwArgs.editable;
                    var view = new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody(args);
                    onComplete(tab, view);
                }
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody", dojo.hitch(this, func, tab, onComplete));
                }
				this._addPage({name: Constants.getMessage("labelExeResult"), 
                    onDeferredLoad: dojo.hitch(this, loadFunc),
					closable: true,
					browserTitle: Constants.getMessage("labelExeResult")	
				});
			},
			
			showEWIResults: function(args){
                var func = function(tab, onComplete){
                    var _resultHistory = new com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory({
                        parentController: this,
                        ewiItemId: args.ewiItemId
                    });
                    onComplete(tab, _resultHistory);
                }
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory", dojo.hitch(this, func, tab, onComplete));
                }
                this._addPage({
                    name: Constants.getMessage("labelResultHist"),
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: Constants.getMessage("labelResultHist")
                });
            },
			
			_onClickMyTestCases: function()
			{
                window.location.hash = Utility.getMyTestCasesURI();
			},
            
            _onClickAllTestCases: function()
            {
                window.location.hash = Utility.getTestCasesURI();
            },
			
			_onClickShowAdapterStatus: function(){
				var queryName = Constants.getMessage("labelAdapterConsole");
                var loadFunc = function(tab, onComplete){
                    this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView", dojo.hitch(this, function(tab, onComplete){
                        var args = {};
                        args.parentController = this;
                        args.queryName = queryName
                        args.hideReservationNode = true;
                        var view = new com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView(args);
                        view.setInProgress(Constants.getMessage("msgQueryTableList", Constants.getMessage("labelAdapters")));
                        onComplete(tab, view);
                    }, tab, onComplete));
                }                             
                var browserTitle = Constants.getMessage("labelAdapterConsole");
				this._addPage({
                    name: queryName,
                    onDeferredLoad: dojo.hitch(this, loadFunc),
                    closable: true,
                    browserTitle: browserTitle
                });
			},
			
			_error: function(error) 
			{
				console.debug(this.declaredClass + ": Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
