/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.rft.web.ui.internal.view.extension.RFTScriptEditorSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");
dojo.require("dijit.TitlePane");	
dojo.require("dijit.InlineEditBox");
dojo.require("dijit.form.CheckBox");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dijit.form.ComboBox");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.InlineEditor");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection");

dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");

(function() { // module container

var   Constants                        = com.ibm.rqm.planning.web.client.internal.Constants;
var   Utility                          = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var	  EditorUtil					   = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var   ScriptClient 					   = com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient;
var   FULLPATH					       = "ScriptPath";
var   ARGUMENTS					       = "arguments";
var   REScriptEditorSection			   = com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection;
var   sourcenode 					   = null;
var   viewfiletitlepane 			   = null;
var   viewFileEditBox                  = null;
var   viewFileSetcode                  = false;
var   editbox                          = com.ibm.asq.common.web.ui.internal.widgets.InlineEditArea;
var   TeamServerClient                 = com.ibm.team.repository.web.transport.TeamServerClient;
var   viewFileContentDetails           = {fileName: null, testplan: null, iteration: null};
var   PlanClient					   = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
var   TimeBoxClient					   = com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var   _TP                              = null;
var   scriptArgsBox                    = null;
var   scriptargstitlePane              = null;
var   includeIteration 			   	   = false;
var   RftUiUtil						   = null;
var   X_AUTH_MSG 					   = "X-com-ibm-team-repository-web-auth-msg";
var ServiceResponseHandler			   = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

dojo.declare(
   	"com.ibm.rqm.adapter.rft.web.ui.internal.view.extension.RFTScriptEditorSection", 
   	[dijit._Widget, dijit._Templated, AbstractArtifactEditorSection, REScriptEditorSection], 
   	{
   	templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.rft.web", "ui/internal/view/templates/extension/RFTScriptEditorSection.html"),
   	allPlans: [],
	constructor: function(args) {
		this._script = args.script;
	},
   
	postCreate: function() {
	},   

   	initialize: function(){
		if (!dojo.getObject("com.ibm.rqm.adapter.rft.web.ui.internal.RftUiUtil")){
			jazz.core.loader.load_async("com.ibm.rqm.adapter.rft.web.ui.internal.RftUiUtil", dojo.hitch(this,"_initialize2"));
		}else{
			this._initialize2();
		}
	},
	_initialize2:function(){
		RftUiUtil = com.ibm.rqm.adapter.rft.web.ui.internal.RftUiUtil;		
   		this.createBrowseSection(this._selectionArea, this._browseContainer, this._adapterContainer);
		if(!this._functionalScriptPathHandle && !this.parentEditor.isReadOnly())
	  		this._functionalScriptPathHandle = this.connect(this._functionalScriptPath, "onkeypress", this.setDirty);
		if(!this.adapterSelector._scriptPathHandle)
	  		this.adapterSelector._scriptPathHandle = this.connect(this.adapterSelector._scriptPath, "onkeypress", this.setDirty);
		this._sharePrefixBox.readOnly = true;
		if(this.parentEditor.isReadOnly())
			this._functionalScriptPath.readOnly = true;
		this.addscriptargs();	
		this._shareprefixlabel.innerHTML = Constants.getMessage("labelSharedLocation");
		this._typeOfScriptLabel.innerHTML = RftUiUtil.getMessage("labelRelativeScriptPath");
		if (this._script) 
				this.addfilearea();
	},
  	
   	updateAdapterRadioClicked: function() {
		dojo.style(this._shareprefixlabel, "display", "none");
		dojo.style(this._sharePrefixBox, "display", "none");	
		dojo.style(this._typeOfScriptLabel, "display", "none");
		dojo.style(this._functionalScriptPath, "display", "none");
		dojo.style(this.adapterSelector._labelScriptPath, "display", "inline");
	 	dojo.style(this.adapterSelector._scriptPath, "display", "inline");
		this.adapterSelector._scriptPath.disabled = false;
		if (this.viewfiletitlepane)	
			this.movefilepane();		
		if (this._script) 
			this.adapterSelector._scriptPath.value = this._script.fullPath;
	},
	
	updateBrowseRadioListener: function() {
		dojo.style(this.adapterSelector._labelScriptPath, "display", "none");
	 	dojo.style(this.adapterSelector._scriptPath, "display", "none");
		dojo.style(this._shareprefixlabel, "display", "inline");
		dojo.style(this._sharePrefixBox, "display", "inline");	
		dojo.style(this._typeOfScriptLabel, "display", "inline");
		dojo.style(this._functionalScriptPath, "display", "inline");
		if (this._script) {
			var relPath = this.stripLeadingSlash(this._script.relativePath);
			this._functionalScriptPath.value = relPath;
			
			if (this._script.sharePrefix) {
				this._sharePrefixBox.value = this._script.sharePrefix;
			} else {
				this._sharePrefixBox.value = "";
			}
			if (this.viewfiletitlepane)
				this.movefilepane();
		}
	},
	
	setSelectedFiles: function(resource){
		var fileList = resource.fileList;
		if(fileList && fileList.length >0){
			this._sharePrefixBox.value = this.initialPath;
			var relPath = this.fileList[0].resourceURN.substring(this.initialPath.length, this.fileList[0].resourceURN.length);
			relPath = this.stripLeadingSlash(relPath);
			this._functionalScriptPath.value = relPath;
		}
   },
   
   setAdapterInfo: function(param){
   	if(this.info.selectedAdapter)
	{
   		this.adapterSelector._scriptPath.value = this.info.scriptPath+ this.getFileSeperater() + this.info.selectedScript.name;
		this.adapterSelector._scriptPath.disabled = false;
	}
	else
	   	this.adapterSelector._scriptPath.value = "";
		
   },
   
      //@Overriden from RemoteExecutionScriptEditorSection
   getHelpContextID: function(){
      return null;
   },
   
   //@Overriden from RemoteExecutionScriptEditorSection
   getActions: function(){
      return [];
   },    
   
   getAttributes: function(){
		var args = {};
		if(this.browserUsage  == true){
			args.managedByAdapter = false;
			args.sharePrefix = this._sharePrefixBox.value
			var relPath = this._functionalScriptPath.value;
			args.relativePath = this.getFileSeperater() + relPath;
			this.absolutePath = this.fileList[0].resourceURN;
		}else if(this.adapterUsage == true){
			args.managedByAdapter = true;
			args.adapterId = this.info.selectedAdapter.id;
			args.fullPath = this.adapterSelector._scriptPath.value;
		}
		return args;
	},
	
   validate: function(){
	   	if (this.browserUsage  == true){
			if (!this._sharePrefixBox.value || dojo.trim(this._sharePrefixBox.value).length == 0) {
				this.setValidationError(RftUiUtil.getMessage("msgRequiredFieldSharedpath"));
				return false;
			} 
			if (!this._functionalScriptPath.value || dojo.trim(this._functionalScriptPath.value).length == 0) {
				this.setValidationError(RftUiUtil.getMessage("msgRequiredFieldSharedpath"));
				return false;
			} 
			
		} 
		
		if (this.adapterUsage == true) {
			if(!this.info || !this.info.selectedAdapter)
			{
				this.setValidationError(RftUiUtil.getMessage("msgRequiredFieldAdapter"));
				return false;
			}
			if ( dojo.trim(this.adapterSelector._scriptPath.value).length == 0) {
				alert("File need to be selected");
				return false;
			}
			return true;
		}
		return true;
   },
     
   //@Overridden from RemoteExecutionScriptEditorSection
   saveFinished: function(testScript){
      this._script = testScript;
	  this.addfilearea();
	 // this.initialize();
	 this.setSectionDirty(false);
   },  
   
  	
	
	//FILE AREA FUNCTIONS
	error: function(errorObj){
			console.error("Error in File Browser "+ errorObj.message + " ");
	},
	
   addfilearea: function()
   {
   		if (this.viewfiletitlepane)
			return;

		var viewName = RftUiUtil.getMessage("labelSourceView");
   		this.viewfiletitlepane = new dijit.TitlePane({title: viewName, open: false, style:"overflow:auto;overflow-x:hidden;overflow-y:hidden;"});
		this.connect(this.viewfiletitlepane, "toggle", this.onViewFileToggle);
		this._scriptInfo.appendChild(this.viewfiletitlepane.domNode);
			
	},
	
	movefilepane: function() 
	{
		if (!this.viewfiletitlepane)
			return;
			
		if (this.viewfiletitlepane.open == false)
			return;
			
		if (this.browserUsage == true)
		{		
			if (this.fileareacontainer) 
				dojo.style(this.fileareacontainer, "display", "inline");
			else 
				this.addfilearecontent();
				
			if (this.fileareamessage)
				dojo.style(this.fileareamessage, "display", "none");
		} else 
		{
			if (this.adapterUsage == true) {
				if (this.fileareacontainer) 
					dojo.style(this.fileareacontainer, "display", "none");
				if (this.fileareamessage) 
					dojo.style(this.fileareamessage, "display", "inline");	
				else 
					this.addfileareamessage();		
			}
		}
		
	},
	
	onViewFileToggle: function()
	{
		if (this.browserUsage == true)
			this.addfileareacontent();
			
		if (this.adapterUsage == true)	
			this.addfileareamessage();
			
	},
	
	addfileareamessage: function()
	{
		if (this.fileareamessage)
			true;
			
		this.fileareamessage = document.createElement('label');
		this.fileareamessage.innerHTML = RftUiUtil.getMessage("notfetchfile");
		this.viewfiletitlepane.setContent(this.fileareamessage);
	},
	
	addfileareacontent: function() 
	{
		if (this.fileareacontainer)
			return;
			
		this.fileareacontainer = document.createElement("div");
		var table = document.createElement("table");
		table.width=500;
		var row1 = document.createElement("tr");
		
		var cell11 = document.createElement("td");
		var testplanlabel = document.createElement('label');	
		testplanlabel.innerHTML = Constants.getMessage("labelTestPlan");
		dojo.style(testplanlabel, "fontSize", "9pt");
		dojo.style(testplanlabel, "font-family:Arial");
		cell11.appendChild(testplanlabel);
		
		var  cell12 = document.createElement("td");
		this._TP = document.createElement('select');
		dojo.style(this._TP, "width", "100%");
		dojo.style(this._TP, "font-family", "Arial");
		dojo.style(this._TP, "fontSize", "9pt");
		this.connect(this._TP, "onchange", this._planUpdated);
		cell12.appendChild(this._TP);
		this._TP.appendChild(new Option("Loading...", ""));
		
		var cell13 = document.createElement("td");
		var testiterationlabel = document.createElement('label');	
		testiterationlabel.innerHTML = Constants.getMessage("labelIteration");
		dojo.style(testiterationlabel, "fontSize", "9pt");
		dojo.style(testiterationlabel, "font-family:Arial");
		cell13.appendChild(testiterationlabel);
		
		var  cell14 = document.createElement("td");
		this._Iteration = document.createElement('select');
		dojo.style(this._Iteration, "width", "100%");
		dojo.style(this._Iteration, "font-family", "Arial");
		dojo.style(this._Iteration, "fontSize", "9pt");
		cell14.appendChild(this._Iteration);
		
		var cell15 = document.createElement("td");
		var button = document.createElement('button');
		button.innerHTML = RftUiUtil.getMessage("labelGetFile");
		dojo.style(button, "fontSize", "1em");
		this.connect(button, "onclick", this.getfile);
		cell15.appendChild(button);
				
		row1.appendChild(cell11);
		row1.appendChild(cell12);
		row1.appendChild(cell13);
		row1.appendChild(cell14);
		row1.appendChild(cell15);
		table.appendChild(row1);		
		this.fileareacontainer.appendChild(table);
		
		this.divnode = document.createElement("div");	 
		this.fileareacontainer.appendChild(this.divnode);
		
		this.viewfiletitlepane.setContent(this.fileareacontainer);
		
		var responseHandler = new ServiceResponseHandler(this, "_initTP", "error");
		PlanClient.getTestPlans(responseHandler, {});
   },
   
   
   
   _updateIterationCombo: function()
		{
			var planId = this._TP.value;
			dojox.data.dom.removeChildren(this._Iteration);
			if(planId ==="global" || this.includeIteration == false )
			{
				this._Iteration.disabled = true;
				return;
			}
			var allPlans = this.allPlans;
			var allPlansLen = allPlans.length;
			this._Iteration.disabled = false;
			for(var i=0;i<allPlansLen;i++)
			{
				var id = parseInt(planId, 10)
				if(allPlans[i].id === id)
				{
					var planIterations = allPlans[i].iterations;
					if(planIterations)
					{
						var planIterationsLength = planIterations.length;
						for(var i=0;i<planIterationsLength;i++)
						{
							var opt = new Option(planIterations[i].name, planIterations[i].itemId);
							this._Iteration.appendChild(opt);
						}
						break;	
					}else
						this._Iteration.disabled = true;
				}
			}
			if(this.parentEditor.isReadOnly()){
				this._TP.disabled = true;
				this._Iteration.disabled = true;
			}
				
		},
		
		_planUpdated: function(){
			this._updateIterationCombo();
			//this._updateLocations();
		},
		
   _appendIterations: function(iterations)
	{
		if(iterations && iterations.length > 0)
		{
			var allPlans = this.allPlans;
			var allPlansLength = allPlans.length;
			for(var i=0;i<allPlansLength;i++)
			{
				if(allPlans[i].versionableItemId === iterations[0].targetTestPlanUUID)
				{
					allPlans[i].iterations = iterations;
						break;
				}	
			}
		}
		this.planIterationReceived++;
		if(this.totalPlans == this.planIterationReceived)
			this._planUpdated();
	},
	
	getPlanLocation: function(plan, resources) {
		
		var loc = resources.location;
		if (loc == null || dojo.trim(loc).length == 0) 
			return null;
		var suffix = null;
		
		var optionArgs = {
				id: plan.id,
				location: resources.location,
				includeIteration: false 
		}	
		if (resources.resolvedPath.indexOf(Constants.INCLUDE_PLAN)!= -1){
			suffix = plan.name;
			optionArgs.location = optionArgs.location + this.getFileSeperater() + suffix;
		} 
			
		if (resources.resolvedPath.indexOf(Constants.INCLUDE_ITERATION)!= -1){
			optionArgs.includeIteration = true;
			this.includeIteration = true;
		}
							
		return optionArgs;
	},
		
  _initTP: function(plans){
			dojox.data.dom.removeChildren(this._TP);
			var optionVals = {
				id: "global",
				location: this._sharePrefixBox.value,
				includeIteration: false
			}
			this.TPOptionVals  = [];
			var option = new Option(Constants.getMessage("labelUnassigned"), 0);
			this.TPOptionVals.push(optionVals);
			this._TP.appendChild(option);
			this.totalPlans= plans.length;
			this.planIterationReceived = 0;
			var plansLength = plans.length;
			if(plans && plansLength>0){
				for(var i=0;i<plansLength;i++){
					var added = false;
					var sections = plans[i].sections;
					var resources = [];
					var sectionsLength = sections.length;
					for(var j=0;j<sectionsLength;j++){
						if(sections[j].id == "com.ibm.rqm.planning.editor.section.planResources") {
							resources = (sections[j].content != "" ? dojo.fromJson(sections[j].content) : [])
							if (resources) {
								var resourcesLength = resources.length;
								for (var k=0; k<resourcesLength;k++) {							
									if (resources[k].type == this.scriptType.name) {
										var loc = this.getPlanLocation(plans[i], resources[k]);
										if (loc)
										{
											var option = new Option(plans[i].name, this.TPOptionVals.length);
											this.TPOptionVals.push(loc);
											this._TP.appendChild(option);
											if (option.inlcudeIteration) {
												var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
												TimeBoxClient.getTestPhasesDTO(responseHandler, {testPlanId: plans[i].versionableItemId});
											}
										}
									}
								}
							}
						}	
					} /* end of section */
					plans[i].resources = resources;
					this.allPlans.push(plans[i]);
					
				}	
			}
		},
		
	//GET FILE FUNCTIONS 
	getFilePath:function() {
   		if(this.browserUsage  == true){
			if (this._TP)
			{
				var option = this.TPOptionVals[this._TP.options.selectedIndex]
				//var option = this._TP.options[this._TP.options.selectedIndex].value;
				var path = option.location + this.getFileSeperater() + this._functionalScriptPath.value;
				return path;
				
			} else 
			{
				var prefix = this._sharePrefixBox.value;
				var relPath = this._functionalScriptPath.value;
				
				return prefix + this.getFileSeperater() + relPath;
			}
		}/*else if(this.adapterUsage == true){
			return this.adapterSelector._scriptPath.value;
		}*/
   },
   
   getfile: function()
   {
		var responseHandler = new ServiceResponseHandler(this, "onTransferSuccess", "onTransferFailure");
		var filePath = this.getFilePath();
		if (!filePath)
			return;
		filePath = filePath.replace(/\.testsuite$/,"\.java");
		//TODO PASS good file when under testplan and iteration...
		var bindArgs = this.getBindArgs(filePath, responseHandler);
	  	var xhr = dojo.xhrGet(bindArgs).ioArgs.xhr;
      //	serviceRequest._setXMLHttpRequest(xhr);
   },
   
   getBindArgs: function(fileName, serviceResponseHandler) 
   {
   	
	var headers = {};
	headers["accept"] = "text/json";
	headers["content-type"] = "application/x-www-form-urlencoded; charset=utf-8";
	var bindArgs = {
		url: TeamServerClient._getServicePrefix() + "com.ibm.rqm.integration.service.IIntegrationService/resource" + "?resourceURN=" + fileName,
		handleAs: "text",
		headers: headers,
		preventCache: dojo.isIE,
		fileName: fileName,
		responseHandler: serviceResponseHandler,
		obj:this,
		handle: function(response, ioArgs){
			
			if (response instanceof Error) {
				var errorObj = {
					status: ioArgs.xhr.status,
					message: null,
					exception: undefined
				};
				if (ioArgs.xhr.status == 404)
				{
					if (fileName.match(/\.java$/))
					{
						var filePath = fileName.replace(/\.java$/, ".vb");
						var bindArgs = this.obj.getBindArgs(filePath, this.responseHandler);
	  					var xhr = dojo.xhrGet(bindArgs).ioArgs.xhr;
					} else 
					{
						errorObj.message = "Could not find the script" + this.fileName;
						serviceResponseHandler.doErrorCallback(errorObj);
					}
				}
				if (ioArgs.xhr.statusText === "Internal Server Error" || ioArgs.xhr.statusText === "Bad Request") {
					var errorResponse = ioArgs.xhr.responseText || "";
					errorResponse = dojo.fromJson(errorResponse);
					if (dojo.isObject(errorResponse)) {
						errorObj.message = "["+errorResponse.errorCode + "] : " + errorResponse.errorMessage;
						errorObj.exception = errorResponse;
					}
					else {
						errorObj.message = errorResponse;
						if (errorObj.message.indexOf("-- ") > 0 && errorObj.message.length > 3) {
							errorObj.message = errorObj.message.substring(errorObj.message.indexOf("-- ") + 3);
						}
						errorObj.message = errorObj.message.replace(/&#39;/g, "\"");
					}
					serviceResponseHandler.doErrorCallback(errorObj);
				}else if (ioArgs.xhr.getResponseHeader(X_AUTH_MSG) == "authrequired") {
					//TODO: Fix this
					TeamServerClient._loginPrompt(this, serviceResponseHandler, serviceRequest.getMethodType().toLowerCase());
				}
				else {
					errorObj.message = errorResponse;
				}		
			}else {
				serviceResponseHandler.doCallback(response);
			}	
		}
		};
		return bindArgs;
 	},
	
   	onTransferSuccess: function(obj) {
   		var value = obj.replace(/</gm, "&amp;lt;").replace(/>/gm, "&amp;gt;").replace(/\n/g, "<br>");
   		this.divnode.innerHTML = value;
		//viewFileContentDetails.filename = filename;
	},
			
	onTransferFailure: function(errorObject) {
		this.showError(errorObject);	
		//viewFileSetcode = true;
	},

//// SCRIPT ARGS Functions
   addscriptargs: function()
   {
   		if (this.scriptargstitlePane)
			return;
		var msgtitle=	RftUiUtil.getMessage("labelScriptArguments");
		this.scriptargstitlePane = new dijit.TitlePane({title: msgtitle,open: false,style:"overflow:auto;overflow-x:hidden;overflow-y:hidden;"});
		this.scriptargstitlePane.classname = "steps-title";
		this.connect(this.scriptargstitlePane, "toggle", this.addscriptargsconent);
		this._scriptInfo.appendChild(this.scriptargstitlePane.domNode);
	},
	
	addscriptargsconent: function()
	{
		if (this.scriptArgsBox)
			return;
		var table = document.createElement("table");
		
		table.width = "60%";
		var dpStore = {	identifier: 'dpId', label: 'dpId', items: [{dpId: 1},{dpId: RftUiUtil.getMessage("dprecordall")}]};
		var dpLogStore = new dojo.data.ItemFileWriteStore({data : dpStore});
		for( var i=2; i < 100 ;i ++)
		{
			dpLogStore.newItem({dpId: i});
		}	

		var tbody = document.createElement("tbody");	
		var row1 = document.createElement("tr");
		var row2 = document.createElement("tr");
		var row3 = document.createElement("tr");
		
		var cell11 = document.createElement("td");
		
		/*cell11.innerHTML = RftUiUtil.getMessage("labelScriptArguments"); */
		cell11.align = "left";	
		cell11.nowrap = true;
		
		var label11 = document.createElement("label");
		label11.innerHTML = RftUiUtil.getMessage("labelScriptArguments");
		cell11.appendChild(label11);
		
		var cell12 = document.createElement("td");	
		this.scriptArgsBox = document.createElement("input");
		dojo.style(this.scriptArgsBox, "padding", "1pt");
		//this.scriptArgsBox.style="padding:1pt";
		this.scriptArgsBox.size=50;
		cell12.appendChild(this.scriptArgsBox);
		
		
		row1.appendChild(cell11);
		row1.appendChild(cell12);

		var cell21 = document.createElement("td");
		//cell21.innerHTML = RftUiUtil.getMessage("labelExecutionArguments");
		cell21.align = "left";
		cell21.nowrap = true;
		var label12 = document.createElement("label");
		label12.innerHTML = RftUiUtil.getMessage("labelExecutionArguments");
		cell21.appendChild(label12);
		
		var cell22 = document.createElement("td");
		this.execArgsBox = document.createElement("input");
		dojo.style(this.execArgsBox, "padding", "1pt");
		this.execArgsBox.size=50;
		cell22.appendChild(this.execArgsBox);
		
		row2.appendChild(cell21);
		row2.appendChild(cell22);

		var cell31 = document.createElement("td");
		cell31.align="left";
		//cell31.innerHTML = "Datapool Iteration Count";
		cell31.nowrap = true;
		var label13 = document.createElement("label");
		label13.innerHTML = RftUiUtil.getMessage("datapooliterationcount");
		cell31.appendChild(label13);
		
		var cell32 = document.createElement("td");
		this.dpSelectBox = new dijit.form.ComboBox({value: RftUiUtil.getMessage("dprecordall"), store:dpLogStore ,name:"state2",searchAttr:"dpId",autoComplete:true,ignoreCase:true});
		dojo.style(this.dpSelectBox, "padding", "1pt");
		
		cell32.appendChild(this.dpSelectBox.domNode);
		
		row3.appendChild(cell31);
		row3.appendChild(cell32);

		tbody.appendChild(row1);
		tbody.appendChild(row2);
		tbody.appendChild(row3);
		
		table.appendChild(tbody);
		this.scriptargstitlePane.setContent(table);
		if (this._script && this._script.properties)
		{
			var arg = this.getScriptProperty(this._script.properties, "ExecArguments");
			if (arg) {
				this.execArgsBox.value = arg;
			}
			arg = this.getScriptProperty(this._script.properties, "ScriptArguments");
			if (arg) {
				this.scriptArgsBox.value = arg;
			}
			arg = this.getScriptProperty(this._script.properties, "DpCount");
			if (arg) {
				if (arg != "-1")
				{
					this.dpSelectBox.setValue(arg);
				} else 
				{
					this.dpSelectBox.setValue(RftUiUtil.getMessage("dprecordall"));
				}
			}
		}
		if (!this.parentEditor.isReadOnly()) {
			this.execArgsBoxHandle = this.connect(this.execArgsBox, "onkeypress", this.setDirty);
			this.scriptArgsBoxHandle = this.connect(this.scriptArgsBox, "onkeypress", this.setDirty);
			this.dpSelectBoxHandle = this.connect(this.dpSelectBox, "onChange", this.setDirty);
		}else{
			this.execArgsBox.readOnly = true;
			this.scriptArgsBox.readOnly = true;
			this.dpSelectBox._setDisabledAttr(true);
		}
   }, 
   
   
   getProperties: function(){
    var props = [];
	
	var arg1 = {
		propertyType: "string",
		propertyName: "ScriptArguments",
		propertyValue: ""	
	}
	
	if (this.scriptArgsBox)
		arg1.propertyValue = this.scriptArgsBox.value;
	else if (this._script && this._script.properties)
		arg1.propertyValue = this.getScriptProperty(this._script.properties, "ScriptArguments"); 
	props.push(arg1);

	
	var arg2 = {
		propertyType: "string",
		propertyName: "ExecArguments",
		propertyValue: ""	
	}
	
	if (this.execArgsBox)
		arg2.propertyValue = this.execArgsBox.value;
	else if (this._script && this._script.properties)
		arg2.propertyValue = this.getScriptProperty(this._script.properties, "ExecArguments");
	 
	props.push(arg2);
	
	var arg3 = {
		propertyType: "string",
		propertyName: "DpCount",
		propertyValue: ""	
	}
	
	if (this.dpSelectBox)
	{
		var val = this.dpSelectBox.getValue();
		if (val==RftUiUtil.getMessage("dprecordall"))
		{
			arg3.propertyValue = "-1";	
		} else {
			arg3.propertyValue = val;
		}
		
	}
	else if (this._script && this._script.properties)
		arg3.propertyValue = this.getScriptProperty(this._script.properties, "DpCount");
	
	props.push(arg3)
	
	return props;
   }
   


});

})();