/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteDesignSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPlanPopup");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
(function(){ // module container

	var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var RichTextControl = com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var wrapText  = com.ibm.asq.common.web.ui.internal.util.wordWrapping.wrapText;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var TestPlanMapper = com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
	var PlanningPageClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var SelectTestPlanPopup = com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectTestPlanPopup;
	var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteDesignSection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templateString: "<div dojoAttachPoint=\"_details\" class=\"com-ibm-rqm-test-planning-summary\">"+
							"<div class=\"editor\">"+
								"<div dojoAttachPoint=\"_categoriesNode\"></div>"+
								"<div dojoAttachPoint=\"_planNode\">"+
								"<table width=\"30%\"><tbody>"+
									"<tr width=\"100%\">"+
										"<td width=\"30%\">"+
							              "<label>${labelTestPlan}</label>"+
										"</td>"+
										"<td width=\"50%\">"+
							              "<a  tabindex=\"0\"  dojoAttachPoint=\"_testPlanName\">${labelSelectTestPlan}</label></a>"+
										"</td>"+
										"<td width=\"20%\">"+
							              "<img tabindex=\"0\" style=\"cursor: pointer;\" dojoAttachPoint=\"_changePlanNode\"></img>"+
										  "<img tabindex=\"0\" style=\"cursor: pointer;\" dojoAttachPoint=\"_clearPlanNode\"></img>"+
										"</td>"+
									"</tr>"+
								"</tbody></table>"+
								"</div>"+
								"<table width=\"100%\">"+
									"<tr>"+
										"<td>"+
							              "<div class=\"richText\" dojoAttachPoint=\"_richTextEditorNode\"></div>"+
										"</td>"+
									"</tr>"+
								"</table>"+
							"</div>"+
						"</div>",
                
		labelSelectTestPlan: Constants.getMessage("labelSelectTestPlan"),
		labelTestPlan: Constants.getMessage("labelTestPlan")+ Constants.getMessage("labelColen"),
		
        constructor: function(){
            this._workItem = null;
        },
        
        postCreate: function(args){
            this.inherited('postCreate', arguments);
            //set up workitem support for this section
            this.addWorkItemSupport(EditorUtil.getCurrentContributor().itemId);
        },
        
		//@Overriden from AbstractArtifactEditorSection
        initialize: function(isEditable) {
            this._suite = this.getArtifact();
			if (!this.initialized) {// this method is even called from saveFinished below, so duplicate connects result
				this._changePlanNode.src = ImageCache.TEST_PLAN;
				this._changePlanNode.alt = Constants.getMessage("labelChangeTestPlan");
				this._changePlanNode.title = Constants.getMessage("labelChangeTestPlan");
				this._clearPlanNode.alt = Constants.getMessage("labelClearTestPlan");
				this._clearPlanNode.title = Constants.getMessage("labelClearTestPlan");
				this.connect(this._changePlanNode, "onclick", "_changePlan");
				this.connect(this._clearPlanNode, "onclick", "_clearPlan");
			}
			this._testPlanName.style.cursor = "pointer";
			this._testPlanName.style.color= "#1E9494";
			if(this._suite && this._suite.testPlan){
				this._clearPlanNode.src = ImageCache.CLEAR_FILTER_ENABLED;
				this.getParentEditor().setTestPlanVersionableItemId(this._suite.testPlan.versionableItemId);
				
                if(!this._suite.testPlan.id)
                {
                //TODO: It is incorrect to save the name  and versionableItemId instead of the plan id, for now I will leave this extra call 
                // in order to obtain the id, but this must be changed.
                    var responseHandler = new TestPlanMapper(this, "_searchPlanItem", "_error");
                    PlanningPageClient.getTestPlans(responseHandler, {includeTestCases: false, includeCategories: false, versionableItemId:this._suite.testPlan.versionableItemId, name:this._suite.testPlan.name});
                }
                                
				this._testPlanName.innerHTML = this._suite.testPlan.name;
				this._clearPlanLink();
			}else{
				this._clearPlanLink();
				this.planLinkClick = this.connect(this._testPlanName, "onclick", "_changePlan");
				this._clearPlanNode.src = ImageCache.CLEAR_FILTER_DISABLED;
				this._testPlanName.href ="";
				this._testPlanName.innerHTML = Constants.getMessage("labelSelectTestPlan");
			}
            //create the rich text control
			
			if (!this._richText) {
				this._richText = new RichTextControl({
                    editable: this.isEditable(),
					inEditMode: false,  //default to preview mode
					contentHTML: this.getSection().content ? this.getSection().content : "",
					save: dojo.hitch(this, function(){
						var editor = this.getParentEditor();
						if(dojo.isFunction(editor.onSave)){
							editor.onSave();
						}
					})
				});
				dojox.data.dom.removeChildren(this._richTextEditorNode);
				this._richTextEditorNode.appendChild(this._richText.domNode);
                dojo.connect(this._richText, "onChange", this, "setDirty");
			}else {
				this._richText.setContentHTML(this.getSection().content);
			}
            this.initialized = true;
        },
        
		//@Overridden from AbstractArtifactEditorSection
        getExpandHandler: /* Function */ function() {
            return dojo.hitch(this, "_showRichText");
        },
		
        _showRichText: function() {
            if (this._richText) {
                this._richText.show();
            }
        },
        
        _searchPlanItem: function(args)
        {
          if (args)
          {
              if(args.length == 1)
                this._suite.testPlan.id = args[0].id;
              else
              {
                  //Since we searched basically by name, there could be the posibility to have 2 different 
                  //Plan Items that have the same name, hence we need to search for the correct one
                  for(var i=0; i<args.length; i++)
                  {
                      if(args[i].versionableItemId == this._suite.testPlan.versionableItemId)
                      {
                                       
                        this._suite.testPlan.id = args[i].id;                       
                        break;
                      }
                  }
              }
              //If id was found create the link
              if(this._suite.testPlan.id)
                this._testPlanName.href = Utility.getTestPlanURI({id: this._suite.testPlan.id});  
          }  
        },
		       
        //@Overridden from AbstractArtifactEditorSection
        getAttributes: function(){
            var attributes = {};
            if (this._richText && this._richText.getContentHTML() != null) {
                attributes.description = this._richText.getContentHTML();
            }
            if (this.getWorkItemEditor()) {            
                attributes.ownerId = this.getWorkItemEditor().getOwnerId();                
            }
            return attributes;
        },
        
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
		//	if(this.initialized)
         //       this.initialize();
			this.addWorkItemSupport(true);
        },
        
        //@Overridden from AbstractArtifactEditorSection --> disable 'remove' capability for Summary section          
        getHeaderContent: /* String || DOM Node */ function(isEditable) {
            return null;
        },
        
		//@Overridden from AbstractArtifactEditorSection: 
		validate: function () {
			return true;
		},
		
		//@Overridden from AbstractArtifactEditorSection:		
        getSectionInfo: function() {      
            this.inherited("getSectionInfo", arguments);
            if (this._richText || this.getSection().content) {
                var strValue = this._richText ? this._richText.getContentXHTML() : this.getSection().content;
                this.getSection().attributes = [];
                this.getSection().attributes.push({
                    type: "richtext",
                    name: "content",
                    value: strValue ? dojo.trim(strValue) : null
                });
            }
			return this.getSection();
        },
		
		_changePlan: function(e){
			dojo.stopEvent(e);
			var responseHandler = new TestPlanMapper(this, "_createPlanDialog", "_error");
            PlanningPageClient.getTestPlansSummary(responseHandler, {includeTestCases: false, includeCategories: false});
		},
		
		_createPlanDialog: function(plans){
			if(plans && plans.length >0){
				 var args = {
				 	title: Constants.getMessage("labelSelectTestPlan"),
				 	actionId:Constants.getMessage("labelTestPlan"),
                    plans: plans,
					okCallback: dojo.hitch(this, "_okButtonClicked"),
		            cancelCallback: null 
                }
				var planChangePopUp = new SelectTestPlanPopup();
				planChangePopUp.initialize(args);
			}else{
				this._displayAlertDialog(Constants.getMessage("msgPlanNotFound"));
			}
		},
		
		_okButtonClicked: function(args){
			this._testPlanName.innerHTML = args.testPlanName ? args.testPlanName : Constants.getMessage("labelSelectTestPlan");
			this.getParentEditor().setTestPlanVersionableItemId(args.testPlanVersionableItemId);
			var testPlan = {};
			testPlan.testPlanName = args.testPlanName;
			testPlan.testPlanId = args.testPlanId;
			testPlan.testPlanVersionableItemId = args.testPlanVersionableItemId;
			this.getParentEditor().setTestPlan(testPlan);
			this._testPlanName.style.color= "#1E9494";
			this._testPlanName.style.cursor = "pointer";
			
			if(args.testPlanVersionableItemId){
			    this._testPlanName.href = Utility.getTestPlanURI({id: args.testPlanId});			
				this._clearPlanLink();
				this._clearPlanNode.src = ImageCache.CLEAR_FILTER_ENABLED;		
			}else{
				this._clearPlanLink();
				 this._testPlanName.href ="";
				this._clearPlanNode.src = ImageCache.CLEAR_FILTER_DISABLED;		
				this.planLinkClick = this.connect(this._testPlanName, "onclick", "_changePlan");		
			}	
			this.setDirty();
		},
		
		_clearPlan: function(){
			this.getParentEditor().setTestPlanVersionableItemId(null);
			this._clearPlanNode.src = ImageCache.CLEAR_FILTER_DISABLED;
			this._testPlanName.innerHTML = Constants.getMessage("labelSelectTestPlan");
			this._testPlanName.style.cursor = "pointer";
			this._clearPlanLink();
			this.planLinkClick = this.connect(this._testPlanName, "onclick", "_changePlan");
			this._testPlanName.style.color= "#1E9494";
			this.setDirty();
		},
		
		_clearPlanLink: function(){
			if(this.planLinkClick){
				this.disconnect(this.planLinkClick);
				this.planLinkClick = null;
			}
		},
		
		_displayAlertDialog: function(message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.open();
        },
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from TestSuiteDesignSection#_error");
		}
		
    });
    
})();
