/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.planning.HelpNavWidget");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.HelpNavWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");

(function() 
{	
	var	ImageCache = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
	var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;
	
	/**
	 * Widget to display list of link elements in the LeftNavigation.
	 */
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.HelpNavWidget",
				 [dijit._Widget, dijit._Templated],
		{
			templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/planning/HelpNavWidget.html"),

			constructor: function(args) 
			{
				this.controller = null;
				this.cshelpid = args.cshelpid;
			},
	
			postCreate: function() 
			{
				if (this.cshelpid != null) {
					var cshelp = new CSHelp();
					cshelp.contextID = this.cshelpid;
					this._cshelp.appendChild(cshelp.domNode);
				} else {
					this._helpIcon.src = ImageCache.HELP;
				}
			}
		}
	);
}
)();
