//SequenceLog
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceLog");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceLog");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultStepsTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility");

(function() {
var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AbstractEditor 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor;
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var SequenceClient					= com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;
var SequenceResultStepsTableView	= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultStepsTableView;
var GlobalEvents					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var Utility  						= com.ibm.rational.test.lm.sequencer.web.ui.internal.util.Utility;
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceLog", [dijit._Widget, dijit._Templated, AbstractEditor],
{
		templateString: "<div>" +
						"    <div dojoType=\"com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout\" dojoAttachPoint=\"_header\"" +
                	    "         summaryEditable=\"false\" summaryAsDesc=\"true\">" +
						"<div dojoAttachPoint=\"topSection\">"+
						"<table style=\"padding-left: 20px;\"><tbody>"+
						"<tr><td style=\"padding-left: 20px;\"><label>${labelSequenceName}</label></td><td style=\"padding-left: 20px;\"><label dojoAttachPoint=\"_sequenceName\"></label></td></tr>"+
						"<tr><td style=\"padding-left: 20px;\"><label>${typeOfRun}</label></td><td style=\"padding-left: 20px;\"><label dojoAttachPoint=\"_typeOfRun\"></label></td></tr>"+
						"<tr><td style=\"padding-left: 20px;\"><label>${labelStartTime}</label></td><td style=\"padding-left: 20px;\"><label dojoAttachPoint=\"_startTime\"></label></td></tr>"+
						"<tr><td style=\"padding-left: 20px;\"><label>${labelEndTime}</label></td><td style=\"padding-left: 20px;\"><label dojoAttachPoint=\"_endTime\"></label></td></tr>"+
						"<tr><td style=\"padding-left: 20px;\"><label>${labelActualResult}</label></td><td style=\"padding-left: 20px;\"><label dojoAttachPoint=\"_actualResult\"></label></td></tr>"+
						"</tbody></table>"+
						"</div>"+
						"<div dojoAttachPoint=\"tableSection\"></div>"+
						"</div>"+
						"</div>",
		widgetsInTemplate: true,
		labelSequenceName: Constants.getMessage("labelSequenceName"),
		labelActualResult: Constants.getMessage("labelActualResult"),
		typeOfRun: Constants.getMessage("typeOfRun"),
		labelStartTime: Constants.getMessage("labelStartTime"),
		labelEndTime: Constants.getMessage("labelEndTime"),
		
		postCreate: function(){
			this.initialize();
		},
		
		initialize: function(){
			this.sections = [];
			this.setReadOnly(true);
			this.createHeader({title: Constants.getMessage("labelExecutionSequenceResult")
												, iconClass: "sequence-result-def-icon-48", nonEditable: true,
												csHelpId: "sequence_result.html"});
			this._cancelSequenceButton = this.getHeader().addRightViewAction(Constants.getMessage("labelCancel"), dojo.hitch(this, "onCancel"), null, null);
			this._cancelSequenceButton.setDisabled(true); 
			this.seqStepTable = new SequenceResultStepsTableView({parentSection: this});
			this.seqStepTable.initialize({});
			var resultTableSection = this.createSection(this.tableSection, {title: Constants.getMessage("labelStepResults"), widget: this.seqStepTable, csHelpId: "sequence_result_steps.html"});
			
			if(this.itemId){
				var args = {itemId: this.itemId};
				var responseHandler = new ServiceResponseHandler(this, "fillData", "_error");
				SequenceClient.getExecutionSequenceResultsDTO(responseHandler, args);
			}
		},
		
		fillData: function(results){
			if(results && results.length > 0){
				this.result = results[0];
			}
			var result = this.result;
			this.seqStepTable.initialize(result);
			
			this._sequenceName.innerHTML = result.sequenceName;
			this.getHeader().setSummary(result.sequenceDescription);
			this._typeOfRun.innerHTML = result.isBVT ? Constants.getMessage("labelBuildBased") : Constants.getMessage("labelTimeBased");
			
			this._actualResult.innerHTML = Utility.getResultString(result.result);
			
			if(result.result == "IN_PROGRESS"){
				this._cancelSequenceButton.setDisabled(false);
			}else{
				this._cancelSequenceButton.setDisabled(true);
				if(result.result == "CANCELLED")
					this.getHeader().setStatus(Constants.getMessage("labelCancelledSequence"), 3, Constants.getMessage("msgCancelledSequence"));
			}
			var start  = new Date();
			start.setTime(result.startTime);
			this._startTime.innerHTML = dojo.date.locale.format(start, {formatLength: "medium"});
			if(result.endTime){
				var end  = new Date();
				end.setTime(result.endTime);
				this._endTime.innerHTML =  dojo.date.locale.format(end, {formatLength: "medium"});
			}else{
				this._endTime.innerHTML = Constants.getMessage("labelNA");
			}
		},
		
		getTabClass: function(){
			return "sequence-result-icon-16-inTab";
		},
		
		onSave: function(){
			
		},
		
		onDiscard: function(){
			
		},
		
		onCancel: function(){
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self._cancel();
				},
				noCallback: null
			}
			var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
            dialog.setSecondaryTitle(args.title);
            dialog.open();
		},
		
		_cancel: function(){
			var args = {};
			args.sequenceResultItemId= this.result.itemId;
			var responseHandler = new ServiceResponseHandler(this, "_cancelComplete", "_cancelError");
			SequenceClient.postCancelRunningExecutionSequence(responseHandler, args);
		},
		
		_cancelError: function(e){
			this.getHeader().setStatus(Constants.getMessage("labelUnableToCancel"), 1, e.message);
			this._error(e);
		},
		
		_cancelComplete: function(obj){
			this.result.result = "CANCELLED";//Service returns a boolean here so make the sequence.
			this.fillData([this.result]);
			dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_SEQUENCE_RESULT, [this.result]]);
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from SequenceLog#_error");
		}
	}
);
}
)();
		
