/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableFormField");

(function() {

var Utility = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var AbstractFilteredTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView;
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionPagingTableView", [AbstractFilteredPagingTableView],
{
    addExecutionStateFilter: function(filterObj, filtersCollection, callback) {
        var self = this;
        var successCallback = function(executionStates) {
            var stateOptions = [];
            for (var i = 0; i < executionStates.length; i++) {
                stateOptions.push({
                    name: executionStates[i].name,
                    value: executionStates[i].id,
                    checked: false
                });
            }

            var statesFilter = {
                name: filterObj.name, // must match key in the arg list of the API
                title: filterObj.label,
                promptTitle: filterObj.prompt,
                type: filterObj.type,
                defaultValue: [],
                params: {
                    options: stateOptions
                }
            };
            filtersCollection.push(statesFilter);
            callback();
        };
        
        var errCallback = function(e) {
            self._error(e);
            callback();
        };

        Utility.getExecutionStates(successCallback, errCallback);
    },
    
    addAdvancedArtifactFilter: function(filterObj, filtersCollection,advancedParams) {
        var artifactFilter = {
            name: filterObj.name,  // must match key in the arg list of the API
            title: filterObj.label ? filterObj.label : Constants.getMessage("labelScriptType") + Constants.getMessage("labelColen"),
            promptTitle: filterObj.prompt ? filterObj.prompt : Constants.getMessage("labelScriptType"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 300,
                fieldClass: "com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableFormField",
                fieldArgs: {
                    'artifactType': filterObj.artifactType,
                    'simpleKey': filterObj.simpleKey,
                    'advancedKey': filterObj.advancedKey,
					'advancedParams':advancedParams
                }
            }
        };
        filtersCollection.push(artifactFilter);
    }
    
});

// this class will be removed once all artifacts are using server side paging
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView", [AbstractFilteredTableView],
{
    addExecutionStateFilter: function(filterObj, filtersCollection, callback) {
        var self = this;
        var successCallback = function(executionStates) {
            var stateOptions = [];
            for (var i = 0; i < executionStates.length; i++) {
                stateOptions.push({
                    name: executionStates[i].name,
                    value: executionStates[i].id,
                    checked: false
                });
            }

            var statesFilter = {
                name: filterObj.name, // must match key in the arg list of the API
                title: filterObj.label,
                promptTitle: filterObj.prompt,
                type: filterObj.type,
                defaultValue: [],
                params: {
                    options: stateOptions
                }
            };
            filtersCollection.push(statesFilter);
            callback();
        };
        
        var errCallback = function(e) {
            self._error(e);
            callback();
        };

        Utility.getExecutionStates(successCallback, errCallback);
    },
    
    addAdvancedArtifactFilter: function(filterObj, filtersCollection,advancedParams) {
        var artifactFilter = {
            name: filterObj.name,  // must match key in the arg list of the API
            title: filterObj.label ? filterObj.label : Constants.getMessage("labelScriptType") + Constants.getMessage("labelColen"),
            promptTitle: filterObj.prompt ? filterObj.prompt : Constants.getMessage("labelScriptType"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 700,
                fieldClass: "com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableFormField",
                fieldArgs: {
                    'artifactType': filterObj.artifactType,
                    'simpleKey': filterObj.simpleKey,
                    'advancedKey': filterObj.advancedKey,
					'advancedParams':advancedParams
                }
            }
        };
        filtersCollection.push(artifactFilter);
    }
    
});

})();
