//AdapterConsoleTableView
/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//MFV This was extracted from MachineAdapterTableView.  The use of the code in the Execution->Adapter Console
//was growing more and more divergent from the use for selecting machines and test cells so it made sense that
//there be separate classes.

dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");

(function() {
	
var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Constants      					= com.ibm.rqm.planning.web.client.internal.Constants;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AssetUriUtil					= com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var toolService                     = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
var TableContentFilterProvider      = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var AbstractFilteredExecutionTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView;
var MACHINE_SEARCH_COLUMNS = "machine.id, machine.name, machine.operatingsystem.hostname";

dojo.declare("AdapterConsoleTableView.Sorter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter,
{
	_sortComparator: function(obj1, obj2){
		if(this.sortCol == 4){
			if(obj1.statusValue == null || obj2.statusValue == null)
				return 0;
			if(this.sortDir == TableConstants.SORT_DIR_ASCEND){
				return obj1.statusValue - obj2.statusValue;
			}else{
				return obj2.statusValue - obj1.statusValue;
			} 
		}else 
			return this.inherited("_sortComparator",arguments);
	}
});

dojo.declare("AdapterConsoleTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(parentView) {
        this.parentView = parentView;
    },
	
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },
	
	rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.deleteAction)
            this.parentView.deleteAction.setDisabled(selectionCount == 0);
    },
    
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    }
});

dojo.declare("AdapterConsoleTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 8;
    },

    _columnHeadings: [
	            Constants.getMessage("labelId"),
				Constants.getMessage("labelMachineName"),
	            Constants.getMessage("labelAdapterType"),
				Constants.getMessage("labelAdapterStatus"),
				Constants.getMessage("labelHealth"),
				Constants.getMessage("labelHostname"),
				Constants.getMessage("labelIPAddress"),
				Constants.getMessage("labelPollingInterval")
    ],
    
    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
   
    _columnIdName: [
        "id",
        "machineName",
        "adapterTypes",
        "status",
        "",
        "hostname",
        "ipAddress",
        ""
    ],

    getColumnIdName: function(index){
        return this._columnIdName[index];
    },

    getColumnHeadingImage: function(content, atColumnIndex){		  
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
		//Group Machine, Adapter Type, or Status
        return (atColumnIndex == 1 || atColumnIndex == 2 || atColumnIndex == 3);     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    _columnWidths: [10,15,15,10,10,20,10,10],
    
    getColumnWidth: function(content, atColumnIndex){
        return this._columnWidths[atColumnIndex];
    },
	
    setServerTime: function(serverTime){
		this.serverTime = serverTime;
	},

    getContentObjects: function(content){
        return content;
    },
    
	getRowDataId: function(rowData){
        return rowData.adapterInfo.id;
    },
	
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
			case 4: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;					 
        }
		if(atColumnIndex == 1){
			type = TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
		if(atColumnIndex == 4)
			return TableConstants.ALIGN_CENTER;
		else	
        	return TableConstants.ALIGN_LEFT;
    },
 
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.adapterInfo.id;
                break;
			case 1: 
                val = rowData.adapterInfo.machine ? rowData.adapterInfo.machine.name : "";
                break;
            case 2: 
                val = rowData.adapterInfo.adapterType.adapterName;
                break;
			case 3:
					var engineStatus = Constants.getMessage("labelAvailable");
					rowData.statusValue = 0;
					if(rowData.adapterInfo.health == "RED"){
						engineStatus = Constants.getMessage("labelUnAvailable");
						rowData.statusValue = 2;
					}else if(rowData.adapterInfo.health == "YELLOW"){
						engineStatus = Constants.getMessage("labelAvailable");
						rowData.statusValue = 1;
					}
				val = engineStatus;
				break;
            case 4: 
                this.engineStatus = Constants.getMessage("labelAvailable");
				this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
				this.engineToolTip = Constants.getMessage("msgEngAvailable");
				rowData.statusValue = 0;
				if(rowData.adapterInfo.health == "RED"){
					this.engineStatus = Constants.getMessage("labelUnAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					this.engineToolTip = Constants.getMessage("msgEngUnresponsive");
					if(!rowData.adapterInfo.machine.name)
					   this.engineToolTip = Constants.getMessage("labelArchiveCategory", rowData.adapterInfo.adapterType.adapterName);
					rowData.statusValue = 2;
				}
				else if(rowData.adapterInfo.health == "YELLOW"){
					this.engineStatus = Constants.getMessage("labelAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					this.engineToolTip = Constants.getMessage("msgEngRespondLate");
					rowData.statusValue = 1;
				}

				val = this.engineStatus;
                break;
			case 5:
					val = rowData.adapterInfo.hostName;
				break;
			 case 6: 
                val = rowData.adapterInfo && rowData.adapterInfo.machine ? rowData.adapterInfo.machine.ipAddress : "";
                break;
			case 7: 
                val = Utility.getTimeDifferenceInHrMinSec(rowData.adapterInfo.pollingInterval);
                break;		
        }
        return val;
    },

	getToolTip: function(adapter, avail){
		var reqInQueue = adapter.requestsInQueue ? adapter.requestsInQueue : 0; 
		var timeSinceLastContact = adapter.serverTime - adapter.lastHeartBeat;
		var str = [];
		str.push("<table><tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelstatus")+": "+"</td><td>"+avail+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelLastSinceLastContact")+": "+"</td><td>"+Utility.getTimeDifferenceInHrMinSec(timeSinceLastContact)+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelJobsInQueue")+": "+"</td><td>"+ reqInQueue +"</td></tr>");				
		str.push("<tr><td> </td><td> </td></tr>");
		if(adapter.name){
			str.push("<tr><td align=left>"+Constants.getMessage("labelName")+": "+"</td><td>"+ adapter.name +"</td></tr>");				
			str.push("<tr><td> </td><td> </td></tr>");
		}
		str.push("</table>");
		return str.join("");
	},

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 4) {
			val = {image:this.engineStatusIcon,tooltip : this.getToolTip(rowData.adapterInfo, this.engineToolTip)};
		}else if(atColumnIndex == 1 && rowData.adapterInfo.machine){
			val = {href: AssetUriUtil.getViewAssetDetailURI("Machine", rowData.adapterInfo.machine.itemId)};
		}		  
        return val;
    }
});

dojo.declare("AdapterConsoleTableView.TableContentFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;

        // define the static filters
        this.filters = [];
        this.filters.push({
            name: "machineName",  // must match key in the arg list of the API
            title: Constants.getMessage("labelMachineName") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelMachineName"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, 
            params: null
        });
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelAdapterConsole"));
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilters: function() {
        return this.filters;
    },  
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
        this.tableView.filteredArgs = {};
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
                    args[nameKey] = '';
                }
            }
        }
        this.tableView.filteredArgs = args;
        this.tableView._loadTable();
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.AdapterConsoleTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionTableView],
{    
    templateString: '<div dojoAttachPoint="domNode" class="com-ibm-rqm-test-execution-machine-adapter-view">' +
	                '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
					'  </div>'+
					'    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"> ' +
					'    </div>' +
					'</div>',

    widgetsInTemplate: true,
	allowMultiSelect: false,
    constructor: function(){
		//Expected to be supplied by the caller:
		//serverTime - Available in each adapters dto 
		//loadingCompleteCallback - Called when all the data is loaded into the table.
		//							returns the data that would show in the table
        this.showQueryFilters = true;  // default to show filters
        this.filteredArgs = {};
	},
	 
	postCreate: function(){
		this.inherited("postCreate", arguments);		
		this.initialLoad = true;  //Used to gate calls to the loadingComplete callback
		
        this.viewHeaderNode.setTitle(this.queryName);
		this.viewHeaderNode.setCSHelpId("rqm_adapter_console.html");
		this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelAdapterConsoleHelp"));

        // initialize options for the view builder
        this.setTypeLabel(Constants.getMessage("labelAdapterConsole"));
        this.setSearchFunction(dojo.hitch(toolService, "getSearchAdaptersDTO"));
        this.setSearchCallback(dojo.hitch(this, "_showAdapters"));

        if (this.postQueryFilterCallback) {
            this.setSearchFilterCallback(this.postQueryFilterCallback);
        }
        this._initialize();
        // apply the user preference whether to initially open the view builder
        if (this.showQueryFilters) {
			setTimeout(dojo.hitch(this,function(){
            	this._initializeFilters();
			}),0);             
        } else {
		   this._loadTable();
        }
    },

    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new AdapterConsoleTableView.TableContentFilterProvider(this, this.isInitiallyOpen());
        // add the adapter type filter
        var providerFilters = this.filterProvider.filters;
        var adapterTypesFilter = {
            name: "adapterTypes" // must match key in the arg list of the API
        };

        // add script state filter
        this.addScriptTypeFilter(adapterTypesFilter, providerFilters, function(){});
		this._initializeOtherFilters();
    },

    _initializeOtherFilters: function() {
        var providerFilters = this.filterProvider.filters;
        
        var adaptersStatus = [];
        adaptersStatus.push({
            name: Constants.getMessage("labelAvailable"),
            value: "Available",
            checked: false
        });
        adaptersStatus.push({
            name: Constants.getMessage("labelUnAvailable"),
            value: "Unavailable",
            checked: false
        });

        providerFilters.push({
            name: "status",  // must match key in the arg list of the API
            title: Constants.getMessage("labelStatusWithColon"),
            promptTitle: Constants.getMessage("labelstatus"),
            type: TableContentFilterProvider.FIELD_TOGGLELIST,
            defaultValue: null,
            params: {options: adaptersStatus}
        });

        providerFilters.push({
            name: "hostname",  // must match key in the arg list of the API
            title: Constants.getMessage("labelHostname") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelHostname"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, 
            params: null
        });
        
        providerFilters.push({
            name: "ipAddress",  // must match key in the arg list of the API
            title: Constants.getMessage("labelIPAddress") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelIPAddress"),
            type: TableContentFilterProvider.FIELD_IP,
            defaultValue: null, 
            params: null
        });

        providerFilters.push({
            name: "id", // must match key in the arg list of the API
            title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: null
        });
		this._loadTable();
    },

    _initialize: function(){
		//Create the table for showing the machines
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            sortByColumn: 3,
            sortDir: TableConstants.SORT_DIR_ASCEND,
            tableId: "RQM-EXE-MACH-ADAPTER-TABLEVIEWER"                                
        });
        
        this._tableViewerNode.appendChild(tableViewer.domNode);
        tableViewer.setContentPageSize(20);
		var tableProvider = new AdapterConsoleTableView.TableProvider();
		tableProvider.setServerTime(this.serverTime);
        tableViewer.setContentProvider(tableProvider);
        tableViewer.setTableListener(new AdapterConsoleTableView.TableListener(this));
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelMachineAdapter")));
		var sorter = new AdapterConsoleTableView.Sorter();
		tableViewer.setSorter(sorter);
		var content = [];
		tableViewer.setContent(content);

        // initFilterProvider uses the table's id to index
        // into the per-session saved filters. Need to setup
        // this attribute to properly obtain the saved filters.
        this.tableViewer = tableViewer;
        tableViewer.show();

        this.refreshAction = tableViewer.addAction("Refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, this.refreshMATV));
        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_ADAPTER;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
        if (!perm || perm['delete']) {
            this.deleteAction = tableViewer.addAction("Delete", Constants.getMessage("labelDelete"), this, "delete-icon-image", dojo.hitch(this, this.deleteActionM));
            this.deleteAction.setDisabled(true);
        }
	},
	
	//Here's how this goes.....
	//Start with all machines
	_loadTable: function(){
        this.showInitLoadProgress = true;
        this.tableViewer.showLoadingProgress();
		if (this.showQueryFilters) {
            this.initFilterProvider(this.filterProvider);
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
		this.runQuery(this.filteredArgs);
	},
	
    _showAdapters: function(adapters){
		this.adapterData = adapters;
        if (dojo.isArray(adapters) && adapters.length > 0) {
    		this.mergedData = this._mergeAdapterDataWithMachines();
        } else {
            this.mergedData = [];
        }
        this.tableViewer.setContent( this.mergedData );
        this.tableViewer.refresh();

		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback(this.mergedData, this);
		}
	},

	_mergeAdapterDataWithMachines :function(){
		//Get the server time that was returned with the adapter data
		//We'll use that to show adapter availability
		if (this.adapterData != null && this.adapterData.length > 0){
			this.serverTime = this.adapterData[0].serverTime;
		}
		var resultData = [];
		var len3 = this.adapterData.length;
		for (var i = 0; i < len3; i++){	
	  	    var adapter = {};
	   	    adapter.adapterInfo = this.adapterData[i];
		    resultData.push(adapter);		
	    }	
		return resultData;
	},

	reInitialize: function(scriptType, configID, loadingCompleteCallback){
		this.scriptType = scriptType;
		this.configID = configID;
		this.loadingCompleteCallback = loadingCompleteCallback;
		this.initialLoad = true;
		this._loadTable();
	},
	
	refreshMATV: function(){
		this.reInitialize(this.scriptType, this.configID, this.loadingCompleteCallback);
		this.viewHeaderNode.clearStatus();
	},

	deleteActionM: function(){		
		var selectedItems = this.tableViewer.getCheckedRows();
		var len = selectedItems.length;
		if (len > 0 ){
			var messagespan = document.createElement("label");
            messagespan.innerHTML = Constants.getMessage("msgDeleteAdapter",len);
            var yesNoDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog({
				primaryTitle:Constants.getMessage("labelDelete")+" "+Constants.getMessage("labelAdapter"),
                yesCallback:dojo.hitch(this,"_deleteAdapter"),
                yesCallbackData:selectedItems,
				isClosable: true
            });
            yesNoDialog.contentContainer.appendChild(messagespan);
            yesNoDialog.open();
		}
	},
	_deleteAdapter:function(selectedItems){
		this.adaptersToDeleteCount = selectedItems.length;
		this.adaptersDeletedCount = 0;
		var toolService = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
		var len = selectedItems.length;
		for(var i=0;i<len;i++){
			var params = { id: selectedItems[i].adapterInfo.id};
			var responseHandler = new ServiceResponseHandler(this, "_success", "_failure");
			toolService.postDelete(responseHandler, params);
		}
		
	},
	_success: function(object){
		this.adaptersDeletedCount++;
		if(this.adaptersDeletedCount == this.adaptersToDeleteCount){
			this.refreshMATV();
			this.deleteAction.setDisabled(true);
			this.viewHeaderNode.setStatus(Constants.getMessage("msgAdapterDeleteSuccess"),ViewHeaderLayout.INFO);
		}
	},
	
	_failure: function(object){
		this.adaptersDeletedCount++;
		if(this.adaptersDeletedCount == this.adaptersToDeleteCount){
			this.deleteAction.setDisabled(true);
			this.viewHeaderNode.setStatus(Constants.getMessage("msgAdapterDeleteFailed"),ViewHeaderLayout.ERROR,object.message);
		}
	}
});

})();