/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.DefectTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
//RTC Integration
dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredListDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.WindowUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.RichHoverCellRenderer");
dojo.require("com.ibm.rqm.defects.web.util.RichHoverUtil");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer");

dojo.require("com.ibm.rqm.defects.web.helper.RemoteItemPicker");
dojo.require("com.ibm.rqm.defects.web.util.ItemPickerUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

dojo.require("com.ibm.rqm.defects.web.ui.internal.LinksTableView");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() {

var TableConstants 	= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Utility        	= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      	= com.ibm.rqm.planning.web.client.internal.Constants;
var ImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var DEFECT_URL		= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DefectView		= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;//Need DV here since same table used in EWIListing

var ChangeRequestManager			= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var WorkItemSelectionDialog			= com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog;
var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;

var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var DeferredDialog					= com.ibm.rqm.defects.web.ui.view.common.DeferredDialog;
var WindowUtil						= com.ibm.rqm.defects.web.ui.utils.WindowUtil;
var RichHoverCellRenderer 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.RichHoverCellRenderer;
var RichHoverUtil		  			= com.ibm.rqm.defects.web.util.RichHoverUtil;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var Status                          = com.ibm.team.repository.web.foundation.Status;
var DEFECT_ORIGIN_1					= "ExecutionResult";
var DEFECT_ORIGIN_2					= "ScriptlessResult";
var DEFECT_ORIGIN_3					= "BlockingPopup";

var NewDefectDataInitializer        = com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer;

var RemoteItemPicker				= com.ibm.rqm.defects.web.helper.RemoteItemPicker;
var ItemPickerUtil					= com.ibm.rqm.defects.web.util.ItemPickerUtil;
var CSHelp 							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var getCurrentProjectArea           = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

dojo.declare("DefectTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(view){
		this.parentView = view;
	},
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		 var selectionCount = tableViewer.getCheckedRows().length;
		 
		 if (this.parentView.changeStatusActionNode){
			if(selectionCount == 0 || rowObject.statusId == 5)
            	this.parentView.changeStatusActionNode.setDisabled(true);
			else
				this.parentView.changeStatusActionNode.setDisabled(false);
		}
		
		if (this.parentView.deleteActionNode){
			if(selectionCount == 0)
				this.parentView.deleteActionNode.setDisabled(true);
			else
				this.parentView.deleteActionNode.setDisabled(false);
		}
    },
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    } 
});
dojo.declare("DefectTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
		if(content.length && this.isExternal(content[0])){
			return 2;
		}else{
			return 4;
		}
    },
    
    _columnHeadings: [
            Constants.getMessage("labelBlockingStatus"),
            Constants.getMessage("labelId"),
        Constants.getMessage("labelSummary"),
        Constants.getMessage("labelState")
    ],
	
	_compactColumnHeadings: [
        Constants.getMessage("labelBlockingStatus"),
        Constants.getMessage("labelSummary")
    ],
    
    getColumnHeading: function(content, index){
		if(content.length && this.isExternal(content[0]))
			return this._compactColumnHeadings[index];
		else
        	return this._columnHeadings[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },
    getIsColumnGroupable: function(content, atColumnIndex){
        return false;
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return false;   
    },
    getColumnWidth: function(content, atColumnIndex){
		if(content.length && this.isExternal(content[0])){
			switch(atColumnIndex) {
	            case 0: 
	                return 20;
	            case 1: 
	                return 80;
	        }
		}else{
			switch(atColumnIndex) {
	            case 0: 
	                return 20;
	            case 1: 
	                return 15;
	            case 2: 
	                return 40;
	            case 3: 
	                return 25;		 
	        }
		}
        return 0;
    },
    getContentObjects: function(content){
        return content;
    },    
    getRowDataId: function(rowData){
        return "_table_row_for_defect_" + (rowData.defectItemUri ? rowData.defectItemUri : rowData.id);
    },
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
				// HACK fix for 17837, to differentiate between internal/external defect, check its stateId
				//if(ChangeRequestManager.INIT_INITIALIZED){
				if (this.isExternal(rowData)) {
					type = "RENDER_TYPE_RICHHOVERLINK";
				}else{
					type = TableConstants.RENDER_TYPE_LINK;
				}
                break;						 
        }
        return type;
    },
    getCellAlignment: function(rowData, atColumnIndex){
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
		if(this.isExternal(rowData)){
			switch(atColumnIndex) {
	            case 0: 
	                val = rowData.isBlocking;
	                break;
	            case 1: 
	                val = Utility._restoreTags(rowData.summary);
	                break;   
	        }
		}else{
			switch(atColumnIndex) {
	            case 0: 
	                val = rowData.isBlocking;
	                break;
	            case 1: 
	                val = rowData.id;
	                break;
	            case 2: 
	                val = Utility._restoreTags(rowData.summary);
	                break;   
	            case 3: 
					val = rowData.status;
	                break;  
	        }
		}
        return val;
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
        var val = null;  
        if (atColumnIndex == 0) {
           val = {};
		   	  var isFixed = (rowData.statusId == 3) || (rowData.statusId == 4) || (rowData.statusId == 5);//id 5 corresponds to Closed, id 4 corresponds to Verified, 3 corresponds to resolved
			  val.image = ((rowData.isBlocking && !isFixed) ? ImageCache.BLOCKING_DEFECT: ImageCache.NOIMAGE); 
			  val.tooltip = "";
		  }
		 if (atColumnIndex == 1) {
		 	val = {};
		 	// HACK fix for 17837, to differentiate between internal/external defect, check its stateId
			//if(ChangeRequestManager.INIT_INITIALIZED){
			if (this.isExternal(rowData)) { 
				val.uri = RichHoverUtil.getWorkItemUri(rowData.defectItemUri);
				val.presentationUri = RichHoverUtil.getWorkItemPresentationUri(rowData.defectItemUri);
				val.label = Utility._restoreTags(rowData.summary);
//			}else if (rowData.defectItemUri){
//				val.href = rowData.defectItemUri;
			}else{
				val.href = DEFECT_URL + rowData.id;
			}
		  } 		  
        return val;
    },
	isExternal: function(rowData){
		if (!rowData.stateId && !rowData.statusId)
			return true;
		else
			return false;
	}
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.DefectTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
						  '</div>',

    widgetsInTemplate: true,
	isEditable: true,
    constructor: function() {
		this.draftDefectId = 0;
		this.draftItemUriList = [];
		this.needDisabled = false; 
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
	        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            allowAdjustSettings: true,
	            autoSaveSettings: true,
	            tableId: "RQM-DEFECT-TABLEVIEWER"                          
	        });  
			tableViewer.registerCellRenderer("RENDER_TYPE_RICHHOVERLINK", new RichHoverCellRenderer());
	        this._tableViewerNode.appendChild(tableViewer.domNode);
			          
	        var content = this.defects ? this.defects : [];
	        tableViewer.setContentPageSize(5);
	        tableViewer.setContent(content);
			tableViewer.setContentProvider(new DefectTableView.TableProvider());
	        tableViewer.setTableListener(new DefectTableView.TableListener(this));
			  
			tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelDefects")));
	        tableViewer.show();
			var actions = this.isEditable ? this.getTableActions() : [];
			var actionsLength = actions.length;
			for (var i = 0; i < actionsLength; i++) {
	            var action = actions[i];
	            var actionButton = tableViewer.addAction(action.actionId, action.label, null, action.iconClass, action.actionHandler);
	            if (action.disabled && action.disabled == true)
	                actionButton.setDisabled(true);
				if(action.actionId == "newdefect"){
					this.addNewActionNode = actionButton;
				}
				if(action.actionId == "adddefect"){
					this.addExistingActionNode = actionButton;
				}
				if(action.actionId == "changestatus"){
					this.changeStatusActionNode = actionButton;
				}
				if(action.actionId == "deletedefect"){
					this.deleteActionNode = actionButton;
				}	
	        }
			this.tableViewer = tableViewer;
    },
	setContent: function(content){
		var newContent = content ? content : [];
		this.tableViewer.setContent(newContent);
		this.tableViewer.refresh();
		if(this._defectView){
			this._defectView.defectList = [];
		}
		if(this.changeStatusActionNode)
			this.changeStatusActionNode.setDisabled(true);
		if(this.deleteActionNode)
			this.deleteActionNode.setDisabled(true);
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	enableActions:function(){
		if(this.isEditable){
		this.addNewActionNode.setDisabled(false); 
		this.addExistingActionNode.setDisabled(false); 
		} 
	},
	getTableActions: function(){
		var actions = [];
			   
            actions.push({
                actionId: "newdefect",
                label: Constants.getMessage("labelAddNewDefect"),
                actionHandler: dojo.hitch(this, "onCreateNewDefect"),
                iconClass: "new-defect-icon-image",
				disabled: this.needDisabled                  
            });
            actions.push({
                actionId: "adddefect",
                label: Constants.getMessage("labelAddExistingDefect"),
                actionHandler: dojo.hitch(this, "onAddDefect"),
                iconClass: "add-defect-icon-image",
                disabled: this.needDisabled              
            });
			actions.push({
                actionId: "changestatus",
                label: Constants.getMessage("labelChangeStatus"),
                actionHandler: dojo.hitch(this, "onChangeStatus"),
                iconClass: "change-blocked-defect-status-icon-image",
                disabled: true              
            });
			
			actions.push({
                actionId: "deletedefect",
                label: Constants.getMessage("labelRemoveDefects"),
                actionHandler: dojo.hitch(this, "onDeleteDefect"),
                iconClass: "delete-icon-image",
				disabled: true                  
            });  
			return actions;
	},
	_getEWI: function(){
		return this.parentEditor.ewi?this.parentEditor.ewi:this.parentEditor.ewis[0];
	},
	
	_freshDefectTable: function(defect){
		this.parentEditor._updateExternalDraftItem({id: defect.id,
						summary: Utility._restoreTags(defect.summary),
						status: defect.status,
						defectItemUri: defect.reference
		});
	},
	
	onCreateNewDefect: function(){
		this._defectIconClicked("new",Constants.getMessage("labelAddNewDefect"));
	},
	
	onAddDefect: function(){
		this._defectIconClicked("existing",Constants.getMessage("labelAddExistingDefect"));
	},
	
	onDeleteDefect: function(){
		this._defectIconClicked("delete",Constants.getMessage("labelRemoveDefect"));
	},
	
	_defectIconClicked: function(contextMenuSelection, title){		
		ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
            if (currentProvider != null){
				this._dispatchDefectActionViaProvider(contextMenuSelection, currentProvider);
			} else {
				if(contextMenuSelection !== "delete")
					this._defectIconClicked2(contextMenuSelection,title);
				else
					this._deleteDefect();
			}
        }));
	},
	_deleteDefect:function(){
		var defects = this.getSelectedRows();
		this.parentEditor._removeDefects(defects);
	},
	_dispatchDefectActionViaProvider: function(contextMenuSelection, currentProvider) {
		if (!contextMenuSelection || contextMenuSelection == "new") {
			this._addNewDefectViaPicker(currentProvider);
		} else if (contextMenuSelection == "existing") { 
			this._addExistingDefectViaPicker(currentProvider);
		} else if (contextMenuSelection == "delete") {
			this._deleteDefectViaProvider();
		}
	},
	
	_addNewDefectViaPicker: function(currentProvider){
		var result = this.parentEditor ? this.parentEditor.result : null;
		var er;
		if(result){
			er = result.id;
		}
		NewDefectDataInitializer.getDefectDescription(this._getEWI(),null, er, currentProvider, dojo.hitch(this, function(desc) {
			var self = this;
			
			var summary;
			if(this._getEWI()){
				summary = this._getEWI().name != this._getEWI().testCase.name ? Constants.getMessage("labelFailingTestCaseWithEWI", this._getEWI().testCase.name, this._getEWI().name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this._getEWI().testCase.name)
			}
			// add build info if any
			if(this.parentEditor && this.parentEditor.result && this.parentEditor.result.buildRecord) {
            	var buildRec = this.parentEditor.result.buildRecord;
            	var buildInfo = (buildRec.parentBuildDefName) ? (buildRec.parentBuildDefName +  " : " + buildRec.name) : buildRec.name;
            
            	desc += "\r\n";
		        desc += Constants.getMessage("labelBuildRecord") + ":";
		        desc += "\r\n";
		    	desc += buildInfo;
		        desc += "\r\n";
        	}
	      	var creationUrl = null;
	        if (currentProvider.providerUris.defaultCreationDialogURI.indexOf("?") > -1) {
	           	creationUrl = currentProvider.providerUris.defaultCreationDialogURI + "&" + ItemPickerUtil.getWICreationDialogParamString(summary, desc);
	        } else {
				creationUrl = currentProvider.providerUris.defaultCreationDialogURI;	
			}
			
			var params= {
	            dialogTitle: Constants.getMessage("labelAddNewDefect"),
	            secondaryTitle: " ",
				pickerURL: creationUrl,
				height: currentProvider.providerUris.creationDialog.height,
				width: currentProvider.providerUris.creationDialog.width,
				parentElement: this.domNode,
				onOk: function(result) {
					console.debug(result);
					var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
					
					if(workItems.length > 0){
						var workItem = workItems[0];	
						
						var defect = {
								summary: Utility._restoreTags(workItem.summary),
	//							status: workItem.status,
								defectItemUri: workItem.url,
								uri: workItem.url					
							};
	//					if(currentProvider.linkType != ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST){
	//						defect.isRTCWorkItem = true;
	//					}
						var defectList= [];
						defectList.push(defect);
							if(dojo.isFunction(self.parentEditor._appendInExtDefectList)){
								self.parentEditor._appendInExtDefectList(defectList,"new");
							}	
					}
				},
				onClose: function() {
				    console.debug("close!");
				}
	
	        };	            
	        new RemoteItemPicker(params);
		}));
	},
	
	_addExistingDefectViaPicker: function(currentProvider){
		var self = this;
		
		var defectSelectionDialog = currentProvider.services.getSelectionDialog("defect", true);
		var params= {
            dialogTitle: Constants.getMessage("labelAddExistingDefect"),
            secondaryTitle: " ",
			pickerURL: defectSelectionDialog.uri,
			height: defectSelectionDialog.height,
			width: defectSelectionDialog.width,
			parentElement: this.domNode,
			onOk: function(result) {
				console.debug(result);
				
				var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
				
				if(workItems.length > 0){
					var defectList= [];
					for(var i = 0; i < workItems.length; i++){
						var workItem = workItems[i];	
					
						var defect = {
								summary: Utility._restoreTags(workItem.summary),
								defectItemUri: workItem.url,
								uri: workItem.url					
							};
						defectList.push(defect);
					}
						if(dojo.isFunction(self.parentEditor._appendInExtDefectList)){
							self.parentEditor._appendInExtDefectList(defectList,"new");
					}			
				}
			},
			onClose: function() {
			    console.debug("close!");
			}

        };	            
        new RemoteItemPicker(params);
	},
	
	_deleteDefectViaProvider: function(){
		var defects = this.tableViewer.getCheckedRows();
		var self = this;
		var args = {
			title: Constants.getMessage("labelConfirmation"),
			message: Constants.getMessage("msgRemoveDefectAssociation"),
			yesCallback: function(defects){
				self.parentEditor.removeExternalDraftItem(defects);
				return true;          
			},
			yesCallbackData:defects
		}
		var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        dialog.setSecondaryTitle(args.title);
        dialog.open();
	},
	
	_getExecutionResultUri:function(){
		var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
		result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
		result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionResult/" + this.parentEditor.resultItemId;
		return result;
	},
	_getEwiUri: function() {
		var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
		result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
		result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + this._getEWI().itemId;
		return result;
	},
	_defectIconClicked2: function(contextMenuSelection, title){
		this._defectView = new DefectView({parentEditor: this.parentEditor});
		this.addNewActionNode.setDisabled(true);
		this.addExistingActionNode.setDisabled(true);
		var dialogArgs = {
			primaryTitle: title,
            isClosable: true,
			showActions:false,
			style: "z-index: 997;",
			zIndex: 997,//keep below 1000 for datepicker to show
			onClose: dojo.hitch(this, function(){
				this.addNewActionNode.setDisabled(false);
				this.addExistingActionNode.setDisabled(false);
				//ELB
				if(dojo.isFunction(this.parentEditor._appendInDefectList)){
					this.parentEditor._appendInDefectList(this._defectView.defectList,contextMenuSelection);
				}
			})
		}
		    
        this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog(dialogArgs);
		this._defectsViewer.blockerDiv.style.zIndex = 998;
		this._defectView.setParentDialog(this._defectsViewer);
		this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);

        // this is a opening a new defect, get the initial seed values for the form.
        // Don't open the form until we've fetched all related data.
        if (contextMenuSelection == "new") {
			var result = this.parentEditor ? this.parentEditor.result : null;
			if(result){
				NewDefectDataInitializer.getDefectSeedValuesFromEWI(this._getEWI(),null,null,result.id, dojo.hitch(this, "_initNewDefectForm"));
			}else{			
	            NewDefectDataInitializer.getDefectSeedValuesFromEWI(this._getEWI(), null, null, null, dojo.hitch(this, "_initNewDefectForm"));
			}			
			var cshelp = new CSHelp({contextID: "rqm_add_new_def.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelAddNewDefectHelp"));
			this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
        }
        else {
            this._defectView.setViewType(contextMenuSelection);
			var cshelp = new CSHelp({contextID: "rqm_add_exist_def.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelAddExistingDefectHelp"));
			this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
            this._defectsViewer.open();
            this._defectsViewer.setWidth('800px');
        }
	},

    _initNewDefectForm: function(seedValues) {
        // record the build info if one exists.
        if(this.parentEditor && this.parentEditor.result && this.parentEditor.result.buildRecord) {
            var buildRec = this.parentEditor.result.buildRecord;
            var buildInfo = (buildRec.parentBuildDefName) ? (buildRec.parentBuildDefName +  " : " + buildRec.name) : buildRec.name;
            
            seedValues[NewDefectDataInitializer.BUILD_ID_ATTR] = buildInfo;
        }
        this._defectView.setViewType("new", seedValues);    
        this._defectsViewer.open();
        this._defectsViewer.setWidth('800px');
    },
	
	onChangeStatus: function(){
		var defects = this.getSelectedRows();
		ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
			if (currentProvider != null) {
				this.parentEditor._updateExtDefectStatus(defects);
			}else {
				var defectsLength = defects.length;
				for (var i = 0; i < defectsLength; i++) {
					this.parentEditor._updateDefectStatus(defects[i].id,!defects[i].isBlocking);
				}
			}
		}));
	},
	
	getSelectedRows: function() {
	     return this.tableViewer.getCheckedRows();
	 }
});
})();
