/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents   = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AbstractFilteredExecutionPagingTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionPagingTableView;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var ExecutionResultClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var AllResultsMapper = com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper;
var ProgressUtility  = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;
var LabelNA = Constants.getMessage("labelNA");

dojo.declare("ExecutionLogTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(parentView) {
        this.parentView = parentView;
    },

    rowCheckStateChanged: function(tableViewer, rowObject, state){
        var selection = tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(selection);
        var selectionCount = realSelection ? selection.length : tableViewer.getContentPageSize(); // use the page size for select all
		var p = this.parentView;

        if (p.deleteActionNode)
            p.deleteActionNode.setDisabled(selectionCount == 0);
		//Print action node
		if (selectionCount == 0) {
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfsummarymenu");
			p.showAction("printpdfsummarymenu");
		} else if (selectionCount > 1) {
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfsummarymenu");
			p.enableAction("printpdfmultiplemenu");
			p.showAction("printpdfmultiplemenu");
		} else if (selectionCount == 1) {
			p.hideAction("printpdfsummarymenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfhistorycarmenu");
			p.showAction("printpdfhistorycarmenu");
		}
    },
	
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
     	if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		else if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData){
        if(callback) {
            callback(actionId, filters);
        }                     
    }
});

dojo.declare("ExecutionLogTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{    
    getNumColumns: function(content){
        return 15;
    },
 
 
    _columnHeadings: [
		Constants.getMessage("labelId"),
		Constants.getMessage("labelName"),
		Constants.getMessage("labelTestCase"),
        Constants.getMessage("labelTestScript"),
        Constants.getMessage("labelCompleted"),
		Constants.getMessage("labelState"),
		Constants.getMessage("labelEWINameLabel"),
		Constants.getMessage("labelBuild"),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelPass")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelFail")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelBlocked")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelInconclusive")),
		Constants.getMessage("labelPointsValue", Constants.getMessage("labelAttempted")),
		Constants.getMessage("labelTestPlan"),
		Constants.getMessage("labelIteration")
    ],
 	ids: [
		"id","name","testCase","testScript","completed",
		"stateIds","TER","build","pointsPass","pointsFail",
		"pointsBlocked","pointsInconclusive","pointsAttempted","testPlan","testPhaseName"
    ],
    
    getColumnIdName: function(index){
        return this.ids[index];
    },

    getColumnHeading: function(content, index){
        return this._columnHeadings[index];
    },
 
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },

    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
	getIsColumnVisible: function(atColumnIndex){
		return ( ! (atColumnIndex >= 6));
	},
	
    getIsColumnGroupable: function(content, atColumnIndex){
        return ((atColumnIndex > 0 && atColumnIndex <= 7)||(atColumnIndex >12));     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex != 6 && atColumnIndex !=7);   
    },
    
    _columnWidths: [8,17,23,24,13,15,10,10,10,10,10,10,10,10,10],  //  190???

    getColumnWidth: function(content, atColumnIndex){
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_execution_result_" + rowData.itemId;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0:
			case 1: 
			case 2: 
			case 3: 
            case 5: 
			    type = TableConstants.RENDER_TYPE_LINK;
                break;
            case 4: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;					 			 
			case 7: 
                type = rowData.buildName ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
                break;						 
			case 13: 
                type = rowData.testPlan ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
                break;						 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },

    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
			case 0:
				val = rowData.id;
				break;
			case 1:
                var name = rowData.name ? rowData.name : "";
				val = Constants.getMessage("labelNamedResult", name);
				break;	
			case 2:
				val = rowData.testCase ? rowData.testCase.name: "";
				break;
            case 3: 
                val = rowData.script && rowData.script.name ? rowData.script.name:""; //Test Script Name
                break;
            case 4:
				val = LabelNA; 
                if (rowData.endTime > 0) {
                   val = new Date(); //Completed
                   val.setTime(rowData.endTime);
                }
                break;   
            case 5: 
                val = Utility.getStatusText(rowData); //State
                break;
			case 6: 
                // the name is the TER name. We tag on the result label (above in name column)
                // to indicate we're looking at the result of the TER execution.
                val = rowData.name ? rowData.name : ""; //EWIName
                break;	
			case 7: 
                val = rowData.buildName ? rowData.buildName : LabelNA; ; //Build name
                break;
			case 8: 
                val = rowData.pointsPassed; //Pass points
                break;
			case 9: 
                val = rowData.pointsFailed; //Fail points
                break;
			case 10: 
                val = rowData.pointsBlocked; //Blocked points
                break;
			case 11: 
                val = rowData.pointsInconclusive; //Inconclusive points
                break;
			case 12: 
                val = rowData.pointsAttempted; //Attempted points
                break;				 
			case 13: 
                val = rowData.testPlan?rowData.testPlan.name:""; //Plan
                break;
			case 14: 
                val = rowData.phaseName?rowData.phaseName:""; //MileStone
                break;				 
        }
        return val;
    },
    getCellRawData: function(rowData, atColumnIndex)
    {
        // don't need to convert the long time value to Time object.
        // return the raw data for sorting/grouping operations.
        if(atColumnIndex == 4) {
            return rowData.endTime|| "";
        }
        return this.getCellDisplayData(rowData, atColumnIndex);
    },
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){ 
        var val = {};
        // name column: attach to the result page.
		if(atColumnIndex == 0 || atColumnIndex == 1 || atColumnIndex == 5) {
            val.href = this.getHref(rowData);
        }
		else if (atColumnIndex == 2 && rowData.testCase && rowData.testCase.id) {
			val.href = Utility.getTestCaseURI(rowData.testCase.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
        else if (atColumnIndex == 3 && rowData.script && rowData.script.id) {
			val.href = Utility.getTestScriptURI(rowData.script.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
		else if(atColumnIndex == 7 && rowData.buildId){
			val.href = com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil.getBuildRecordURI(rowData.buildId);
		}
		else if(atColumnIndex == 13 && rowData.testPlan && rowData.testPlan.id){
			val.href = Utility.getTestPlanURI(rowData.testPlan.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
        return val;
    },
	
	getHref: function(rowData) {
		return Utility.getResultURI({resultItemId: rowData.itemId});
	}
});

dojo.declare("ExecutionLogTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);
		
        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyResults"),
                promptTitle: Constants.getMessage("labelOnlyMyResults"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: this.defaultToMine,
                params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelExeResults"));
    },
	
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },	
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
					args[nameKey] = '';
				}
            }
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionPagingTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,
    pdfPrintType: "executionresult",  // define the pdf print type. Our super class will handle it.

    constructor: function() {
	 	this.results = null;
        this.showInitLoadProgress = false;
		this._actionButtons = [];
        this.showQueryFilters = false;
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
        
        this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
		
        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(ExecutionResultClient, "getAllSearchResultItemIds");

        // we're showing query filters, we'll be managing our own
        // contents. Initialize the query filters first.
		setTimeout(dojo.hitch(this,function(){
			this._initialize();
		}),0);
        if (this.isQueryPage && this.showQueryFilters) {
	        //setup search details
			this.setSearchFunction(dojo.hitch(ExecutionResultClient, "searchAllResults"));
	        this.setSearchCallback(dojo.hitch(this, "refresh"));
	        this.setResponseHandlerType(AllResultsMapper);
	        this.setTypeLabel(Constants.getMessage("labelViewTestcaseResults"));
		    
			//initialize filters
            this._initializeFilters();
        }
	},
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new ExecutionLogTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine());

        var filters = this.filterProvider.filters;
         //append new filters - owner and then states (via callback)
        var callback = dojo.hitch(this, function(){
	        var statesFilter = {           
	            //filterName, filterLabel, filterPrompt, filterType, callback
	            name: "stateIds",
	            label: Constants.getMessage("labelStateLabel"),
	            prompt: Constants.getMessage("labelState"),
				type:TableContentFilterProvider.FIELD_TOGGLELIST
	        }
	        this.addExecutionStateFilter(statesFilter, this.filterProvider.filters, dojo.hitch(this, "_initialize2"));
		});
		
		//append owner field
        var ownerFilter = {
            name: "ownerUUIDs",
            label: Constants.getMessage("labelowner"),
            prompt: Constants.getMessage("labelOwner") ,
			type:TableContentFilterProvider.FIELD_TOGGLELIST
        }
        this.addContributorFilter(ownerFilter, this.filterProvider.filters, callback);
		
        filters.push({
            name: "id", // must match key in the arg list of the API
            title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: null
        });

        // add the test script filter
        var testScriptFilter = {
            name: "testScript",  // must match what the filter provider looks for
            label: Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelTestScript"),
            artifactType: Constants.TYPE_SCRIPT,
            simpleKey: "testScriptName",
            advancedKey: "vScriptUUIDs"
        };
        this.addAdvancedArtifactFilter(testScriptFilter, filters);

        // add the test case filter
        var testCaseFilter = {
            name: "testCase",  // must match what the filter provider looks for
            label: Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelTestCase"),
            artifactType: Constants.TYPE_CASE,
            simpleKey: "testCaseName",
            advancedKey: "vTestCaseUUIDs"
        };
        this.addAdvancedArtifactFilter(testCaseFilter, filters);

        // add the test plan filter
        var testPlanFilter = {
            name: "testPlan",  // must match what the filter provider looks for
            label: Constants.getMessage("labelTestPlan") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelTestPlan"),
            artifactType: Constants.TYPE_PLAN,
            simpleKey: "testPlanName",
            advancedKey: "vTestPlanItemIds"
        };
        this.addAdvancedArtifactFilter(testPlanFilter, filters);

        filters.push({
            name: "testPhaseName", // must match key in the arg list of the API
            title: Constants.getMessage("labelIteration") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelIteration"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null,
            params: null
        });
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "completed",  // must match what the filter provider looks for
            fromKey: "completedFrom",
            toKey: "completedTo",
            label: Constants.getMessage("labelCompleted") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelCompleted")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, filters);
    },
	
    _remapQueryArgs: function(cachedFilterArgs) {
        var filterArgs = this.inherited("_remapQueryArgs", arguments);
        var filterArgsCloned = false;
        
        // test script filter can be simple by name or advanced by array of id
        if (filterArgs["testScript"] != null) { // expect to be single entry array
            filterArgs = dojo.clone(filterArgs);
            filterArgsCloned = true;
            for (var key in filterArgs["testScript"]) {
                if (key != "advancedObj") {
                    filterArgs[key] = filterArgs["testScript"][key];
                }
            }
            delete filterArgs["testScript"];
        }
        // test case filter can be simple by name or advanced by array of id
        if (filterArgs["testCase"] != null) { // expect to be single entry array
            if (!filterArgsCloned) {
                filterArgs = dojo.clone(filterArgs);
                filterArgsCloned = true;
            }
            for (var key in filterArgs["testCase"]) {
                if (key != "advancedObj") {
                    filterArgs[key] = filterArgs["testCase"][key];
                }
            }
            delete filterArgs["testCase"];
        }
        // test plan filter can be simple by name or advanced by array of id
        if (filterArgs["testPlan"] != null) { // expect to be single entry array
            if (!filterArgsCloned) {
                filterArgs = dojo.clone(filterArgs);
                filterArgsCloned = true;
            }
            for (var key in filterArgs["testPlan"]) {
                if (key != "advancedObj") {
                    filterArgs[key] = filterArgs["testPlan"][key];
                }
            }
            delete filterArgs["testPlan"];
        }
        return filterArgs;
    },

	_initialize: function() {
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            allowMultiSort: true,
            handleVirtualSelectAll: true,            
            tableId: "RQM-TE-LOG-TABLEVIEWER",
			sortByColumn:4,
			sortDir:TableConstants.SORT_DIR_DESCEND                                
        });        
		
        // initFilterProvider uses the table's id to index
        // into the per-session saved filters. Need to setup
        // this attribute to properly obtain the saved filters.
        this.tableViewer = tableViewer;
				
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.results ? this.results : [];
		this.queryName = this.queryName ? this.queryName : Constants.getMessage("labelExeResults");
        
		 if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
			this.viewHeaderNode.setCSHelpId("rqm_view_exec_results.html");
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelExeResultsHelp"));
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }
		  
        tableViewer.setContent(content);
		this.provider = this._constructTableContentProvider();	
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableListener(new ExecutionLogTableView.TableListener(this));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		
		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
		
        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_RESULT;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
		if (this.isQueryPage && (!perm || perm.archive)) {
            this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "invokeAction", "itemId", this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);
        }
		tableViewer.setTableRowsCheckable(true, false);
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
		  		
		//******print button content******
		var printHistoryCARMenu = new dijit.Menu({ style: "display: none;"});
		var printSummaryMenu = new dijit.Menu({ style: "display: none;"});
		var printMultipleMenu = new dijit.Menu({ style: "display: none;"});
		
        var normalOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelCAR"),
        	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "artifact-print")   // uses the new print engine
        });
        var historyOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelHistory"),
        	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print")    // uses the new print engine
        });
        var summaryOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelSummary"),
        	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "list-table-print") // uses the new print engine   
        });        
        var multipleOption = new dijit.MenuItem({
        	label: Constants.getMessage("printLabelMultiple"),
        	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "artifact-print")   // uses the new print engine
        });
		
        printHistoryCARMenu.addChild(normalOption);
        printHistoryCARMenu.addChild(historyOption);      
        printSummaryMenu.addChild(summaryOption);
        printMultipleMenu.addChild(multipleOption);
        
       	this.printSummaryActionNode = tableViewer.addAction(
       			"printpdfsummarymenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintPdfActionClick"),
       			printSummaryMenu
       	);      	
       	this._actionButtons.push(this.printSummaryActionNode);
       	this.enableAction("printpdfsummarymenu");
       	
       	this.printHistoryCARActionNode = tableViewer.addAction(
       			"printpdfhistorycarmenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print"),
       			printHistoryCARMenu
       	);
       	this._actionButtons.push(this.printHistoryCARActionNode);
       	this.hideAction("printpdfhistorycarmenu");
       	
       	this.printMultipleActionNode = tableViewer.addAction(
       			"printpdfmultiplemenu",
       			Constants.getMessage("labelPDFView"),
       			null,
       			"pdf-icon-image",
       			dojo.hitch(this, "_onPrintPdfActionClick"),
       			printMultipleMenu
       	);
       	this._actionButtons.push(this.printMultipleActionNode);
       	this.hideAction("printpdfmultiplemenu");
		//******end print button content******
		if(!this.showQueryFilters && (!content || !content.length)){
			this.printSummaryActionNode.setDisabled(true);
			this.printHistoryCARActionNode.setDisabled(true);
			this.printMultipleActionNode.setDisabled(true);
		}
		
		
    },
	_initialize2:function(){
		//if preference specifies, run the query
		if (this.showQueryFilters) {
			this.initRunQuery();
			this.initFilterProvider(this.filterProvider);
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
		}
	},
	_constructTableContentProvider: function() {
        //create the table provider
        return new ExecutionLogTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });     
    },

	_onDeleteActionClick: function(selectedIds) {
		var selectedERs = selectedIds;
		var len = selectedERs.length;
        var args = {
            'message': Constants.getMessage("msgDelExecutionResultConfirm",len),
            'yesCallback': dojo.hitch(this, "_deleteAction"),
            'yesCallbackData': selectedIds,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function(selectedIds) {         
        this.deleteActionNode.setDisabled(true);
        var selectedERCount = selectedIds.length;

        this.selectedIds = selectedIds;
		this.selectedER = selectedERCount;
		this.archivedERs = 0;
        
		if (selectedERCount > 0) {
            var self = this;
            var callbackER = {
                success: function(par){
                    self.archivedERs = par;
                    self._deleteSuccess();
                },
                failure: function(err){
                    self._deleteFailure();
                }
            }
            this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingExecutionResult"), 0, null); 
            var responseHandler = new ServiceResponseHandler(callbackER, "success", "failure");
            ExecutionResultClient.archiveExecutionResult(responseHandler, {
                uuids: selectedIds,
                archive: true
            });
        }
    },
    
    _deleteSuccess: function(response) {
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
		this.errorERCount++
        this._setDeleteStatus(err);
    },
    
    _setDeleteStatus: function(err){
        ProgressUtility.endTaskMonitor(this.monitorId, (err && err.message) ? err.message : null);
        if (this.isQueryPage) {
            var message = Constants.getMessage("msgDeletedExecutionResults", this.archivedERs, this.selectedER);
            this.viewHeaderNode.setStatus(message, this.errorERCount == 0 ? ViewHeaderLayout.SUCCESS : ViewHeaderLayout.INFO);
        }
        if (this.archivedERs > 0) {
            // notify all pages (including itself) execution results are deleted
             this._deleteBySelf = true;
            dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_EXE_LOG, this.selectedIds]);
        }
    },

	refresh: function(content) {
        if(this.showInitLoadProgress && !this.inProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		if(this.printSummaryActionNode && this.printHistoryCARActionNode 
				&& this.printMultipleActionNode){
			var disable = (!content || !content.length);
			this.printSummaryActionNode.setDisabled(disable);
			this.printHistoryCARActionNode.setDisabled(disable);
			this.printMultipleActionNode.setDisabled(disable);
		}
		this.results = content;
		// we are only updating the virtual content. The virtual
        // content provider has convenient method to do that. Call
        // it to load the virtual content. Updating a virtual page
        // is much less 'destructive' then a regular table refresh.
        // It retains the row selection states.
        if (this.updatePageOnly) {
			this.provider.loadPageContent(content);
		}
		else {
			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		}
		this.viewHeaderNode.clearStatus();
    },

	uninitialize: function(){
		//Remove menu items
		var menus = this._actionButtons;
		var menuLength = menus ? menus.length : 0;
		if(menus && menuLength>0){
			for(var i=0;i<menuLength;i++){
				menus[i].destroyRecursive();
			}
		}
	},
	
	getActionButton: function(actionId) {
    	 var len = this._actionButtons ? this._actionButtons.length : 0;
         for (var i = 0; i < len; i++) {
        	 if (this._actionButtons[i].actionId == actionId) {
        		 return this._actionButtons[i];
             }
         }        
      },

	hideAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.addClass(button.domNode,"dijitDisplayNone");
          }
      },
      
	showAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.removeClass(button.domNode,"dijitDisplayNone");
          } 
      },    

	disableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(true);
          } 
      },
  	
	enableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(false);
          } 
      }, 
	
    // handler on added exe log
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about exe log
        if (artifactType == Constants.TYPE_EXE_LOG) {
            if (this._deleteBySelf && changeType == GlobalEvents.ArtifactsDeleted && this._invalidateQuery) {
                this._invalidateQuery();
                delete this._deleteBySelf;
                return;
            }
            if (this.isQueryPage) {
                this._showArtifactChangedMessage(this.viewHeaderNode, Constants.TYPE_RESULT, changeType);
                return;
            }
			var results = this.results;
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add exe log to the table
                if (!results) {
                    results = artifactArray;
                } else {
                    results = results.concat(artifactArray);
                }
            } else {
				var found = false;
				var len = results.length;
				var artifactLength = artifactArray.length;
                
                // iterate through the array of artifacts
                for (var i = 0; i < artifactLength; i++) {
					found = false;
                    // iterate through the array of results in the table
                    for (var j = 0; j < len; j++) {
                        // handle the matching result
                        if (artifactArray[i].itemId == results[j].itemId) {
                            // swap result on update
							if (changeType == GlobalEvents.ArtifactsUpdated){
								results.splice(j, 1, artifactArray[i]);
							}else if (changeType == GlobalEvents.ArtifactsDeleted){//remove on deletion
								results.splice(j, 1);
								len-=1;
							}
							found = true;
                            break;
                        }
                    }
					if (!found) {
						results = results.concat(artifactArray[i]);
					}
			    }
            }
			this.results = results;
			this.tableViewer.setContent(results);
            this.tableViewer.refresh();
        }
    }
});

})();