/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

(function() {

var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache    			= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility     		   	= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants  			    = com.ibm.rqm.planning.web.client.internal.Constants;
var ConfigurationUriUtil 	= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var ExecutionResultStates	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
var LabelTestSuite          = Constants.getMessage("labelTestSuites");
var LabelEWIs               = Constants.getMessage("labelEWIs");
var LabelExecution          = Constants.getMessage("labelExecution");
var LabelUnassigned         = Constants.getMessage("labelUnassigned");
var LabelLocalMachine       = Constants.getMessage("labelLocalComputer");
var LabelSuiteExecCancelled = Constants.getMessage("msgSuiteExecCancelled");
var LabelExeResult          = Constants.getMessage("labelExeResult");
var ExecutionClient         = com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
var TableContentFilterProvider         = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var AbstractFilteredExecutionTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView;
var ServiceResponseHandler          = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

dojo.declare("ExecutionTableViewTableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
  
    rowCheckStateChanged: function(tableViewer, rowObject, state){
	},
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData){                
        if (callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData){
        if (callback) {
            callback(actionId, filters);
        }                     
    }
});

dojo.declare("ExecutionTableViewTableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);
    },
	
	setERGId: function(ergId){
		this.ergId = ergId;
	},
	
    getNumColumns: function(content){
        return this.getIsConsoleNode() ? 9 : 8;
    },
    

    _columnHeadings: [
		Constants.getMessage("labelType"),
        Constants.getMessage("labelName"),
        Constants.getMessage("labelConfig"),
        Constants.getMessage("labelScript"),
		Constants.getMessage("labelHostname"),
		Constants.getMessage("labelstatus"),
		Constants.getMessage("labelProgress"),
		Constants.getMessage("labelModified"),
	    Constants.getMessage("labelResult")
    ],
    
	getColumnHeading: function(content, index){
        if(!this.getIsConsoleNode()){
			index++;
		}
        return this._columnHeadings[index];
    },
	
	_columnIdName: [
        Constants.getMessage("types"),
        Constants.getMessage("name"),
        Constants.getMessage("configuration"),
        Constants.getMessage("scriptName"),
        Constants.getMessage("hostname"),
        Constants.getMessage("statusIds"),
        Constants.getMessage(""),
        Constants.getMessage("modified"),
        Constants.getMessage("resultStateIds")
	],
	
    getColumnIdName: function(index){
        if(!this.getIsConsoleNode()){
            index++;
        }
        return this._columnIdName[index];
    },

	getIsColumnVisible: function(atColumnIndex){
		return this.getIsConsoleNode() && atColumnIndex == 8 ? false : true;
	},
	
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
		if(this.getIsConsoleNode())
			return (atColumnIndex === 0); 
		else
			return false;    
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
		switch(atColumnIndex) {
            case 0: 
                return 6;
			case 1: 
                return this.getIsConsoleNode() ? 12 : 16;
            case 2: 
                return 14;
            case 3: 
                return 14;
            case 4: 
                return 14;
			case 5: 
                return 6;
			case 6: 
                return 19;
            case 7: 
                return this.getIsConsoleNode() ? 15 : 11;
			case 8: 
                return 6;	 
        }
        return 0;
    },
   
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_con_" + rowData.itemId;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
                type = (rowData.state && rowData.state.id != "com.ibm.rqm.executionframework.common.requeststate.cancelled")  ? TableConstants.RENDER_TYPE_LINK: TableConstants.RENDER_TYPE_TEXT;
                break;
			case 2: 
                type = rowData.configuration ? TableConstants.RENDER_TYPE_LINK : (this._getPropertyValue(rowData.propertiesMap, "configuration") != "" ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT);
                break;
			case 3: 
                type = rowData.scriptName ? TableConstants.RENDER_TYPE_LINK : (this._getPropertyValue(rowData.propertiesMap, "scriptName") != "" ? TableConstants.RENDER_TYPE_LINK: TableConstants.RENDER_TYPE_TEXT);
                break;	
			case 5: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 6: 
                type = (rowData.state && rowData.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled")?
							TableConstants.RENDER_TYPE_TEXT:"RenderType.ProgressBar";
                break;
            case 7: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;                               
			case 8:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;					 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        if(atColumnIndex < 0)
            return TableConstants.ALIGN_CENTER;
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
		if(atColumnIndex == 0 || atColumnIndex == 5 || atColumnIndex == 8)
			return TableConstants.ALIGN_CENTER;	
        return TableConstants.ALIGN_LEFT;
    },
        
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
        switch(atColumnIndex) {
            case 0: 
                val = rowData.scriptTypeName ? LabelTestSuite : LabelEWIs;
                break;
			case 1:
				val = rowData.testCaseName ? rowData.testCaseName : this._getPropertyValue(rowData.propertiesMap, "testCaseName");
				val = val + " " + LabelExecution; 		
                break;
            case 2: 
                val = rowData.configuration ? rowData.configuration : (this._getPropertyValue(rowData.propertiesMap, "configuration") != "" ? this._getPropertyValue(rowData.propertiesMap, "configuration"): LabelUnassigned);
                break;
            case 3: 
                val = rowData.scriptName ? rowData.scriptName : (this._getPropertyValue(rowData.propertiesMap, "scriptName") != "" ? this._getPropertyValue(rowData.propertiesMap, "scriptName"): LabelUnassigned);
                break;   
            case 4: 
				val = rowData.machine ? rowData.machine : (this._getPropertyValue(rowData.propertiesMap, "machine") != "" ? this._getPropertyValue(rowData.propertiesMap, "machine") : LabelLocalMachine);
                break; 
			case 5: 
				val = rowData.state ? rowData.state.id : "";
                break;
			case 6: 
				if(rowData.state && rowData.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled")
					val = LabelSuiteExecCancelled;
				else
					val = rowData.progress;	
                break;
			case 7:
				var now = new Date();
				if (parseInt(now.getTime(), 10) > parseInt(rowData.modified, 10)) {
                    now.setTime(rowData.modified);
                }
                val = now;
                break;
			case 8:
				val = "";
				var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId");
				if (resultId && resultId != "")
					val = LabelExeResult;
				break;
        }
        return val;
    },

    // Implements the rawData method. This is used by sorting/grouping comparison of
    // row data. Returns the proper and compariable data for columns. Several columns
    // data returned in the getCellDisplayData method are empty strings due to the column type
    // being an image. This method returns the comparible data for those columns.
    getCellRawData: function(rowData, atColumnIndex)
    {
        atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
        
        // state name
        if(atColumnIndex == 5) {
            return Utility.getRequestStateToolTip(rowData.state);   
        }
        // modified time. for comparison, just the long value 
        else if(atColumnIndex == 7) {
            return rowData.modified;
        }
        // result display string
        else if(atColumnIndex == 8) {
            var val = (rowData.resultState) ? rowData.resultState.name : this._getPropertyValue(rowData.propertiesMap, "resultResultStateName");

            // if no results yet, check to see if it has been started, if so, use the label.
            // Otherwise, the test has not been started, just keep it an empty string.
            if(!val) {
                var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId");
                val = (resultId && resultId != "") ? LabelExeResult : "";
            }
            return val;           
        }
        return this.getCellDisplayData(rowData, atColumnIndex);
    },
        
    _getPropertyValue: function(propertiesMap, key){
		var value = "";
		var len = propertiesMap ? propertiesMap.length : 0;
		for(var i=0;i<len;i++){
			if(propertiesMap[i].propertyName == key){
				return propertiesMap[i].propertyValue;
			}
		}
		return value;
	},
	
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){ 
        var val = {};  
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
		if(atColumnIndex == 0){
			 val.image = rowData.icon ? rowData.icon : ImageCache.EWI;
			 if(rowData.link)
				val.href = rowData.link;
			else{
				var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId") !="" ? this._getPropertyValue(rowData.propertiesMap, "resultItemId") : null;
				var ergId = this.ergId?this.ergId:this._getPropertyValue(rowData.propertiesMap,"resultGroupId");
            	val.href = Utility.startExecution(this._getPropertyValue(rowData.propertiesMap, "ewiItemId"), this._getPropertyValue(rowData.propertiesMap, "scriptItemId"), resultId, rowData.id, ergId);
			} 
		} else if(atColumnIndex == 1) {
			if(rowData.link){
				 val.href = rowData.link;
			}else{
				var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId") !="" ? this._getPropertyValue(rowData.propertiesMap, "resultItemId") : null;
				var ergId = this.ergId?this.ergId:this._getPropertyValue(rowData.propertiesMap,"resultGroupId");				
	            val.href = Utility.startExecution(this._getPropertyValue(rowData.propertiesMap, "ewiItemId"), this._getPropertyValue(rowData.propertiesMap, "scriptItemId"), resultId, rowData.id, ergId);
				val.tooltip = Utility.getTestInformationToolTip({
					type: Constants.getExtensionDisplayMessage(this._getPropertyValue(rowData.propertiesMap, "scriptTypeName")),
					testPlan: this._getPropertyValue(rowData.propertiesMap, "testPlan"),
					testPhase: this._getPropertyValue(rowData.propertiesMap, "testPhase")
				});
			}	
        }else if(atColumnIndex == 2){
			if(rowData.link){
				val.href = rowData.link;
			}else{
				var id = this._getPropertyValue(rowData.propertiesMap, "configId");
				val.href = (id ? ConfigurationUriUtil.getEditConfigurationURI(id) : "");
			}
		}else if(atColumnIndex == 3) {
			if(rowData.link){
				val.href = rowData.link;
			}else{
				var revision = this._getPropertyValue(rowData.propertiesMap, "scriptRevision");
				if (revision && revision > 0) {
					val.href = Utility.getTestScriptURI(this._getPropertyValue(rowData.propertiesMap, "scriptItemId"), null, this._getPropertyValue(rowData.propertiesMap, "scriptRevision"), this._getPropertyValue(rowData.propertiesMap, "scriptSnapshotName"));
				} else {
            		val.href = Utility.getTestScriptURI(this._getPropertyValue(rowData.propertiesMap, "scriptId"), Utility.CONSTRUCTION_PERSPECTIVE);
				}
			}	
		}else if(atColumnIndex == 5) {
			var stateId = rowData.state ? rowData.state.id : null;
			val.image = Utility.getStateInfo(stateId, null, true);
			val.tooltip = Utility.getRequestStateToolTip(rowData.state);
		}else if(atColumnIndex == 6) {
			if(rowData.state && rowData.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled"){
				val.initialText = Constants.getMessage("msgSuiteExecCancelled");
			}else{
				if(rowData.link){
					val.href = rowData.link;
				}else{
					var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId") !="" ? this._getPropertyValue(rowData.propertiesMap, "resultItemId") : null;
					var ergId = this.ergId?this.ergId:this._getPropertyValue(rowData.propertiesMap,"resultGroupId");
	            	val.href = Utility.startExecution(this._getPropertyValue(rowData.propertiesMap, "ewiItemId"), this._getPropertyValue(rowData.propertiesMap, "scriptItemId"), resultId, rowData.id, ergId);
				}
				if(!this.getIsConsoleNode() && this._getPropertyValue(rowData.propertiesMap, "scriptType") == "com.ibm.rqm.planning.common.scripttype.manual"){
					val.initialText = Constants.getMessage("labelRunManTest");
				}
			}
		}else if(atColumnIndex == 8){
			val.image = ImageCache.NOIMAGE;
			if(rowData.resultState){
				var resultStateName = rowData.resultState.name;
				var resultStateId = rowData.resultState.id;
				val.href = Utility.showSuiteResult({ id: rowData.id });
				val.image = ImageCache.TEST_SUITE;
			}else{
				var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId");
				var resultStateName = this._getPropertyValue(rowData.propertiesMap, "resultResultStateName");
				var resultStateId = this._getPropertyValue(rowData.propertiesMap, "resultResultStateId");
				if (resultId && resultId != "") {
					val.href = Utility.getResultURI({resultItemId: resultId});
					val.image = ImageCache.EWI_LOG;
				}
			}
			if(resultStateId != "" && resultStateName != ""){
				val.image = ExecutionResultStates.ICONS[resultStateId];
				val.tooltip = resultStateName;
			}
		}
        return val;
    },
	
	setConsoleNode: function(bool){
		this.isConsoleNode = bool;
	},
	
	getIsConsoleNode: function(){
		return this.isConsoleNode;
	}
    
});

dojo.declare("ExecutionTableView.TableContentFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;

        // define the static filters
        this.filters = [];
        
        if (this.tableView.getIsConsoleNode()) {
            var typeFilters = [];
            typeFilters.push({
                name: Constants.getMessage("labelTestExecutionRecords"),
                value: "TER",
                checked: false
            });
            typeFilters.push({
                name: Constants.getMessage("labelTestSuites"),
                value: "TESTSUITE",
                checked: false
            });
            this.filters.push({
                name: "types",  // must match key in the arg list of the API
                title: Constants.getMessage("labeltype"),
                promptTitle: Constants.getMessage("labelType"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: null, 
                params: {options: typeFilters}
            });
        }
        this.filters.push({
            name: "name",  // must match key in the arg list of the API
            title: Constants.getMessage("labelname"),
            promptTitle: Constants.getMessage("labelName"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, 
            params: null
        });
        
        this.filters.push({
            name: "configuration",  // must match key in the arg list of the API
            title: Constants.getMessage("labelConfig") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelConfig"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, 
            params: null
        });
        
        this.filters.push({
            name: "scriptName",  // must match key in the arg list of the API
            title: Constants.getMessage("labelScript") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelScript"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, 
            params: null
        });
        
        this.filters.push({
            name: "hostname",  // must match key in the arg list of the API
            title: Constants.getMessage("labelHostname") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelHostname"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null, 
            params: {
                fieldWidth: 200,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormCheckboxOverrideTextField",
                fieldArgs: {
                    checkboxLabel: Constants.getMessage("labelUseLocalhost"),
                    checkboxValue: "localhost" //$NON-NLS-1$
                }
            }
        });
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible", Constants.getMessage("labelExecCon"));
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilters: function() {
        return this.filters;
    },  
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
                    args[nameKey] = '';
                }
            }
        }
        if (!this.tableView.getIsConsoleNode()) {
            args['types'] = 'TESTSUITE';
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
					'  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				  	'</div>',

    widgetsInTemplate: true,
    isConsoleNode: true,
    
    constructor: function() {
	 	this.requests = null;
	 	this.useQueryFilters = true;   // allow using as table without view builder filtering
        this.showQueryFilters = true;  // default to show filters
        // Set initial search query to only display queued and running execution
        this.initFilterArgs = {
            myItemsOnly: this._onlyMineByDefault,
            includeArchived: false,
            statusIds: ["com.ibm.rqm.executionframework.common.requeststate.nottaken", "com.ibm.rqm.executionframework.common.requeststate.taken"]
        }        
        this.sortResult = true;
	 },

    postCreate: function(){
        this.inherited("postCreate", arguments);

        // initialize options for the view builder
        this.setTypeLabel(Constants.getMessage("labelExecCon"));

        if (this.postQueryFilterCallback) {
            this.setSearchFilterCallback(this.postQueryFilterCallback);
        }
        setTimeout(dojo.hitch(this,function(){
			this._initialize();
		}),0);
        // apply the user preference whether to initially open the view builder
        // if view builder filtering is to use
        if (this.useQueryFilters && this.showQueryFilters) {
            this._initializeFilters();             
        }
    },

    _remapQueryArgs: function(cachedFilterArgs) {
        var filterArgs = this.inherited("_remapQueryArgs", arguments);
        var argsCloned = false;
        
        // set type to TER if any of the TER specific filter attributes are set
        if (filterArgs["configuration"] || filterArgs["scriptName"] || filterArgs["hostname"]) {
            if (!filterArgs["types"]) {
                filterArgs = dojo.clone(filterArgs);
                argsCloned = true;
            }
            filterArgs["types"] = "TER";
        }

        // if hostname is localhost, re-map to use boolean localhost param
        if (filterArgs["hostname"] != null && filterArgs["hostname"] == "localhost") {
            if (!argsCloned) {
                filterArgs = dojo.clone(filterArgs);
            }
            filterArgs["isLocalComputer"] = true;
            delete filterArgs["hostname"];
        }

        return filterArgs;
    },

    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new ExecutionTableView.TableContentFilterProvider(this, this.isInitiallyOpen());
        
        var filters = this.filterProvider.filters;
        // add the status states filter
        var self = this;
        var serviceObj = {
            success: function(statusStates) {
                if (dojo.isArray(statusStates) && (statusStates.length > 0)) {
                    // sort the states by name
                    function stateCompare(stateA, stateB) {
                        var a = stateA.name;
                        var b = stateB.name;
                        return a > b ? 1 : a < b ? -1 : 0;
                    }

                    statusStates = statusStates.sort(stateCompare);
                    var statusStatesOptions = [];
                    var statusStatesCount = statusStates.length;
                    for (var i = 0; i < statusStatesCount; i++) {
                        statusStatesOptions.push({
                            name: statusStates[i].name,
                            value: statusStates[i].id,
                            checked: false
                        });
                    }

                    var statusStatesFilter = {
                        name: "statusIds",  // must match key in the arg list of the API
                        title: Constants.getMessage("labelstatus") + Constants.getMessage("labelColen"),
                        promptTitle: Constants.getMessage("labelstatus"),
                        type: TableContentFilterProvider.FIELD_TOGGLELIST,
                        // Set default filters to "queued" and "running"                        
                        defaultValue: ["com.ibm.rqm.executionframework.common.requeststate.nottaken", "com.ibm.rqm.executionframework.common.requeststate.taken"],
                        params: {options: statusStatesOptions}
                    };
                
                    // add the status states filter
                    var providerFilters = self.filterProvider.filters;
                    providerFilters.push(statusStatesFilter);
                }
                
            },
            
            failure: function(e) {
                self._error(e);
            }
        };
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        ExecutionClient.getAllAdapterRequestStateTypes(responseHandler);
		// add the modified time filter
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "modified",  // must match what the filter provider looks for
            fromKey: "modifiedFrom",
            toKey: "modifiedTo",
            label: Constants.getMessage("labelModified") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelModified")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, filters);
		   // add the result states filter
        var providerFilters = this.filterProvider.filters;
        var resultStateFilter = {
            name: "resultStateIds", // must match key in the arg list of the API
            label: Constants.getMessage("labelResult") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelResult"),
            type: TableContentFilterProvider.FIELD_TOGGLELIST
        };

        // add script state filter
        this.addExecutionStateFilter(resultStateFilter, providerFilters, dojo.hitch(this, "_initialize2"));
    },	
    
	_initialize: function(){
		if (!dojo.getObject("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ProgressBarCellRenderer")) {
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ProgressBarCellRenderer", dojo.hitch(this, "_initializeAfterLoad"));
		}else{
			this._initializeAfterLoad();
		}
	},
	
    _initializeAfterLoad: function() {
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            sortByColumn: (this.sortResult) ? 7 : -1,
            sortDir: TableConstants.SORT_DIR_DESCEND,            
            tableId: "RQM-EXECUTION-TABLEVIEWER"            
        });        
        this.tableViewer = tableViewer;
        this._tableViewerNode.appendChild(tableViewer.domNode);
		this.isQueryPage = this.queryName;
		 if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }        
		tableViewer.setContentPageSize(20);
        var content = this.requests ? this.requests : [];
        tableViewer.setContent(content);
		var args = {
		  ergId: null,
		  isConsoleNode: this.isConsoleNode
		};
		if(this.ergId)
			args.ergId = this.ergId;
		var tableProvider = new ExecutionTableViewTableProvider(args);
        tableViewer.setContentProvider(tableProvider);
        tableViewer.setTableListener(new ExecutionTableViewTableListener({}));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName ? this.queryName: Constants.getMessage("labelExecCon")));
		  
		tableViewer.registerCellRenderer("RenderType.ProgressBar", 
			new com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ProgressBarCellRenderer());

		for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
            if (action.disabled && action.disabled == true) {
                actionButton.setDisabled(true);
            }
            if (action.hidden && action.hidden == true) {
                dojo.addClass(actionButton.domNode, "hidden");
            }
			if(action.actionId == "refresh"){
				this.refreshButton = actionButton;
			}
        }

		tableViewer.setTableRowsCheckable(false);
        tableViewer.show();		
    },
	_initialize2:function(){
        // Just in case our initialize call hasn't finish before the filter initialize call,
        // we would not have a tableViewer created yet. Wait for a while before accessing.
        if(!this.tableViewer) {
            if(!this.retry) {
                this.retry = 0;
            }
            else if(this.retry > 4) {
                // shouldn't happen...abort retry
                return;
            }
            this.retry++;
            setTimeout(dojo.hitch(this, "_initialize2"), 10);
            return;
        }
		if (this.useQueryFilters && this.showQueryFilters) {
            this.initFilterProvider(this.filterProvider);
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
		if (this.useQueryFilters) {
            this.initRunQuery();
        }
	},	           
	// override the AbstractFilteredTableView to set type to test suite when not in console
	//
    getCachedFilters: function() {
        var cachedFilters = this.inherited("getCachedFilters", arguments);
        if (!this.getIsConsoleNode()) {
            if (cachedFilters == null) {
                cachedFilters = { types: 'TESTSUITE' }; 
            } else {
                cachedFilters.types = 'TESTSUITE';
            }
        }
        return cachedFilters;
    },

	// override the AbstractFilteredTableView to handle results with two array of TER results
	// and test suites results
	//
    showQueryResults: function(resultsDTO) {
        this.stopInProgress();
        var results = [];
        var hasResults = false;
        if (dojo.isArray(resultsDTO)) {
            var TERResultsDTO = (resultsDTO.length > 0) ? resultsDTO[0] : null;
            var suiteResultsDTO = (resultsDTO.length > 1) ? resultsDTO[1] : null;
            var TERResultsStatus = (TERResultsDTO != null) ? TERResultsDTO.status : null;
            var suiteResultsStatus = (suiteResultsDTO != null) ? suiteResultsDTO.status : null;
            var TERResults = (TERResultsStatus == Constants.ARTIFACT_SEARCH_STATUS_OK) ? TERResultsDTO.results : [];
            var suiteResults = (suiteResultsStatus == Constants.ARTIFACT_SEARCH_STATUS_OK) ? suiteResultsDTO.results : [];
            results.push(TERResults);
            results.push(suiteResults);
            
            if ((TERResultsStatus != null && TERResultsStatus == Constants.ARTIFACT_SEARCH_STATUS_MAX_EXCEEDED) ||
                (suiteResultsStatus != null  && suiteResultsStatus == Constants.ARTIFACT_SEARCH_STATUS_MAX_EXCEEDED)) {
                // too many results, show warning dialog
                if (TERResultsStatus == Constants.ARTIFACT_SEARCH_STATUS_MAX_EXCEEDED) {
                    this.showQueryThresholdWarning(TERResultsDTO);
                } else {
                    this.showQueryThresholdWarning(suiteResultsDTO);
                }
            } else if ((TERResultsStatus != null  && TERResultsStatus == Constants.ARTIFACT_SEARCH_STATUS_OK) ||
                (suiteResultsStatus != null  && suiteResultsStatus == Constants.ARTIFACT_SEARCH_STATUS_OK)) {
                // at least one of them is ok
                if (this._searchFilterCallback && dojo.isFunction(this._searchFilterCallback)) {
                    results = this._searchFilterCallback(results);
                }
                this._doSearchCallback(results);
            } else {
                // none of them is ok
                var errMsg = null;
                if (TERResultsDTO && TERResultsDTO.message) {
                    errMsg = TERResultsDTO.message;
                }
                if (suiteResultsDTO && suiteResultsDTO.message) {
                    if (errMsg) {
                        errMsg += " - " + suiteResultsDTO.message;
                    } else {
                        errMsg = suiteResultsDTO.message;
                    }
                }
                if (!errMsg) {
                    errMsg = "Unknown execution console Error";
                }
            }
        }
    },
	
	/*
	 * External apis need to check if the tableviewer/viewheader is present or removed
	 */
	    
	setContent: function(content){
		if(this.tableViewer && !this.tableViewer.uninitialized){
			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		}else{
			console.error("tableviewer is not present or uninitialized");
		}
	},
	
	showTable: function(){
		if(this.tableViewer && !this.tableViewer.uninitialized){
			this.tableViewer.refresh();
		}else{
			console.error("tableviewer is not present or uninitialized");
		}
	},
	
	appendItem: function(item){
		if(this.tableViewer && !this.tableViewer.uninitialized){
			var content = this.tableViewer.getContent();
			if(dojo.isArray(item) && item.length != 0)
				content = content.concat(item)
			else if(item && !dojo.isArray(item))
				content = content.concat([item]);//Concat as an array item
			
			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		}else{
			console.error("tableviewer is not present or uninitialized");
		}	
	},
	
	setERGId: function(ergId){
		if((this.tableViewer && !this.tableViewer.uninitialized)){
			var contentPvder =this.tableViewer.getContentProvider();
			contentPvder.setERGId(ergId);
			this.ergId = ergId;
			this.tableViewer.refresh();
		}else{
			console.error("tableviewer is not present or uninitialized");
		}		
	},
	
	setConsoleNode: function(bool){
		if((this.tableViewer && !this.tableViewer.uninitialized)){
			this.isConsoleNode = bool;
			this.tableViewer.getContentProvider().setConsoleNode(bool);
		}else{
			console.error("tableviewer is not present or uninitialized");
		}	
	},
	
	getIsConsoleNode: function(){
		return this.isConsoleNode;
	},
	disableRefresh:function(){
		if((this.tableViewer && !this.tableViewer.uninitialized) && this.refreshButton){
			this.refreshButton.setDisabled(true);
		}else{
			console.error("tableviewer is not present or uninitialized or refresh button not found");
		}
	},
	enableRefresh:function(){
		if((this.tableViewer && !this.tableViewer.uninitialized) && this.refreshButton){
			this.refreshButton.setDisabled(false);
		}else{
			console.error("tableviewer is not present or uninitialized or refresh button not found");
		}
	}
});

})();