/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.keyword.web.ui.internal.view.table.KeywordsTableView")
dojo.provide("com.ibm.rqm.keyword.web.ui.internal.view.table.KeywordsTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.string.BidiComplex");

dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.TagSelector");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableFilter");
dojo.require("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordsContentFilterProvider");
dojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

(function() {
	
var KeywordClient       = com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient;
var DuplicateAction 	= com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;	
var ActionEntityType 	= com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType;	
var TableConstants 		= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Utility        		= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var Constants           = com.ibm.rqm.planning.web.client.internal.Constants;
var RENDER_TYPE_TAGS 	= "RenderType.Tags";
var TagWidget			= com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget;
var WidgetUtil 			= com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;


dojo.declare("KeywordsTableView.TagWidget", 
             [com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget,
			  com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView],
{    

		postCreate: function() {
//			WidgetUtil.setSpacerImage(this._spacer);
			this.tags.value = this.values;
			this._setReadOnlyTagValues(this.tags.value);
			this._previousTagsValue = this.tags.value;
			var self = this;
			this._tagSelector= /* createWidget */ new com.ibm.team.workitem.web.ui.internal.view.editor.TagSelector( {	
					_tagNode: this.tags,
					parentWidget: this,
					_parentNode: this.domNode,
					_callback: function(str) {
						self._updateTagText(str);
					}
				});
/*			if (this.parentController.pageController.isGuest()) {
				dojo.addClass(this.tags, "GuestField");
			}
*/			
			this._tagSelector.setAllTags(this._possibleValues);
			this._isChanged = false;
			this.setReadOnly(false);
			this._areTagsLoaded = true;
		},
		_updateTagText: function(str){
			this.inherited("_updateTagText",arguments);
			if(this.cellModifier)
				this.cellModifier.cellValueChanged(this.rowObject.tags, this.tags.value, this.rowObject, this.columnIndex);
		},
		_handleDirtyingEvent:function(e){
			this.inherited("_handleDirtyingEvent",arguments);
			if(this.cellModifier)
				this.cellModifier.cellValueChanged(this.rowObject.tags, this.tags.value, this.rowObject, this.columnIndex);
		},
		_handleTagBlur: function(e){
			this.inherited("_handleTagBlur",arguments);
			if(this.cellModifier)
				this.cellModifier.cellValueChanged(this.rowObject.tags, this.tags.value, this.rowObject, this.columnIndex);
		},
		setCallbackValues:function(rowObject,cellModifier,columnIndex){
			this.rowObject = rowObject;
			this.cellModifier = cellModifier;
			this.columnIndex = columnIndex;
		},
		_getAttributeValue: function() {
			return "";
		},
		_setAttributeValue: function(value, isInit){
			
		}
});

dojo.declare("KeywordsTableView.TagCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, columnIndex){
        var str = cellData;
		var tagWidget = new KeywordsTableView.TagWidget({values:[cellData],_possibleValues:this._possibleValues});
		tagWidget.setCallbackValues(rowObject,cellModifier,columnIndex);
        this.cellNodes.push(tagWidget);
        return tagWidget.domNode;
    },
	setPossibleValues:function(values){
		this._possibleValues = values;
	},
    disconnectAll: function()
    {
        //console.debug("================TagCellRenderer disconnectAll");
        this.inherited(arguments);
        var cellNodes = this.cellNodes;
        var len = cellNodes.length;
        for(var i = 0; i < len; i++) {
            var node = cellNodes[i];
            if(node.destroy)
                node.destroy();
        } 
        this.cellNodes = [];
    }

});

dojo.declare("KeywordTableView.TableFilter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableFilter,
{
	accepts: function(viewer, rowObject, filter){
		var searchTag = this.tag.toLowerCase();
		var tagArr = rowObject.tags.split(",");
		for(var tag in tagArr){
			if(tagArr[tag] == searchTag)
				return true;
		}
		return false;
	},
	setTag: function(tag){
		this.tag = tag;
	}
});

dojo.declare("KeywordsTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    setRowCheckListener:function(listener){
		this.rowCheckListener = listener;
	},
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		if(this.rowCheckListener && this.rowCheckListener.method)
			this.rowCheckListener.method.apply(this.rowCheckListener.context);
	},
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData))
            callbackData();		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null)
                callback(callbackData);
            else
                callback();
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    }
    
});

dojo.declare("KeywordsTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    setChangeListener: function(listener){
		this.changeListener = listener;
	},
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
        if(columnIndex == 0) {
			rowObject.name = newValue;
			if(this.changeListener && this.changeListener.method)
				this.changeListener.method.apply(this.changeListener.context, [rowObject]);
        } 
		if(columnIndex == 1) {
			if(newValue == rowObject.manualScript.id)
				rowObject.defaultScript = rowObject.manualScript;
			else{
				for(var i=0;i<rowObject.executionScripts.length; i++){
					if(newValue == rowObject.executionScripts[i].id){
						rowObject.defaultScript = rowObject.executionScripts[i];					
						break;
					}
				}
			}
			if(this.changeListener && this.changeListener.method)
				this.changeListener.method.apply(this.changeListener.context, [rowObject]);
        }
		if(columnIndex == 3) {
			rowObject.tags = dojox.string.BidiComplex.stripSpecialCharacters(newValue);
			if(this.changeListener && this.changeListener.method)
				this.changeListener.method.apply(this.changeListener.context, [rowObject]);
        }    
	},
    
    cellActionInvoked: function(rowObject, columnIndex)
    {}
});

dojo.declare("KeywordsTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    getNumColumns: function(content){
        return 5;
    },
    getColumnHeading: function(content, index){
        var headings = [
            Constants.getMessage("labelKeyword"),
			Constants.getMessage("labelAssociatedScript"),
			Constants.getMessage("labelType"),
			Constants.getMessage("labelTags"),
            Constants.getMessage("labelModified")
        ];
        return headings[index];
    },
    ids: [
        "name",
        "scriptName",
        "scriptTypeIds",
        "tags",
        "modifiedDateTime"
    ],   
    getColumnIdName: function(index){
        return this.ids[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    getIsColumnGroupable: function(content, atColumnIndex){
	 	  return (atColumnIndex == 2||atColumnIndex == 4);
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex != 3);     
    },
	getIsCellEditable:function(){
		return this.inEditMode;
	},
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 25;
            case 1: 
                return 20;
            case 2: 
                return 20;
            case 3: 
                return 20;
            case 4: 
                return 15; 					 				
        }
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return rowData.id;
    },
   
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
		if(this.inEditMode && this.selectedRows) {
			var len = this.selectedRows.length;
        	switch(atColumnIndex) {
			case 0:
				for(var j=0;j<len;j++){
					if(this.selectedRows[j].id == rowData.id){
						type = TableConstants.RENDER_TYPE_EDITABLE_TEXT;
                        break;
					}
				}
				break;
			case 1:
				for(var j=0;j<len;j++){
					if(this.selectedRows[j].id == rowData.id){
						type = TableConstants.RENDER_TYPE_ENUM;
                        break;
					}
				}
				break;
			case 3:
				for(var j=0;j<len;j++){
					if(this.selectedRows[j].id == rowData.id){
						type = RENDER_TYPE_TAGS;
						break;
					}
				}
				break;
			}
		}else if(atColumnIndex == 4){       		
        	type = TableConstants.RENDER_TYPE_DATE;
		}else if(atColumnIndex == 1){
			type = TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex){
		var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name && rowData.name != "" ? rowData.name : "";
                break;
			case 1: 
                val = rowData.defaultScript.name;
                break;
            case 2: 
				if(rowData.defaultScript.scriptType.name == "Manual")
					val = Constants.getMessage("labelManual")
				else
                	val = Constants.getExtensionDisplayMessage(rowData.defaultScript.scriptType.name);
                break;
            case 3: 
                val = rowData.tags;
                break;	
            case 4:
				var now = new Date().getTime();
				if(parseInt(now,10)> parseInt(rowData.modified,10))
                	val = Utility.formatDateFromLong(rowData.modified);
				else
					val = Utility.formatDateFromLong(now);
                break;
				
			}
        return val;				       
    },
	
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
		var found = false;
		if(atColumnIndex == 1 ) {
            val = {};
			val.href = Utility.getTestScriptURI(rowData.defaultScript.id);
			if(this.selectedRows){
				var len = this.selectedRows.length;
				for(var j=0;j<len;j++){
					if(this.selectedRows[j].id == rowData.id){
						found = true;
						break;
					}
				}
			}
			if(!this.inEditMode || !found)
            	val.href = Utility.getTestScriptURI(rowData.defaultScript.id);
			else{
				val.choices = [];
				val.choices.push({text: rowData.defaultScript.name,value:rowData.defaultScript.id});
				if(rowData.manualScript.itemId != rowData.defaultScript.itemId && !rowData.manualScript.archived)
					val.choices.push({text: rowData.manualScript.name, value: rowData.manualScript.id});
				val.select = rowData.defaultScript.id;				
			}			
        }    
        return val;
    },
    setInEditMode: function(flag,selectedRows){
		this.inEditMode = flag;
		if(flag)
			this.selectedRows = selectedRows;
		else
			this.selectedRows = null;
	}
    
});

dojo.declare("com.ibm.rqm.keyword.web.ui.internal.view.table.KeywordsTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
					'<div dojoAttachPoint="_querySection">' +
                    '      <span dojoAttachPoint="_queryTitle" class="query-title">${labelCurrentQuery}</span>' +
                    '      <span dojoAttachPoint="_queryName" class="query-name"></span>' +
                    '   </div>' +
                    '</div>',

    editable: true,
    widgetsInTemplate: false,
	labelCurrentQuery: Constants.getMessage("labelCurrentQuery"),
	parentView:null,
	tagList:[],
    constructor: function() {
	 	this.keywords = [];
		this._actionButtons = [];
        this.showQueryFilters = true;  // default to show filters
	 },

    postCreate: function(){
        if (this.queryName) {
            this._queryName.innerHTML = this.queryName;
            this._querySection.style.display = "";
        } else
            this._querySection.style.display = "none";

        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(KeywordClient, "getAllSearchResultItemIds");

        // initialize options for the view builder, search and callback methods are
        // set in KeywordList.js
        this.setTypeLabel(Constants.getMessage("labelKeywords"));
        if (this.postQueryFilterCallback) {
            this.setSearchFilterCallback(this.postQueryFilterCallback);
        }
        setTimeout(dojo.hitch(this,function(){
			this._initialize();
		}),0);
        // apply the user preference whether to initially open the view builder
        if (this.showQueryFilters) {
            this._initializeFilters();             
        }
    },
	getAllTags:function(){
		var handler = new ServiceResponseHandler(this, "setAllTags", "_error");
		KeywordClient.getKeywordTags(handler);
	},
	setAllTags:function(tags){
		this.tagList = this._parseTags(tags);
		if(this.parentView && this.parentView.tagCloud)
			this.parentView.tagCloud.showTagList(this.tagList);
		if(this.tagCellRender)
			this.tagCellRender.setPossibleValues(this.tagList);
	},
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordsContentFilterProvider(this, this.isInitiallyOpen());
        var providerFilters = this.filterProvider.filters;
        
        // add the modified time filter
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "modifiedDateTime",  // must match what the filter provider looks for before runQuery()
            fromKey: "modifiedFrom",
            toKey: "modifiedTo",
            label: Constants.getMessage("labelModified") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelModified")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, providerFilters);

        // add the script type filter
        var scriptTypesFilter = {
            name: "scriptTypeIds" // must match key in the arg list of the API
        };

        // add script state filter
        this.addScriptTypeFilter(scriptTypesFilter, providerFilters, dojo.hitch(this, "_initializeScriptState"));
    },

    _initializeScriptState: function() {
        // add script state filter
        var providerFilters = this.filterProvider.filters;
        this.addArtifactStateFilter(providerFilters);

        // continue initialization
        this._initialize2();
    },
    
    _initialize: function(){
        this.keywords = [];
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            handleVirtualSelectAll: true,
            tableId: this.queryName ? "RQM-KEYWORD-QUERY-TABLEVIEWER" : "RQM-KEYWORD-TABLEVIEWER" 
        });
		this.tableViewer = tableViewer;
		this.tagCellRender = new KeywordsTableView.TagCellRenderer();
		this.tagCellRender.setPossibleValues(this.tagList);
		tableViewer.registerCellRenderer(RENDER_TYPE_TAGS,this.tagCellRender);		       
        this._tableViewerNode.appendChild(tableViewer.domNode);	
        tableViewer.setContentProvider(this._constructTableContentProvider());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelKeywords")));
		var tableListener = new KeywordsTableView.TableListener();
		tableListener.setRowCheckListener({
			context: this,
			method:dojo.hitch(this, function() {
				if(this.inEditMode)
					return;
                var selection = this.getSelectedRows();
                var realSelection = dojo.isArray(selection);
				var count = realSelection ? selection.length : this.tableViewer.getContentPageSize(); // select all, just use the page size
                
				if (count > 0) {
                    // cannot edit virtual select all.
                    if(!realSelection){
                        this.disableAction("edit"); 
                    }else {
                        this.enableAction("edit");
                    }
					this.enableAction("archive");
					this.enableAction("duplicate");
					if (count > 1){
						this.disableAction("associate");
					}else {
						this.enableAction("associate");
					}
				}else{
					this.disableAction("duplicate");					
					this.disableAction("edit");
					this.disableAction("archive");
					this.disableAction("associate");
				}					
			})
		});
		tableViewer.setTableListener(tableListener);
		var cellModifier = new KeywordsTableView.CellModifier();
		cellModifier.setChangeListener({
			context: this,
			method:dojo.hitch(this, function(rowObject) {
                    this.storeChangedKeywords(rowObject);
                }) 
		});
		tableViewer.setCellModifier(cellModifier);        
        tableViewer.setTableRowsCheckable(true, false);

        if (this.postInit && dojo.isFunction(this.postInit)) {
            this.postInit();
        }
        this.setContent(this.keywords);
        this.tableViewer.show();       
    },
	_initialize2:function(){
		if (this.showQueryFilters) {
            this.initFilterProvider(this.filterProvider);
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
		this.initRunQuery();
	},
    _constructTableContentProvider: function() {
        //create the table provider
        this.provider = new KeywordsTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });    
        return this.provider; 
    },
    
    showKeywords: function(result){
        this.refresh(result);
    },
    
	getTagList:function(){
		return this.tagList;
	},
	_parseTags:function(tags){
		var tagList = [];
		if(tags && tags.length>0){
			tags = dojox.string.BidiComplex.stripSpecialCharacters(tags);
			var tagArr = [tags];
			if(tags.indexOf(',')>0)
				tagArr = tags.replace(/\,/g," ").split(" ");
			else if(tags.indexOf(' ')>0)
				tagArr = tags.split(" ");
			for(var tag in tagArr){
				if(tagArr[tag].length>0 && tagArr[tag]!=" ")
					tagList.push({
						id: tagArr[tag]
					});
			}
		}
		return tagList;
	},
	addAction:function(actionId,actionLabel,callbackData,iconClass,callback){
		var actionButton = this.tableViewer.addAction(actionId,actionLabel,callbackData,iconClass,callback);
		this._actionButtons.push(actionButton);
	},
	
	setupDuplicateAllowed: function(){
		var duplicateAction = new  DuplicateAction();
	    duplicateAction.isDuplicateAllowed(ActionEntityType.KEYWORD, dojo.hitch(this, "_isDuplicateAllowedCallback"));
	},
	
	_isDuplicateAllowedCallback: function(allowed){
		if(!allowed){
			var button = this.getActionButton("duplicate");								
			button.domNode.style.display = "none";
		}			
	},
	
	show:function(){
		this.tableViewer.show();
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	},
	setContent:function(content){
		var newContent = [];
		if(content)
			newContent = dojo.clone(content);
		this.keywords = newContent;
		this.tableViewer.setContent(newContent);	
	},
	refresh:function(content){
		if(this.tableViewer){
            // we are only updating the virtual content. The virtual
            // content provider has convenient method to do that. Call
            // it to load the virtual content. Updating a virtual page
            // is much less 'destructive' then a regular table refresh.
            // It retains the row selection states.
            if (this.updatePageOnly) {
                this.provider.loadPageContent(content);
            }
            else {
                this.tableViewer.setContent(content);
                this.tableViewer.refresh();
            }
            this.getAllTags();
			this.disableAction("save");
			this.disableAction("edit");
			this.disableAction("associate");
			this.disableAction("archive");
			this.disableAction("duplicate");			
		}
	},
	getActionButton: function(actionId){
        for (var i = 0; i < (this._actionButtons ? this._actionButtons.length : 0); i++) {
            if (this._actionButtons[i].actionId == actionId)
                return this._actionButtons[i];
        }        
    },
	disableAction: function(actionId){
        var button = this.getActionButton(actionId);
         if (button )
            button.setDisabled(true); 
    },
	enableAction: function(actionId){
        var button = this.getActionButton(actionId);
        if (button )
            button.setDisabled(false);
    },
	setTableStateForEditing: function(){
		this.disableAction("create");
		var editBtn = this.getActionButton("edit");
		editBtn.setLabel(Constants.getMessage("labelDiscardChanges"));
		dojo.removeClass(editBtn.iconNode, "edit-keyword-image");
		dojo.addClass(editBtn.iconNode, "discard-edit-icon-image");
		this.disableAction("refresh");
		this.disableAction("archive");
		this.disableAction("associate");
		this.enableAction("save");		
		this.changedKeywords = [];
		this.inEditMode = true;
		var selectedRows = this.tableViewer.getCheckedRows();
		this.tableViewer.getContentProvider().setInEditMode(true,selectedRows);
		this.tableViewer.refresh();
	},
	unsetTableStateForEditing: function(){
		this.disableAction("save");
		this.enableAction("create");
		var editBtn = this.getActionButton("edit");
		editBtn.setLabel(Constants.getMessage("labelEditKeywords"));
		dojo.removeClass(editBtn.iconNode, "discard-edit-icon-image");
		dojo.addClass(editBtn.iconNode, "edit-keyword-image");
		this.enableAction("refresh");
		this.inEditMode = false;
		this.tableViewer.getContentProvider().setInEditMode(false);
		this.tableViewer.refresh();
	},
	getTableStateForEditing:function(){
		return this.inEditMode;
	},
	storeChangedKeywords:function(rowObject){
		var found = false;
		var len = this.changedKeywords.length;
		for(var i=0;i<len;i++){
			if(rowObject.id === this.changedKeywords[i].id){
				found = true;
				break;
			}		
		}
		if(!found)
			this.changedKeywords.push(rowObject);
	},
	getChangedKeywords:function(){
		if(this.changedKeywords)
			return this.changedKeywords;
		return [];
	},
	handleTagClick:function(tagName){
		var currentTableFilter = this.tableViewer.contentFilter;
		if(!this.tagFilter)
			this.tagFilter = new KeywordTableView.TableFilter();
		this.tagFilter.setTag(tagName);
		this.tableViewer.setFilter(this.tagFilter);
		this.tableViewer.performFilterBy(tagName);
		this.tableViewer.headerRenderer.filterInput.value = tagName;
		this.tableViewer.setFilter(currentTableFilter);
	},
	_error: function(e){
		console.error("An error occurred: [" + e.message + "] @ KeywordTableView#_error");
	}
      
});

})();
