//MACHINEADAPTERTABLEVIEW
/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.client.internal.reservations");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");          //Using this for Date formatting.  Probably should use an RQM method
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.client.internal.collections");


(function() {
	
var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Constants      					= com.ibm.rqm.planning.web.client.internal.Constants;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var SelectUtility					= com.ibm.asq.common.web.ui.internal.util.SelectUtility;
var RtlmUiUtil 						= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var AssetUriUtil					= com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var MACHINE_SEARCH_COLUMNS = "machine.id, machine.name, machine.operatingsystem.hostname";

/*The data structure of the row data is
{
	machineID   
	machineName
	reservedTill
	adapterInfo		(A structure defining the info for an adapter)
	cellID			Maybe Null if not selecting Test Cells
	cellName		Maybe Null if not selecting Test Cells
}
*/


dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: ['<div dojoAttachPoint="domNode" class="com-ibm-rqm-test-execution-machine-adapter-view">' ,
					'    <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection" open="true" dojoAttachPoint="configNode">' ,
					'        <table class="ma-config-table" dojoAttachPoint="configTableNode">' ,
					'            <tr>' ,
					'                <td>' ,
					'                  <div dojoAttachPoint="configNameNode" class="ma-label"></div>' ,
					'                </td>' ,
					'            </tr>' ,
					'            <tr>' ,
					'                <td>' ,
					'                  <div dojoAttachPoint="configSummaryNode"></div>' ,
					'                </td>' ,
					'            </tr>' ,
					'            <tr>' ,
					'                <td style="padding-top: 10px">' ,
					'                  <input dojoAttachPoint="applyFilterCheckBox" type="checkbox" id="applyFilterCB"/>' ,
					'                  <label for="applyFilterCB" dojoAttachPoint="applyFilterLabel">Filter Machines by Configuration</label>' ,
					'                </td>' ,
					'            </tr>' ,
					'        </table>' ,
	                '    </div>' , 
					'    <div dojoAttachPoint="durationNode">' ,
					'        <label class="ma-label" for="durationSelect" dojoAttachPoint="durationLabel">Duration of execution:</label>' ,
					'        <select class="ma-select" dojoAttachPoint="durationSelector" id="durationSelect">' ,
					'        </select>' ,
					'    </div>' ,
					'    <div dojoAttachPoint="typeNode">' ,
                	'        <table width="100%">' ,
                	'        <tr>' ,
					'               <td width="10%">' ,
					'                  <span class="ma-label" dojoAttachPoint="selectFromLabel" style="padding-right: 10px"></span>' ,
					'               </td>' ,
					'               <td width="10%" style="padding-top: 3px">' ,
					'                   <input type="radio" name="typeName" dojoAttachPoint="tcRadio"</input><span dojoAttachPoint="testCellTypeLabel" style="padding-left: 5px">' ,
					'               </td>' ,
					'               <td style="padding-top: 3px">' ,
					'                   <input type="radio" name="typeName" dojoAttachPoint="machineRadio"</input><span dojoAttachPoint="machineTypeLabel" style="padding-left: 5px">' ,
					'               </td>' ,
                	'        </tr>' , 
                    '    </table>' ,
					'    </div>' ,
					'    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"> ' ,
					'    </div>' ,
					'</div>'].join(""),

    widgetsInTemplate: true,
	allowMultiSelect: false,
	
    constructor: function(){
		//Expected to be supplied by the caller:
		//scriptType - String representing the type of script to find adapters for 
		//serverTime - the current time on the server - used to determine the state of the adapter
		//configID - the internal ID of the config we will use to in the search for machines - Can be NULL
		//loadingCompleteCallback - Called when all the data is loaded into the table.
		//							returns the data that would show in the table
		this.hideReservationNode =false;
			
	},
	 
	postCreate: function(){
		this.inherited("postCreate", arguments);		
		this.results = null;
		this.theConfig = null;

		this.theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
		this.initialLoad = true;  //Used to gate calls to the loadingComplete callback
		
		this.testCellTypeLabel.innerHTML = Constants.getBaseLmMessage("cellCells");
		this.machineTypeLabel.innerHTML = Constants.getBaseLmMessage("navMach");
		this.selectFromLabel.innerHTML = Constants.getBaseLmMessage("cellSelectFrom");
		
		//Add the click handler to the show all checkbox
		this.connect(this.applyFilterCheckBox, "onclick", "_onApplyFilterCheckClick");
		//Todo load this value from the string catalog
		this.applyFilterLabel.innerHTML = Constants.getMessage("lableFilterByConfiguration");
		this.durationLabel.innerHTML = Constants.getMessage("labelExecutionDuration");
		this.configNode.setDisplayTitle(Constants.getMessage("labelConfiguration")); 
		
		this.tcRadio.checked = true;
		
		this.connect(this.tcRadio, "onclick", this.showTestCellsClicked);
		this.connect(this.machineRadio, "onclick", this.showMachinesClicked);
			
		//Create the table for showing machines	
		this._createMachineTable();
		//Create the table for showing Test Cells
		this._createTestCellTable();

		this._loadDurations();
		this.connect(this.durationSelector, "onchange","_onDurationChange");
		//Get the default duration of the execution
		this.duration = this.durationSelector.options[ this.durationSelector.selectedIndex ].value;
		if(this.hideReservationNode){
			this.durationNode.style.display = "none";
		}
		
		//If there is an associated config then show it and load the table
		//otherwise hide the config node and load the table
		if (this.configID) 
			this._loadAndShowConfig(this.configID);
		else 
		{
			this.configNode.domNode.style.display="none";
			this._loadInitialTable(); //Will load based on the selected type.
		}
	},
	
	_loadDurations: function(){
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 5), 5 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 10), 10 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 15), 15 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 30), 30 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelOneHour"), 60 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 2), 120 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 4), 240 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 8), 480 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 16), 960 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelOneDay"), 1440, true, true ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 2), 2880 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 3), 4320 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 4), 5760 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 5), 7200 ));
	},
	
	_loadInitialTable: function()
	{
		if (this.tcRadio.checked == true)
		{
			this.tableInUse = this.cellTableViewer;
			this.showTestCells();			
		}
		else
		{
			this.tableInUse = this.tableViewer;
			this.showMachines();
		}
			
	},
	
		
	//Show the config info.  What we display differs by whether the user is selecting by Test Cell or Machine	
	_showConfig: function(config, configName){
		dojox.data.dom.removeChildren(this.configSummaryNode);
		//if searching for machines, only show the 1st Lab Resource Description
		if (this.machineRadio.checked == true){
			var configSummary = new com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary({
				configPart: config.getRootPart(0)
			});
			if (configSummary) 
				this.configSummaryNode.appendChild(configSummary.domNode);
		}
		else{ //Show all the Lab Resource Descriptions
			var len = config.getRootParts().length;
			for (var i = 0; i < len; i++){
				var configSummary = new com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary({
					configPart: config.getRootPart(i)
				});
				if (configSummary) 
					this.configSummaryNode.appendChild(configSummary.domNode);
			}
		}			
		this.configNameNode.innerHTML = configName;
			
	},
	
	_loadAndShowConfig: function(configID){
		//Setup the response handlers and load the config
        var responseHandler = new ServiceResponseHandler(this, "_loadConfigSuccess", "_loadConfigFailure");
        var configService = new com.ibm.rational.test.lm.web.client.internal.config();
		configService.retrieveConfigurationWithDetails(responseHandler, configID);
	},
	
	_loadConfigSuccess: function(response){
		//Save the config string 
        var config = this.theCatalog.createConfigurationFromJson(response.configuration);
		this.theConfig = config;
		this.theConfigName = response.name;
		//Show the config in the ui		
		this._showConfig(config, response.name);
		//and load the table		
		this._loadInitialTable();
	},
	
	_loadConfigFailure: function(response){
		//For now just proceed and assume no config.
		//NEED TO DECIDE HOW TO HANDLE THIS BETTER
		this._loadInitialTable();
	},
	
	/*********************************
	 * 
	 * Machine Table Methods
	 * 
	 *********************************/
	
	_createMachineTable: function()
	{
		//Create the table for showing the machines
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-EXE-MACH-ADAPTER-TABLEVIEWER"                                
        });
		
		this.tableViewer = tableViewer;
			
		//Set default number of items to show
        tableViewer.setContentPageSize(20);
		
		//Creat and set the table provider
		var tableProvider = new MachineAdapterTableView.TableProvider();
		tableProvider.setServerTime(this.serverTime);
        tableViewer.setContentProvider(tableProvider);
		
		//Create and set the table listener
        tableViewer.setTableListener(this);
		
		//Rows are checkable
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */!this.allowMultiSelect);

		//set the sorter
		var sorter = new MachineAdapterTableView.Sorter();
		tableViewer.setSorter(sorter);
		
		//Set the summary label
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelMachineAdapter")));
		
		//initalize the display
		var content = [];
		tableViewer.setContent(content);
        tableViewer.show();
        this._tableViewerNode.appendChild(tableViewer.domNode);
	},
	
	showMachinesClicked: function()
	{
		this.stopInProgress();
		this.machineRadio.checked = true;
		this.showMachines(/*forceLoad*/false);
	},
	
	
	showMachines: function(forceLoad)
	{
		this.tableInUse = this.tableViewer;
				
		//Update the Test Environment display
		if (this.theConfig && this.theConfigName)
			this._showConfig(this.theConfig, this.theConfigName);

		//Load the machines if necessary
		if (forceLoad || !this.machinesLoaded)
		{
			this.machinesLoaded = true;
			this._loadMachines();
		}
		
		//remove the table currently shown and show the machine table
		dojox.data.dom.removeChildren(this._tableViewerNode);
        this._tableViewerNode.appendChild(this.tableViewer.domNode);
	},
	

	_loadMachines: function()
	{
		this.setInProgress();		
	   	var responseHandler = new ServiceResponseHandler(this, "_searchSuccess", "_searchError");
		var config = null;
		//If we have a config and the user checked that they want to use it then go for it
		if (this.theConfig != null && this.applyFilterCheckBox.checked)
			config = this.theConfig;
		else  //otherwise use an empty search config
    	    config = this.theCatalog.createConfiguration("Machine"); 

		var searchParam = {configuration: config,
						   index:0,  //For now just use the first Part in the config
	                       columns: ( MACHINE_SEARCH_COLUMNS )
	                      };
	                this.theCatalog.search(responseHandler, searchParam);
	},
	
	_searchSuccess: function(response){
		//If no machines match then no sense continuing
		if (response == null || response.Data == null || response.Data.length == 0){
			this.tableViewer.setContent([]);
			this.tableViewer.show();
			//Perform the supplied callback to indicate loading is complete
			if (this.loadingCompleteCallback && this.initialLoad){
				this.initialLoad = false;
				this.loadingCompleteCallback([], this);
			}
		}else{
			var reservationService = new com.ibm.rational.test.lm.web.client.internal.reservations();
			//Save the data from this call.
			//This will be passed to the table in the reservation response handler
			//Build objects out of each row in the response
			this.tableData = [];
			//Get the ids for passing to the reservation checking service
			var ids = [];
			var len = response.Data.length;
			for (var i = 0; i < len; i++){
				var responseData = response.Data[i]; 
				if(responseData[0] && responseData[1]){
					var machineInfo = {};
					machineInfo.machineID = responseData[0];
					machineInfo.machineName = responseData[1];
					machineInfo.osName = responseData[1];
					this.tableData.push(machineInfo);
					
					//build a list of IDs to pass to the reservation checking service
					ids.push(responseData[0]);
				}	
			}
			var responseHandler = new ServiceResponseHandler(this, "_searchResSuccess", "_searchResError");
			reservationService.getReservationsInWindow(responseHandler, ids, this.duration);
		}
		this.stopInProgress();		
	},
	
	_searchError: function(response){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
		this.stopInProgress();
	},
	
	_searchResSuccess: function(response){
		//Save the response data.  it will be used by a callback from the table provider
		//The callback will ask if a particular machine is reserved.  To answer that we need this response data
		this.reservationData = response;
		if (this.reservationData == null)
			this.reservationData = [];  //Don't like nulls
		this.mergedData = this._mergeResDataWithMachines();  //Merges this.reservationData with this.tableData
		var params = {};
		if(this.scriptType){
			params.type = this.scriptType;
		}
		var toolService = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
		var responseHandler = new ServiceResponseHandler(this, "_searchAdapterSuccess", "_searchAdapterError");
		toolService.getAdaptersWithMachines(responseHandler, params);
	},
	
	_searchResError: function(){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
	},
	
	_searchAdapterSuccess:function(response){
		this.adapterData = response;
		this.mergedData = this._mergeAdapterDataWithMachines();
		if(this.lastSelectedAdapter || this.lastSelectedAdapterExternalId){
			var mergedData = this.mergedData;
			var len = mergedData.length;
			for(var i=0;i<len;i++){
				if((mergedData[i].adapterInfo.id == this.lastSelectedAdapter || 
						mergedData[i].adapterInfo.externalId == this.lastSelectedAdapterExternalId ) && i!=0){
					var tempData = mergedData[0];//swap the first adapter with the last selected one
					mergedData[0] = mergedData[i];
					mergedData[i] = tempData;
					break;
				}
			}
		}
        this.tableViewer.setContent( this.mergedData );
		if(this.mergedData && this.mergedData.length>0){
			var mergedData = this.mergedData;
			var len = mergedData.length;
			var availableAdapter = this.mergedData[0];
			for(var i=0;i<len;i++){//Get the first live available adapter
				if(mergedData[i].adapterInfo && mergedData[i].adapterInfo.health == "GREEN"){
					if(mergedData[i].adapterInfo.requestsInQueue == 0)
						availableAdapter = mergedData[i];
						break;
				}
			}
			this.tableViewer.rowCheckedHandler.setRowCheckState(availableAdapter,true);
			this.rowCheckStateChanged(this.tableViewer);
		}
        this.tableViewer.show();
		this.tableViewer.performSortBy(3, TableConstants.SORT_DIR_ASCEND);
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback(this.mergedData, this);
		}
	},

	_searchAdapterError:function(response){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
	},
	
	//Merge this.tableData with this.reservationData
	//Any machines that are reserved by someone else are removed from this.tableData
	//Any remaining machines will have the reservation time added to it
	_mergeResDataWithMachines: function(){
		//If no reservations or no machines then return
		if (this.tableData.length == 0 || this.reservationData.length == 0)
			return this.tableData;
		var currentUserID = this.getCurrentUserID();	
		var mergedData = [];
		//Loop over all the this.tableData rows
		var len = this.tableData.length;
		var len2 = this.reservationData.length;
		for (var i = 0; i < len; i++){
			var machineRow = this.tableData[i];
			
			//Add in the duration info in case any clients use it
			machineRow.duration = this.duration;

			var machineID = machineRow.machineID;
			var mergedRow = null;
			var badReservation = false;
			//See if the machine is reserved.
			for (var j = 0; j < len2; j++){
				var reservationData = this.reservationData[j]; 
				if (reservationData.resourceId == machineID){
					var len3 = reservationData.reservations.length;
					//The machine is reserved.  Ensure that ALL the reservations are for the current user
					for (var k = 0; k < len3; k++){
						//See if it is reserved for the current user
						if (reservationData.reservations[k].reservedFor.id != currentUserID){ //It is reserved for the current user
							//This may be better handled by having rows in the table that are not selectable so the user can see that
							//there are matching machines but they are currently reserved by someone else
							badReservation = true;
							break;
						}
					}
					//If no bad reservations then add in some reservation data and push the row onto the merged data array
					if (!badReservation){
						mergedRow = machineRow;
						//Save the reserved time to display in the table
						mergedRow.reservedTill = reservationData.reservations[0].reserveTo;
					}
					//Only 1 set of reservation data per machine ID so we can break here
					break;
				}
			}
			//If this machine is reserved by someone else then continue on to the next machine without pushing it into the merged data array
			if (badReservation)
				continue;


			if (mergedRow)  //The reservation data is in the merged info so push it onto the array we will return
				mergedData.push(mergedRow);
			else{ //There must be no reservation for this machine so lets add it to the merged data without any reservation info
				mergedData.push(machineRow);
			}
		}
		return mergedData;
	},
	
	_mergeAdapterDataWithMachines :function(){
		//Get the server time that was returned with the adapter data
		//We'll use that to show adapter availability
		if (this.adapterData != null && this.adapterData.length > 0){
			this.serverTime = this.adapterData[0].serverTime;
		}
		//Iterated over all the mergedData
		//The merged data will contain at this point all the reserveable machines
		//Remove any machine from the list that is not in the adapter data
		//because that indicates that the machine is not running the necessary adapter
		//add the adapter info to the merged data for any matchine machine.
		var resultData = [];
		var len = this.mergedData.length;
		for (var i = 0; i < len; i++){
			var mergedInstance = this.mergedData[i];
			var machineID = mergedInstance.machineID;
			var adapterArray = this._findAdaptersForMachine(machineID, this.adapterData);
			if (adapterArray == null)  //no match for the machine so don't add it to the resulting merged data
				continue;
			//At least one adapter found for this machine
			//The adapter matches the machine so add the adapter info to this row
			var len2 = adapterArray.length;
			for (var j = 0; j < len2; j++){
				var resultInstance = this._cloneData(mergedInstance);
				resultInstance.adapterInfo = adapterArray[j];
				resultData.push(resultInstance);
			}
		}
		return resultData;
	},
	
	_findAdaptersForMachine: function(machineID, adapterData){
		if (machineID == null || adapterData == null)
			return null;
		var adapterArray = [];
		var len = adapterData.length;
		for (var i = 0; i < len; i++)
			if (adapterData[i].machine && adapterData[i].machine.itemId == machineID)
				adapterArray.push(adapterData[i]);
		return adapterArray;
	},
	
	refreshContents: function() {
        if(this.tableInUse) {
            this.tableInUse.refresh();
        }
    },
    
	/*********************************
	 * 
	 * Test Cell Table Methods
	 * 
	 *********************************/
	
	_createTestCellTable: function()
	{
		//Create the table for showing the machines
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-EXE-MACH-ADAPTER-TABLEVIEWER"                                
        });
		
		//Set default number of items to show
        tableViewer.setContentPageSize(20);
		
		//Creat and set the table provider
		var tableProvider = new MachineAdapterTableView.CellTableProvider();
		tableProvider.setServerTime(this.serverTime);
        tableViewer.setContentProvider(tableProvider);
		
		//Create and set the table listener
        tableViewer.setTableListener(this);
		
		//Rows are checkable
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */!this.allowMultiSelect);

		//set the sorter
		var sorter = new MachineAdapterTableView.CellSorter();
		tableViewer.setSorter(sorter);
		
		//Save the table viewer as a member variable
		this.cellTableViewer = tableViewer;			

		//initalize the display
		var content = [];
		tableViewer.setContent(content);
        tableViewer.show();	
	},	
	
	showTestCellsClicked: function()
	{
		this.stopInProgress();
		this.tcRadio.checked = true;
		this.showTestCells(false);
	},
	
	showTestCells:function(forceLoad)
	{
		this.tableInUse = this.cellTableViewer;

		//Update the Test Environment display
		if (this.theConfig && this.theConfigName)
			this._showConfig(this.theConfig, this.theConfigName);

		var configID = null;
		//If we have a config and the user checked that they want to use it then go for it
		if (this.configID && this.applyFilterCheckBox.checked)
			configID = this.configID

		if (forceLoad || !this.cellsLoaded)
		{
			this.cellsLoaded = true;
			this.loadCells(configID);
		}
			
		dojox.data.dom.removeChildren(this._tableViewerNode);
        this._tableViewerNode.appendChild(this.cellTableViewer.domNode);
	},
	
	//Load all the Test Cells that match the give config.  If config is null then load all Test Cells.
	loadCells: function(configID)
	{
		this.setInProgress();		
	   	var responseHandler = new ServiceResponseHandler(this, "_cellSearchSuccess", "_cellSearchError");
        var cellService = new com.ibm.rational.test.lm.web.client.internal.collections();

		//Setup the from and to dates based on 'Now' and the duration
		var fromDate = new Date();
		var toDate = new Date(fromDate.getTime() + this.duration*60*1000);  //Duration is in minutes, need milliseconds

		cellService.getByAvailability (responseHandler, fromDate.getTime(), toDate.getTime(), false, configID)		
	},
	
	_cellSearchSuccess: function(response)
	{
		this.allCells = response;
		//If there are some available Test Cells then lets find machines running the appropriate adapter
		//We'll merge that data with the cell data.
		if (response && response.length > 0)
		{
			var params = {};
			if(this.scriptType)
			{
				params.type = this.scriptType;
			}
			
			var toolService = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
			var responseHandler = new ServiceResponseHandler(this, "_cellSearchAdapterSuccess", "_cellSearchAdapterError");
			toolService.getAdaptersWithMachines(responseHandler, params);			
		}
		else  //No Test Cells Found
		{
			this.stopInProgress();
			this.tableViewer.setContent([]);
			this.tableViewer.show();

			//Since we found no cells, show machines
			this.machineRadio.checked = true;
			this.showMachines();			
		}
	},
	
	_cellSearchError: function()
	{
		//Try loading machines if we get an error here
		this.machineRadio.checked = true;
		this.showMachines();			
	},
	
	_cellSearchAdapterSuccess: function(response)
	{
		var adapterData = response;
		this.stopInProgress();
		this.mergedCellData = [];
		var mergedCellData = this.mergedCellData;
		//Loop over each Cell looking for machines that are running an appropriate adapter
		//If one is found, create data to be added to the table for display
		
		//For each cell
		var len = this.allCells.length;
		for (var i = 0; i < len; i++){
			var cell = this.allCells[i];
			var machinesProcessed = [];
			
			//for each machine in the cell
			var len2 = cell.topologies ? cell.topologies.length:0;
			for (var j = 0; j<len2; j++){
				var topology = cell.topologies[j];
				var machineID = topology.resourceId;
				
				//See if there are any adapters for the machine
				var adapterArray = this._findAdaptersForMachine(machineID, adapterData);
				if (adapterArray == null)  //no match for the machine so don't add it to the resulting merged data
					continue;
					
				//See if we've already processed this machine for this cell.
				//This could happen if a machine is in the cell topology more than once.
				//In this case there is no need to show the machine more than once
				var duplicateMachine = false;
				var len3 = machinesProcessed.length;
				for (var k = 0; k < len3; k++){
					if (machinesProcessed[k] == machineID){
						duplicateMachine = true;
						break;
					}
				}
				//dupe instance of this machine in the cell so skip it
				if (duplicateMachine)
					continue;
					
				machinesProcessed.push(machineID);
				
				//At least one adapter found for this machine
				//The adapter matches the machine so add the adapter info to this row
				var len4 = adapterArray.length;
				for (var k = 0; k < len4; k++){
					var tableEntry = {};
					tableEntry.machineID = machineID;
					tableEntry.machineName = topology.resourceName;
					tableEntry.adapterInfo = adapterArray[k];
					tableEntry.cellID = cell.itemId;
					tableEntry.cellName = cell.name;
					tableEntry.cellStateID = cell.stateId;
					tableEntry.duration = this.duration;
					
					mergedCellData.push(tableEntry);
				}
			}
		}
		if(this.lastSelectedAdapter || this.lastSelectedAdapterExternalId){
			var len = mergedCellData.length;
			for(var i=0;i<len;i++){
				if((mergedCellData[i].adapterInfo.id == this.lastSelectedAdapter || 
						mergedCellData[i].adapterInfo.externalId == this.lastSelectedAdapterExternalId ) && i!=0){
					var tempData = mergedCellData[0];//swap the first adapter with the last selected one
					mergedCellData[0] = mergedCellData[i];
					mergedCellData[i] = tempData;
					break;
				}
			}
		}
        this.cellTableViewer.setContent( mergedCellData );
		if(mergedCellData && mergedCellData.length>0){
			var availableAdapter = mergedCellData[0];
			var len5 = mergedCellData.length;
			for(var i=0;i<len5;i++){//Get the first live available adapter
				if(mergedCellData[i].adapterInfo && mergedCellData[i].adapterInfo.health == "GREEN") {
					if(mergedCellData[i].adapterInfo.requestsInQueue == 0)
						availableAdapter = mergedCellData[i];
						break;
				}
			}
			this.cellTableViewer.rowCheckedHandler.setRowCheckState(availableAdapter,true);
			this.rowCheckStateChanged(this.cellTableViewer);
		}
		
        this.cellTableViewer.show();
		this.cellTableViewer.performSortBy(0, TableConstants.SORT_DIR_ASCEND);

		if (this.mergedCellData.length == 0){   //No Test Cells Found
			//Try to show machines if no test cells found
			this.machineRadio.checked = true;
			this.showMachines();			
		}else{ //Perform the supplied callback to indicate loading is complete
			if (this.loadingCompleteCallback && this.initialLoad){
				this.initialLoad = false;
				this.loadingCompleteCallback(this.mergedCellData, this);
			}
		}
	},
	
	_cellSearchAdapterError: function(){
		//Try loading machines if we get an error here
		if (this.loadingCompleteCallback && this.initialLoad){
			this.machineRadio.checked = true;
			this._loadMachines();
		}		
	},
	
	
	/*********************************
	 * 
	 * Helper Methods and Such
	 * 
	 *********************************/
	
	getSelection :function(){
		//Gather the selected rows from the appropriate table
		var selectedRows = this.tableInUse.getCheckedRows();
		if (selectedRows == null || selectedRows.length == 0){
			if (this.allowMultiSelect)
				return [];
			else
				return {};
		}
		var selection = null;
		
		//If multiselect then we need an array of objects
		if (this.allowMultiSelect){
			selection = [];
			for (var i = 0; i < selectedRows.length; i++){
				var rowObject = selectedRows[i];
				var selData = {};
				selData.machine = rowObject;
				selData.machineID = rowObject.machineID;
				selData.machineName = rowObject.machineName;
				selData.adapterInfo = rowObject.adapterInfo;
				selData.cellID = rowObject.cellID;
				selData.cellName = rowObject.cellName;
				selData.cellStateID = rowObject.stateId;
				selData.duration = this.duration;
				selection.push(selData);
			}
		}else{  //just a single object
			var rowObject = selectedRows[0];
			selection = {};
			selection.machine = rowObject;
			selection.machineID = rowObject.machineID;
			selection.machineName = rowObject.machineName;
			selection.adapterInfo = rowObject.adapterInfo;
			selection.cellID = rowObject.cellID;
			selection.cellName = rowObject.cellName;
			selection.cellStateID = rowObject.stateId ? rowObject.stateId : null;
			selection.duration = this.duration;
		}
		return selection;
	},

	//Helpers
	getCurrentUserName: function(){
		return getAuthenticatedContributor().userId;
	},

	getCurrentUserID: function(){
		return getAuthenticatedContributor().itemId;
	},

	//Event Handlers
	_onApplyFilterCheckClick: function(){
		if (this.tcRadio.checked == true){
			this.showTestCells(true);			
		}else{
			this.showMachines(true);
		}
	},
	
	_onDurationChange: function(){
		//Get the duration of the execution
		this.duration = this.durationSelector.options[ this.durationSelector.selectedIndex ].value;
		if (this.tcRadio.checked == true){
			this.showTestCells(true);			
		}else{
			this.showMachines(true);
		}
	},
	
	rowCheckStateChanged: function(tableViewer){
		if(this.onCheckedStateChange){
			this.onCheckedStateChange(!(tableViewer.getCheckedRows().length == 0));	
		}
	},	

	//Ideally should be in table listener
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },
	
	//Methods for the callers to get selelcted info
	getSelectedAdapter: function(){
		return this.getSelection().adapterInfo;   //Note assuming single select mode
	},
	
	getSelectedInfo: function(){
		return this.getSelection();
	},
	
	//Return all the data that would show in the table
	getAllMachineAdapterInfo: function(){
		return(this.mergedData);
	},
	
	//Utility method for reserving a selected machine.
	//It will use the current duration in the class as the reservation duration
	reserveMachine: function(machineID, responseHandler){
		var reservationService = new com.ibm.rational.test.lm.web.client.internal.reservations();
		var fromDate = new Date();
		var toDate = new Date(fromDate.getTime() + this.duration*60*1000);  //Duration is in minutes, need milliseconds
		//Fill in any gaps in the reservation
		reservationService.fillReservationGaps(responseHandler, machineID, fromDate.getTime(), toDate.getTime(), false);		
	},

	//Utility method for reserving a selected machine.
	//It will use the current duration in the class as the reservation duration
	reserveCell: function(cellID, responseHandler){
        var cellService = new com.ibm.rational.test.lm.web.client.internal.collections();
		//Setup the from and to dates based on 'Now' and the duration
		var fromDate = new Date();
		var toDate = new Date(fromDate.getTime() + this.duration*60*1000);  //Duration is in minutes, need milliseconds
		//Need to get the stateid of the cell to ensure that the user is using an up-to-date cell for the reservations
		var stateID = null;
		var allCells = this.allCells;
		var len = allCells.length;
		for (var i = 0; i < len; i++){
			if (allCells[i].itemId == cellID){
				stateID = allCells[i].stateId;
				break;
			}
		}
		//Fill in any gaps in the reservation
		cellService.reserveResources(responseHandler, cellID, stateID, fromDate.getTime(), toDate.getTime());		
	},
	
	
	reInitialize: function(scriptType, configID, loadingCompleteCallback){
		this.machinesLoaded = false;
		this.cellsLoaded = false; 
		this.scriptType = scriptType;
		this.configID = configID;
		this.loadingCompleteCallback = loadingCompleteCallback;
		this.initialLoad = true;
		this._loadInitialTable();
	},
	
	refreshMATV: function(){
		this.reInitialize(this.scriptType, this.configID, this.loadingCompleteCallback);
	},

	_cloneData:function(sourceObj){
		var destObject = {};
	    for (var i in sourceObj){
        	if (typeof sourceObj[i] == 'object'){
            	destObject[i] = this._cloneData(sourceObj[i]);
        	}else
            	destObject[i] = sourceObj[i];
    	}
		return destObject;
	},

 	setInProgress: function(msg){
		if (this.tableInUse){
			this.tableInUse.showLoadingProgress(msg);
		}
	},
	
	stopInProgress: function(){
		if (this.tableInUse){
			this.tableInUse.endLoadingProgress();
		}
	}
});
	
	
	/*********************************
	 * 
	 * Cell Table Providers
	 * 
	 *********************************/


dojo.declare("MachineAdapterTableView.CellSorter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter,
{
	_sortComparator: function(obj1, obj2){
		if(this.sortCol == 4){
			if(obj1.statusValue == null || obj2.statusValue == null)
				return 0;
			if(this.sortDir == TableConstants.SORT_DIR_ASCEND){
				return obj1.statusValue - obj2.statusValue;
			}else{
				return obj2.statusValue - obj1.statusValue;
			} 
		}else 
			return this.inherited("_sortComparator",arguments);
	}
});

dojo.declare("MachineAdapterTableView.CellTableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 6;
    },

    getColumnHeading: function(content, index){
		var headings = [
			Constants.getBaseLmMessage("cellLabel"),
            Constants.getMessage("labelMachineName"),
            Constants.getMessage("labelHostname"),
			Constants.getMessage("labelAdapterName"),
			Constants.getMessage("labelHealth"),
			Constants.getMessage("labelJobsInQueue")
        ];
		
        return headings[index];
    },
   
	//Group by Health
    getIsColumnGroupable: function(content, atColumnIndex){
        return atColumnIndex == 4;     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 20;
			case 1: 
                return 20;
            case 2: 
                return 20;
            case 3: 
                return 20;
            case 4: 
               return 10;
			case 5: 
                return 10;
        }
        return 0;
    },
	
    setServerTime: function(serverTime){
		this.serverTime = serverTime;
	},

    getContentObjects: function(content){
        return content;
    },
    
	getRowDataId: function(rowData){
        return rowData.cellID + rowData.adapterInfo.id;
    },
	
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
			case 4: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;					 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
       	return TableConstants.ALIGN_LEFT;
    },
 
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
			case 0:
				val = rowData.cellName;
				break;
			case 1: 
                val = rowData.machineName;
                break;
            case 2: 
                val = rowData.adapterInfo.hostName;
                break;
			case 3:
				val = Constants.getExtensionDisplayMessage(rowData.adapterInfo.name);
				break;
            case 4: 
                this.engineStatus = Constants.getMessage("labelAvailable");
				this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
				this.engineToolTip = Constants.getMessage("msgEngAvailable");
				rowData.statusValue = 0;
				if(rowData.adapterInfo.health == "RED"){
					this.engineStatus = Constants.getMessage("labelUnAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					this.engineToolTip = Constants.getMessage("msgEngUnresponsive");
					rowData.statusValue = 2;
				}
				else if(rowData.adapterInfo.health == "YELLOW"){
					this.engineStatus = Constants.getMessage("labelAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					this.engineToolTip = Constants.getMessage("msgEngRespondLate");
					rowData.statusValue = 1;
				}
				val = this.engineStatus;
                break;
			 case 5: 
                val = rowData.adapterInfo.requestsInQueue;
                break;
        }
        return val;
    },

	getToolTip: function(adapter, avail){
		var reqInQueue = adapter.requestsInQueue ? adapter.requestsInQueue : 0; 
		var timeSinceLastContact = adapter.serverTime - adapter.modified;
		var str = [];
		str.push("<table><tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelstatus")+": "+"</td><td>"+avail+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelLastSinceLastContact")+": "+"</td><td>"+Utility.getTimeDifferenceInHrMinSec(timeSinceLastContact)+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelJobsInQueue")+": "+"</td><td>"+ reqInQueue +"</td></tr>");				
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("</table>");
		return str.join("");
	},

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 4) {
           val = {};
			  val.image = this.engineStatusIcon;
			  val.tooltip = this.getToolTip(rowData.adapterInfo, this.engineToolTip);
		  }	  
        return val;
    }
});

	
	/*********************************
	 * 
	 * Machine Table Providers
	 * 
	 *********************************/

dojo.declare("MachineAdapterTableView.Sorter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter,
{
	_sortComparator: function(obj1, obj2){
		if(this.sortCol == 4){
			if(obj1.statusValue == null || obj2.statusValue == null)
				return 0;
			if(this.sortDir == TableConstants.SORT_DIR_ASCEND){
				return obj1.statusValue - obj2.statusValue;
			}else{
				return obj2.statusValue - obj1.statusValue;
			} 
		}else 
			return this.inherited("_sortComparator",arguments);
	}
});

dojo.declare("MachineAdapterTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 7;
    },

    getColumnHeading: function(content, index){
		var headings = [
		 	Constants.getMessage("labelId"),
            Constants.getMessage("labelMachineName"),
            Constants.getMessage("labelHostname"),
			Constants.getMessage("labelAdapterName"),
			Constants.getMessage("labelHealth"),
			Constants.getMessage("labelReserved"),
			Constants.getMessage("labelJobsInQueue")
        ];
		
        return headings[index];
    },
   
    getColumnHeadingImage: function(content, atColumnIndex){		  
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
	//Group by State and Reservation
    getIsColumnGroupable: function(content, atColumnIndex){
        return atColumnIndex == 4;     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 5;
			case 1: 
                return 15;
            case 2: 
                return 30;
            case 3: 
                return 10;
            case 4: 
               return 10;
            case 5: 
                return 20;
			case 6: 
                return 10;
        }
        return 0;
    },
	
    setServerTime: function(serverTime){
		this.serverTime = serverTime;
	},

    getContentObjects: function(content){
        return content;
    },
    
	getRowDataId: function(rowData){
        return rowData.adapterInfo.id;
    },
	
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
			case 4: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;					 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
		if(atColumnIndex == 4)
			return TableConstants.ALIGN_CENTER;
		else	
        	return TableConstants.ALIGN_LEFT;
    },
 
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.adapterInfo.id;
                break;
			case 1: 
                val = rowData.machineName;
                break;
            case 2: 
                val = rowData.adapterInfo.hostName;
                break;
			case 3:
				val = Constants.getExtensionDisplayMessage(rowData.adapterInfo.name);
				break;
            case 4: 
                this.engineStatus = Constants.getMessage("labelAvailable");
				this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
				this.engineToolTip = Constants.getMessage("msgEngAvailable");
				rowData.statusValue = 0;
				if(rowData.adapterInfo.health == "RED"){
					this.engineStatus = Constants.getMessage("labelUnAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					this.engineToolTip = Constants.getMessage("msgEngUnresponsive");
					rowData.statusValue = 2;
				}
				else if(rowData.adapterInfo.health == "YELLOW"){
					this.engineStatus = Constants.getMessage("labelAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					this.engineToolTip = Constants.getMessage("msgEngRespondLate");
					rowData.statusValue = 1;
				}
				val = this.engineStatus;
                break;
			case 5:
				var tillDate = rowData.reservedTill;
				if (tillDate != null && tillDate != ""){
					var resTill = RtlmUiUtil.getDateDisplay(tillDate, false);
					val = Constants.getMessage("labelReservedUntil", resTill);
				}
				break;
			 case 6: 
                val = rowData.adapterInfo.requestsInQueue;
                break;
        }
        return val;
    },

	getToolTip: function(adapter, avail){
		var reqInQueue = adapter.requestsInQueue ? adapter.requestsInQueue : 0; 
		var timeSinceLastContact = adapter.serverTime - adapter.modified;
		var str = [];
		str.push("<table><tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelstatus")+": "+"</td><td>"+avail+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelLastSinceLastContact")+": "+"</td><td>"+Utility.getTimeDifferenceInHrMinSec(timeSinceLastContact)+"</td></tr>");
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("<tr><td align=left>"+Constants.getMessage("labelJobsInQueue")+": "+"</td><td>"+ reqInQueue +"</td></tr>");				
		str.push("<tr><td> </td><td> </td></tr>");
		str.push("</table>");
		return str.join("");
	},

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 4) {
           val = {};
			  val.image = this.engineStatusIcon;
			  val.tooltip = this.getToolTip(rowData.adapterInfo, this.engineToolTip);
		  }	  
        return val;
    }
});

})();