/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.table.NewTestCaseByRequirementTableView");
 
dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.CategoryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.properties.TestPlanTestCaseConfigSelector");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.client.internal.ContributorClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var CategoryMapper = com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper;
var CategoryClient = com.ibm.rqm.planning.web.client.internal.CategoryClient;
var GlobalEvents   = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var UserClient 	   = com.ibm.asq.common.web.client.internal.ContributorClient;

dojo.declare("NewTestCaseByRequirementTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("NewTestCaseByRequirementTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
	// Summary:
	//    Method to be called when a cell renderer changes the cell value. This notifies
	//    the cell's value change event. 
	//    
	//    
	cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
		// store the new values in our internal data model        
		rowObject.revision = newValue ? newValue : "";
	}
});

dojo.declare("NewTestCaseByRequirementTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);
		this.categoryTypeMap = {};
		this.columnProfile = null;
		if (!this.categoryTypes || !dojo.isArray(this.categoryTypes)) {
			throw new Error("Parameter 'categoryTypes' is REQUIRED!");
		}
		
        this.COLUMNS = {
            NAME: this.toColumn(Constants.getMessage("labelName"), 15, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'name'),
//            DESCRIPTION: this.toColumn(Constants.getMessage("labelDescription"), 10, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'description'),
			OWNER: this.toColumn(Constants.getMessage("labelOwner"), 20, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'owner'),
            WEIGHT: this.toColumn(Constants.getMessage("labelWeight"), 5, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'weight')
        }      
		var numCategories = this.categoryTypes.length;
		this.COLUMNS.CATEGORIES = [];
		for (var i = 0; i < numCategories; i++) {
			var t = this.categoryTypes[i];
			if (!t.archived) {
				this.categoryTypeMap[t.itemId] = t;
				var width = Math.floor(60 / numCategories);
				var name = Constants.getMessage(t.name); // out of the box category name has translated value.
				this.COLUMNS[t.itemId] = this.toColumn(name, width, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT);
				this.COLUMNS[t.itemId].typeItemId = t.itemId;
				this.COLUMNS.CATEGORIES.push(this.COLUMNS[t.itemId]);
			}
		}
        this.PROFILES = {};
        this.PROFILES.ALL = [this.COLUMNS.NAME, this.COLUMNS.OWNER];		
		this.PROFILES.ALL = this.PROFILES.ALL.concat(this.COLUMNS.CATEGORIES);
        this.PROFILES.ALL = this.PROFILES.ALL.concat([this.COLUMNS.WEIGHT]);  
		
        this.columnProfile = null;
        this.columnProfileName = null;
        this.setProfile(this.profile ? this.profile : "ALL"); //default to 'ALL' (full) column profile        
    },
    
    toColumn: function(name, width, groupable, alignment, type, rowName) {
        return {
            name: name,
            width: width,
            groupable: groupable,
            alignment: alignment,
            type: type,
            rowName: rowName
        }
    },  
	
	getProfile: function() {
		return this.columnProfile;
	},

    getProfileName: function() {
        return this.columnProfileName;
    },
			
	setProfile: function(/* string */ profile) {
		if (this.PROFILES[profile]) {
			this.columnProfileName = profile;
			this.columnProfile = this.PROFILES[profile];
		}
	},

    getColumnIndex: function(name) {
        for (var i = 0; i < this.columnProfile.length; i++) {
            if (this.columnProfile[i].name == name) {
                return i;
            }
        }
        return -1;
    },
	
	setCategoryTypes: function(newTypes) {
        this.categoryTypes = newTypes;
    },
		
    // Summary:
    //
    getNumColumns: function(content)
    {
        return this.columnProfile.length;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this.columnProfile[index].name;
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
		var column = this.columnProfile[atColumnIndex];
		if ((column.rowName && column.rowName == "name")) 
			return null;
		var img = {
				src: ImageCache.BULK_CHANGE,
				disabled: true
		};
		if(column.rowName && column.rowName == "weight")
			img.actionId = Constants.getMessage("labelWeight");
		else if (column.rowName && column.rowName == "owner")
			img.actionId = Constants.getMessage("labelOwner");
		else 
			img.actionId =  column.name;
		img.tooltip = Constants.getMessage("labelChangeProperties", img.actionId);
		return img;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].alignment;
    },   
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].groupable;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return true;     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {			
		var column = this.columnProfile[atColumnIndex];
		if (this.columnProfileName == "ALL") {
			return column.width;
		}
		//TODO - refactor into base class or create profile class
		//if using a smaller column profile, adjust widths
		var total = 0;
		for (var colName in this.columnProfile) {
			total += this.columnProfile[colName].width;
		}
		//split the difference between all columns proportionately
        var rowBuffer = 100 - total;   //percentage of width unused
		var columnBuffer = rowBuffer * (column.width / total);  //proportionately redistrubute
		return (column.width + Math.round(columnBuffer));        
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_testCase_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = this.columnProfile[atColumnIndex].type;
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].alignment;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    	
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
		var column = this.columnProfile[atColumnIndex];
        switch(column.name) {
            case this.COLUMNS.NAME.name: 
                val = rowData.name;
                break;
            case this.COLUMNS.WEIGHT.name: 
                val = rowData.weight;
                break;
            case this.COLUMNS.OWNER.name: 
                val = rowData.owner? rowData.owner.name : "";
                break;   
			default:
			    val = this.getCategoryByType(rowData, column.typeItemId) || "";
				break;            
        }
        return val;
    },	

    getCellRawData: function(rowData, atColumnIndex)
    {
        var val = "";
        var rowName = this.columnProfile[atColumnIndex].rowName;
        
        if(rowName) {
            return (rowData[rowName] || val);
        }
        
        var column = this.columnProfile[atColumnIndex];
		val = this.getCategoryByType(rowData, column.typeItemId) || "";
		
        return val;
    },
	
    getCategoryByType: function(testCase, typeItemId) {
        if (testCase && testCase.categories) {
			var type = this.categoryTypeMap[typeItemId];
			for (var i = 0; i < (type.categories ? type.categories.length : 0); i++) {
				for (var j = 0; j < testCase.categories.length; j++) {
					if (type.categories[i].itemId == testCase.categories[j]) {
                		return type.categories[i].name;
            		}
				}
			}
        }
		return Constants.getMessage("labelUnassigned");
    }
	
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.NewTestCaseByRequirementTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_queryTableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
					'  <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" ></div>' +
				    '</div>',

    editable: true,
    widgetsInTemplate: true,

    constructor: function() {
		this.categoryTypes = null;
	 	this.testCases = null;
		this.rowCheckedListener = null;
	 },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);

		EditorUtil.loadStateTransitionConstraintSettings();  //Load the prefs in case we attempt actions that require checking (like execute)

        this._initCategory();
    },

    _initCategory: function() {
        //get the category types (used instead of resolving them for each test case)
        var responseHandler = new CategoryMapper(this, "_initialize", "_error");
        CategoryClient.getCategoryTypeSummaries(responseHandler, Constants.MODEL_TYPE_CASE);
	},
	
    _initialize: function(categoryTypes) {
		this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
		
		//create the table provider
        this.provider = new NewTestCaseByRequirementTableView.TableProvider({
            profile: this.profile ? this.profile : Constants.TABLE_PROFILE_ALL,
            categoryTypes: this.categoryTypes
        });		
		
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode             
			showPagingControl: true,
			showPagingRangeControl: true,
            showGroupFilterControls: false,
            showPagingActionsControls: true,
            allowAdjustSettings: true,
            autoSaveSettings: true
        });	               

        tableViewer.tableId = "RQM-REQ-NEW-TC-TABLEVIWER";
        
        // it is not a query page i.e. within a section without header
        this.viewHeaderNode.domNode.style.display = "none";
        dojox.data.dom.removeChildren(this._tableViewerNode);
        this._tableViewerNode.appendChild(tableViewer.domNode);
        
        var content = this.testCases ? this.testCases : [];
        tableViewer.setContent(content);
        tableViewer.setTableRowsCheckable(true);        
        tableViewer.setContentProvider(this.provider);
		tableViewer.setTableListener(new NewTestCaseByRequirementTableView.TableListener({
			parentView: this
		}));
        tableViewer.setCellModifier(new NewTestCaseByRequirementTableView.CellModifier());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestCases")));
        tableViewer.setUnspecifiedGroupTitle(Constants.getMessage("labelUnassigned"));
        tableViewer.show();
        tableViewer.setEditable(true);
        this.tableViewer = tableViewer;	
    },

    getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },
    
    refresh: function(content) {       
        this.testCases = content;
        
		if (this.tableViewer) {
			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		}
    },  
	
	tableHeaderColumnActionInvoked: function(columnIndex, actionId) {
        if (actionId == Constants.getMessage("labelWeight")) {
            var args = {
                actionId: actionId,
                okCallback: dojo.hitch(this, "_handleCaseBulkChanged")
            }
            var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectWeightPopup();
            dlg.initialize(args);
        }
        else 
            if (actionId == Constants.getMessage("labelOwner")) {
				var self = this;
                var handler = {
                    success: function(users){
                        if (dojo.isArray(users) && users.length > 0) {
                            var owners = [];
                            for (var i = 0; i < users.length; i++) {
                                if (users[i].name != "ADMIN" && users[i].name != "GUEST" && !users[i].archived) {
									if(com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(users[i].itemId))
										users[i].name = Constants.getMessage("labelUnassigned");
                                    owners.push(users[i]);
                                }
                            }
                            
                            var args = {
                                owners: owners,
                                actionId: actionId,
                                okCallback: dojo.hitch(self, "_handleCaseBulkChanged")
                            }
                            
                            var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectOwnerPopup();
                            dlg.initialize(args);
                        }
                        
                    },
                    error: function(e){
                        console.error(e);
                    }
                };
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                UserClient.getContributors(responseHandler);
            }
            else {
                var categoryType;
                for (var i = 0; i < this.categoryTypes.length; i++) {
                    var categoryName = Constants.getMessage(this.categoryTypes[i].name);
                    if (categoryName == actionId) {
                        categoryType = this.categoryTypes[i];
                        break;
                    }
                }
                var args = {
                    categoryType: categoryType,
                    actionId: actionId,
                    okCallback: dojo.hitch(this, "_handleCaseBulkChanged")
                }
                var dlg = new com.ibm.rqm.planning.web.ui.internal.view.common.properties.SelectCategoryPopup();
                dlg.initialize(args);
            }
	},
	
	_handleCaseBulkChanged: function(args){
		var selected = this.tableViewer.getCheckedRows();
		
        for(var i = 0; i < (selected ? selected.length : 0); i++) {
			if (args.actionId == Constants.getMessage("labelWeight")) {
            	selected[i].weight = args.weight;
        	}
			else if(args.actionId == Constants.getMessage("labelOwner")) {
				selected[i].owner.itemId = args.OwnerItemId;
				selected[i].owner.name = args.OwnerUserId;
			}
			else {
				var newCategories = this._mergeCategory(selected[i].categories, args.categoryTypeItemId, args.categoryValueItemId);
            	selected[i].categories = newCategories;
			}
		}
		
		for(var i = 0; i < this.testCases.length; i++) {
			for(var j = 0; j < (selected ? selected.length : 0); j++) {
				if(this.testCases[i].id == selected[j].id) {
					this.testCases[i] = selected[j];
					break;
				}
			}
		}
		this.tableViewer.refresh();
	},
			
	_mergeCategory: function(categories, CategoryTypeItemId, CategoryValueItemId) {
		var newCategories = [];
 
		for(var i = 0; i < this.categoryTypes.length; i++){
			var type = this.categoryTypes[i];
			var newValueItemId = null;
			
			if (type.itemId == CategoryTypeItemId) {
				newValueItemId = CategoryValueItemId;
			}
			else {
				newValueItemId = this._getCategoryByType(type, categories);
			}
	        if(newValueItemId)
	            newCategories.push(newValueItemId);
		}
  
        return newCategories;
    },
  
    _getCategoryByType: function(type, categories) {
        for(var i = 0; i < (type.categories ? type.categories.length:0); i++) {
            for(var j = 0; j < (categories?categories.length:0); j++) {
                if(type.categories[i].itemId == categories[j])
                    return categories[j];
            }
        }
        return null;
    },
    
	getAttribute: function() {
		var ownerIds = [];
		var weights = [];
		var categories = [];
		var workItemsJsonStrings = [];
		var names = [];
		for(var i = 0; i < this.testCases.length; i++) {
			var testcase = this.testCases[i];
			weights.push(testcase.weight);
			names.push(testcase.name);
			categories.push((testcase.categories && testcase.categories.length > 0) ? testcase.categories.join() : "-1");
			if(!testcase.owner || testcase.owner.name == Constants.getMessage("labelUnassigned")) {
				ownerIds.push("-1");
				workItemsJsonStrings.push("-1");
			}
			else {
				ownerIds.push(testcase.owner.itemId);
				var wiList = [{
                    state: "1",
                    section: "com.ibm.rqm.planning.editor.section.testCaseSummary",
                    owner: testcase.owner.itemId,
                    projectAreaName: EditorUtil.getCurrentProjectArea().name
                }];
				workItemsJsonStrings.push(dojo.toJson(wiList));
			}
		}
		return {names: names, ownerIds: ownerIds, weights: weights, categories: categories, workItemsJsonStrings: workItemsJsonStrings};
	},
	
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    }
    
});

})();
