//debug TestCaseTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
 
dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.CategoryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.asq.common.web.client.internal.option");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.PreviewScriptTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.BulkChangeAction");

dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview");

(function() {

var DuplicateAction = com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var TestCaseClient = com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
var TestCaseMapper = com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
var CategoryMapper = com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper;
var CategoryClient = com.ibm.rqm.planning.web.client.internal.CategoryClient;
var CategoryUtil   = com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil;
var GlobalEvents   = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ExecutionPopUp = com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp;
var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var AbstractFilteredPagingTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView;
var getCurrentProjectArea			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var ActionPackage = com.ibm.rqm.planning.web.ui.internal.model.action;
var ActionEntityType = ActionPackage.ActionEntityType;
var ProgressUtility = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

dojo.declare("TestCaseTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var realSelection = dojo.isArray(selection);
        var selectionCount = realSelection ? selection.length : tableViewer.getContentPageSize(); // use the page size for select all
        var archivedCount = 0;
        var nonArchivedCount = 0;
        
        // determine how many selected test cases are archived
        if (realSelection) {
        for (var i = 0; i < selectionCount; i++) {
            if (selection[i].archived) {
                archivedCount++;
            } else {
                nonArchivedCount++;
            }
        }
        }
        else {
            // search paged content don't return any archived items. 
            nonArchivedCount = selectionCount;
        }
        
        var disableWhenEmpty = selectionCount == 0 || !tableViewer.isEditable();
         if (this.parentView.duplicateActionNode){
			this.parentView.duplicateActionNode.setDisabled(disableWhenEmpty);
		}
        if (this.parentView.deleteActionNode)
            // can delete archived or non-archived test cases
            this.parentView.deleteActionNode.setDisabled(disableWhenEmpty);
		if (this.parentView.changeSuspectActionNode)
            // can not invoke if there is any archived test case selected
            this.parentView.changeSuspectActionNode.setDisabled(archivedCount > 0 || nonArchivedCount == 0 || !tableViewer.isEditable());
		if (this.parentView.executeActionNode)
            // can not invoke if there is any archived test case selected
            this.parentView.executeActionNode.setDisabled(archivedCount > 0 || nonArchivedCount != 1);	
        if (this.parentView.genEWIActionNode)
            // can not generate ewi if there is any archived test case selected
            this.parentView.genEWIActionNode.setDisabled(archivedCount > 0 || nonArchivedCount == 0 || !tableViewer.isEditable());	
        if(this.parentView.createScriptActionNode){
			this.parentView.createScriptActionNode.setDisabled(archivedCount > 0 || nonArchivedCount == 0 || !tableViewer.isEditable());
		}	    
		if (this.parentView.riskActionNode)
            this.parentView.riskActionNode.setDisabled(archivedCount > 0 || nonArchivedCount != 1 || !tableViewer.isEditable());	
		if (this.parentView.moveUpNode)
            this.parentView.moveUpNode.setDisabled(disableWhenEmpty);
		if (this.parentView.moveDownNode)
            this.parentView.moveDownNode.setDisabled(disableWhenEmpty);
				
		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}			
		if (selectionCount == 0) {					
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfsummarymenu");
			p.showAction("printpdfsummarymenu");
		} else if (selectionCount > 1) {
			p.hideAction("printpdfhistorycarmenu");
			p.hideAction("printpdfsummarymenu");
			p.enableAction("printpdfmultiplemenu");
			p.showAction("printpdfmultiplemenu");
		} else if (selectionCount == 1) {	
			p.hideAction("printpdfsummarymenu");
			p.hideAction("printpdfmultiplemenu");
			p.enableAction("printpdfhistorycarmenu");
			p.showAction("printpdfhistorycarmenu");
		}
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.headerActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("TestCaseTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
	// Summary:
	//    Method to be called when a cell renderer changes the cell value. This notifies
	//    the cell's value change event. 
	//    
	//    
	cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
		// store the new values in our internal data model        
		rowObject.revision = newValue ? newValue : "";
	},
	
	cellActionInvoked: function(rowObject, columnIndex){
	}
});

dojo.declare("TestCaseTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    
    constructor: function(args) {
        dojo.mixin(this, args);
		this.categoryTypeMap = {};
		this.columnProfile = null;
		if (!this.categoryTypes || !dojo.isArray(this.categoryTypes)) {
			throw new Error("Parameter 'categoryTypes' is REQUIRED!");
		}
		
        this.COLUMNS = {
            TYPE: this.toColumn("", 2, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_IMAGE, 'type', true),
			ID: this.toColumn(Constants.getMessage("labelId"), 10, false, TableConstants.ALIGN_CENTER, this.tableViewer.isInPicker? TableConstants.RENDER_TYPE_TEXT : TableConstants.RENDER_TYPE_LINK, 'id', true),
			COMMUNITYRISK: this.toColumn(Constants.getMessage("labelCommunityRiskHeader"), 7, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_FADEINOUT, 'communityRisk', false),
			CALCULATEDRISK: this.toColumn(Constants.getMessage("labelRiskAssessment"), 7, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_FADEINOUT, 'systemRisk', true, 'calculatedRisk'),
			SUSPECT: this.toColumn(Constants.getMessage("labelSuspect"), 2, true, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_IMAGE, 'suspect', true),
            NAME: this.toColumn(Constants.getMessage("labelName"), 20, false, TableConstants.ALIGN_LEFT, this.tableViewer.isInPicker? TableConstants.RENDER_TYPE_TEXT : TableConstants.RENDER_TYPE_LINK, 'name', true),
            STATE: this.toColumn(Constants.getMessage("labelState"), 8, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'state', true),
            WEIGHT: this.toColumn(Constants.getMessage("labelWeight"), 8, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'weight', true),
            MODIFIED: this.toColumn(Constants.getMessage("labelModified"), 10, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_DATE, 'modified', true),
			
			SNAPSHOTS: this.toColumn(Constants.getMessage("labelSnapshots"), 15, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_ENUM, 'snapshot', true),
			
			TER_COUNT: this.toColumn(Constants.getMessage("labelTERCount"), 5, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'tercount', true)
        }      
		var numCategories = this.categoryTypes.length;
		this.COLUMNS.CATEGORIES = [];
		for (var i = 0; i < numCategories; i++) {
			var t = this.categoryTypes[i];
			if (!t.archived) {
				this.categoryTypeMap[t.itemId] = t;
				var width = Math.floor(35 / numCategories);
				var name = Constants.getMessage(t.name); // out of the box category name has translated value.
				this.COLUMNS[t.itemId] = this.toColumn(name, width, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, null, true, t.name);
				this.COLUMNS[t.itemId].typeItemId = t.itemId;
				this.COLUMNS.CATEGORIES.push(this.COLUMNS[t.itemId]);
			}
		}
		this._createCategoryValueMap();
        this.PROFILES = {};
        this.PROFILES.ALL = [this.COLUMNS.TYPE, this.COLUMNS.ID, this.COLUMNS.COMMUNITYRISK, this.COLUMNS.CALCULATEDRISK, this.COLUMNS.SUSPECT, this.COLUMNS.NAME, this.COLUMNS.STATE];		
		this.PROFILES.ALL = this.PROFILES.ALL.concat(this.COLUMNS.CATEGORIES);
        this.PROFILES.ALL = this.PROFILES.ALL.concat([this.COLUMNS.WEIGHT, this.COLUMNS.MODIFIED]);  
		
		this.PROFILES.MINIMAL = [this.COLUMNS.TYPE, this.COLUMNS.ID, this.COLUMNS.CALCULATEDRISK, this.COLUMNS.NAME, this.COLUMNS.STATE];
		this.PROFILES.MINIMAL = this.PROFILES.MINIMAL.concat(this.COLUMNS.CATEGORIES);
        this.PROFILES.MINIMAL = this.PROFILES.MINIMAL.concat(this.COLUMNS.MODIFIED);

		this.PROFILES.INPLAN = [this.COLUMNS.TYPE, this.COLUMNS.ID, this.COLUMNS.COMMUNITYRISK, this.COLUMNS.CALCULATEDRISK, this.COLUMNS.SUSPECT, this.COLUMNS.NAME, this.COLUMNS.STATE];		
		this.PROFILES.INPLAN = this.PROFILES.INPLAN.concat(this.COLUMNS.CATEGORIES);
		this.PROFILES.INPLAN = this.PROFILES.INPLAN.concat(this.COLUMNS.TER_COUNT);
        this.PROFILES.INPLAN = this.PROFILES.INPLAN.concat([this.COLUMNS.WEIGHT, this.COLUMNS.MODIFIED]);  
		
        this.PROFILES.SNAPSHOT = [this.COLUMNS.TYPE, this.COLUMNS.ID, this.COLUMNS.NAME, this.COLUMNS.SNAPSHOTS, this.COLUMNS.STATE];
        this.PROFILES.SNAPSHOT = this.PROFILES.SNAPSHOT.concat(this.COLUMNS.CATEGORIES);		
		
        this.columnProfile = null;
        this.columnProfileName = null;
        this.setProfile(this.profile ? this.profile : "ALL"); //default to 'ALL' (full) column profile        
    },
    labelUnassigned: Constants.getMessage("labelUnassigned"),
    
    _createCategoryValueMap: function() {
		if (!this.categoryValueMap){
			this.categoryValueMap = {};
		}
		var numCategories = this.categoryTypes.length;
		for (var i = 0; i < numCategories; i++) {
			var t = this.categoryTypes[i];
			if (!t.archived) {
				var jLen = t.categories ? t.categories.length : 0;
				if (jLen){
					var cat = t.categories;
					var valMap = this.categoryValueMap;
					for (var j = 0; j < jLen; ++j){
						var val = cat[j];
						valMap[val.itemId] = {name: val.name, type: t}; 
					}
				} 
			}
		}
    },
    
    toColumn: function(name, width, groupable, alignment, type, rowName, isVisible, dbName) {
        return {
            name: name,
            width: width,
            groupable: groupable,
            alignment: alignment,
            type: type,
            rowName: rowName,
			isVisible: isVisible,
            
            // initialize a db name for the column, if no explicit dbName is provided, use the rowName
            dbName: (dbName) ? dbName : rowName
        }
    },  
	
	getProfile: function() {
		return this.columnProfile;
	},

    getProfileName: function() {
        return this.columnProfileName;
    },
			
	setProfile: function(/* string */ profile) {
		if (this.PROFILES[profile]) {
			this.columnProfileName = profile;
			this.columnProfile = this.PROFILES[profile];
		}
	},

    getColumnIndex: function(name) {
        for (var i = 0; i < this.columnProfile.length; i++) {
            if (this.columnProfile[i].name == name) {
                return i;
            }
        }
        return -1;
    },
	
    getColumnIdName: function(index)
    {
        var profile = this.getProfile();
        return profile[index].dbName;
    },

	setCategoryTypes: function(newTypes) {
        this.categoryTypes = newTypes;
    },
		
    // Summary:
    //
    getNumColumns: function(content)
    {
        return this.columnProfile.length;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var column = this.columnProfile[index];
		if (column.name == this.COLUMNS.TER_COUNT.name) {
			return null; //display image only (with tooltip) in the header for this column
		}
		return column.name;
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
		var column = this.columnProfile[atColumnIndex];
		if (column.name == this.COLUMNS.TER_COUNT.name) {
			return {
				src: ImageCache.EWI,
				tooltip: Constants.getMessage("labelTERCountDetail")
			}
		}
		if (!this.enableRowEditable || (column.rowName && (
					column.rowName != "weight" && column.rowName != "systemRisk" && column.rowName != "state"))) 
			return null;
		else if (column.name == this.COLUMNS.CALCULATEDRISK.name) {
			if (this.tableViewer.queryName) {
				//only add bulk change in "All Test Cases" table
				var img = {
					actionId: column.name,
					src: ImageCache.BULK_CHANGE,
					disabled: true
				};
				img.tooltip = Constants.getMessage("labelChangeProperties", img.actionId);
				return img;
			}
			else return null;
		} else {
			var img = {
				actionId: column.name ? column.name : Constants.getMessage("labelWeight"),
				src: ImageCache.BULK_CHANGE,
				disabled: true
			};
			img.tooltip = Constants.getMessage("labelChangeProperties", img.actionId);
			return img;
		}
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
		return this.columnProfile[atColumnIndex].alignment;
    },   
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].groupable;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].name != this.COLUMNS.TYPE.name &&
               this.columnProfile[atColumnIndex].name != this.COLUMNS.CALCULATEDRISK.name &&
               this.columnProfile[atColumnIndex].name != this.COLUMNS.COMMUNITYRISK.name;
    },
    
	getIsColumnVisible: function(atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].isVisible;
    },
	
    getColumnWidth: function(content, atColumnIndex)
    {			
		var column = this.columnProfile[atColumnIndex];
		if (this.columnProfileName == "ALL") {
			return column.width;
		}
		//TODO - refactor into base class or create profile class
		//if using a smaller column profile, adjust widths
		var total = 0;
		for (var colName in this.columnProfile) {
			total += this.columnProfile[colName].width;
		}
		//split the difference between all columns proportionately
        var rowBuffer = 100 - total;   //percentage of width unused
		var columnBuffer = rowBuffer * (column.width / total);  //proportionately redistrubute
		return (column.width + Math.round(columnBuffer));        
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return (rowData.itemId ? rowData.itemId : rowData.participantId);
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = this.columnProfile[atColumnIndex].type;
        // link is disabled as text label if the test case is archived
        if ((rowData.archived || rowData.newItem) && (type == TableConstants.RENDER_TYPE_LINK)) {
            return TableConstants.RENDER_TYPE_TEXT;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].alignment;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    	
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
		var column = this.columnProfile[atColumnIndex];
        switch(column.name) {
            case this.COLUMNS.TYPE.name: 
                val = "";
                break;
            case this.COLUMNS.ID.name: 
                val = rowData.id;
                break;
			case this.COLUMNS.COMMUNITYRISK.name: 
                val = this._getRiskLevel(rowData.risk, "communityRisk");
                break; 		
			case this.COLUMNS.CALCULATEDRISK.name: 
                val = this._getRiskLevel(rowData.risk, "calculatedRisk");
                break; 					
            case this.COLUMNS.NAME.name: 
                val = rowData.name;
				if (rowData.snapshotInfo) {
					var snap = rowData.snapshotInfo;
					val += Constants.getMessage("labelRevisionInfo", snap.revision, snap.name);
				}
                break;
            case this.COLUMNS.STATE.name: 
                //val = rowData.state;
				val = rowData.archived ? Constants.getMessage("labelDeleted") : EditorUtil.getStateNameFromID(rowData.state);             
                break;
            case this.COLUMNS.WEIGHT.name: 
                val = rowData.weight;
                break;
            case this.COLUMNS.MODIFIED.name: 
                val = new Date();
                val.setTime(rowData.modified);
                break;   
			case this.COLUMNS.SUSPECT.name: 
                val = (rowData.suspect)? Constants.getMessage("labelSuspect") : Constants.getMessage("labelNonSuspect");
                break; 	
            case this.COLUMNS.SNAPSHOTS.name: 
                val = "";
                break; 
            case this.COLUMNS.TER_COUNT.name: 
                val = rowData.terCount != null ? rowData.terCount : 0;
                break; 				 				
			default:
			    val = this.getCategoryByType(rowData, column.typeItemId) || "";
				break;            
        }
        return val;
    },	

    getCellRawData: function(rowData, atColumnIndex)
    {
        var val = "";
        var rowName = this.columnProfile[atColumnIndex].rowName;
        
        if(rowName) {
            return (rowData[rowName] || val);
        }
        
        var column = this.columnProfile[atColumnIndex];
		if(column.name == this.COLUMNS.SUSPECT.name) {
			val = (rowData.suspect)?"Suspect":"Non-Suspect";
		}
		else {
			val = this.getCategoryByType(rowData, column.typeItemId) || "";
		}
        return val;
    },
	
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = {};
		var colName = this.columnProfile[atColumnIndex].name;
        switch(colName) {
            case this.COLUMNS.TYPE.name: 
                val.image = ImageCache.TEST_CASE;
                if (!this.tableViewer.isInPicker) {
	                val.tooltip = rowData.archived ? Constants.getMessage("labelTCDeleted") : Constants.getMessage("labelClickToOpenTestCase");
	                if (!rowData.archived) {
	                    if (rowData.newItem && this.newItemLinkCallback) {
	                        val.onclick = dojo.hitch(this, function(){
	                            this.newItemLinkCallback(rowData.participantId);
	                        });
	                    } else if (rowData.snapshotInfo) {
	                        val.href = Utility.getTestCaseURI(rowData.itemId, rowData.snapshotInfo.revision);
	                    } else {
	                        val.href = Utility.getTestCaseURI(rowData.id);
	                    }
	                }
                }
                break;
			case this.COLUMNS.COMMUNITYRISK.name: 
				//no translate
				var image = ImageCache.RISK_LEVELS[this._getRiskLevel(rowData.risk, "communityRisk")];
				if (image) {
					val.image = image; 
					val.tooltipInfo = {
						createContents: dojo.hitch(this, this._createTooltip, rowData),
						onOpen: dojo.hitch(this, this._openTooltip, rowData),
						onClose: dojo.hitch(this, this._closeTooltip)
					};
				}
                break;
			case this.COLUMNS.CALCULATEDRISK.name:
				//no translate 
                var image = ImageCache.RISK_LEVELS[this._getRiskLevel(rowData.risk, "calculatedRisk")];
				if (image) {
					val.image = image;
					val.tooltipInfo = {
						createContents: dojo.hitch(this, this._createTooltip, rowData),
						onOpen: dojo.hitch(this, this._openTooltip, rowData),
						onClose: dojo.hitch(this, this._closeTooltip)
					};
				}
                break;
			case this.COLUMNS.ID.name:
                if (!rowData.archived) {
                    val.linkType = Constants.getMessage("TestCaseID");
                }
            case this.COLUMNS.NAME.name: 
                if (!rowData.archived) {
                    if (rowData.newItem && this.newItemLinkCallback) {
                        val.onclick = dojo.hitch(this, function(){
                            this.newItemLinkCallback(rowData.participantId);
                        });
                    } else if (rowData.snapshotInfo) {
                        val.href = Utility.getTestCaseURI(rowData.itemId, rowData.snapshotInfo.revision);
                    } else {
                        val.href = Utility.getTestCaseURI(rowData.id);
                    }
                }
                break;
            case this.COLUMNS.STATE.name: 
            case this.COLUMNS.WEIGHT.name:
			case this.COLUMNS.MODIFIED.name:
                break;       
			case this.COLUMNS.SUSPECT.name: 
                if (rowData.suspect) {
					val.image = ImageCache.TESE_SUSPECT;
				} else if (!rowData.suspect) {
					val.image = ImageCache.TESE_NONE_SUSPECT;
				} else {
					val.image = "";
				}
				break;
			case this.COLUMNS.SNAPSHOTS.name:
                val.select = "";
                val.choices = [];
                val.choices.push({
                    text: Constants.getMessage("labelCurrent"),
                    value: ""
                });				
				if (rowData.snapshots) {
					for (var i = 0; i < rowData.snapshots.length; i++) {
						val.choices.push({
							text: (rowData.snapshots[i].revision + ": " + rowData.snapshots[i].name),
							value: rowData.snapshots[i].revision
						})
					}
				}
				break;
        }
        return val;		
    },
    
    getCategoryByType: function(testCase, typeItemId) {
        if (testCase && testCase.categories) {
			var tcCategories = testCase.categories;
			var tcCategoriesLength = tcCategories.length;
			var valMap = this.categoryValueMap;
			for (var j = 0; j < tcCategoriesLength; j++) {
				var tcCategory = tcCategories[j];
				var val = valMap[tcCategory];
				if (val && val.type.itemId == typeItemId) {
					return val.name;	
            		}
				}
			}
		return this.labelUnassigned;
    },
	
	_getRiskLevel: function(dtoRisk, riskType) {
		if (dtoRisk) {
			var levelString = null;
			switch (riskType) {
				case "communityRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("communityRisk")+14, dtoRisk.indexOf("communityRisk")+15);
					break;
				case "calculatedRisk":
					levelString = dtoRisk.slice(dtoRisk.indexOf("calculatedRisk")+15, dtoRisk.indexOf("calculatedRisk")+16);
					break;
			}
			var level = Number(levelString);
            if (level != NaN && level >= 0) {
				return level;
            } 
		}
		return 0;
	},
	
	_createTooltip: function(rowData, hoverPopup) {
		this.riskTooltipWidget = new com.ibm.rqm.risk.web.ui.internal.view.assessment.AssessmentOverview({
			artifact: rowData,
			artifactType: Constants.MODEL_TYPE_CASE,
			editable: this.enableRowEditable || false
		});
		hoverPopup.content = this.riskTooltipWidget.domNode;
	},
    
	_openTooltip: function(data) {
	},
	
	_closeTooltip: function(hoverPopup) {
		hoverPopup._lastOpen = -1;
		if(this.riskTooltipWidget && this.enableRowEditable)
			this.riskTooltipWidget.onSave(this.tableViewer);
            this.riskTooltipWidget = null;
	}
	
});

dojo.declare("TestCaseTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine, addSnapshotsFilter) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);
        this.addSnapshotsFilter = addSnapshotsFilter;

        // define the static filters
        this.filters = [];
        this.filters.push({		
            name: "myItemsOnly",  // must match key in the arg list of the API
            title: Constants.getMessage("labelOnlyMyTestCases"),
            promptTitle: Constants.getMessage("labelOnlyMyTestCases"),
            type: TableContentFilterProvider.FIELD_CHECKBOX,
            defaultValue:  this.defaultToMine, params: null
        });
        if (this.addSnapshotsFilter == true) {
            this.filters.push({
                name: "includeSnapshots",  // must match key in the arg list of the API
                title: Constants.getMessage("labelIncludeSnapshots"),
                promptTitle: Constants.getMessage("labelIncludeSnapshots"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: false, params: null               
            });
        }		
		this.filters.push({
            name: "name",  // must match key in the arg list of the API
            title: Constants.getMessage("labelname"),
            promptTitle: Constants.getMessage("labelName"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, params: null
        });
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescription", Constants.getMessage("labelTestCases"));
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilters: function() {
        return this.filters;
    },
		
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },

    getFilterIdName: function(index)
    {
        var filter = this.filters[index];
        return filter.dbName || filter.name;        
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        if (this.tableView) {
            // must have the view context to perform the query and update the table display
            var allCategories = [];
            var args = {};
            
            for (var nameKey in filters) {
                // iterate through the filters
                if (filters[nameKey] != null) {
                    // skip those that are not specified
                    if (nameKey.indexOf("categories") == 0) {
                        // filter name has "categories" prefix, flatten all selected categories 
                        // into an array of comma separated strings
                        allCategories.push(filters[nameKey].join(","));
                    } 
                    else {
                        if (nameKey == "weight") {
                            args['weightComparator'] = filters[nameKey].operator;
                            args['weightValue'] = filters[nameKey].value;
                        }
                        else {
                            args[nameKey] = filters[nameKey] || "";
                            if(args[nameKey] == 'Any@@')
                                args[nameKey] = '';
                            }
                    }
                }
            }
            // add the flattened categories array to the args if there is any defined
            if (allCategories.length > 0) {
                args["categories"] = allCategories;
            }
            
            // This is a new query, reset the paging
            this.tableView.queryToken = null;
            this.tableView.runQuery(args);
        }
    }
});

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredPagingTableView],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_queryTableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
					'  <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" ></div>' +
				    '</div>',

    // allows clients to control whether the table should show
    // change settings controls.
    allowChangingTableSettings: true,
    editable: true,
	printable: false,
    widgetsInTemplate: true,
    pdfPrintType: "testcase",  // define the pdf print type. Our super class will handle it.
    
    constructor: function() {
		this.categoryTypes = null;
	 	this.testCases = null;
		this.newItemLinkCallback = null;
		this.rowCheckedListener = null;
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
		this.allowQuerySnapshots = false;
        this.enableRowSelection = false; 
		this.isSingleSelect = false;
        this.allowSelectAll = true;
        this.displayInPopup = false;
        this._actionButtons = [];
	},

    uninitialize: function() 
    {
        if(this.parent)
            this.parent._testCaseTableView = null;
        this.categoryTypes = null;
        this.testCases = null;
        this.tableViewer = null;
    },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);

		EditorUtil.loadStateTransitionConstraintSettings();  //Load the prefs in case we attempt actions that require checking (like execute)

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
        
		//init options for running search		
		this.setSearchFunction(dojo.hitch(TestCaseClient, "searchTestCases"));	
		this.setSearchCallback(dojo.hitch(this, "show"));
		this.setResponseHandlerType(TestCaseMapper);
		this.setTypeLabel(Constants.getMessage("labelTestCase"));
        if (this.postQueryFilterCallback) {
            this.setSearchFilterCallback(this.postQueryFilterCallback);
        }
        // hook in the method to obtain all results' item ids.
		this._getAllResultsItemIds = dojo.hitch(TestCaseClient, "getAllSearchResultItemIds");
		this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();
		        
        // we're showing query filters, we'll be managing our own
        // contents. Initialize the query filters first.
        //get the category types (used instead of resolving them for each test case)
        var responseHandler = new CategoryMapper(this, "_initialize", "_error");
        CategoryClient.getCategoryTypeSummaries(responseHandler, Constants.MODEL_TYPE_CASE, this.fullCategorySet);
	},
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function(categoryTypes) {
        // create the filter provider for the table
        this.filterProvider = new TestCaseTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine(), this.allowQuerySnapshots);

        this.moreFilters = [];
		//callback: initialize the orginator filter with the list of contributors
        var callback = dojo.hitch(this, function() {
            // add the category filters to the end if there is any
            for (var j = 0; j < this.moreFilters.length; j++) {
                this.filterProvider.filters.push(this.moreFilters[j]);
            }
            this._initialize2(categoryTypes);
        });
        
        var contributorFilter = {           
            //filterName, filterLabel, filterPrompt, filterType, callback
            name: "originatorUUIDs",
            label: Constants.getMessage("labeloriginatorLabel"),
            prompt: Constants.getMessage("labelOriginator"),
            type:TableContentFilterProvider.FIELD_TOGGLELIST
        }
        this.addContributorFilter(contributorFilter, this.filterProvider.filters, callback);
		//add state filter
        this.addArtifactStateFilter(this.moreFilters);
        
        this.moreFilters.push({
            name: "suspect",
            title: Constants.getMessage("labelSuspect") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelSuspect"),
            type: TableContentFilterProvider.FIELD_ENUM, 
            defaultValue: "Any@@", 
            params: [
                {
                    name: Constants.getMessage("labelAnyCap"),
                    value: 'Any@@'
                },
                {
                    name: Constants.getMessage("labelSuspect"),
                    value: "true"
                }, 
                {
                    name: Constants.getMessage("labelNonSuspect"),
                    value: "false"
                }
            ]
        });
        this.moreFilters.push({
            name: "weight",
            title: Constants.getMessage("labelWeight") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelWeight"),
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: null,
            params: {
                fieldWidth: 240,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
                fieldArgs: {'showNumericOperators': true}
            }
        });
        this.moreFilters.push({
            name: "id", // must match key in the arg list of the API
            title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: null
        });
        
        var calculatedRiskFilter = {
            name: "calculatedRisk",  // must match key in the arg list of the API
            label: Constants.getMessage("labelRiskAssessment") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelRiskAssessment")
        };
        this.addRiskFilter(calculatedRiskFilter, this.moreFilters);
        
        var communityRiskFilter = {
            name: "communityRisk",  // must match key in the arg list of the API
            label: Constants.getMessage("labelCommunityRiskHeader") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelCommunityRiskHeader")
        };
        this.addRiskFilter(communityRiskFilter, this.moreFilters);

        // add the modified time filter
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "modified",  // must match what the filter provider looks for
            fromKey: "modifiedFrom",
            toKey: "modifiedTo",
            label: Constants.getMessage("labelModified") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelModified")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, this.moreFilters);

        // initialize filters for all the categoryType
        this.currentCategoryFilters = CategoryUtil.getCategoryTypesFilters(categoryTypes);
        this.moreFilters = this.moreFilters.concat(this.currentCategoryFilters);
    },
    	
    _constructTableContentProvider: function() {
        //create the table provider
        return new TestCaseTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            profile: this.profile ? this.profile : Constants.TABLE_PROFILE_ALL,
            categoryTypes: this.categoryTypes,
            newItemLinkCallback: this.newItemLinkCallback,
            enableRowEditable: this.enableRowEditable,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });     
    },
    _initialize2:function(){
		 if (this.showQueryFilters) {
			this.initFilterProvider(this.filterProvider);
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
			this.initRunQuery();
        }
	},
    _initialize: function(categoryTypes) {
		if (this.showQueryFilters) {
			setTimeout(dojo.hitch(this, function(){
				this._initializeFilters(categoryTypes);
			}), 0);
		}
		this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
		
		this.provider = this._constructTableContentProvider();
        
		//create table viewer		
		var isMinimal = this.profile && ((this.profile != Constants.TABLE_PROFILE_ALL) && this.profile!= "INPLAN");		
        var allowChangeSettings = (this.allowChangingTableSettings && (!isMinimal || this.tableId));
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode             
			showPagingControl: !this.printable,
			showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,
            allowAdjustSettings: allowChangeSettings,
            autoSaveSettings: allowChangeSettings,
            handleVirtualSelectAll: true,
            allowMultiSort: true,
            allowSelectAll: this.allowSelectAll,
            displayInPopup: this.displayInPopup
        });	               

        // setup the table's id for saving table settings
        // Also, the per-session saved filter is indexed by
        // the table's id, need to set this up before creating
        // the filter provider. 
        this.tableViewer = tableViewer;
        if(!isMinimal || this.tableId) {
            var id = (this.tableId) ? this.tableId : ((this.isQueryPage) ? "RQM-TC-QUERY-TABLEVIWER" : "RQM-TC-TABLEVIWER");
            tableViewer.tableId = id;
        }

          
        if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this.viewHeaderNode.setCSHelpId("rqm_view_test_cases.html"); 
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelAllTestCase")+" "+Constants.getMessage("labelHelp"));       
			this._tableViewerNode.style.display = "none";
            dojox.data.dom.removeChildren(this._queryTableViewerNode);
			this._queryTableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            dojox.data.dom.removeChildren(this._tableViewerNode);
			this._tableViewerNode.appendChild(tableViewer.domNode);
        }
        
        var content = this.testCases ? this.testCases : [];
        tableViewer.setContent(content);
        tableViewer.setContentProvider(this.provider);
		tableViewer.setTableListener(new TestCaseTableView.TableListener({
			parentView: this
		}));
        tableViewer.setCellModifier(new TestCaseTableView.CellModifier());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestCases")));
        tableViewer.setUnspecifiedGroupTitle(Constants.getMessage("labelUnassigned"));
        if (this.enableRowSelection) {
            tableViewer.setTableRowsCheckable(this.editable && !this.printable, /* isSingleSelect */ false);
        }
		if (this.isSingleSelect) {
			tableViewer.setTableRowsCheckable(this.editable && !this.printable, /* isSingleSelect */ true);
		}
		// always enable multiple row check when the widget is included in the picker
		if (this.isInPicker) {
			tableViewer.setTableRowsCheckable(true, false);
		}
		
        var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);

		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), null, "refresh-icon-image", this.refreshCallback);    
        }
		
		//add any actions provided by the consumer
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            if(!this.isQueryPage && action.label == Constants.getMessage("labelRemoveTestCases")){//If not querypage remove action will be sent
				this.deleteActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
				this.deleteActionNode.setDisabled(true);
			} else if (action.label == Constants.getMessage("labelGenEWIs")) {
                this.genEWIActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                this.genEWIActionNode.setDisabled(true);
            } else if(action.label == Constants.getMessage("labelChangeTestCaseProperties")) {
				this.batchUpdateNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                this.batchUpdateNode.setDisabled(true);
			} else if (action.label == Constants.getMessage("labelExeTest")) {
                this.executeActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                this.executeActionNode.setDisabled(true);
            } else if(action.actionId == "moveup"){
				this.moveUpNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
				this.moveUpNode.setDisabled(true);
			} else if(action.actionId == "movedown"){
				this.moveDownNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
				this.moveDownNode.setDisabled(true);
			} else 
				tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
					
        }		

		//Check Test Case Execute Permission
		var tc_exec_permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE_EXE);
        // default to allow if fail to fetch permission
		var hasExePermission = !tc_exec_permission ? true : tc_exec_permission 
																&& tc_exec_permission[PermissionsClient.ACTION_EXECUTE];
        if (this.isQueryPage) {
            if (hasExePermission && !this.executeActionNode) {
                this.executeActionNode = tableViewer.addAction(
                        "execute",                                  // action id
                        Constants.getMessage("labelExeTest"),       // label
                        null,                                       // callback data
                        "execute-icon-image",                       // icon class
                        dojo.hitch(this, "_onExecuteActionClick")); // callback
                this.executeActionNode.setDisabled(true);
				
            }
        }
		
		if (this.executeActionNode != null && hasExePermission && !tableViewer.getTableRowsCheckable()) {
			tableViewer.setTableRowsCheckable(true, this.isSingleSelect);
		}
        
        var cat_permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_CATEGORY);
        if (!cat_permission || cat_permission[PermissionsClient.ACTION_EDIT] && !this.minimalAction) {
            //add action for managing categories
            this.configureActionNode = tableViewer.addAction("configure", // action id
                Constants.getMessage("labelManageCategories", Constants.TYPE_CASE), // label
                null, // callback data
                "categories-icon-image", // icon class
                dojo.hitch(this, "_handleCategoriesClick") // callback
            );
        }
        
        if (!permission || permission[PermissionsClient.ACTION_EDIT] && !this.minimalAction) {
            //add action for changing suspect attribute	
            this.changeSuspectActionNode = tableViewer.addAction(
                "ChangeSuspect", 
                Constants.getMessage("labelChangeSuspect"), 
                this, 
                "req-suspect-icon-image", 
                dojo.hitch(this, "invokeAction", "versionableItemId", this, "_onChangeSuspectActionClick")
            );
            this.changeSuspectActionNode.setDisabled(true);
        }
        
		if (this.isQueryPage) {
			var script_permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SCRIPT);
	        if (!script_permission || script_permission[PermissionsClient.ACTION_CREATE]) {
                var self = this;
                //If the user has permissions, check if the admin has enabled script generation and only then add the action
                var callback = {
                    success: function(prefValue){
                        var p = prefValue ? dojo.fromJson(prefValue.value) : {};
                        self.manualScriptGenerationPrefValue = p;
                        if (!p.disableGeneration) {
                            //add action for script generation
                            self.createScriptActionNode = tableViewer.addAction("createscript]", // action id
                                 Constants.getMessage("labelCreateManualScriptFromDesign"), // label
                                 null, // callback data
                                 "generate-scripts-icon", // icon class
                                 dojo.hitch(self, "_handleCreateManualScriptFromDesign") // callback
                            );
                            self.createScriptActionNode.setDisabled(true);
                        }
                        self._initialize1(permission);
                    },
                    failure: function(){
                        self._initialize1(permission);
                    }
                }
                var responseHandler = new ServiceResponseHandler(callback, "success", "failure");
                var option = new com.ibm.asq.common.web.client.internal.option();
                option.getProjectPreferences(responseHandler, getCurrentProjectArea().itemId, Constants.MANUALSCRIPT_CONVERTOR_DICTIONARY_CATEGORY);
                
                // don't finish the initialization code yet, until we come back
                // from getting the dictionary pref.
                return;
            }
		}
        // need to call the splitted code to complete the initialization.
        this._initialize1(permission);		
    },

	//Need to split the initialization inorder to keep the ordering of actions intact.
	_initialize1: function(permission){
		// for query page there will be no passed in actions and we need a delete action
        var content = this.testCases ? this.testCases : [];
		var tableViewer = this.tableViewer;
        if (this.isQueryPage) {
            if (!permission || permission[PermissionsClient.ACTION_ARCHIVE]) {
                this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "invokeAction", "versionableItemId", this, "_onDeleteActionClick")); // callback
                this.deleteActionNode.setDisabled(true);
            }
			
			var openedArtifacts = [];
        	this.selectedCases = [];
			
			this.duplicateActionNode = tableViewer.addAction(
	        		"duplicate",
        			Constants.getMessage("labelDuplicateAction"),
	        		null,
        			"duplicate-icon-image",
					dojo.hitch(this, "invokeAction", "id", this, "_onDuplicateActionClick"));					
      		this.duplicateActionNode.setDisabled(true);
			var duplicateAction = new  DuplicateAction();
			duplicateAction.setType(ActionEntityType.TEST_CASE);
			duplicateAction.isDuplicateAllowed(ActionEntityType.TEST_CASE, dojo.hitch(this, "_isDuplicateAllowedCallback"));
	    	
			//******print button content******
    		var printHistoryCARMenu = new dijit.Menu({ style: "display: none;"});
    		var printSummaryMenu = new dijit.Menu({ style: "display: none;"});
    		var printMultipleMenu = new dijit.Menu({ style: "display: none;"});
    		
            var normalOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelCAR"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
            });
            var historyOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelHistory"),
            	onClick: dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print")
            });
            var summaryOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelSummary"),
            	onClick: dojo.hitch(this, "_onPrintActionClick", /*print type*/ "list-table-print")
            });        
            var multipleOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelMultiple"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
            });
    		
            printHistoryCARMenu.addChild(normalOption);
            printHistoryCARMenu.addChild(historyOption);      
            printSummaryMenu.addChild(summaryOption);
            printMultipleMenu.addChild(multipleOption);
            
           	this.printSummaryActionNode = tableViewer.addAction(
           			"printpdfsummarymenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintActionClick", /*print type*/ "list-table-print"),
           			printSummaryMenu
           	);      	
           	this._actionButtons.push(this.printSummaryActionNode);
           	this.enableAction("printpdfsummarymenu");
           	
           	this.printHistoryCARActionNode = tableViewer.addAction(
           			"printpdfhistorycarmenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintActionClick", /*printType*/ "history-print"),
           			printHistoryCARMenu
           	);
           	this._actionButtons.push(this.printHistoryCARActionNode);
           	this.hideAction("printpdfhistorycarmenu");
           	
           	this.printMultipleActionNode = tableViewer.addAction(
           			"printpdfmultiplemenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintPdfActionClick"),
           			printMultipleMenu
           	);
           	this._actionButtons.push(this.printMultipleActionNode);
           	this.hideAction("printpdfmultiplemenu");
            //******end print button content******
        }

        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        if (this.printable) {
            tableViewer.setContentPageSize(-1);
        }
        tableViewer.show();
        tableViewer.setEditable(this.editable); 
        
		if(!this.showQueryFilters && (!content || !content.length)){
			if (!this.minimalAction && this.isQueryPage) {
				this.printSummaryActionNode.setDisabled(true);
				this.printHistoryCARActionNode.setDisabled(true);
				this.printMultipleActionNode.setDisabled(true);
			}
		}
	},
	

		
    //API
    getAction: function(id) {
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            if (this.actions[i].label == id) {
                return this.actions[i];
            }
        }
    },
    
    getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },
    
    refresh: function(content, skipClearStatus) {       
        this.testCases = content;
        var cancelProgress = this.showInitLoadProgress;
        
        // we don't create the table until we fetched the categories.
        // The table may not have existed at this point. The real data
        // has arrived. Always reset the init load progress flag. 
        if(this.showInitLoadProgress) {
            this.showInitLoadProgress = false;
        }
		if (this.tableViewer) {
            if(cancelProgress) {
                this.tableViewer.endLoadingProgress();
            }
            var hasItems = (content && content.length);
			if (hasItems) {
				var contentLength = content.length;
				for (var i = 0; i < contentLength; i++) {
					content[i].rowId = i;
				}
			}
            // we are only updating the virtual content. The virtual
            // content provider has convenient method to do that. Call
            // it to load the virtual content. Updating a virtual page
            // is much less 'destructive' then a regular table refresh.
            // It retains the row selection states.
            if (this.updatePageOnly) {
                this.provider.loadPageContent(content);
            }
            else {
                this.tableViewer.setContent(content);
                this.tableViewer.refresh();
            }
			var listener = this.tableViewer.getTableListener();
			if(listener)
				listener.rowCheckStateChanged(this.tableViewer);
		}
        if (this.viewHeaderNode && !skipClearStatus) {
            this.viewHeaderNode.clearStatus();
        }
    },  

	// Summary:
    //    Get categoryTypes first, then displays the table.
    //    The content provider is changed, so invoke _reContructTable to reset the whole table
    //
	show: function(content, skipClearStatus) {
        this.testCases = content;

        // we are only updating the server side pages, don't have 
        // to refetch the category...
        if(this.updatePageOnly) {
            this.refresh(content, skipClearStatus);
            this.updatePageOnly = false;
            return;
        }
        
        //reset CategoryTypes
		var self = this;
		var handler = {
            success: function(categoryTypes) {
                //reset TableViewer first
                self.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
                var cancelProgress = self.showInitLoadProgress;
                // we don't create the table until we fetched the categories.
                // The table may not have existed at this point. The real data
                // has arrived. Always reset the init load progress flag. 
                if (self.showInitLoadProgress) {
                    self.showInitLoadProgress = false;
                }
                if (self.tableViewer) {
                    if (cancelProgress) {
                        self.tableViewer.endLoadingProgress();
                    }
					self._reContructTable(categoryTypes, content);
                }
                if (self.viewHeaderNode && !skipClearStatus) {
                    self.viewHeaderNode.clearStatus();
                }
                
                //reset viewBuilder?
                if (self.showQueryFilters) {
                    var newCategoryFilters = CategoryUtil.getCategoryTypesFilters(self.categoryTypes);
                    if (!CategoryUtil.isCategoryFiltersSame(newCategoryFilters, self.currentCategoryFilters)) {
                        //category filters are changed, user have the choice to reset viewbuilder or not
                        self._confirmResetViewBuilder(newCategoryFilters);
                    }

                    if (self.queryFiltersCallback) {
                        self.queryFiltersCallback();
                    }
                }
				// One last call back. Right now this is used for duplicate to post final status
				if(self._searchFinalCallback)
					self._searchFinalCallback();
            },
            error: function(e) {
                self._error(e);
            }
        }
		var responseHandler = new CategoryMapper(handler, "success", "error");
        CategoryClient.getCategoryTypeSummaries(responseHandler, Constants.MODEL_TYPE_CASE);		
	},
	
	_handleCreateManualScriptFromDesign: function(){
        var createManualScriptProc = dojo.hitch(this, function(selectedCases) {
		this.previewTable = new com.ibm.rqm.planning.web.ui.internal.view.table.PreviewScriptTableView({testCases: selectedCases});
		
		var dialogArgs = {
				primaryTitle: Constants.getMessage("msgCreateManualScripts"),
                okCallback: dojo.hitch(this, "_createManualScripts"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				style: "z-index: 9991;",
				zIndex: 9990,
				movable: true
            };
            this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this.floatingPane._yesAction = function(){
				var selection = null;
        		if (dojo.isFunction(this.selectionHandler)) {
					selection = this.selectionHandler();
				}            
        		if (dojo.isFunction(this.yesCallback)) {
					//allow callback to cancel close (for example, if some validation fails)
					var callbackResponse = this.yesCallback(this.yesCallbackData, selection);
					if (callbackResponse != null && callbackResponse == false) {
						//do not close
						return;
					}
				} 
			};
            this.floatingPane.setWidth("80%");
            this.floatingPane.contentContainer.appendChild(this.previewTable.domNode);
            this.floatingPane.getOkButton().disabled = false;    
			this.floatingPane.open(); 
        });
        // we might not have all data. Get virtual selected rows will determine
        // whether this is a select all and, if so, it will fetch all data for this action.
        // if there are deselected items from a select all, filter them by the item's id
        this.getVirtualSelectedRows('itemId', createManualScriptProc);
	},

	_onCancel: function(){
	},
	
	_createManualScripts: function(){
		var valid = this.previewTable.validate();
		if(!valid){
			return false;
		}
		var values = this.manualScriptGenerationPrefValue;
		this.vpValues = values.vps ? values.vps : [];
		this.rpValues = values.rps ? values.rps : [];
		var dictionary = [];
		dictionary.push({vpValues: {value: this.vpValues}, rpValues: {value: this.rpValues}});
		var dictionaryJsonString = dojo.toJson(dictionary);
				
		var selectedCases = this.previewTable.getContent();
		this.floatingPane.close();//Close now, table gets destroyed
		this.selectedCaseCount = selectedCases.length;
		var params = { uid:[], scriptOwnerIds: [], scriptNames: []};
        if (this.selectedCaseCount > 0) {
            for (var i = 0; i < this.selectedCaseCount; i++) {
				params.uid.push(selectedCases[i].itemId);
				params.scriptNames.push(selectedCases[i].testScriptName);
				var owner = selectedCases[i].owner && selectedCases[i].owner.itemId ? selectedCases[i].owner.itemId : "";
				params.scriptOwnerIds.push(owner);//Send blank string if owner is not selected
            }
			params.autoCreateManualScript = true;
			params.dictionaryJsonString = dictionaryJsonString;
			var responseHandler = new ServiceResponseHandler(this, "_scriptCreationSuccess", "_scriptCreationError");
            TestCaseClient.postBulkChangeTestCase(responseHandler,params);
            this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgCreatingManualScripts"), 0, null);  
		}
	},
	
	_scriptCreationSuccess: function(cases) {
        ProgressUtility.endTaskMonitor(this.monitorId);
        
        if (!this.contentIsVirtual && cases && cases.length > 0) {
			for(var i=0;i<this.testCases.length;i++){
				for(var j=0;j<cases.length;j++){
					if(this.testCases[i].id == cases[j].id){
						this.testCases[i] = cases[j];
					}
				}
			}
            this.refresh(this.testCases);
        }
        else {
            this._invalidateQuery();
		}
    },
    
    _scriptCreationError: function(err) {
		console.error("Testcasetableview: Error while creating Manual script for test cases "+err.message);
        if (this.isQueryPage)
            this.viewHeaderNode.setProgressEnd();
		this.refresh(this.testCases);	
    },
	
	//Internal
	_onExecuteActionClick: function(){
		var selectedItems = this.tableViewer.getCheckedRows();
		var selectedCase = selectedItems[0];
		
		if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)) 
		{
			var state = selectedCase.state;
			if (state != Constants.STATETRANSITION_STATE_APPROVED) 
			{
				var errorStr = Constants.getMessage("msgCannotExecuteTestCaseNotApproved", selectedCase.name);
                if (this.isQueryPage)
					this.viewHeaderNode.setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, errorStr);
				else
					alert(errorStr);
				return;
			}
		}
	    var execPopUp = new ExecutionPopUp();
		var args = {
			testCase: selectedCase
		}
		execPopUp.initialize(args);
	},
	
    _handleCategoriesClick: function() {
		//refresh tableview by public event
        this._categoriesEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor({
			artifactType: Constants.MODEL_TYPE_CASE
		});
    },
	
    _handleCategoriesChanged: function(categoryTypes) {
		//reset View Builder
		this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
		var newCategoryFilters = CategoryUtil.getCategoryTypesFilters(this.categoryTypes);
		this._resetViewBuilder(newCategoryFilters);
		
		//reset test cases' table
        this._reContructTable(categoryTypes);
    },
	
 	_onDuplicateActionClick: function(ids) {
		var duplicateAction = new  DuplicateAction();
		duplicateAction.setType(ActionEntityType.TEST_CASE);
		duplicateAction.execute(ids, dojo.hitch(this, "_invalidateQuery"), dojo.hitch(this, "_duplicateError"));		
	},
		
	_isDuplicateAllowedCallback: function(allowed){
		if(!allowed)
			this.duplicateActionNode.domNode.style.display = "none";			
	},
	
	_duplicateError: function(e){
		alert(Constants.getMessage("msgDuplicateError", e && e.message ? e.message: ""));		
	},
	
    _onDeleteActionClick: function(selectedIds) {
        // check if any selected test cases are current displayed in another tabs
        var openedArtifacts = [];
        var selectedCases = [];
        var selectedRows = this.tableViewer.getCheckedRows();
        
        if (dojo.isArray(selectedRows) && this.artifactsDisplayContainer) {
            var userSelectedCases = this.tableViewer.getCheckedRows();
            var len = userSelectedCases.length;
            if (len > 0) {
                for (var i = 0; i < len; i++) {
                    var caseURI = Utility.getTestCaseURI(userSelectedCases[i].id);
                    if (this.artifactsDisplayContainer.hasPage(caseURI)) {
                        openedArtifacts.push(userSelectedCases[i]);
                    } else {
                        selectedCases.push(userSelectedCases[i]);
                    }
                }
            }
        } else {
            // can't check for opened tab, just show the deleting confirmation
            selectedCases = null;
        }
        var len2 = (selectedCases) ? selectedCases.length : selectedIds.length;
		this.selectedCases = selectedCases;
        var prompt = Constants.getMessage("msgDelTestCaseConfirm",len2);
        if (openedArtifacts.length > 0) {
            if (len2 > 0) {
                // some selected artifacts are not opened in tabs
                prompt = Constants.getMessage("msgDelSomeOpenTestCaseConfirm");
            } else {
                // all selected artifacts are opened in tabs
                prompt = Constants.getMessage("msgDelAllOpenTestCaseConfirm");
            }
        }

        var args = {
            'message': prompt,
            'options': openedArtifacts,
            'selectedIds': selectedIds,
            'okCallback': 
                function(view) {
                    view._deleteAction();
                },
            'okCallbackData': this,
            'cancelCallback': null,
            'cancelCallbackData': null
        };
        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.OptionsDialog(args);
        this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
        this.confirmDialog.open();
    },
	
	_onChangeSuspectActionClick: function(selectedIds) {
        var selectedCaseCount = selectedIds.length;
		var args = {
            'message': Constants.getMessage("msgChangeSuspectConfirm", selectedCaseCount),
            'selectedIds': selectedIds,
            'yesCallback': 
                function(view) {
                    view._changeSuspectAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        this.confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        this.confirmDialog.open();
	},
	
	_changeSuspectAction: function() {
        var dlg = this.confirmDialog;
        this.confirmDialog = null;
        
        var selectedIds = dlg.selectedIds;
        if (selectedIds.length > 0) {
            var responseHandler = new ServiceResponseHandler(this, "_changeSuspectSuccess", "_error");
            TestCaseClient.changeSuspectTestCase(responseHandler,
                    {
                        'versionableItemIds': selectedIds
                    });
        }
	},
	
	_changeSuspectSuccess: function(response) {
        if (this.showQueryFilters) {
			//using filters/query; invalidate (and refresh) current query
			this._invalidateQuery();
		} else if (dojo.isFunction(this.refreshCallback)) {
			//otherwise, if there is a refresh callback, invoke it 
			this.refreshCallback();		
		}
		this.changeSuspectActionNode.setDisabled(true);
	},
    
    _deleteAction: function() {         
        var deleteIds;
        var dlg = this.confirmDialog;
        this.confirmDialog = null;
        
        // we have possible shown options to not delete certain items, check it.
        if (this.selectedCases) {
            this.selectedCases = this.selectedCases.concat(dlg.getSelection());
            var count = this.selectedCases.length;
            deleteIds = [];
            for(var i = 0; i < count; i++) {
                deleteIds.push(this.selectedCases[i].versionableItemId);
            }
        }
        else {
            // no special handling of opened items, just use all deleted ids.
            deleteIds = dlg.selectedIds;
        }
        var totalDeleteCnt = this.selectedCaseCount = deleteIds.length;
        if (totalDeleteCnt > 0) {
            this.deleteActionNode.setDisabled(true);
            this.errorCaseCount = 0;
            this.deletedCaseCount = 0;
            if (this.isQueryPage){
                this.viewHeaderNode.setProgressStart(
                    Constants.getMessage("msgDeletedTestCases", 0, this.selectedCaseCount), ViewHeaderLayout.INFO );
            }            
			var self = this;
			var callback ={
				success:function(response){
					self.deletedCaseCount=response;
					var responseHandler = new ServiceResponseHandler(self, "_deleteSuccess", "_deleteFailure");
					TestCaseClient.postArchiveEWIsForTCs(responseHandler,{testCaseItemIds: deleteIds,archive: true});
				},
				failure:function(err){
					self._deleteFailure(err);
				}
			}
            this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingTestCases"), 0, null);  
            var responseHandler = new ServiceResponseHandler(callback, "success", "failure");
            TestCaseClient.archiveTestCases(responseHandler,{uuids_versionable: deleteIds,archive: true});
        }
    },
	
	_deleteSuccess: function(response) {
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        this.errorCaseCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        ProgressUtility.endTaskMonitor(this.monitorId);
        if (this.isQueryPage)
            this.viewHeaderNode.setStatus(
                Constants.getMessage("msgDeletedTestCases", this.deletedCaseCount, this.selectedCaseCount),
                this.errorCaseCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedCaseCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
            );
        if (this.deletedCaseCount > 0) {
                // notify all pages (including itself) test plans are deleted
                this._deleteFromSelf = true;
                // TODO: virtual select all case don't have selectedCases... need to use itemIds in
                // notification.
            dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_CASE, this.selectedCases]);
        }
    },	

    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about test cases
        if (artifactType == Constants.TYPE_CASE) {
            if (this._deleteFromSelf && changeType == GlobalEvents.ArtifactsDeleted) {
                if(this._invalidateQuery)
                    this._invalidateQuery();
                delete this._deleteFromSelf;
                return;
            }             
            if (this.isQueryPage) {
                this._showArtifactChangedMessage(this.viewHeaderNode, Constants.TYPE_CASE, changeType);
                return;
            }
            
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add test cases to the table
                if (!this.testCases) {
                    this.testCases = artifactArray;
                } else {
                    this.testCases = this.testCases.concat(artifactArray);
                }
                this.refresh(this.testCases, true);
            } else {
                for (var i = 0; i < artifactArray.length; i++) {
                    // iterate through the array of test cases in the table
                    for (var j = 0; j < this.testCases.length; j++) {
                        // handle the matching test case
                        if (artifactArray[i].id == this.testCases[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap test case on update
                                this.testCases.splice(j, 1, artifactArray[i]);
                                this.refresh(this.testCases, true);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove test case from table on delete
                                this.testCases.splice(j, 1);
                                this.refresh(this.testCases, true);
                            }
                            break;
                        }
                    }
                }
            }
        }
        else if(artifactType == Constants.TYPE_TC_CATEGORY) {
            this._handleCategoriesChanged(artifactArray);
        }
    },

    // @override.
    //    Abstract method to actually performs the batch change operations. Specific
    //    subclassess need to override this method to do the work on the artifact type.
	doBatchUpdate: function(itemIds, columnIndex, actionId) {
        var categoryType = null;
        var categoryTypes = this.categoryTypes;
        
        // pass along the category type if the bulk change
        // is for a category.
        for (var i = 0; i < categoryTypes.length; i++) {
            var categoryName = Constants.getMessage(categoryTypes[i].name);
            if (categoryName == actionId) {
                categoryType = categoryTypes[i];
                break;
            }
        }
        var action = new ActionPackage.TestCaseBulkChangeAction({
            actionId: actionId,
            itemIds: itemIds,
            categoryType: categoryType,
            completeCallback: dojo.hitch(this, "_invalidateQuery"),
            errorCallback: dojo.hitch(this, "_invalidateQuery")
        });
        
        // this is change weight bulk action. After its completion
        // we need to update the risk assessment as well. Get and 
        // pass along the versionableItemIds of the selected items
        // to do that.
        if(actionId == Constants.getMessage("labelWeight")) {
            this.invokeAction("versionableItemId", this, function(ids) {
                // set the versionableItemIds and execute
                // the action.
                action.versionableItemIds = ids; 
                action.execute();
            });
            // fetch the versionableItemIds first before running it
            return;
        }
        action.execute();
	},
    
	_mergeCategory: function(categories, CategoryTypeItemId, CategoryValueItemId) {
		var newCategories = [];
 
		for(var i = 0; i < this.categoryTypes.length; i++){
			var type = this.categoryTypes[i];
			var newValueItemId = null;
			
			if (type.itemId == CategoryTypeItemId) {
				newValueItemId = CategoryValueItemId;
			}
			else {
				newValueItemId = this._getCategoryByType(type, categories);
			}
	        if(newValueItemId)
	            newCategories.push(newValueItemId);
		}
  
        return newCategories;
    },
  
    _getCategoryByType: function(type, categories) {
        for(var i = 0; i < (type.categories ? type.categories.length:0); i++) {
            for(var j = 0; j < (categories?categories.length:0); j++) {
                if(type.categories[i].itemId == categories[j])
                    return categories[j];
            }
        }
        return null;
    },
    
	_reContructTable: function(categoryTypes, testCases) {
		if(testCases)
			this.tableViewer.setContent(testCases);

		var currentPageCtr = this.tableViewer.getCurrentPageControl();	
		//reset test cases' table
        this.provider = this._constructTableContentProvider();
		this.tableViewer.setContentProvider(this.provider);
		this.tableViewer.reconstruct(currentPageCtr);
		
		if (this.tableViewer)
		{
			var listener = this.tableViewer.getTableListener();
			if(listener)
				listener.rowCheckStateChanged(this.tableViewer);
		}
	},

	_confirmResetViewBuilder: function(newCategoryFilters) {
        //reset ViewBuilder
		var self = this;
        var args = {
            title: Constants.getMessage("labelConfirmation"),
            message: Constants.getMessage("msgChangeViewBuildConfirm"),
            yesCallback: function() {
				self._resetViewBuilder(newCategoryFilters);
			},
            noCallback: function(){
                return false;
            }
        }
        var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        dialog.setSecondaryTitle(args.title);
        dialog.open();
	},
	
	_resetViewBuilder: function(newCategoryFilters) {
		if (this.filterProvider) {
			var newFilters = [];
			var oldFilters = this.filterProvider.filters;
			for(var i = 0; i < oldFilters.length; i++) {
				if(oldFilters[i].name.indexOf("categories") == -1)
					newFilters.push(oldFilters[i]);
			}
			this.currentCategoryFilters = newCategoryFilters;
			newFilters = newFilters.concat(this.currentCategoryFilters);
			delete this.filterProvider.filters;
			this.filterProvider.filters = newFilters;
			
			this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
		}
	},

	_duplicateError: function(e){
		alert(Constants.getMessage("msgDuplicateError", e && e.message ? e.message: ""));	
	},
		
	
	getTableContent: function() {
        return this.tableViewer.getContent();
    },
	
	setRowChecked:function(row,state){
		this.tableViewer.rowCheckedHandler.setRowCheckState(row,state);
	},	
	
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    },	
    
    getActionButton: function(actionId) {
    	 var len = this._actionButtons ? this._actionButtons.length : 0;
         for (var i = 0; i < len; i++) {
        	 if (this._actionButtons[i].actionId == actionId) {
        		 return this._actionButtons[i];
             }
         }        
    },

	hideAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.addClass(button.domNode,"dijitDisplayNone");
          }
    },
      
	showAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
  			dojo.removeClass(button.domNode,"dijitDisplayNone");
          } 
    },    

    disableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(true);
          } 
    },
  	
  	enableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(false);
          } 
    }	
    
});

})();
