//TestCellTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestCellTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.web.client.internal.collections");

(function() {

var TableConstants 				= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;

dojo.declare("TestCellTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
   
  rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = selection.length;
//		if(selectionCount > 0){
//			this.parentView.removeActionNode.setDisabled(false);
//		}else{
//			this.parentView.removeActionNode.setDisabled(true);
//		}	
		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
     tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("TestCellTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("TestCellTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 3;
    },
    
    // Summary:
    //
	_columnHeadings:  [
			Constants.getMessage("labelTestCellName"),
//            Constants.getMessage("labelMeetAdapterCriteria"),
            Constants.TEST_ENVIRONMENT,
			Constants.getMessage("labelSummary")
    ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return (atColumnIndex == 1);  //Group by Test Environment     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return (true);  //Sort by any column     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 30;
            case 1: 
                return 30;
			case 2: 
                return 40;	
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_test_cell" + rowData.itemId;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

//        switch(atColumnIndex) {
//            case 0: 
//                type = TableConstants.RENDER_TYPE_LINK;
//                break;
//			case 1: 
//                type = TableConstants.RENDER_TYPE_LINK;
//                break;
//			case 1: 
//                type = TableConstants.RENDER_TYPE_IMAGE;
//                break;		
//        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name;
                break;
			case 1:
				val = rowData.testEnvName;
				break;
			case 2: 
                val = rowData.summary;
                break;	
        }
        return val;
    },
    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
		var val = null;
		return val;
    }
    
    
});

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestCellTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
		this.actions = [];
		this.testCells = [];
		this._actionButtons = [];
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
    },
	
	initialize: function(){
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            showGroupFilterControls: false,
            tableId: "TEST-CELLS-TABLEVIEWER"                                
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);

        var content = this.testCells;

        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
        tableViewer.setContentProvider(new TestCellTableView.TableProvider());
        tableViewer.setTableListener(new TestCellTableView.TableListener({parentView: this}));
        tableViewer.setCellModifier(new TestCellTableView.CellModifier());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ true);
		
		this.actions = this.getTableActions();
		var actionLen = (this.actions ? this.actions.length : 0);
		for (var i = 0; i < actionLen; i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
            if (action.disabled && action.disabled == true)
                actionButton.setDisabled(true);
            if (action.hidden && action.hidden == true)
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
            this._actionButtons.push(actionButton);
        }
		
        tableViewer.show();
		this.tableViewer = tableViewer;
		
		//Load the table with Test Cells
		this.loadCells();
	},
	
	getTableActions: function(){
		return [];		
	},
	
	_handleRemove: function(){
		var selectedItems = this.tableViewer.getCheckedRows();
		var content = this.getContent();
		var selectedItemsLength = selectedItems.length;
		if(selectedItemsLength == 0){
			return;
		}
		var contentLength = content.length;
		for(var i=0;i<selectedItemsLength;i++){
			var updatedContent = [];
			for(var j=0;j<contentLength;j++){
				if(content[j].rowId == selectedItems[i].rowId){
					continue;
				}
				updatedContent.push(content[j]);
			}
			content = updatedContent;//swap updated content so that less traversal is needed.
		}
//		this.mySection.setDirty(true);
		this.tableViewer.setContent(content);
		this.tableViewer.refresh();
		if(content.length ==0)
			this.disableAllActions();
	},
	
	loadCells: function()
	{
        this.tableViewer.showLoadingProgress();
		var responseHandler = new ServiceResponseHandler(this, "_loadSuccess", "_loadFailure");
		var collectionsService = new com.ibm.rational.test.lm.web.client.internal.collections();
		collectionsService.getAllTestCells(responseHandler);		
	},
	
	
    _loadSuccess: function(response) 
	{
		this.tableViewer.endLoadingProgress();		
        this.tableViewer.setContent(response ? response : []);
        this.tableViewer.refresh();
    },
    
    _loadFailure: function(response) 
	{
		this.tableViewer.endLoadingProgress();		
    },		
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	getSelectedItem: function(){
		return this.tableViewer.getCheckedRows();
	},
	
	disableAllActions: function(){
		var actions = this.tableViewer.getActionButtons();
		for(var action in actions){
			if(actions[action].actionId != "add")
				actions[action].setDisabled(true);
		}
	},
	
	_error: function(error){
		console.error("Error in TestCellTableView "+ error.message);
	},
	
	//Enablel the OK button (if one) based on the row selection
	rowCheckedListener: function(row, state)
	{
		if (this.OKButton)
			this.OKButton.disabled = !state;
	}
});
})();
