//TestRecordSelectionTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordSelectionTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");

(function() {

var TableConstants 				= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;

dojo.declare("TestRecordSelectionTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
   
  rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = selection.length;
		//if table view has a rowCheckListener, invoke it
		var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
        if(p && p.okButton){
            p.okButton.disabled = (selectionCount < 1);
        }  
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
     tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
//		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("TestRecordSelectionTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("TestRecordSelectionTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
	
	// Summary:
    //
    getNumColumns: function(content)
    {
        return (this.recordType == Constants.MODEL_TYPE_EWI ? 7 : 4);
    },
    
    // Summary:
    //
   _columnHeadingsEWI: [
	    Constants.getMessage("labelName"),
		Constants.getMessage("labelTestCase"),
		Constants.getMessage("labelEnvironment"),
		Constants.getMessage("labelTestPlan"),
		Constants.getMessage("labelMilestone"),
		Constants.getMessage("labelOwner"),
		Constants.getMessage("labelLastResult")
    ],
    _columnHeadings: [
        Constants.getMessage("labelName"),
        Constants.getMessage("labelState"),
		Constants.getMessage("labelOwner"),
		Constants.getMessage("labelLastResult")
    ],
    
    _EWIColumnIds: [
        "name",
        "testCase",
        "configuration",
        "testPlan",
        "testPhaseName",
        "ownerUUIDs",
        "stateIds"
    ],
    _suiteColumnIds: [
        'name',
        'state',
        'ownerUUIDs',
        'statusIds'
    ],
    
    getColumnIdName: function(index)
    {
        if(this.recordType == Constants.MODEL_TYPE_EWI){    
            return this._EWIColumnIds[index];
        }
        return this._suiteColumnIds[index];   
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings;
		if(this.recordType == Constants.MODEL_TYPE_EWI){	
			headings = this._columnHeadingsEWI;
		}else{
			headings = this._columnHeadings;
		}	
        return headings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        if(this.recordType == Constants.MODEL_TYPE_EWI){    
            return atColumnIndex != 2;
        }
        return atColumnIndex < 3;
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        if(this.recordType == Constants.MODEL_TYPE_EWI){    
            return atColumnIndex != 2;
        }
        return atColumnIndex < 3;
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return (this.recordType == Constants.MODEL_TYPE_EWI ? 15 : 25);
			case 1: 
                return (this.recordType == Constants.MODEL_TYPE_EWI ? 15 : 25);
            case 2: 
                return (this.recordType == Constants.MODEL_TYPE_EWI ? 15 : 25);
            case 3: 
                return (this.recordType == Constants.MODEL_TYPE_EWI ? 15 : 25);
			case 4: 
                return 15;
            case 5: 
                return 10;
            case 6: 
                return 10;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

//        switch(atColumnIndex) {
//            case 3: 
//                type = TableConstants.RENDER_TYPE_ENUM;
//                break;
//			case 5: 
//                type = TableConstants.RENDER_TYPE_IMAGE;
//                break;
//			case 6: 
//                type = TableConstants.RENDER_TYPE_IMAGE;
//                break;		
//        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name;
                break;
			case 1: 
                val = (this.recordType == Constants.MODEL_TYPE_EWI ? rowData.testCaseName : Constants.getMessage(rowData.state) );
                break;
            case 2: 
                val = (this.recordType == Constants.MODEL_TYPE_EWI ? 
						(rowData.configName ? rowData.configName : Constants.getMessage("labelUnassigned"))	: 
						(rowData.ownerName ? rowData.ownerName : Constants.getMessage("labelUnassigned")) 
						) ; 
                break;
            case 3: 
                val = (this.recordType == Constants.MODEL_TYPE_EWI ? 
						(rowData.testPlanName ? rowData.testPlanName : Constants.getMessage("labelUnassigned")) : 
						(rowData.currentResultStateName ? rowData.currentResultStateName : Constants.getMessage("labelUnassigned")) 
						);
                break;
			case 4: 
                val = rowData.phaseName ? rowData.phaseName : Constants.getMessage("labelUnassigned");
                break;
			case 5: 
                val = rowData.ownerName ? rowData.ownerName : Constants.getMessage("labelUnassigned");
                break;
			case 6: 
                val = rowData.currentResultStateName ? rowData.currentResultStateName : Constants.getMessage("labelUnassigned");
                break;
        }
        return val;
    },
    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
		var val = null;
		return val;
    }
});

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordSelectionTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
		this.actions = [];
		this.records = [];
		this.recordType = Constants.MODEL_TYPE_EWI;
		this._actionButtons = [];
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
    },
	
	initialize: function(){
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            // don't allow select all, we've paging content.
            allowSelectAll: false,
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: this.recordType == Constants.MODEL_TYPE_SUITE ? "TEST-SUITE-RECORD-SELECTION-TABLEVIEWER" : "TEST-EWI-RECORD-SELECTION-TABLEVIEWER"                                
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);

        tableViewer.setContent([]);
        this.pageSize = this.pageSize || TableConstants.MIN_PAGE_SIZE;
        this.pageIndex = 0;  
        this.queryToken = null;
        
		this.provider = new TestRecordSelectionTableView.TableProvider({
            recordType: this.recordType, 
            isVirtual: true,
            currentPageIndex: this.pageIndex,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize,
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.pageIndex = pageIndex;
                this.fetchContent();
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageIndex = 0;
				this.queryToken = null;
                this.fetchContent();
            })
            
        });	
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableListener(new TestRecordSelectionTableView.TableListener({parentView: this}));
        tableViewer.setCellModifier(new TestRecordSelectionTableView.CellModifier());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
		
		this.actions = this.getTableActions();
		var actionLen = (this.actions ? this.actions.length : 0);
		for (var i = 0; i < actionLen ; i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
            if (action.disabled && action.disabled == true)
                actionButton.setDisabled(true);
            if (action.hidden && action.hidden == true)
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
            this._actionButtons.push(actionButton);
        }
        
		tableViewer.showLoadingProgress();
        tableViewer.show();
		this.tableViewer = tableViewer;
		
        if(this.okButton){
		    this.okButton.disabled = true;
        }
        this.fetchContent();
	},
	
    fetchContent: function() {
        var responseHandler = new ServiceResponseHandler(this, "_loadContent", "_loadContentError");
        var args = {
            page: this.pageIndex,
            pageSize: this.pageSize
        }
		if(this.provider.getTextFilter())
			args.textSearch = this.provider.getTextFilter();
        if(this.queryToken) {
            args.queryToken = this.queryToken;
        }
        var sortArgs = this.provider.buildGroupSortServerArgs();
        if (sortArgs.length > 0) {
            args['sortColumns'] = sortArgs;
        }
        this.queryServiceCall(responseHandler, args);        
    },
    
    _loadContent: function(resultsDTO) {
        var wasNewQuery = (!this.queryToken);
        var provider = this.provider;
        
        this.queryToken = resultsDTO.queryToken;
        this.pageIndex = resultsDTO.currentPage;
        var results = this.records = resultsDTO.results;
        
        provider.totalPageCount = this.totalPages = resultsDTO.totalPages;
        provider.totalContentCount = this.totalSize = resultsDTO.totalSize;
		provider.currentPageIndex = this.pageIndex = resultsDTO.currentPage;
        this.tableViewer.endLoadingProgress();
        
        if (wasNewQuery && results) {
            this.tableViewer.setContent(results);
            this.tableViewer.refresh();
        }
        else {
            provider.loadPageContent(results);
        }
    },
    
	getTableActions: function(){
		var actions = [];
//      actions.push({
//                    actionId: "refresh",
//                    label: Constants.getMessage("labelChoseAdaptersAtRunTime"),
//                    actionHandler: dojo.hitch(this, "_handleChoseAdaptersAtRunTime"),
//                    iconClass: "add-icon-image",
//                    disabledOnReadOnly: true
//                });
//      actions.push({
//                    actionId: "edit",
//                    label: Constants.getMessage("labelEditAdapters"),
//                    actionHandler: dojo.hitch(this, "_handleEditAdapters"),
//                    iconClass: "edit-icon-image",
//                    disabled: true
//                });
		return actions;		
	},
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	getSelectedItems: function(){
		return this.tableViewer.getCheckedRows();
	},
	
	getRecordType: function(){
		return this.recordType;
	},

    _loadContentError: function(error) {
        if(!this.tableViewer || this.tableViewer.uninitialized){
            console.error(this.declaredClass + ": tableviewer not found");
            return;
        }
        this.tableViewer.endLoadingProgress();
        this.tableViewer.showContentError((error && error.message) ? error.message : null);     
    },
	
	_error: function(error){
		console.error("Error in TestRecordSelectionTableView "+ error.message);
	}
});
})();
