//TestRecordTableView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.core.loader");
/*
 * author: vasrivas
 */
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordSelectionTableView");
(function() {

var TableConstants 				= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;

dojo.declare("TestRecordTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(args) {
		dojo.mixin(this, args);
    },
    
   
  rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selection = tableViewer.getCheckedRows();
        var selectionCount = selection.length;
		var p = this.parentView;
		if(selectionCount > 0){
			p.removeActionNode.setDisabled(false);
			p.executeActionNode.setDisabled(false);
		}else{
			p.removeActionNode.setDisabled(true);
			p.executeActionNode.setDisabled(true);
		}
		//if table view has a rowCheckListener, invoke it
		
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener)) {
			p.rowCheckedListener(rowObject, state);
		}
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
     tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	// Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		this.parentView.tableHeaderColumnActionInvoked(columnIndex, actionId);  
    }  
});

dojo.declare("TestRecordTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 1) {
            if(dojo.isString(newValue)) {
                rowObject.testScriptName = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("TestRecordTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 7;
    },
    
    // Summary:
    //
    _columnHeadings: [
		"",
        Constants.getMessage("labelId"),
		Constants.getMessage("labelName"),
        Constants.getMessage("labelState"),
		Constants.getMessage("labelActualResult"),
		Constants.getMessage("labelOwner"),
		Constants.getMessage("labelModified")
    ],
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return false;     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
            case 1: 
                return 5;
            case 2: 
                return 20;
			case 3: 
                return 15;
			case 4: 
                return 15;
			case 5: 
                return 20;
			case 6: 
                return 20;				
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_test_record" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 2: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 4: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 6:
				type = TableConstants.RENDER_TYPE_DATE;
				break;			
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = "";
                break;
            case 1: 
                val = rowData.id; 
                break;
            case 2: 
                val = rowData.name;
                break;
			case 3: 
                val = Constants.getMessage(rowData.state);
                break;
            case 4: 
                val = rowData.currentResultStateGroupName; 
                break;
            case 5: 
                val = rowData.ownerName ? rowData.ownerName : Constants.getMessage("labelUnassigned");
                break;
			case 6: 
                var date = new Date();
                date.setTime(rowData.modified);
                val = date; //Last Modified
                break;		
        }
        return val;
    },
    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
		var val = null;
		if(atColumnIndex == 0) {
            val = {};
			val.image = ImageCache.TEST_SUITE;
//            val.href = Utility.getTestSuiteURI(rowData.id);
			val.tooltip = Constants.getMessage("labelClickToOpenTestSuite");				
        }else if(atColumnIndex == 1){
			val={};
//		 		val.href = Utility.getTestSuiteURI(rowData.id);
				val.linkType = Constants.getMessage("TestSuiteID");
				val.tooltip =""
		}else if(atColumnIndex == 2){
			val={};
//		 		val.href = Utility.getTestSuiteURI(rowData.id);
				val.tooltip="";
		}else if(atColumnIndex == 4){
			val = {};
			if(rowData.currentResultGroup){
				var inprogress = rowData.currentResultGroup && rowData.currentResultGroup.state.name == Constants.getMessage("labelInProgress") ? true : false;
//				if(inprogress)
//					val.href = Utility.runSuite({groupId: rowData.currentResultGroup.id});
//				else
//					val.href = Utility.showSuiteResult({id: rowData.currentResultGroup.id});
			}
		}   
		return val;
    }
    
});

dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
		this.actions = [];
		this.testRecords = [];
		this._actionButtons = [];
		this._itemsToTrack = {};
		this._itemsToTrack.recordTables = [];
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
    },
	
	initialize: function(){
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            showGroupFilterControls: false,
            tableId: "TEST-RECORDS-TABLEVIEWER"                                
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);

        var content = this.testRecords;

        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
		this.provider = new TestRecordTableView.TableProvider();	
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableListener(new TestRecordTableView.TableListener({parentView: this}));
        tableViewer.setCellModifier(new TestRecordTableView.CellModifier());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
		
		this.actions = this.getTableActions();
		var actionLen = (this.actions ? this.actions.length : 0);
		for (var i = 0; i < actionLen; i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
            if (action.disabled && action.disabled == true)
                actionButton.setDisabled(true);
            if (action.hidden && action.hidden == true)
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
			if(action.actionId == "execute"){
				this.executeActionNode = action;
			}
			if(action.actionId == "remove"){
				this.removeActionNode = actionButton;
			}
			if(action.actionId == "addsuite"){
				this.addSuiteActionNode = actionButton;
			}
			if(action.actionId == "addter"){
				this.addTERActionNode = actionButton;
			}
            this._actionButtons.push(actionButton);
        }
		
        tableViewer.show();
		this.tableViewer = tableViewer;
		jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", function f(){});
		jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", function f(){});
	},
	
	getTableActions: function(){
		var actions = [];
		actions.push({
                    actionId: "execute",
                    label: Constants.getMessage("labelExecute"),
                    actionHandler: dojo.hitch(this, "_handleExecute"),
                    iconClass: "execute-icon-image",
                    disabled: true
                });
		actions.push({
                    actionId: "addsuite",
                    label: Constants.getMessage("labelAddSuite"),
                    actionHandler: dojo.hitch(this, "_handleAddSuite"),
                    iconClass: "testsuite-icon-16",
                    disabledOnReadOnly: true
                });		
		actions.push({
                    actionId: "addter",
                    label: Constants.getMessage("labelAddTER"),
                    actionHandler: dojo.hitch(this, "_handleAddTER"),
                    iconClass: "ewi-icon-16",
                    disabledOnReadOnly: true
                });
		actions.push({
                    actionId: "refresh",
                    label: Constants.getMessage("labelRefresh"),
                    actionHandler: dojo.hitch(this, "_handleRefresh"),
                    iconClass: "refresh-icon-image"
                });
		actions.push({
                    actionId: "remove",
                    label: Constants.getMessage("labelRemove"),
                    actionHandler: dojo.hitch(this, "_handleRemove"),
                    iconClass: "delete-icon-image",
                    disabledOnReadOnly: true,
					disabled: true
                });
		return actions;		
	},
	
	_handleRemove: function(){
		var selectedItems = this.tableViewer.getCheckedRows();
		var content = this.getContent();
		if(selectedItems.length == 0){
			return;
		}
		var contentLength = content.length;
		var selectedItemsLength = selectedItems.length;
		for(var i=0;i<selectedItemsLength;i++){
			var updatedContent = [];
			for(var j=0;j<contentLength;j++){
				if(content[j].rowId == selectedItems[i].rowId){
					continue;
				}
				updatedContent.push(content[j]);
			}
			content = updatedContent;//swap updated content so that less traversal is needed.
		}
		this.mySection.setDirty(true);
		this.tableViewer.setContent(content);
		this.tableViewer.refresh();
		if(content.length ==0)
			this.disableAllActions();
	},
	
	_handleExecute: function(){
		
	},
	
	_handleAddSuite: function(){
		var content = this.tableViewer.getContent();
		if(content.length > 0){
			alert("Cannot add more than one test record");
		}else{
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", dojo.hitch(this, "_fetchSuites"));
		}
	},

	_handleAddTER: function(){
		var content = this.tableViewer.getContent();
		if(content.length > 0){
			alert("Cannot add more than one test record");
		}else{
			jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", dojo.hitch(this, "_fetchEWIs"));
		}
	},
	
	_fetchEWIs: function(){
		this.recordType = Constants.MODEL_TYPE_EWI;
		var responseHandler = new ServiceResponseHandler(this, "_createRecordSelectionTable", "_error");
		com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, {});
	},
	
	_fetchSuites: function(){
		this.recordType = Constants.MODEL_TYPE_SUITE;
		var responseHandler = new ServiceResponseHandler(this, "_createRecordSelectionTable", "_error");
		com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteSummaryDTOs(responseHandler, {});
	},
	
	_createRecordSelectionTable: function(records){
		var args = {
			recordType: this.recordType,
			records: records
		}
		this.recordTable = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestRecordSelectionTableView(args);
		this.recordTable.initialize();
		this._itemsToTrack.recordTables.push(this.recordTable);
		var dialogArgs = {
			okCallback: dojo.hitch(this, "_updateTable"),
			width: "80%",
			height: "80%",
			primaryTitle: Constants.getMessage("labelSelectTestRecord")
		}
		var dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
		dialog.contentContainer.appendChild(this.recordTable.domNode);
        dialog.getOkButton().disabled = false;    
		dialog.open(); 
	},
	
	_updateTable: function(){
		var items = this.recordTable.getSelectedItems();
		var type = this.recordTable.getRecordType();
		if(items.length == 1){
			this.tableViewer.setContent(items);
			this.tableViewer.refresh();
			this.mySection.testRecordAdded(items[0], type);
		}
	},
	
	_handleRefresh: function(){
		
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	disableAllActions: function(){
		var actions = this.tableViewer.getActionButtons();
		for(var action in actions){
			if(actions[action].actionId != "add")
				actions[action].setDisabled(true);
		}
	},
	
	uninitialize: function(){
			//Destroy the tables internal to this widget 
			var recordTableLength = this._itemsToTrack.recordTables.length;
			var recTables = this._itemsToTrack.recordTables;
			for(var i=0;i<recordTableLength;i++){
				recTables[i].destroy();
				console.debug("TestRecordTableView removing internal RecordTables");
			}
		},
	
	_error: function(error){
		console.error("Error in TestRecordTableView "+ error.message);
	}
});
})();
