/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");

(function() {

var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     			= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        			= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      			= com.ibm.rqm.planning.web.client.internal.Constants;
var ConfigurationUriUtil 	= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;

dojo.declare("TestSuiteInternalResultTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        //alert("Row check state changed: " + rowObject.col1);        
    }
});

dojo.declare("TestSuiteInternalResultTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        alert("cell value changed on object: " + rowObject.col1 + ", new Value: " + newValue);
        
        // store the new values in our internal data model
        if(columnIndex == 6) {
            if(dojo.isString(newValue)) {
                rowObject.selection = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
		//handle delete action
		if (columnIndex == 6) {
		   //alert("delete clicked for TestCase: " + rowObject.id);
		}
    }
});

dojo.declare("TestSuiteInternalResultTableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = Constants.getMessage("labelAddCustCrtl");
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("TestSuiteInternalResultTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content){
        return 7;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings = [
			Constants.getMessage("labelId"),
			Constants.getMessage("labelTestCase"),
            Constants.getMessage("labelConfig"),
            Constants.getMessage("labelTestScript"),
			Constants.getMessage("labelHostname"),
			Constants.getMessage("labelWeight"),
			Constants.getMessage("labelOverallVerdict")
        ];
        return headings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
		  /*
        if(atColumnIndex == 5) {
            return ImageCache.REMOVE_ENABLED;
        }
        */		  
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return false;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
            case 1: 
                return 20;
            case 2: 
                return 20;
            case 3: 
                return 20;
            case 4: 
                return 15;
            case 5: 
                return 10;	
            case 6: 
                return 10; 					 				
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_row_for_suite_internal_result_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_LINK;

        switch(atColumnIndex) {
            case 2: 
                type = rowData.configName ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
                break;
            case 4: 
                type = TableConstants.RENDER_TYPE_TEXT;
                break;
			case 5: 
                type = TableConstants.RENDER_TYPE_TEXT;
                break;					 			 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.id;
                break;
            case 1: 
                val = rowData.testCase.name;
                break;
            case 2: 
                val = rowData.configName ? rowData.configName : Constants.getMessage("labelUnassigned"); 
                break;
            case 3: 
                val = rowData.script? rowData.script.name:""; //TestScript Name
                break;
            case 4: 
                val = rowData.machine
                break;          
            case 5: 
                val = rowData.weight;
                break;  
            case 6: 
                val = rowData.state ? rowData.state.name : Constants.getMessage("labelUnknown");
                break; 
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
	  	if(atColumnIndex == 0) {
            val = {};
            val.href = Utility.getResultURI({ewiId: rowData.ewiId, resultItemId: rowData.itemId});				
        }
	  	else if(atColumnIndex == 1) {
            val = {};
            val.href = Utility.getTestCaseURI(rowData.testCase.id);				
        }
		else if(atColumnIndex == 2) {
            val = {};//Configuration
            if(rowData.configId)
            	val['href'] = ConfigurationUriUtil.getEditConfigurationURI(rowData.configId);
        }
        else if (atColumnIndex == 3 && rowData.script) {
           	val = {};
			if (rowData.script && rowData.script.snapshotInfo) {
				val.href = Utility.getTestScriptURI(rowData.script.versionableItemId, null, 
							rowData.script.snapshotInfo.revision, rowData.script.snapshotInfo.name);
			} else {
				val.href = Utility.getTestScriptURI(rowData.script.id, Utility.CONSTRUCTION_PERSPECTIVE);
			}
        }
		else if (atColumnIndex == 6) {
        	val = {};
			val.href = Utility.getResultURI({ewiId: rowData.ewiId, resultItemId: rowData.itemId});
        }	  
        return val;
    }
    
    
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
	                 '   <div>' +
						  '      <span style="display: none;" dojoAttachPoint="_queryTitle" class="query-title">${labelCurrentQuery}</span>' +
						  '      <span style="display: none;" dojoAttachPoint="_queryName" class="query-name"></span>' +
						  '   </div>' +
						  '</div>',

    widgetsInTemplate: true,
	labelCurrentQuery: Constants.getMessage("labelCurrentQuery"),

    constructor: function() {
	 	this.results = [];
	 },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();        
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.results ? this.results : [];

        tableViewer.setContent(content);
		tableViewer.setShowingFilterControl(false);
		tableViewer.setShowingPagingControl(false);
		tableViewer.setShowingPagingRangeControl(false);
        tableViewer.setContentProvider(new TestSuiteInternalResultTableView.TableProvider());
        tableViewer.setTableListener(new TestSuiteInternalResultTableView.TableListener());
        tableViewer.setCellModifier(new TestSuiteInternalResultTableView.CellModifier());
        tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestSuiteResultExecution")));
		
		dojo.style(tableViewer.controlAreaNode, "display", "none");
		tableViewer.show();
		  
		  this.tableViewer = tableViewer;
    },
	
	refresh: function(results){
		this.results = results ? results : [];
		this.tableViewer.setContent(this.results)
		this.tableViewer.refresh();
	},
	
	updateItem: function(resultItemId, args, refreshTable){
		var content = this.tableViewer.getContent()
		for (var i = 0; i < content.length; i++) {
			var cont = content[i];
        	if (cont.itemId == resultItemId) {
        		cont.configName = args.configName;
				cont.configId = args.configId;
				cont.ewiId = args.ewiId;
				cont.weight = args.weight;
				break;
        	}
        }
		this.tableViewer.setContent(content);
        if(refreshTable)
			this.tableViewer.refresh();
	}
	
});

})();
