/******************TestSuiteTableView**********************/
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2011. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressStatusMonitor");

dojo.require("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.CategoryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.BulkChangeAction");

(function() {
	
var DuplicateAction = com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants 				= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        				= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var GlobalEvents   				= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var TestExecutionSuiteClient 	= com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient;
var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
var Constants_getMessage        = Constants.getMessage;
var TESMapper					= com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper;
var EditorUtil 					= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var ViewHeaderLayout 			= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AbstractFilteredExePagingTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionPagingTableView;
var TableContentFilterProvider  = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var PermissionsClient           = com.ibm.asq.common.web.client.internal.PermissionsClient;
var CategoryMapper				= com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper;
var CategoryClient				= com.ibm.rqm.planning.web.client.internal.CategoryClient;
var CategoryUtil   				= com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil;
var ActionEntityType 			= com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType;
var ExecutionUtil               = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ActionPackage               = com.ibm.rqm.planning.web.ui.internal.model.action;
var ProgressUtility             = com.ibm.asq.common.web.ui.internal.widgets.progressStatus.ProgressUtility;

dojo.declare("TestSuiteTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{        
	constructor: function(parentView) {
        this.parentView = parentView;
    },
	
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selectionCount = tableViewer.getCheckedRows().length;
        var parentView=this.parentView;
        if (parentView.deleteActionNode)
            parentView.deleteActionNode.setDisabled(selectionCount == 0);
	    if (this.parentView.duplicateActionNode){
			this.parentView.duplicateActionNode.setDisabled(selectionCount == 0);
		}
		if (parentView.executeActionNode)
            parentView.executeActionNode.setDisabled(selectionCount != 1);	
		
		if (parentView.bulkchangeActionNode)
            parentView.bulkchangeActionNode.setDisabled(selectionCount == 0);
		
		if(!parentView.suites || !parentView.suites.length){
			parentView.hideAction("printpdfcarmenu");
			parentView.hideAction("printpdfmultiplemenu");
			parentView.showAction("printpdfsummarymenu");
			parentView.disableAction("printpdfsummarymenu");			
		} else if (selectionCount == 0) {					
			parentView.hideAction("printpdfcarmenu");
			parentView.hideAction("printpdfmultiplemenu");
			parentView.enableAction("printpdfsummarymenu");
			parentView.showAction("printpdfsummarymenu");
		} else if (selectionCount > 1) {
			parentView.hideAction("printpdfcarmenu");
			parentView.hideAction("printpdfsummarymenu");
			parentView.enableAction("printpdfmultiplemenu");
			parentView.showAction("printpdfmultiplemenu");
		} else if (selectionCount == 1) {	
			parentView.hideAction("printpdfsummarymenu");
			parentView.hideAction("printpdfmultiplemenu");
			parentView.enableAction("printpdfcarmenu");
			parentView.showAction("printpdfcarmenu");
		}			
    },
    
	// Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
	// Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
         if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },
	
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },	

	tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
        this.parentView.headerActionInvoked(columnIndex, actionId);  
    } 	    
});

dojo.declare("TestSuiteTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    
    constructor: function(args) {
        dojo.mixin(this, args);
    },
    
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
    },
    
    cellActionInvoked: function(rowObject, columnIndex){
	}
});

dojo.declare("TestSuiteTableView.TableProvider",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);
		this.categoryTypeMap = {};
        if (!this.categoryTypes || !dojo.isArray(this.categoryTypes)) {
            throw new Error("Parameter 'categoryTypes' is REQUIRED!");
        }
		
        this.COLUMNS = {
            TYPE: this.toColumn("", 2, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_IMAGE, 'type', true),
            ID: this.toColumn(Constants.getMessage("labelId"), 10, false, TableConstants.ALIGN_CENTER, this.tableViewer.isInPicker? TableConstants.RENDER_TYPE_TEXT : TableConstants.RENDER_TYPE_LINK, 'id', true),
            NAME: this.toColumn(Constants.getMessage("labelName"), 14, true, TableConstants.ALIGN_LEFT, this.tableViewer.isInPicker? TableConstants.RENDER_TYPE_TEXT : TableConstants.RENDER_TYPE_LINK, 'name', true),
            STATE: this.toColumn(Constants.getMessage("labelState"), 9, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'state', true),
            STATUS: this.toColumn(Constants.getMessage("labelStatus"), 9, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_LINK, 'status', true, "statusIds"),
			OWNER: this.toColumn(Constants.getMessage("labelOwner"), 10, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'owner', true, "ownerUUIDs"),
			MODIFIED: this.toColumn(Constants.getMessage("labelModified"), 10, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_DATE, 'modified', true)
        }      
        this.COLUMNS.ALL = [this.COLUMNS.TYPE, this.COLUMNS.ID,this.COLUMNS.NAME, this.COLUMNS.STATE, this.COLUMNS.STATUS, this.COLUMNS.OWNER];
        
        var numCategories = this.categoryTypes.length;
        for (var i = 0; i < numCategories; i++) {
            var t = this.categoryTypes[i];
			if (!t.archived) {
				this.categoryTypeMap[t.itemId] = t;
				var width = (36 / numCategories);
                var name = Constants.getMessage(t.name); // out of the box category name has translated value.
				this.COLUMNS[t.itemId] = this.toColumn(name, width, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, null, true, t.name);
				this.COLUMNS[t.itemId].typeItemId = t.itemId;
				this.COLUMNS.ALL.push(this.COLUMNS[t.itemId]);
			}
        }
        
        this.COLUMNS.ALL = this.COLUMNS.ALL.concat([this.COLUMNS.MODIFIED]);
    },
	
    toColumn: function(name, width, groupable, alignment, type, rowName, isVisible, dbName) {
        return {
            name: name,
            width: width,
            groupable: groupable,
            alignment: alignment,
            type: type,
			rowName: rowName,
			isVisible: isVisible,
            
            dbName: dbName || rowName
        }
    },  
	    
    getNumColumns: function(content){
        return this.COLUMNS.ALL.length;
    },

    getColumnIndex: function(name) {
         var profile = this.COLUMNS.ALL;
        
        for (var i = 0; i < profile.length; i++) {
            if (profile[i].name == name) {
                return i;
            }
        }
        return -1;
    },

    getColumnIdName: function(index)
    {
        var profile = this.COLUMNS.ALL;
        return profile[index].dbName;
    },
	
	getColumnHeading: function(content, index){
         return this.COLUMNS.ALL[index].name;
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
		if (this.enableRowEditable) {
			if (atColumnIndex >= 6 && atColumnIndex <= this.getNumColumns() - 2) {
				return {
					actionId: this.COLUMNS.ALL[atColumnIndex].name,
					tooltip: Constants.getMessage("labelChangeProperties", this.COLUMNS.ALL[atColumnIndex].name),
					src: ImageCache.BULK_CHANGE
				};
			}
			var columnName = this.COLUMNS.ALL[atColumnIndex].name;
			if (columnName == Constants_getMessage("labelOwner")) {
				return {
					actionId: columnName,
					tooltip: Constants_getMessage("labelChangeProperties", columnName),
					src: ImageCache.BULK_CHANGE
				};
			}
			
		}
		return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].alignment;
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
		return this.COLUMNS.ALL[atColumnIndex].groupable;
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
		return (this.COLUMNS.ALL[atColumnIndex].name != this.COLUMNS.TYPE.name);   
    },
    
	getIsColumnVisible: function(atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].isVisible;
    },

	getColumnWidth: function(content, atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].width;
    },    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
		return this.COLUMNS.ALL[atColumnIndex].type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
		return this.COLUMNS.ALL[atColumnIndex].alignment;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
		var column = this.COLUMNS.ALL[atColumnIndex];
        switch(column.name) {
            case this.COLUMNS.TYPE.name: 
                val = ""
                break;
            case this.COLUMNS.ID.name: 
                val = rowData.id
                break;          
            case this.COLUMNS.NAME.name: 
				val = rowData.name
				break;
			case this.COLUMNS.STATE.name:
				val = rowData.state ? EditorUtil.getStateNameFromID(rowData.state) : "" ;
                break;
			case this.COLUMNS.STATUS.name: 
                val = rowData.currentResultGroup ? (rowData.currentResultGroup.state ? rowData.currentResultGroup.state.name : Constants_getMessage("labelInProgress")) : Constants_getMessage("labelNotRun");
                break;
			case this.COLUMNS.OWNER.name: 
                val = rowData.owner ? rowData.owner.name : "";
                break;  
			case this.COLUMNS.MODIFIED.name:
				val = new Date();
                val.setTime(rowData.modified);
                break;
			default:
                val = this.getCategoryByType(rowData, column.typeItemId) || "";
                break;				
        }
        return val;
    },
	
	getCellRawData: function(rowData, atColumnIndex)
    {
		var rowName = this.COLUMNS.ALL[atColumnIndex].rowName;
        
        // use the modified value directly for sorting/grouping.
		if(rowName == this.COLUMNS.MODIFIED.name) {
            return rowData[rowName] || "";
        }
        // need to use the display value for sorting/grouping.
        return this.getCellDisplayData(rowData, atColumnIndex);
    },

	getCategoryByType: function(suite, typeItemId) {
        if (suite && suite.categories) {
            for (var i = 0; i < suite.categories.length; i++) {
                if (suite.categories[i].categoryType.itemId == typeItemId) {
                    //return plan.categories[i].name;
					return this.getCategoryName(suite.categories[i]);
                }
            }
        }
		return Constants.getMessage("labelUnassigned");
    },
	
	getCategoryName: function(category) {
		var type = this.categoryTypeMap[category.categoryType.itemId];
		for (var i = 0; i < (type.categories ? type.categories.length : 0); i++) {
			if (type.categories[i].itemId == category.itemId) {
				return type.categories[i].name;
			}
		}
		return Constants.getMessage("labelUnassigned");
	},
	
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
		var currentResult = rowData.currentResult;
		var colName = this.COLUMNS.ALL[atColumnIndex].name;
		if(colName == this.COLUMNS.TYPE.name) {
            val = {};
			val.image = ImageCache.TEST_SUITE;
            val.href = Utility.getTestSuiteURI(rowData.id);
			val.tooltip = Constants_getMessage("labelClickToOpenTestSuite");				
        }else if(colName == this.COLUMNS.ID.name){
			val={};
	 		val.href = Utility.getTestSuiteURI(rowData.id);
			val.linkType = Constants_getMessage("TestSuiteID");
			val.tooltip =""
		}else if(colName == this.COLUMNS.NAME.name){
			val={};
	 		val.href = Utility.getTestSuiteURI(rowData.id);
			val.tooltip="";
		}else if(colName == this.COLUMNS.STATUS.name){
			val = {};
			if(rowData.currentResultGroup){
				var inprogress = rowData.currentResultGroup && rowData.currentResultGroup.state.name == Constants_getMessage("labelInProgress") ? true : false;
				if(inprogress)
					val.href = Utility.runSuite({groupId: rowData.currentResultGroup.id});
				else
					val.href = Utility.showSuiteResult({id: rowData.currentResultGroup.id});
			}
		}   
        return val;
    }
});

dojo.declare("TestSuiteTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine, addSnapshotsFilter) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);		
        this.addSnapshotsFilter = addSnapshotsFilter;

        // define the static filters
        this.filters = [];
        this.filters.push(
        {
            name: "myItemsOnly",  // must match key in the arg list of the API
            title: Constants_getMessage("labelOnlyMyTestSuites"),
            promptTitle: Constants_getMessage("labelOnlyMyTestSuites"),
            type: TableContentFilterProvider.FIELD_CHECKBOX,
            defaultValue: this.defaultToMine, params: null
        });
        if (this.addSnapshotsFilter == true) {
            this.filters.push({
                name: "includeSnapshots",  // must match key in the arg list of the API
                title: Constants_getMessage("labelIncludeSnapshots"),
                promptTitle: Constants_getMessage("labelIncludeSnapshots"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: false, params: null               
            });
        }           
        this.filters.push({
            name: "name",  // must match key in the arg list of the API
            title: Constants_getMessage("labelname"),
            promptTitle: Constants_getMessage("labelName"),
            type: TableContentFilterProvider.FIELD_TEXT,
            defaultValue: null, 
            params: null
        });
    },

    getFilterIdName: function(index)
    {
        var filter = this.filters[index];
        return filter.dbName || filter.name;        
    },

    getTitle: function() {
        return Constants_getMessage("labelFilterTitle");    
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getSummaryText: function() {
        return Constants_getMessage("labelFilterDescriptionAllVisible", Constants_getMessage("labelTestSuites"));
    },
    
    getInitialVisibleFilterCount: function() {
        return 5;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return this.filters[index].params;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants_getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants_getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        
        var allCategories = [];
        var args = {};
        
        for (var nameKey in filters) {
            // iterate through the filters and skip those that are not specified
            if (filters[nameKey] != null) {
                if (nameKey.indexOf("categories") == 0) {
                    // filter name has "categories" prefix, flatten all selected categories into a single array
                    allCategories.push(filters[nameKey].join(","));
                } else {
                    args[nameKey] = filters[nameKey] || "";
                    if(args[nameKey] == 'Any@@')
                        args[nameKey] = '';
                }
            }
        }
		// add the flattened categories array to the args if there is any defined
            if (allCategories.length > 0) {
                args["categories"] = allCategories;
            }
        this.tableView.runQuery(args);
    }
});


dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExePagingTableView],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" isCompact="true" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_queryTableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
					'  <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" ></div>' +
				    '</div>',

    editable: true,
    widgetsInTemplate: true,
    pdfPrintType: "testsuite",  // define the pdf print type. Our super class will handle it.

    constructor: function() {
        this.actions = [];
        this._actionButtons = [];
	 	this.suites = [];
		this.queryName = null;
		this.executable = false;
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
        this.filterArgs = null;
        this.initOpenFilter = false;
        this.allowQuerySnapshots = false;		
	 },

    postCreate: function() {
		this.inherited("postCreate", arguments);
		EditorUtil.loadStateTransitionConstraintSettings();  //Load the prefs in case we attempt actions that require checking (like execute)
		
        this.isQueryPage = this.queryName;

        // hook in the method to obtain all results' item ids.
        this._getAllResultsItemIds = dojo.hitch(TestExecutionSuiteClient, "getAllSearchResultItemIds");
        // apply the user preference whether to initially open the filter area
        if (this.showQueryFilters) {
			//init options for running search
	        this.setSearchFunction(dojo.hitch(TestExecutionSuiteClient, "searchTestSuites"));
	        this.setSearchCallback(dojo.hitch(this, "show"));
			this.setResponseHandlerType(TESMapper);
	        this.setTypeLabel(this.queryName);
	        if (this.postQueryFilterCallback) {
	            this.setSearchFilterCallback(this.postQueryFilterCallback);
	        }	
	        this._projectAlias = com.ibm.asq.common.web.ui.internal.util.Utility.getCurrentProjectAreaAlias();	
        }
    	//get the category types - required to show the table properly and for the filters
		var responseHandler = new ServiceResponseHandler(this, "_initialize", "_error");
		// include archived if showing filter
    	CategoryClient.getCategoryTypes(responseHandler, Constants.MODEL_TYPE_SUITE, this.showQueryFilters);
         
	},
	
    _initialize: function(categoryTypes){
    	
		this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
        if (this.showQueryFilters) {
			setTimeout(dojo.hitch(this,function(){
				this._initializeFilters(categoryTypes);
			}),0);
		}
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            tableId: (this.isQueryPage) ? "RQM-TS-QUERY-TABLEVIWER" : "RQM-TS-TABLEVIWER",
            allowAdjustSettings: true,
            allowMultiSort: true,
            handleVirtualSelectAll: true,
            autoSaveSettings: true            
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);
		
        // initFilterProvider uses the table's id to index
        // into the per-session saved filters. Need to setup
        // this attribute to properly obtain the saved filters.
        this.tableViewer = tableViewer; 
        var content = this.suites ? this.suites : [];

        if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
			this.viewHeaderNode.setCSHelpId("rqm_view_test_suites.html"); 
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelAllTestSuite")+" "+Constants.getMessage("labelHelp"));
			dojox.data.dom.removeChildren(this._queryTableViewerNode);
            this._queryTableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
			dojox.data.dom.removeChildren(this._tableViewerNode);
            this._tableViewerNode.appendChild(tableViewer.domNode);
        }		  

        tableViewer.setContent(content);
        
        this.provider = this._constructTableContentProvider();
        tableViewer.setContentProvider(this.provider);
		tableViewer.setTableSummary(Constants_getMessage("labelTableSummary", this.queryName ? this.queryName: Constants_getMessage("labelTestSuites")));
		
		var tableListener = new TestSuiteTableView.TableListener(this);
		if (this.executable && this.rowCheckListener) {
           tableListener.setRowCheckListener(this.rowCheckListener);
		}        
		tableViewer.setTableListener(tableListener);
        tableViewer.setCellModifier(new TestSuiteTableView.CellModifier());
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
           
		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
        	tableViewer.addAction("refresh", Constants_getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
		var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);
        
        var cat_permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_CATEGORY);
        if (!cat_permission || cat_permission[PermissionsClient.ACTION_EDIT]) {
            //add action for managing categories
            this.configureActionNode = tableViewer.addAction("configure", // action id
                Constants.getMessage("labelManageCategories", Constants.TYPE_SUITE), // label
                null, // callback data
                "categories-icon-image", // icon class
                dojo.hitch(this, "_handleCategoriesClick") // callback
            );
        }

		var length=(this.actions ? this.actions.length : 0);		   
        for (var i = 0; i < length; i++) {
            var action = this.actions[i];
			var actionButton;
			if (action.label == Constants_getMessage("labelChangeTestSuiteProperties")) {
				this.bulkchangeActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
				this.bulkchangeActionNode.setDisabled(true);
				actionButton = this.bulkchangeActionNode;
			}
			else {
				actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
			}
			
            if (action.disabled && action.disabled == true) {
                actionButton.setDisabled(true);
            }
            if (action.hidden && action.hidden == true) {
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
            }
            this._actionButtons.push(actionButton);
        }
		
		if (this.isQueryPage) {
            var type = PermissionsClient.OP_TEST_SUITE_EXE;
            var perm = PermissionsClient.getStoredPermission(type);
            
            if (!perm || perm.execute) {
                this.executeActionNode = tableViewer.addAction("execute", // action id
                    Constants_getMessage("labelExecute"), // label
                    null, // callback data
                    "execute-icon-image", // icon class
                    dojo.hitch(this, "_onExecuteActionClick")); // callback
                this.executeActionNode.setDisabled(true);
            }
        }
		
		if (this.isQueryPage) {
            var ts_type = PermissionsClient.OP_TEST_SUITE;
            var perm = PermissionsClient.getStoredPermission(ts_type);
            
            if (!perm || perm.archive) {
                this.deleteActionNode = tableViewer.addAction("delete", // action id
                    Constants_getMessage("labelDelete"), // label
                    null, // callback data
                    "delete-icon-image", // icon class
                    dojo.hitch(this, "invokeAction", "itemId", this, "_onDeleteActionClick")); // callback
                this.deleteActionNode.setDisabled(true);
            }
    		this.duplicateActionNode = tableViewer.addAction(
    	        		"duplicate",
            			Constants.getMessage("labelDuplicateAction"),
    	        		null,
            			"duplicate-icon-image",
            			dojo.hitch(this, "invokeAction", "id", this, "_onDuplicateActionClick"));
          	this.duplicateActionNode.setDisabled(true);
			var duplicateAction = new  DuplicateAction();
			duplicateAction.isDuplicateAllowed(ActionEntityType.TEST_SUITE, dojo.hitch(this, "_isDuplicateAllowedCallback"));
			
			//******print button content******
    		var printCARMenu = new dijit.Menu({ style: "display: none;"});
    		var printSummaryMenu = new dijit.Menu({ style: "display: none;"});
    		var printMultipleMenu = new dijit.Menu({ style: "display: none;"});
    		
            var normalOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelCAR"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
            });
            var summaryOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelSummary"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick", /*print type*/ "list-table-print")
            });        
            var multipleOption = new dijit.MenuItem({
            	label: Constants.getMessage("printLabelMultiple"),
            	onClick: dojo.hitch(this, "_onPrintPdfActionClick")
            });
    		
            printCARMenu.addChild(normalOption);
            printSummaryMenu.addChild(summaryOption);
            printMultipleMenu.addChild(multipleOption);
            
           	this.printSummaryActionNode = tableViewer.addAction(
           			"printpdfsummarymenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintPdfActionClick", /*print type*/ "list-table-print"),
           			printSummaryMenu
           	);      	
           	this._actionButtons.push(this.printSummaryActionNode);
           	this.enableAction("printpdfsummarymenu");
           	
           	this.printCARActionNode = tableViewer.addAction(
           			"printpdfcarmenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintPdfActionClick", /*printType*/ "history-print"),
           			printCARMenu
           	);
           	this._actionButtons.push(this.printCARActionNode);
           	this.hideAction("printpdfcarmenu");
           	
           	this.printMultipleActionNode = tableViewer.addAction(
           			"printpdfmultiplemenu",
           			Constants.getMessage("labelPDFView"),
           			null,
           			"pdf-icon-image",
           			dojo.hitch(this, "_onPrintPdfActionClick"),
           			printMultipleMenu
           	);
           	this._actionButtons.push(this.printMultipleActionNode);
           	this.hideAction("printpdfmultiplemenu");
            //******end print button content******
        }
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
		tableViewer.setEditable(this.editable);
		
		//if preference specifies, run the query
		
    },
	_initialize2:function(categoryTypes){
		this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
		if (this.showQueryFilters) {
			//Add the category filters to the end if there is any
	        for (var j = 0; j < this.allCategoryFilters.length; j++) {
	            this.filterProvider.filters.push(this.allCategoryFilters[j]);
	        }
			this.initFilterProvider(this.filterProvider);
			this.initRunQuery();
			this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
		}
	},
    _constructTableContentProvider: function() {
        //create the table provider
        return new TestSuiteTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            categoryTypes: this.categoryTypes,
            enableRowEditable: (this.enableRowEditable ? this.enableRowEditable : false),
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            
            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });     
    },
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function(categoryTypes) {
        // create the filter provider for the table
        this.filterProvider = new TestSuiteTableView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine(), this.allowQuerySnapshots);

		//Initialize filters for Categories
		this.allCategoryFilters = CategoryUtil.getCategoryTypesFilters(categoryTypes);
		
        //callback: initialize the orginator/owner contributor filters       
        var ownerFilter = {           
            //filterName, filterLabel, filterPrompt, filterType, callback
            name: "ownerUUIDs",
            label: Constants_getMessage("labelOwner"),
            prompt: Constants_getMessage("labelOwner"),
            type:TableContentFilterProvider.FIELD_TOGGLELIST
        }

        var originatorFilter = {           
            //filterName, filterLabel, filterPrompt, filterType, callback
            name: "originatorUUIDs",
            label: Constants_getMessage("labeloriginatorLabel"),
            prompt: Constants_getMessage("labelOriginator"),
            type:TableContentFilterProvider.FIELD_TOGGLELIST
        }		

         var callback = dojo.hitch(this, function() {
            this.addContributorFilter(originatorFilter, this.filterProvider.filters, dojo.hitch(this, "_addExecutionStateFilter", categoryTypes));
			
        });
		
        this.addContributorFilter(ownerFilter, this.filterProvider.filters, callback);
		this.moreFilters = [];
		
		//add state filter
        this.addArtifactStateFilter(this.moreFilters);  
		
        // add the id filter
        this.moreFilters.push({
            name: "id", // must match key in the arg list of the API
            title: Constants.getMessage("labelId") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelId"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: null
        });
        // add the modified time filter
        var dateTimeFilter = {
            processFilter: true, // parent class handle processing the to and from date time params
            name: "modified",    // must match what the filter provider looks for
            fromKey: "modifiedFrom",
            toKey: "modifiedTo",
            label: Constants.getMessage("labelModified") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelModified")
        };
        this.addDateTimeRangeFilter(dateTimeFilter, this.moreFilters);

		var moreFilters=this.moreFilters;
		var length=moreFilters.length;
		var filters=this.filterProvider.filters;
        for (var i = 0; i < length; i++) {
            filters.push(moreFilters[i]);
        }		
    },	
 
    _addExecutionStateFilter: function(categoryTypes) {
        // add the execution result states filter
        var providerFilters = this.filterProvider.filters;
        var resultStateFilter = {
            name: "statusIds", // must match key in the arg list of the API
            label: Constants.getMessage("labelStatus") + Constants.getMessage("labelColen"),
            prompt: Constants.getMessage("labelStatus"),
            type: TableContentFilterProvider.FIELD_TOGGLELIST
        };
        this.addExecutionStateFilter(resultStateFilter, providerFilters, dojo.hitch(this, "_initialize2", categoryTypes));
    },

	 // API
    getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },

	getTableContent: function() {
        return this.tableViewer.getContent();
    },
	
    getAction: function(actionId) {
    	var actions=this.actions;
    	var length=(actions ? actions.length : 0);
        for (var i = 0; i < length; i++) {
            if (actions[i].actionId == actionId) {
                return actions[i];
            }
        }        
    },
    
    getActionButton: function(actionId){
    	var actionButtons=this._actionButtons;
		var length=(actionButtons ? actionButtons.length : 0);
        for (var i = 0; i < length; i++) {
        	var actionButton=actionButtons[i];
            if (actionButton.actionId == actionId) {
                return actionButton;
            }
        }        
    },
    
    hideAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
            dojo.addClass(button.domNode, "dijitDisplayNone");
        } 
    },
    
    showAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
            dojo.removeClass(button.domNode, "dijitDisplayNone");
        } 
    },
	
	disableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(true);
          } 
    },
	
	enableAction: function(actionId) {
          var button = this.getActionButton(actionId);
          if (button ) {
              button.setDisabled(false);
          } 
    },    
        
    appendItem: function(item) {
    	var content = this.tableViewer.getContent();
        content.push(item);
        this.tableViewer.setContent(content);
		this.suites = this.tableViewer.getContent()
        this.tableViewer.refresh();
    },
	
	refresh: function(content){
        if(this.showInitLoadProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }

        this.suites = content;
        
        // we are only updating the virtual content. The virtual
        // content provider has convenient method to do that. Call
        // it to load the virtual content. Updating a virtual page
        // is much less 'destructive' then a regular table refresh.
        // It retains the row selection states.
        if (this.updatePageOnly) {
            this.provider.loadPageContent(content);
        }
        else {
            this.tableViewer.setContent(content);
            this.tableViewer.refresh();
        }
		 var listener = this.tableViewer.getTableListener();
		 if(listener)
			listener.rowCheckStateChanged(this.tableViewer);
		
	},
	
	show: function(content, skipClearStatus) {
		
		this.suites = content || [];

        // we are only updating the server side pages, don't have 
        // to refetch the category...
        if(this.updatePageOnly) {
            this.refresh(content, skipClearStatus);
            this.updatePageOnly = false;
            return;
        }
        
        //reset CategoryTypes
		var self = this;
		var handler = {
            success: function(categoryTypes) {
                //reset TableViewer first
                self.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
                var cancelProgress = self.showInitLoadProgress;
                // we don't create the table until we fetched the categories.
                // The table may not have existed at this point. The real data
                // has arrived. Always reset the init load progress flag. 
                if (self.showInitLoadProgress) {
                    self.showInitLoadProgress = false;
                }
                if (self.tableViewer) {
                    if (cancelProgress) {
                        self.tableViewer.endLoadingProgress();
                    }
					self._reContructTable(categoryTypes, content);
                }
                if (self.viewHeaderNode && !skipClearStatus) {
                    self.viewHeaderNode.clearStatus();
                }
                
                //reset viewBuilder?
                if (self.showQueryFilters) {
                    var newCategoryFilters = CategoryUtil.getCategoryTypesFilters(self.categoryTypes);
                    if (!CategoryUtil.isCategoryFiltersSame(newCategoryFilters, self.allCategoryFilters)) {
                        //category filters are changed, user have the choice to reset viewbuilder or not
                        self._confirmResetViewBuilder(newCategoryFilters);
                    }

                    if (self.queryFiltersCallback) {
                        self.queryFiltersCallback();
                    }
                }
            },
            error: function(e) {
                self._error(e);
            }
        }
		var responseHandler = new CategoryMapper(handler, "success", "error");
        CategoryClient.getCategoryTypeSummaries(responseHandler, Constants.MODEL_TYPE_SUITE);		
	},	
	_onExecuteActionClick: function(){
		//See if we need to validate that all Test Cases are approved before we run
		var suites = this.getSelectedItems();
		if(suites && suites.length == 1){
			if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)){
				//need to validate that all Test Cases are approved
				var suite = suites[0];
				var testCases = suite.elements;
				var badTestCaseString = "";
				if (testCases && testCases.length > 0){
					for (var i = 0; i < testCases.length; i++){
						var tc = testCases[i];
						var state = tc.workitem.testCase.state;
						if (state != Constants.STATETRANSITION_STATE_APPROVED) 
							badTestCaseString += " " + tc.workitem.testCase.name;
					}
				}
				if (badTestCaseString != ""){  //Found and offending test case so display a message and return
					var errorStr = Constants_getMessage("msgCannotExecuteSuiteTestCaseNotApproved", badTestCaseString);
					this.viewHeaderNode.setStatus(Constants_getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
					return;
				}else{
					//check for approved test suite.
					var suite = suites[0];
					if (!suite.state || suite.state != Constants.STATETRANSITION_STATE_APPROVED){
						var errorStr = Constants_getMessage("msgCannotExecuteTestSuiteNotApproved", suite.name);
						this.viewHeaderNode.setStatus(Constants_getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
						return;
					}
				}	
			}
			
            var responseHandler = new TESMapper(this, "_showPopup", "_popupFailure");
            TestExecutionSuiteClient.getTestExecutionSuiteDTOs(responseHandler,{
                id: suites[0].id,
				resolveWorkItems: false,
				resolvePlan: false,
				/*resolveCurrentResult: true,*/ // Redundant data not required
				resolveFullCurrentResult: false,
				resolveSection: false,
				/*resolveElements: true,*/ // Redundant data not required
				resolveElementsResult: false,
				resolveElementsRequest: false,
				/*resolveElementsTestcase: true,*/ // Redundant data not required
				resolveElementFullTestase: false,
				stateId: suites[0].stateId
            });
		}
	},
	
	_showPopup: function(suites) {
		var afterLoad = dojo.hitch(this, function(){
			if (suites!=null && suites.length>0) {
				var selPopUp = new com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp();
				selPopUp.initialize(suites[0]);
			}
		});
		
		jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp", afterLoad);
	},
	
    _popupFailure: function(err) {
		this.viewHeaderNode.setStatus(Constants_getMessage("msgErrorLoadingTestSuite"), ViewHeaderLayout.ERROR);
    },
	
	_onDuplicateActionClick: function(ids) {
		var duplicateAction = new  DuplicateAction();
		duplicateAction.setType(ActionEntityType.TEST_SUITE);
		duplicateAction.execute(ids, dojo.hitch(this, "_invalidateQuery"), dojo.hitch(this, "_duplicateError"));		
	},
	
	_isDuplicateAllowedCallback: function(allowed){
		if(!allowed)
			this.duplicateActionNode.domNode.style.display = "none";			
	},
	
	_duplicateError: function(e){
		alert(Constants.getMessage("msgDuplicateError", e && e.message? e.message: ""));		
	},
    
	_onDeleteActionClick: function(ids) {
		var len = ids.length;
        var args = {
            'message': Constants_getMessage("msgDelTestSuiteConfirm",len),
            deleteIds: ids,
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        this.confirmDialog.setSecondaryTitle(Constants_getMessage("labelConfirmation"));
        this.confirmDialog.open();
    },

    _deleteAction: function() { 
        var deleteIds = this.confirmDialog.deleteIds;  
        
        this.confirmDialog = null;
        this.deleteActionNode.setDisabled(true);
        this.selectedSuiteCount = deleteIds.length;
        this.errorSuiteCount = 0;
        this.deletedSuiteCount = 0;

        if (this.selectedSuiteCount > 0) {
        	var length=this.selectedSuiteCount;
            this.monitorId = ProgressUtility.beginTaskMonitor(Constants.getMessage("msgDeletingTestSuite"), length, null);  
            
            for (var i = 0; i < length; i++) {
                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
                TestExecutionSuiteClient.archiveTestExecutionSuite(responseHandler,{
                            uuid_ts: deleteIds[i],
                            archive: true
                        });
            }
        }
    },
    
    _deleteSuccess: function(response) {
        this.deletedSuiteCount++;
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        this.errorSuiteCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        var currDeletedCnt = (this.deletedSuiteCount + this.errorSuiteCount);
        
        ProgressUtility.updateTask(this.monitorId, currDeletedCnt);
        if (currDeletedCnt == this.selectedSuiteCount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants_getMessage("msgDeletedTestSuite", this.deletedSuiteCount, this.selectedSuiteCount),
                    this.errorSuiteCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedSuiteCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedSuiteCount > 0) {
                this._deleteFromSelf = true;
                // TODO: virtual select all case don't have selectedPlans... need to use itemIds in
                // notification.
                // notify all pages (including itself) test suites are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_SUITE, this.tableViewer.getCheckedRows()]);
            }
        }
    },

	// handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about test suites
        if (artifactType == Constants.TYPE_SUITE) {
            // handle delete from self and query page case.
            if (this._deleteFromSelf && changeType == GlobalEvents.ArtifactsDeleted) {
                this._invalidateQuery();
                delete this._deleteFromSelf;
                return;
            }
            if (this.isQueryPage) {
                this._showArtifactChangedMessage(this.viewHeaderNode, Constants.TYPE_SUITE, changeType);
                return;
            }
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add test suites to the table
                if (!this.suites) {
                    this.suites = artifactArray;
                } else {
                    this.suites = this.suites.concat(artifactArray);
                }
                this.refresh(this.suites);
            } else {           
                // iterate through the array of artifacts
                var suites=this.suites;
                var iLength=artifactArray.length;
                for (var i = 0; i < iLength; i++) {
                    // iterate through the array of test cases in the table
                    var jLength=suites.length;
                    for (var j = 0; j < jLength; j++) {
                        // handle the matching test suite
                        if (artifactArray[i].id == suites[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap test suite on update
                                suites.splice(j, 1, artifactArray[i]);
                                this.refresh(suites);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove test suite from table on delete
                                suites.splice(j, 1);
                                this.refresh(suites);
                            }
                            break;
                        }
                    }
                }
            }
        }
		 if (artifactType == Constants.TYPE_CASE) {
            if (changeType == GlobalEvents.ArtifactsUpdated) {
            	var cLength=artifactArray.length;
            	var suites=this.suites;
				for(var count=0; count < cLength; count++){
					var iLength=suites.length;
					var artifact=artifactArray[count];
					var artifactId=artifact.id;
					for(var i=0; i < iLength; i++){
						var suite=suites[i];
						var elements = suite.elements ? suite.elements : [];
						var jLength=elements.length;
						for(var j=0; j < jLength; j++){
							var element=elements[j];
							var workitem=element.workitem;
							if(workitem && workitem.testCase && workitem.testCase.id == artifactId){
								workitem.testCase = artifact;
								suite.elements.splice(j, 1, element);
							}
						}
					}
				}
			}
			this.viewHeaderNode.clearStatus();
			this.refresh(this.suites);
		}else if(artifactType == Constants.TYPE_TES_CATEGORY) {
            this._handleCategoriesChanged(artifactArray); 
        }  	
    },
	
	_handleCategoriesClick: function(){
		var catEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor({
            artifactType: Constants.MODEL_TYPE_SUITE
        });
	},
	
	_handleCategoriesChanged: function(categoryTypes) {
		//reset View Builder
		this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
		var newCategoryFilters = CategoryUtil.getCategoryTypesFilters(this.categoryTypes);
		this._resetViewBuilder(newCategoryFilters);
		
		//reset test suite table
        this._reContructTable(categoryTypes);
	},
	
	_reContructTable: function(categoryTypes, testSuites) {
		if(testSuites)
			this.tableViewer.setContent(testSuites);

		var currentPageCtr = this.tableViewer.getCurrentPageControl();	
		//reset test plans' table
        this.provider = this._constructTableContentProvider();
		
		this.tableViewer.setContentProvider(this.provider);
		this.tableViewer.reconstruct(currentPageCtr);
		var listener = this.tableViewer.getTableListener();
		if(listener)
			listener.rowCheckStateChanged(this.tableViewer);

	},
	
	_mergeCategory: function(categories, CategoryTypeItemId, CategoryValueItemId) {
		var newCategories = [];
		for(var i = 0; i < this.categoryTypes.length; i++){
			var type = this.categoryTypes[i];
			var newValueItemId = null;
			
			if (type.itemId == CategoryTypeItemId) {
				newValueItemId = CategoryValueItemId;
			}
			else {
				newValueItemId = this._getCategoryByType(type, categories);
			}
	        if(newValueItemId)
	            newCategories.push(newValueItemId);
		}
        return newCategories;
    },
  
    _getCategoryByType: function(type, categories) {
        for(var i = 0; i < (type.categories ? type.categories.length:0); i++) {
            for(var j = 0; j < (categories?categories.length:0); j++) {
                if(type.categories[i].itemId == categories[j])
                    return categories[j];
            }
        }
        return null;
    },
	
	_confirmResetViewBuilder: function(newCategoryFilters) {
        //reset ViewBuilder
		var self = this;
        var args = {
            title: Constants.getMessage("labelConfirmation"),
            message: Constants.getMessage("msgChangeViewBuildConfirm"),
            yesCallback: function() {
				self._resetViewBuilder(newCategoryFilters);
			},
            noCallback: function(){
                return false;
            }
        }
        var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        dialog.setSecondaryTitle(args.title);
        dialog.open();
	},
	
	_resetViewBuilder: function(newCategoryFilters) {
		if (this.filterProvider) {
			var newFilters = [];
			var oldFilters = this.filterProvider.filters;
			for(var i = 0; i < oldFilters.length; i++) {
				if(oldFilters[i].name.indexOf("categories") == -1)
					newFilters.push(oldFilters[i]);
			}
			this.allCategoryFilters = newCategoryFilters;
			newFilters = newFilters.concat(this.allCategoryFilters);
			delete this.filterProvider.filters;
			this.filterProvider.filters = newFilters;
			
			this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
		}
	},

    // @override.
    //    The test suite's batch update expects the 'id' of the item
    //    and not the itemId.
    headerActionInvoked: function(columnIndex, actionId)
    {
        var isRiskAction = (actionId == Constants.getMessage("labelRiskAssessment"));
        var idType = 'id';
        
        this.invokeAction(idType, this, "doBatchUpdate", columnIndex, actionId)
    },

    // @override.
    //    Abstract method to actually performs the batch change operations. Specific
    //    subclassess need to override this method to do the work on the artifact type.
    doBatchUpdate: function(itemIds, columnIndex, actionId) {
        var categoryType = null;
        var categoryTypes = this.categoryTypes;
        
        // pass along the category type if the bulk change
        // is for a category.
        for (var i = 0; i < categoryTypes.length; i++) {
            var categoryName = Constants.getMessage(categoryTypes[i].name);
            if (categoryName == actionId) {
                categoryType = categoryTypes[i];
                break;
            }
        }
        var action = new ActionPackage.TestSuiteBulkChangeAction({
            actionId: actionId,
            itemIds: itemIds,
            categoryType: categoryType,
            completeCallback: dojo.hitch(this, "_invalidateQuery"),
            errorCallback: dojo.hitch(this, "_invalidateQuery")
        });
        action.execute();
    },
	
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e ? e.message : "Unknown");
    }	
	
});

})();
