//debug testplantreeview
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.tree.TestPlanTreeView");
 
dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Tree");
dojo.require("dijit.Menu");
dojo.require("jazz.util.ResizeNotifier");


dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.DeleteAction");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.PrintPDFAction");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.tree.TestPlanTreeModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.tree.TestPlanTree");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.HorizontalTree");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.ActionRegistry");

(function() {

var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.asq.common.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var TestPlanTreeModel = com.ibm.rqm.planning.web.ui.internal.view.tree.TestPlanTreeModel;
var TestPlanTree = com.ibm.rqm.planning.web.ui.internal.view.tree.TestPlanTree;
var HorizontalTree = com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.HorizontalTree;
var DuplicateAction = com.ibm.rqm.planning.web.ui.internal.model.action.DuplicateAction;
var DeleteAction = com.ibm.rqm.planning.web.ui.internal.model.action.DeleteAction;
var PrintPDFAction = com.ibm.rqm.planning.web.ui.internal.model.action.PrintPDFAction;
var ActionEntityType = com.ibm.rqm.planning.web.ui.internal.model.action.ActionEntityType;


dojo.declare("Tree.ActionRegistry",
             com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.ActionRegistry,
{   
    init: function()
    {
        this.openActionDef = {
                label: Constants.getMessage('labelOpen'),   //Open
                callback: dojo.hitch(this.parentView, "openItem"),
				defaultAction: true
        };
        
		//Define the actions for the various node types in the tree
        this.testPlanActions = {
            actions: [
            this.openActionDef,
            {
                label: Constants.getMessage("msgDuplicate"),		//Duplicate
                callback: dojo.hitch(this.parentView, "duplicateItem")
            },
			{
                label: Constants.getMessage("msgDelete"),
                callback: dojo.hitch(this.parentView, "deleteItem")
            },
			{
                label: "PDF Print",
                isSubMenu: true,
				subActions: {
					actions: [{
						label: Constants.getMessage("printLabelCAR"),		//Current Artifact Report
						callback: dojo.hitch(this.parentView, "printCurrentArtifact")
					}, {
						label: Constants.getMessage("printLabelTPDR"),		//Test Plan Detail Report
						callback: dojo.hitch(this.parentView, "printTestPlanDetailedReport")
					}, {
						label: Constants.getMessage("printLabelTPCR"),		//Test Plan Comprehensive Report
						callback: dojo.hitch(this.parentView, "printTestPlanComprehensiveReport")
					}, {
						label: Constants.getMessage("printLabelHistory"),	//History Report
						callback: dojo.hitch(this.parentView, "printHistoryReport")
					}]
				}
            }]
		};
        this.testCaseActions = {
            actions: [
            this.openActionDef,
            {
                label: Constants.getMessage("msgDuplicate"),		//Duplicate
                callback: dojo.hitch(this.parentView, "duplicateItem")
            },
			{
                label: "PDF Print",
                isSubMenu: true,
				subActions: {
					actions: [{
						label: Constants.getMessage("printLabelCAR"),		//Current Artifact Report
						callback: dojo.hitch(this.parentView, "printCurrentArtifact")
					}, {
						label: Constants.getMessage("labelShowNormalView"),		//Normal View
						callback: dojo.hitch(this.parentView, "printTestPlanDetailedReport")
					}, {
						label: Constants.getMessage("labelFullSize"),		//Full Size
						callback: dojo.hitch(this.parentView, "printTestPlanComprehensiveReport")
					}, {
						label: Constants.getMessage("printLabelHistory"),	//History Report
						callback: dojo.hitch(this.parentView, "printHistoryReport")
					}]
				}
            }]
		};
        this.testScriptActions = {
            actions: [
            this.openActionDef,
            {
                label: Constants.getMessage("msgDuplicate"),		//Duplicate
                callback: dojo.hitch(this.parentView, "duplicateItem")
            },
			{
                label: "PDF Print",
                isSubMenu: true,
				subActions: {
					actions: [{
						label: Constants.getMessage("labelShowNormalView"),		//Current Artifact Report
						callback: dojo.hitch(this.parentView, "printCurrentArtifact")
					}, {
						label: Constants.getMessage("printLabelHistory"),	//History Report
						callback: dojo.hitch(this.parentView, "printHistoryReport")
					}]
				}
            }]
		};
		
		this.executionResultActions = {
            actions: [
			{
                label: "PDF Print",
                isSubMenu: true,
				subActions: {
					actions: [{
						label: Constants.getMessage("labelShowNormalView"),		//Current Artifact Report
						callback: dojo.hitch(this.parentView, "printCurrentArtifact")
					}, {
						label: Constants.getMessage("printLabelHistory"),	//History Report
						callback: dojo.hitch(this.parentView, "printHistoryReport")
					}]
				}
            }]
		};

        this.executionResultWithOpenActions = {
            actions: [
            this.openActionDef,
            {
                label: "PDF Print",
                isSubMenu: true,
                subActions: {
                    actions: [{
                        label: Constants.getMessage("labelShowNormalView"),     //Current Artifact Report
                        callback: dojo.hitch(this.parentView, "printCurrentArtifact")
                    }, {
                        label: Constants.getMessage("printLabelHistory"),   //History Report
                        callback: dojo.hitch(this.parentView, "printHistoryReport")
                    }]
                }
            }]
        };
		
		this.requirementActions = {
            actions: [
              this.openActionDef,
			{
                label: Constants.getMessage("msgDuplicate"),		//Duplicate
                callback: dojo.hitch(this.parentView, "duplicateItem")
            },			
			{
                label: "PDF Print",
                isSubMenu: true,
				subActions: {
					actions: [{
						label: Constants.getMessage("labelShowNormalView"),		//Current Artifact Report
						callback: dojo.hitch(this.parentView, "printCurrentArtifact")
					}]
				}
            }]
		};

		
		this.openOnlyActions = {
            actions: [this.openActionDef]
		};
    },
    
    // API 
    getContextActions: function(model, item)
    {
        if (item.type == "testplan")
            return this.testPlanActions;
		else if (item.type == "testcase")
			return this.testCaseActions;
		else if (item.type == "testscript")
			return this.testScriptActions;
		else if (item.type == "executionresult" ||
		         item.type == "executionworkitem") {
			   var actions = this.executionResultActions;
            // we can only open an item with an 'enclosure' in the
            // artifact.
            if(item.artifact && item.artifact.enclosure) {
                actions = this.executionResultWithOpenActions;
            }
            return actions;
        }
		else if (item.type == "requirement")
			return this.requirementActions;
        else if (item.artifact && item.artifact.enclosure)
            return this.openOnlyActions;
		return null;
    }
});

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.tree.TestPlanTreeView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-tree-view" tabindex="-1">' +
                    // attach our content node to containerNode as well, allowing our content to be destructable by destroyRecursive
                    '  <div dojoAttachPoint="_treeNode,containerNode" class="com-ibm-rqm-test-artifact-tree-view" tabindex="-1"></div>' +
                    '</div>',

	// variable used to keep track of unique identifier for tree nodes
    _uniqueId: 0,
    
    groups: null,  // provided in constructor args
    root: null,
    tree: null,
    isHtree: false,
    nPages: 0,
    pageSize: 0,
    totalSize: 0,
    fetchTestPlanPage: null,
	reloadTestPlan: null, 	// invalidate the query in the container, and reload
    
    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
    	this._initialize();
	},
	
	// load the tree with data
	_initialize: function() {
        
    	// create a new tree.
    	// The refresh function is sometimes spammed before the tree
    	// is actually ready to be displayed.  This causes some "flicker" in the
    	// tree viewer as an empty tree is drawn and then immediately replaced.
    	// In order to avoid this flicker the tree is only created when
    	// valid group data has been provided.
        if (this._hasGroups(this.groups)) {
			this.model = new TestPlanTreeModel({
                groups: this.groups,
                pageSize: this.pageSize,
                totalSize: this.totalSize,
                nPages: this.nPages,
                fetchTestPlanPage: this.fetchTestPlanPage
            });
			
            if (!this.isHtree) {
                this.tree = new TestPlanTree({
                    model: this.model,
                    getIconClass: dojo.hitch(this, this._getIconClass),
                    onClick: dojo.hitch(this, this._onClick),
                    onClose: dojo.hitch(this, this._onClose),
                    persist: false,
                    showRoot: true,
					actionRegistry: new Tree.ActionRegistry({parentView: this, showActionLabel:false})					
                });
            }
            else {
                this.tree = new HorizontalTree({
                    model: this.model,
					allowAutoResize: false,
                    getIconClass: dojo.hitch(this, this._getIconClass),
                    nVisiblePanelsHint: 4,
                    actionRegistry: new Tree.ActionRegistry({parentView: this, showActionLabel:false}),
                    width: "100%",
                    height: "400px"
                });
				// handle resizing the explorer when the window is resized. If
				// we allow the explorer to resize itself, this parent node would
				// allow a wider width. Have to constraint the width of the explorer
				// to the width of this container.
                this.resizeNotifierId = jazz.util.ResizeNotifier.register({context: this, callback: function(){
                    var contentBox = dojo.contentBox(this._treeNode);
                    if(contentBox.w > 0) {
                        contentBox.h = 400;
                        this.tree.resize(contentBox);
                    }
                }});
            }
			
	        // top level nodes are groups
	        if (this.groups[0].name != null) {
	        	// groups
		        for (var i=0; i<this.groups.length; i++) {
		        	var group = this.groups[i];
		        	var testplans = group.objects;
		        	var item = this._newItem(group, group.name, "group", this.root);
		        	// testplans
			        for (var j=0; j<testplans.length; j++) {
			        	var testplan = testplans[j];
			        	var child = this._newItem(testplan, testplan.name, "testplan", item);
			        }
		        }
	        }
	        // no groups, top level nodes are test plans
	        else {
	        	var testplans = this.groups[0].objects;
		        for (var i=0; i<testplans.length; i++) {
		        	var testplan = testplans[i];
		        	var item = this._newItem(testplan, testplan.name, "testplan", this.root);
		        }
	        }
	        
            if(!this.isHtree)
               this.tree.rootNode.expand();
            else 
                this.tree.load();
			this._treeNode.appendChild(this.tree.domNode);
		}
		
    },

	_destroyUI: function() {
        dojox.data.dom.removeChildren(this._treeNode);
        if (this.tree!=null) {
            this.tree.destroy();
            this.tree=null;
        }
    	if (this.model!=null) {
	    	this.model.destroy();
	    	this.model=null;
    	}
        if (this.resizeNotifierId) {
            jazz.util.ResizeNotifier.unregister(this.resizeNotifierId);
            delete this.resizeNotifierId;
        }  
        if(this.groups)      
    	   delete this.groups;
	},
	
    refresh: function(groups) {
    	this._destroyUI();
        this.groups = groups;
    	this._initialize();      		
    }, 
	
    _newItem: function(artifact, name, type, parent, /*optional*/id) {
    	if (id==null) {
    		id = this._uniqueId++;
    	}
    	var tmp = {
    		artifact: artifact,
    		name: name,
    		type: type,
    		id: id,
    		children: [],
    		childrenLoaded: false
    	};
		var newItem = this.tree.model.newItem(tmp, parent);
    	return newItem;
    },

    // checks to see if the provided groups array
    // is ready for display.  it is ready for display
    // if it contains more than one group element or if
    // the first group element has more than one object.	    
    _hasGroups: function(groups) {
    	var hasGroups = false;
    	if (groups!=null && groups.length>0) {
    		if (groups.length>1) {
    			hasGroups = true;
    		} else if (groups[0].objects.length>0) {
    			hasGroups = true;
    		}
    	}
    	return hasGroups;
    },
    
    _iconMap: {
    	'project': 'project-icon-tree-16',
    	'testplan': 'testplan-icon-tree-16',
    	'testplanGroup': 'testplan-icon-tree-16',
    	'testcase': 'testcase-icon-tree-16',
    	'testcaseGroup': 'testcase-icon-tree-16',
    	'requirement': 'requirement-icon-tree-16',
    	'requirementGroup': 'requirement-icon-tree-16',
    	'testscript': 'testscript-icon-tree-16',
    	'remotescript': 'testscript-icon-tree-16',
    	'testscriptGroup': 'testscript-icon-tree-16',
    	'remotescriptGroup': 'testscript-icon-tree-16',
    	'manualscriptGroup': 'testscript-icon-tree-16',
    	'executionworkitem': 'ewi-icon-tree-16',
    	'executionworkitemGroup': 'ewi-icon-tree-16',
    	'executionresult': 'ewiresult-icon-tree-16',
    	'executionresultGroup': 'ewiresult-icon-tree-16',
    	'workitem': 'defect-icon-tree-16',
    	'workitemGroup': 'defect-icon-tree-16'
    },
    
	_getIconClass: function(item, opened)
	{
       	var iconClass;
       	
       	if (item == null) {
			iconClass = opened ? "dijitFolderOpened" : "dijitFolderClosed";
       	}
       	else if (this._getItemIcon(item) != null) {
	       	iconClass = this._getItemIcon(item);
	    }
	    else {
			iconClass = opened ? "dijitFolderOpened" : "dijitFolderClosed";
		}
		return iconClass;
	},
	
	_getItemIcon: function(item) {
		var iconClass = this._iconMap[item.type];
		if (item.type == "testplan") {
			//handle icons for master/child
			if (item.artifact.isMaster === true) {
				iconClass = "testplan-master-icon-tree-16";
			} else if (item.artifact.isChild === true || item.parent.type == "childrenGroup") {
				iconClass = "testplan-child-icon-tree-16";
			}
		} else if (item.type == "childrenGroup") {
			iconClass = "testplan-child-icon-tree-16";
		}
		return iconClass;
	},
	
	mapItemType2ActionType: function(type){
		if (type == "testplan")
			return ActionEntityType.TEST_PLAN;
        if(type == "testcase")
			return ActionEntityType.TEST_CASE;			
        if(type == "requirement")
			return ActionEntityType.REQUIREMENT;						
        if(type == "testscript")
			return ActionEntityType.TEST_SCRIPT;									
		return null;
	},
	
	printPDF: function(parent, item, recursion, partialRecursion, history)
	{
		var id = this.getItemId(item);
		if(id){
			var  selection = [id];
			var type = item.type;
		
			var printPDFAction = new PrintPDFAction({_recursion : recursion,
			                                         _partialRecursion : partialRecursion,
												 	_history : history,
												 	_printType : type});
        	printPDFAction.execute([selection], this._printPDFComplete, this._printPDFFailed);
		}
	},
	
	_printPDFComplete: function()
	{
		
	},
	
	_printPDFFailed: function()
	{
		
	},			
	printCurrentArtifact: function(parent, item) 
	{
		this.printPDF(parent, item, false, false, false);
	},
	
	printTestPlanDetailedReport: function(parent, item) 
	{
		this.printPDF(parent, item, true, true, false);
	},

	printTestPlanComprehensiveReport: function(parent, item) 
	{
		this.printPDF(parent, item, true, false, false);
	},
	
	printHistoryReport: function(parent, item) 
	{
		this.printPDF(parent, item, false, false, true);
	},

	
	deleteItem: function(parentItem, item)
	{
		//The delete action needs the versionable IDs to actually perform the delete
		//And it needs the numeric IDs for the notifiaction sent to the views.
		var versionableIDArray = [item.artifact.versionableItemId];
		var numericIDArray = [item.artifact.id];

		var type = item.type;
		var deleteAction = new DeleteAction(
		{
			artifactType: type,
			artifactName: item.name
		});
		
		this.deletedItem = item;
		this.deletedItemParent = item.parent;
		var idArrays = {versionableIDs : versionableIDArray,
						numericIDs : numericIDArray};
        deleteAction.execute(idArrays, dojo.hitch(this, "_deleteComplete"), dojo.hitch(this, "_deleteFailed"));
	},
	
	_deleteComplete: function()
	{
		this.model.onDelete(this.deletedItem);
	},
	
	_deleteFailed: function(msg)
	{
		//Need a better handler
		alert("Failed - " + msg);
	},
	
	// Test Plans have an id of 1, 2 etc. The objects have a test plan id of 
	// urn...:<number>
	
	getItemId: function(item)
	{
		var id;
		if(item && item.artifact){
			id = item.artifact.id; 
			if(isNaN(id)){
				var i = id.lastIndexOf(":");
				id = id.substr(i + 1, id.length - 1);
			}
			else {
				id += '';
			}
		}
		return id;
	},
	
	duplicateItem: function(folderItem, item){
		var id = this.getItemId(item);
		if(id && folderItem){
			var  selection = [id];
			var type = item.type;
			this.duplicateAction = new DuplicateAction();
			var containingItem = folderItem.parent;
			while(containingItem && !containingItem.artifact)
				containingItem = containingItem.parent;
			if(containingItem){
				id = this.getItemId(containingItem);
				if(id)
					this.duplicateAction.setContext(this.mapItemType2ActionType(containingItem.type), id);
			}
			var duplicateType = this.mapItemType2ActionType(type);			
			if(duplicateType){
				this.duplicateAction.folderItem = folderItem;				
				this.duplicateAction.setType(duplicateType);				
      				this.duplicateAction.execute(selection, dojo.hitch(this, "_duplicateComplete"), this._duplicateFailed);
			}
		}
		else
			this._duplicateFailed();
	},
	
	_duplicateComplete: function(copiedItems)
	{
		var type = this.duplicateAction._type;
		if(type == ActionEntityType.TEST_PLAN)
			this.reloadTestPlan();
		else {
            if (!this.isHtree) 
				this.tree.addToTree(this.duplicateAction.folderItem);			
		}
	},
	
	_duplicateFailed: function(e)
	{
		alert(Constants.getMessage("msgDuplicateError", e && e.message ? e.message: ""));		
	},		
	
	// listen for tree node close.  remove the children
	// so refresh will be done next time it is opened
	_onClose: function(/* dojo.data */ item, /*TreeNode*/ node){
		
		// children of the root node (project) are provided
		// via the table query
		if (item.type=="project") {
			return;
		}
		
		// recursively destroy all the child nodes
		var children = node.getChildren();
		for (var i=0; i<children.length; i++) {
			var childNode = children[i];
			this._destroyNodeRecursive(childNode,0);
			node.removeChild(childNode);
		}
		
		// clear out the children
		item.children = [];
		item.mayHaveChildren=true;
		
		// reset the expando indicator since don't
		// know yet whether next query to the server
		// might return children
		node.isExpandable = true;
		node.state = "UNCHECKED";
	},
	
	// recursively destroy a tree node
	_destroyNodeRecursive: function(/*TreeNode*/ node, /*int*/ tooMuchRecursionCheck) {
		// safety check for too much recursion
		if (++tooMuchRecursionCheck > 100) {
			console.error("too much recursion while destroying tree nodes");
			return;
		}
		
		// destroy the node's children
		var children = node.getChildren();
		for (var i=0; i<children.length; i++) {
			var childNode = children[i];
			this._destroyNodeRecursive(childNode,tooMuchRecursionCheck);
			node.removeChild(childNode);
		}
		
		// destroy the node
		this.model.destroyRecursive(node.item);
		node.destroy();
	},

	// TODO Is the default version of _onClick in the Tree 
	_onClick: function(/* dojo data */ item, /* TreeNode*/ node)
	{
			this.tree.focusNode(node);
	},

	openItem: function(parentItem, item){
		if (item.type=="testplan") { 
			//determine if the testplan came from the original dataset via the
			//table viewer or from a feed (as in the case of child plans)
			var enclosure = item.artifact.enclosure;
			if (enclosure != null) {
				//testplan came from feed; load by enclosure 
				this._locationByEnclosure(item.artifact.enclosure);
			} else {
				//testplan came from the table view; load directly by id
				var hash = Utility.getTestPlanURI({id: item.artifact.id});
				window.location.hash = hash;				
			}	
		}
		else if (item.type=="testcaseGroup") {
			var testplanId = item.parent.artifact.id;
			var hash = Utility.getTestPlanURI({id: testplanId});
			var hashWithSectionId = hash + "&sectionId=com.ibm.rqm.planning.editor.section.planTestCases";  //$NON-NLS$
			window.location.hash = hashWithSectionId;
		}
		else if (item.type=="requirementGroup") {
			var targetType = item.parent.type;
			if (targetType=="testplan") {
				var testplanId = item.parent.artifact.id;
				var hash = Utility.getTestPlanURI({id: testplanId});
				var hashWithSectionId = hash + "&sectionId=com.ibm.rqm.requirements.editor.section.planRequirements"; //$NON-NLS$ 
				window.location.hash = hashWithSectionId;
			} else if (targetType=="testcase") {
				this._locationByEnclosure(item.parent.artifact.enclosure, "com.ibm.rqm.requirements.editor.section.caseRequirements"); //$NON-NLS$
			}
		}
		else if (item.type=="testscriptGroup") {
			this._locationByEnclosure(item.parent.artifact.enclosure, "com.ibm.rqm.planning.editor.section.testCaseScripts"); //$NON-NLS$
		}
		else if (item.type=="remotescriptGroup") {
			this._locationByEnclosure(item.parent.parent.artifact.enclosure, "com.ibm.rqm.execution.editor.section.ewis"); //$NON-NLS$
		}
		else if (item.type=="manualscriptGroup") {
			this._locationByEnclosure(item.parent.parent.artifact.enclosure, "com.ibm.rqm.planning.editor.section.testCaseScripts"); //$NON-NLS$
		}
		else if (item.type=="executionworkitemGroup") {
			this._locationByEnclosure(item.parent.artifact.enclosure, "com.ibm.rqm.execution.editor.section.ewis"); //$NON-NLS$
		}
		else if (item.artifact && item.artifact.enclosure) {
			this._locationByEnclosure(item.artifact.enclosure);
		}
	},
	
	_locationByEnclosure: function(enclosure, sectionId) {
		var index = enclosure.indexOf('#');
		if (index > 0) {
			var hash = enclosure.substring(index+1);
			if (sectionId != null) {
				hash = hash + "&sectionId=" + sectionId;
			} 
			window.location.hash = hash;
		} else {
			window.location = enclosure;
		}	
	},
    
    destroy: function(){
        this.inherited("destroy", arguments);
        
        if (this.resizeNotifierId) {
            jazz.util.ResizeNotifier.unregister(this.resizeNotifierId);
            delete this.resizeNotifierId;
        }
    },
	
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    }
	
});

})();
