/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.dashboard.web.util.internal.I18nUtil");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");
(function() {
	

var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var I18nUtil = com.ibm.team.dashboard.web.util.internal.I18nUtil;

dojo.declare("com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet",  Viewlet,
{   
	//Get Project Area must be used for remote environmens
	getProjectArea: function() {	    		
		
		if(!this.isRemote()){  //local environment
    		var ProjectArea = com.ibm.team.process.web.projectArea;
    		if(ProjectArea)  
        		return ProjectArea;    	    	
		}
		else{
            var scopeItem = this.getScopeItem();    // Report via saved query (remote)
            if (scopeItem && scopeItem.itemId) {
                return scopeItem;
            }
		}
        return null;
	},
	
	isRemote: function(){
		if(this.site && this.site.viewletAdapter)
			return !this.site.viewletAdapter.local;
	},
	
	createNoScopeMsg: function() {	
        var msgSpan = document.createElement("span");
        msgSpan.innerHTML = com.ibm.asq.common.web.client.internal.Constants.getMessage("viewletnotConfigured");
        if (this.getSite().isDashboardEditing()) {
            var editSpan = document.createElement("span");
            var nodes = I18nUtil.addMessage(editSpan, com.ibm.asq.common.web.client.internal.Constants.getMessage("selectArea"));
            this.connect(nodes[0], "onclick", this.handleToggleSettings);
            msgSpan.appendChild(editSpan);
        }
        return msgSpan;
    },
    
	handleToggleSettings: function(event) {
        dojo.stopEvent(event);
        this.getSite().toggleSettings();
    },
    
	getFormattedUrl:function(){
		if(this.isRemote())
			return net.jazz.ajax._contextRoot+"/web/console/"+this.getProjectArea().name;
		else 
			return "";
	},

	
	// Make sure uninitialize doesn't call destroy back again and result in recursive destroys
	destroy: function() {
		if(this.isDestroyed() == false)
			this.inherited(arguments);
	},
  
	// Destroy all of the widgets used by this widget.
	uninitialize: function() {
		if(this.domNode != null)
			com.ibm.asq.common.web.ui.internal.util.Utility.destroyWidgetsFromNode(this.domNode);  
	}
	
});

})();
