/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *   
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.QMEventLogViewlet");

dojo.require("com.ibm.team.dashboard.viewlets.web.ui.internal.JazzFeedViewlet");
dojo.require("jazz.util.format");
dojo.require("jazz.util.html");
dojo.require("jazz.ui.HoverPopup");
dojo.require("jazz.util.date");
//dojo.require("com.ibm.team.dashboard.viewlets.web.ui.internal.utils.RelativeDateFormat");

(function()
{
var FormatUtil = jazz.util.format;
var HTMLUtility = jazz.util.html;
var HoverPopup = jazz.ui.HoverPopup;
//var RelativeDateFormat = com.ibm.team.dashboard.viewlets.web.ui.internal.utils.RelativeDateFormat;
var DateTime = jazz.util.date;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.QMEventLogViewlet",	
			 com.ibm.team.dashboard.viewlets.web.ui.internal.JazzFeedViewlet,
{
	// this is not needed anymore, was only used by SortableFilterableTable
	getViewletStrId: function()
	{
		return "com.ibm.team.dashboard.viewlets.web.qualitymanager";			
	},
	
	/* Node[] */ renderEntry: function(/* EntryDTO */ entry, /* EntryDTO */ entryDetails, /* boolean */ zoomed) {

/*		var columns = new Array();
		var firstItem = entry.items[0];
		
		// render icon if exists
		if (firstItem.category) {
			var td = document.createElement("td");
			dojo.addClass(td, "iconCell");
			var div = document.createElement("div");
			dojo.addClass(div, "icon");
			dojo.addClass(div, firstItem.category);
			var imgDiv = document.createElement("div");
			if (firstItem.overlay) {
				var img = document.createElement("img");
				img.src = firstItem.overlay;
				if (firstItem.overlayClass)
					dojo.addClass(imgDiv, firstItem.overlayClass);
				imgDiv.appendChild(img);
			} else if (dojo.isFF) {
				// workaround a firefox display bug when there is a row with an overlay above a row without one
				imgDiv.style.display = "none";
				var img = document.createElement("img");
				img.src = "";
				imgDiv.appendChild(img);
			}
			div.appendChild(imgDiv);
			td.appendChild(div);
			columns.push(td);
		}
		
		// render count for multi-item entries
		var td = document.createElement("td");
		var count = entry.items.length;
		if (count > 1) {
			var countSpan = document.createElement("span");
			countSpan.className = "count";
			countSpan.innerHTML = "[" + count + "] ";
			td.appendChild(countSpan);
		}
*/		
		var columns = new Array();
		var firstItem = entry.items[0];
		
		// render icon if exists
		if (firstItem.category) {
			var td = document.createElement("td");
			dojo.addClass(td, "iconCell");
			var div = document.createElement("div");
			dojo.addClass(div, "icon");
			dojo.addClass(div, firstItem.category);
			var imgDiv = document.createElement("div");
			if (firstItem.overlay) {
				var img = document.createElement("img");
				img.src = firstItem.overlay;
				if (firstItem.overlayClass)
					dojo.addClass(imgDiv, firstItem.overlayClass);
				imgDiv.appendChild(img);
			} else if (dojo.isFF) {
				// workaround a firefox display bug when there is a row with an overlay above a row without one
				imgDiv.style.display = "none";
				var img = document.createElement("img");
				img.src = "";
				imgDiv.appendChild(img);
			}
			div.appendChild(imgDiv);
			td.appendChild(div);
			columns.push(td);
		}
		
		// render count for multi-item entries
		var td = document.createElement("td");
		var count = entry.items.length;
		if (count > 1) {
			var countSpan = document.createElement("span");
			countSpan.className = "count";
			countSpan.innerHTML = "[" + count + "] ";
			td.appendChild(countSpan);
		}

//		var a = document.createElement("a");
//		if (!firstItem.disableLink)
//			a.href = firstItem.linkURL;
//		else
//			a.href = "#";
//		if (firstItem.targetLink)
//			a.target = firstItem.targetLink;
		
		// render link
		var a = document.createElement("a");
		var remote  = this.site && this.site.viewletAdapter && !this.site.viewletAdapter.local;
		if (!firstItem.disableLink)
		{
			if(remote){ //If we are remote, let the  feed link work, just change the target
				a.href = firstItem.linkURL;
				a.target = "_RQMScope";
			}
			else{ //If we are local, recreate the link  to avoid the loading message
				var tokens = firstItem.linkURL.split( "/" );
				if (tokens && tokens.length > 0) {
					var id = tokens[ tokens.length - 1 ];
					a.href = document.location.protocol + 
							 "//" + 
							 document.location.host + 
							 document.location.pathname + 
							 document.location.search + 
							 "#action=com.ibm.team.workitem.viewWorkItem&id=" + 
							 id;
					
				}
				else
				{
					a.href = "#";
				}
			}
		}
		else 
			a.href = "#";
			
		a.innerHTML = FormatUtil.insertWordBreaks(HTMLUtility.removeScript(firstItem.title), 20);
		
		// attach tooltip
		var hoverPopup = new HoverPopup({
			around: [a],
			createContents: dojo.hitch(this, this._createTooltip, entry),
			onOpen: dojo.hitch(this, this._onTooltipOpen, entry),
			onClose: dojo.hitch(this, this._onTooltipClose)
		});
		this._hoverPopups.push(hoverPopup);
		
		a.style.zoom = "normal"; // Bug #44703
		td.appendChild(a);
		columns.push(td);
		
		if (firstItem.disableLink) {
			this.connect(a, "onclick", function(event) {
				event.preventDefault();
				hoverPopup.open();
			});
		}
		
		// set style if read
		if (this._trackReadMarks) {
			var className = this._isRead(entry) ? "read-entry" : "unread-entry";
			if (firstItem.critical) {
				className = "critical-" + className;
			}
			for (var i=0;i<columns.length;i++) {
				dojo.addClass(columns[i], className);
			}
		}

		// render date
		if (!zoomed && firstItem.date) {
			var separatorSpan = document.createElement("span");
			separatorSpan.innerHTML = "&nbsp ";
			td.appendChild(separatorSpan);
			var dateSpan = document.createElement("span");
			dateSpan.className = "date";
			dateSpan.innerHTML = DateTime.formatDif(new Date(firstItem.date), false, true);
			td.appendChild(dateSpan);
		}
		
		entry.columns = columns;
		return columns;

/*		
		a.innerHTML = FormatUtil.insertWordBreaks(HTMLUtility.removeScript(firstItem.title), 20);
		var tooltipSpan = document.createElement("span");
		tooltipSpan.innerHTML = "<span class=\"com-ibm-team-dashboard-viewlets-web-ui-internal-FeedViewlet-tooltip\"><span class=\"loading\">Loading...</span></span>";
		var tooltip = new HoverPopup({around: [a], onOpen: dojo.hitch(this, this._onTooltipOpen), callbackArg: {tooltipSpan: tooltipSpan, entry: entry}, preDisplayCheck: dojo.hitch(this, this._onPreTooltipOpen, entry), onClose: dojo.hitch(this, this._onTooltipClose)}, tooltipSpan);
		a.style.zoom = "normal"; // Bug #44703
		td.appendChild(a);
		columns.push(td);
		
		if (firstItem.disableLink) {
			this.connect(a, "onclick", function(event) {
				event.preventDefault();
				tooltip.open();
			});
		}
		
		// set style if read
		if (this._trackReadMarks) {
			var className = this._isRead(entry) ? "read-entry" : "unread-entry";
			if (firstItem.critical) {
				className = "critical-" + className;
			}
			for (var i=0;i<columns.length;i++) {
				dojo.addClass(columns[i], className);
			}
		}

		// render date
		if (!zoomed && firstItem.date) {
			var separatorSpan = document.createElement("span");
			separatorSpan.innerHTML = "&nbsp ";
			td.appendChild(separatorSpan);
			var dateSpan = document.createElement("span");
			dateSpan.className = "date";
			dateSpan.innerHTML = DateTime.formatDif(new Date(firstItem.date), false, true);
			td.appendChild(dateSpan);
		}
		
		entry.columns = columns;
		return columns;  */
	}
});

})();
