/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.ViewletContainer");

dojo.require("com.ibm.team.dashboard.web.ui.internal.ViewletContainer");

(function() {

	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.ViewletContainer", 
				  com.ibm.team.dashboard.web.ui.internal.ViewletContainer, 
{
	templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/viewlets/ViewletContainer.html"),
	
	initialZoom: false,
		
	_hideZoom: function(e) {
		this._zoom.style.visibility = 'hidden';
		this._zoom.style.right = "";
	},
			
	_showZoom: function(e) {
		if (this._viewlet.hasZoomableContent())
			this._zoom.style.visibility = 'visible';
		else return;
		
		
		if (this.isZoomed ) {			
			if (!(dojo.isIE < 7 && dojo.isIE > 0) ) {
				var coords = dojo.coords( this._contentWrapper, true );
				var vBar = ( this._contentWrapper.scrollHeight > coords.h );
				var hBar = ( this._contentWrapper.scrollWidth > coords.w );
				
				//For some reason when there are no vertical or horizontal scroll bar if the zoom button is clicked then it can cause a 
				//scroll bar to appear.  So do not put bottom or right on the link.
				if( vBar )
					this._zoom.style.bottom = ( ( hBar && dojo.isFF && dojo.isFF < 3 ) ? 20 : 1 ) - this._contentWrapper.scrollTop + "px";
				if( hBar )
					this._zoom.style.right = 1 - this._contentWrapper.scrollLeft + "px";
			}
			if (!this.onViewletScroll) {
				this.onViewletScroll = this.connect(this._contentWrapper,"onscroll",this._showZoom);	
			}
		}
	},
	
	_addViewletIcon: function() {
		var icon = this._viewletHelper.icon;
		if (!icon) {
			icon = this._viewletDefinition.icon;
		}
		var iconImage = document.createElement("img");
		if (icon.indexOf("://") == -1) {
				iconImage.src = dojo.moduleUrl(	this._viewlet.declaredClass.substring( 0, this._viewlet.declaredClass.indexOf( ".web" ) + 4 ), 
												icon.substring(icon.indexOf("/") + 1));
		}
		else {
			iconImage.src = icon;
		}
		iconImage.className = "icon-image";
		this._headerIcon.appendChild(iconImage);
	}

});

})();

