/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.ViewletPage");

dojo.require("com.ibm.team.dashboard.web.ui.internal.ViewletPage");
dojo.require("com.ibm.team.dashboard.web.ui.internal.ViewletContainer");

(function() {
	
var ViewletContainer = com.ibm.team.dashboard.web.ui.internal.ViewletContainer;
var RQMDEFAULTTRIM = 4; 

	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.ViewletPage", 
				  com.ibm.team.dashboard.web.ui.internal.ViewletPage, 
{
	/*
	 * Override, set viewletContainer's trim to 4
	 */
	_addViewlet: function(/* ViewletHelper */ viewletHelper, /* number */ columnIndex, /* number */ viewletIndex) {
		// set up params
		var args = {
			dashboardBundle: this.dashboardContainer.dashboardBundle,
			viewletHelper: viewletHelper,
			viewletPage: this,
			_columnIndex: columnIndex,
			editing: this.editing
		};
		// add viewlet to destination column
		var column = this.columns[columnIndex];
		try {
			var viewletContainer = new ViewletContainer(args);	
			viewletContainer.addListener(dojo.hitch(this, this._onChange), Constants.PROPERTY_DASHBOARD);
			viewletContainer.addListener(dojo.hitch(this, this._onChange), Constants.PROPERTY_CONTRIBUTOR_INFO);
			viewletContainer.setTrim(RQMDEFAULTTRIM);
			
			if (viewletIndex != -1 && column.widgets.length >= viewletIndex) {
				// insert at given index
				column.add(viewletContainer, {index: viewletIndex, handle: viewletContainer._header, type: "viewlet", animate: true});
			} else {
				// append to the end of the column
				column.add(viewletContainer, {handle: viewletContainer._header, type: "viewlet", animate: false});
			}
			this._setEmptyTabMessage(false);
		} catch(e) {
			console.error(e);
		}
	}
});

})();

