//debug welcome
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WelcomeViewlet");
dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.asq.common.web.ui.internal.util.DomConstructor");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet");

(function() {

/*
 * Aliases
 */
var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var AbstractViewlet = com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet;
/*
 * A viewlet with welcome information for RQM
 */
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WelcomeViewlet",
	AbstractViewlet, {
	
	templateString: "<div><div dojoAttachPoint=\"_content\" \><span class=\"loading\">${labelLoading}</span></div>",
	
	labelLoading: Constants.getMessage("labelLoading"),
	developmentEnv: false,
	
	postCreate: function()
	{
		this.inherited( "postCreate", arguments );
		var data = "<div style='padding:1px 1px 12px 1px;'>" +
				   "<iframe frameborder='0' width='100%' height='400px'" + 
				   ( ( this.developmentEnv ) ? " src='/jazz/web/com.ibm.rqm.planning.web/ui/internal/view/viewlets/WelcomeTestData.html'>" : 
				   						   " src='/help/rtopic/com.ibm.rational.test.qm.welcome.doc/topics/qm_welcome.html?lang=" + dojo.locale + "'>" ) +
				   "</iframe>" +
				   "</div>";
				   
		var dom = new com.ibm.asq.common.web.ui.internal.util.DomConstructor( data );
		this.helpContent = dom.domNode;
		this._content.replaceChild(this.helpContent, this._content.firstChild);
		if (window.addEventListener) {
			window.addEventListener( "resize", dojo.hitch( this, this._onResize ), false );
		}
		else
		{
			window.attachEvent( "onresize", dojo.hitch( this, this._onResize ) );
		}
	},
	
	refresh: function() {
		this.getSite().setLoading(true);
		this.update();
		this.getSite().setLoading(false);
		this.getSite().doneRefresh();
	},
	
	update: function() {
		if (this._error) {
			var errorSpan = document.createElement("span");
			errorSpan.innerHTML = "<span class=\"error\">Error: " + this._error.message + "</span>";
			this._content.replaceChild(errorSpan, this._content.firstChild);
		}
		else {
//			var data = 
//				"<div>" +
//				"<style type='text/css'>" +
//				"body {font-size: x-small; font-family: sans-serif;}" +
//				"h1, h2, h3 {font-size: small; color: #f26721; }" +
//				"</style>" +
//				"<h2>Welcome to IBM Rational Quality Manager</h2>" +
//				"<p>IBM Rational Quality Manager is a collaborative, web-based, quality management solution that offers comprehensive test planning and project management for the full software lifecycle. </p>" +
//				"<div>" +
//				"<h3>Announcements</h3>" +
//				"<p>Join us on the <a href='http://qualitymanager.wordpress.com/'>Rational Quality Manager blog</a> where you can " +
//				"have your questions answered and share your thoughts about how Quality Manager is progressing.</p>" +
//				"<h3>Getting acquainted</h3>" +
//				"<p>Take a few minutes to become familiar with some of the key features of Rational Quality Manager.</p>" +
//				"<ul>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.qm.doc/topics/c_qm_overview.html' TARGET='_blank'>Product overview</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.qm.doc/topics/t_plan_tests.html' TARGET='_blank'>Planning the test effort</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.qm.doc/topics/t_construct_scripts.html' TARGET='_blank'>Developing test scripts</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.qm.doc/topics/t_run_tests.html' TARGET='_blank'>Running your tests</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.lm.doc/topics/t_manage_lab_machines.html' TARGET='_blank'>Managing lab machines</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.lm.doc/topics/t_working_with_lab_requests.html' TARGET='_blank'>Working with lab requests</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.qm.doc/topics/t_analyze_test.html' TARGET='_blank'>Evaluating tests results</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.qm.doc/topics/t_migrate_to_qm.html' TARGET='_blank'>Migrating your test assets</a></li>" +
//				"</ul>" +
//				"<h3>Tutorials</h3>" +
//				"<p>Complete the following tutorials for a quick overview of Rational Quality Manager.</p>" +
//				"<ul>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.qm.tutorial.doc/topics/as_qm_abstract.html' TARGET='_blank'>Getting started with Rational Quality Manager</a></li>" +
//				"<li><a href='/help/index.jsp?topic=/com.ibm.rational.test.lm.tutorial.doc/topics/a_managelabres.html' TARGET='_blank'>Managing your lab resources</a></li>" +
//				"</ul>" +
//				"</div>" +
//				"</div>";
				
			setTimeout( dojo.hitch( this, this._getWelcomePage ), 100 );
		}
	},
	
	_getWelcomePage: function()
	{
		var contentWrapper = this._getContentWrapper();
		var height = "400";
		var units = "px";
		
		if( this.container.isZoomed && contentWrapper )
		{
			height = contentWrapper.style.height.match( /^[0-9]+/ );
			if (height) {
				units = contentWrapper.style.height.match( /[a-z]+/ );
				units = ( units ) ? units : "";
				height = height - 25;
			}
		}
		
		var iframe = this._getIframe( this._content );
		if( iframe )
		{
			iframe.setAttribute( "height", height + units );
		}		
	},
	
	_getContentWrapper: function()
	{
		var parent = this._content;
		while( parent )
		{
			if( parent.tagName.toLowerCase() == "div" && 
				parent.className == "content-wrapper" )
			{
				return( parent );
			}
			
			parent = parent.parentNode;
		}
		
		return( null );
	},
	
	_getIframe: function( parent )
	{	
		var iframe = null;
		
		for( var iNode = 0; ( iframe == null ) && ( iNode < parent.childNodes.length ); iNode++ )
		{
			if( parent.childNodes[ iNode ].tagName.toLowerCase() == "iframe" )
			{
				return( parent.childNodes[ iNode ] );
			}
			else
			{
				iframe = this._getIframe( parent.childNodes[ iNode ] )
			}
		}
		
		return( iframe );
	},
	
	_onResize: function()
	{
		if( this.container.isZoomed )
		{
			this.update();
		}
	}
});

})();
