//QueryConfigurationsView
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dojo.parser");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.PageUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.ConfigurationsTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.LRDSelectorDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.table.AbstractFilteredTableView");

(function() 
{
	var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
	var ConfigurationUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
	var PageUtil = com.ibm.rational.test.lm.web.ui.internal.pages.PageUtil;
    var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
    var AbstractFilteredTableView = com.ibm.rational.test.lm.web.ui.internal.views.table.AbstractFilteredTableView;
	var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
	var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
    var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
    
dojo.declare("QueryConfigurationsView.TocTableProvider",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    getNumColumns: function(content)
    {
        return 8;
    },
    
    getColumnHeading: function(content, index)
    {
        var headings = [
            RtlmUiUtil.getCatalogMessage("pl_name"),
            RtlmUiUtil.getCatalogMessage("Database"),
            RtlmUiUtil.getCatalogMessage("pl_operatingsystem"),
            RtlmUiUtil.getCatalogMessage("ApplicationServer"),
            RtlmUiUtil.getCatalogMessage("Browser"),
            RtlmUiUtil.getCatalogMessage("TestTool"),
            RtlmUiUtil.getCatalogMessage("CPU"),
            RtlmUiUtil.getCatalogMessage("ManagementAgent")
        ];
        return headings[index];
    },

     
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 13;
            case 1: 
                return 13;
            case 2: 
                return 13;
            case 3: 
                return 13;
            case 4: 
                return 13;
            case 5: 
                return 9;
            case 6: 
                return 13;
            case 7: 
                return 13;
        }
        return 0;
    },
    
    getContentObjects: function(content)
    {
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        if (atColumnIndex == 0) {
            type = TableConstants.RENDER_TYPE_ACTION;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name;
                break;
            case 1: 
                val = rowData.database;
                break;          
            case 2: 
                val = rowData.os;
                break;          
            case 3: 
                val = rowData.appServer;
                break;          
            case 4: 
                val = rowData.browsers;
                break;          
            case 5: 
                val = rowData.testTools;
                break;          
            case 6: 
                val = rowData.cpu;
                break;          
            case 7: 
                val = rowData.managementAgent;
                break;          
        }
        return val;
    },


     getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0) {
            val = {};
            val['index'] = rowData.id;
        }

        return val;
    }  
});

dojo.declare("QueryConfigurationsView.TableProvider",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    getNumColumns: function(content)
    {
        return 3;
    },
    
    _columnHeadings: [
		"",
        RtlmUiUtil.getMessage("cfgName"),
        RtlmUiUtil.getMessage("cfgSummary")
    ],
    
    getColumnHeading: function(content, index)
    {
        return this._columnHeadings[index];
    },

    
    getColumnIdName: function(index)
    {
        if(index == 1) {
            return "name";
        }
        return null;
    },
	 
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return atColumnIndex > 0;   
    },

    _columnWidths: [1,34,65],
    
    getColumnWidth: function(content, atColumnIndex)
    {
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content)
    {
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        if (atColumnIndex == 0) {
            type = TableConstants.RENDER_TYPE_IMAGE;
        } else if (atColumnIndex == 1) {
            type = TableConstants.RENDER_TYPE_LINK;
        }
        
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        
        if (atColumnIndex == 1) {
            val = rowData.name;
        } else if ((atColumnIndex == 2) && (rowData.summary != null)) {
            val = rowData.summary;
        } 

        return val;
    },

     getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0) {
            val = {};
            val['href'] = ConfigurationUriUtil.getEditConfigurationURI( rowData.id );
			val['image'] = ImageCache.CONFIGURATION_ICON;
        }
        else if(atColumnIndex == 1) {
            val = {};
            val['href'] = ConfigurationUriUtil.getEditConfigurationURI( rowData.id );
        }

        return val;
    }  
    
    
});


//Handler for the TOC table cell click
dojo.declare("QueryConfigurationsView.TOCCellModifier",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, 
{
	constructor: function(view) {
		this._view = view;
	},
	
	cellActionInvoked: function(rowObject, columnIndex)
    {
		//Get the config ID out of the row data and open 
		var URI = ConfigurationUriUtil.getEditConfigurationURI( rowObject.configID );
		window.location.href = URI;
    }
});

dojo.declare("QueryConfigurationsView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection, defaultToMine, addSnapshotsFilter) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		this.defaultToMine = (defaultToMine === true);
		this.addSnapshotsFilter = addSnapshotsFilter;

        // define the static filters
        this.filters = [];
		this.filters.push({
	        name: "name",  // must match key in the arg list of the API
	        title: RtlmUiUtil.getCatalogMessage("pl_name"),
	        promptTitle: RtlmUiUtil.getCatalogMessage("pl_name"),
	        type: TableContentFilterProvider.FIELD_TEXT,
	        defaultValue: null, 
	        params: null
        });
    },

    getTitle: function() {
        return RtlmUiUtil.getRQMMessage("labelFilterTitle");    
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getSummaryText: function() {
        return RtlmUiUtil.getRQMMessage("labelFilterDescriptionAllVisible",RtlmUiUtil_getMessage("cfgConfigurationsPageTitle"));
    },
    
    getInitialVisibleFilterCount: function() {
        return 5;    
    },
	
    getFilters: function() {
        return this.filters;
    },	
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: RtlmUiUtil.getRQMMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: RtlmUiUtil.getRQMMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters.
        this.tableView.tableViewer.clearContentFilters();
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
            }
        }
        this.tableView.runQuery(args);
    }
});


dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView", 
	[dijit._Widget, dijit._Templated,AbstractFilteredTableView], 
{
	//This line is NECESSARY fot the attachPoints in the PageLayout to get instantiated
	widgetsInTemplate: true,
	
	//The layout of the page.
	templateString: 
		'<div id="${id}" dojoAttachPoint="domNode">' +
		'<div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout"' +
		'     dojoAttachPoint="myPageLayout" isCompact="true" noline="true">' + 		
		' <!-- The table of configurations -->  '+
		' <div dojoAttachPoint="configurations_panel"> '+
		'   <table width="100%" cellpadding="12" cellspacing="12"> '+
		'       <tr> '+
		'          <td> '+
		'               <!-- table resultarea --> '+
		'               <div dojoAttachPoint="resultDiv" > '+
		'               </div> '+
		'          </td> '+
		'       </tr> '+
		'       <tr>' +
		'          <td>' +
        '              <span dojoAttachPoint="TOCTitle" class="view-subtitle"></span>' +
		'          </td>' +
		'       </tr>' +
		'       <tr> '+
		'          <td> '+
		'               <!-- detail grid are --> '+
		'               <div dojoAttachPoint="detailDiv" > '+
		'               </div> '+
		'          </td> '+
		'       </tr> '+		
		'   </table> '+
		' </div>' +
		'</div>'+
		'</div>',

    
    postCreate: function()
    {
        com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView.superclass.postCreate.apply(this);
		//Set the title and cs help id on the page
		this.myPageLayout.setTitle(RtlmUiUtil_getMessage("cfgConfigurationsPageTitle"));
		this.myPageLayout.setCSHelpId("rtlm_view_all_configurations.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.myPageLayout.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", "", RtlmUiUtil_getMessage("cfgConfigurationsPageTitle")));		
		
		this.maxItemCount = 1000;
		jazz.core.loader.load_async("com.ibm.rqm.planning.web.client.internal.PreferenceClient", function(){});	
		//Create the table that will hold the reservations
		this.createTable();
		
		//Create the grid that will show the content of a selelcted config
		this.createTOC();
		this.initRunQuery();	
	},
	
	_onRefreshActionClick: function()
	{
		this.loadTable();
	},

	_onCopyActionClick: function()
	{
		var rows = this.tableViewer.getCheckedRows();  
		//Should only be enabled if 1 row is selected so just get the first one
		var configID = rows[0].id;
		
		//Open up the editor with a copy of the selected config.
		var URI = ConfigurationUriUtil.getCopyConfigurationURI( configID );
		window.location.href = URI;
	},
	
	_onPreviewClick : function()
	{
		var rows = this.tableViewer.getCheckedRows();
		
		var configID = rows[0].id;

		if (configID) 
		{
			var configService =  new com.ibm.rational.test.lm.web.client.internal.config();
			var rh = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "loadTOC", "_getConfigDetailsError");
			configService.retrieveConfigurationWithDetails(rh, configID);
		}
    },
	
	loadTOC : function(response)
	{
		this._view.loadTOC(response);
		dijit.scrollIntoView(this._view.detailDiv);	
	},
	
	createTable: function()
	{
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-LM-TE-TABLEVIEWER"                                
        });
		this.resultDiv.appendChild( this.tableViewer.domNode );
		this._initializeFilters();
		this.initFilterProvider(this.filterProvider);
        this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
		this.tableViewer.setTableMajorMode(TableConstants.MAJOR_MODE_GRID);
        var QueryConfigurationsView_TableProvider = new QueryConfigurationsView.TableProvider();
		this.tableViewer.setContentProvider(QueryConfigurationsView_TableProvider);
		this.tableViewer.setContentPageSize(10);
		this.tableViewer.setTableRowsCheckable(true, false);
		this.tableViewer.setTableListener(this);
		this.tableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("cfgConfigurationsPageTitle")));
        this.tableViewer.setContent( [] );  
        this.tableViewer.show();       

        var tePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_TEST_ENVIRONMENT);  
        var reqPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_REQUEST);  

		//Refresh Action
        this.refreshAction = this.tableViewer.addAction("Refresh", RtlmUiUtil_getMessage("Refresh"), null, "refresh-icon-image", dojo.hitch( this, this._onRefreshActionClick ) );

		//Copy Action
        if(!tePerm || tePerm[PermissionsClient.ACTION_CREATE]) {       
            this.copyAction = this.tableViewer.addAction("Copy", RtlmUiUtil_getMessage("labelCopyButton"), null, "copy-icon-image", dojo.hitch( this, this._onCopyActionClick ) );
		    this.copyAction.setDisabled(true);
	    }
        			
		//Preview Button
        this.previewAction = this.tableViewer.addAction("Preview", RtlmUiUtil_getMessage("labelPreview"), null, "preview-icon-image", dojo.hitch(this, this._onPreviewClick));
        this.previewAction.setDisabled(true);
        
		//Create Request Action
        if (!reqPerm || reqPerm[PermissionsClient.ACTION_CREATE]) {
		    this.createRequestAction = this.tableViewer.addAction("CreateRequest", RtlmUiUtil_getMessage("createRequestAction"), null, "create-request-icon-image",dojo.hitch(this, "_createRequest"));
		    this.createRequestAction.setDisabled(true);	
		}

		//Create Test Cell Action
        if (!reqPerm || reqPerm[PermissionsClient.ACTION_CREATE]) {
		    this.createTCAction = this.tableViewer.addAction("CreateTestCell", RtlmUiUtil_getMessage("createTestCellAction"), null, "create-testcell-from-TE-icon-16",dojo.hitch(this, "_createTestCell"));
		    this.createTCAction.setDisabled(true);	
		}
        
        // Search Asset action
		this.searchAction = this.tableViewer.addAction("Search", RtlmUiUtil_getMessage("searchAssetAction"), null, "search-icon-image", dojo.hitch(this, "_searchAssets"));
		this.searchAction.setDisabled(true);

		// Delete action
        if (!tePerm || tePerm[PermissionsClient.ACTION_ARCHIVE]) {
            this.deleteAction = this.tableViewer.addAction("Delete", RtlmUiUtil_getMessage("cfgDelete"), null, "delete-icon-image", dojo.hitch(this, "_deleteConfig"));
            this.deleteAction.setDisabled(true);
        }
	},
	
	createTOC: function()
	{
		this.TOCTable = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		this.detailDiv.appendChild( this.TOCTable.domNode );
		
		this.TOCTable.setTableMajorMode(TableConstants.MAJOR_MODE_GRID);
        var TocTableProvider = new QueryConfigurationsView.TocTableProvider();
		this.TOCTable.setContentProvider(TocTableProvider);
		this.TOCTable.setContentPageSize(10);
        var TOCCellModifier = new QueryConfigurationsView.TOCCellModifier(this);
		this.TOCTable.setCellModifier(TOCCellModifier);
		this.TOCTable.setShowingFilterControl(false);
        this.TOCTable.setShowingPagingControl(false);		
	},
	
	loadTable: function()
	{
		//Disable the actions before we refresh
        if(this.createRequestAction)
		    this.createRequestAction.setDisabled(true);	
		this.searchAction.setDisabled(true);

		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadTable", "_errorFunc");
		configs.getAll(responseHandler);
    },	
	
	_loadTable: function(response)
	{
		this.tableViewer.setContent( ( response ) ? response : [] );  
		this.tableViewer.refresh();       
	},
	
	loadTOC : function(response)
	{
		if (response.configuration) 
		{
			this.TOCTitle.innerHTML = response.name;

			var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
			var config = catalog.createConfigurationFromJson(response.configuration);
			
			//Build the content to be passed to the TOC
			var content = [];
			var partCount = config.getRootParts().length;
			for (var i = 0; i < partCount; i++) 
			{
				var rowData = {};
				var thisPart = config.getRootPart(i);
				var thisLabel = config.getLabel(i);
				rowData.configID = response.id;
				rowData.id = i;
				rowData.name = thisLabel;
				rowData.database = config.getValueByIndex(i, "DataBase");
				rowData.os = config.getValueByIndex(i, "OperatingSystem");
				rowData.appServer = config.getValueByIndex(i, "Application Server");
				rowData.browsers = config.getValueByIndex(i, "Browsers");
				rowData.testTools = config.getValueByIndex(i, "TestTools");
				rowData.cpu = config.getValueByIndex(i, "CPU");
				rowData.managementAgent = config.getValueByIndex(i, "ManagementAgent");
				content.push(rowData);
			}
			
			this.TOCTable.setShowingPagingControl(partCount > 10);
			this.TOCTable.setContent(content);
			this.TOCTable.show();
		}
		
	},
	
	_errorFunc: function(errorType, errorMessage) 
	{
		// bring down the working dialog
		RtlmUiUtil.hideWorkingDialog();
//		setWidgetContent('current_reservation_results', getMessage("userHmFailGetMyReservations"));
	},
	
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) 
	{
		callback(callbackData);
	},
	tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	_createRequest:function()
	{
		var rows = this.tableViewer.getCheckedRows();
		
		var configID = rows[0].id;
		var args;
		if(configID)
            args = {'configId': configID};
		
        var newRequestUri = com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil.getNewRequestURI(args);
        window.location.href = newRequestUri;
	},

	_createTestCell:function()
	{
		var rows = this.tableViewer.getCheckedRows();
		
		var configID = rows[0].id;
		var args;
		if(configID)
            args = {'testEnvironmentID': configID};
		
        var newTCUri = com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil.getNewTestCellURI(args);
        window.location.href = newTCUri;
	},
	
	_deleteConfig : function()
	{
		var rows = this.tableViewer.getCheckedRows();
		var len = rows.length;
		var args = {
            'message': RtlmUiUtil_getMessage("configConfirmDelete",len),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil_getMessage("msgConfirmTitle"));
        confirmDialog.open();
	},
	
	_deleteAction: function() {
		var rows = this.tableViewer.getCheckedRows();
        var rows_length = rows ? rows.length : 0;
		if (rows_length == 0)
			return;
		
		var idArray = [];
		for (var i = 0; i < rows_length; i++)
		{
			idArray.push(rows[i].id);
		}
		var configService =  new com.ibm.rational.test.lm.web.client.internal.config();
		var rh = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_deleteSuccess", "_deleteError");
		configService.deleteConfigurations(rh, idArray);
	},
	
	_deleteSuccess : function(response)
	{
        // broadcast the delete event including to itself to clean up the table
        dojo.publish(GlobalEvents.ArtifactsDeleted, [RtlmUiUtil.TYPE_CONFIG, this.tableViewer.getCheckedRows()]);
	},
	
	_deleteError : function(response)
	{
        var details = (response && response.message) ? response.message : null;
        this.myPageLayout.setStatus(RtlmUiUtil_getMessage("cfgMsgActionError"), ViewHeaderLayout.ERROR, details);
	},
	
	
	//Methods for performing the search action
	_searchAssets: function()
	{
		var rows = this.tableViewer.getCheckedRows();
		var configID = rows[0].id;

		if (configID) 
		{
			var configService =  new com.ibm.rational.test.lm.web.client.internal.config();
			var rh = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_getConfigDetailsForSearchSuccess", "_getConfigDetailsError");
			configService.retrieveConfigurationWithDetails(rh, configID);
		}
	},
	
	
	_getConfigDetailsForSearchSuccess: function(response) 
	{
		if (response.configuration) 
		{
		 	var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
			var config = catalog.createConfigurationFromJson(response.configuration);
			var parts = config.getRootParts();
		
			if (parts.length > 1) 
			{
				// Prompt user which part to search
                var dialog_args = {title: RtlmUiUtil_getMessage("cfgSelectAssetForSearch"), defaultID:response.id};
				this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.LRDSelectorDialog(dialog_args);
				this.selectDlg.setOKAction( dojo.hitch( this, this._handleConfigPartSelectOK ) );
				this.selectDlg.show();
			}
			else 
				if (parts.length == 1) 
				{
					var args = {'type' : "Machine",
								'initialConfigID' : response.id,
								'initialPartIndex' : 0};
			
					window.location.href = AssetUriUtil.getSearchAssetURIWithArgs(args);
				}
		}
	},
	
	_handleConfigPartSelectOK: function(){
		var selectedPart = this.selectDlg.getSelectedAssetDescriptor();
		if(selectedPart) 
		{
			var args = {'type' : "Machine",
						'initialConfigID' : this.selectDlg.getSelectedConfigID(),
						'initialPartIndex' : this.selectDlg.getSelectedIndex()};
			
			window.location.href = AssetUriUtil.getSearchAssetURIWithArgs(args);
		}
	},

	_getConfigDetailsError: function(response) 
	{
		console.debug(response);
	},
		
	rowCheckStateChanged: function(tableViewer, rowObject, state)
	{
        this._updateTableActions();
        this.myPageLayout.clearStatus();
	},
	
    _updateTableActions: function()
    {
        //determine how many rows are checked
        var numCheckedRows = this.tableViewer.getCheckedRows().length;
        
        if(this.createRequestAction)
            this.createRequestAction.setDisabled(numCheckedRows != 1);

		if (this.createTCAction)
            this.createTCAction.setDisabled(numCheckedRows != 1);
			            
        this.searchAction.setDisabled(numCheckedRows != 1);
        this.previewAction.setDisabled(numCheckedRows != 1);
        
        if(this.copyAction)
            this.copyAction.setDisabled(numCheckedRows != 1);
        
        if(this.deleteAction)    
            this.deleteAction.setDisabled(numCheckedRows == 0);        
    },
    
    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about config
        if (artifactType == RtlmUiUtil.TYPE_CONFIG) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // refresh table on add to sync up with server
                this.loadTable();
            } else {
                var content = this.tableViewer.getContent();
                var content_length = content.length;
                // iterate through the array of artifacts
                var artifactArray_length = artifactArray.length;
                for (var i = 0; i < artifactArray_length; i++) {
                    // iterate through the array of config in the table
                    for (var j = 0; j < content_length; j++) {
                        // handle the matching content
                        if (artifactArray[i].id == content[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap config on update
                                content.splice(j, 1, artifactArray[i]);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove config from table on delete
                                content.splice(j, 1);
                                content_length -=1;
                            }
                            break;
                        }
                    }
                }
                this.tableViewer.setContent(content);
                this.tableViewer.refresh();
                this._updateTableActions();
            }
        }
    },
	_searchFunc:function(responseHandler,args){
		if(!args.maxItemCount)
			args.maxItemCount = this.maxItemCount;
		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		configs.searchConfigs(responseHandler,args);
	},
	_initializeFilters: function() {
        // create the filter provider for the table
		this.setSearchFunction(dojo.hitch(this, "_searchFunc"));
		this.setSearchCallback(dojo.hitch(this, "_loadTable"));
		this.setTypeLabel(RtlmUiUtil_getMessage("cfgConfigurationsPageTitle"));
        this.filterProvider = new QueryConfigurationsView.TableFilterProvider(this, this.isInitiallyOpen(), this.isDefaultsToMine(), false);
        this.moreFilters = [];
		
		var args = {projectAreaItemId: getCurrentProjectArea().itemId,keyPrefix: "com.ibm.rqm.artifact.preferences"}
		var handler = new ServiceResponseHandler(this, "_setPreferences", "_error");
		com.ibm.rqm.planning.web.client.internal.PreferenceClient.getPreferenceEntries(handler, args.projectAreaItemId, args.keyPrefix);
    },
	_setPreferences:function(preferences){
		if (preferences) {
			var fullKey = "com.ibm.rqm.artifact.preferences.Configuration.searchResultLimit";
            var pref_length = preferences.length;
			for (var i = 0; i < pref_length; i++) {
				if (preferences[i].key == fullKey) {
					this.maxItemCount = preferences[i].value;
				}
			}
		}
	},
	_error:function(errorObj){
		console.error(errorObj.message);
	}
});

})();
