/*************************AUTOMATIONSVIEW************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
 
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.propertyeditor.PropertyEditor");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");

dojo.require("com.ibm.rational.test.lm.web.client.internal.inventory");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.util.DomConstructor");
dojo.require("com.ibm.asq.common.web.client.internal.admin");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.AutomationsMachinesTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.AutomationsTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.JobStatusTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.AbstractForm");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
//
// Summary:
//
(function() {
	
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
var RtlmUiUtil_getCommonMessage = RtlmUiUtil.getCommonMessage;

var autoTbl = '<div dojoAttachPoint="domNode" class="automation-section-area">' +
              '  <div dojoAttachPoint="jobsNode" style="width:100%;">' +
              '  </div>' +
              '  <div dojoAttachPoint="machinesNode" style="width:100%;">' +
              '  </div>' +
              '</div>';

var RelatedInfoPanel=com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel;              
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var adminService = new com.ibm.asq.common.web.client.internal.admin();
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ONE_SEC = 1000;
	
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView", 
    [dijit._Widget, dijit._Templated,
     com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin,
     com.ibm.rational.test.lm.web.ui.internal.widgets.AbstractForm],
{    
    templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/views/inventory/templates/AutomationsView.html"),
    widgetsInTemplate: true,
	listTable: null,
	asset: null,
	assetType: null,
    assetTypeNames:null,
	insideEditor: false,
    staticRelatedInfo: null,
    refreshInterval: ONE_SEC * 8, // the interval to auto refresh the deploy view. 
    
    getStaticRelatedInfo: function() {
        return this.staticRelatedInfo;
    },
        
    getStaticRelatedInfoId: function() {
        return "com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView"
    },

    postCreate: function() {
        this.inherited("postCreate", arguments);

		//NOTE: If this is inside the editor, section needs to be passed to this widget.
		if(!this.insideEditor){
	        this.staticRelatedInfo = new RelatedInfoPanel();
	        this.staticRelatedInfo.addLink(RtlmUiUtil_getMessage("labelRelatedSites"),
	                                       RtlmUiUtil_getMessage("productBuildForge"),
	                                       "http://www-306.ibm.com/software/awdtools/buildforge/enterprise/index.html");
	
			this.viewHeaderNode.setTitle(RtlmUiUtil_getMessage("labelAutomations"));
			this.viewHeaderNode.setCSHelpId("rtlm_view_automation.html", com.ibm.rational.test.lm.web.CSHelpID);
			this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", "", "Automation"));
		}			
		this.section = new com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer( {
			title: RtlmUiUtil_getMessage("labelAutomations"),
            hideToolbarOnReadOnly: false,
            headerActionsAlign: "right",
            collapsible: !this.insideEditor,
            open: true
		} );
        
        // hide unused header div's
        this.section.infoNode.style.display = "none";
        this.section.summaryNode.style.display = "none";
        
        // If we're been show as a view, we can run the automation immeidately
        // Otherwise, we only allow the user to edit the properties only.
        if (!this.insideEditor) {
            this.runbutton = this.section.addAction(RtlmUiUtil_getMessage("labelRun"), dojo.hitch(this, this._runAutomation), null, null, "execute-icon-image");
            this.runbutton.setDisabled( true );                             
        }
        else {
            var callback = dojo.hitch(this, "_editAutomationParameters");
            var label = RtlmUiUtil_getCommonMessage("Properties");
            
            this.editProperties = this.section.addAction(label, callback, null, null, "edit-icon-image");
            this.editProperties.setDisabled( true ); 
            if(this.okButton){
                this.okButton.disabled = true;
            }                                        
        }
		this.refreshbutton = this.section.addAction( RtlmUiUtil_getMessage("labelRefreshButton"), 
								dojo.hitch( this, this.updateAutomationsForMachines),
								null,
                                null,
								"refresh-icon-image" );
								
		var automationPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_AUTOMATION);  
	    if(!automationPerm || automationPerm[PermissionsClient.ACTION_RUN]) {   				
	    	this.refreshbutton.setDisabled(false);
	    }
        else{
			this.refreshbutton.setDisabled(true);
		}
		
		this.machinesNjobs = new com.ibm.asq.common.web.ui.internal.util.DomConstructor( autoTbl );
		this.section.contentNode.appendChild( this.machinesNjobs.domNode );
		this._clearViewAndUpdate();
		this.formAreaNode.appendChild( this.section.domNode );
    
        // limit the page size of the tables to 5 when it's in dialog mode.
        var tableArgs = {
            showPagingRangeControl: this.insideEditor ? false : true,
            pageSize: this.insideEditor ? 5 : -1
        };
        this.automationsTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(tableArgs);
		this.automationsTableViewer.setTableRowsCheckable( true, true );
		this.jobsbanner.contentNode.appendChild( this.automationsTableViewer.domNode );
        var automationsTableProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.AutomationsTableProvider();
        this.automationsTableViewer.setContentProvider(automationsTableProvider); 
        this.automationsTableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("Automation")));

        this.automationsTableViewer.setContent( [] );
        this.automationsTableViewer.show();
			
        this.machinesTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(tableArgs);
		this.machinesTableViewer.setTableRowsCheckable( true );
		this.machinesection.contentNode.appendChild( this.machinesTableViewer.domNode );
        var automationsMachinesTableProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.AutomationsMachinesTableProvider( "Machine" );
        this.machinesTableViewer.setContentProvider(automationsMachinesTableProvider);
        this.machinesTableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("navMach")));

        var empty_data = {Data:[]};
        this.machinesTableViewer.setContent(empty_data);
        this.machinesTableViewer.show();

        this.machinesNjobs.jobsNode.appendChild( this.jobsbanner.domNode );
        this.machinesNjobs.machinesNode.appendChild( this.machinesection.domNode );
		
		
        if(!automationPerm || automationPerm[PermissionsClient.ACTION_RUN] || this.insideEditor) 
		      this.updateAutomationsForMachines();  
		
		if(this.insideEditor){			
			this.machinesTableViewer.showLoadingProgress();
			this.automationsTableViewer.showLoadingProgress();
		}
		
        //Listeners
        var m_listener = new com.ibm.rational.test.lm.web.ui.internal.views.providers.AutomationMachinesListener( {"receiver": this, "automationstbl": this.automationsTableViewer } );
        this.machinesTableViewer.setTableListener( m_listener );
        var a_listener = new com.ibm.rational.test.lm.web.ui.internal.views.providers.AutomationsListener( {"receiver": this, "machinestbl": this.machinesTableViewer} );
        this.automationsTableViewer.setTableListener( a_listener );
        
		if(!this.insideEditor){
	        this.operationsTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            allowAdjustSettings: true,
	            autoSaveSettings: true,
	            tableId: "RQM-LM-JOB-STATUS-TABLEVIEWER"                                
	        });
	        this.operationsTableViewer.setContentPageSize( 10 );
			this.operationsTableViewer.setTableRowsCheckable( false );
            var jobStatusTableProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.JobStatusTableProvider();
	        this.operationsTableViewer.setContentProvider(jobStatusTableProvider);
			this.operationsTableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("Operation")));
			
			var modifier = new com.ibm.rational.test.lm.web.ui.internal.views.providers.JobStatusCellModifier( this );
	        this.operationsTableViewer.setCellModifier( modifier );
	       	//Set initial sorting so that the sorting is not random on the items within the group
	       	this.operationsTableViewer.sortDir = this.operationsTableViewer.getContentProvider().getInitialSortDirection();
	       	this.operationsTableViewer.sortByColumn = this.operationsTableViewer.getContentProvider().getInitialSortByColumn();
	
            this.operationsTableViewer.addAction("Refresh", 
                        RtlmUiUtil_getMessage("labelRefreshButton"),
                        null,
                        "refresh-icon-image",
                        dojo.hitch(this, "_refreshRunningAutomations"));
                        
	        this.opersection.contentNode.appendChild( this.operationsTableViewer.domNode );
	        this.resultAreaNode.appendChild( this.opersection.domNode );
	        
	        this.operationsTableViewer.setContent( [] );
	        this.operationsTableViewer.show();
		}
		this.permissionsHash = {};
        
        // save our view's uri for comparison later when
        // auto refreshing.
        if (!this.insideEditor) {
            this.autoRefresh = false;
            this.myViewUri = window.location.hash;
            this._initAutoRefreshAutomation();
        }   
    },

    // Summary:
    //    Initilaize the view to auto refresh the deploy entries. It sets up a toggle to 
    //    start/stop auto refreshing in the deploy section and starts the timer event to
    //    periodically re-fetch the deploy data.
    //
    //    NOTE: The UI part is not used at this point. Control auto refresh internally. 
    //    When we fetch the operations status we detect whether there're running automation
    //    jobs. If there're, we'll turn on auto-refresh, when there're no more running jobs
    //    we automatically turn off auto-refresh.
    //    
    _initAutoRefreshAutomation: function()
    {
        /*
         * 
         * DISABLE VISIBLE UI FOR REFRESH CONTROL
         *
        this.opersection.infoNode.style.display = "";
        
        var args = {'checked':this.autoRefresh};
        this.autoRefreshToggle = new dijit.form.CheckBox(args);
        this.autoRefreshToggle.domNode.style.margin = "0em 0.3em 0em 0.5em";
        this.connect(this.autoRefreshToggle, "onChange", dojo.hitch(this, "_toggleAutoRefresh"));
        
        this.opersection.infoNode.appendChild(this.autoRefreshToggle.domNode);
        
        var autoRefreshLabel = document.createElement("span");
        autoRefreshLabel.innerHTML = RtlmUiUtil_getMessage("labelAutoRefreshDeployView");
        autoRefreshLabel.style.marginTop = "0.7em";
        this.opersection.infoNode.appendChild(autoRefreshLabel);
        */
       
        // setup the timer to auto refresh the deploy view
        if (this.autoRefresh) {
            this.refreshViewTimer = setInterval(dojo.hitch(this, "autoRefreshView"), this.refreshInterval);
        }    
    },
    
    // Summary:
    //    Turn on/off auto refresh of automation results. 
    //
    _toggleAutoRefresh: function()
    {
        // NOTE: 
        // no direct UI control at this point yet. Only using the 
        // internal control variable to enable/disable auto refresh
        // of automation results.
        //
        var isChecked = this.autoRefresh;//this.autoRefreshToggle.checked;
        
        if (isChecked) {
            if (!this.refreshViewTimer) {
                // initiate a refresh right away and enable the timer to refresh.
                this.autoRefreshView();
                this.refreshViewTimer = setInterval(dojo.hitch(this, "autoRefreshView"), this.refreshInterval);
            }
        }
        else {
            this.clearAutoRefresh();
        }    
    },
	
	_update: function()
	{
		this._search();
	},
	
	_search: function()
    {
    	this.viewHeaderNode.clearStatus();

		this.automationsTableViewer.setContent( [] ); 
		this.automationsTableViewer.refresh();
        this.automationsTableViewer.showLoadingProgress();
		            				
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_searchSuccess", "_searchError");
		inven.getAllAutomations( responseHandler );
    },
		
	_searchSuccess: function( response )
	{
        this.automationsTableViewer.endLoadingProgress();   
		this.automationsTableViewer.setContent( ( response ) ? response : [] );
        this.automationsTableViewer.refresh();
	},
	
	_searchError: function( message, error )
	{
        this.automationsTableViewer.endLoadingProgress();   
        this.automationsTableViewer.setContent( [] );
        this.automationsTableViewer.refresh();
	},
	
	updateAutomationsForMachines: function( ids )
	{
		this.viewHeaderNode.clearStatus();
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_displayAutomationsAndMachines", "_updateAutomationsFailure");
		inven.updateAutomations( responseHandler );
	},
	 
	showAutomationsForMachines: function()
	{
		this.refreshbutton.callbackData = dojo.getObject( "com.ibm.rational.test.lm.web.machines" );
		dojo.setObject( "com.ibm.rational.test.lm.web.machines", null );
        if (this.runbutton) {
            this.runbutton.domNode.style.display = "";
        }
        this.permissionsHash = {};
		this._clearViewAndUpdate();
		this._displayAutomationsAndMachines( null );
	},
	
	_displayAutomationsAndMachines: function( response )
	{
		// clear the table contents first, before fetching the data.
        var empty_data = {Data:[]};
        this.machinesTableViewer.setContent(empty_data); 
        this.machinesTableViewer.refresh();
        this.machinesTableViewer.showLoadingProgress();
		
        this.automationsTableViewer.setContent( [] ); 
        this.automationsTableViewer.refresh();
        this.automationsTableViewer.showLoadingProgress();

		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_searchSuccess", "_searchError");
		if( !( this.refreshbutton.callbackData ) )
			inven.getAllAutomations( responseHandler );
		
		if( this.refreshbutton.callbackData )
		{
			this._getMachinesSuccess( this.refreshbutton.callbackData );
		}
		else
		{
			var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
			var config = catalog.createConfiguration( "Machine" );
			var searchParam = { configuration: config,
                                columns: "machine.id, machine.name" };
			
			var machineHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_catalogSearchSuccess", "_catalogSearchFailure");
			catalog.search( machineHandler, searchParam );
			
		}
		
		this._refreshRunningAutomations();
	},
	
	_updateAutomationsFailure: function( errorObj )
	{
		this._displayAutomationsAndMachines();
	},

    _checkRunPermissionForMachineId: function(id)
    {
        if(this.permissionsHash[id]) {
            return this.permissionsHash[id]["canAutomate"];
        }
        // optimistically set to has permission.
        return true;
    },
    
    _enableRunButton: function()
    {
        var button = this.runbutton || this.editProperties;
        if(!button) {
            return;
        }
        var machines = this.machinesTableViewer.getCheckedRows();
        var jobs = this.automationsTableViewer.getCheckedRows();
        var disable = jobs.length == 0 || machines.length == 0;
        
        this.viewHeaderNode.clearStatus();
        
        if (!disable && machines.length > 0) {
            var machines_length = machines.length;
            for (var i = 0; i < machines_length; i++) {
                var rowData = machines[i];
                var runPerm = this._checkRunPermissionForMachineId(rowData["machine.id"]);
                
                if(!runPerm) {
                    disable = true;
                    
                    // show a message in the header to indicate no perm to
                    // run automations.
                    this.viewHeaderNode.setStatus(
                        RtlmUiUtil_getMessage("noAutomationPermissions"), 
                        ViewHeaderLayout.WARNING, 
                        RtlmUiUtil_getMessage("noAutomationPermissionsDetails"));
                    break;
                }
            }
        }        
        button.setDisabled( disable );
         if(this.okButton){
                this.okButton.disabled = disable;
            } 
    },
    
    _fetchMachinePermissionsAndCheckButtonState: function()
    {
        var rows = this.machinesTableViewer.getCheckedRows();
        
        // deselection
        if (rows.length == 0) {
            this._enableRunButton();
            return;
        }
        
        var fetchPermList = [];
        var rows_length = rows.length;
        for (var i = 0; i < rows_length; i++) {
            var id = rows[i][( "machine.id" )];
            
            if(!this.permissionsHash[id]) {
                fetchPermList.push(id);
            }
        }            
        
        // we have all of the permissions for the rows, can check right away
        if(fetchPermList.length == 0) {
            this._enableRunButton();
            return;
        }
        
        var responseHandler = new ServiceResponseHandler
        (
            {
                _self: this,
                _success: function (perms) {
                    if (perms) {
                        // store the permissions in a table hashed by its id.
                        var perms_length = perms.length;
                        for (var i = 0; i < perms_length; i++) {
                            this._self.permissionsHash[perms[i]['itemId']] = perms[i];
                        }
                    }
                    this._self._enableRunButton();
                },
                _failure: function (errObj) {
                    // optimistically disables permission check
                    this._self._enableRunButton();
                }
            },
            "_success",
            "_failure"
        );
        
        // fetches the permissions for the rows, before we start the button
        // enablement check.
        adminService.getResourcePermissions(responseHandler, fetchPermList);
        
    },
    
    
	_catalogSearchSuccess: function( results )
	{
        // clear the permission cache. We've refetched 
        // the machine list.
        this.permissionsHash = {};
		this._automationMachinesSuccess( results );
	},
	
	_catalogSearchFailure: function( errObj )
	{
        this.viewHeaderNode.setStatus(
            RtlmUiUtil_getMessage("automateFetchMachinesError"), 
            ViewHeaderLayout.ERROR, 
            (errObj && errObj.message) ? errObj.message : null);
			
        this.machinesTableViewer.endLoadingProgress();
        var empty_data = {Data:[]};
        this.machinesTableViewer.setContent(empty_data);
        this.machinesTableViewer.refresh();
	},
	
	_automationMachinesSuccess: function( results )
	{
        this.machinesTableViewer.endLoadingProgress();   
        this.machinesTableViewer.setContent( results );
        this.machinesTableViewer.refresh();
	},
	
	_automationMachinesFailure: function( errObj )
	{
	},
	
	_getMachinesSuccess: function( results )
	{   		                 
        var ids = [];
        
        var data_length = results.Data.length;
        for( var iMachine = 0; iMachine < data_length; iMachine++ )
        {
        	ids.push( results.Data[ iMachine ][ 0 ] );
        }
        
        this.machinesTableViewer.endLoadingProgress();   
		this.machinesTableViewer.setContent( results );
        this.machinesTableViewer.refresh();
        
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_searchSuccess", "_searchError");
		var inven = new com.ibm.rational.test.lm.web.client.internal.inventory();
        inven.getAutomationsForAsset( responseHandler, ids );
        
        //Check the machines that have been selected to run a job on
		if( this.refreshbutton.callbackData && this.refreshbutton.callbackData.Data )
		{
			var states = {};
            var selected = false;
			var machineids = ( dojo.isArray( this.refreshbutton.callbackData.Data ) ) ? this.refreshbutton.callbackData.Data : [this.refreshbutton.callbackData.Data];
            var machineids_length = machineids.length;
	    	for( var iId = 0; iId < machineids_length; iId++ )
	    	{
                // TODO: We really shouldn't just use the table viewer's
                // internals to select the rows. We should create the neccessary
                // table API to select rows programatically.
                // 
	    		if( this.machinesTableViewer.orderedObjects )
	    		{
                    var orderedObjects_length = this.machinesTableViewer.orderedObjects.length;
			    	for( var iGroup = 0; iGroup < orderedObjects_length; iGroup++ )
			    	{
			    		if( this.machinesTableViewer.orderedObjects[ iGroup ] )
			    		{
                            var group_length = this.machinesTableViewer.orderedObjects[ iGroup ].length;
			    			for( var iMachine = 0; iMachine < group_length; iMachine++ )
			    			{
					    		if( this.machinesTableViewer.orderedObjects[ iGroup ][ iMachine ][ "machine.id" ] == machineids[ iId ][ 0 ] )
					    		{
					    			states[ machineids[ iId ][ 0 ] ] = { checked: true, rowObject: this.machinesTableViewer.orderedObjects[ iGroup ][ iMachine ] };
                                    selected = true;
					    			break;
					    		}
				    		}
			    		} 
			    	}
		    	}
	    	}
	    	
	    	this.machinesTableViewer.rowCheckedHandler.rowStates = states;
            
            // there're pre-selected machines. Check the permissions to enable the run button
            if(selected)
                this._fetchMachinePermissionsAndCheckButtonState();
    	}
    	
    	this.machinesTableViewer.refresh();
    },

	_getMachinesError: function( error )
	{
        this.machinesTableViewer.endLoadingProgress();   
        this.machinesTableViewer.setContent( [] );
        this.machinesTableViewer.refresh();
	},
	
	_runAutomation: function( event )
	{
        var okCallback = dojo.hitch(this, function() {
            this.viewHeaderNode.clearStatus();
            var autoData = this._getIdsFromTable( this.automationsTableViewer, "jobId", ["providerName", "providerInstance", "jobName"] );
            this.machineData = this._getIdsFromTable( this.machinesTableViewer, "machine.id");
            if (autoData["ids"].length > 0 && this.machineData["ids"].length > 0) {
                var parameters = this._getAutomationParameters();
                this._providerName = autoData["extra"]["providerName"];
                this._jobName = autoData["extra"]["jobName"];
                var inventory = new com.ibm.rational.test.lm.web.client.internal.inventory();
                var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_automationSuccess", "_automationError");
    
                this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("msgStartAutoOp"));
                inventory.runAutomation(responseHandler, this.machineData["ids"], autoData["ids"][0], autoData["extra"]["providerName"], autoData["extra"]["providerInstance"], parameters);
            }
        });
        this._editAutomationParameters(okCallback, /* cancelCallback */ null);
	},
	
	_automationSuccess: function( response )
	{
        this.viewHeaderNode.setProgressEnd();         
		if (response && (response.rc != "SPIRC_NO_ERROR")) {
			var msgKey = response.rc;
			if (msgKey == "SPIRC_PROVIDER_CONNECTION_ERROR") {
				msgKey = "providerConnectedError";
			} else if (msgKey == "SPIRC_PROVIDER_CONNECTION_AUTH_ERROR") {
				msgKey = "providerAuthError";
			} else if (msgKey == "SPIRC_RESOURCE_NOT_FOUND") {
				msgKey = "resourceNotFound";
			}			
			var message = RtlmUiUtil_getMessage(msgKey, this._providerName, this._jobName);
			if (response.message) {
			    message += ": " + response.message;
			}
			this.viewHeaderNode.setStatus(message, ViewHeaderLayout.ERROR);
		}
		else {
            // start auto refresh to refetch automation results periodically.
            this.autoRefresh = true;
			this._toggleAutoRefresh();
		}
	},
	
	_automationError: function( errorObj )
	{
        var details = (errorObj && errorObj.message) ? errorObj.message : null;
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("ErrStartAutoOp"), ViewHeaderLayout.ERROR, details);    
	},
	
    _hasRunningOperations: function(response)
    {
        if(!response)
            return false;
            
        var response_length = response.length;
        for(var i = 0; i < response_length; i++) {
            var opRec = response[i];
            
            if(opRec.state['name'] != 'STOPPED')
                return true;
        }
        return false;
    },
    
	_getOperationsSuccess: function( response )
	{	
        if(this.operationsTableViewer){
			this.operationsTableViewer.endLoadingProgress();
	        this.operationsTableViewer.setContent( ( response ) ? response : [] );
	        this.operationsTableViewer.refresh();
        }
        // check for running operations. Change our auto-refresh state
        // based on the whether we've running ops, if the two states
        // are different, change the auto refresh status. Basically, turn ON 
        // autoRefresh if we've active ops, or turn OFF autoRefresh if we 
        // don't have active ops anymore.
        var hasRunningOp = this._hasRunningOperations(response);
        
        if (this.autoRefresh != hasRunningOp) {
            this.autoRefresh = hasRunningOp;
            this._toggleAutoRefresh();
        }
	},
	
	_getOperationsError: function( errObj )
	{
        if(this.operationsTableViewer){
			this.operationsTableViewer.endLoadingProgress();
	        this.operationsTableViewer.setContent( [] );
	        this.operationsTableViewer.refresh();
		}	
	},
	
	_getIdsFromTable: function( table, idKey, extraargs )
	{
		var ids = [];
		var data = { "ids":[], "extra": {}};
		
		var rows = table.getCheckedRows()
		var rows_length = rows.length;
		for( var iRow = 0; iRow < rows_length; iRow++ )
		{
			data[ "ids" ].push( rows[ iRow ][ idKey ] );
			if( extraargs )
			{
				var extra = {};
				
                var extraargs_length = extraargs.length;
				for( var iProp = 0; iProp < extraargs_length; iProp++ )
				{
					extra[ extraargs[ iProp ] ] = rows[ iRow ][ extraargs[ iProp ] ]
				}
				
				data["extra"] = extra;
			}
		}
				
		return( data );
	},
	
	_clearViewAndUpdate: function()
	{
        if (!this.jobsbanner) {
			this.jobsbanner = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({
				title: RtlmUiUtil_getMessage("labelAutomationToRun"),
                titleSize: "10pt",
                bgShading: false,
				collapsible: false
			});
            this.jobsbanner.setTitleMode(false);
            this.jobsbanner.showTitleOnly();
			dojo.addClass(this.jobsbanner.contentNode, "automation-inner-section-top");
		}
		this.viewHeaderNode.clearStatus();
		
		this._constructOperationsSection();
	    
        if (!this.machinesection) {
            this.machinesection = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({
                title: RtlmUiUtil_getMessage("labelAvailMachForAutomation"),
                titleSize: "10pt",
                bgShading: false,
                collapsible: false
            });
            this.machinesection.setTitleMode(false);
            this.machinesection.showTitleOnly();
            dojo.addClass(this.machinesection.contentNode, "automation-inner-section");
        }
	},
	
	_constructOperationsSection: function()
	{
		if( !(this.opersection) )
		{
			this.opersection = new com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer( {
					title: RtlmUiUtil_getMessage("labelRunningAutomations"),
                    hideToolbarOnReadOnly: false,
                    headerActionsAlign: "right",
                    open: true } );
            // hide unused header div's
            this.opersection.infoNode.style.display = "none";
            this.opersection.summaryNode.style.display = "none";
		}
	},
	
	_constructMachinesSection: function()
	{
		var args = {
			title: RtlmUiUtil_getMessage("labelAvailMachForAutomation"),
            collapsible: false
		};
        
		this.machinesection = ( this.machinesection ) ? this.machinesection :
			new com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea(args);
		
	},
	
	_refreshRunningAutomations: function()
	{
		this.viewHeaderNode.clearStatus();
		var inventory = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_getOperationsSuccess", "_getOperationsError");
        
        // clear the current contents first and show the loading status.
        if(this.operationsTableViewer){
			this.operationsTableViewer.setContent( [] );
	        this.operationsTableViewer.refresh();
	        this.operationsTableViewer.showLoadingProgress();
		}	
		inventory.getAutomationOperations( responseHandler );		
	},
	
    _editAutomationParameters: function(okHandler, cancelHandler)
    {        
        var propEditor = new com.ibm.asq.common.web.ui.internal.widgets.propertyeditor.PropertyEditor({showFrame:false});
        var args = {
            primaryTitle: RtlmUiUtil_getCommonMessage("Properties"),
            isClosable: true,
            okCallback: dojo.hitch(this, function() {
                var props = propEditor.getProperties();
                this.editedProperties = this._convertNameValueProperty(props);
                if(okHandler)
                    okHandler();
            }),
            cancelCallback: cancelHandler
        };          
        var paramDialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);  
        
        this._loadAutomationParameters(propEditor, this.selectedAutomation.parameters);
        paramDialog.contentContainer.appendChild(propEditor.domNode);
        paramDialog.open();
    },
    
    _getAutomationParameters: function() 
    {
        if(this.editedProperties)
            return this.editedProperties;
            
        if(this.selectedAutomation)
            return this.selectedAutomation.parameters;
        
        return null;    
    },
        
    update: function( rowData, state )
    {
        // this method is called from the automation table's row selection event. 
        // record the selected automation.
        this.selectedAutomation = null;
        this.editedProperties = null;
        
        // this is selection event, save the selected automation
        if( state )
        {
            this.selectedAutomation = rowData;
            this.editedProperties = this.selectedAutomation.parameters;
        }
    },

    _loadAutomationParameters: function(propWidget, params) 
    {
        propWidget.clear();
        if (params) {
            var param_length = params.length;
            for (var i = 0; params && (i < param_length); i++) {
                // configure all server properties to be non-deletable. The user 
                // can only edit them, but cannot remove them.
                propWidget.addProperty(params[i].name, params[i].value, /*can delete*/ false);
            }
        }
    },
    
    _convertNameValueProperty: function(properties)
    {
        // Converts the properties returned by the properties editor, which is an
        // associative array to an array of name, value objects.
        
        var jobProps = [];    
        for(var propName in properties) {
            jobProps.push({name: propName, value: properties[propName]});
        }
        return jobProps;
    },
    
	cancelJob: function( jobId )
	{
		var inventory = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_cancelSuccess", "_cancelError");
		inventory.cancelJob( responseHandler, jobId );
	},
	
	_cancelSuccess: function( results )
	{
		this._refreshRunningAutomations();
	},
	
	_cancelError: function( errObj )
	{
	},

    autoRefreshView: function()
    {
        // if our page is not in view, don't waste the cycle to update
        // the jobs data. Suspend the refresh until we're in view again.
        if (dojo.isDescendant(this.domNode, document) && this.myViewUri == window.location.hash) {
            this._refreshRunningAutomations();
        }
    },
    
    clearAutoRefresh: function()
    {
        if(this.refreshViewTimer) {
            clearInterval(this.refreshViewTimer);
            delete this.refreshViewTimer;
        }
    },
    
	getCurrentSelectionFromTables: function(){
		var args = {};
        
		args.machines = this.machinesTableViewer.getCheckedRows();
        args.jobs = this.automationsTableViewer.getCheckedRows();
		var properties = this._getAutomationParameters();
		args.jobs[0]["parameters"] = properties;
        
		return args;
	},
	
    uninitialize: function()
    {
        // the page is being removed. Clear any timers that we've started.
        this.clearAutoRefresh();
        // remove the related info panel
        if (this.staticRelatedInfo){
			this.staticRelatedInfo.destroy();
		}        
    }     
});

})();
