// ********  ARCHIVED ASSETS VIEW ********* //

/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.ArchivedAssetsView");

//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.SimpleAssetsView");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

(function() 
{
var MachineInfo = com.ibm.rational.test.lm.web.ui.internal.views.providers.SimpleMachineSearchInfo;
//var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
    
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.ArchivedAssetsView", 
             com.ibm.rational.test.lm.web.ui.internal.views.machines.SimpleAssetsView, 
{
    constructor: function()
    {
        this.tableId = "RQM-LM-ARCHIVED-ASSET-TABLEVIEWER";       
    },
    
    initializeViewHeader: function()
    {
        // load the asset's state types
        this.assetStateTypeNames = ["delete", "hide"];
        this.assetStateType = "delete";
        
        //Set the title and cs help id on the page
        this.viewHeaderNode.setTitle(RtlmUiUtil_getMessage("MachTitleArchived"));
        this.viewHeaderNode.setCSHelpId("rtlm_managedellabres.html", com.ibm.rational.test.lm.web.CSHelpID);
        this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", RtlmUiUtil_getMessage("MachTitleArchived"), ""));
    },

    //Asset selector methods
    _constructAssetSelector: function()
    {
        var views = [];
        var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
        this.assetTypeNames = catalog.getAssetTemplateNames();

        // create a different view for each of the asset type in different state types.                
        for(var i in this.assetTypeNames) {
            for (var j in this.assetStateTypeNames) {
                var queryType = this.assetTypeNames[i] + "," + this.assetStateTypeNames[j];
                var opts = {
                    'name': RtlmUiUtil_getMessage("view" + this.assetTypeNames[i] + "-" + this.assetStateTypeNames[j]),
                    'value': queryType
                };
                views.push(opts);
            }
        }
        this.assetType = this.assetTypeNames[0];
        this.assetStateType = this.assetStateTypeNames[0];
        this.tableViewer.setTableContentSelectors(views);
    },

    tableContentSelectionChanged: function(tableViewer, contentSelectionValue)
    {
        var types = contentSelectionValue.split(',');
        var assetType = types[0];
        this.assetStateType = types[1];
        this._loadAssetType(assetType);
    },
        
    getSearchParameters: function()
    {
        this._searchAttributeCriteria = MachineInfo.getSearchAttributeCriteria()[this.assetType];
        var searchParam = {
            configuration: this.asset,
            visibility: (this.assetStateType == "delete") ? "ARCHIVED" : "HIDDEN",
            columns: ( this._searchAttributeCriteria )
        };
        return searchParam;
    },
    
    _searchSuccess: function( response )
    {
        if (!response.Header) {
            var colnames = this._searchAttributeCriteria.replace(/, /g,',');
            colnames = colnames.split(',');
            response.Header = colnames;
        }

        this.tableViewer.noItemMessage = "";

        this.refreshButton.setDisabled( false );
        this.viewHeaderNode.setProgressEnd();
        this.tableViewer.endLoadingProgress();

        this.tableViewer.setContent( response );
        this.tableViewer.refresh();
        this._checkButtonStatus();  
    },
    
    _searchError: function( message, error )
    {
        this.refreshButton.setDisabled( false );
        this.viewHeaderNode.setProgressEnd();
        this.tableViewer.endLoadingProgress();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgFetchHideDeletedError"), ViewHeaderLayout.ERROR);     
    },
    
    _updateTableAction: function()
    {
        
    },
    
    createTableProvider: function()
    {
        var assetType = (this.assetType == "Machine") ? "ArchiveMachine" : this.assetType;
        var tableProvider = new com.ibm.rational.test.lm.web.ui.internal.views.providers.SimpleMachineSearchTableProvider(assetType);
        tableProvider.receiver = this;
        
        if(this.assetStateType == "delete") {
            tableProvider.setAssetStateIsDeleted();
        }
        return tableProvider;                
    },
        
    createTableActions: function()
    {
        this.refreshButton = this.tableViewer.addAction( "Search", RtlmUiUtil_getMessage("Refresh"), null, "refresh-icon-image", dojo.hitch( this, "_searchAssets"));
        this.restoreButton = this.tableViewer.addAction("Restore", RtlmUiUtil_getMessage("labelRestoreButton"), "restore", "restore-icon-image", dojo.hitch(this, "_archiveSelected"));
        this.restoreButton.setDisabled(true);
    },
    
    _checkButtonStatus: function()
    {
        var checkedRows = this.tableViewer.getCheckedRows();
        this.restoreButton.setDisabled( checkedRows.length == 0 );
    },

    // handler on artifacts deleted or restored
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        if ((artifactType == RtlmUiUtil.TYPE_MACHINE) || (artifactType == RtlmUiUtil.TYPE_VM)) {
            if ((changeType == GlobalEvents.ArtifactsDeleted) || (changeType == GlobalEvents.ArtifactsUndeleted)) {
                // convert asset objects to query result objects
                var queryObjArray = [];
                var artifactArray_length = artifactArray.length;
                for (var i = 0; i < artifactArray_length; i++) {
                    var queryObj = this.assetObjToQueryObj(artifactArray[i]);
                    if (queryObj) {
                        queryObjArray.push(queryObj);
                    } else {
                        // can't convert asset object to query result object, reload the table
                        this._searchAssets();
                        return;
                    }
                }

                // get the current result table content
                var content = this.tableViewer.getContent();

                if (changeType == GlobalEvents.ArtifactsDeleted) {
                    // artifacts deleted, add to the result table
                    content.Data = content.Data.concat(queryObjArray);
                    this.tableViewer.setContent(content);
                    this.tableViewer.refresh();
                } else if (changeType == GlobalEvents.ArtifactsUndeleted) {
                    var queryObjArray_length = queryObjArray.length;
                    var data = content.Data;
                    var data_length = data.length;
                    // artifacts restored, remove from the result table
                    for (var i = 0; i < queryObjArray_length; i++) {
                        // iterate through the array of assets in the table
                        for (var j = 0; j < data_length; j++) {
                            // handle the matching asset
                            if (queryObjArray[i][0] == data[j][0]) {
                                // remove restored entry from table
                                data.splice(j, 1);
                                break;
                            }
                        }
                    }
                    this.tableViewer.setContent(content);
                    this.tableViewer.refresh();
                }
            }
        }
    }
});

})();   