//Group Detail View
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//

//
//
// Author: P. Chu
//
// Summary:
//    
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DatePicker");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.asq.common.web.client.internal.admin");
dojo.require("com.ibm.rational.test.lm.web.client.internal.group");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.GroupUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetSelectorDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("net.jazz.ajax.ui.PlatformUI");

(function() {

var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var ProjectArea = com.ibm.team.process.web.client.projectarea;
var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var machineCol = "machine.id, machine.name, machine.operatingsystem, machine.Manufacturer, machine.assetfamily," +
"VirtualImage.id, VirtualImage.name, VirtualImage.operatingsystem, VirtualImage.ImageType, VirtualImage.assetfamily";
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants; 
var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

var RtlmUiUtil_getMessage = RtlmUiUtil.getMessage;
var RtlmUiUtil_getCommonMessage = RtlmUiUtil.getCommonMessage;
var LOADING = RtlmUiUtil_getMessage("appWorking");
var ViewHeaderLayout_ERROR = ViewHeaderLayout.ERROR;
var ViewHeaderLayout_INFO = ViewHeaderLayout.INFO;
var ViewHeaderLayout_WARNING = ViewHeaderLayout.WARNING;

// Augment the search criteria for the 'Add' asset selection query. This is to include the 
// Manufacterer & assetFamily fields that we display in our member asset list display.
//
var SearchCriteria = {
    'Machine' : "machine.id, machine.name, machine.group, machine.operatingsystem, machine.ipAddress, machine.assetfamily, machine.Manufacturer",
    'VirtualImage' : "VirtualImage.id, VirtualImage.name, VirtualImage.ImageType, VirtualImage.group, VirtualImage.operatingsystem, VirtualImage.VMFile, VirtualImage.assetfamily"
};
// The attribute map to map the 'Add' asset selection query result to our member asset list
// row data format. The selection query result is transformed to an associative array indexed by
// the field names. Our member asset list row data is an array of values.
//
var AssetAttributeMap = {
    'Machine' : ["machine.id", "machine.name", "machine.operatingsystem", "machine.Manufacturer", "machine.assetfamily"],
    'VirtualImage' : ["VirtualImage.id", "VirtualImage.name", "VirtualImage.operatingsystem", "VirtualImage.ImageType", "VirtualImage.assetfamily"]
};

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView", 
    [dijit._Widget, dijit._Templated, com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormListener],
{    
    templateString: ['<div class="group-detail-view" dojoAttachPoint="domNode" tabindex="-1">' ,
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode"' ,
                    '       titleEditable="true" summaryEditable="true">' ,
                    '    <table border="0" dojoAttachPoint="relocateInfoNode">' ,
                    '      <tr>' ,
                    '        <td valign="middle" nowrap><span dojoAttachPoint="labelStartDate" class="attributes-entry-label"></span></td>' ,
                    '        <td valign="middle" nowrap><span dojoAttachPoint="startDateNode"></span></td>' ,
                    '        <td valign="middle"></td>' ,
                    '        <td valign="middle" nowrap><label dojoAttachPoint="labelTeam" class="attributes-entry-label" for="lm-group-edit-team-area"></label></td>' ,
                    '        <td width="100%" valign="middle">' ,
                    '          <select id="lm-group-edit-team-area" dojoAttachPoint="teamAreaSelector" class="attributes-entry-value"></select>' ,
                    '        </td>' ,
                    '      </tr>' ,
                    '      <tr>' ,
                    '        <td valign="middle" nowrap><span dojoAttachPoint="labelExpirationDate" class="attributes-entry-label"></span></td>' ,
                    '        <td valign="middle" nowrap><span dojoAttachPoint="expirationDateNode"></span></td>' ,
                    '        <td valign="middle">' ,
                    '          <span class="date-container">' ,
                    '            <input type="checkbox" id="no-expiration-checkbox" style="vertical-align:middle;margin-left:20px" dojoAttachPoint="expirationDateCheckbox"' ,
                    '                   dojoAttachEvent="onclick:_onExpirableChecked">' ,
                    '            </input><label dojoAttachPoint="labelNeverExpire" class="attributes-entry-label" for="no-expiration-checkbox"></label>' ,
                    '          </span>' ,
                    '        </td>' ,
                    '      </tr>' ,
                    '    </table>' ,
                    '    <div dojoType="com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer"',
                    '         dojoAttachPoint="assetsNode" open="true" hideToolbarOnReadOnly="false">' ,
                    '    </div>' ,
                    '  </div>' ,
                    '</div>'].join(""),

    widgetsInTemplate: true,
	removeAssetActionNode: null,
	
    // initial status message and state to display when the view is done loading
    statusMessage: null,
    statusState: null,
    
    // the group ID being viewed.
    groupId: null,
    
    // if the group is new (doesn't exist yet)
    isNew: false,
    
    // the actual group object
    group: null,
	originalGroup: null,

    groupService: null,
    
    discardButtonNode: null,
    saveButtonNode: null,

    _startDateField: null,
    _expirationDateField: null,
    
    assetTableViewer: null,
    
    deleted: false, // flag to indicate if this group is deleted

    postCreate: function() {
        this.inherited("postCreate", arguments);

        this.labelTeam.innerHTML = RtlmUiUtil_getMessage("labelRequiredTeamArea");
        this.labelStartDate.innerHTML = RtlmUiUtil_getMessage("labelStartDate");
        this.labelExpirationDate.innerHTML = RtlmUiUtil_getMessage("labelExpirationDate");
        this.labelNeverExpire.innerHTML = RtlmUiUtil_getMessage("labelNeverExpire");
        
        this.addAssetList = [];
        this.removeAssetList = [];
        
        if (this.isNew) {
            this.viewHeaderNode.setCSHelpId("rtlm_create_group.html", com.ibm.rational.test.lm.web.CSHelpID);
			this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", RtlmUiUtil_getMessage("labelNew"), RtlmUiUtil_getMessage("labelGroupType")));
        }
        this.viewHeaderNode.setIconClass("machine-group-icon-48");
        this.viewHeaderNode.setNoValueEditableTitleLabel(RtlmUiUtil_getMessage("labelNewGroupTitlePrompt"));
        this.viewHeaderNode.setTypeLabel(RtlmUiUtil_getMessage("labelGroupType"));
        this.viewHeaderNode.onTitleEdited = dojo.hitch(this, "_onGroupNameChanged");
        this.viewHeaderNode.onSummaryEdited = dojo.hitch(this, "_onDescriptionChanged");
		this.viewHeaderNode.setSummaryLabel(RtlmUiUtil_getMessage("description"));

        this.discardButtonNode = this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("discard_button"), dojo.hitch(this, "_onDiscardActionClick"), null, null);
        this.saveButtonNode = this.viewHeaderNode.addRightViewAction(RtlmUiUtil_getMessage("save_button"), dojo.hitch(this, "_onSaveActionClick"), null, null);
        
        // create the start date 
        this._startDateField = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
            name: "startDate",
            value: "",
            invalidMessage: RtlmUiUtil_getMessage("reqMsgDateInputFormat"),
            nonExistDateMessage: RtlmUiUtil_getMessage("regMsgNonExistDate"),
            onChange: dojo.hitch(this, "_onStartDateChanged"),
            onkeyup: dojo.hitch(this, "_onStartDateChanged"),
            "class": "text-field",
            fieldLabel: RtlmUiUtil_getMessage("labelStartDate")
            });
        this.startDateNode.appendChild(this._startDateField.domNode);
        this._startDateField.init();
                            
        // create the expiration date 
        this._expirationDateField = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
            name: "expirationDate",
            value: "",
            invalidMessage: RtlmUiUtil_getMessage("reqMsgDateInputFormat"),
            nonExistDateMessage: RtlmUiUtil_getMessage("regMsgNonExistDate"),
            onChange: dojo.hitch(this, "_onExpirationDateChanged"),
            onkeyup: dojo.hitch(this, "_onExpirationDateChanged"),
            "class": "text-field",
            fieldLabel: RtlmUiUtil_getMessage("labelExpirationDate")
            });

        this.expirationDateNode.appendChild(this._expirationDateField.domNode);
        this._expirationDateField.init();

        // set up the TeamArea selector
        this.connect(this.teamAreaSelector, "onchange", "_onTeamAreaChanged");
        var teamArea = GroupUtil.getAllTeamArea();
       
        var empty_option = new Option( "", "" );
		SelectUtility.add( this.teamAreaSelector, empty_option );

        var teamArea_length = teamArea.length;
        for (var i = 0; i < teamArea_length; i++) {
            var team_option = new Option( teamArea[i].name, teamArea[i].uuid );
			SelectUtility.add( this.teamAreaSelector, team_option );
        }

        // relocate the info node in template string to the header
        this.viewHeaderNode.getInfoAttributesNode().appendChild(this.relocateInfoNode);

        // create the assets table
        var table_provider = new GroupAssetsTable.TableProvider(this);
        var table_listener = new GroupAssetsTable.TableListener(this);
		this.assetTableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
        this.assetTableViewer.setContentProvider(table_provider);
        this.assetTableViewer.setTableRowsCheckable(true);
		this.assetTableViewer.setTableListener(table_listener);
		this.assetTableViewer.setTableSummary(RtlmUiUtil_getMessage("labelTableSummary", RtlmUiUtil_getMessage("labelAsset")));
        this.assetTableViewer.setContent([]);
        this.assetTableViewer.show();
        
        if (this._hasEditPermission()) {
            this.addResourceButton = this.assetTableViewer.addAction("_addAssets",
                RtlmUiUtil_getMessage("labelAddToGroup"), 
                null, //callback data
                "add-icon-image",
                dojo.hitch(this, "_onAddResourceClick"));
                         
            this.removeAssetActionNode = this.assetTableViewer.addAction("_releaseAssets", // action id
                RtlmUiUtil_getMessage("labelReleaseFromGroup"), // label
                null, //callback data
                "delete-icon-image", //icon class
                dojo.hitch(this, "_onReleaseAssetActionClick")); // callback
            this.removeAssetActionNode.setDisabled(true);        
        }
        this.assetsNode.setTitle(RtlmUiUtil_getMessage("labelGroupAssets"));
        this.assetsNode.setCSHelpId("rtlm_lgroup_sect_labresource.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.assetsNode.setCSHelpButtonLabel(RtlmUiUtil_getMessage("labelHelp", "", RtlmUiUtil_getMessage("labelGroupAssets")));
		this.assetsNode.containerNode.appendChild(this.assetTableViewer.domNode);
		
        this.groupService = new com.ibm.rational.test.lm.web.client.internal.group();

		this._loadForm();
        if (this.isNew) {
            // for new lab resource group set focus to the title
            this.viewHeaderNode.setEditableTitleFocus();
        }
	},
    
    uninitialize: function() {
        if (this.groupService)
            this.groupService = null;
    },

    _hasEditPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE_GROUP);  
        return (!perm || perm[PermissionsClient.ACTION_EDIT]);           
    },
    
	_loadForm: function() {
        this.viewHeaderNode.clearStatus();
        this.discardButtonNode.setDisabled(true);
        this.saveButtonNode.setDisabled(true);
        
        this._clearEdited();
        
        if (this.isNew) {
            this._loadFormAssets();
            this._clearForm();
        } else {
            this._loadGroupById(this.groupId);
        }
	},
	
    _loadGroupById: function(id) {
        this.viewHeaderNode.setProgressStart(LOADING, /*hideContent*/true);
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadGroupSuccess", "_loadGroupFailure");
        this.groupService.getGroupById(responseHandler, id);
    },
    
    _loadGroupSuccess: function(response) {
        // got the group data
        this.group = (response);
		this.stateId = response.stateId;
        
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadAssetsSuccess", "_loadAssetsFailure");
        this.groupService.searchForAllAssetsInGroup(responseHandler, this.groupId, machineCol);
        this.assetTableViewer.showLoadingProgress();

        // show the proper asset's name in its parent container.
        var label_arg = [window.location.hash, this.group.name, "machine-group-icon-16", false];
        dojo.publish(GlobalEvents.UpdateTabLabel, label_arg);
		
		// update browserTitle
		this._updateBrowserTitle();
    },
    
    _loadGroupFailure: function(response) {
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("errLoadGroupInfo"), ViewHeaderLayout_ERROR);    

        var details = (response && response.message) ? response.message : null;
        com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(RtlmUiUtil_getMessage("labelGroupType"), details);
    },
    
    _loadAssetsSuccess: function(response) {
        this.viewHeaderNode.setProgressEnd();
        
        this.assetTableViewer.endLoadingProgress();
        this.group.assets = response.Data;
        this._loadFormData();
    },
    
    _loadAssetsFailure: function(response) {
        this.viewHeaderNode.setProgressEnd();
        this.assetTableViewer.endLoadingProgress();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("errLoadAssetInfo"), ViewHeaderLayout_ERROR);    
        this._loadFormData();
    },
    
    _loadFormData: function() {
        // load general group info to header
        this.viewHeaderNode.setTitle(this.group.name);
        this.viewHeaderNode.setSummary(this.group.description ? this.group.description : "");

		this._setTeamAreaValue(this.group.teamArea);
        if(this.group.startDate) {
            this._startDateField.setValue(this.group.startDate);  
        } else {
            this._startDateField.setDisplayedValue("");
        }
        if (this.group.expirable) {
            this._expirationDateField.setValue(this.group.expirationDate);
        } else {
            this._expirationDateField.setDisplayedValue("");
        }
        this.expirationDateCheckbox.checked = !this.group.expirable;
        this._expirationDateField.setDisabled(this.expirationDateCheckbox.checked);
        
        // Refresh (discard changes) will reload the form and there could be invalid date in the form.
        // Validate will clear the invalid icon in the fields.
        this._startDateField.validate();
        this._expirationDateField.validate();
        
        // load assets info
        this._loadFormAssets();
        this._updateActionButtons();   

        // set initial status message if one is set. When after save success, the page is
        // reloaded. The success message needs to be shown.
        if (this.statusMessage) {
            this.viewHeaderNode.setStatus(this.statusMessage, this.statusState ? this.statusState : ViewHeaderLayout_INFO);
            this.statusMessage = null;
            this.statusState = null;
        }             
    },
    
    _loadFormAssets: function() {
        var sandboxAssets = [];

        // create the 'sandbox' list of items. This includes
        // not yet saved add assets and remove assets
        if(this.group && this.group.assets) {
            sandboxAssets = sandboxAssets.concat(this.group.assets);
            
            // apply the substractive assets
            var rmlist = this.removeAssetList;
            var rmlen = rmlist.length;
            if(rmlen > 0) {
                var provider = this.assetTableViewer.getContentProvider();
                for(var i = 0; i < rmlen; i++) {
                    var id = provider.getRowDataId(rmlist[i]);
                    this._removeFromAssetList(sandboxAssets, id);
                }
            }
        }
        sandboxAssets = sandboxAssets.concat(this.addAssetList);
        
        this.assetTableViewer.setContent(sandboxAssets);
		this.assetTableViewer.refresh();

        // update the status for the member asset count.
        var message = RtlmUiUtil_getMessage("msgNoAssetInGroup"); 
        if (this.addAssetList.length > 0 || this.removeAssetList.length > 0) {
            message = "";
            var needBreak = false;
            if (this.addAssetList.length > 0) {
                message = RtlmUiUtil_getMessage("msgAssetsAdded", this.addAssetList.length);
                needBreak = true;
            }
            if (this.removeAssetList.length > 0) {
                if(needBreak) {
                    message += "<br/>";
                }
                message = message + RtlmUiUtil_getMessage("msgAssetsRemoved", this.removeAssetList.length);            
            }
        }
        else if(this.group && this.group.assets && this.group.assets.length > 0) {
            message = RtlmUiUtil_getMessage("msgAssetsNumberInGroup", this.group.assets.length);
        }
        this.assetsNode.setSummary(message);
    },
    
    _getIdsForAssets: function(assets) {
        var assetIds = [];
        var assetsLen = assets ? assets.length : 0;
        var provider = this.assetTableViewer.getContentProvider();
        
        for (var i = 0; i < assetsLen; i++) {
            var id = provider.getRowDataId(assets[i]);
            if (id) assetIds.push(id);
        }
        return assetIds;
    },
    
    _onSaveActionClick: function() {
		GroupUtil.setGroupsListValid(false);
        var responseHandler = new ServiceResponseHandler(this, "_saveSuccess", "_saveFailure");
        
        if (this.isNew) {
            this.groupService.createGroup(responseHandler,
										  this._getTeamAreaValue(),
                                          !this.expirationDateCheckbox.checked,
                                          this.viewHeaderNode.getTitle(),
                                          this.viewHeaderNode.getSummary(),
                                          this.expirationDateCheckbox.checked ? null : this._getDateValue(this._expirationDateField),
                                          this._getDateValue(this._startDateField),
                                          false,
                                          this._getIdsForAssets(this.addAssetList));
        } else {
            this.groupService.updateGroup(responseHandler,
										  this._getTeamAreaValue(),
                                          this.groupId,
                                          !this.expirationDateCheckbox.checked,
                                          this.viewHeaderNode.getTitle(),
                                          this.viewHeaderNode.getSummary(),
                                          this.expirationDateCheckbox.checked ? null : this._getDateValue(this._expirationDateField),
                                          this._getDateValue(this._startDateField),
										  this.stateId,
                                          false,
                                          this._getIdsForAssets(this.addAssetList),
                                          this._getIdsForAssets(this.removeAssetList));
        }
        
        this.viewHeaderNode.setProgressStart(RtlmUiUtil_getMessage("savingGroup"));
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("savingGroup"), ViewHeaderLayout_INFO);        
        this.discardButtonNode.setDisabled(true); 
        this.saveButtonNode.setDisabled(true);
    },
    
    _getDateValue: function(dateWidget) {
        if (dateWidget && dateWidget.getDisplayedValue())
            return dateWidget.getValue().getTime();
        else
            return null;
    },
    
    _getDateString: function(date) {
        if (!date)
            return "";

        return dojo.date.locale.format(date, { selector: 'date', formatLength: "short" });
    },
    
    _onStartDateChanged: function() {
		this.validateDifference();
        if (!this._startDateField.isValid()) {
            this._startDateEdited = true;
        } else {
            var newValue = this._startDateField.getValue();
            this._startDateEdited = false;
            if (this.isNew) {
                if (newValue) {
                    this._startDateEdited = true;
                }
            } else if ((this.group.startDate && !newValue) ||
                       (!this.group.startDate && newValue) ||
                       (this.group.startDate && newValue && (this.group.startDate.getTime() != newValue.getTime()))) {
                this._startDateEdited = true;
            }
        }
        if(this._startDateEdited) {
            var date = this._startDateField.getValue();
            this._expirationDateField.setConstraint("min", date);
        }
        this._updateActionButtons();
    },

    _onExpirationDateChanged: function() {
        this.validateDifference();
		if (!this._expirationDateField.isValid()) {
            this._expirationDateEdited = true;
        } else {
            var newValue = this._expirationDateField.getValue();
            this._expirationDateEdited = false;
            if (this.isNew) {
                if (newValue) {
                    this._expirationDateEdited = true;
                }
            } else if ((this.group.expirationDate && !newValue) ||
                       (!this.group.expirationDate && newValue) ||
                       (this.group.expirationDate && newValue && (this.group.expirationDate.getTime() != newValue.getTime()))) {
                this._expirationDateEdited = true;
            }
        }
        if(this._expirationDateEdited) {
            var date = this._expirationDateField.getValue();
            this._startDateField.setConstraint("max", date);
        }
        this._updateActionButtons();
    },

	/*
	 * Since 1.0.1
	 */
	validateDifference:function(){
		//See defect 10191
		var enteredStartTime = this._startDateField.getValue() != null ?this._startDateField.getValue().getTime() : 0;
		var enteredEndTime = this._expirationDateField.getValue() != null ? this._expirationDateField.getValue().getTime() : 0;
		//Extra check, it seems that it is possible not to enter any or to have enter only start/end date also.
		if(	enteredEndTime == 0 || enteredStartTime == 0 ){
			this.invalidDateCombination = false;
			return;
		}
		//If both entered then validate
		var deltaMinutes = enteredEndTime - enteredStartTime;
		if(deltaMinutes < 0 && !this.expirationDateCheckbox.checked){
			this.invalidDateCombination = true;
		}else{
			this.invalidDateCombination = false;
		}
	},
	
    _onExpirableChecked: function() {
        this._expirableEdited = false;
        this._expirationDateField.setDisabled(this.expirationDateCheckbox.checked);
        
        if (this.expirationDateCheckbox.checked) {
            this._expirationDateEdited = false;
            
            // clear any constraints that we might have placed on start date.
            this._startDateField.setConstraint("max", null);
        } else {
            this._onExpirationDateChanged(this._expirationDateField.getValue());
        }
        
        if (this.isNew) {
            this._expirableEdited = this.expirationDateCheckbox.checked;
        } else if (this.group.expirable == this.expirationDateCheckbox.checked) {
            this._expirableEdited = true;
        }
		this.validateDifference();
        this._updateActionButtons();
    },
    
    _onGroupNameChanged: function(name) {
		//With the change that on every keypress the ViewHeaderLayout fireChangeEvent is called but still the onChange event is
		//not called until the editor loses focus.  Thus just set the title here because it is accessed in _updateActionButtons.
		this.viewHeaderNode.setTitle( name );
        this._groupNameEdited = false;
        if (this.isNew) {
            if (name) {
                this._groupNameEdited = true;
            }
        } else if (name != this.group.name) {
            this._groupNameEdited = true;
        }
        this._updateActionButtons();
    },
    
    _onTeamAreaChanged: function() {
        this._teamAreaEdited = false;
        if (this.isNew) {
            if (this._getTeamAreaValue()) {
                this._teamAreaEdited = true;
            }
        } else if (this._getTeamAreaValue() != this.group.teamArea) {
                this._teamAreaEdited = true;
        }
        this._updateActionButtons();
    },
    
    _onDescriptionChanged: function(desc) {
        this._descriptionEdited = false;
        if (this.isNew) {
            if (desc) {
                this._descriptionEdited = true;
            }
        } else if (desc != this.group.description) {
            this._descriptionEdited = true;
        }
        this._updateActionButtons();
    },
    
	_updateActionButtons: function() {
	    if (this.deleted || this._clearingForm)
	       return;

        if (!this._hasEditPermission()) {
            var msg = RtlmUiUtil_getCommonMessage("statusNoEditPerm");
            var details = RtlmUiUtil_getCommonMessage("msgNoEditPermDetails", RtlmUiUtil_getMessage("labelGroupType"));
            
            this.viewHeaderNode.setStatus(msg, ViewHeaderLayout_WARNING, details);
            this.saveButtonNode.setDisabled(true);
            this.discardButtonNode.setDisabled(true);
            return;
        }
	       
	    var edited = this._hasEdited();
	    this.discardButtonNode.setDisabled(!edited);
	    
	    if (this.viewHeaderNode.getTitle() == "") {
			this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgMissingGroupName"), ViewHeaderLayout_ERROR);
			this.saveButtonNode.setDisabled(true);
		} else if (!this._getTeamAreaValue()) {
			this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgMissingTeamArea"), ViewHeaderLayout_ERROR);
			this.saveButtonNode.setDisabled(true);
        } else if (!this._startDateField.isValid()) {
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgInvalidStartDate"), ViewHeaderLayout_ERROR);
            this.saveButtonNode.setDisabled(true);
        } else if (!this.expirationDateCheckbox.checked && !this._expirationDateField.isValid()) {
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgInvalidEndDate"), ViewHeaderLayout_ERROR);
            this.saveButtonNode.setDisabled(true);
		}else if (this.invalidDateCombination) {
            this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgInvalidStartEndDates"), ViewHeaderLayout_ERROR);
            this.saveButtonNode.setDisabled(true);
		} else {
            if(edited) {
                var msgId = (this.isNew) ? "saveNewReminderMsg" : "saveChangeReminderMsg";
                msg = RtlmUiUtil_getMessage(msgId);           
                this.viewHeaderNode.setStatus(msg, ViewHeaderLayout_INFO);        
            }
            else {
                this.viewHeaderNode.clearStatus();                
            }
			this.saveButtonNode.setDisabled(!edited);			
		}
        var disable = this.assetTableViewer.getCheckedRows().length == 0;
        this.removeAssetActionNode.setDisabled(disable);      
          
        //Update the tab label to show that the group is edited, or not.
        var name = (this.group) ? this.group.name : null;
        var label_arg = [window.location.hash, name, "machine-group-icon-16", edited];
        dojo.publish(GlobalEvents.UpdateTabLabel, label_arg);
	},
	
    _clearEdited: function() {
        this._groupNameEdited = false;
        this._teamAreaEdited = false;
        this._descriptionEdited = false;
        this._startDateEdited = false;
        this._expirationDateEdited = false;
        this._membersEdited = false;
        this._expirableEdited = false; 
        
        // clears the sandbox asset lists.
        this.addAssetList = [];
        this.removeAssetList = [];
    },
    
	_hasEdited: function() {
        if (this._groupNameEdited ||
            this._teamAreaEdited ||
            this._descriptionEdited ||
            this._startDateEdited ||
            this._expirationDateEdited ||
			this._membersEdited ||
            this._expirableEdited)
            return true;
        return false;
	},
	
	_clearForm: function() {
	    this._clearingForm = true;
        this.viewHeaderNode.setTitle("");
        this.viewHeaderNode.setSummary("");
        this._setTeamAreaValue(null);
        this._startDateField.setDisplayedValue("");
        this._expirationDateField.setDisplayedValue("");
        this.expirationDateCheckbox.checked = false;
        this._onExpirableChecked();
        this._clearingForm = false;
	},
	
    _saveSuccess: function(response) {
        // we're reloading the group data to refresh. That would clear any messages
        // set. Save the save status and let the reload display it at the end.
        this.statusMessage = RtlmUiUtil_getMessage("savedSuccessMsg", RtlmUiUtil.getCurrentTimeString());
        this.statusState = ViewHeaderLayout.SUCCESS;
        
        this._clearEdited();
        
        if (this.isNew) {
            this.isNew = false;
            this.groupId = response.itemId;
			this.stateId = response.stateId;
            
            // update our URI
            var url_arg = [window.location.hash, AssetUriUtil.getGroupDetailURI(this.groupId)];
            var artifact_arg = [ RtlmUiUtil.TYPE_GROUP, [ this.group ], AssetUriUtil.getGroupDetailURI(this.groupId) ];
            dojo.publish(GlobalEvents.UpdateTabUri, url_arg);
            dojo.publish(GlobalEvents.ArtifactsAdded, artifact_arg);
        } else {
            var artifact_arg = [ RtlmUiUtil.TYPE_GROUP, [ this.group ], AssetUriUtil.getGroupDetailURI(this.groupId) ];
            dojo.publish(GlobalEvents.ArtifactsUpdated, artifact_arg);
        }
        this._loadGroupById(this.groupId);
        var responseHandler = new ServiceResponseHandler(this, "_refreshSuccess", "_refreshFailure");
        GroupUtil.refresh(responseHandler);
    },
    
    _saveFailure: function(errorType) {
        var details = (errorType && errorType.message) ? errorType.message : null;
        
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("errSavingGroup"), ViewHeaderLayout_ERROR, details);

        if(errorType && errorType.message && errorType.message.toLowerCase().indexOf('license') > -1) {
            RtlmUiUtil.showServerErrorMessage(RtlmUiUtil_getCommonMessage("serverLicenseErrMsg"));                  
        }        
    },
    
    _refreshSuccess: function(response) {
        GroupUtil.setGroupsListValid(true);
    },
    
    _refreshFailure: function(errorType) {
        var details = (errorType && errorType.message) ? errorType.message : null;
        
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("errRefreshingGroupList"), ViewHeaderLayout_ERROR, details);

        if(errorType && errorType.message && errorType.message.toLowerCase().indexOf('license') > -1) {
            RtlmUiUtil.showServerErrorMessage(RtlmUiUtil_getCommonMessage("serverLicenseErrMsg"));                  
        }        
    },
    
    _onDiscardActionClick: function() {
        var args = {
            'message': RtlmUiUtil_getMessage("confirmDiscard"),
            'yesCallback': 
                function(view) {
                    // clear sandbox data.
                    view.addAssetList = [];
                    view.removeAssetList = [];
                    view._loadForm();
                    view._updateActionButtons();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil_getMessage("confirmDiscardTitle"));
        confirmDialog.open();
    },
    
    _onReleaseAssetActionClick: function() {
        var selectedAssets = this.assetTableViewer.getCheckedRows();        
        var list = selectedAssets;
        var len = list.length;
        
        // shouldn't happen, just sanity check
        if(len < 1) return;
        
        var provider = this.assetTableViewer.getContentProvider();
        
        // check the add list for removal first. If this item was
        // just added and not part of the group yet, just remove it
        // from the sandbox add list.
        for(var i = 0; i < len; i++) {
            var id = provider.getRowDataId(list[i]);
            
            if(!this._removeFromAssetList(this.addAssetList, id)) {
                // real remove item, add it to our remove sandbox list.
                this.removeAssetList.push(list[i]);
            }
        }
        this._loadFormAssets();
        this._membersEdited = true;
        this._updateActionButtons();
    },
    
    _getTeamAreaDisplayValue: function() {
        if (this.teamAreaSelector.value) {
            var options = this.teamAreaSelector.options;
            var options_length = options.length;
            for (var i = 0; i < options_length; i++) {
                if (options[i].selected) {
                    return options[i].text;
                }
            }
        }
        return RtlmUiUtil_getMessage("undefined");
    },

    _getTeamAreaValue: function() {
        return this.teamAreaSelector.value;
    },

    _setTeamAreaValue: function(value) {
        this.teamAreaSelector.value = value;
    },
    
    _createLabelInfo: function(label, domNode) {
        var attributeSpan = document.createElement('span');
        var attributeLabel = document.createElement('span');
        var attributeVal = document.createElement('span');
        attributeSpan.className = "attributes-entry";
        attributeLabel.className = "attributes-entry-label";
        attributeLabel.attributeVal = "attributes-entry-value";
        attributeLabel.innerHTML = label;
        attributeVal.appendChild(domNode);
        attributeSpan.appendChild(attributeLabel);
        attributeSpan.appendChild(attributeVal);
        return attributeSpan;
    },

    // update the UI to reflect the group is deleted 
    setGroupDeleted: function() {
        this.deleted = true;
        this.saveButtonNode.setDisabled(true);
        this.discardButtonNode.setDisabled(true);
        this.viewHeaderNode.setStatus(RtlmUiUtil_getMessage("msgGroupDeleted"), ViewHeaderLayout_ERROR);
    },
    
    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about deleted group
        if ((artifactType == RtlmUiUtil.TYPE_GROUP) && (changeType == GlobalEvents.ArtifactsDeleted)) {
            var artifactArray_length = artifactArray.length;
            for (var i = 0; i < artifactArray_length; i++) {
                // check if the group of this editor is deleted
                if (artifactArray[i].id == this.groupId) {
                    // update the UI to reflect the config is deleted 
                    this.setGroupDeleted();
                    break;
                }
            }
        }
    },
	
    // Summary:
    //    Given a list and an asset id, if the asset id is in the list,
    //    remove it from the list and returns true for removed. Otherwise,
    //    returns false.
    _removeFromAssetList: function(list, assetId)
    {
        var provider = this.assetTableViewer.getContentProvider();
        var len = list.length;
        
        for(var i = len - 1; i >= 0; i--) {
            var id = provider.getRowDataId(list[i]);
            
            if(id == assetId) {
                list.splice(i, 1);
                return true;
            }
        }
        return false;    
    },
    
    // Summary:
    //   Returns true if the specified asset record is in the current
    //   sandbox asset list. This method is used by the add assset selection
    //   dialog to exclude assets that the group currently has. 
    _inAssetSandboxList: function(asset)
    {
        var assetId = asset[0];
        var content = this.assetTableViewer.getContent();
        var provider = this.assetTableViewer.getContentProvider();
        var len = content.length;
        
        for(var i = 0; i < len; i++) {
            var id = provider.getRowDataId(content[i]);
            
            if(id == assetId) {
                return true;
            }
        }
        return false;
    },
    
	_onAddResourceClick: function()
	{
		var dialogArgs = {
			title:RtlmUiUtil_getMessage("labelAddToGroup"),
			style: "position: absolute; top: 15%; left: 15%; width: 65%; height: 68%;",
            searchCriteria: SearchCriteria,
            exclude: dojo.hitch(this, "_inAssetSandboxList") // don't show any items that is already in our list
		}
		this.selectDialog = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetSelectorDialog(dialogArgs);
		this.selectDialog.setOKAction(dojo.hitch(this, function() {
            var assetType = this.selectDialog.getAssetType();
            var newAssets = this.selectDialog.getSelectedAssets();
            
            if (newAssets && newAssets.length > 0) {
                this._updateAddList(assetType, newAssets);    
                this._loadFormAssets();
                
                this._membersEdited = true;
                this._updateActionButtons();
            }
        }));
		this.selectDialog.show();
	},

    _updateAddList: function(assetType, selectedAssets)
    {
        var nAssets = selectedAssets.length;
        var mapType = AssetAttributeMap[assetType];
        var offset = assetType == "Machine" ? 0 : 5;
        
        for(var i = 0; i < nAssets; i++) {
            var asset = selectedAssets[i];

            // if the user removed something from the current list
            // and then adding it back, just remove it from the deleted list to
            // 'add' it back.
            if(this._removeFromAssetList(this.removeAssetList, asset[mapType[0]])) {
                continue;
            }
            // map each attribute into the row object, which is
            // just an array of values. The asset is an associative
            // array of attribute name to value.
            var rowData = new Array(5 + offset);
            for(var j = 0; j < 5; j++) {
                rowData[j + offset] = asset[mapType[j]];
            }
            this.addAssetList.push(rowData);
        }
    },
	
	isDirty: function()
	{
		return( this._hasEdited() );
	},
	
	_updateBrowserTitle: function(){
		if (this.page) {
			var	name ;
			if (this.isNew) {
				name = RtlmUiUtil_getMessage("labelCapitalNew");
			}
			else {
				name = this.group.name;
			}
			this.page.browserTitle = RtlmUiUtil_getMessage("pageTitleAssetGroup", name);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle );
			net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;
		}
	}
	
});

dojo.declare("GroupAssetsTable.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
	_assetView: null,
	
	constructor: function(assetView) {
		this._assetView = assetView;
	},
	
    getNumColumns: function(content) {
        return 4;
    },

    _columnHeadings: [
        RtlmUiUtil.getMessage("labelAssetName"),
        RtlmUiUtil.getMessage("labelOS"),
        RtlmUiUtil.getMessage("labelMfrOrType"),
        RtlmUiUtil.getMessage("labelAssetType")
    ],
	
    getColumnHeading: function(content, atColumnIndex) {
        return this._columnHeadings[atColumnIndex];
    },

    getColumnHeadingImage: function(content, atColumnIndex) {
        return null;
    },
    
    getIsColumnGroupable: function(content, atColumnIndex) {
		// groupable by column 4, asset type
        return atColumnIndex == 3;     
    },

    getIsColumnSortable: function(content, atColumnIndex) {
		return true;
    },
    
    _columnWidths: [
        30, // "Asset Name",
        25, // "Operation System",
        20, // "Manufacturer/Type",
        25 // "Asset Type"
    ],
    
    getColumnWidth: function(content, atColumnIndex) {
        return this._columnWidths[atColumnIndex];
    },
    
    getContentObjects: function(content) {
        // the groups data is already an array
        return content;
    },
    
    getRowDataId: function(rowData) {
        return( ( rowData[ 4 ] ) ? rowData[ 0 ] : ( ( rowData[ 9 ] ) ? rowData[ 5 ] : null ) );
    },

    getCellDisplayType: function(rowData, atColumnIndex) {
        var types = [
            TableConstants.RENDER_TYPE_LINK,   // "Asset Name",
            TableConstants.RENDER_TYPE_TEXT,   // "Operation System",
            TableConstants.RENDER_TYPE_TEXT,   // "Manufacturer",
			TableConstants.RENDER_TYPE_TEXT    // "Asset Type"
        ];
		return types[atColumnIndex];
    },

    _normalizeOSDisplay: function(osName)
    {
        if( osName == null || osName == "OperatingSystem" )
        {
             return "";
        }
        var indx = osName.indexOf("OperatingSystem");
        if( indx > -1) 
        {
            return osName.replace(/OperatingSystem/, RtlmUiUtil.getMessage("unknownOsDisplay"));
        }
        return osName;
    },
        
    getCellDisplayData: function(rowData, atColumnIndex) {
		// line up with the search attribute criteria columns
		if (rowData[4]) {
// "machine.id, machine.name, machine.operatingsystem, machine.owner, machine.assetfamily";
			switch (atColumnIndex) {
				case 0: // Asset Name
					return rowData[1];
				case 1: // "Operation System"
					return this._normalizeOSDisplay(rowData[2]);
				case 2: // "Manufacturer"
					return (rowData[3]) ? rowData[3] : "";
				case 3: // "Asset Type"
					return rowData[4];
			}
		} else if (rowData[9]) {
// "VirtualImage.id, VirtualImage.name, VirtualImage.operatingsystem, VirtualImage.ImageType, VirtualImage.assetfamily";
			switch (atColumnIndex) {
				case 0: // Asset Name
					return rowData[6];
				case 1: // "Operation System"
					return this._normalizeOSDisplay(rowData[7]);
				case 2: // "Manufacturer"
					return (rowData[8]) ? rowData[8] : "";
				case 3: // "Asset Type"
					return rowData[9];
			}
		}

		return "";
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex) {
		if (atColumnIndex == 0) {
			if (rowData[4]) {
                var machine_url = { 'href': AssetUriUtil.getViewAssetDetailURI("Machine", rowData[0]) };
            	return machine_url;
			} else if (rowData[9]) {
                var image_url = { 'href': AssetUriUtil.getViewAssetDetailURI("VirtualImage", rowData[5]) };
            	return image_url;
			}
		}
		
		return( {} );
    }
});

dojo.declare("GroupAssetsTable.TableListener",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{    
	_assetView: null,
	
	constructor: function(assetView) {
		this._assetView = assetView;
	},
	
    rowCheckStateChanged: function(tableViewer, rowObject, state) {
		if (this._assetView.removeAssetActionNode)
			this._assetView.removeAssetActionNode.setDisabled(tableViewer.getCheckedRows().length == 0);
    },

    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) {
        callback(callbackData);
    }
});

})();
