/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservationsTableProvider"); 

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

(function() {

	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var column_types = [ TableConstants.RENDER_TYPE_LINK ];
	var field_names = [ "machine.id", "machine.name" ];
			
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservationsTableProvider", 
             com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider,
{
	constructor: function()
	{
		this.setParameters( { "column_headings" : this.getColumnHeadings(),
					  "id_fields" : this.getIdFields(),
					  "column_types" : column_types } );
	},
	
	getColumnHeadings : function()
	{
		return( [{title: RtlmUiUtil.getMessage("resMachineName"), native_column: "machine\\.name", isSortable: true, includeInFilter: true, width: 100 }]);
	},
	
	getIdFields: function()
	{
		return( "machine\\.id" );
	},
	
	// Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
    	//Molding the data so that it can be used by the MachineTableProvider
    	var rows = [];
		for( var iRow = 0; iRow < content.Data.length; iRow++ )
		{
			var aRow = {};
			
			for( var iField = 0; iField < content.Data[ iRow ].length; iField++ )
			{
				aRow[ field_names[ iField ] ] = content.Data[ iRow ][ iField ];
			}
			
            rows.push(aRow);
		}
		
		return( rows );
    },
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0) {
            val = {};
 			var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
            val['href'] = AssetUriUtil.getViewAssetDetailURI( "Machine", this.getRowDataId( rowData ) );
        }

        return val;
    }       
    
});

})();
