/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil");
(function() {

var Root             = "com.ibm.rqm.planning.home.actionDispatcher";
var BaseActionHref   = "#action=" + Root;

// Summary:
//    Utility object to compose URIs for request page's actions.
//
com.ibm.rational.test.lm.web.ui.internal.views.testcells.TestCellUriUtil = {


    getAllTestCellsURI: function(args)
    {
        var base = BaseActionHref + "&subAction=allTestCells";
        var uri = base; 
        var moreArgs = "";       
		if(args) 
		{
			for(var argName in args) 
			{
				moreArgs += ("&" + argName + "=" + args[argName]); 
			}
		}
		uri += moreArgs;
        console.debug(uri);
        return uri;
    },
     
    // Summary:
    //    Creates the URI to launch the new TestCell view. Optionally, the caller
    //    can pass in extra argument name value pairs.
    //        
    getNewTestCellURI: function(args)
    {
        var timestamp = dojo.date.locale.format(new Date(), {selector:"time", timePattern:"hh:mm:ss"});
        var moreArgs = "";
        
        if(args) {
            for(var argName in args) {
                moreArgs += ("&" + argName + "=" + args[argName]); 
            }
        }
        return BaseActionHref + "&subAction=createTestCell" + "&id=" + timestamp + moreArgs;
    },

    // Summary:
    //    Creates the URI to launch the edit TestCell view for the specified TestCell id.  
    //        
    getEditTestCellURI: function(id) 
    {
        return BaseActionHref + "&subAction=viewTestCell" + "&cellID=" + id;
    }
    
};
})();
