/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.JobStatusViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.rational.test.lm.web.client.internal.inventory");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.JobStatusTableProvider"); 
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet");

(function() {
	
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var AbstractViewlet = com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet;
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.JobStatusViewlet",  AbstractViewlet,
{   
    
    templateString: '<div id="${id}" dojoAttachPoint="domNode">' +
            '   <table width="100%" cellpadding="12"> '+
            '       <tr> '+
            '           <td> '+
            '               <!-- table resultarea --> '+
            '               <div dojoAttachPoint="jobStatusViewletContent" '+
            '               </div> '+
            '           </td> '+
            '       </tr> '+
            '   </table> '+
            '</div>',		

    inventory: new com.ibm.rational.test.lm.web.client.internal.inventory(),
//    assetUriUtil: new com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil(),
	uiUtil: com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil,
	
	_jobStatus: null,
	

    
    /*
     * Called by the framework after the viewlet is instantiated, but before the
     * first refresh. Viewlets that need to initialize themselves shoudl override.
     */
    init: function() {
		this._createTable();
    },
	
	_createTable: function() {                   
        var table = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();

        table.setContentProvider( new com.ibm.rational.test.lm.web.ui.internal.views.providers.JobStatusTableProvider() );
        table.setContentPageSize( 10 );
		var modifier = new com.ibm.rational.test.lm.web.ui.internal.views.providers.JobStatusCellModifier( this );
        table.setCellModifier( modifier );
        table.setTableSummary(RtlmUiUtil.getMessage("labelTableSummary", RtlmUiUtil.getMessage("job_status_title")));
		
        
        this.jobStatusViewletContent.appendChild( table.domNode );
        
        table.setContent( [] );
        table.show();
		this.resultTable=  table;				
		        
    },
	
    /*
     * Public Method
     * 
     * Refreshes the viewlet content.
     * 
     * @param <none>
     * @return <none>
     */ 
    refresh: function() {		
        this.getSite().setLoading(true);
		
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_getOperationsSuccess", "_getOperationsError");
//        this.inventory.getOperations(responseHandler);
        this.inventory.getAutomationOperations(responseHandler);
    },
    
    _getOperationsSuccess: function(response) {
		var site = this.getSite();
		this._jobStatus = response;		
        this._update();
        site.setLoading(false);
        site.doneRefresh();
    },
    
    _getOperationsError: function(response) {
		console.error("Job Status viewlet got error: " + response);
		var site = this.getSite();		
		this._jobStatus = null;
        this._update();
        site.setLoading(false);
        site.doneRefresh();
    },
    
    /*
     * Repopulates the viewlet. New content should not be retrieved from the server.
     * Called when presentation of the viewlet is changed in some way, but new information
     * is not required.
     * 
     * Viewlets should override.
     */
    _update: function() {
		var table = this.resultTable;		
        table.setContent( ( this._jobStatus ) ? this._jobStatus : [] );
        table.show();
        table.performSortBy( this.resultTable.getContentProvider().getInitialSortByColumn(),
       								   this.resultTable.getContentProvider().getInitialSortByColumn() );
    },
	
	
	cancelJob: function( jobId )
	{
		var inventory = new com.ibm.rational.test.lm.web.client.internal.inventory();
	   	var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_cancelSuccess", "_cancelError");
		inventory.cancelJob( responseHandler, jobId );
	},
	
	_cancelSuccess: function( results )
	{
		this.refresh();
	},
	
	_cancelError: function( errObj )
	{
	}    
});

})();
