/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.Button");

dojo.require("dijit.form.Button");

(function(){
var _textContent=dojo.isIE?"innerText":"textContent";

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.Button", dijit.form.Button, {
	
	_scroll: false,

    constructor: function() {
	},

    postCreate: function(){
        this.inherited('postCreate', arguments);
    },

    _setDisabledAttr: function(/*Boolean*/ value){
        this.disabled = value;
        
        //dojo.attr(this.focusNode, 'disabled', value);
        dijit.setWaiState(this.focusNode, "disabled", value);

        var tn = this.stateNode || this.domNode;
        if(value){
            //reset those, because after the domNode is disabled, we can no longer receive
            //mouse related events, see #4200
            this._hovering = false;
            this._active = false;
            // remove the tabIndex, especially for FF
            this.focusNode.removeAttribute('tabIndex');
            
            // on IE the button's disabled-ness is not shown. Add it our own
            // disabled class. 
            if(dojo.isIE) {
                dojo.addClass(tn, "asqDijitButtonDisabled");
            }
        }else{
            this.focusNode.setAttribute('tabIndex', this.tabIndex);
            if(dojo.isIE) {
                dojo.removeClass(tn, "asqDijitButtonDisabled");
            }
        }
        this._setStateClass();
},
	
    //FIX defect 4697. 
	//@Overridden: setDisabled function from dijit.form._FormWidget. 
	//When the domNode is disabled, the title should appear when the mouse is over the button. 
    setDisabled: function(/*Boolean*/ disabled){
        // summary:
        //      Set disabled state of widget.
        this.attr('disabled', disabled);
    },
	_setLabelAttr: function(val){
		this.containerNode[_textContent] = this.label = val;
		if (this.showLabel == false && !this.params.title){
            this.titleNode.title = val;
		}
	},
	setLabel: function(/*String*/content){
        this.attr("label", content);
	}		

});
})();