/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
// pc 09/08/09
// This file doesn't seem to be used by any JS file.
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.NewMachineConfigPanel");

dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.Button");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget")
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.data.ItemFileReadStore");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.FilteringCustomElementProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

(function(){
var AssetContentProviderFactory=com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetContentProviderFactory;
var Catalog=com.ibm.asq.common.web.client.internal.Catalog;
var FilteringCustomElementProvider=com.ibm.rational.test.lm.web.ui.internal.views.machines.FilteringCustomElementProvider;
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var SectionLayoutForm=com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionLayoutForm;

dojo.declare(
  "com.ibm.rational.test.lm.web.ui.internal.widgets.NewMachineConfigPanel",
  [dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/widgets/templates/NewMachineConfigPanel.html"),
	
	//The config
	configString:null,
	
	//Used to preserve the original config when in selectable mode
	originalConfig:null,
	
	title: "",
	
	_selectConfigAction:null,
	
	/* the state of the config panel */
	state: "EDITABLE",
  
	/* the state that the config can be in which affects the display */
	EDITABLE: "EDITABLE",
	READONLY: "READONLY",
	SELECTABLE: "SELECTABLE",  // read only with check boxes to select param

	/* classes for various parts to allow override particular part of main class */
	headerClass: null,       // header div area for title and action
	headerLabelClass: null,  // header div area for title and action
	actionLinkClass: null,   // action using link

	/* event hook called when elements in the panel are changed */
	onChange: function(evt) {},
	
	/* local "member" variables */
	formLayout: null,
	tableArgs: null,
	listTable: null,
	catalog:null,
	provider: null,

	AssetContentProviderFactory: null,		
	CustomElementProvider: null,
	
	_configsLoaded: false,
		
	postCreate :function()
	{
		//Init the content provider
		this.AssetContentProviderFactory = AssetContentProviderFactory;		
		
		//Initialize the catalog object
        this.catalog = new Catalog();
	
		//set label for input node
		this.configSelectorLabel.setAttribute("for", this.configSelector.id);
		
		//Set the title of the panel
		if (this.title == "")
			this.title = RtlmUiUtil.getMessage("reqLabel_machine_def");
		this._setTitle(this.title);		
		
		//Init the class types for the various nodes
		this._initClasses();
		
		//Create the config spec area
		this._createConfigArea();
		
		//Initialize the config with the provided config (if any)
		this._initConfigArea();
	},
	
	isEdited :function()
	{
		//MFV need to figure out how to set this
		return true;
	},
	
	_setTitle :function(title)
	{
		this.headerNode.innerHTML = title;
	},
	
	_initClasses :function()
	{
		// allow override the class of individual part from the main class
		if (this.headerClass != null)
			this.headerRowNode.className = this.headerClass;
			
		if(this.headerLabelClass != null) 
			this.headerNode.className = this.headerLabelClass;
	},
	
	_createConfigArea :function()
	{
		this._constructAssetSelector();
		this._constructConfigSelector();
		
		//Hookup the clear button
		this.connect(this.clearButton, "onclick", this._loadAssetTypeToForm);
		this.clearButton.value = RtlmUiUtil.getMessage( "cfgClearForm");

		this.formLayout = new SectionLayoutForm(this.configLayoutNode);
	},
	
	//Initialize the config area
	//Need to set the appropriate provider based on asset type and then load the asset into the form
	_initConfigArea :function()
	{
		if (this.configString != null) 
		{
			console.debug(this.configString);
			this.asset = this.catalog.createConfigurationFromJson(this.configString);
			if (this.asset) 
				this.assetType = this._getAssetTypeFromAsset(this.asset);
		}
		if (this.config != null)
		{
			this.asset = this.config;
			this.assetType = this._getAssetTypeFromAsset(this.asset);
		}
		else 
		{
			this.assetType = "Machine";
			this.asset = this.catalog.createConfiguration(this.assetType);
		}
		
		var custProvider = new FilteringCustomElementProvider( this.formLayout );
		this.provider = this.AssetContentProviderFactory.getAssetSearchContentProvider(this.assetType, this.formLayout, null );

		this.formLayout.setCustomElementProvider( custProvider );
		
        this.formLayout.setContentProvider(this.provider);

		
		this.formLayout.setContent(this.asset);
		this.formLayout.doLayout();
		this.formLayout.loadDataToForm();	
	},

	//Retrieve the asset type of a config
	_getAssetTypeFromAsset :function(asset)
	{
		var assetType = null;
		if (asset != null)
		{
			var rootPart = asset.getRootPart(0);
			if (rootPart != null)
			{
				var root = rootPart.getRoot();
				if (root != null)
					assetType = root.getName();
			}
		}
		return assetType;
	},
	
	setConfig :function(state, config)
	{
		this.state = state.toUpperCase();
		this.configString = null;
		
		//Save the original config - used when in "Selectable" mode.
		//In Selectable mode we let Larry mess with the congif but not save it.
		this.originalConfig = config;
		if (config != null)
			this.config = config.clone();
			
		this._initConfigArea();
	},
	
	getConfig :function(reason)
	{
		//Here's the deal with the if statement below.
		//We let Larry modify the config in "Selectable" mode.
		//This means that if he wants to mess with the config in order to look for machines he can.
		//BUT we don't want to allow Larry to save the changes to the config so
		//If we are in "Selectable" mode AND the action is "find machines" then return the modified config
		//In ALL other cases in "Selectable" mode return the original config
		if (this.state == this.SELECTABLE)
		{
			if (reason != null && reason.actionId == "findMachine")
				return(this.asset);
			else
				return(this.originalConfig);
		} 
		else
			return this.asset;
	},
	
	getError: function()
	{
		var errorMessage = "";
		return errorMessage;
	},
	
	getWarning: function()
	{
		var warningMessage = "";
		return warningMessage;
	},
	
	_constructConfigSelector: function()
	{
		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_configSuccess", "_configError");
		this.configSelector.onChange = dojo.hitch(this, "_configChangeHandler");
		configs.getAllWithDetails(responseHandler);
	},

    _constructAssetSelector: function()
	{
        var catalog = new Catalog();
        this.assetTypeNames = catalog.getAssetTemplateNames();
        
        for(var i in this.assetTypeNames) {
			this.assetTypeSelector.options[i] = new Option( RtlmUiUtil.getMessage( this.assetTypeNames[i] ), this.assetTypeNames[i] );
			if(i == 0) {
				this.assetTypeSelector.options[i].selected = true;
			}
        }
		this.assetType = this.assetTypeNames[0];
		this.assetTypeSelector.onchange = dojo.hitch(this, "_loadAssetTypeToForm");
	},
    _getSelectAssetTypeValue: function() 
    {
        for(var i = 0; i < this.assetTypeSelector.options.length; i++) {
            if(this.assetTypeSelector.options[i].selected) {
                return this.assetTypeSelector.options[i].value;
            }
        }
		// should never happens
        return this.assetTypeNames[0];
    },

	//Retrieve the asset type from the selector and load the type
	_loadAssetTypeToForm: function()
	{
		this.assetType = this._getSelectAssetTypeValue();
		this._loadAssetType();
	},
	
	//Load the asset type specified in this.assetType
	_loadAssetType: function()
	{
        var catalog = new Catalog();
        this.asset = catalog.createConfiguration(this.assetType); 
		var custProvider = new FilteringCustomElementProvider( this.formLayout );
		this.provider = this.AssetContentProviderFactory.getAssetSearchContentProvider(this.assetType, this.formLayout, null );
		
		var formLayout = this.formLayout;
		formLayout.setCustomElementProvider( custProvider );
        formLayout.setContentProvider(this.provider);
        formLayout.setContent(this.asset);
        formLayout.doLayout();
	},
	
	setConfigSelection: function(configId) {
		if (this._configsLoaded) {
			this.configSelector.setValue(configId);
			this._configSelection = null;
		}
		else 
			this._configSelection = configId;
	},

	_configChangeHandler: function()
	{
		var currentConfigLabel = this.configSelector.getDisplayedValue();
		if (currentConfigLabel == null)
			return;
		//MFV 03/07/08  FOR NOW WE ONLY BUILD CONFIGS FOR MACHINES
		//THIS WILL HAVE TO CHANGE EVENTUALLY			
		this.assetType = "Machine";
		
		//ensure the correct asset  type displays in the asset type combo box.
		for(var i = 0; i < this.assetTypeSelector.options.length; i++) 
		{
			if (this.assetTypeSelector.options[i].value == this.assetType)
				this.assetTypeSelector.options[i].selected = true;
        }
		
		//Load the asset type so the layout will work correctly
		this._loadAssetType();
		
		var catalog = new Catalog();
		this.configSelector.store.fetchItemByIdentity({
				"identity": this.configSelector.getValue(), 
				"onItem": function(item){
					var configJson = this.configSelector.store.getValue(item,"value");
					this.asset = catalog.createConfigurationFromJson(configJson);
					console.debug(configJson);
					this.formLayout.setContent(this.asset);
			    	this.formLayout.doLayout();
			    	this.formLayout.loadDataToForm();	
					
				},
				"onError": function(){
					alert("should never happen!")
				},
				"scope": this
				
		});
		
	},
	
	_configSuccess: function(response)
	{
		var datastore = {};
		var catalog = new Catalog();
		//defaulting the datastore so that it has the correct object structure.
		// 
		datastore.data = {  "theIdentifier": "id",  "items": [] };

		//Add in configs from the response
		if (response != null) 
		{
			for (var i = 0; i < response.length; i++) 
			{
				var moreValues = {};
				var name = response[i].name;
				var configObjString = response[i].configuration;
				moreValues.name = name;
				moreValues.id = response[i].id;
				moreValues.value = configObjString;
        		datastore.data.items.push(moreValues);
			}
		}
		this.configSelector._popupWidget = null;
		this.configSelector._hasMasterPopup = false;
		this.configSelector.store = new dojo.data.ItemFileReadStore(datastore);
		this._configsLoaded = true;
		if (this._configSelection) {
			this.configSelector.setValue(this._configSelection);
			this._configSelection = null;
		}
	},
	
	_configError: function( message, error )
	{
		var x = 1;
	}

});
})();