/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.asq.common.web.ui.internal.widgets.SortableOptionChooser");
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.SortableOptionChooser");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.OptionChooser");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.asq.common.web.client.internal.Constants");

(function(){ // module container

var Constants = com.ibm.asq.common.web.client.internal.Constants;

    var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	
    dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.SortableOptionChooser", [dijit._Widget, dijit._Templated, com.ibm.asq.common.web.ui.internal.widgets.OptionChooser], {
        
        templateString: ['<div id="${id}" dojoAttachPoint="domNode" tabindex="-1" class="com-ibm-asq-common-web-ui-sortable-option-chooser">',
                        ' <table border="0">',
                        '  <tr>',
                        '   <td dojoAttachPoint="leftSelectTitleNode"/>',
                        '   <td/>',
                        '   <td>',
						'    <div>',
                        '       <span dojoAttachPoint="rightSelectTitleNode"></span>',
						'       <span style="padding-left: 35px">' ,
						'       <button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="editButton" title="${editLabel}" iconClass="edit-button" dojoAttachEvent="onClick: _onEdit,onKeyPress: _onEdit" tabindex="-1"></button>' ,
						'       <button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="newButton" title="${newLabel}" iconClass="new-button" dojoAttachEvent="onClick: _onNew,onKeyPress: _onNew" tabindex="-1"></button>' ,
						'       <button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="upButton" title="${upLabel}" iconClass="up-button" dojoAttachEvent="onClick: _onMoveUp,onKeyPress: _onMoveUp" tabindex="-1"></button>' ,
						'       <button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="downButton" title="${downLabel}" iconClass="down-button" dojoAttachEvent="onClick: _onMoveDown,onKeyPress: _onMoveDown" tabindex="-1"></button>' ,
						'       <button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="deleteButton" title="${deleteLabel}" iconClass="delete-button" dojoAttachEvent="onClick: _onDelete,onKeyPress: _onDelete" tabindex="-1"></button>' ,
                        '       </span>' ,
						'    </div>' ,
						'   </td>' ,
                        '  </tr>' ,
                        '  <tr>' ,
                        '   <td>' ,
                        '    <label style="display:none;" for="choosableOptions">${leftTitle}</label>' , 
                        '    <select id="choosableOptions" dojoAttachPoint="choosableOptionsNode" name="choosableOptions" class="optionSelect" multiple="true" size="20" dojoAttachEvent="onchange: _onChooseSelect,ondblclick:_onAddItems">' ,
                        '    </select>' ,
                        '   </td>' ,
                        '   <td align="center">' ,
                        '    <table border="0" style="width:35px">' ,
                        '     <tr>' ,
                        '      <td><button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="addItemNode" iconClass="com-ibm-asq-common-web-ui-option-chooser-move-right-button" dojoAttachEvent="onClick: _onAddItems,onKeyPress: _onAddItems" tabindex="-1"></button></td>' ,
                        '     </tr>' ,
                        '     <tr>' ,
                        '      <td><button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="addAllItemsNode" iconClass="com-ibm-asq-common-web-ui-option-chooser-move-all-right-button" dojoAttachEvent="onClick: _onAddAllItems,onKeyPress: _onAddAllItems" tabindex="-1"></button></td>' ,
                        '     </tr>' ,
                        '     <tr>' ,
                        '      <td><button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="removeItemNode" iconClass="com-ibm-asq-common-web-ui-option-chooser-move-left-button" dojoAttachEvent="onClick: _onRemoveItems,onKeyPress: _onRemoveItems" tabindex="-1"></button></td>' ,
                        '     </tr>' ,
                        '     <tr>' ,
                        '      <td><button dojoType="com.ibm.asq.common.web.ui.internal.widgets.Button" dojoAttachPoint="removeAllItemsNode" iconClass="com-ibm-asq-common-web-ui-option-chooser-move-all-left-button" dojoAttachEvent="onClick: _onRemoveAllItems,onKeyPress: _onRemoveAllItems" tabindex="-1"></button></td>' ,
                        '     </tr>' ,
                        '    </table>' ,
                        '   </td>' ,
                        '   <td>' ,
                        '    <label style="display:none;" for="chosenOptions">${rightTitle}</label>' ,
                        '    <select id="chosenOptions" dojoAttachPoint="chosenOptionsNode" class="optionSelect" multiple="true" size="20" dojoAttachEvent="onchange:_onChosenSelect">' ,
                        '    </select>' ,
                        '   </td>' ,
                        '  </tr>' ,
                        ' </table>' ,
                        ' <div align="center">' ,
                        ' <table class="chooser-button-area" dojoAttachPoint="buttonTableNode" border="0">' ,
                        '  <tr>' ,
                        '   <td class="action-button-cell">' ,
                        '    <button dojoAttachPoint="okNode" class="option-action-button" dojoAttachEvent="onclick: _okAction"></button>' ,
                        '   </td>' ,
                        '   <td class="action-button-cell">' ,
                        '    <button dojoAttachPoint="cancelNode" class="option-action-button" dojoAttachEvent="onclick: _cancelAction"></button>' ,
                        '   </td>' ,
                        '  </tr>' ,
                        ' </table>' ,
                        ' </div>' ,
                        '</div>'].join(""),
                        
		newLabel: Constants.getMessage("labelNew"),
		newIcon: ImageCache.ADD_ICON_ENABLED,		
		upLabel: Constants.getMessage("labelUp"),
		upIcon: ImageCache.MOVE_UP_ICON_ENABLED,
		downLabel: Constants.getMessage("labelDown"),
		downIcon: ImageCache.MOVE_DOWN_ICON_ENABLED,
		deleteLabel: Constants.getMessage("labelDelete"),
		deleteIcon: ImageCache.DELETE,
		editLabel: Constants.getMessage("labelEdit"),
		editIcon: ImageCache.EDIT,
		
		enableCreate: false,
		widgetsInTemplate: true,
		
		postCreate: function() {
			this.inherited('postCreate', arguments);
			this.deletedOptions = [];
			this._enableButtons();
		},
			
		addNewListener: function(newListener) {
			if (dojo.isFunction(newListener)) {
				this._newListener = newListener;
			}
		},
		
		addEditListener: function(editListener) {
			if (dojo.isFunction(editListener)) {
				this._editListener = editListener;
			}
		},
		
		addDeleteListener: function(deleteListener) {
			if (dojo.isFunction(deleteListener)) {
				this._deleteListener = deleteListener;
			}
		},
		
		setDisabled: function(/*boolean*/ disabled) {
			this.inherited("setDisabled",arguments); 
			if (disabled) {
				this._disableButtons();
			}
		},
		
		getDeletedOptions: function(){
			return this.deletedOptions;
		},
		
        _onNew: function(e) {
			if (e && e.type == "keypress" && e.keyCode != dojo.keys.ENTER) return;
            if (dojo.isFunction(this._newListener)) {
                this._newListener();
            }
            if(e){
                dojo.stopEvent(e);
            }
        },
		
		_onEdit: function(e) {
			if (e && e.type == "keypress" && e.keyCode != dojo.keys.ENTER) return;
            if (dojo.isFunction(this._editListener)) {
				var selected = null;
				var options = this.chosenOptionsNode.options;
				selected = this.options[options[options.selectedIndex].value].data;
				selected.index = options.selectedIndex;
				selected.value = options[options.selectedIndex].value;
				if(selected){
					this._editListener(selected);
				}
            }
            if(e){
                dojo.stopEvent(e);
            }
        },
				
		_onMoveUp: function(e){
			if (e && e.type == "keypress" && e.keyCode != dojo.keys.ENTER) return;
			if(this.chosenOptionsNode.options[0].selected == true){
				return;
			}
			for( var i = 0; i < this.chosenOptionsNode.options.length; i++){
				if(this.chosenOptionsNode.options[i].selected == true && i > 0){
					var option = dojo.clone(this.chosenOptionsNode.options[i - 1]);
					this.chosenOptionsNode.options[i - 1].value = this.chosenOptionsNode.options[i].value;
					this.chosenOptionsNode.options[i - 1].innerHTML = this.chosenOptionsNode.options[i].innerHTML;
					this.chosenOptionsNode.options[i - 1].selected = true;
					this.chosenOptionsNode.options[i - 1].required = this.chosenOptionsNode.options[i].required;
					this.chosenOptionsNode.options[i - 1].className = this.chosenOptionsNode.options[i].className;
					 this.chosenOptionsNode.options[i - 1].title = this.chosenOptionsNode.options[i].title;
					this.chosenOptionsNode.options[i].value = option.value;
					this.chosenOptionsNode.options[i].innerHTML = option.innerHTML;
					this.chosenOptionsNode.options[i].selected = option.selected;
					this.chosenOptionsNode.options[i].required = option.required;
					this.chosenOptionsNode.options[i].className = option.className;
					this.chosenOptionsNode.options[i].title = option.title;
				}
			}
			if(e){
                dojo.stopEvent(e);
            }
		},
		
		_onMoveDown: function(e) {
			if (e && e.type == "keypress" && e.keyCode != dojo.keys.ENTER) return;
			if(this.chosenOptionsNode.options[this.chosenOptionsNode.options.length - 1].selected == true){
				return;
			}
			for( var i = this.chosenOptionsNode.options.length - 1; i >= 0; i--){
				if(this.chosenOptionsNode.options[i].selected == true && i < this.chosenOptionsNode.options.length - 1){
					var option = dojo.clone(this.chosenOptionsNode.options[i + 1]);
					this.chosenOptionsNode.options[i + 1].value = this.chosenOptionsNode.options[i].value;
					this.chosenOptionsNode.options[i + 1].innerHTML = this.chosenOptionsNode.options[i].innerHTML;
					this.chosenOptionsNode.options[i + 1].selected = true;
					this.chosenOptionsNode.options[i + 1].required = this.chosenOptionsNode.options[i].required;
					this.chosenOptionsNode.options[i + 1].className = this.chosenOptionsNode.options[i].className;
					this.chosenOptionsNode.options[i + 1].title = this.chosenOptionsNode.options[i].title;
					this.chosenOptionsNode.options[i].value = option.value;
					this.chosenOptionsNode.options[i].innerHTML = option.innerHTML;
					this.chosenOptionsNode.options[i].selected = option.selected;
					this.chosenOptionsNode.options[i].required = option.required;
					this.chosenOptionsNode.options[i].className = option.className;
					this.chosenOptionsNode.options[i].title = option.title;
				}
			}
			if(e){
                dojo.stopEvent(e);
            }
		},
		
		_onDelete: function(e) {
			if (e && e.type == "keypress" && e.keyCode != dojo.keys.ENTER) return;
            if (dojo.isFunction(this._deleteListener)) {
                this._deleteListener();
            }
            if(e){
                dojo.stopEvent(e);
            }
		},
		
		_okAction: function( event )
		{
			this.okNode.disabled = true;
			if( this.oklistener )
				this.oklistener( event );
			if(event){
                dojo.stopEvent(event);
            }
		},

        _enableButtons: function() {
            this.inherited('_enableButtons', arguments);
            this.newButton.setDisabled(this.enableCreate ? false : true);
			var options = this.chosenOptionsNode.options;
			var length = options.length;
			var selectedData = [];
			var requiredSelected = false;
			var outOfBoxSelected = false;
			for(var i = 0; i < length; i++){
				var option = options[i];
				if(option.selected){
					var data = this.options[option.value].data;
					selectedData.push(data);
					requiredSelected = requiredSelected || data.required;
					outOfBoxSelected = outOfBoxSelected || data.itemType == Constants.STATICSECTION;
				}
			}
			if(selectedData.length == 1){
				this.editButton.setDisabled(false || outOfBoxSelected);
			}else{
				this.editButton.setDisabled(true);
			}
			
			if(selectedData.length > 0){
				 this.upButton.setDisabled(false);
	             this.downButton.setDisabled(false);
				 this.deleteButton.setDisabled(requiredSelected || outOfBoxSelected);
			} else {
				 this.upButton.setDisabled(true);
                 this.downButton.setDisabled(true);	
				 this.deleteButton.setDisabled(true);
			}
        },
		        
        _disableButtons: function() {
			this.inherited('_disableButtons', arguments);
            this.newButton.setDisabled(true);
            this.upButton.setDisabled(true);
            this.downButton.setDisabled(true);
			this.editButton.setDisabled(true);
			this.deleteButton.setDisabled(true);
        }
        
    });
    
})();
