/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.horizontalTree.FxUtil");

dojo.require("dojo.fx");

(function() {

dojo.fx.wipeInHorizontal = function(/*Object*/ args){
    // summary
    //      Returns an animation that will expand the
    //      node defined in 'args' object from it's current height to
    //      it's natural height (with no scrollbar).
    //      Node must have no margin/border/padding.
    args.node = dojo.byId(args.node);
    var node = args.node, s = node.style, o;
    var maxWidth = args.width;
    
    var anim = dojo.animateProperty(dojo.mixin({
        properties: {
            width: {
                // wrapped in functions so we wait till the last second to query (in case value has changed)
                start: function(){
                    // start at current [computed] height, but use 1px rather than 0
                    // because 0 causes IE to display the whole panel
                    o = s.overflow;
                    s.overflow="hidden";
                    if(s.visibility=="hidden"||s.display=="none"){
                        s.width="1px";
                        s.display="";
                        s.visibility="";
                        return 1;
                    }else{
                        var width = dojo.style(node, "width");
                        return Math.max(width, 1);
                    }
                },
                end: function(){
                    return maxWidth;
                }
            }
        }
    }, args));

    dojo.connect(anim, "onEnd", function(){ 
        s.width = maxWidth;
        s.overflow = o;
    });

    return anim; // dojo._Animation
}

dojo.fx.wipeOutHorizontal = function(/*Object*/ args){
    // summary
    //      Returns an animation that will shrink node defined in "args"
    //      from it's current height to 1px, and then hide it.
    var node = args.node = dojo.byId(args.node);
    var s = node.style;
    var o;

    var anim = dojo.animateProperty(dojo.mixin({
        properties: {
            width: {
                end: 1 // 0 causes IE to display the whole panel
            }
        }
    }, args));

    dojo.connect(anim, "beforeBegin", function(){
        o = s.overflow;
        s.overflow = "hidden";
        s.display = "";
    });
    dojo.connect(anim, "onEnd", function(){
        s.overflow = o;
        s.width = "auto";
        s.display = "none";
    });

    return anim; // dojo._Animation
}


})();

