/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormCheckboxLabelField");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.AbstractFormField");

(function() {
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormCheckboxLabelField", 
    com.ibm.rational.test.lm.web.ui.internal.widgets.layout.AbstractFormField,
{
    checked: false,
    
    postCreate: function() {
        this.inherited("postCreate", arguments);
        var td = this.fieldRowNode.insertCell(0);
        var doc = document;
		var inputLabel = doc.createElement("label");
		this.checkbox = doc.createElement("input");
        this.checkbox.type = "checkbox";
		this.checkbox.checked = this.checked;
        this.connect(this.checkbox, "onchange", "_handleCheckStateChanged");
		inputLabel.appendChild(this.checkbox)
        td.appendChild(inputLabel);
        
        this.labelField = doc.createElement("div");
        this.fieldHolderNode.appendChild(this.labelField);
        this.formField = this.labelField;
        this.formField.className = "field";
    },
          
    setValue: function(value)
    {
        this.labelField.innerHTML = value;
    },

    // Summary:
    //    Returns the value from the field. Subclass must override. A null is returned if
    //    no value is specified.
    //
    getValue: function()
    {
        return this.labelField.innerHTML;
    },
    
    _handleCheckStateChanged: function()
    {
        if(this.checkbox.checked) {
            dojo.removeClass(this.fieldLabelNode, "field-checkbox-deselected");
            dojo.removeClass(this.formField, "field-checkbox-deselected");
        }
        else {
            dojo.addClass(this.fieldLabelNode, "field-checkbox-deselected");
            dojo.addClass(this.formField, "field-checkbox-deselected");
        }
        this.onValueChanged(this, !this.checkbox.checked, this.checkbox.checked);
    }
});

})();
