/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//
// Summary:
//    InsertAttachDialog extends GenericAttachmentViewer to provide attachment uploading dialog. 
//    The Attachment Table is hidden, user could get the attachment info from Rich Text Area.  
//     
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertAttachDialog");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.GenericAttachmentViewer");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");

(function(){
	var Constants = com.ibm.asq.common.web.client.internal.Constants;
	
	var GenericAttachmentViewer = com.ibm.asq.common.web.ui.internal.widgets.GenericAttachmentViewer;

    dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertAttachDialog", GenericAttachmentViewer, {
        
		templateString: '<div style="background-color: white; border: 1px gray solid; padding: 15px;">' +
			'<div dojoAttachPoint= "_attachmentHeaderArea">'+
			'<div dojoAttachPoint="_message"></div>'+
			'<form dojoAttachPoint="_uploadForm" method="post" enctype="multipart/form-data">'+
			'   <div>${labelAddAttachmentRichText}</div>'+
			'   <div dojoAttachPoint="_uploadInputDiv"></div>'+
			'</form>'+
			'<table dojoAttachPoint="_attachmentTable">'+
			'<tbody dojoAttachPoint="_attachmentTableBody"></tbody>'+
			'</table>'+
			'<div dojoAttachPoint="_uploadDiv"></div>'+
			'</div>'+
			'<div dojoAttachPoint="_previewSection" style = "display:none"><label dojoAttachPoint="_noOfAttachments"></label></div>'+
			' <div><button dojoAttachEvent="onclick:cancel">${labelCancel}</button></div>' +
			'</div>',
		
		labelAddAttachmentRichText:  Constants.getMessage("labelAddAttachmentRichText"),
        labelCancel: Constants.getMessage("actionLabel_cancel"),
			
		//@Overridden from GenericAttachmentViewer
        postCreate: function(args){
			com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertAttachDialog.superclass.postCreate.apply(this, arguments);
        },
        
		//@Overridden from GenericAttachmentViewer
        initialize: function(args){
			com.ibm.asq.common.web.ui.internal.widgets.richtext.plugins.InsertAttachDialog.superclass.initialize.apply(this, arguments);
            this.parent = args.parent;
			this._attachmentTable.style.display = "none";
        },
	
		//@Overridden from GenericAttachmentViewer
        _showFormHideMessage: function() {
			this._isUploadInProgress = false;
			this._initializeUploadInput(); // reset the form
			var newAtta = this.getNewAttachments();
			if(newAtta && newAtta.length > 0)
				this.parent.setValue({attaches: newAtta});
			this._attachmentArray = new Array();
			dojox.data.dom.removeChildren(this._attachmentTableBody);
		},
		
		//@Overridden from GenericAttachmentViewer: no need to refresh attachment table
		_rebindAttachments: function() {
		},
		
		cancel: function(event) {
			 this.parent.editor.focus();
			 this.parent._onCloseDialog();
			 if(event){
                dojo.stopEvent(event);
             }
		}
    });
    
})();
