//Scheduler
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
// author: Paul Beaulieu
//
// Summary: This is a widget to choose options.
//

dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.scheduler.Scheduler");

dojo.require( "dijit._Calendar" );
dojo.require( "dijit._Widget" );
dojo.require( "dijit._Templated" );
dojo.require( "dijit.form.Slider" );
dojo.require( "dijit.form.Button" );
dojo.require("dijit.form.TextBox");
dojo.require("dojo.date.locale");
dojo.require("dojox.data.dom");
dojo.require("jazz.ui.HoverPopup");

dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker");
dojo.require("com.ibm.asq.common.web.ui.internal.util.DomConstructor");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");

dojo.require("com.ibm.team.repository.web.client.session.Session");

(function() {
var _textContent=dojo.isIE?"innerText":"textContent"; 

var am = 1;
var pm = 2;

var hour = 0;
var day = 1;
var month = 2;

var daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var monthvalues = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
var zoomlevels = ["hourly", "daily", "weekly", "monthly", "yearly"];
var slotsperunit = {"hourly": 24, "daily": 24, "weekly": 7, "monthly": 31, "yearly": 12}
var settings = {
				 "hourly": {"showhours": true, "unitsToShow": 1, "slotsperunit": 24, "resolution": hour }, 
				 "daily": {"showhours": false, "unitsToShow": 4, "slotsperunit": 24, "resolution": hour }, 
				 "weekly":{"showhours": false, "unitsToShow": 4, "slotsperunit": 7, "resolution": day }, 
				 "monthly":{"showhours": false, "unitsToShow": 4, "slotsperunit": 31, "resolution": day }, 
				 "yearly": {"showhours": false, "unitsToShow": 4, "slotsperunit": 12, "resolution": month }
			   };
			   
var zoomcmds = {
				"hourly": {"zoomout": "daily", "zoomin": "hourly"},
				"daily": {"zoomout": "weekly", "zoomin": "hourly" },
				"weekly": {"zoomout": "monthly", "zoomin": "daily" },
				"monthly": {"zoomout": "yearly", "zoomin": "weekly" },
				"yearly": {"zoomout": "yearly", "zoomin": "monthly" }
			   }			   

var onedaymillis = ( new Date( 1970, 1, 2 ) ).getTime() - ( new Date( 1970, 1, 1 ) ).getTime();
var onehourmillis = ( new Date( 1970, 1, 1, 1, 0, 0, 0 ) ).getTime() - ( new Date( 1970, 1, 1, 0, 0, 0, 0 ) ).getTime();
var getCurrentContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;


dojo.declare(
    "com.ibm.asq.common.web.ui.internal.widgets.scheduler.Scheduler",
    [dijit._Widget, dijit._Templated],
{
    templateString: ['<div class="scheduler-widget" dojoAttachPoint="domNode" tabindex="-1">' ,
    				'    <table class="scheduler-button-table" dojoAttachPoint="dateselectionnode">' ,
					'    <tr dojoAttachPoint="reserveFromArea">' ,
					'     <td nowrap dojoAttachPoint="fromDateNode" colspan="2" class="from-date-cell"/>' ,
					'     <td nowrap dojoAttachPoint="legendNode" class="legend-cell">' ,
					'     </td>' ,
					'    </tr>' ,
					'    <tr dojoAttachPoint="reserveToArea">' ,
					'     <td nowrap dojoAttachPoint="toDateNode" class="to-date-cell"/>' ,
					'     <td nowrap dojoAttachPoint="bottomRowButtonAreaNode2" class="reserve-cell-area">' ,
					'      <div dojoType="dijit.form.Button" showLabel="true" iconClass="scheduler-reserve-icon-image" class="scheduler-reserve-button" dojoAttachPoint="reserveButtonNode" disabled/>' ,
					'     <td nowrap dojoAttachPoint="bottomRowButtonAreaNode" class="refresh-cell-area style="width=20px">' ,
					'      <div dojoType="dijit.form.Button" showLabel="false" iconClass="scheduler-refresh-icon-image" class="scheduler-reserve-button" dojoAttachPoint="refreshButtonNode" style="width=20px"/>' ,
					'     </td>' ,
					'    </tr>' ,
                    '    <tr>' ,
                    '     <td>' ,
                    '      <div dojoAttachPoint="messageArea" style="display: none">' ,
                    '       <div class="scheduler-error-image">' ,
                    '         <span dojoAttachPoint="messageLabel" class="scheduler-error-message"></span>' ,
                    '       </div>' ,
                    '      </div>' ,
                    '     </td>' ,
                    '    </tr>' ,
					'    <tr dojoAttachPoint="separatorNode" class="separator-row">' ,
					'     <td colspan="3">' ,
					'      <div class="separator-div">' ,
					'      </div>' ,
					'     </td>' ,
					'    </tr>' ,
//					'    <tr>' ,
//					'     <td>' ,
//					'      <table class="legend-table">' ,
//					'       <thead>' ,
//					'        <th colspan="6" class="legend-header">Legend</th>' ,
//					'       </thead>' ,
//					'       <tr>' ,
//					'        <td class="legend-label">Reserved:</td>' ,
//					'        <td class="reserved-div">\u00a0</td>' ,
//					'        <td class="legend-label">Reservable:</td>' ,
//					'        <td class="reservable-div">\u00a0</td>' ,
//					'        <td class="legend-label">Conflict:</td>' ,
//					'        <td class="conflict-div">\u00a0</td>' ,
//					'       </tr>' ,
//					'      </table>' ,
//					'     </td>' ,
//					'	 </tr>' ,
					'    <tr>' ,
					'     <td>' ,
					'      <table class="legend-table">' ,
					'       <tr>' ,
					'        <td class="color-code"><div class="reserved-for-you-div"/></td>' ,
					'        <td class="legend-label">${reservedForYouLabel}</td>' ,
					'       </tr>' ,
					'       <tr>' ,
					'        <td class="color-code"><div class="reserved-div"/></td>' ,
					'        <td class="legend-label">${reservedLabel}</td>' ,
					'       </tr>' ,
					'       <tr>' ,
					'        <td class="color-code"><div class="reservable-div"/></td>' ,
					'        <td class="legend-label">${reservableLabel}</td>' ,
					'       </tr>' ,
					'       <tr>' ,
					'        <td class="color-code"><div class="conflict-div"/></td>' ,
					'        <td class="legend-label">${conflictLabel}</td>' ,
					'       </tr>' ,
					'      </table>' ,
					'     </td>' ,
					'    </tr>' ,
					'    <tr>' ,
					'     <td dojoAttachPoint="progressCellNode">',
		            '      <div dojoAttachPoint="progressIndicator" class="progress-indicator" style="display: none">' ,
                    '       <div class="view-progress-image">' ,
                    '        <span dojoAttachPoint="progressLabel" class="view-progress-label"></span>' ,
                    '       </div>' ,
                    '      </div>' ,
				    '     </td>' ,
					'     <td dojoAttachPoint="zoomActionsCellNode" class="scheduler-button-top-row">' ,
					'      <span dojoAttachPoint="zoomSpanNode"/>' ,
					'     </td>' ,
					'    </tr>' ,
					'   </table>' ,
   				    '  <div class="scheduler-day-area" dojoAttachPoint="dayareanode"></div>' ,
                    '</div>'].join(""),

	widgetsInTemplate: true,
	reservedLabel: MessageUtil.getMessage( MessageBundle.COMMON, "ReservedForOthers" ),
	reservedForYouLabel: MessageUtil.getMessage( MessageBundle.COMMON, "ReservedForYou" ),
	reservableLabel: MessageUtil.getMessage( MessageBundle.COMMON, "Reservable" ),
	conflictLabel: MessageUtil.getMessage( MessageBundle.COMMON, "Conflict" ),
	    						
	postCreate: function()
	{
		this.currentUser = getCurrentContributor();  //Use the current user to determine the reservation types
		var idparts = this.domNode.id.split( "_" );
		this.idpart = idparts[ idparts.length - 1 ];
		this.reserveButtonNode.onClick =dojo.hitch( this, this.onReserveClick );
		this.refreshButtonNode.onClick =dojo.hitch( this, this.onRefreshClick );

		this.reserveButtonNode.setLabel( MessageUtil.getMessage(MessageBundle.COMMON, "Reserve") );
		var midnight = new Date();
        midnight.setHours(0, 0, 0, 0);
		
		this.startDatePicker = new com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker( 
						{
							"label": MessageUtil.getMessage(MessageBundle.COMMON, "Reserve From"),
							"onDateChange": dojo.hitch(this, this.onStartDateChange),
							"onTimeChange": dojo.hitch(this, this.onStartTimeChange),
                            "onKeyUp": dojo.hitch(this, this.onStartDateChange),
							"dateName": "ReserveFrom",
							"dateClass": "scheduler-date-box-input-entry",
							"minDate": midnight,
							"time": midnight
						});

        var endOfDayTime = new Date();
        endOfDayTime.setHours(23, 59, 0, 0);
		this.endDatePicker  = new com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker( 
						{"label": MessageUtil.getMessage(MessageBundle.COMMON, "Reserve To" ),
						 "onDateChange": dojo.hitch( this, this.onEndDateChange ),
						 "onTimeChange": dojo.hitch( this, this.onEndTimeChange ),
                         "onKeyUp": dojo.hitch(this, this.onEndDateChange),
						 "dateName": "ReserveTo",
						 "dateClass": "scheduler-date-box-input-entry",
						 "minDate": midnight,
						 "time": endOfDayTime
						 });
		
		this.fromDateNode.appendChild( this.startDatePicker.domNode );							
		this.toDateNode.appendChild( this.endDatePicker.domNode );							


		this.currentStartDate = new Date();
		
		this.createButtonTopRow();
		
		//show the refresh button if desired by the client
		if (!this.showRefresh)
			this.refreshButtonNode.domNode.style.display = "none";
		
		if( this.entities )
			this._createSchedulerTimesTable( this.currentStartDate );
	},
		
    hideReservationControls: function() 
    {
        dojo.style(this.reserveFromArea, "display", "none");
        dojo.style(this.reserveToArea, "display", "none");
        dojo.style(this.separatorNode, "display", "none");        
    },
    
	_createSchedulerTimesTable: function( startDate )
	{	
		this.slots = settings[ this.zoomlevel ][ "slotsperunit" ];
		this.showhours = settings[ this.zoomlevel ][ "showhours" ];
		this.unitstoshow = settings[ this.zoomlevel ][ "unitsToShow" ];
		this.start24hrTime = 0;
		
		this.currentStartDate = startDate;
		
		if( this.zoomlevel == "hourly" )
		{
			this.starttime = 0;
			this.startperiod = am;
			this.endtime = 12;
			this.endperiod = pm;
		}
		else if( this.zoomlevel == "weekly" )
		{
			var dayofweek = this.currentStartDate.getDay();
			this.currentStartDate = new Date( this.currentStartDate.getTime() - dayofweek * onedaymillis );
		}
		else if( this.zoomlevel == "monthly" )
		{
			var day = this.currentStartDate.getDate();
			this.currentStartDate = new Date( this.currentStartDate.getTime() - ( ( day - 1 ) * onedaymillis ) );
		}
		
		var table = document.createElement( "table" );
		table.className = "scheduler-entity-table";
		this._createDayOfWeekRow( table, this.currentStartDate );
		if( this.showhours )
			this._createHoursOfDayRow( table );
			
		this.dayareanode.appendChild( table );
				
		for( var iEntity = 0; this.entities && ( iEntity < this.entities.length ); iEntity++ )
		{
			this._createEntitySchedulerRow( table, this.entities[ iEntity ] );
		}
			
		this._createFakeRowForBorder( table );
		this._createButtonRow( table );
	},
	
	_createDayOfWeekRow: function( table, startDate )
	{
		var date = new Date( startDate.getFullYear(),
							 startDate.getMonth(),
							 startDate.getDate(),
							 startDate.getHours(),
							 startDate.getMinutes(),
							 startDate.getSeconds(),
							 startDate.getMilliseconds() );
							 
		var trnode = table.insertRow( table.rows.length );
		var weekday = 0;
		
		if (this.showentities) {
			var tdnode = trnode.insertCell(0);
			tdnode.className = "scheduler-entity-table-emptycell";
			tdnode[_textContent]=MessageUtil.getMessage(MessageBundle.COMMON, "labelName");  //MFV
		}
		
		this._createVerticalSpacer( trnode );
		
		var dateslots = [];
		
		for( var iDay = 0; iDay < this.unitstoshow; iDay++ )
		{
			var str = null;
			
			if( iDay > 0 )
			{
				this._createVerticalSpacer( trnode );
				var day = date.getDate();
				
				if( this.zoomlevel == "yearly" )
				{
					date.setFullYear( date.getFullYear() + 1 );
				}
				else if (this.zoomlevel == "monthly") {
					var day = date.getDate();
					var monthdays = daysInMonth[ date.getMonth() ];
					if( ( ( date.getMonth() == 1 ) && this._isLeapYear( date.getYear() ) ) )
					{
						monthdays += 1;	
					}
					
					date = new Date( date.getTime() + onedaymillis * monthdays )				
				}
				else {
					date.setDate(day + ((this.zoomlevel == "weekly") ? 7 : 1));
				}
			}
						
            if (this.zoomlevel == "weekly") {
				var week = dojo.date.locale._getWeekOfYear( date );
				var dayofweek = date.getDay();
				var day = date.getDate();
				str = MessageUtil.getMessage(MessageBundle.COMMON, "Week of ");
				if( dayofweek > 0 )
				{
					//normalize the date to the first day of the week.  If a week crosses months, this will
					//properly work
					date = new Date( date.getTime() - ( dayofweek * onedaymillis ) );
					day = date.getDate();
				}
				var month = dojo.date.locale.format(date, {
					selector: "date",
					datePattern: "MMMM",
					timePattern: null
				});
				str += month + " " + day; 
			}
			else if( this.zoomlevel == "monthly" )
			{
				var day = date.getDate();
				str = dojo.date.locale.format(date, {
					selector: "date",
					datePattern: "MMMM",
					timePattern: null
				});
			}
			else if( this.zoomlevel == "yearly" )
			{
				str = dojo.date.locale.format(date, {
					selector: "date",
					datePattern: "yyyy",
					timePattern: null
				});				
			}
			else {
				var dayofweek = dojo.date.locale.format(date, {
                        selector: "date",
                        datePattern: "EEEE",
                        timePattern: null
                    });
                var dateStyle = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getDateFormatStyle();     
                var dateStr = dojo.date.locale.format(date, dateStyle);  
                
				if (this.zoomlevel == "daily") {                    
					str = dayofweek;
                    dateslots.push(dateStr);
				}
				else
				{
                    str = dayofweek + " " + dateStr;
				}
			}
					
			this.currentRow = 0
			var tdnode = trnode.insertCell( trnode.cells.length );
			tdnode.className = ( ( this.zoomlevel == "hourly" || this.zoomlevel == "daily" ) ? "time-dayofweek-cell-no-border" : "time-dayofweek-cell" );
			tdnode.id = ( ( this.zoomlevel == "daily" ) ? ( "time-dayofweek-cell-dayname-" + iDay + "-" + this.idpart ) : ( "time-dayofweek-cell-day-" + iDay + "-" + this.idpart ) );
			tdnode.colSpan = this.slots;
			tdnode[_textContent]=str;
			
			if (this.zoomlevel == "hourly" ||
			    this.zoomlevel == "weekly" )
			{
				this._createCalendarButton(tdnode, iDay, dojo.hitch(this, this._calendarButtonAction) );
			}
		}
				
		if( this.zoomlevel == "daily" )
		{
			//Create the Month, Day and Year row part of the day
			var trnode = table.insertRow( table.rows.length );

			if (this.showentities) 
			{
				//Need empty space where the "Name" column is
				var blanknode = trnode.insertCell(0); //MFV
				blanknode.className = "scheduler-entity-table-emptycell";
			}

			this._createVerticalSpacer( trnode );

			for( var iDay = 0; iDay < dateslots.length; iDay++ )
			{
				if (iDay > 0) {
					this._createVerticalSpacer(trnode);
				}
				
				var tdnode = trnode.insertCell( trnode.cells.length );
				tdnode.className = "time-dayofweek-cell";
				tdnode.id = "time-dayofweek-cell-day-" + iDay + "-" + this.idpart;
				tdnode.colSpan = this.slots;
				tdnode[_textContent]=dateslots[ iDay ];
				this._createCalendarButton(tdnode, iDay, dojo.hitch(this, this._calendarButtonAction) );
			}	
			 
			this._createVerticalSpacer( trnode );
		}
		else
			this._createVerticalSpacer( trnode );
	},
	
	_createHoursOfDayRow: function( table )
	{
		var trnode = table.insertRow( table.rows.length );
		
		if (this.showentities) {
			var tdnode = trnode.insertCell(0);
			tdnode.className = "scheduler-entity-table-emptycell";
			tdnode[_textContent]="\u00a0";
		}
		
		this._createVerticalSpacer( trnode );
		
		for( var iDay = 0; iDay < this.unitstoshow; iDay++ )
		{
			if( iDay > 0 )
			{
				this._createVerticalSpacer( trnode );
			}
			
			for( var i = 0; i < this.slots; i++ )
			{
				tdnode = trnode.insertCell( trnode.cells.length );
				
				tdnode.className = "time-timeofday-cell";
				
				var timestring = "";
				
				if( this.is24hour )
				{
					timestring = ( ( ( this.starttime < 12 ) ? "0" + this.starttime : this.starttime ) + "00 hrs" );
				}
				else
				{
					if( this.startperiod == am )
					{
						if( this.starttime + i == 12 )
						{
							timestring = ( ( this.starttime + i ) + "pm" );
						}
						else if( this.starttime + i > 12 )
						{
							timestring = ( ( this.starttime + i - 12 ) + "pm" );
						}
						else
						{
							if( ( this.starttime == 0 ) && ( i == 0 ) )
							{
								timestring = "12am" ;														
							}
							else
								timestring = ( ( this.starttime + i ) + "am" );						
						}
					}
					else
					{
						timestring = ( ( this.starttime + i ) + ( ( this.startperiod == 1 ) ? "am" : "pm" ) );
					}
				}
				
				tdnode[_textContent]=timestring;
			}
		}
		
		this._createVerticalSpacer( trnode );
	},
	
	_createVerticalSpacer: function( row )
	{
		var cell = row.insertCell( row.cells.length );
		cell[_textContent]="\u00a0";
		cell.className = "scheduler-vertical-spacer";
	},
	
	_createEntitySchedulerRow: function( table, entity )
	{
		var trnode = table.insertRow( table.rows.length );
		
		if (entity && this.showentities ) {
			var tdnode = trnode.insertCell( 0 );
			tdnode.className = "scheduler-entity-table-cell";
			if (entity.link)  //If there is a link associated with the entity (machine)
			{
				//add a link to the machine
				var link = document.createElement("a");
				link[_textContent]=entity.name;
				link.href = entity.link;
				tdnode.appendChild(link);
			}
			else
				tdnode[_textContent]=entity.name;
		}
		
		this._createVerticalSpacer( trnode );
		var cellIndices = [];
		var numdays = 0;
									 
		for( var iDay = 0; iDay < this.unitstoshow; iDay++ )
		{
			var date = null;
			
			if (this.zoomlevel == "weekly") {
				date = new Date( this.currentStartDate.getTime() + onedaymillis * 7 * iDay )
			}
			else if( this.zoomlevel == "monthly" )
			{
				var day = this.currentStartDate.getDate();
				var monthdays = daysInMonth[ ( this.currentStartDate.getMonth() + iDay ) % 12 ];
				//Testing for leap years
				if( ( ( ( this.currentStartDate.getMonth() + iDay ) % 12 ) == 1 ) && this._isLeapYear( this.currentStartDate.getYear() + ( ( iDay > 1 ) ? 1 : 0 ) ) )
				{
					monthdays += 1;	
				}
				
				
				date = new Date( this.currentStartDate.getTime() + ( ( iDay > 0 ) ? onedaymillis * numdays : 0 ) );				
				numdays += monthdays;
			}
			else if( this.zoomlevel == "yearly" )
			{
				date = new Date( ( this.currentStartDate.getFullYear() + iDay ), 0, 1 );
			}
			else {
				date = new Date(this.currentStartDate.getFullYear(), 
				                    this.currentStartDate.getMonth(), 
									this.currentStartDate.getDate() + iDay, 
									this.start24hrTime, 0, 0, 0);
			}
								 
			if( iDay > 0 )
			{
				this._createVerticalSpacer( trnode );
			}
			
			var start = trnode.cells.length;
			
			for( var i = 0; i < this.slots; i++ )
			{
				date = this.updateDate( date, i, 0 );
				//date.setHours( date.getHours() + ( ( i > 0 ) ? 1 : 0 ) );
				tdnode = trnode.insertCell( trnode.cells.length );
				var settable = this._isScheduleSetForDate( date );
				var reserved = this._isEntityReserved( entity, date );

				if (reserved && settable) //reserved by the current user
				{
					if (this._isReservedForCurrentUser(reserved))  //if reserved by current user then OK
						tdnode.className = "time-timeofday-entity-cell-settable";
					else
						tdnode.className = "time-timeofday-entity-cell-blocked";
					
					var tooltip = new jazz.ui.HoverPopup({
						html: this._createReservationTooltipString(reserved),
						around: [tdnode]
					});
					
				}
				else if( reserved && !settable )
				{
					if (this._isReservedForCurrentUser(reserved))  //if reserved by current user then OK
						tdnode.className = "time-timeofday-entity-cell-reserved-for-you";
					else
						tdnode.className = "time-timeofday-entity-cell-reserved";
					
					var tooltip = new jazz.ui.HoverPopup({
						html: this._createReservationTooltipString(reserved),
						around: [tdnode]
					});
				}
				else if( settable )
				{
					tdnode.className = "time-timeofday-entity-cell-settable";
				}
				else
				{
					tdnode.className = ( this.showhours ) ? "time-timeofday-entity-cell" : "time-timeofday-entity-cell-notimes";					
				}
				
				tdnode[_textContent]="\u00a0";
				
			}
			
			var end = trnode.cells.length - 1;
			
			cellIndices.push( { "start": start, "end": end } )
		}
		
		this._createVerticalSpacer( trnode );
		
		if( !( this.rows ) )
		{
			this.rows = [];
		}
		
		if( this.rows )
		{
			this.rows.push( { "entity": entity, row: trnode, indices: cellIndices } );
		}	
	},
	
	_createFakeRowForBorder: function( table )
	{
		var trnode = table.insertRow( table.rows.length );
		trnode.className = "separator-row";
		var cell = trnode.insertCell( trnode.cells.length );
		cell.colSpan = this.slots * this.unitstoshow + this.unitstoshow + 1;
		cell.className = "border-cell";
		var div = document.createElement( "div" );
		div.className = "border-div";
		cell.appendChild( div );
	},

	updateDate: function( date, slot, startvalue )
	{
		if( ( this.zoomlevel == "hourly" ) ||
		    ( this.zoomlevel == "daily" ) )
			return( new Date( date.setHours( date.getHours() + ( ( slot > startvalue ) ? 1 : 0 ) ) ) );
        else if( this.zoomlevel == "weekly" )
		{
			return( new Date( date.getTime() + ( ( slot > 0 ) ? onedaymillis : 0 ) ) );
		}
		else if( this.zoomlevel == "monthly" )
		{
			var month = date.getMonth();
			if( ( daysInMonth[ month ] < settings[ "monthly" ][ "slotsperunit" ] ) && ( slot >= daysInMonth[ month ] ) )
			{
				if( ( month == 1 ) && this._isLeapYear( date.getYear() ) && ( slot >= 29 ) )
				{
					return( date );
				}
				else if( ( month == 1 ) && !this._isLeapYear( date.getYear() ) )
				{
					return( new Date( date.getTime() + ( ( slot > 0 ) ? onedaymillis : 0 ) ) );
				}
				
				return( date );
			}
			else
			{
				return( new Date( date.getTime() + ( ( slot > 0 ) ? onedaymillis : 0 ) ) );
			}
		}
		else if( this.zoomlevel == "yearly" )
		{
			return( new Date( date.setMonth( date.getMonth() + ( ( slot > 0 ) ? 1 : 0 ) ) ) );
		}				
	},
	
	_createButtonRow: function( table )
	{
		var trnode = table.insertRow( table.rows.length );
		
		if (this.showentities) {
			var tdnode = trnode.insertCell(0);
			tdnode.className = "scheduler-entity-table-emptycell";
			tdnode[_textContent]="\u00a0";
		}
		
		tdnode = trnode.insertCell( trnode.cells.length );
		tdnode[_textContent]="\u00a0";
		tdnode.className = "scheduler-vertical-spacer-transparent";
		
		var lefttdnode = trnode.insertCell( trnode.cells.length );
		lefttdnode.colSpan = ( this.slots * this.unitstoshow + ( this.unitstoshow + 1 ) ) / 2;
		
		this._createLeftButton( lefttdnode );
		
		var righttdnode = trnode.insertCell( trnode.cells.length );
		righttdnode.colSpan = ( this.slots * this.unitstoshow + ( this.unitstoshow + 1 ) ) - lefttdnode.colSpan;
		
		this._createRightButton( righttdnode );	
	},
	
	_createLeftButton: function( tdnode )
	{
		tdnode.className = "time-timeofday-buttonleft-cell";
        var arg = {
            label: MessageUtil.getMessage(MessageBundle.COMMON, "scheduler_buttonleft"),
            showLabel: false, // label only or both icon and label
            onClick: dojo.hitch( this, this.backButtonAction ),
            iconClass: "scheduler-button-left-image",
            'class': "com-ibm-asq-common-web-ui-internal-widgets-scheduler-left-button"
        };
        		        
		var leftbutton = new dijit.form.Button( arg );
		tdnode.appendChild( leftbutton.domNode );
	},
	
	_createRightButton: function( tdnode )
	{
		tdnode.className = "time-timeofday-buttonright-cell";
        var arg = {
            label: MessageUtil.getMessage(MessageBundle.COMMON, "scheduler_buttonright"),
            showLabel: false, // label only or both icon and label
            onClick: dojo.hitch( this, this.forwardButtonAction ),
            iconClass: "scheduler-button-right-image",
            'class': "com-ibm-asq-common-web-ui-internal-widgets-scheduler-right-button"
        };
        
		var rightbutton = new dijit.form.Button( arg );
		tdnode.appendChild( rightbutton.domNode );
	},
	
	backButtonAction: function()
	{
		var day = this.currentStartDate.getDate();
		var month = this.currentStartDate.getMonth();
		var year = this.currentStartDate.getFullYear();
		
		if (this.zoomlevel == "yearly") {
			this.currentStartDate.setFullYear(year - 1, month, day);
		}
		else if (this.zoomlevel == "monthly") {
			var daystosub = daysInMonth[( month == 0 ) ? 11 : month - 1 ];
			if ((month - 1 == 1) && this._isLeapYear(year)) 
				daystosub++;
			
			this.currentStartDate = new Date(this.currentStartDate.getTime() - onedaymillis * (daystosub - day + 1));
		}
		else 
			if (this.zoomlevel == "weekly") {
				this.currentStartDate = new Date(this.currentStartDate.getTime() - onedaymillis * 7);
			}
			else {
				if (day == 1) {
					year = (month == 0) ? year - 1 : year;
					month = (month == 0) ? 11 : month - 1;
					day = daysInMonth[month] + ((this._isLeapYear(year) && (month == 1)) ? 1 : 0);
				}
				else 
					day = day - 1;
				
				this.currentStartDate.setFullYear(year, month, day);
			}
			
		this._updateDaysOfWeekTimeOut();
	},
	
	forwardButtonAction: function()
	{
		var day = this.currentStartDate.getDate();
		var month = this.currentStartDate.getMonth();
		var year = this.currentStartDate.getFullYear();
		
		if (this.zoomlevel == "yearly") {
			this.currentStartDate.setFullYear( year + 1, month, day );
		}
		else if (this.zoomlevel == "monthly") {
			var daystoadd = daysInMonth[ month ];
			if( ( month == 1 ) && this._isLeapYear( year ) )
				daystoadd++;
				
			this.currentStartDate = new Date( this.currentStartDate.getTime() + onedaymillis * ( daystoadd - day + 1 ) );
		}
		else if (this.zoomlevel == "weekly") {
			this.currentStartDate = new Date( this.currentStartDate.getTime() + onedaymillis * 7 );
		}
		else {
			if (daysInMonth[month] == day) {
				year = (month == 11) ? year + 1 : year;
				month = (month == 11) ? 0 : month + 1;
				day = 1 + ((this._isLeapYear(year) && (month == 1)) ? daysInMonth[month] : 0);
			}
			else 
				day = day + 1;
				
			this.currentStartDate.setFullYear( year, month, day );
		}
			
		this._updateDaysOfWeekTimeOut();
	},
	
	_subtractDaysFromDate: function( date, days )
	{
		var day = date.getDate();
		var month = date.getMonth();
		var year = date.getFullYear();
		var multiplier = ( ( this.zoomlevel == "weekly" ) ? 7 : 1 );
		
		return( new Date( ( date.getTime() - ( multiplier * onedaymillis * days ) ) ) );
		
//		if( ( day - days ) < 1 )
//		{
//			var zerothday = new Date( 1970, 1, 1 );
//			var nthday = new Date( 1970, 1, 1 + days );
//			var diff = nthday.getTime() - zerothday.getTime();
//			var newDateTime = date.getTime() - diff;
//			var newDate = new Date( newDateTime );
//			year = newDate.getFullYear();
//			month = newDate.getMonth();
//			day = newDate.getDate();
//		}
//		else
//			day = day - days;
//			
//		return( new Date( year,
//						  month,
//						  day,
//						  date.getHours(),
//						  date.getMinutes(),
//						  date.getSeconds(),
//						  date.getMilliseconds() ) );
	},

	_isLeapYear: function( year )
	{
		if( ( year % 4 ) == 0 )
		{
			if( ( ( year % 100 ) == 0 ) && ( year % 400 ) )
			{
				return( false );
			} 
			
			return( true );
		}
		
		return( false );
	},
	
	_createCalendarButton: function( cellNode, day, callback, field )
	{
        var arg = {
            'label': MessageUtil.getMessage(MessageBundle.COMMON, "scheduler_buttoncalendar"),
            showLabel: false, // label only or both icon and label
            iconClass: "scheduler-button-calendar-image",
            'class': "com-ibm-asq-common-web-ui-internal-widgets-scheduler-calendar-button"
        };
        
        if( callback )
        {
        	arg[ "onClick" ] = 	function( e )
        					   	{
        					   		callback( this, e, field );
        					   	}
        }
        
        if( day != undefined )
        {
        	arg[ "day" ] = day;
        }
                
		var calendarbutton = new dijit.form.Button( arg );
		
		cellNode.appendChild( calendarbutton.domNode );
	},
	
	_calendarButtonAction: function( button, event )
	{
		if (!this._picker) 
		{
			var popupProto = dojo.getObject("dijit._Calendar", true /*false*/);
			this._picker = new popupProto({
				_currentDateBox: null,
				_dateBoxId: null,
				_container: this,
				_parent: button,
				closable:true,
				onValueSelected: function(date)
				{
					dijit.popup.close(this._container._picker);
					var day = this._parent.day;
					this._container.currentStartDate = this._container._subtractDaysFromDate( date, day );
					this._container._updateDaysOfWeekTimeOut();
				}
			});
			
			dojo.connect(this._picker, "onBlur", this._picker, function() {
			    dijit.popup.close(this);	
			});
		}
		else
		{
			this._picker._parent = button;
		}
		
		var date = new Date( this.currentStartDate.getFullYear(),
							 this.currentStartDate.getMonth(),
							 this.currentStartDate.getDate(),
							 this.currentStartDate.getHours(),
							 this.currentStartDate.getMinutes(),
							 this.currentStartDate.getSeconds(),
							 this.currentStartDate.getMilliseconds() );
						
							 
							 
		var multiplier = ( ( this.zoomlevel == "weekly" ) ? 7 : 1 );
		date = new Date( ( date.getTime() + ( button.day * multiplier * onedaymillis ) ) )
		
		this._picker.setValue(date);								  
        
		dijit.popup.open({
			parent: button,
			popup: this._picker,
			around: button.domNode,
			onClose: function()
			{//do nothing
			}
		});		
		
		dijit.focus(this._picker.domNode);
	},
	
	_updateDaysOfWeekTimeOut: function()
	{
		setTimeout( dojo.hitch( this, this._updateDaysOfWeek ), 200 );
	},
	
	_updateDaysOfWeek: function()
	{
		var date = new Date( this.currentStartDate.getFullYear(),
							 this.currentStartDate.getMonth(),
							 this.currentStartDate.getDate(),
							 this.currentStartDate.getHours(),
							 this.currentStartDate.getMinutes(),
							 this.currentStartDate.getSeconds(),
							 this.currentStartDate.getMilliseconds() );
		
		var dateslots = [];
		
		for( var iDay = 0; iDay < this.unitstoshow; iDay++ )
		{
			var tdnodedayofweek = null;
			if (this.zoomlevel == "daily") {
				tdnodedayofweek = dojo.byId("time-dayofweek-cell-dayname-" + iDay + "-" + this.idpart);
			}
			
			var tdnodeday = dojo.byId( "time-dayofweek-cell-day-" + iDay + "-" + this.idpart );
			
			var str = null;
			
			if( tdnodeday )
			{
				dojox.data.dom.removeChildren( tdnodeday );

				if (this.zoomlevel == "weekly") {
					date = new Date( date.getTime() + ( ( iDay > 0 ) ? onedaymillis * 7 : 0 ) )
					var week = dojo.date.locale._getWeekOfYear( date );
					var dayofweek = date.getDay();
					var day = date.getDate();
					
					if( dayofweek > 0 )
					{
						//normalize the date to the first day of the week.  If a week crosses months, this will
						//properly work
						date = new Date( date.getTime() - ( dayofweek * onedaymillis ) );
						day = date.getDate();
					}
					str = MessageUtil.getMessage(MessageBundle.COMMON, "Week of ");
					var month = dojo.date.locale.format(date, {
						selector: "date",
						datePattern: "MMMM",
						timePattern: null
					});
					
					
					str += month + " " + day; 
				}
				else if( this.zoomlevel == "monthly" )
				{
					var monthdays = daysInMonth[ date.getMonth() ];
					if( ( ( ( date.getMonth() ) % 12 ) == 1 ) && this._isLeapYear( date.getYear() ) )
					{
						monthdays += 1;	
					}
					
					var numdays = monthdays;
					
					date = new Date( date.getTime() + ( ( iDay > 0 ) ? ( onedaymillis * numdays ) : 0 ) );				
					str = dojo.date.locale.format(date, {
						selector: "date",
						datePattern: "MMMM",
						timePattern: null
					});
				}
				else if( this.zoomlevel == "yearly" )
				{
					date = new Date( date.setFullYear( date.getFullYear() + 1 ) );
			        str = dojo.date.locale.format(date, {selector: "date", datePattern: "yyyy", timePattern: null});
				}
				else {
					var day = date.getDate();
					date.setDate( day + ( ( iDay > 0 ) ? 1 : 0 ) );

                    var dayofweek = dojo.date.locale.format(date, {
                            selector: "date",
                            datePattern: "EEEE",
                            timePattern: null
                        });
                    var dateStyle = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getDateFormatStyle();     
                    var dateStr = dojo.date.locale.format(date, dateStyle);  
                    
					if (this.zoomlevel == "daily") {						
						tdnodedayofweek[_textContent]=dayofweek;
                        
                        str = dateStr;
					}
					else {
                        str = dayofweek + " " + dateStr;  
					}
				}
				
				tdnodeday[_textContent]=str;
				
				if (this.zoomlevel == "hourly" ||
				this.zoomlevel == "daily" ||
				this.zoomlevel == "weekly") {
					this._createCalendarButton(tdnodeday, iDay, dojo.hitch(this, this._calendarButtonAction));
				}	        			
			}
		}
		
		for (var iEntity = 0; iEntity < this.rows.length; iEntity++) 
		{
			var numdays = 0;		
			for (var iDay = 0; iDay < this.unitstoshow; iDay++) 
			{
				var date = null;
				
				if (this.zoomlevel == "weekly") {
					date = new Date( this.currentStartDate.getTime() + onedaymillis * 7 * iDay )
				}
				else if( this.zoomlevel == "monthly" )
				{
					var day = this.currentStartDate.getDate();
					var monthdays = daysInMonth[ ( this.currentStartDate.getMonth() + iDay ) % 12 ];
					if( ( ( ( this.currentStartDate.getMonth() + iDay ) % 12 ) == 1 ) && this._isLeapYear( this.currentStartDate.getYear() + ( ( iDay > 1 ) ? 1 : 0 ) ) )
					{
						monthdays += 1;	
					}
					
					
					date = new Date( this.currentStartDate.getTime() + ( ( iDay > 0 ) ? onedaymillis * numdays : 0 ) );				
					numdays += monthdays;
				}
				else if( this.zoomlevel == "yearly" )
				{
					date = new Date( ( this.currentStartDate.getFullYear() + iDay ), 0, 1 );
				}
				else {
					date = new Date(this.currentStartDate.getFullYear(), 
					                    this.currentStartDate.getMonth(), 
										this.currentStartDate.getDate() + iDay, 
										this.start24hrTime, 0, 0, 0);
				}
				
				var count = 0;
				for (var i = this.rows[ iEntity ].indices[ iDay ].start; i <= this.rows[ iEntity ].indices[ iDay ].end; i++) 
				{
					date = this.updateDate( date, count, 0 );
					var tdnode = this.rows[ iEntity ].row.cells[ i ];
					var settable = this._isScheduleSetForDate( date );
					var reserved = this._isEntityReserved( this.rows[ iEntity ].entity, date );

					if (reserved && settable) //reserved by the current user
					{
						if (this._isReservedForCurrentUser(reserved))  //if reserved by current user then OK
							tdnode.className = "time-timeofday-entity-cell-settable";
						else
							tdnode.className = "time-timeofday-entity-cell-blocked";
						
						var tooltip = new jazz.ui.HoverPopup({
							html: this._createReservationTooltipString(reserved),
							around: [tdnode]
						});
						
					}
					else if( reserved && !settable )
					{
						if (this._isReservedForCurrentUser(reserved))  //if reserved by current user then OK
							tdnode.className = "time-timeofday-entity-cell-reserved-for-you";
						else
							tdnode.className = "time-timeofday-entity-cell-reserved";
	                        var tooltip = new jazz.ui.HoverPopup({
	                            html: this._createReservationTooltipString(reserved),
	                            around: [tdnode]
	                        });
					}
					else if( settable )
					{
						tdnode.className = "time-timeofday-entity-cell-settable";
					}
					else
					{
						tdnode.className = ( this.showhours ) ? "time-timeofday-entity-cell" : "time-timeofday-entity-cell-notimes";					
					}					
					count++;
				}
			}
		}
	},
	
	reserve: function( entity, start_date, end_date, update, resBy, resFor )
	{
		if( !this.reserveEntity )
		{
			this.reserveEntity = {};
		}
		
        var resData = { "start_date": start_date, "end_date": end_date };
        if (resBy && resFor) {
            resData.resBy = resBy;
            resData.resFor = resFor;
        }
        
		if( this.reserveEntity[ entity.id ] )
		{
			if( !this.reserveEntity[ entity.id ]["reservation_dates" ] )
			{
				this.reserveEntity[ entity.id ]["reservation_dates" ] = [];
			}
			
			this.reserveEntity[ entity.id ]["reservation_dates" ].push( resData );
		}
		else
		{
			this.reserveEntity[ entity.id ] = { "reservation_dates": [ resData ] };
		}
		
		if( update )
			this.update();		
	},
	
	update: function()
	{
		this._setProgressStart( MessageUtil.getMessage( MessageBundle.COMMON, "Processing" ) );
		setTimeout( dojo.hitch( this, this._updateScheduler ), 200 );
	},
	
	_updateScheduler: function()
	{
        dojox.data.dom.removeChildren( this.dayareanode );
		this.rows = [];
		this._createSchedulerTimesTable( this.currentStartDate );	
		this._setProgressEnd();	
	},
	
	_isEntityReserved: function( entity, date )
	{
		if( this.reserveEntity && this.reserveEntity[ entity.id ] )
		{
			var resolution = settings[ this.zoomlevel ][ "resolution" ];
			var dates = this.reserveEntity[ entity.id ][ "reservation_dates" ];
			var slotSize = 0;   // Size of a slot in milliseconds
			var slotDate = date; // The date/time of the current slot's left edge
			
			if(resolution == hour)
					slotSize = onehourmillis;
			else if(resolution == day){
					// Start the slot at the start of the day. 	
					slotDate = new Date( date.getFullYear(), 
										 date.getMonth(),
										 date.getDate(),
										 0, 0, 0, 0 );
					slotSize = onedaymillis;
			}
			for( var iDate = 0; iDate < dates.length;  iDate++ )
			{
				var start_date = dates[ iDate ].start_date;
				var end_date = dates[ iDate ].end_date;
				
				var sTime = start_date.getTime(); 
				var eTime = end_date.getTime(); 
				var slotLeftEdgeTime = slotDate.getTime();
				
				if(resolution == month){
					var monthNo = slotDate.getMonth();
					var days = daysInMonth[monthNo];
					slotSize = days * onedaymillis;					 				
				}
								
				// If the start time is anywhere from the slotLeftEdge time to the slotRight edget  
				// time, highlight that slot. For example, 3:00 Left edge would cover 3-4, a time
				// of 3:30 would be included.
				//
				// For end time, no need, end time of 10:30 is handled by 10:00 slot
				//
				if(sTime  < (slotLeftEdgeTime + slotSize) && eTime > slotLeftEdgeTime)
					return dates[iDate];
		    }
		}
		return false;
	},
	
	_isReservedForCurrentUser: function( date )
	{
		return (this.currentUser.name == date.resFor);
	},	
	
	addEntity: function( entity, update )
	{
		//entity definition:
		//id - REQUIRED internal id of the machine
		//name - REQUIRED the visible name of the machine
		//link - OPTIONAL the link for opening the editor for the machine
		if( this.entities )
		{
			this.entities.push( entity );
		}
		else
		{
			this.entities = [entity];
		}
		
		if (update) {
			this.update();
			
//			dojox.data.dom.removeChildren(this.dayareanode);
//			
//			this._createSchedulerTimesTable(this.currentStartDate);
		}
	},
	
	clear: function()
	{
		this.entities = null;
		this.reserveEntity = null;
		dojox.data.dom.removeChildren( this.dayareanode );		
	},

    _getDateTimeValueFromField: function(field, /*optional*/timePrecision)
    {
        var val = field.getValue();
        
        if(val) {
            // add the time components to the date
            if(field.timeField && timePrecision) {
                var time = field.timeField.getTime();
                val.setHours(time.getHours(), time.getMinutes(), 0, 0);
            }
            val = val.getTime();
        }
        return val;
    },
	
	onStartDateChange: function()
	{
        if(this._inSetTime)
            return;
            
		this.reserveStartDate = this.startDatePicker.getDateValue();
		this.showSchedulerSettings();

        // apply constraints to the end date
        if(this.startDatePicker.isValid()) {
            var minDate = this._getDateTimeValueFromField(this.startDatePicker, /*timePrecision*/false);
            
            if (minDate) {
                var toField = this.endDatePicker;
                
                toField.dateNode.setConstraint('min', minDate);
                toField.dateNode.isValid(false);
            }   
        }
	},
	
	onStartTimeChange: function()
	{
        if(this._inSetTime)
            return;

		this.reserveStartTime = this.startDatePicker.getTimeValue();
		this.showSchedulerSettings();
	},
	
	onEndDateChange: function()
	{
        if(this._inSetTime)
            return;

		this.reserveEndDate = this.endDatePicker.getDateValue();
		this.showSchedulerSettings();
        
        // apply constraints to the start date
        if (this.endDatePicker.isValid()) {
            var maxDate = this._getDateTimeValueFromField(this.endDatePicker, /*timePrecision*/ false);
            
            if (maxDate) {
                var fromField = this.startDatePicker;
                
                fromField.dateNode.setConstraint('max', maxDate);
                fromField.dateNode.isValid(false);
            }
        }
	},
	
	onEndTimeChange: function()
	{
        if(this._inSetTime)
            return;

		this.reserveEndTime = this.endDatePicker.getTimeValue();
		this.showSchedulerSettings();
	},
	
	showSchedulerSettings: function()
	{
		this.reserveStartDateObject = null;
		this.reserveEndDateObject = null;
		
		if( this.reserveStartDate && this.reserveEndDate )
		{
			this.reserveStartDateObject = new Date(this.reserveStartDate);
			this.reserveStartDateObject.setHours( 0 );
			this.reserveStartDateObject.setMinutes( 0 );
            if (this.reserveStartTime) {
				this.reserveStartDateObject.setHours(this.reserveStartTime.getHours());
				this.reserveStartDateObject.setMinutes(this.reserveStartTime.getMinutes());
			}
			
			this.reserveEndDateObject = new Date(this.reserveEndDate);
			this.reserveEndDateObject.setHours( 23 );
			this.reserveEndDateObject.setMinutes( 59 );
            if (this.reserveEndTime) {
				this.reserveEndDateObject.setHours(this.reserveEndTime.getHours());
				this.reserveEndDateObject.setMinutes(this.reserveEndTime.getMinutes());
			}

            // make sure the range is valid first.
            if(this.reserveEndDateObject.getTime() < this.reserveStartDateObject.getTime()) {
                this.reserveButtonNode.setDisabled(true);
                this._showDateRangeErrorMessage(MessageUtil.getMessage( MessageBundle.COMMON, "dateRageErrorMsg" ));
                return;
            }
            else {
                this._hideDateRangeErrorMessage();
            }
            
			for (var iEntity = 0; this.entities && (iEntity < this.entities.length); iEntity++) {
				if ( this.reserveEntity && this.reserveEntity[ this.entities[ iEntity ].id ] && !this._isReserveTimeOK( this.entities[ iEntity ] ) ) {
					
					this.reserveButtonNode.setDisabled(true);
                    this._showDateRangeErrorMessage(MessageUtil.getMessage( MessageBundle.COMMON, "dateRageConflictMsg" ));
					break;
				}
				else{
					this.reserveButtonNode.setDisabled(false);					
                    this._hideDateRangeErrorMessage();
				}
			}
			
			this.currentStartDate = new Date( this.reserveStartDateObject.getTime() );
			
			this.update();
		}
		else
		{
			this.reserveButtonNode.setDisabled( true );			
			if( this.reserveStartDate )
			{
				this.currentStartDate = new Date( this.reserveStartDate.getTime() );
				this.update();
			}
		}
		
	},
	
	//checks to see if the anticipated scheduling of the reservation is ok even though the visible
	//resolution might not show it.  returns true for a time to be scheduled is OK
	_isReserveTimeOK: function( entity )
	{
		if( this.reserveEntity && this.reserveEntity[ entity.id ] && this.reserveStartDateObject && this.reserveEndDateObject ) {
			var dates = this.reserveEntity[ entity.id ]["reservation_dates"];
			var enable = true;
			
			var resStart = this.reserveStartDateObject.getTime();
			var resEnd = this.reserveEndDateObject.getTime();
			
			for (var iDate = 0; iDate < dates.length; iDate++) {
				var resFor = dates[iDate].resFor;
				
				//If reserved for the current user then continue cause that's OK
				if (resFor == this.currentUser.name)
					continue;
					
				var start_date = dates[iDate].start_date;
				var end_date = dates[iDate].end_date;
				
				var starttime = start_date.getTime();
				var endtime = end_date.getTime();
				
				if (((resStart < endtime) && (resEnd >= starttime)) ||
				((resStart < endtime) && (resEnd > endtime)) ||
				((resEnd > starttime) && (resEnd <= endtime))) {
					enable = false;
					break;
				}
			}

			return( enable );		
		}
		
		return( false );
	},
	
	_isScheduleSetForDate: function( date )
	{
		if( this.reserveStartDateObject && this.reserveEndDateObject )
		{
			var prevDateTime = this._previousTimeSlot( date );
			var nextDateTime = this._nextTimeSlot( date );
			var currenttime = date.getTime();
			var starttime = this.reserveStartDateObject.getTime();
			var endtime = this.reserveEndDateObject.getTime();
			var previousTime = prevDateTime.getTime();
			var nextTime =  nextDateTime.getTime();
			
			var resolution = settings[ this.zoomlevel ][ "resolution" ];
			
			switch( resolution )
			{
				case hour:
					var resDate = new Date( date.getTime() );
					resDate.setHours( resDate.getHours() );
					resDate.setMinutes( 0 );
					resDate.setSeconds( 0 );
					resDate.setMilliseconds( 0 );
					var currentTime = resDate.getTime();
					var currentTimePlusOne = currentTime + onehourmillis;
					if( ( ( currentTime >= starttime ) && ( currentTime < endtime ) ) ||
					    ( ( currentTimePlusOne > starttime ) && ( currentTime < endtime ) ) )
						return( true );
					break;
				case day:
					var resDate = new Date( date.getTime() );
					resDate.setDate( resDate.getDate() );
					resDate.setHours( 0 );
					resDate.setMinutes( 0 );
					resDate.setSeconds( 0 );
					resDate.setMilliseconds( 0 );
					var currentTime = resDate.getTime();
					var currentTimePlusOne = currentTime + onedaymillis;
					if( ( ( currentTime >= starttime ) && ( currentTime < endtime ) ) ||
					    ( ( currentTimePlusOne > starttime ) && ( currentTime < endtime ) ) )
						return( true );
					break;
				case month:
					var resDate = new Date( date.getTime() );
					resDate.setMonth( resDate.getMonth() );
					resDate.setDate( 1 );
					resDate.setHours( 0 );
					resDate.setMinutes( 0 );
					resDate.setSeconds( 0 );
					resDate.setMilliseconds( 0 );
					var currentTime = resDate.getTime();
					if( ( ( currentTime >= starttime ) && ( currentTime < endtime ) ) )
						return( true );
					break;
			}
		}
		
		return( false );
	},
	
	onReserveClick: function()
	{
		this._setProgressStart( MessageUtil.getMessage( MessageBundle.COMMON, "Reserving" ) );
		for( var iListener = 0; this.reserveClickListeners && ( iListener < this.reserveClickListeners.length ); iListener++ )
		{
			this.reserveClickListeners[ iListener ]( this.reserveStartDateObject, this.reserveEndDateObject );
		}
		
//		for( var iEntity = 0; this.entities && ( iEntity < this.entities.length ); iEntity++ )
//		{
//			this.reserve( this.entities[ iEntity ], this.reserveStartDateObject, this.reserveEndDateObject, false, this.currentUser.userId );	
//		}
		
		this.clearDates();
	},
	
	onRefreshClick: function()
	{
		for( var iListener = 0; this.refreshClickListeners && ( iListener < this.refreshClickListeners.length ); iListener++ )
		{
			this.refreshClickListeners[ iListener ]( );
		}
		
	},
	
	onFinishReservation: function()
	{
		this._setProgressEnd();		
	},
	
	addReserveClickListener: function( listener )
	{
		if( !( this.reserveClickListeners ) )
		{
			this.reserveClickListeners = [];
		}
		
		this.reserveClickListeners.push( listener );
	},

	addRefreshClickListener: function( listener )
	{
		if( !( this.refreshClickListeners ) )
		{
			this.refreshClickListeners = [];
		}
		
		this.refreshClickListeners.push( listener );
	},
	
	createButtonTopRow: function( table )
	{
		this.zoomOutButton = this._createZoomButton( this.zoomSpanNode, "zoom-out", "scheduler-zoom-out-icon", dojo.hitch( this, this._zoomOutAction ) );
		this.zoomInButton = this._createZoomButton( this.zoomSpanNode, "zoom-in", "scheduler-zoom-in-icon", dojo.hitch( this, this._zoomInAction ) );
	},
	
	_createZoomButton: function( cellNode, label, icon, callback )
	{
        var arg = {
            'label': MessageUtil.getMessage(MessageBundle.COMMON, label),
            showLabel: false, // label only or both icon and label
            iconClass: icon,
            'class': "com-ibm-asq-common-web-ui-internal-widgets-scheduler-zoom-button"
        }
        
        if( callback )
        {
        	arg[ "onClick" ] = 	function( e )
        					   	{
        					   		callback( this, e );
        					   	}
        }
        
                
		var button = new dijit.form.Button( arg );
		
		cellNode.appendChild( button.domNode );
		
		return(  button );
	},
	
	_zoomOutAction: function( button, e )
	{
		//Reset date to now
		//this.currentStartDate = new Date();
		if (this.zoomInButton) {
			this.zoomInButton.setDisabled( false );
		}
		
		this.currentStartDate = ( ( this.reserveStartDate ) ? new Date( this.reserveStartDate.getTime() ) : this.currentStartDate );
		var newzoom = zoomcmds[ this.zoomlevel ][ "zoomout" ];
		if (newzoom != this.zoomlevel) {
			this._setProgressStart( MessageUtil.getMessage( MessageBundle.COMMON, "Processing" ) );
			this.zoomlevel = newzoom;
			button.setDisabled( zoomcmds[ this.zoomlevel ][ "zoomout" ] == this.zoomlevel );
			this.update();
		}
	},
	
	_zoomInAction: function( button, e )
	{
		//Reset date to now
		//this.currentStartDate = new Date();
		if (this.zoomOutButton) {
			this.zoomOutButton.setDisabled( false );
		}
		
		this.currentStartDate = ( ( this.reserveStartDate ) ? new Date( this.reserveStartDate.getTime() ) : this.currentStartDate );
		var newzoom = zoomcmds[ this.zoomlevel ][ "zoomin" ];
		if (newzoom != this.zoomlevel) {
			this._setProgressStart( MessageUtil.getMessage( MessageBundle.COMMON, "Processing" ) );
			this.zoomlevel = newzoom;
			button.setDisabled( zoomcmds[ this.zoomlevel ][ "zoomin" ] == this.zoomlevel );
			this.update();
		}		
	},
	
	_previousTimeSlot: function( date )
	{
		var day = this.currentStartDate.getDate();
		var month = this.currentStartDate.getMonth();
		var year = this.currentStartDate.getFullYear();
		
		if (this.zoomlevel == "yearly") {
			var daystosub = daysInMonth[( month == 0 ) ? 11 : month - 1 ];
			if ((month - 1 == 1) && this._isLeapYear(year)) 
				daystosub++;
			
			return( new Date(date.getTime() - onedaymillis * (daystosub - day + 1)));
		}
		else if (this.zoomlevel == "monthly") {
			return( new Date(date.getTime() - onedaymillis) );
		}
		else if (this.zoomlevel == "weekly") {
			return( new Date(date.getTime() - onedaymillis) );
		}
		else {
			return( new Date( date.getTime() - onedaymillis / 24))
		}		
	},
	
	_nextTimeSlot: function( date )
	{
		var day = this.currentStartDate.getDate();
		var month = this.currentStartDate.getMonth();
		var year = this.currentStartDate.getFullYear();
		
		if (this.zoomlevel == "yearly") {
			var daystosub = daysInMonth[( month == 11 ) ? 0 : month + 1 ];
			if ((month + 1 == 1) && this._isLeapYear(year)) 
				daystosub++;
			
			return( new Date(date.getTime() + onedaymillis * (daystosub - day + 1)));
		}
		else if (this.zoomlevel == "monthly") {
			return( new Date(date.getTime() + onedaymillis) );
		}
		else if (this.zoomlevel == "weekly") {
			return( new Date(date.getTime() + onedaymillis) );
		}
		else {
			return( new Date( date.getTime() + onedaymillis / 24))
		}		
	},
	
	// show the in-progress indicator and hide the title
    //
    _setProgressStart: function(message) {
        this.progressLabel.innerHTML = message;
        this.progressIndicator.style.display = "inline";
    },
    
    // restore the title and hide the in-progress indicator
    //
    _setProgressEnd: function() {
        this.progressLabel.innerHTML = "";
        this.progressIndicator.style.display = "none";
    },

    _showDateRangeErrorMessage: function(msg) {
        this.messageArea.style.display = "inline";
        this.messageLabel.innerHTML = msg;
    },

    _hideDateRangeErrorMessage: function() {
        this.messageArea.style.display = "none";
        this.messageLabel.innerHTML = "";
    },
    
	clearDates: function()
	{
        this._inSetTime = true;
		this.startDatePicker.clear();
		this.endDatePicker.clear();
        
        var minDate = new Date();
        minDate.setHours(0);
        minDate.setMinutes(0);
        
        this.startDatePicker.dateNode.constraints['min'] = minDate;
        this.endDatePicker.dateNode.constraints['min'] = minDate;
        
        minDate.setHours(23, 59, 0, 0);
        this.endDatePicker.timeField.setTime( minDate );
        
        this._inSetTime = false;
		delete this["reserveStartDate"];
		delete this["reserveEndDate"];
		this.showSchedulerSettings();
		this.update();		
	},
	
	_createReservationTooltipString: function(reserved)
	{
		if (reserved.resFor) 
		{
			var resFor = this._isReservedForCurrentUser(reserved) ? "you" : reserved.resFor;
			
			if (reserved.start_date instanceof Date && reserved.end_date instanceof Date) //If we have begin and end times (should always be true)
			{
				var startStr = dojo.date.locale.format(reserved.start_date, 
				{
					formatLength: "short"
				});
				var endStr = dojo.date.locale.format(reserved.end_date, 
				{
					formatLength: "short"
				});
				return MessageUtil.getMessage(MessageBundle.COMMON, "ReservedForFromTill", resFor, startStr, endStr);
			}
			else 
				return MessageUtil.getMessage(MessageBundle.COMMON, "ReservedFor", resFor);
		}
		else
			return "";  //no reservation info.  This is typically an error case.
	}
}	
);

})();
