/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ImageCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ImageCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    // Summary:
    //    Renders the image cell content. The following cellData can be expected. 
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, columnIndex)
    {
        var img = document.createElement("img");
        var tooltip = cellData;
        if(extendedDisplayInfo) {
            var imgSrc = extendedDisplayInfo['mouseOutImage'] || extendedDisplayInfo['image'];
            //when adding Tooltip there is no need to use the alt attribute of the images in IE8 is duplicating the information
            img.alt = "";
            img.src = imgSrc;
            
            if(extendedDisplayInfo['tooltip'])
                tooltip = extendedDisplayInfo['tooltip'];
			if (extendedDisplayInfo['mouseOverImage']){
			
    	    	var x = extendedDisplayInfo['mouseOutImage'] || extendedDisplayInfo['image'];
    	    	var srcOut = dojo.isString(x) ? x : x.toString();
    	    	 
    	    	x = extendedDisplayInfo['mouseOverImage'];
    	    	var srcOver = dojo.isString(x) ? x : x.toString();
    	    	
    	    	this.connect(img, "onmouseout", dojo.hitch({'srcOut': srcOut},this.outOfImage));
	        	this.connect(img, "onmouseover", dojo.hitch({'srcOver': srcOver},this.overImage));
    	    }
        }
        else {
            img.src = cellData;
        }
        
        
        if (extendedDisplayInfo &&  extendedDisplayInfo['href']) {
            // display image as link only if the table is not displayed in a popup
            if (!viewer.displayInPopup) {
                this._attachTooltipToCell(img, tooltip);
                
                var anchor = document.createElement("a");
                anchor.href = extendedDisplayInfo.href;
                anchor.appendChild(img);
                return anchor;
            }
        } else {
            this._attachTooltipToCell(img, tooltip);        
        }

        return img;
    },
    
    overImage: function(e)
    {	
    	if (this.srcOver)
    		e.target.src = this.srcOver;
    },
    
    outOfImage: function(e)
    {
    	if (this.srcOut)
    		e.target.src = this.srcOut;
    }
    
});

})();
