/**ArtifactCopyWizard**************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizard");
dojo.require("com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage");
dojo.require("com.ibm.rqm.planning.web.client.internal.CopyClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.wizard.Wizard");
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){

var CopyClient				= com.ibm.rqm.planning.web.client.internal.CopyClient;
var ServiceResponseHandler  = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var ArtifactCopyWizardPage 	= com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage;
var Wizard					= com.ibm.asq.common.web.ui.internal.wizard.Wizard
var Status					= com.ibm.team.repository.web.foundation.Status;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizard", Wizard, {
	
	jobItemId:null,
	sourcePA:"",
	targetPA:"",
	cancelCallback:null,
	constructor: function(args) {
		this.sourcePA = args.sourcePA;
		this.targetPA = args.targetPA;
		this.jobItemId = args.jobId;
		this.cancelCallback = args.cancelCallback;
		this.params = args.params;
	},
	getTitle: function() {
		if(!this._title)
			this._title= Constants.getMessage("msgDuplicating2", this.targetPA) +
			    " - " + Constants.getMessage("labelCorrelationTitle");
		return this._title;
	},
	getPages:function(){
		if(!this._pages){
			this._pages = [];
			var params = this.params;
			var sourcePA = this.sourcePA;
			var targetPA = this.targetPA;
			if(params.teams)
				this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
					pageId:"teams",
					title:Constants.getMessage("labelTeams"),
					description:Constants.getMessage("msgCorrelateTeam",sourcePA,targetPA),
					items:params.teams
				}));
			if(params.objectives)
				this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
					pageId:"objectives",
					title:Constants.getMessage("labelQualityObjectives"),
					description:Constants.getMessage("msgCorrelateQualityObjective",sourcePA,targetPA),
					items:params.objectives,
					allowUnique:true
				}));
			if(params.resourceLocs)			
				this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
					pageId:"resourceLocs",
					title:Constants.getMessage("labelSharedLocation"),
					description:Constants.getMessage("msgCorrelateResourceLocation",sourcePA,targetPA),
					items:params.resourceLocs
				}));
			if(params.planTemplates)			
				this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
					pageId:"planTemplates",
					title:Constants.getMessage("labelTemplates"),
					description:Constants.getMessage("msgCorrelateTestPlanTemplate",sourcePA,targetPA),
					items:params.planTemplates
				}));
			if(params.caseTemplates)
				this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
					pageId:"caseTemplates",
					title:Constants.getMessage("labelTemplates"),
					description:Constants.getMessage("msgCorrelateTestCaseTemplate",sourcePA,targetPA),
					items:params.caseTemplates
				}));
			if(params.risks)			
				this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
					pageId:"risks",
					title:Constants.getMessage("labelRiskAssessment"),
					description:Constants.getMessage("msgCorrelateRisk",sourcePA,targetPA),
					items:params.risks
				}));
			if(params.planCategories)
				this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
					pageId:"planCategories",
					title:Constants.getMessage("labelCategory"),
					description:Constants.getMessage("msgCorrelatePlanCategory",sourcePA,targetPA),
					items:params.planCategories,
					allowUnique:true
				}));
	        if(params.caseCategories)
                this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
                    pageId:"caseCategories",
                    title:Constants.getMessage("labelCategory"),
                    description:Constants.getMessage("msgCorrelateCaseCategory",sourcePA,targetPA),
                    items:params.caseCategories,
                    allowUnique:true
                }));
            if(params.suiteCategories)
                this._pages.push(com.ibm.rqm.planning.web.ui.internal.wizard.ArtifactCopyWizardPage.create({
                    pageId:"suiteCategories",
                    title:Constants.getMessage("labelCategory"),
                    description:Constants.getMessage("msgCorrelateSuiteCategory",sourcePA,targetPA),
                    items:params.suiteCategories,
                    allowUnique:true
                }));
		}
		return this._pages;
	},
	performFinish: function(runWhenFinished, monitor) {
		var pages = this._pages;
		var len = pages.length;
		var returnValues= {uuid:this.jobItemId,sourceItems:[],targetItems:[],optTargetData:[]};
		for(var i=0;i<len;i++){
			var value = pages[i].getValues();
			returnValues.sourceItems = 
			    returnValues.sourceItems.concat(value.sourceItems)
			returnValues.targetItems = 
			    returnValues.targetItems.concat(value.targetItems);
			returnValues.optTargetData = 
			    returnValues.optTargetData.concat(value.optTargetData);
		}
		var callbackObj = {
			success: function(results){
				runWhenFinished(Status.OK_STATUS);
			},
			failure: function(error){
				runWhenFinished(new Status(Status.ERROR, error.message, error));
			}
		}
		var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
		CopyClient.postCorrelate(responseHandler,returnValues);
	},
	performCancel: function() {
		var args = {
            'message': Constants.getMessage("msgCorrelateConfirmCancel"),
            'yesCallback': 
                function(view) {
                    if (view.cancelCallback) {
	     			   return view.cancelCallback(view.jobItemId);
	    			}
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
		return false;
	}
});

})();
