/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.wizard.Wizard");

(function(){
	
dojo.declare("com.ibm.asq.common.web.ui.internal.wizard.Wizard", null, {

	_title: null,
	_pages: null,

	constructor: function() {
	},
	
	getTitle: function() {
		return this._title;
	},

	getPages: function() {
		if(!this._pages)
			this._pages = [];
		return this._pages;
	},

	getInitialPage: function() {
		if(this._pages)
			return this._pages[0];
	},

	getPreviousPage: function(currentPage) {
		var index= dojo.indexOf(this._pages, currentPage);
		return index > 0 ? this._pages[index - 1] : null;
	},

	getNextPage: function(currentPage) {
		var index= dojo.indexOf(this._pages, currentPage);
		return index < this._pages.length - 1 ? this._pages[index + 1] : null;
	},

	performFinish: function(runWhenFinished) {
		runWhenFinished(Status.OK_STATUS);
	},
	performCancel: function() {
		return true;
	},
	canFinish: function() {
		return dojo.every(this._pages, function(page) {
			return page.isPageComplete();
		});
	},
	__sentinel: null // terminates this class definition
});

})();
