/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.wizard.WizardPage");

dojo.require("dijit._Widget");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");
dojo.require("com.ibm.team.repository.web.foundation.Status");

(function(){

var NullProgressMonitor	= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var Status				= com.ibm.team.repository.web.foundation.Status;
	
dojo.declare("com.ibm.asq.common.web.ui.internal.wizard.WizardPage", 
			 [dijit._Widget], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	
	
	_wizardDialog: null,
	title: null,
	description: null,
	_isPageComplete: true,
	
	constructor: function() {
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------	

	getTitle: function() {
		return this.title;
	},

	getDescription: function() {
		return this.description;
	},

	getContentNode: function() {
		return "";
	},

	isPageComplete: function() {
		return this._isPageComplete;
	},
	
	setWizardDialog: function(wizardDialog) {
		this._wizardDialog= wizardDialog;
	},
	
	aboutToShow: function(runWhenReady) {
		runWhenReady(Status.OK_STATUS);
	},

	aboutToHide: function() {
		
	},
	
	// ---- WizardPage api -------------------------------------------------------------------------------------------------	

	setPageComplete: function(complete) {
		this._isPageComplete= complete;
		if (this._wizardDialog != null) {
			this._wizardDialog.updateButtons();
		}
	},
	
	runWithProgress: function(progressMonitoredCode) {
		if (this._wizardDialog != null) {
			this._wizardDialog.runWithProgress(progressMonitoredCode);
		} else {
			runWithProgress(new NullProgressMonitor())
		}
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});
})();
