/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.util.ItemPickerUtil");

(function(){
    var ITEM_KEY_MESSAGE = "oslc_cm:message";
    
    var ITEM_KEY_RESULT = "oslc_cm:results";
    var ITEM_KEY_URI = "rdf:resource";
    var ITEM_KEY_LINKTITLE = "oslc_cm:label";
    
    var ITEM_KEY_RM_RESULT = "oslc_rm:results";
    var ITEM_KEY_RM_LINKTITLE = "oslc_rm:label";
    
    var OSCL_ATTRIB_TYPE = "dc:type";
    var OSCL_ATTRIB_SUMMARY = "dc:name";
    var OSCL_ATTRIB_DESCRIPION = "dc:description";
    
    /**
     * @return an array of work item objects in {summary, url}
     * @param {Object} workItemsJsonString - law results returned from the picker
     */
    com.ibm.rqm.defects.web.util.ItemPickerUtil.parse = function(itemsJsonString){
        var results = [];
        var jsonObj = dojo.fromJson(itemsJsonString);
        for (var index = 0; index < jsonObj[ITEM_KEY_RESULT].length; index++) {
            var itemObj = {};
            itemObj.summary = unescape(jsonObj[ITEM_KEY_RESULT][index][ITEM_KEY_LINKTITLE]);
            itemObj.url = jsonObj[ITEM_KEY_RESULT][index][ITEM_KEY_URI];
            console.debug(itemObj);
            results.push(itemObj);
        }
        return results;
    }
    
    com.ibm.rqm.defects.web.util.ItemPickerUtil.parseFromRTC = com.ibm.rqm.defects.web.util.ItemPickerUtil.parse;
    
    com.ibm.rqm.defects.web.util.ItemPickerUtil.parseFromCQ = com.ibm.rqm.defects.web.util.ItemPickerUtil.parse;
    
    /**
     * @return an string which would be attached to the Picker url hash fragment, the summary and description will be add to the new careated work item automaticly
     * @param {Object} summary
     * @param {Object} desc
     */
    com.ibm.rqm.defects.web.util.ItemPickerUtil.getWICreationDialogParamString = function(summary, desc){
        var params = {};
		var title = summary; 
		if (summary && summary.length > 125) {
			title = summary.substring(0, 122) + "...";
		}
        params[OSCL_ATTRIB_SUMMARY] = title;
        params[OSCL_ATTRIB_DESCRIPION] = desc;
        return dojo.objectToQuery(params);
    }
    
    com.ibm.rqm.defects.web.util.ItemPickerUtil.parseRmSelectResult = function(itemsJsonString){
        var results = [];
        var jsonObj = dojo.fromJson(itemsJsonString);
        for (var index = 0; index < jsonObj[ITEM_KEY_RM_RESULT].length; index++) {
            var itemObj = {};
            itemObj.summary = unescape(jsonObj[ITEM_KEY_RM_RESULT][index][ITEM_KEY_RM_LINKTITLE]);
            itemObj.uri = jsonObj[ITEM_KEY_RM_RESULT][index][ITEM_KEY_URI];
            results.push(itemObj);
        }
        return results;
    }
})();
