/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.util.XMLUtil");

(function(){
    function _getAttributeNodeValue(attributeNode){
        return attributeNode.nodeValue;
    }
    
    function _getAttributeNode(node, baseName, namespace){
        var attribute;
        if (dojo.isIE) {
            attribute = node.attributes.getQualifiedItem(baseName, namespace) || node.attributes.getNamedItem(baseName);
        }
        else {
            attribute = node.attributes.getNamedItemNS(namespace, baseName) || node.attributes.getNamedItem(baseName);
        }
        return attribute;
    }
    
    function _getNode(collection, baseName, namespaceURI){
        var matchingNode;
        dojo.forEach(collection, function(node){
            if ((node.baseName == baseName || node.localName == baseName) && (node.namespaceURI == namespaceURI || (node.namespaceURI === "" && namespaceURI === null))) { //$NON-NLS-1$
                matchingNode = node;
            }
        });
        return matchingNode;
    }
    
    function _getNodes(collection, baseName, namespaceURI){
        var matchingNodes = [];
        dojo.forEach(collection, function(node){
            if ((node.baseName == baseName || node.localName == baseName) && (node.namespaceURI == namespaceURI || (node.namespaceURI === "" && namespaceURI === null))) { //$NON-NLS-1$
                matchingNodes.push(node);
            }
        });
        return matchingNodes;
    }
    // XML namespaces
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns#"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_DC = "http://purl.org/dc/terms/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_OSLC = "http://open-services.net/xmlns/discovery/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_OSLC_CM = "http://open-services.net/xmlns/cm/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_OSLC_QM = "http://open-services.net/xmlns/qm/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_OSLC_RM = "http://open-services.net/xmlns/rm/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_JP = "http://jazz.net/xmlns/prod/jazz/process/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_JD = "http://jazz.net/xmlns/prod/jazz/discovery/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_CALM = "http://jazz.net/xmlns/prod/jazz/calm/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_RDFS = "http://www.w3.org/2000/01/rdf-schema#"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_DCTERMS = "http://purl.org/dc/terms/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_OSLC_RDM = "http://open-services.net/xmlns/rm/1.0/"; //$NON-NLS-1$
    com.ibm.rqm.defects.web.util.XMLUtil.NAMESPACE_RRM_COL = "http://jazz.net/xmlns/alm/rm/Collection/v1.0/"; //$NON-NLS-1$
    // XML utils
    com.ibm.rqm.defects.web.util.XMLUtil.getAttributeNodeValue = _getAttributeNodeValue;
    com.ibm.rqm.defects.web.util.XMLUtil.getAttributeNode = _getAttributeNode;
    com.ibm.rqm.defects.web.util.XMLUtil.getNode = _getNode;
    com.ibm.rqm.defects.web.util.XMLUtil.getNodes = _getNodes;
})();
