/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *   
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
package com.ibm.rational.test.lm.spi.bf.internal;

import java.io.IOException;

import com.buildforge.services.common.ServiceException;
import com.ibm.rational.test.lm.spi.bf.common.BFAPIAuthenticationException;
import com.ibm.rational.test.lm.spi.bf.common.BFAPIClientConnectionException;
import com.ibm.rational.test.lm.spi.common.SPIAuthenticationException;
import com.ibm.rational.test.lm.spi.common.SPIClientConnectionException;
import com.ibm.rational.test.lm.spi.common.SPIException;
import com.ibm.rational.test.lm.spi.common.SPIResourceNotFoundException;

public class APIExceptionHandle {

	public static void handleAPIExceptions(Exception e) throws SPIException {
		if (e instanceof BFAPIClientConnectionException) {
			throw new SPIClientConnectionException(
					"BuildForge APIClientConnectionException for " + e.getMessage());//$NON-NLS-1$
		} else if (e instanceof IOException) {
			throw new SPIException(
					"BuildForge IOException for " + e.getMessage());//$NON-NLS-1$
		} else if (e instanceof ServiceException) {
			throw new SPIException(
					"BuildForge ServiceException for " + e.getMessage());//$NON-NLS-1$
		} else if (e instanceof BFAPIAuthenticationException) {
			throw new SPIAuthenticationException(
					"BuildForge APIAuthenticationException for " + e.getMessage());//$NON-NLS-1$
		} else if (e instanceof SPIResourceNotFoundException) {
			throw (SPIResourceNotFoundException) e;
		} else {
			throw new SPIException(
					"BuildForge APIException for " + e.getMessage());//$NON-NLS-1$
		}
	}
}
